--
-- Author: Liyang
-- Date: 2015-06-26 17:28:09
-- 角色基类

local actor_control = class("actor_control")

-- 状态值
function actor_control:ctor(target)
	--绑定状态机
	cc.bind(self, "stateMachine")
	--绑定事件
	cc.bind(self, "event")

	self:setupState({
		events = {
			--初始化后, 进入准备状态
            {name = "event_initialize", from = "none", to = "state_idle" },
            --切换到空闲状态
            {name = "event_idle", from = "*", to = "state_idle" },
            -- 移动事件
            {name = "event_move", from = "*", to = "state_move" },
            --被击
            {name = "event_behit", from = "*", to = "state_behit" },
            --闪避
            -- {name = "event_shanbi", from = "state_idle", to = "state_idle" },
            -- 移动事件结束
            -- {name = "event_moveover", from = "state_move", to = "state_idle" },
            -- 攻击
            {name = "event_attack", from = {"state_idle","state_move","state_behit","state_hide"}, to = "state_attack" },
            {name = "event_attack_over", from = "state_attack", to = {"state_idle","state_move","state_behit"} },
            -- 进入眩晕状态
            
            -- 进入混乱状态
            --隐藏
            {name = "event_hide", from = "*", to = "state_hide" },
            --退出隐藏
            {name = "event_exitHide", from = "*", to = "state_idle" },
            --死亡事件
            {name = "event_die", from = "*", to = "state_die" },
            --复活事件
            {name = "event_relive", from = "state_die", to = "state_idle" },
		},
		callbacks = {
			onevent_initialize = handler(self, self.onEvent_initialize),
			onevent_idle = handler(self, self.onEvent_idle),
			onevent_hide = handler(self, self.onEvent_hide),
			onevent_exitHide = handler(self, self.onEvent_exitHide),
			onevent_move = handler(self, self.onEvent_move),
			onevent_behit = handler(self, self.onEvent_behit),
			onevent_attack = handler(self, self.onEvent_attack),
			onevent_attack_over = handler(self, self.onEvent_attack_over),
			onevent_die = handler(self, self.onEvent_die),
			onevent_relive = handler(self, self.onEvent_relive),
		}
	});

	self.target_ = target;

	--广播一个动画完成 和 帧事件
	self.registerConfig = {
		-- {"login","event_start",1},
		-- {"login","event_createloginview",1},
		-- {"login","event_loginAccount",1},
		-- {"login","event_createregister",1},
		-- {"login","event_registeraccount",1},
		-- {"login","event_registercancel",1},
		-- {"login","event_chooseserver",1},--选择服务器
	}

	--角色属性值
	self.attribute_camp = 1; --阵营
	self.attribute_bossmark = 0; --是否是boss
	self.attribute_isdrop = 1;
	self.attribute_droptype = 1;
	self.attribute_sumhp = 1;--角色总血量
	self.attribute_currenthp = 1;--当前血量
	self.attribute_templateid = 1;--模板id
	self.attribute_IsZero = 1;

	--地图坐标
	self.cell_x = 0;
	self.cell_y = 0;

	self.draw_x = 0;
	self.draw_y = 0;
	--显示hp位置
	self.display_hp = { x = 0,y = 100};
	--攻击位置
	self.display_act = { x = 0,y = 50};
	--buf列表
	self.buffList = {};
	self.numericalPos = {};

	--buff叠加显示记录
    self.OverlayPos = {0,0,0,0,0,0,0,0};
    self.OverlayDisplayPos = 1;

    self.m_speed = 8;

    self.m_Direction = 1;

    self.movePath = {};

    self.hpDisplay = 0;

    --角色与服务器同步判断
    self.define_ForceSyncDis = 5;
end


--注册事件
function actor_control:register_event(  )
	local defaultCallbacks = {
        -- actor_control_start = handler(self, self.event_login),
        -- actor_control_createloginview = handler(self, self.event_CreateloginView),
        -- actor_control_loginAccount = handler(self, self.event_loginAccount),
        -- actor_control_createregister = handler(self, self.event_createRegister),
        -- actor_control_registeraccount = handler(self, self.event_registerAccount),
        -- actor_control_registercancel = handler(self, self.event_registerCancel),
        -- actor_control_chooseserver = handler(self, self.event_chooseserver),
    }
    self.eventlisen = {};
	for i,v in ipairs(self.registerConfig) do
		local eventname = createGlobaleEventName( v[1], v[2] )
		print("注册事件",eventname);
		if defaultCallbacks[eventname] then
			self.eventlisen[eventname] = createGlobalEventListener( v[1], v[2], defaultCallbacks[eventname], v[3] )
		end
	end
end

function actor_control:addExecuteEvent( eventname )
	if not eventname then
		return;
	end
	for i,v in ipairs(eventname) do
		table.insert(self.registerConfig, 1, eventname)
	end
end

-------------------------------状态机函数----------------------------------

--[[ 初始化游戏
	event = {
		name ,	
		args = {

			finishCallfun = nil,--完成回调函数
		}
	}	
]]
function actor_control:onEvent_initialize( event )
	--创建角色显示
	self.showObject = ManagerActor:CreateActorView( self.attribute_templateid );
	self.showObject:setActorData( self );
	--得到坐标位置
	local x ,y= Data_Battle.mapData:getCellToWorld( self.cell_x ,self.cell_y );
	print("actor onEvent_initialize",x,y,self.cell_x ,self.cell_y,Data_Battle.mapData:getWorldToCell( x,y ))
	-- print()
	self.showObject:setPosition(cc.p(x, y));
	-- self.showObject:retain();
	self.showObject.mark = 1;
	self.showObject:setScale(0.5);
	--添加到显示界面
	dispatchGlobaleEvent( "battleDisplay" ,"add" ,{self.showObject,1 ,self.cell_x + self.cell_y})
	--创建光环
	-- local herostar = heroConfig[self.attribute_templateid].star
	-- self.buttonview = ManagerActor:CreateActorButtonView( self )
	-- self.buttonview:createGuangHuangEffect( herostar );
	-- self.showObject:addShowObject( self.buttonview , 1 );
	-- self.buttonview:setVisible(false);

	--创建血条显示
	--血量
	local sumHP = GetSoldierSetup(self.attribute_templateid).hp;
	self:setSumHp( sumHP );
	self.attribute_currenthp = sumHP;
	self.topview = ManagerActor:CreateActorTopView(self);
	self.topview:createHPShow();
	-- self.topview:retain();
	self.topview:setPosition(cc.p(x, y));
	self.topview.mark = 1;
	-- self.topview:setVisible(false);
	--添加到显示界面
	dispatchGlobaleEvent( "battleDisplay" ,"add" ,{self.topview,3,self.cell_x + self.cell_y});

	--设置移动速度
	self.m_speed = 1000 / (GetSoldierSetup(self.attribute_templateid).move_invl - 100);


	self:setHpShow(false);
	--随机一个方向
	local dir = math.random(100) % 8 + 1;
	self:changeDirection( dir )
	print("初始方向:",dir)
	self:doEvent("event_idle");
end

--重新进入初始化状态
function actor_control:onEvent_idle( event )
	--进入休闲状态
	self.showObject:setPlayAnimationType( "idle" );

end

--隐藏状态
function actor_control:onEvent_hide( event )
	self.showObject:setVisible(false);
end

--退出隐藏状态
-- function actor_control:onEvent_exitHide( event )
-- 	self.showObject:setVisible(true);
-- end


--移动状态
--[[
	args {
		播放速度
		是否循环
	}
]]
function actor_control:onEvent_move(event)
	-- local move_x = event.args[1].x;
	-- local move_y = event.args[1].y;
	-- local listenercallfun = event.args[1].Callback
	-- print("actor_control:onEvent_move:",move_x ,move_y ,listenercallfun)
	-- self.showObject:setAnimationListen( "move" ,listenercallfun );
	-- self.showObject:exexuteMoveAction( move_x , move_y );
	-- --更新坐标
	-- self.cell_x ,self.cell_y = Data_Battle.mapData:getWorldToMapTransform( move_x ,move_y );

	self.showObject:setPlayAnimationType( "move" );
end

function actor_control:onEvent_behit( event )
	self.showObject:setPlayAnimationType( "behit" );
end

function actor_control:onEvent_shanbi( event )
	self.showObject:setPlayAnimationType( "shanbi" );
end

function actor_control:onEvent_relive( event )
	-- self.showObject:playAnimationByID( "revive")
	-- self.showObject:setVisible(true);
	-- self:setHpShow( true );
end

--技能施法1
function actor_control:onEvent_attack( event )
	local listenercallfun = event.args[1].Callback
	self.showObject:setAnimationListen( "attack" ,listenercallfun );
	self.showObject:setPlayAnimationType( "attack" );
end

--攻击结束后执行
function actor_control:onListenAttack(  )
	self:doEvent("event_idle");
end

--攻击结束
function actor_control:onEvent_attack_over( event )
	self.showObject:playAnimation_SkillOver_1();
end


--死亡
function actor_control:onEvent_die( event )
	--清空状态
	-- self.bufList = {};
	-- self.target_:releaseAllEffect();
	-- --播放死亡动画
	-- self.target_:playAnimationByID( "die" ,nil ,-1);
	-- AudioManager.playSkillEffectSound("sound_die");--播放死亡音效

	self.showObject:setPlayAnimationType("die");
	self.showObject:setVisible(false)
	self:setHpShow( false );
end




----------------------------------逻辑函数-------------------------------------

--监听动画事件
function actor_control:ListenAnimationEvent( movementID )
	--动画完成
	if self.AnimationCompleteCallFun then
		self.AnimationCompleteCallFun(movementID);
	end
end

--监听帧动画事件
function actor_control:ListenAnimationFrameEvent( evt )
	if self.AnimationFrameCallFun then
		self.AnimationFrameCallFun(evt);
	end
end

--设置动画完成监听
function actor_control:setListenAnimationComplete( callbcak )
	--设置动画完成监听
	self.AnimationCompleteCallFun = callbcak;
end

function actor_control:setListenAnimationFrameEvent( callback )
	self.AnimationFrameCallFun = callback;
end

--[[ 初始化数据
	herodata  英雄数据
	params = {
		herodata = nil,--英雄数据
		mark = "456",-- 角色GUID
		camp = 1,-- 阵营
		bossmark = 0,是否是boss
		frompos = 1, ,位置
		map_x = 21,
		map_y = 21,
	}
]]
function actor_control:InviData( params )
	-- body
	self.ActorData = params.herodata;
	self.attribute_Mark = params.mark or 1;
	self.attribute_camp = params.camp or 1; --阵营
	self.attribute_bossmark = params.bossmark or 0; --是否是boss
	self.attribute_sumhp = params.sumhp or 0;--角色总血量
	self.attribute_currenthp = params.currenthp or 0;--当前血量
	self.attribute_templateid = params.templateid;--模板id
	self.attribute_IsShowName = params.isshowname or 0; --是否显示名称
	self.attribute_playname = params.playername or 0;--所属名称
	self.cell_x = params.cell_x or 21;
	self.cell_y = params.cell_y or 21;
    -- self:doEvent("initialize") -- 启动状态机
end

function actor_control:getId()
	return self.attribute_Mark;
end

function actor_control:getCamp()
	return self.attribute_camp;
end

--得到被攻击的位置
function actor_control:getAttackPostion(  )
	return self.display_act;
end

--设置被攻击的位置
function actor_control:setAttackPostion( pos )
	self.display_act.x = pos.x;
	self.display_act.y = pos.y;
end

--得到显示HP的位置
function actor_control:getHpPostion(  )
	return self.display_hp;
end

--设置HP位置
function actor_control:setHpPostion( pos )
	self.display_hp.x = pos.x;
	self.display_hp.y = pos.y;
end

function actor_control:setSumHp( values )
	self.attribute_sumhp = values;
	self.hpScale = 100 / self.attribute_sumhp;
end

--更新函数
function actor_control:updata_hp( valuse )
	self.attribute_currenthp = valuse;
	self.topview:setHpValuse( self.hpScale * valuse );
	if self.attribute_currenthp <= 0 then
		self:doEvent("event_die");
	end
end

--[[当前血量改变
    hpvaluse 改变值
    isdead 主要是为了修正值
]]
function actor_control:UpDataCurrentHp( hpvaluse ,isdead)
    local hp = self.attribute_currenthp + hpvaluse;
    if (not isdead) and hp < 0 then
        hp = 1;
    end
    self:updata_hp(hp);
end

function actor_control:setHpShow( isshow )
	if isshow then
		self.topview:setVisible(true);
	else
		self.topview:setVisible(false);
	end
end

function actor_control:setHPDisplayTime(  )
	self.hpDisplay = 10;
end

function actor_control:setSkillPromptShow( name )
	if name then
		self.topview:createSkillName( name );
	end
end

function actor_control:ShowName(  )
	--判断阵营
	-- if self.attribute_camp == 1 then
	-- 	return false;
	-- end

	if self.attribute_IsShowName == 1 then
		self:setRoleNameShow(  );
	end

	-- --判断战斗类型
	-- if Data_Battle:checkCurrentBattlefieldTypeIsPVP(  ) then
	-- 	self:setRoleNameShow(  );
	-- else
	-- 	if self.attribute_bossmark == 1 then
	-- 		self:setRoleNameShow(  );
	-- 	end
	-- end
end

--设置角色名称显示
function actor_control:setRoleNameShow(  )
	--判断是否是boss

	local herostar = heroConfig[self.attribute_templateid].star;
	local heroname = heroConfig[self.attribute_templateid].name;
	local color = ResIDConfig:getEquipQualityInfo( herostar ).color;
	self.topview:createRoleName( heroname , color );
end

--添加数值buf效果
function actor_control:addNumericeBufEffect( effect )
	local pos = 0;
	for i,v in pairs(self.numericalPos) do
		if v then
			pos = pos + 1 ;
		end
	end
	if pos < 5 then
		self.numericalPos[effect] = effect;
		effect.pos = pos + 1;
		local x = 30 + (pos - 1) * 30;
		local sunLen = pos * 30;
		effect:setPosition(cc.p(x , 0))
		self.topview:createBufShow( effect ,sunLen);
	end
end

--去除数值效果
function actor_control:removeNumericeBufEffect( effect )
	if not self.numericalPos[effect] then
		return;
	end
	local removepos = self.numericalPos[effect].pos;
	self.numericalPos[effect] = nil;
	local x,y = 0,180;

	for k,v in pairs(self.numericalPos) do
		if v.pos > removepos then
			v.pos = v.pos - 1;
		end
		x = 30 + (v.pos - 1) * 30;
		effect:setPosition(cc.p(x , 0));
	end
	local count = table.nums(self.numericalPos);
	self.topview:createBufShow( nil ,count*30);
end

--[[添加颜色效果
]]
function actor_control:setColorEffect( color )
	print("actor_control:setColorEffect",self.showObject);
	if self.showObject then
		self.showObject:setColorEffect( color );
	end
end

--判断角色是否拥有buff
function actor_control:IsHaveBuff( buffid )
    for i,v in pairs(self.buffList) do
        if v and v.BuffType == buffid then
            printInfo("添加相同buf：%s", buffid);
            return v;
        end
    end
    return false;
end

--添加buff
function actor_control:AddBuff( node )
    for i,v in pairs(self.buffList) do
        if v and v.BuffType == node.BuffType then
        	printInfo("添加相同buf：%s", node.BuffType);
            return false;
        end
    end
    self.buffList[node] = node;
    self.showObject:addShowObject( node , 3 );
    printInfo("添加buff:%s",tostring(self),node.BuffType);
    return true;
end

--移除buf
function actor_control:RemoveBuff( buffType )
	print("actor_control:RemoveBuff",buffType)
    for i,v in pairs(self.buffList) do
    	print(i,v,v.BuffType,"==",buffType)
        if v and v.BuffType == buffType then
            printInfo("移除buff:%s",buffType);
            v:ExitEffect(  );
            self.buffList[i] = nil;
            return;
        end
    end
end

--清除所有buf
function actor_control:ClearBuff(  )
    for i,v in pairs(self.buffList) do
        if v then
            v:ExitEffect(  );
            self.buffList[i] = nil;
        end
    end
end

--是否死亡
function actor_control:isDead(  )
	if self:getState() == "state_die" then
        return true;
    end
	return false;
end

--死亡检测
function actor_control:DeadCheck(  )
	--判断角色是否已经死亡
    if self:getState() == "state_die" then
        return true;
    end
    if self.attribute_currenthp <= 0 then
        self:doEvent("event_die")
        return true;
    end
    return false;
end

--设置角色的zorder
function actor_control:setActorLocalZOrder( zorder )
	-- self.showObject:setLocalZOrder(zorder);
	self.showObject:getParent():reorderChild(self.showObject,zorder);
end

function actor_control:resetActorLocalZOrder(  )
	self.showObject:getParent():reorderChild(self.showObject,self.cell_x + self.cell_y);
end

--获得角色移动方向
function actor_control:pointToDir( cellPt )
    local angle=cc.pToAngleSelf(cellPt);
    local index = (angle+2 * math.pi+math.pi / 8)/(math.pi / 4);
    -- print("pointToDir:",math.modf(index%8 + 1))
    return ManagerActor.ActorAngleDir[math.modf(index%8 + 1)];
end

--改变角色方向
function actor_control:changeDirection( nMoveDir )
	self.m_Direction = nMoveDir;
end

function actor_control:getDirection(  )
	return self.m_Direction;
end

-------------------------角色移动逻辑----------------------------------

--得到施法技能ID
function actor_control:getSkillID(  )
	return GetSoldierSetup(self.attribute_templateid).skillID;
end

--得到技能释放位置
function actor_control:getSkillCastPostion(  )
	local mySellpos = { x = 0,y = 0};
	mySellpos.x ,mySellpos.y = self:getCellPos();

	--获得角色配置信息
	local soldierInfo = GetSoldierSetup(self.attribute_templateid)
	mySellpos.x = mySellpos.x + soldierInfo.cell_w / 2;
	mySellpos.y = mySellpos.y + soldierInfo.cell_h / 2;

	return Data_Battle.mapData:getCellToWorld( mySellpos.x, mySellpos.y );
end

--得到被击位置
function actor_control:getBehitPostion(  )
	local x,y = self.showObject:getPosition();
	local data = ModelCfg[GetSoldierSetup(self.attribute_templateid).resID];
	return x + data.defaultPos_ack.x,y + data.defaultPos_ack.y;
end

--得到
-- function actor_control:getBehitPostion(  )
-- 	-- body
-- end

--设置角色位置
function actor_control:setActorPos( x , y )
	self.showObject:setPosition(cc.p(x ,y));
	self.topview:setPosition(cc.p(x ,y));
end

--得到角色位置
function actor_control:getActorPos(  )
	return self.showObject:getPosition();
end


function actor_control:setMoveTest( movedata )
	self:prepareMove( movedata );
	self:doEvent("event_move");
end

--设置角色位置
function actor_control:SetCellPos(curPos)
	local world_x ,world_y=Data_Battle.mapData:getCellToWorld( curPos.x ,curPos.y );
	self.showObject:setLocalZOrder(curPos.x + curPos.y);
	self.topview:setLocalZOrder(curPos.x + curPos.y);
	self.draw_x = world_x;
	self.draw_y = world_y;
    self:setActorPos(world_x,world_y);
    -- print("当前位置:",self:getActorPos(  ))
    -- print("SetCellPos:",self.draw_x,self.draw_y)
end

--得到角色cell坐标
function actor_control:getCellPos(  )
	return Data_Battle.mapData:getWorldToCell_1( self.showObject:getPosition() );
end

function actor_control:getCellPosByMap(  )
	return Data_Battle.mapData:getWorldToCell( self.showObject:getPosition() );
end

function actor_control:GetCellDis( pos )
	local mySellpos = { x = 0,y = 0};
	mySellpos.x ,mySellpos.y = self:getCellPos(  );
	local  dis_x = math.abs(pos.x - mySellpos.x);
	local  dis_y = math.abs(pos.y - mySellpos.y);
	return math.max(dis_x,dis_y);
end

--[[设置准备移动的步骤数据
]]
function actor_control:prepareMove( data )
	self.movePath = {};
	local count = 1;
	for i=#data,1,-1 do
		local pos = {};
		pos.x = data[i].x;
		pos.y = data[i].y;
		self.movePath[count] = pos;
		count = count + 1
	end
	-- self.executeMoveMark = false;
end

function actor_control:AddMoveByPos( pos )
	if self:getState() == "state_move" then
		local index = #self.movePath;
		self.movePath[index + 1] = pos;
	else
		self.movePath = {};
		self.movePath[1] = pos;
	end
	
end

--更新
function actor_control:update( delta )
	--检查模型状态
	if self:isDead() then
		return;
	end
	if self.showObject then
		self.showObject:playAnimation();
	end
	--执行状态逻辑
    self:executeState( delta );
    --判断是否显示血条
    if self.hpDisplay > 0 then
    	self.hpDisplay = self.hpDisplay - delta;
    	self:setHpShow( true );
    else
    	self:setHpShow( false );
    end
end

--执行状态
function actor_control:executeState( delta )
    if self:getState() == "state_move" or table.nums(self.movePath) > 0 then
        --执行移动状态
        if self:moveStepLogic( delta ) then
        	--进入休闲状态
        	self:doEvent("event_idle")
        end
    end
end

--每步执行逻辑
function actor_control:moveStepLogic( delta )
	if table.nums(self.movePath) <= 0 then
		return true;
	end

	-- print("moveStepLogic 0:",table.nums(self.movePath))
	for i,v in ipairs(self.movePath) do
		local startpos = {};
		if i == 1 then
			startpos.x,startpos.y = self:getCellPos(  );
			-- startpos.x = self.cell_x;
			-- startpos.y = self.cell_y;
		else
			startpos.x = self.movePath[i - 1].x;
			startpos.y = self.movePath[i - 1].y;
		end
		--得到2点向量
		local offset = cc.pSub(v,startpos);
		--得到距离
		local dis = cc.pGetLength(offset);
		--计算移动所需时间
		local moveTime = dis / self.m_speed;
		-- print("moveStepLogic 1:",i,startpos.x,startpos.y,v.x,v.y,offset.x,offset.y,dis,moveTime,delta)
		--如果移动时间大于当前时间执行当前移动
		if moveTime > delta then
			-- self.executeMovePos = i;
			local speedX=self.m_speed*(offset.x/dis);
            local speedY=self.m_speed*(offset.y/dis);
            local curPos=cc.pAdd(startpos,cc.p(delta*speedX,delta*speedY));
            --得到方向
            local nMoveDir=self:pointToDir(offset);
            --
            self:changeDirection(nMoveDir);
            self:SetCellPos(curPos);
            --判断是否要删除数据
            for j=i - 1,1,-1 do
            	table.remove(self.movePath,j);
            end
            -- print("remove ==>",i);
            -- print("moveStepLogic 2:",i,self.attribute_Mark,nMoveDir,curPos.x,curPos.y,self:getCellPosByMap(),self:getCellPos())
            --同步服务器角色信息
            -- afterStep();
            return false;
		end
		delta = delta - moveTime;
	end
	-- print(table.nums(self.movePath))
	self:SetCellPos(self.movePath[table.nums(self.movePath)]);
	self.movePath = {};
	--同步服务器角色信息
    -- afterStep();
	return true;
end

--执行移动到某一个位置
function actor_control:executeMoveToPos( pos )
	local actor_x ,actor_y = self:getCellPosByMap(  )
    Data_Battle.mapData.m_Astar:searchPath( {
            start_x = actor_x,
            start_y = actor_y,
            end_x = pos.x,
            end_y = pos.y
        } )
    local movePath = Data_Battle.mapData.m_Astar.path;
    self:prepareMove( movedata );
	self:doEvent("event_move");
end

--处理服务器移动指令
function actor_control:onServerMove( endpos , path )
	--判断角色是否死亡
	if self:isDead(  ) then
		return;
	end
	local dis = self:GetCellDis( endpos );
	if dis >= self.define_ForceSyncDis then
		print("onServerMove:define_ForceSyncDis",endpos.x,endpos.y)
		self:SetCellPos(endpos);
	end
	--这里可以直接用服务器的路径
	-- self:prepareMove( movedata );
	self:AddMoveByPos( cc.p(endpos.x,endpos.y) );
	self:doEvent("event_move");
end



--注册关闭事件
function actor_control:remove_event(  )
	--清除事件监听
	for k,v in pairs(self.eventlisen) do
		GLOBAL_EVENT_DISPTACHER:removeEventListener(v);
	end
end

return actor_control;
