--
-- Author: Liyang
-- Date: 2015-06-26 17:28:09
-- 建筑控制基类

local buildControl_Base = class("buildControl_Base")

-- 状态值
function buildControl_Base:ctor(target)
	--绑定状态机
	cc.bind(self, "stateMachine")
	--绑定事件
	cc.bind(self, "event")

	self:setupState({
		events = {
			--初始化后, 进入准备状态
            {name = "event_initialize", from = "none", to = "state_idle" },
            --切换到空闲状态
            {name = "event_idle", from = "*", to = "state_idle" },
            -- 移动事件
            {name = "event_move", from = "state_idle", to = "state_move" },
            -- 移动事件结束
            {name = "event_moveover", from = "state_move", to = "state_idle" },
            --攻击
            {name = "event_attack", from = "state_idle", to = "state_attack" },
            --攻击结束
            {name = "event_attack_over", from = "state_attack", to = {"state_idle"} },
            --隐藏
            {name = "event_hide", from = "*", to = "state_hide" },
            --退出隐藏
            {name = "event_exitHide", from = "state_hide", to = "state_idle" },
            --死亡事件
            {name = "event_die", from = "*", to = "state_die" },
            --复活事件
            {name = "event_relive", from = "state_die", to = "state_idle" },
		},
		callbacks = {
			onevent_initialize = handler(self, self.onEvent_initialize),
			onevent_idle = handler(self, self.onEvent_idle),
			onevent_hide = handler(self, self.onEvent_hide),
			onevent_exitHide = handler(self, self.onEvent_exitHide),
			--进入移动之前
			onbeforeevent_move = handler(self, self.onBefore_move),
			onevent_move = handler(self, self.onEvent_move),
			onevent_moveover = handler(self, self.onEvent_moveover),
			onevent_attack = handler(self, self.onEvent_attack),
			onevent_attack_over = handler(self, self.onEvent_attack_over),
			onevent_die = handler(self, self.onEvent_die),
			onevent_relive = handler(self, self.onEvent_relive),
		}
	});

	self.target_ = target;

	--注册事件
	self:register_event(  );

	--建筑属性值
	self.attribute_isdrop = 1;
	self.attribute_droptype = 1;
	self.attribute_sumhp = 1;--角色总血量
	self.attribute_currenthp = 1;--当前血量
	self.attribute_templateid = 1;--模板id

	--地图坐标
	self.cell_x = 0;
	self.cell_y = 0;
	--buf列表
	self.buffList = {};
	self.numericalPos = {};

	self.hpDisplay = 0;
	--buff叠加显示记录
    self.OverlayPos = {0,0,0,0,0,0,0,0};
    self.OverlayDisplayPos = 1;
end


--注册事件
function buildControl_Base:register_event(  )
	self.registerConfig = {
		-- {"login","event_start",1},
		-- {"login","event_createloginview",1},
		-- {"login","event_loginAccount",1},
		-- {"login","event_createregister",1},
		-- {"login","event_registeraccount",1},
		-- {"login","event_registercancel",1},
		-- {"login","event_chooseserver",1},--选择服务器
	}

	local defaultCallbacks = {
        -- buildControl_Base_start = handler(self, self.event_login),
        -- buildControl_Base_createloginview = handler(self, self.event_CreateloginView),
        -- buildControl_Base_loginAccount = handler(self, self.event_loginAccount),
        -- buildControl_Base_createregister = handler(self, self.event_createRegister),
        -- buildControl_Base_registeraccount = handler(self, self.event_registerAccount),
        -- buildControl_Base_registercancel = handler(self, self.event_registerCancel),
        -- buildControl_Base_chooseserver = handler(self, self.event_chooseserver),
    }
    self.eventlisen = {};
	for i,v in ipairs(self.registerConfig) do
		local eventname = createGlobaleEventName( v[1], v[2] )
		print("注册事件",eventname);
		if defaultCallbacks[eventname] then
			createGlobalEventListener( v[1], v[2], defaultCallbacks[eventname], v[3] )
		end
	end
	
end

function buildControl_Base:addExecuteEvent( eventname )
	if not eventname then
		return;
	end
	for i,v in ipairs(eventname) do
		table.insert(self.registerConfig, 1, eventname)
	end
end


-------------------------------状态机函数----------------------------------

--[[ 初始化建筑
	event = {
		name ,	
		args = {

			finishCallfun = nil,--完成回调函数
		}
	}	
]]
function buildControl_Base:onEvent_initialize( event )

	self.drawInfo = require("app.build.buildDrawAnalysis.lua").new();
	self.drawInfo:analysisData( self.attribute_templateid );
	self.drawInfo:retain();

	print("onEvent_initialize:",self.attribute_templateid)
	--创建角色显示
	self.showObject = ManagerBuild:CreateBuildView( self.attribute_templateid );
	self.showObject:setData( self );
	--得到坐标位置
	local x ,y= Data_Battle.mapData:getCellToWorld( self.cell_x ,self.cell_y );
	self.showObject:setPosition(cc.p(x, y));
	print("buildControl_Base",x ,y,self.cell_x ,self.cell_y,self.showObject:getPosition())
	-- self.showObject:retain();
	self.showObject.mark = 1;

	--添加到显示界面
	dispatchGlobaleEvent( "battleDisplay" ,"add" ,{self.showObject,1 ,self.cell_x + self.cell_y})

	--创建建筑修建范围
	self.buttonview = ManagerBuild:CreateBuildButtonView( self )
	self.showObject:addShowObject( self.buttonview , 0 );
	-- self.buttonview:setVisible(false);

	
	--创建血条显示
	--血量
	local sumHP = GetBuildCfg(self.attribute_templateid).hp;
	self:setSumHp( sumHP );
	self.attribute_currenthp = sumHP;
	self.topview = ManagerBuild:CreateBuildTopView(self);
	self.topview:createHPShow();
	-- self.topview:retain();
	self.topview:setPosition(cc.p(x, y));
	self.topview.mark = 1;
	-- self.topview:setVisible(false);
	--添加到显示界面
	dispatchGlobaleEvent( "battleDisplay" ,"add" ,{self.topview,3,self.cell_x + self.cell_y});

	if self.IsCreate then
		self:setBuildCreateMark( true )
	else
		Data_Battle.mapData:setMapDataByBuild( self ,2 , 1 );
	end

	self:setHpShow(false);
	self:doEvent("event_idle");
end

--重新进入初始化状态
function buildControl_Base:onEvent_idle( event )
	--进入休闲状态
	-- self:dispatchEvent({name = "EVENT_IDLE",data = event.args});

	self.showObject:setPlayAnimationType( "idle" );
end

--隐藏状态
function buildControl_Base:onEvent_hide( event )
	self.showObject:setVisible(false);
end

--退出隐藏状态
function buildControl_Base:onEvent_exitHide( event )
	self.showObject:setVisible(true);
end

--进入入场
function buildControl_Base:onEvent_entrance( event )
	self.showObject:playAnimationByID("entrance");
end

--入场结束
function buildControl_Base:onEvent_entranceover( event )
	self.showObject:playAnimationByID("idle");
	self.buttonview:setVisible(true);
	-- self:setColorEffect( cc.c3b(255, 0, 0) );
	--判断是否显示名称
	self:ShowName();
end

--进入移动之前
function buildControl_Base:onBefore_move( event )
	--
	print("build onBefore_move",self.IsCreate)
	control_Combat:setProtectScopeShow( true,Data_Battle.CONST_CAMP_ATTACK );
	self:ExecuteClickEffect( "green" );
	--记录移动开始位置
	self.recordMoveCell_x = self.cell_x;
	self.recordMoveCell_y = self.cell_y;
	Data_Battle.mapData:setMapDataByBuild( self , 2 ,0 );
	if not self.IsCreate then
		self:setBuildChooseMark( true )
	end
end

--移动状态
--[[
	args {
		播放速度
		是否循环
	}
]]
function buildControl_Base:onEvent_move(event)
	-- local move_x = event.args[1].x;
	-- local move_y = event.args[1].y;
	-- local listenercallfun = event.args[1].Callback
	print("buildControl_Base:onEvent_move:")
	--开启移动状态监测
	self.moveScheduler = GLOBAL_SCHEDULER:scheduleScriptFunc(
            handler(self, self.checkBuildMoveState),
            1, 
            false
    )
end

function buildControl_Base:onEvent_moveover( event )
	if self.moveScheduler then
		GLOBAL_SCHEDULER:unscheduleScriptEntry(self.moveScheduler);
		self.moveScheduler = nil;
	end
	--判断是否能移动到这个位置
	if self._MoveBuildState == 1 then
		if not self.IsCreate then
			--发送移动事件
			BuildManager:sendBuildMoveMsg( {
	            templeID = self.attribute_templateid,
	            guid = self.guid,
	            plot_x = Data_Battle.plot_x,
	            plot_y = Data_Battle.plot_y,
	            cell_x = self.cell_x,
	            cell_y = self.cell_y,
	            index = 1
	            } );
		end
		
	else
		--返回先前位置
		self:setBuildCellPos( self.recordMoveCell_x , self.recordMoveCell_y );
	end
	
	--关闭显示
	self:ExecuteClickEffect( "" );
	Data_Battle.mapData:setMapDataByBuild( self ,2 ,1 );
	self:setBuildChooseMark( false );
	--关闭
	control_Combat:setProtectScopeShow( false,0 );
end

function buildControl_Base:onEvent_relive( event )
	self.showObject:playAnimationByID( "revive")
	self.showObject:setVisible(true);
	self:setHpShow( true );
end

--技能施法1
function buildControl_Base:onEvent_attack( event )
	-- local listenercallfun = event.args[1].Callback
	-- self.showObject:setAnimationListen( "skill_1" ,listenercallfun );
	-- self.showObject:playAnimationByID("skill_1");
	
end

function buildControl_Base:onEvent_attack_over( event )
	-- self.showObject:playAnimation_SkillOver_1();
end

--死亡
function buildControl_Base:onEvent_die( event )
	--清空状态
	-- self.bufList = {};
	-- self.target_:releaseAllEffect();
	-- --播放死亡动画
	-- self.target_:playAnimationByID( "die" ,nil ,-1);
	-- AudioManager.playSkillEffectSound("sound_die");--播放死亡音效
	self.showObject:setPlayAnimationType("die");
	self.showObject:setVisible(false);
	self:setHpShow( false );
end




----------------------------------逻辑函数-------------------------------------

--监听动画事件
function buildControl_Base:ListenAnimationEvent( movementID )
	--动画完成
	if self.AnimationCompleteCallFun then
		self.AnimationCompleteCallFun(movementID);
	end
end

--监听帧动画事件
function buildControl_Base:ListenAnimationFrameEvent( evt )
	if self.AnimationFrameCallFun then
		self.AnimationFrameCallFun(evt);
	end
end

--设置动画完成监听
function buildControl_Base:setListenAnimationComplete( callbcak )
	--设置动画完成监听
	self.AnimationCompleteCallFun = callbcak;
end

function buildControl_Base:setListenAnimationFrameEvent( callback )
	self.AnimationFrameCallFun = callback;
end

--[[ 初始化数据
	herodata  英雄数据
	params = {
		herodata = nil,--英雄数据
		mark = "456",-- 角色GUID
		camp = 1,-- 阵营
		bossmark = 0,是否是boss
		frompos = 1, ,位置
		cell_x = 21,
		cell_y = 21,
		guid = "",
		sumhp = 1000,
		currenthp = 1000,
	}
]]
function buildControl_Base:InviData( params )
	-- body
	-- self.ActorData = params.herodata;
	self.attribute_Mark = params.mark or 1;
	self.attribute_camp = params.camp or 1; --阵营
	self.attribute_bossmark = params.bossmark or 0; --是否是boss
	self.attribute_sumhp = params.sumhp or 0;--角色总血量
	self.attribute_currenthp = params.currenthp or 0;--当前血量
	self.attribute_templateid = params.templateid;--模板id
	self.attribute_IsShowName = params.isshowname or 0; --是否显示名称
	self.cell_x = params.cell_x or 21;
	self.cell_y = params.cell_y or 21;
	self.guid = params.guid or NULL_GUID;
	self.attribute_level = params.level or 1;
	self.IsCreate = params.iscreate or false;
	print("buildControl_Base InviData:",self.attribute_templateid,self.attribute_Mark)
    -- self:doEvent("initialize") -- 启动状态机
end

--更新
function buildControl_Base:update( delta )
	if self:isDead() then
		return;
	end
	--检查模型状态
	if self.showObject then
		self.showObject:playAnimation();
	end
	--执行状态逻辑
    -- self:executeState( delta );
    --判断是否显示血条
    if self.hpDisplay > 0 then
    	self.hpDisplay = self.hpDisplay - delta;
    	self:setHpShow( true );
    else
    	self:setHpShow( false );
    end
end

function buildControl_Base:getId()
	return self.attribute_Mark;
end

function buildControl_Base:getCamp()
	return self.attribute_camp;
end

function buildControl_Base:setSumHp( values )
	self.attribute_sumhp = values;
	self.hpScale = 100 / self.attribute_sumhp;
end

--更新函数
function buildControl_Base:updata_hp( valuse )
	self.attribute_currenthp = valuse;
	print("设置血量:",valuse,self.attribute_Mark)
	self.topview:setHpValuse( self.hpScale * valuse );

	if self.attribute_currenthp <= 0 then
		self:doEvent("event_die");
	end
end

--[[当前血量改变
    hpvaluse 改变值
    isdead 主要是为了修正值
]]
function buildControl_Base:UpDataCurrentHp( hpvaluse ,isdead)
    local hp = self.attribute_currenthp + hpvaluse;
    if (not isdead) and hp < 0 then
        hp = 1;
    end
    self:updata_hp(hp);
end

function buildControl_Base:setHpShow( isshow )
	if isshow then
		self.topview:setVisible(true);
	else
		self.topview:setVisible(false);
	end
end

function buildControl_Base:setHPDisplayTime(  )
	self.hpDisplay = 10;
end

function buildControl_Base:setSkillPromptShow( name )
	if name then
		self.topview:createSkillName( name );
	end
end

function buildControl_Base:ShowName(  )
	--判断阵营
	-- if self.attribute_camp == 1 then
	-- 	return false;
	-- end

	if self.attribute_IsShowName == 1 then
		self:setRoleNameShow(  );
	end

	-- --判断战斗类型
	-- if Data_Battle:checkCurrentBattlefieldTypeIsPVP(  ) then
	-- 	self:setRoleNameShow(  );
	-- else
	-- 	if self.attribute_bossmark == 1 then
	-- 		self:setRoleNameShow(  );
	-- 	end
	-- end
end

--设置角色名称显示
function buildControl_Base:setRoleNameShow(  )
	--判断是否是boss

	local herostar = heroConfig[self.attribute_templateid].star;
	local heroname = heroConfig[self.attribute_templateid].name;
	local color = ResIDConfig:getEquipQualityInfo( herostar ).color;
	self.topview:createRoleName( heroname , color );
end

--添加数值buf效果
function buildControl_Base:addNumericeBufEffect( effect )
	local pos = 0;
	for i,v in pairs(self.numericalPos) do
		if v then
			pos = pos + 1 ;
		end
	end
	if pos < 5 then
		self.numericalPos[effect] = effect;
		effect.pos = pos + 1;
		local x = 30 + (pos - 1) * 30;
		local sunLen = pos * 30;
		effect:setPosition(cc.p(x , 0))
		self.topview:createBufShow( effect ,sunLen);
	end
end

--去除数值效果
function buildControl_Base:removeNumericeBufEffect( effect )
	if not self.numericalPos[effect] then
		return;
	end
	local removepos = self.numericalPos[effect].pos;
	self.numericalPos[effect] = nil;
	local x,y = 0,180;

	for k,v in pairs(self.numericalPos) do
		if v.pos > removepos then
			v.pos = v.pos - 1;
		end
		x = 30 + (v.pos - 1) * 30;
		effect:setPosition(cc.p(x , 0));
	end
	local count = table.nums(self.numericalPos);
	self.topview:createBufShow( nil ,count*30);
end

--[[添加颜色效果
]]
function buildControl_Base:setColorEffect( color )
	print("buildControl_Base:setColorEffect",self.showObject);
	if self.showObject then
		self.showObject:setColorEffect( color );
	end
end

--判断角色是否拥有buff
function buildControl_Base:IsHaveBuff( buffid )
    for i,v in pairs(self.buffList) do
        if v and v.BuffType == buffid then
            printInfo("添加相同buf：%s", buffid);
            return v;
        end
    end
    return false;
end

--添加buff
function buildControl_Base:AddBuff( node )
    for i,v in pairs(self.buffList) do
        if v and v.BuffType == node.BuffType then
        	printInfo("添加相同buf：%s", node.BuffType);
            return false;
        end
    end
    self.buffList[node] = node;
    self.showObject:addShowObject( node , 3 );
    printInfo("添加buff:%s",tostring(self),node.BuffType);
    return true;
end

--移除buf
function buildControl_Base:RemoveBuff( buffType )
	print("buildControl_Base:RemoveBuff",buffType)
    for i,v in pairs(self.buffList) do
    	print(i,v,v.BuffType,"==",buffType)
        if v and v.BuffType == buffType then
            printInfo("移除buff:%s",buffType);
            v:ExitEffect(  );
            self.buffList[i] = nil;
            return;
        end
    end
end

--清除所有buf
function buildControl_Base:ClearBuff(  )
    for i,v in pairs(self.buffList) do
        if v then
            v:ExitEffect(  );
            self.buffList[i] = nil;
        end
    end
end

--是否死亡
function buildControl_Base:isDead(  )
	if self:getState() == "state_die" then
        return true;
    end
	return false;
end

--死亡检测
function buildControl_Base:DeadCheck(  )
	--判断角色是否已经死亡
    if self:getState() == "state_die" then
        return true;
    end
    if self.attribute_currenthp <= 0 then
        self:doEvent("event_die")
        return true;
    end
    return false;
end



--设置角色的zorder
function buildControl_Base:setActorLocalZOrder( zorder )
	-- self.showObject:setLocalZOrder(zorder);
	self.showObject:getParent():reorderChild(self.showObject,zorder);
end

function buildControl_Base:resetActorLocalZOrder(  )
	self.showObject:getParent():reorderChild(self.showObject,self.cell_x + self.cell_y);
end



--得到建筑地图位置
function buildControl_Base:getBuildCellPos(  )
	return self.cell_x,self.cell_y;
end

function buildControl_Base:ActorMoveEffect( move_x ,move_y ,time ,callfun)
	self.showObject:setAnimationListen( "move" ,callfun );
	self.showObject:exexuteMoveAction( move_x , move_y ,time);
	--更新坐标
	self.cell_x ,self.cell_y = Data_Battle.mapData:getWorldToMapTransform( move_x ,move_y );
end

--得到施法技能ID
function buildControl_Base:getSkillID(  )
	return GetBuildCfg(self.attribute_templateid).skillID;
end

--得到技能释放位置
function buildControl_Base:getSkillCastPostion(  )
	local mySellpos = { x = 0,y = 0};
	mySellpos.x ,mySellpos.y = self:getCellPos();

	--获得角色配置信息
	local soldierInfo = GetBuildCfg(self.attribute_templateid)
	mySellpos.x = mySellpos.x + soldierInfo.cell_w / 2;
	mySellpos.y = mySellpos.y + soldierInfo.cell_h / 2;

	return Data_Battle.mapData:getCellToWorld( mySellpos.x, mySellpos.y );
end

--得到被击位置
function buildControl_Base:getBehitPostion(  )
	local x,y = self:getSkillCastPostion();
	local data = ModelCfg[GetBuildCfg(self.attribute_templateid).resID];
	return x + data.defaultPos_ack.x,y + data.defaultPos_ack.y;
end

--设置角色位置
function buildControl_Base:setBuildCellPos( cell_x , cell_y )
	--得到坐标位置
	self.cell_x = cell_x;
	self.cell_y = cell_y;
	local pos_x ,pos_y= Data_Battle.mapData:getCellToWorld(  self.cell_x,self.cell_y );
	self.showObject:setPosition(cc.p(pos_x ,pos_y));

	--设置血量位置
	self.topview:setPosition(cc.p(pos_x ,pos_y));
end

--设置角色位置
function buildControl_Base:SetCellPos(curPos)
	local world_x ,world_y=Data_Battle.mapData:getCellToWorld( curPos.x ,curPos.y );
	self.showObject:setLocalZOrder(curPos.x + curPos.y);
	self.topview:setLocalZOrder(curPos.x + curPos.y);
	self.draw_x = world_x;
	self.draw_y = world_y;
    self:setPostion(world_x,world_y);
    -- print("当前位置:",self:getActorPos(  ))
    -- print("SetCellPos:",self.draw_x,self.draw_y)
end

--设置角色位置
function buildControl_Base:setPostion( x , y )
	self.showObject:setPosition(cc.p(x ,y));
	self.topview:setPosition(cc.p(x ,y));
end

--得到角色cell坐标
function buildControl_Base:getCellPos(  )
	return Data_Battle.mapData:getWorldToCell_1( self.showObject:getPosition() );
end

function buildControl_Base:getCellPosByMap(  )
	return Data_Battle.mapData:getWorldToCell( self.showObject:getPosition() );
end

function buildControl_Base:GetCellDis( pos )
	local mySellpos = { x = 0,y = 0};
	mySellpos.x ,mySellpos.y = self:getCellPos(  );
	local  dis_x = math.abs(pos.x - mySellpos.x);
	local  dis_y = math.abs(pos.y - mySellpos.y);
	return math.max(dis_x,dis_y);
end

--获得角色移动方向
function buildControl_Base:pointToDir( cellPt )
   
    return ManagerActor.ActorAngleDir[1];
end

--改变角色方向
function buildControl_Base:changeDirection( nMoveDir )

end

----------------------------点击相关逻辑-----------------------------

--是否被点击
function buildControl_Base:IsClick( pos )
	local arenaInfo = GetBuildCfg(self.attribute_templateid)
	if pos.x < self.cell_x or pos.y < self.cell_y or pos.x >= self.cell_x + arenaInfo.cell_w or pos.y >= self.cell_y + arenaInfo.cell_h then
		return false;
	end
	return true;
end

--[[设置建筑当前移动位置的状态
	state 1 绿色状态 0 红色状态
]]
function buildControl_Base:checkBuildMoveState(  )
	if Data_Battle.mapData:IsCanConstructBuild( self ) then
		if self._MoveBuildState == 1 then
			--todo
		else
			self._MoveBuildState = 1;
			self:ExecuteClickEffect( "green" );
		end
		
	else
		if self._MoveBuildState == 0 then
			--todo
		else
			self._MoveBuildState = 0;
			self:ExecuteClickEffect( "red" );
		end
	end
end

--[[执行点击效果
	red 红色
	green 绿色
	cell 显示格子 
]]
function buildControl_Base:ExecuteClickEffect( effect )
	print("ExecuteClickEffect:",effect)
	self.buttonview:ShowEffectAreaScope( effect );
end

--[[设置建筑创建表示
]]
function buildControl_Base:setBuildCreateMark( iscreate )
	self.IsCreate = iscreate;
	if iscreate then
		--添加建筑创建UI
		-- self.createUI = require("app.build.buildview.build_create_quren").new();
		-- self.showObject:addShowObject( self.createUI , 2 );
		-- self.createUI:setPosition(cc.p(0,50));
		-- self.createUI:setOperateBuild( self );
	else
		if self.createUI then
			self.createUI:removeFromParent();
			self.createUI = nil;
		end
	end
	
end

--[[创建建筑选择操作界面
]]
function buildControl_Base:setBuildChooseMark( iscreate )
	if iscreate then
		--添加建筑创建UI
		self.chooseOperUI = require("app.build.buildview.build_choose_handle").new();
		self.showObject:addShowObject( self.chooseOperUI , 2 );
		self.chooseOperUI:setPosition(cc.p(0,50));
		self.chooseOperUI:setOperateBuild( self );
	else
		if self.chooseOperUI then
			self.chooseOperUI:removeFromParent();
			self.chooseOperUI = nil;
		end
	end
	
end

--注册关闭事件
function buildControl_Base:remove_event(  )
	--清除事件监听
	for k,v in pairs(self.eventlisen) do
		GLOBAL_EVENT_DISPTACHER:removeEventListener(v);
	end
end

function buildControl_Base:clear(  )
	if self.moveScheduler then
		GLOBAL_SCHEDULER:unscheduleScriptEntry(self.moveScheduler);
		self.moveScheduler = nil;
	end
	self:remove_event();
	--清除显示UI
	battleDisplayManager:register_event_removeshowobject( self.showObject )
	battleDisplayManager:register_event_removeshowobject( self.topview )
	self.drawInfo:release();
end

return buildControl_Base;
