--
-- Author: LiYang
-- Date: 2016-05-02 23:00:38
-- 控制建筑点击事件

local controller_BuildClickLogic = class("controller_BuildClickLogic")

function controller_BuildClickLogic:ctor()
	--注册的事件
	self.registerConfig = {
		{"BuildCreateTounchEvent","start",1},--点击开始
		{"BuildCreateTounchEvent","move",1},--结束
		{"BuildCreateTounchEvent","end",1},--结束
		{"BuildCreate","over",1},--创建建筑结束
		{"BattleTouchEvent","start",1},--战场触摸事件开始
		{"BattleTouchEvent","onemove",1},--战场移动触摸事件
		{"BattleTouchEvent","end",1},--战场触摸事件结束
	};
	self:register_event(  );
	--操作的建筑
	self._OperationBuild = nil;

	self.INTERVAL_TIME = 2;
	--是否执行操作
	self._IsExcuteOper = false;

	self._IsMoveTounch = false;
end

function controller_BuildClickLogic:register_event(  )

    local defaultCallbacks = {
        BuildCreateTounchEvent_start = handler(self, self.register_event_buildclick_start),
        BuildCreateTounchEvent_move = handler(self, self.register_event_BattleTouchEvent_Onemove),
        BuildCreateTounchEvent_end = handler(self, self.register_event_createbuild_TounchEvent_end),
        BuildCreate_over = handler(self, self.register_event_createbuild_Over),
        BattleTouchEvent_start = handler(self, self.register_event_BattleTouchEvent_start),
        BattleTouchEvent_onemove = handler(self, self.register_event_BattleTouchEvent_Onemove),
        BattleTouchEvent_end = handler(self, self.register_event_BattleTouchEvent_end),
    }
    self.eventlisen = {};
    for i,v in ipairs(self.registerConfig) do
        local eventname = createGlobaleEventName( v[1], v[2] )
        print("注册事件",eventname);
        if defaultCallbacks[eventname] then
            self.eventlisen[eventname] = createGlobalEventListener( v[1], v[2], defaultCallbacks[eventname], v[3] )
        end
    end
end

--[[注册建筑点击开启事件
	clickBuild 点击的建筑
	pos 点击的位置
]]
function controller_BuildClickLogic:register_event_buildclick_start( event )
	print("BuildClickLogic:register_event_buildclick_start")
	self.startTwoParam = event._usedata[1];
	self._IsMoveTounch = false;
	--切换建筑
	self._IsExcuteOper = true;
	self._IsCreateBuild = true;
	self.checkBuild = BuildManager.addNewsBuildData.view;
	self._OperationBuild = BuildManager.addNewsBuildData.view;
	self._OperationBuild:doEvent("event_move");
end


function controller_BuildClickLogic:register_event_BattleTouchEvent_start( event )
	print("controller_BuildClickLogic start")
	self.startTwoParam = event._usedata[1];
	self._IsMoveTounch = false;
	--判断是否是创建建筑
	if self._IsCreateBuild then
		if BuildManager.addNewsBuildData.view:IsClick( { x = self.startTwoParam.cell_1.x ,y = self.startTwoParam.cell_1.y} ) then
            --发送点击建筑事件
            self.checkBuild = BuildManager.addNewsBuildData.view;
        else
        	self.checkBuild = nil;
        end
		return;
	end
	--判断是否点击建筑
    for k,v in pairs(control_Combat.buildViewPool) do
        if v:IsClick( { x = self.startTwoParam.cell_1.x ,y = self.startTwoParam.cell_1.y} ) then
            --发送点击建筑事件
            self.checkBuild = v;
            break;
        end
    end
    --判断检查的建筑
    if not self.checkBuild then
    	return;
    end

    if self._OperationBuild == self.checkBuild then
    	--发送建筑移动位置消息
    	return;
    end

    --添加计时器
    self.Scheduler_ex = GLOBAL_SCHEDULER:scheduleScriptFunc(
        handler(self, self.registerScheduleListen),
        self.INTERVAL_TIME, 
        false
    )
end

--[[
	moveV = movepos,
    pos = pos_1,
    cell_x = cell_x,
    cell_y = cell_y,
]]
function controller_BuildClickLogic:register_event_BattleTouchEvent_Onemove( event )
	print("controller_BuildClickLogic move",self._OperationBuild)
	self._IsMoveTounch = true;
	if self.Scheduler_ex then
		GLOBAL_SCHEDULER:unscheduleScriptEntry(self.Scheduler_ex);
		self.Scheduler_ex = nil;
	end

	if not self._OperationBuild then
		return;
	end
	local moveData = event._usedata;
	--判断是否在操作建筑移动 self._OperationBuild:IsClick( {moveData.cell_x,moveData.cell_y} )
	if self.checkBuild == self._OperationBuild then
		--设置建筑移动标记
		BattleOperation.build = true;
		--移动建筑
		self._OperationBuild:setBuildCellPos( moveData.cell_x , moveData.cell_y );
		return;
	end

end
--[[
		pos = endpos,
        cell_x = cell_x,
        cell_y = cell_y
]]
function controller_BuildClickLogic:register_event_BattleTouchEvent_end( event )
	print("controller_BuildClickLogic end")
	local endTounchData = event._usedata;
	--关闭建筑移动标记
	if self.checkBuild then
		if self._OperationBuild == self.checkBuild or self._IsCreateBuild then
			
		else
			if self.checkBuild:IsClick( { x = endTounchData.cell_x, y = endTounchData.cell_y} ) and (not self._IsMoveTounch) then
				--切换建筑
				self._IsExcuteOper = true;
				if self._OperationBuild then
					self._OperationBuild:doEvent("event_moveover");
				end
				self._OperationBuild = self.checkBuild;
				self._OperationBuild:doEvent("event_move");
			end
		end
		
		
	else
		if self._OperationBuild and (not self._IsMoveTounch) and ( not self._IsCreateBuild) then
			self._OperationBuild:doEvent("event_moveover");
			self._OperationBuild = nil;
			self._IsExcuteOper = false;
		end
	end
	if self.Scheduler_ex then
		GLOBAL_SCHEDULER:unscheduleScriptEntry(self.Scheduler_ex);
		self.Scheduler_ex = nil;
	end
	BattleOperation.build = false;
	self.checkBuild = nil;
	self.Scheduler_ex = nil;
	self._IsMoveTounch = false;
end

--[[
	注册建筑创建移动结束事件
]]
function controller_BuildClickLogic:register_event_createbuild_TounchEvent_end( event )
	local endTounchData = event._usedata;
	--关闭建筑移动标记
	if self.Scheduler_ex then
		GLOBAL_SCHEDULER:unscheduleScriptEntry(self.Scheduler_ex);
		self.Scheduler_ex = nil;
	end
	-- self._OperationBuild = nil;
	-- self._IsExcuteOper = false;
	BattleOperation.build = false;
	self.checkBuild = nil;
	self.Scheduler_ex = nil;
	self._IsMoveTounch = false;
end

--[[注册创建建筑结束事件
]]
function controller_BuildClickLogic:register_event_createbuild_Over( event )
	--关闭建筑移动标记
	if self.Scheduler_ex then
		GLOBAL_SCHEDULER:unscheduleScriptEntry(self.Scheduler_ex);
		self.Scheduler_ex = nil;
	end
	self._IsCreateBuild = false;
	self._OperationBuild = nil;
	self._IsExcuteOper = false;
	BattleOperation.build = false;
	self.checkBuild = nil;
	self.Scheduler_ex = nil;
	self._IsMoveTounch = false;
end

function controller_BuildClickLogic:registerScheduleListen(  )
	if (not self._IsExcuteOper) and (not self.checkBuild) then
		self._IsExcuteOper = true;
		self._OperationBuild = self.checkBuild;
	end
	GLOBAL_SCHEDULER:unscheduleScriptEntry(self.Scheduler_ex);
	self.Scheduler_ex = nil;
end

--注册关闭事件
function controller_BuildClickLogic:remove_event(  )
	--清除事件监听
	for k,v in pairs(self.eventlisen) do
		GLOBAL_EVENT_DISPTACHER:removeEventListener(v);
	end
end

return controller_BuildClickLogic;
