--
-- Author: LiYang
-- Date: 2015-07-21 14:16:18
-- 资源加载逻辑

--[[发送全局事件名预览
eventModleName: loadres -- 战役接口内部控制
eventName: 
	finish 载入完成
]]

--[[监听全局事件名预览
eventModleName: 
eventName:
]]

--[[
	reslist 必须是解析好的 一维数组
]]

-- cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888
-- cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A4444
-- cc.TEXTURE2_D_PIXEL_FORMAT_RG_B565

local resLoadLogic = class("resLoadLogic");

function resLoadLogic:ctor()
	-- body
	--异步加载顺序
	self.AsyncLoadOrder = {
		cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888,
		cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A4444,
		cc.TEXTURE2_D_PIXEL_FORMAT_RG_B565,
	};
	self.CurrentLoad = 1;
end

function resLoadLogic.getInstance()
	if resLoadLogic.instance == nil then
		resLoadLogic.instance = resLoadLogic.new()
	end
	return resLoadLogic.instance
end

--[[设置载入列表
	reslist 载入列表
	mark 标示
	loadtype 加载类型(是否加载loadtype 0 只加载图片 1 加载plist和图片)
]]
function resLoadLogic:setLoadList( reslist , mark ,loadtype)
	self.mark = mark;
	self.resList = reslist;
	--载入的数量
	self.loadCount = table.nums(self.resList);
	self.CurrentLoad = 1;
	-- for k,v in pairs(self.resList) do
	-- 	if v then
	-- 		local resInfo = ResConfig[v];
	-- 		for i,j in ipairs(resInfo.res) do
	-- 			self.ResCount = self.ResCount + 1;
	-- 		end
	-- 	end
	-- end
	self.CurrentIndex = 1;
	self.LoadType = loadtype or 0;
end

function resLoadLogic:setCallback( callfun )
	self.Callfun = callfun;
end

--解析 plist 资源
function resLoadLogic:analysisPlist( res )
	local pos = string.find(res, "%.");
	local resstr = string.sub(res,1,pos)
	return resstr.."plist";
end

--载入资源和plist
function resLoadLogic:LoadResAndList(  )
	for k,v in pairs(self.resList) do
		local format = getTexturePixelFormat( v );
		cc.Texture2D:setDefaultAlphaPixelFormat(format);
		print("      ",v,format,cc.Texture2D:getDefaultAlphaPixelFormat())
		GLOBAL_TEXTURE_CACHE:addImage(v)
		GLOBAL_SPRITE_FRAMES_CACHE:addSpriteFrames(self:analysisPlist( v ));
		cc.Texture2D:setDefaultAlphaPixelFormat(GOLBAL_DEFAULT_PIXELFORMAT);
	end
	-- dispatchGlobaleEvent("loadres", "finish", self.mark)
	-- print("LoadResAndList",self.Callfun);
	if self.Callfun then
		cc.Texture2D:setDefaultAlphaPixelFormat(cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888);
		self.Callfun(self.mark)
	end
end

--载入资源
function resLoadLogic:LoadRes(  )
	for k,v in pairs(self.resList) do
		cc.Texture2D:setDefaultAlphaPixelFormat(getTexturePixelFormat( v ));
		GLOBAL_TEXTURE_CACHE:addImage(v)
		-- GLOBAL_SPRITE_FRAMES_CACHE:addSpriteFrames(plistFilename, image)
		cc.Texture2D:setDefaultAlphaPixelFormat(GOLBAL_DEFAULT_PIXELFORMAT);
	end
	-- dispatchGlobaleEvent("loadres", "finish", self.mark)
	if self.Callfun then
		cc.Texture2D:setDefaultAlphaPixelFormat(cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888);
		self.Callfun(self.mark)
	end
end

--异步加载
function resLoadLogic:AsyncLoadRes(  )
	-- print(self.AsyncLoadOrder[self.CurrentLoad])
	self:AsyncLoadResByFormat( self.AsyncLoadOrder[self.CurrentLoad] )
end

--队列加载资源
function resLoadLogic:AsyncLoadResByQueue(  )
	local resdata = self.resList[self.CurrentIndex];
	local format = getTexturePixelFormat( resdata );
	cc.Texture2D:setDefaultAlphaPixelFormat(format);
	print("      ",resdata,format,cc.Texture2D:getDefaultAlphaPixelFormat())
	GLOBAL_TEXTURE_CACHE:addImageAsync(resdata, handler(self, self.listenerLoadQueue))
end

--[[分格式加载
]]
function resLoadLogic:AsyncLoadResByFormat( PixelFormat )
	-- if not name then
	-- 	printError("Error:resLoadLogic 载入资源为nil")
	-- 	return;
	-- end
	--[[ 分像素格式加载
		先载入
	]]
	self.CurrentCount = 0;
	for k,v in pairs(self.resList) do
		local format = getTexturePixelFormat( v );
		if format == PixelFormat then
			self.CurrentCount = self.CurrentCount + 1;
		end
	end
	print("加载格式资源:",PixelFormat,self.CurrentCount)
	for k,v in pairs(self.resList) do
		local format = getTexturePixelFormat( v );
		if format == PixelFormat then
			cc.Texture2D:setDefaultAlphaPixelFormat(PixelFormat);
			print("      ",v)
			GLOBAL_TEXTURE_CACHE:addImageAsync(v, handler(self, self.ListenLoad))
		end
	end

	if self.CurrentCount < 1 then
		self.CurrentLoad = self.CurrentLoad + 1;
		if self.AsyncLoadOrder[self.CurrentLoad] then
			self:AsyncLoadResByFormat( self.AsyncLoadOrder[self.CurrentLoad] );
		end
	end
	
end

function resLoadLogic:listenerLoadQueue( params )
	-- print("listenerLoadQueue Finish",self.CurrentIndex);
	-- print(params:getName())
	-- print(self.mark ,params:getName(),self.CurrentIndex,self.loadCount);
	self.CurrentIndex = self.CurrentIndex + 1;
	if self.CurrentIndex > self.loadCount then
		print("resLoadLogic:listenerLoadQueue");
		--异步加载完成
		cc.Texture2D:setDefaultAlphaPixelFormat(cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888);
		if self.LoadType == 1 then
			for i,v in ipairs(self.resList) do
				GLOBAL_SPRITE_FRAMES_CACHE:addSpriteFrames(self:analysisPlist( v ));
			end
		end
		if self.Callfun then
			self.Callfun(self.mark)
		end
	else
		self:AsyncLoadResByQueue(  );
	end
end


--监听加载函数
function resLoadLogic:ListenLoad( parame )
	self.loadCount = self.loadCount - 1;
	self.CurrentCount = self.CurrentCount - 1;
	print(self.CurrentCount,parame)
	if self.loadCount < 1 then
		--异步加载完成
		cc.Texture2D:setDefaultAlphaPixelFormat(cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888);
		if self.Callfun then
			self.Callfun(self.mark)
		end
	elseif self.CurrentCount < 1 then
		self.CurrentLoad = self.CurrentLoad + 1;
		print("========================>",self.CurrentLoad)
		if self.AsyncLoadOrder[self.CurrentLoad] then
			self:AsyncLoadResByFormat( self.AsyncLoadOrder[self.CurrentLoad] );
		end
	end
end

ResLoad = resLoadLogic.getInstance();

return resLoadLogic
