--
-- Author: Li Yang
-- Date: 2014-03-18 17:43:26
-- 前端一些资源帧数据配置文件

import(".ResFrameConfig_ResIDConfig")

--得到资源后缀名
function getResSuffixById( restype )
	if restype == "jpg" then
		return ".jpg";
	end
	return ".png";
end

--[[资源配置文件主要用于销毁使用
	动画名称
		restype 资源类型(list , png ,ExportJson ,jpg)
		respath 路径
		res 资源
		animation_name 动画名称
]]
ResConfig = {

	["ui_image/logineffect_0/logineffect_0.ExportJson"] = {
		restype = "ExportJson",
		respath = "ui_image/logineffect_0/",
		res = {"logineffect_00","logineffect_01","logineffect_02","logineffect_03","logineffect_04",
		"logineffect_05","logineffect_06","logineffect_07","logineffect_07","logineffect_08",},
	},

	["ui_image/ui_effect/effect_login_title.ExportJson"] = {
		restype = "ExportJson",
		respath = "ui_image/ui_effect/",
		res = {"effect_login_title",},
	},

	["ui_image/ui_effect/logineffect_button.ExportJson"] = {
		restype = "ExportJson",
		respath = "ui_image/ui_effect/",
		res = {"effect_login_button",},
	},

	["animation/zhanyi/zhanyimark.ExportJson"] = {
		restype = "ExportJson",
		respath = "animation/zhanyi/",
		res = {"zhanyimark0",},
		animation_name = "zhanyimark",
	},
	----------------------战斗结果效果--------------------
	["animation/zhandou/battleresult_1.ExportJson"] = {
		restype = "ExportJson",
		respath = "animation/zhandou/",
		res = {"battleresult_10",},
		animation_name = "battleresult_1",
	},

	["animation/zhandou/battleresult_0.ExportJson"] = {
		restype = "ExportJson",
		respath = "animation/zhandou/",
		res = {"battleresult_00",},
		animation_name = "battleresult_0",
	},

	----------------------角色动画-------------------------
	["herores/lvbu/role_lvbu_back.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/lvbu/",
		res = {"role_lvbu_back0",},
		animation_name = "role_lvbu_back",
	},

	["herores/lvbu/role_lvbu_front.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/lvbu/",
		res = {"role_lvbu_front0",},
		animation_name = "role_lvbu_front",
	},

	--张角
	["herores/zhangjiao/f_zj_e.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/zhangjiao/",
		res = {"zj_font_e",},
		animation_name = "f_zj_e",
	},

	["herores/zhangjiao/f_zj_i.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/zhangjiao/",
		res = {"zj_font_idle",},
		animation_name = "f_zj_i",
	},

	["herores/zhangjiao/f_zj_s_0.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/zhangjiao/",
		res = {"zj_f_s_1_0","zj_f_s_1_1","zj_f_s_1_2","zj_f_s_1_4",},
		animation_name = "f_zj_s_0",
	},

	["herores/zhangjiao/f_zj_s_1.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/zhangjiao/",
		res = {"zj_f_s_2_0","zj_f_s_1_2","zj_f_s_1_4",},
		animation_name = "f_zj_s_1",
	},

	["herores/zhangjiao/zj_1001.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/zhangjiao/",
		res = {"zj_1001",},
		animation_name = "zj_1001",
	},

	--周泰
	["herores/zhoutai/f_zt_e.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/zhoutai/",
		res = {"f_zt_e"},
		animation_name = "f_zt_e",
	},

	["herores/zhoutai/f_zt_i.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/zhoutai/",
		res = {"f_zt_0","f_zt_1","f_zt_2","f_zt_3",},
		animation_name = "f_zt_i",
	},

	["herores/zhoutai/f_zt_s_1.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/zhoutai/",
		res = {"f_zt_s_1_0_0","f_zt_s_1_0_1"},
		animation_name = "f_zt_s_1",
	},

	["herores/zhoutai/f_zt_s_2.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/zhoutai/",
		res = {"f_zt_s_2_0_0","f_zt_s_2_0_1","f_zt_s_2_0_2",},
		animation_name = "f_zt_s_2",
	},

	


	------------------公用效果-----------------
	["herores/common/wuli_entrance_0.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/common/",
		res = {"wuli_entrance_0",},
		animation_name = "wuli_entrance_0",
	},
	["herores/common/wuli_entrance_1.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/common/",
		res = {"wuli_entrance_1",},
		animation_name = "wuli_entrance_1",
	},

	["herores/common/guanghuan_white.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/common/",
		res = {"gh_white",},
		animation_name = "guanghuan_white",
	},

	["herores/common/guanghuan_blue.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/common/",
		res = {"gh_blue",},
		animation_name = "guanghuan_blue",
	},

	["herores/common/guanghuan_purple.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/common/",
		res = {"gh_purple",},
		animation_name = "guanghuan_purple",
	},

	["herores/common/guanghuan_orange.ExportJson"] = {
		restype = "ExportJson",
		respath = "herores/common/",
		res = {"gh_orange",},
		animation_name = "guanghuan_orange",
	},

	--战斗公共资源
	["ui_image/battle/common"] = {
		restype = "plist",
		respath = "ui_image/battle",
		res = {"battle_0",},
	},



	---------------技能效果---------------
	["animation/skilleffect/zj_se_0.ExportJson"] = {
		restype = "ExportJson",
		respath = "animation/skilleffect/",
		res = {"f_zb_s_2_1_0","f_zb_s_2_1_1",},
		animation_name = "zj_se_0",
	},

	["animation/skilleffect/zb_se_0.ExportJson"] = {
		restype = "ExportJson",
		respath = "animation/skilleffect/",
		res = {"zj_se_0",},
		animation_name = "zb_se_0",
	},

	["animation/skilleffect/f_lx_s_2_1.ExportJson"] = {
		restype = "ExportJson",
		respath = "animation/skilleffect/",
		res = {"f_lx_s_2_1",},
		animation_name = "f_lx_s_2_1",
	},

	-------------打击效果---------------
	["animation/skilleffect/bloweffect_1.ExportJson"] = {
		restype = "ExportJson",
		respath = "animation/skilleffect/",
		res = {"f_zr_s_1_1",},
		animation_name = "bloweffect_1",
	},

	["animation/skilleffect/f_hz_s_1_1.ExportJson"] = {
		restype = "ExportJson",
		respath = "animation/skilleffect/",
		res = {"f_hz_s_1_1",},
		animation_name = "f_hz_s_1_1",
	},

	--------------buf效果资源---------------------
	["animation/skilleffect/bufeffect_1.ExportJson"] = {
		restype = "ExportJson",
		respath = "animation/skilleffect",
		res = {"buf_1_0",},
		animation_name = "bufeffect_1",
	},

	["animation/skilleffect/bufeffect_2.ExportJson"] = {
		restype = "ExportJson",
		respath = "animation/skilleffect",
		res = {"buf_2_0",},
		animation_name = "bufeffect_2",
	},

	-- ["animation/battle/zhuangtai.ExportJson"] = {
	-- 	restype = "ExportJson",
	-- 	respath = "animation/battle",
	-- 	res = {"zhuangtai_1",},
	-- 	animation_name = "zhuangtai",
	-- },
}

----------------动画配置------------------


---------------技能资源信息--------------

--[[技能效果资源
	action ,动作列表
]]
EffectResConfig = {
	[20000] = {describe = "张角技能1",action = "skill_2" ,other = {"10000"}, },
	[20001] = {describe = "张角技能2",action = "skill_1" ,other = {"10006"}, },
}


--游戏颜色值
GLOBAL_COLOUR_VALUSE = {
	--服务器状态颜色 1 正常  2繁忙 3 维护 4 新区
	["server_state_1"] = cc.c4b(145, 246,252,255),
	["server_state_2"] = cc.c4b(230, 209, 9,255),
	["server_state_3"] = cc.c4b(255, 0, 0,255),
	["server_state_4"] = cc.c4b(15, 178, 25,255),
}

function getModelData( index )
	return ModelCfg[index];
end




--[[模型配置文件
	frameImage 图片框
	iconImage icon 图片
	pos_x 图片相对于图框的位置
	pos_y
]]
ModelCfg = {
	--[[
		describe 角色描述
		attackfigure 攻击方形象
		defendfigure 防守方形象
	]]
	[20001]={
		describe = "BAY",
		defaultPos_hp = {x = 0,y = 40},--血量显示位置
		defaultPos_ack = {x = 0,y = 0},--被击点位置
		headicon = "heroicon0_small.png",
		actionlist = {
			idle = { 10117,10118,10119,10120,10121,10122,10123,10124 }, --空闲
			-- shanbi = {}, --空闲
			-- behit = {},--被击
			attack = { 10109,10110,10111,10112,10113,10114,10115,10116},--攻击
			move = { 10101,10102,10103,10104,10105,10106,10107,10108 },--移动
			die = { 10125,10126,10127,10128,10129,10130,10131,10132 },--死亡
		},
		--碰撞区域(做矩形碰撞)
		collisionRect = {
			{x = -20, y = -20, width = 100, height = 100},
			-- {x = _x, y = _y, width = _width, height = _height},
		},
	},

	[20002]={
		describe = "兵2",
		defaultPos_hp = {x = 0,y = 40},--血量显示位置
		defaultPos_ack = {x = 0,y = 0},--被击点位置
		headicon = "heroicon0_small.png",
		actionlist = {
			idle = { 10217,10218,10219,10220,10221,10222,10223,10224 }, --空闲
			-- shanbi = {}, --空闲
			-- behit = {},--被击
			attack = { 10209,10210,10211,10212,10213,10214,10215,10216},--攻击
			move = { 10201,10202,10203,10204,10205,10206,10207,10208 },--移动
			die = { 10225,10226,10227,10228,10229,10230,10231,10232 },--死亡
		},
		--碰撞区域(做矩形碰撞)
		collisionRect = {
			{x = -20, y = -20, width = 100, height = 100},
			-- {x = _x, y = _y, width = _width, height = _height},
		},
	},

	[21001]={
		describe = "怪1",
		defaultPos_hp = {x = 0,y = 40},--血量显示位置
		defaultPos_ack = {x = 0,y = 0},--被击点位置
		headicon = "heroicon0_small.png",
		actionlist = {
			idle = { 20117,20118,20119,20120,20121,20122,20123,20124 }, --空闲
			-- shanbi = {}, --空闲
			-- behit = {},--被击
			attack = { 20109,20110,20111,20112,20113,20114,20115,20116},--攻击
			move = { 20101,20102,20103,20104,20105,20106,20107,20108 },--移动
			die = { 20125,20126,20127,20128,20129,20130,20131,20132 },--死亡
		},
		--碰撞区域(做矩形碰撞)
		collisionRect = {
			{x = -20, y = -20, width = 100, height = 100},
			-- {x = _x, y = _y, width = _width, height = _height},
		},
	},

	[21002]={
		describe = "怪2",
		defaultPos_hp = {x = 0,y = 40},--血量显示位置
		defaultPos_ack = {x = 0,y = 0},--被击点位置
		headicon = "heroicon0_small.png",
		actionlist = {
			idle = { 20217,20218,20219,20220,20221,20222,20223,20224 }, --空闲
			-- shanbi = {}, --空闲
			-- behit = {},--被击
			attack = { 20209,20210,20211,20212,20213,20214,20215,20216},--攻击
			move = { 20201,20202,20203,20204,20205,20206,20207,20208 },--移动
			die = { 20225,20226,20227,20228,20229,20230,20231,20232 },--死亡
		},
		--碰撞区域(做矩形碰撞)
		collisionRect = {
			{x = -20, y = -20, width = 100, height = 100},
			-- {x = _x, y = _y, width = _width, height = _height},
		},
	},

	[30000]={
		describe = "工会庇护所",
		defaultPos_hp = {x = 0,y = 150},--血量显示位置
		defaultPos_ack = {x = 0,y = -5},--被击点位置
		headicon = "heroicon0_small.png",
		actionlist = {
			idle = {30101}, --空闲
			-- shanbi = {}, --空闲
			-- behit = {},--被击
			attack = {30101},--攻击
			move = { 30101},--移动
			die = { 30102 },--死亡
		},
		--碰撞区域(做矩形碰撞)
		collisionRect = {
			{x = -20, y = -20, width = 100, height = 100},
			-- {x = _x, y = _y, width = _width, height = _height},
		},
	},

	[30001]={
		describe = "防御塔",
		defaultPos_hp = {x = 0,y = 70},--血量显示位置
		defaultPos_ack = {x = 0,y = -5},--被击点位置
		headicon = "heroicon0_small.png",
		actionlist = {
			idle = {30201}, --空闲
			-- shanbi = {}, --空闲
			-- behit = {},--被击
			attack = {30201},--攻击
			move = { 30201},--移动
			die = { 30202 },--死亡
		},
		--碰撞区域(做矩形碰撞)
		collisionRect = {
			{x = -20, y = -20, width = 100, height = 100},
			-- {x = _x, y = _y, width = _width, height = _height},
		},
	},
}

