--
-- Author: LiYang
-- Date: 2015-07-09 19:36:54
-- 资源ID配置


ResIDConfig = {}

ResIDConfig.IDRange = {
	["role"] = {20000, 29999}, --角色ID范围
	["equip"] = {30000, 39999}, --装备ID范围
	["daoju"] = {40000, 49999}, --道具ID范围
	["skill"] = {50000, 59999}, --道具ID范围
}

--获取资源类型
function ResIDConfig:getResType( resID )
	for k,v in pairs(self.IDRange) do
		if resID >= v[1] and resID <= v[2] then
			return k
		end
	end

	return ""
end


--获取资源分配: 职业
function ResIDConfig:getConfig_profession( professionID )
	return ResIDConfig.configs[professionID+1000];
end

--获取资源分配: 国家
function ResIDConfig:getConfig_country( countryID )
	return ResIDConfig.configs[countryID+4000]
end

--获取资源分配: 国家
function ResIDConfig:getConfig_country1( countryID )
	return ResIDConfig.configs[countryID+4010]
end

--获取资源分配: 道具
function ResIDConfig:getConfig_daoju( daojuID )
	return ResIDConfig.configs[daojuID+40000]
end

--获取资源分配: 装备
function ResIDConfig:getConfig_equip( equipID )
	return ResIDConfig.configs[equipID+6000]
end
function ResIDConfig:getConfig_equipicon( resID )
	return ResIDConfig.configs[resID]
end

--获取资源分配: 角色
function ResIDConfig:getConfig_role( roleID )
	return ResIDConfig.configs[roleID]
end

--获取资源分配: 角色边框
function ResIDConfig:getConfig_cardframe( star )
	return ResIDConfig.configs[star+100]
end

--获取资源分配: buficon
function ResIDConfig:getConfig_bufframe( id )
	return ResIDConfig.configs[id]
end

--得到装备品级信息
function ResIDConfig:getEquipQualityInfo( quality )
	return ResIDConfig.configs[200 + quality];
end
--获取技能icon
function ResIDConfig:getConfig_skill( resID )
	return ResIDConfig.configs[resID]
end

--获得资源配置文件
function ResIDConfig:getResConfifByID( id )
	return ResIDConfig.configs[id];
end

ResIDConfig.configs = {
	--------------------------------角色边框图示-------------------------------
	[101] = {frameImage = "icon/heros_big/cardframe_white_big.png",frameImageBottom = "cardframe_white_bottom.png",zhiyeframe = "cardframe_white_zheye.png", frameImage2 = "cardframe_gray_big2.png", smallFrameImage = "icon/heros/cardframe_gray_small.png", smallFrameImageGuide = "icon/heros/cardframe_gray_small_guide.png", levelFrame = "icon/heros/cardframe_gray_small_lev.png", improveframe = "icon/heros/cardframe_gray_small_improve.png"},
	[102] = {frameImage = "icon/heros_big/cardframe_green_big.png",frameImageBottom = "cardframe_green_bottom.png",zhiyeframe = "cardframe_green_zheye.png", frameImage2 = "cardframe_green_big2.png", smallFrameImage = "icon/heros/cardframe_green_small.png", smallFrameImageGuide = "icon/heros/cardframe_green_small_guide.png", levelFrame = "icon/heros/cardframe_green_small_lev.png", improveframe = "icon/heros/cardframe_green_small_improve.png"},
	[103] = {frameImage = "icon/heros_big/cardframe_blue_big.png",frameImageBottom = "cardframe_blue_bottom.png",zhiyeframe = "cardframe_blue_zhiye.png", frameImage2 = "cardframe_blue_big2.png", smallFrameImage = "icon/heros/cardframe_blue_small.png", smallFrameImageGuide = "icon/heros/cardframe_blue_small_guide.png", levelFrame = "icon/heros/cardframe_blue_small_lev.png", improveframe = "icon/heros/cardframe_blue_small_improve.png"},
	[104] = {frameImage = "icon/heros_big/cardframe_purple_big.png",frameImageBottom = "cardframe_purple_bottom.png",zhiyeframe = "cardframe_purple_zheye.png", frameImage2 = "cardframe_purple_big2.png", smallFrameImage = "icon/heros/cardframe_purple_small.png", smallFrameImageGuide = "icon/heros/cardframe_purple_small_guide.png", levelFrame = "icon/heros/cardframe_purple_small_lev.png", improveframe = "icon/heros/cardframe_purple_small_improve.png"},
	[105] = {frameImage = "icon/heros_big/cardframe_orange_big.png",frameImageBottom = "cardframe_orange_bottom.png",zhiyeframe = "cardframe_orange_zheye.png", frameImage2 = "cardframe_orange_big2.png", smallFrameImage = "icon/heros/cardframe_orange_small.png", smallFrameImageGuide = "icon/heros/cardframe_orange_small_guide.png", levelFrame = "icon/heros/cardframe_orange_small_lev.png", improveframe = "icon/heros/cardframe_orange_small_improve.png"},
	[106] = {frameImage = "icon/heros_big/cardframe_orange_big.png",frameImageBottom = "cardframe_orange_bottom.png",zhiyeframe = "cardframe_orange_zheye.png", frameImage2 = "cardframe_orange_big2.png", smallFrameImage = "icon/heros/cardframe_red_small.png", smallFrameImageGuide = "icon/heros/cardframe_red_small_guide.png", levelFrame = "icon/heros/cardframe_orange_small_lev.png", improveframe = "icon/heros/cardframe_orange_small_improve.png"},
	
	--------------------------------装备品级信息-------------------------------
	[201] = {des = "白装" ,frameImage = "",color = cc.c3b(170, 170, 170)},
	[202] = {des = "绿装" ,frameImage = "",color = cc.c3b(12, 255, 74)},
	[203] = {des = "蓝装" ,frameImage = "",color = cc.c3b(12, 108, 255)},
	[204] = {des = "紫装" ,frameImage = "",color = cc.c3b(223, 12, 255)},
	[205] = {des = "橙装" ,frameImage = "",color = cc.c3b(255, 158, 12)},
	[206] = {des = "红装" ,frameImage = "",color = cc.c3b(255, 12, 15)},

	--------------------------------职业边框图示-------------------------------
	[1001] = {frame = "professionframe_1.png", icon = "professionicon_1.png", bigIcon = "professionicon_1.png"},
	[1002] = {frame = "professionframe_2.png", icon = "professionicon_2.png", bigIcon = "professionicon_2.png"},
	[1003] = {frame = "professionframe_3.png", icon = "professionicon_3.png", bigIcon = "professionicon_3.png"},
	[1004] = {frame = "professionframe_4.png", icon = "professionicon_4.png", bigIcon = "professionicon_4.png"},
	[1005] = {frame = "professionframe_5.png", icon = "professionicon_5.png", bigIcon = "professionicon_5.png"},
	[1006] = {frame = "professionframe_6.png", icon = "professionicon_6.png", bigIcon = "professionicon_6.png"},

	--------------------------------一些其他图示ICon-------------------------------
	[2001] = {describe = "银两", icon = "award_icon_gold.png"},
	[2002] = {describe = "元宝", icon = "award_icon_yuanbao.png"},
	[2003] = {describe = "将魂", icon = "award_icon_jianghun.png"},
	[2004] = {describe = "神将令", icon = "award_icon_shenjiang.png"},
	[2005] = {describe = "经验", icon = "award_icon_exp.png"},
	[2006] = {describe = "士气值", icon = "award_icon_shiqi.png"},
	[2007] = {describe = "vip经验", icon = "award_icon_vipexp.png"},
	[2008] = {describe = "体力", icon = "award_icon_tili.png"},
	[2009] = {describe = "精力", icon = "award_icon_jingli.png"},
	[2010] = {describe = "万能碎片", icon = "award_icon_wanneng.png"},
	[2011] = {describe = "随机蓝色卡", icon = "award_icon_blue.png"},

	--------------------------------技能书icon-------------------------------
	[3001] = {icon = "image_jineng_pinzhi1.png"},
	[3002] = {icon = "image_jineng_pinzhi2.png"},
	[3003] = {icon = "image_jineng_pinzhi3.png"},
	[3004] = {icon = "image_jineng_pinzhi4.png"},


	--------------------------------势力icon-------------------------------
	[4001] = {icon = "icon_shili_wei.png"},
	[4002] = {icon = "icon_shili_shu.png"},
	[4003] = {icon = "icon_shili_wu.png"},
	[4004] = {icon = "icon_shili_qun.png"},

	[4011] = {icon = "icon_shili_wei1.png"},
	[4012] = {icon = "icon_shili_shu1.png"},
	[4013] = {icon = "icon_shili_wu1.png"},
	[4014] = {icon = "icon_shili_qun1.png"},

	--------------------------------buf icon-------------------------------
	[5001] = {describe = "+暴击",icon = "buf_icon_1.png"},
	[5002] = {describe = "+攻击",icon = "buf_icon_2.png"},
	[5003] = {describe = "+命中",icon = "buf_icon_3.png"},
	[5004] = {describe = "+闪避",icon = "buf_icon_4.png"},
	[5005] = {describe = "+生命",icon = "buf_icon_5.png"},
	[5006] = {describe = "+物防",icon = "buf_icon_6.png"},
	[5007] = {describe = "+法防",icon = "buf_icon_7.png"},
	[5008] = {describe = "+韧性",icon = "buf_icon_9.png"},
	[5009] = {describe = "+暴伤",icon = "buf_icon_8.png"},

	[5101] = {describe = "-暴击",icon = "bufdown_icon_1.png"},
	[5102] = {describe = "-攻击",icon = "bufdown_icon_2.png"},
	[5103] = {describe = "-命中",icon = "bufdown_icon_3.png"},
	[5104] = {describe = "-闪避",icon = "bufdown_icon_4.png"},
	[5105] = {describe = "-生命",icon = "bufdown_icon_5.png"},
	[5106] = {describe = "-物防",icon = "bufdown_icon_6.png"},
	[5107] = {describe = "-法防",icon = "bufdown_icon_7.png"},
	[5108] = {describe = "-韧性",icon = "bufdown_icon_9.png"},
	[5109] = {describe = "-暴伤",icon = "bufdown_icon_8.png"},

	-------------------------------装备大边框--------------------------------
	[6001] = {describe = "白色边框",frame = "equip_page_bg1.png"},
	[6002] = {describe = "绿色边框",frame = "equip_page_bg2.png"},
	[6003] = {describe = "蓝色边框",frame = "equip_page_bg3.png"},
	[6004] = {describe = "紫色边框",frame = "equip_page_bg4.png"},
	--------------------------------角色小图示-------------------------------
	-- 起始1000
	-- [10001] = {frameImage = "avatarframe_blue_plus.png",iconImage = "heroicon1.png",pos_x = 5 ,pos_y = 23},
	-- [10002] = {frameImage = "avatarframe_blue_plus.png",iconImage = "heroicon2.png",pos_x = 5 ,pos_y = 23},
	-- [10003] = {frameImage = "avatarframe_gold.png",iconImage = "heroicon3.png",pos_x = 5 ,pos_y = 23},
	-- [10004] = {frameImage = "avatarframe_gold_plus.png",iconImage = "heroicon4.png",pos_x = 5 ,pos_y = 23},
	-- [10005] = {frameImage = "avatarframe_purple_plus.png",iconImage = "heroicon5.png",pos_x = 5 ,pos_y = 23},

	--------------------------------角色大图示-------------------------------
	[20001]={describe = "兵1",smelliconImage = "icon/soldier/monster_3.png",bigiconImage = "icon/heros_big/heroicon1_big.png",pos_x = 5 ,pos_y = 23 ,},	-- 起始20000
	[20002]={describe = "兵2",smelliconImage = "icon/soldier/monster_4.png",bigiconImage = "icon/heros_big/heroicon1_big.png",pos_x = 5 ,pos_y = 23 ,},	-- 起始20000
	[21001]={describe = "怪1",smelliconImage = "icon/soldier/monster_1.png",bigiconImage = "icon/heros_big/heroicon1_big.png",pos_x = 5 ,pos_y = 23 ,},	-- 起始20000
	[21002]={describe = "怪2",smelliconImage = "icon/soldier/monster_2.png",bigiconImage = "icon/heros_big/heroicon1_big.png",pos_x = 5 ,pos_y = 23 ,},	-- 起始20000

	--------------------------------建筑配置-------------------------------
	[30000]={describe = "公会庇护所",smelliconImage = "icon/build/build_icon_1.png",bigiconImage = "icon/heros_big/heroicon1_big.png",builddrawinfo = "build/bihusuo/build_bihusuo.csb",defaultPos_hp = {x = 0,y = 40},defaultPos_ack = {x = 0,y = 0},},
	[30001]={describe = "塔防",smelliconImage = "icon/build/build_icon_0.png",bigiconImage = "icon/heros_big/heroicon1_big.png",builddrawinfo = "build/fangyuta/build_fangyuta.csb",defaultPos_hp = {x = 0,y = 40},defaultPos_ack = {x = 0,y = 0},},
	----------------------------------------装备资源--------------------------------------------------
	-- [30001] = {describe = "白色武器",icon = "icon/equip/equip_10001.png"},
	-- [30002] = {describe = "白色头盔",icon = "icon/equip/equip_10002.png"},
	-- [30003] = {describe = "白色护甲",icon = "icon/equip/equip_10003.png"},
	-- [30004] = {describe = "白色靴子",icon = "icon/equip/equip_10004.png"},
	-- [30005] = {describe = "绿色武器",icon = "icon/equip/equip_10005.png"},
	-- [30006] = {describe = "绿色头盔",icon = "icon/equip/equip_10006.png"},
	-- [30007] = {describe = "绿色护甲",icon = "icon/equip/equip_10007.png"},
	-- [30008] = {describe = "绿色靴子",icon = "icon/equip/equip_10008.png"},
	-- [30009] = {describe = "蓝色武器",icon = "icon/equip/equip_10009.png"},
	-- [30010] = {describe = "蓝色头盔",icon = "icon/equip/equip_10010.png"},
	-- [30011] = {describe = "蓝色护甲",icon = "icon/equip/equip_10011.png"},
	-- [30012] = {describe = "蓝色靴子",icon = "icon/equip/equip_10012.png"},
	-- [30013] = {describe = "紫色武器",icon = "icon/equip/equip_10013.png"},
	-- [30014] = {describe = "紫色头盔",icon = "icon/equip/equip_10014.png"},
	-- [30015] = {describe = "紫色护甲",icon = "icon/equip/equip_10015.png"},
	-- [30016] = {describe = "紫色靴子",icon = "icon/equip/equip_10016.png"},
	-- [30017] = {describe = "橙色武器",icon = "icon/equip/equip_10017.png"},
	-- [30018] = {describe = "橙色头盔",icon = "icon/equip/equip_10018.png"},
	-- [30019] = {describe = "橙色护甲",icon = "icon/equip/equip_10019.png"},
	-- [30020] = {describe = "橙色靴子",icon = "icon/equip/equip_10020.png"},
	-- [30021] = {describe = "神1武器",icon = "icon/equip/equip_10021.png"},
	-- [30022] = {describe = "神1头盔",icon = "icon/equip/equip_10022.png"},
	-- [30023] = {describe = "神1护甲",icon = "icon/equip/equip_10023.png"},
	-- [30024] = {describe = "神1靴子",icon = "icon/equip/equip_10024.png"},
	-- [30025] = {describe = "神2武器",icon = "icon/equip/equip_10025.png"},
	-- [30026] = {describe = "神2头盔",icon = "icon/equip/equip_10026.png"},
	-- [30027] = {describe = "神2护甲",icon = "icon/equip/equip_10027.png"},
	-- [30028] = {describe = "神2靴子",icon = "icon/equip/equip_10028.png"},
	-- [30029] = {describe = "神3武器",icon = "icon/equip/equip_10029.png"},
	-- [30030] = {describe = "神3头盔",icon = "icon/equip/equip_10030.png"},
	-- [30031] = {describe = "神3护甲",icon = "icon/equip/equip_10031.png"},
	-- [30032] = {describe = "神3靴子",icon = "icon/equip/equip_10032.png"},
	-- [30033] = {describe = "神4武器",icon = "icon/equip/equip_10033.png"},
	-- [30034] = {describe = "神4头盔",icon = "icon/equip/equip_10034.png"},
	-- [30035] = {describe = "神4护甲",icon = "icon/equip/equip_10035.png"},
	-- [30036] = {describe = "神4靴子",icon = "icon/equip/equip_10036.png"},
	-- [30037] = {describe = "神5武器",icon = "icon/equip/equip_10037.png"},
	-- [30038] = {describe = "神5头盔",icon = "icon/equip/equip_10038.png"},
	-- [30039] = {describe = "神5护甲",icon = "icon/equip/equip_10039.png"},
	-- [30040] = {describe = "神5靴子",icon = "icon/equip/equip_10040.png"},
	-- [30041] = {describe = "神6武器",icon = "icon/equip/equip_10041.png"},
	-- [30042] = {describe = "神6头盔",icon = "icon/equip/equip_10042.png"},
	-- [30043] = {describe = "神6护甲",icon = "icon/equip/equip_10043.png"},
	-- [30044] = {describe = "神6靴子",icon = "icon/equip/equip_10044.png"},







	----------------------------------------道具资源--------------------------------------------------
	[40000] = {describe = "技能书1",icon = "icon/goods/icon_daoju_jinengshu1.png"},
	[40001] = {describe = "技能书2",icon = "icon/goods/icon_daoju_jinengshu2.png"},
	[40002] = {describe = "技能书3",icon = "icon/goods/icon_daoju_jinengshu3.png"},
	[40003] = {describe = "神将令",icon = "icon/goods/icon_daoju_shenjiangling.png"},
	[40004] = {describe = "强攻号角",icon = "icon/goods/icon_daoju_shijieboss.png"},
	[40005] = {describe = "求贤令",icon = "icon/goods/icon_daoju_qiuxianling.png"},
	[40006] = {describe = "扫荡符",icon = "icon/goods/icon_daoju_sandang.png"},
	[40007] = {describe = "小型体力丹",icon = "icon/goods/icon_daoju_tilidan_xiao.png"},
	[40008] = {describe = "中型体力丹",icon = "icon/goods/icon_daoju_tilidan_zhong.png"},
	[40009] = {describe = "大型体力丹",icon = "icon/goods/icon_daoju_tilidan_da.png"},
	[40010] = {describe = "巨型体力丹",icon = "icon/goods/icon_daoju_tilidan_ju.png"},
	[40011] = {describe = "小型精力丹",icon = "icon/goods/icon_daoju_jinglidan_xiao.png"},
	[40012] = {describe = "中型精力丹",icon = "icon/goods/icon_daoju_jinglidan_zhong.png"},
	[40013] = {describe = "大型精力丹",icon = "icon/goods/icon_daoju_jinglidan_da.png"},
	[40014] = {describe = "巨型精力丹",icon = "icon/goods/icon_daoju_jinglidan_ju.png"},
	[40015] = {describe = "招募令-魏",icon = "icon/goods/icon_daoju_zhaomuling_wei.png"},
	[40016] = {describe = "招募令-蜀",icon = "icon/goods/icon_daoju_zhaomuling_shu.png"},
	[40017] = {describe = "招募令-吴",icon = "icon/goods/icon_daoju_zhaomuling_wu.png"},
	[40018] = {describe = "招募令-群",icon = "icon/goods/icon_daoju_zhaomuling_qun.png"},
	[40019] = {describe = "朱雀宝箱",icon = "icon/goods/icon_daoju_baoxiang_zhuque.png"},
	[40020] = {describe = "玄武宝箱",icon = "icon/goods/icon_daoju_baoxiang_xuanwu.png"},
	[40021] = {describe = "青龙宝箱",icon = "icon/goods/icon_daoju_baoxiang_qinglong.png"},
	[40022] = {describe = "白虎宝箱",icon = "icon/goods/icon_daoju_baoxiang_baihu.png"},
	[40023] = {describe = "五星招募令",icon = "icon/goods/icon_daoju_zhaomuling_5.png"},-- **
	[40024] = {describe = "洗练符",icon = "icon/goods/icon_daoju_xilianfu.png"},
	[40025] = {describe = "虎王经验匣",icon = "icon/goods/icon_daoju_huwang.png"},
	[40026] = {describe = "小量将魂匣",icon = "icon/goods/icon_daoju_jianghun_xiao.png"},
	[40027] = {describe = "中量将魂匣",icon = "icon/goods/icon_daoju_jianghun_zhong.png"},
	[40028] = {describe = "大量将魂匣",icon = "icon/goods/icon_daoju_jianghun_da.png"},
	[40029] = {describe = "饿狼经验匣",icon = "icon/goods/icon_daoju_elang.png"},
	[40030] = {describe = "狂熊经验匣",icon = "icon/goods/icon_daoju_xiong.png"},
	[40031] = {describe = "秦币",icon = "icon/goods/icon_daoju_qingbi.png"},
	[40032] = {describe = "玉璧",icon = "icon/goods/icon_daoju_yubi.png"},
	[40033] = {describe = "青铜鼎",icon = "icon/goods/icon_daoju_qingtongding.png"},
	[40034] = {describe = "铜镜",icon = "icon/goods/icon_daoju_tongjing.png"},
	[40035] = {describe = "招募令-副将",icon = "icon/goods/icon_daoju_zhaomuling_4.png"},
	[40036] = {describe = "VIP宝箱",icon = "icon/goods/icon_daoju_xingyun.png"},
	[40037] = {describe = "真•朱雀宝箱",icon = "icon/goods/icon_daoju_zhenbaoxiang_zhuque.png"},
	[40038] = {describe = "真•玄武宝箱",icon = "icon/goods/icon_daoju_zhenbaoxiang_xuanwu.png"},
	[40039] = {describe = "真•青龙宝箱",icon = "icon/goods/icon_daoju_zhenbaoxiang_qinglong.png"},
	[40040] = {describe = "真•白虎宝箱",icon = "icon/goods/icon_daoju_zhenbaoxiang_baihu.png"},
	[40041] = {describe = "楚币",icon = "icon/goods/icon_daoju_cubi.png"},
	[40042] = {describe = "藏宝图",icon = "icon/goods/icon_daoju_cangbaotu.png"},
	[40043] = {describe = "好友宝箱",icon = "icon/goods/icon_daoju_haoyoulibao.png"},
	[40044] = {describe = "天同石",icon = "icon/goods/icon_daoju_shitou_tiantong.png"},
	[40045] = {describe = "天梁石",icon = "icon/goods/icon_daoju_shitou_tianliang.png"},
	[40046] = {describe = "太阴石",icon = "icon/goods/icon_daoju_shitou_taiyin.png"},
	[40047] = {describe = "天机石",icon = "icon/goods/icon_daoju_shitou_tianji.png"},
	[40048] = {describe = "巨门石",icon = "icon/goods/icon_daoju_shitou_jumen.png"},
	[40049] = {describe = "太阳石",icon = "icon/goods/icon_daoju_shitou_taiyang.png"},
	[40050] = {describe = "天相石",icon = "icon/goods/icon_daoju_shitou_tianxiang.png"},
	[40051] = {describe = "武曲石",icon = "icon/goods/icon_daoju_shitou_wuqu.png"},
	[40052] = {describe = "天府石",icon = "icon/goods/icon_daoju_shitou_tianfu.png"},
	[40053] = {describe = "紫微石",icon = "icon/goods/icon_daoju_shitou_ziwei.png"},
	[40054] = {describe = "贪狼石",icon = "icon/goods/icon_daoju_shitou_tanlang.png"},
	[40055] = {describe = "廉贞石",icon = "icon/goods/icon_daoju_shitou_lianzhen.png"},
	[40056] = {describe = "破军石",icon = "icon/goods/icon_daoju_shitou_pojun.png"},
	[40057] = {describe = "七杀石",icon = "icon/goods/icon_daoju_shitou_qisha.png"},
	[40058] = {describe = "招募令-4星魏",icon = "icon/goods/icon_daoju_zhaomuling_wei.png"},
	[40059] = {describe = "招募令-4星蜀",icon = "icon/goods/icon_daoju_zhaomuling_shu.png"},
	[40060] = {describe = "招募令-4星吴",icon = "icon/goods/icon_daoju_zhaomuling_wu.png"},
	[40061] = {describe = "招募令-4星群",icon = "icon/goods/icon_daoju_zhaomuling_qun.png"},
	[40062] = {describe = "征集令",icon = "icon/goods/icon_daoju_zhenjiling.png"},
	[40063] = {describe = "礼包",icon = "icon/goods/icon_daoju_dalibao.png"},
	[40064] = {describe = "物资",icon = "icon/goods/icon_daoju_wuzi.png"},
	[40065] = {describe = "铁矿石",icon = "icon/goods/icon_daoju_tiekuangshi.png"},
	[40066] = {describe = "紫色名将",icon = "icon/goods/icon_daoju_zhaomuling_4_ming.png"},
	[40067] = {describe = "金粽",icon = "icon/goods/icon_daoju_duanwu_jinzong.png"},
	[40068] = {describe = "龙舟",icon = "icon/goods/icon_daoju_duanwu_longzhou.png"},
	[40069] = {describe = "麻绳",icon = "icon/goods/icon_daoju_duanwu_masheng.png"},
	[40070] = {describe = "糯米",icon = "icon/goods/icon_daoju_duanwu_nuomi.png"},
	[40071] = {describe = "粽叶",icon = "icon/goods/icon_daoju_duanwu_zongye.png"},
	[40072] = {describe = "粽子",icon = "icon/goods/icon_daoju_duanwu_zongzi.png"},


	[40073] = {describe = "白虎牙",icon = "icon/goods/icon_daoju_baihuya.png"},
	[40074] = {describe = "觉醒丹",icon = "icon/goods/icon_daoju_juexingdan.png"},
	[40075] = {describe = "金宝箱",icon = "icon/goods/icon_daoju_jinbaoxiang.png"},
	[40076] = {describe = "金钥匙",icon = "icon/goods/icon_daoju_jinyaoshi.png"},
	[40077] = {describe = "名将宝箱",icon = "icon/goods/icon_daoju_mingjiangbaoxiang.png"},
	[40078] = {describe = "强化石",icon = "icon/goods/icon_daoju_qianghuashi.png"},
	[40079] = {describe = "青龙胆",icon = "icon/goods/icon_daoju_qinglongdan.png"},
	[40080] = {describe = "神器宝箱",icon = "icon/goods/icon_daoju_shenqibaoxiang.png"},
	[40081] = {describe = "升阶石",icon = "icon/goods/icon_daoju_shengjieshi.png"},
	[40082] = {describe = "刷新令",icon = "icon/goods/icon_daoju_shuaxinling.png"},
	[40083] = {describe = "速战令",icon = "icon/goods/icon_daoju_suzhanling.png"},
	[40084] = {describe = "挑战令",icon = "icon/goods/icon_daoju_tiaozhanling.png"},
	[40085] = {describe = "铜宝箱",icon = "icon/goods/icon_daoju_tongbaoxiang.png"},
	[40086] = {describe = "铜钥匙",icon = "icon/goods/icon_daoju_tongyaoshi.png"},
	[40087] = {describe = "玄武甲",icon = "icon/goods/icon_daoju_xuanwujia.png"},
	[40088] = {describe = "银宝箱",icon = "icon/goods/icon_daoju_yinbaoxiang.png"},
	[40089] = {describe = "银钥匙",icon = "icon/goods/icon_daoju_yinyaoshi.png"},
	[40090] = {describe = "职业宝箱",icon = "icon/goods/icon_daoju_zhiyebaoxiang.png"},
	[40091] = {describe = "朱雀羽",icon = "icon/goods/icon_daoju_zhuqueyu.png"},



	

	[40101] = {describe = "VIP经验奖励",icon = "icon/goods/award_icon_vipexp.png"},
	[40102] = {describe = "购买精力",icon = "icon/goods/award_icon_jingli.png"},
	[40103] = {describe = "购买体力",icon = "icon/goods/award_icon_tili.png"},
	[40104] = {describe = "好友上限",icon = "icon/goods/stone_item_5.png"},
	[40105] = {describe = "将魂奖励",icon = "icon/goods/award_icon_jianghun.png"},
	[40106] = {describe = "经验奖励",icon = "icon/goods/award_icon_exp.png"},
	[40107] = {describe = "卡牌背包",icon = "icon/goods/stone_item_3.png"},
	[40108] = {describe = "卡牌仓库",icon = "icon/goods/stone_item_7.png"},
	[40109] = {describe = "士气奖励",icon = "icon/goods/award_icon_shiqi.png"},
	[40110] = {describe = "3星随机卡牌",icon = "icon/goods/award_icon_blue.png"},
	[40111] = {describe = "4星随机卡牌",icon = "icon/goods/icon_daoju_suijikapai.png"},
	[40112] = {describe = "万能碎片",icon = "icon/goods/award_icon_wanneng.png"},
	[40113] = {describe = "银两",icon = "icon/goods/award_icon_gold.png"},
	[40114] = {describe = "邮件道具",icon = "icon/goods/mail_icon.png"},
	[40115] = {describe = "元宝",icon = "icon/goods/award_icon_yuanbao.png"},
	[40116] = {describe = "装备背包",icon = "icon/goods/stone_item_4.png"},
	[40117] = {describe = "月卡",icon = "icon/goods/stone_item_9.png"},
	[40118] = {describe = "月卡",icon = "icon/goods/stone_item_10.png"},
	[40119] = {describe = "功勋",icon = "icon/goods/award_icon_gongxun.png"},
	[40120] = {describe = "棒棒糖",icon = "icon/goods/icon_daoju_bbt.png"},
	[40121] = {describe = "糖葫芦",icon = "icon/goods/icon_daoju_thl.png"},
	[40122] = {describe = "棒冰",icon = "icon/goods/icon_daoju_bg.png"},
	[40123] = {describe = "经验池",icon = "icon/goods/icon_daoju_bg.png"},
	[40124] = {describe = "空白",icon = "icon/goods/blank.png"},
	[40125] = {describe = "熔炼值",icon = "icon/goods/blank.png"},
	[40126] = {describe = "乞丐行乞",icon = "icon/goods/qiyu1.png"},
	[40127] = {describe = "pk 副本",icon = "icon/goods/qiyu2.png"},
	[40128] = {describe = "宝箱跟锦囊",icon = "icon/goods/qiyu3.png"},
	[40129] = {describe = "财宝",icon = "icon/goods/qiyu4.png"},
	[40130] = {describe = "藏宝图",icon = "icon/goods/qiyu5.png"},
	[40131] = {describe = "岔路",icon = "icon/goods/qiyu6.png"},
	[40132] = {describe = "发光的大堆元宝",icon = "icon/goods/qiyu7.png"},
	[40133] = {describe = "发光的井口",icon = "icon/goods/qiyu8.png"},
	[40134] = {describe = "老头仙人",icon = "icon/goods/qiyu9.png"},
	[40135] = {describe = "墓地",icon = "icon/goods/qiyu10.png"},
	[40136] = {describe = "破烂商铺",icon = "icon/goods/qiyu11.png"},
	[40137] = {describe = "山中关卡",icon = "icon/goods/qiyu12.png"},
	[40138] = {describe = "声望",icon = "icon/goods/award_icon_shengwang.png"},
	[40139] = {describe = "竞技场",icon = "icon/goods/shijian1.png"},
	[40140] = {describe = "公会战",icon = "icon/goods/shijian2.png"},


	[50001] = {describe = "曹操君临",icon = "icon/skills/caocao_junling.png"},
	[50002] = {describe = "曹操龙纹",icon = "icon/skills/caocao_longweo.png"},
	[50003] = {describe = "曹操普通",icon = "icon/skills/caocao_putong.png"},
	[50004] = {describe = "曹仁",icon = "icon/skills/caoren.png"},
	[50005] = {describe = "程立",icon = "icon/skills/chengli.png"},
	[50006] = {describe = "陈宫",icon = "icon/skills/chengong.png"},
	[50007] = {describe = "程普",icon = "icon/skills/chengpu.png"},
	[50008] = {describe = "程志远",icon = "icon/skills/chengzhiyuan.png"},
	[50009] = {describe = "大乔",icon = "icon/skills/daqiao.png"},
	[50010] = {describe = "大乔2",icon = "icon/skills/daqiao_2.png"},
	[50011] = {describe = "典韦",icon = "icon/skills/dianwei.png"},
	[50012] = {describe = "貂蝉1",icon = "icon/skills/diaochan_1.png"},
	[50013] = {describe = "貂蝉2",icon = "icon/skills/diaochan_2.png"},
	[50014] = {describe = "董卓",icon = "icon/skills/dongzhuo.png"},
	[50015] = {describe = "法正自雷",icon = "icon/skills/fazheng_zilei.png"},
	[50016] = {describe = "法正天雷",icon = "icon/skills/fazhengtianlei.png"},
	[50017] = {describe = "甘宁",icon = "icon/skills/ganning.png"},
	[50018] = {describe = "高顺",icon = "icon/skills/gaoshun.png"},
	[50019] = {describe = "公孙瓒流血",icon = "icon/skills/gongsunzan_liuxue.png"},
	[50020] = {describe = "公孙瓒普通",icon = "icon/skills/gongsunzan_putong.png"},
	[50021] = {describe = "关羽青龙摆尾",icon = "icon/skills/guanyu_qinglongbaiwei.png"},
	[50022] = {describe = "关羽青龙啸天",icon = "icon/skills/guanyu_qinglongxiaotian.png"},
	[50023] = {describe = "关羽武圣",icon = "icon/skills/guanyu_wusheng.png"},
	[50024] = {describe = "郭嘉1",icon = "icon/skills/guojia_1.png"},
	[50025] = {describe = "郭嘉2",icon = "icon/skills/guojia_2.png"},
	[50026] = {describe = "韩遂",icon = "icon/skills/hansui.png"},
	[50027] = {describe = "黄盖",icon = "icon/skills/huanggai.png"},
	[50028] = {describe = "黄盖1",icon = "icon/skills/huanggai_1.png"},
	[50029] = {describe = "黄埔高1",icon = "icon/skills/huangpugao_1.png"},
	[50030] = {describe = "黄埔高2",icon = "icon/skills/huangpugao_2.png"},
	[50031] = {describe = "黄月英风湿",icon = "icon/skills/huangyueying_fengshi.png"},
	[50032] = {describe = "黄月英三余",icon = "icon/skills/huangyueying_sanyu.png"},
	[50033] = {describe = "黄忠百步",icon = "icon/skills/huangzhong_baibu.png"},
	[50034] = {describe = "黄忠普通",icon = "icon/skills/huangzhong_putong.png"},
	[50035] = {describe = "黄祖普通",icon = "icon/skills/shuangzu_2.png"},
	[50036] = {describe = "黄祖散弹",icon = "icon/skills/huangzu_sandan.png"},
	[50037] = {describe = "华佗1",icon = "icon/skills/huatuo_1.png"},
	[50038] = {describe = "华佗2",icon = "icon/skills/huatuo_2.png"},
	[50039] = {describe = "华雄",icon = "icon/skills/huaxiong.png"},
	[50040] = {describe = "贾诩",icon = "icon/skills/jiaxu.png"},
	[50041] = {describe = "乐进1",icon = "icon/skills/lejin_1.png"},
	[50042] = {describe = "乐进2",icon = "icon/skills/lejin_2.png"},
	[50043] = {describe = "李吹",icon = "icon/skills/lichui.png"},
	[50044] = {describe = "李典",icon = "icon/skills/lidian.png"},
	[50045] = {describe = "凌统",icon = "icon/skills/lingtong.png"},
	[50046] = {describe = "李儒1",icon = "icon/skills/liru_1.png"},
	[50047] = {describe = "李儒2",icon = "icon/skills/liru_2.png"},
	[50048] = {describe = "刘备1",icon = "icon/skills/liubei_1.png"},
	[50049] = {describe = "刘备2",icon = "icon/skills/liubei_2.png"},
	[50050] = {describe = "陆逊普通",icon = "icon/skills/luxun_putonggongji.png"},
	[50051] = {describe = "陆逊谦逊",icon = "icon/skills/luxun_qianxun.png"},
	[50052] = {describe = "陆逊艳遇双龙",icon = "icon/skills/luxun_yanyushuanglong.png"},
	[50053] = {describe = "吕布2",icon = "icon/skills/lvbu_2.png"},
	[50054] = {describe = "吕布无双",icon = "icon/skills/lvbu_wushuanghuji.png"},
	[50055] = {describe = "吕蒙",icon = "icon/skills/lvmeng.png"},
	[50056] = {describe = "吕蒙2",icon = "icon/skills/lvmeng_2.png"},
	[50057] = {describe = "马超",icon = "icon/skills/machao.png"},
	[50058] = {describe = "马良1",icon = "icon/skills/maliang_1.png"},
	[50059] = {describe = "马良2",icon = "icon/skills/maliang_2.png"},
	[50060] = {describe = "马腾",icon = "icon/skills/mateng.png"},
	[50061] = {describe = "孟获",icon = "icon/skills/menghuo.png"},
	[50062] = {describe = "鲁肃",icon = "icon/skills/nusu.png"},
	[50063] = {describe = "庞德",icon = "icon/skills/pangde.png"},
	[50064] = {describe = "庞德1",icon = "icon/skills/pangde_1.png"},
	[50065] = {describe = "庞统1",icon = "icon/skills/pangtong_1.png"},
	[50066] = {describe = "庞统2",icon = "icon/skills/pangtong_2.png"},
	[50067] = {describe = "司马懿1",icon = "icon/skills/simayi_1.png"},
	[50068] = {describe = "司马懿2",icon = "icon/skills/simayi_2.png"},
	[50069] = {describe = "孙策1",icon = "icon/skills/sunce_1.png"},
	[50070] = {describe = "孙坚1",icon = "icon/skills/sunjian_1.png"},
	[50071] = {describe = "孙坚2",icon = "icon/skills/sunjian_2.png"},
	[50072] = {describe = "孙权",icon = "icon/skills/sunquan.png"},
	[50073] = {describe = "孙尚香玲珑",icon = "icon/skills/sunshangxiang_linglonghuoque.png"},
	[50074] = {describe = "孙尚香螺旋",icon = "icon/skills/sunshangxiang_luoxuan.png"},
	[50075] = {describe = "太史慈1",icon = "icon/skills/taisichi_1.png"},
	[50076] = {describe = "太史慈2",icon = "icon/skills/taisichi_2.png"},
	[50077] = {describe = "田丰",icon = "icon/skills/tianfeng.png"},
	[50078] = {describe = "王朗1",icon = "icon/skills/wanglang_1.png"},
	[50079] = {describe = "王朗2",icon = "icon/skills/wanglang_2.png"},
	[50080] = {describe = "王允",icon = "icon/skills/wangyun.png"},
	[50081] = {describe = "魏延",icon = "icon/skills/weiyan.png"},
	[50082] = {describe = "文丑普通",icon = "icon/skills/wenchou_putong.png"},
	[50083] = {describe = "文丑双雄",icon = "icon/skills/wenchou_shuangxiong.png"},
	[50084] = {describe = "夏侯惇",icon = "icon/skills/xiahoudun.png"},
	[50085] = {describe = "夏侯渊涅魂",icon = "icon/skills/xiahouyuan_niehun.png"},
	[50086] = {describe = "夏侯渊索命",icon = "icon/skills/xiahouyuan_suomingpao.png"},
	[50087] = {describe = "小乔1",icon = "icon/skills/xiaoqiao_1.png"},
	[50088] = {describe = "小乔2",icon = "icon/skills/xiaoqiao_2.png"},
	[50089] = {describe = "徐晃",icon = "icon/skills/xuhuang.png"},
	[50090] = {describe = "荀彧1",icon = "icon/skills/xunyu_1.png"},
	[50091] = {describe = "荀彧2",icon = "icon/skills/xunyu_2.png"},
	[50092] = {describe = "徐庶金字符咒",icon = "icon/skills/xusu_jinzifuzhou.png"},
	[50093] = {describe = "许诸死神爆红",icon = "icon/skills/xuzhu_sishenbaohong.png"},
	[50094] = {describe = "许诸邪能火炮",icon = "icon/skills/xuzhu_xienenghuopao.png"},
	[50095] = {describe = "颜良",icon = "icon/skills/yanliang.png"},
	[50096] = {describe = "严颜透阵一击",icon = "icon/skills/yanyan_touzhenyiji.png"},
	[50097] = {describe = "严颜头针重击",icon = "icon/skills/yanyan_touzhenzhongji.png"},
	[50098] = {describe = "袁绍",icon = "icon/skills/yuanshao.png"},
	[50099] = {describe = "袁术1",icon = "icon/skills/yuanshu_1.png"},
	[50100] = {describe = "袁术2",icon = "icon/skills/yuanshu_2.png"},
	[50101] = {describe = "于禁攻守",icon = "icon/skills/yujin_gongshou.png"},
	[50102] = {describe = "于禁普通",icon = "icon/skills/yujinpu_tong.png"},
	[50103] = {describe = "甄姬逆心之吻",icon = "icon/skills/zengji_nixinzhiwen.png"},
	[50104] = {describe = "甄姬妖狐之魅",icon = "icon/skills/zengji_yaohuzhimei.png"},
	[50105] = {describe = "张宝普通",icon = "icon/skills/zhangbao_putong.png"},
	[50106] = {describe = "张宝五雷",icon = "icon/skills/zhangbao_wulei.png"},
	[50107] = {describe = "张飞",icon = "icon/skills/zhangfei.png"},
	[50108] = {describe = "张颌",icon = "icon/skills/zhanghe.png"},
	[50109] = {describe = "张角1",icon = "icon/skills/zhangjiao_1.png"},
	[50110] = {describe = "张角普通",icon = "icon/skills/zhangjiao_putonggongji.png"},
	[50111] = {describe = "张角五雷",icon = "icon/skills/zhangjiao_wuleihongding.png"},
	[50112] = {describe = "张梁",icon = "icon/skills/zhangliang.png"},
	[50113] = {describe = "张辽",icon = "icon/skills/zhangliao.png"},
	[50114] = {describe = "张曼成",icon = "icon/skills/zhangmancheng.png"},
	[50115] = {describe = "张秀",icon = "icon/skills/zhangxiu.png"},
	[50116] = {describe = "张昭换命",icon = "icon/skills/zhangzhao_huanming.png"},
	[50117] = {describe = "张昭足下真言",icon = "icon/skills/zhangzhao_zuxiazhenyan.png"},
	[50118] = {describe = "赵云",icon = "icon/skills/zhaoyun.png"},
	[50119] = {describe = "周泰1",icon = "icon/skills/zhoutai_1.png"},
	[50120] = {describe = "周泰2",icon = "icon/skills/zhoutai_2.png"},
	[50121] = {describe = "周泰3",icon = "icon/skills/zhoutai_3.png"},
	[50122] = {describe = "周瑜1",icon = "icon/skills/zhouyu_1.png"},
	[50123] = {describe = "周瑜2",icon = "icon/skills/zhouyu_2.png"},
	[50124] = {describe = "周瑜3",icon = "icon/skills/zhouyu_3.png"},
	[50125] = {describe = "周瑜4",icon = "icon/skills/zhouyu_4.png"},
	[50126] = {describe = "诸葛亮1",icon = "icon/skills/zhugeliang_1.png"},
	[50127] = {describe = "诸葛亮2",icon = "icon/skills/zhugeliang_2.png"},
	[50128] = {describe = "祝融冷箭",icon = "icon/skills/zurongfuren_lengjian.png"},
	[50129] = {describe = "祝融突袭",icon = "icon/skills/zurongfuren_tuxi.png"},
	[50130] = {describe = "貂蝉闭月",icon = "icon/skills/diaochan_3.png"},
	[50131] = {describe = "赵云七进七出",icon = "icon/skills/zhaoyun_qijinqichu.png"},
	[50132] = {describe = "赵云龙魂",icon = "icon/skills/zhaoyun_longhun.png"},





}

