--
-- Author: LiYang
-- Date: 2015-07-18 09:48:22
-- 效果管理类

--[[ 效果设计模板原则
	1.生命周期完全自己控制
	2.要有完成回调
	3.要有资源配置文件对资源进行管理
	4.涉及有层级管理的效果,应该独立一个效果配置文件来连接效果(现行办法在效果编辑器用帧事件来控制连接)
	5.效果分类 {
		原则 根据主次关系
		1.逻辑控制效果即(主效果)
		2.装饰效果(装饰效果一般情况只创建一个动画)
	}
]]

--[[ 效果模板设计原则
	1. 事件类型
		blow 打击事件(用于技能效果)
	 	hurt 伤害事件
	 	finish 完成事件
	 	create 创建事件(主要是为了来创建装饰效果)
	2."template_armature" 为效果入口模板
	3.
]]

--[[效果模板
	1.被动buf模板 无动作(skilleffect_dq_2)
]]

--加载模板
import(".EffectConfig")
import(".bufeffect.bufManager")
import(".newbieguide.NewbieGuideManager")
local classtemplate_armature = import(".templeate.template_armature")

EffectManager = {};

-- 创建效果方法
EffectManager.CreateEffect = {};

--效果常量参数
---------------------------效果常量值即体验微调值-----------------------------
-- 飞行速度(一些飞行的默认速度)
EffectManager.EFFECT_CONST_FLY_SPEED = 1400;
EffectManager.EFFECT_CONST_INTERVAL_MIN_TIME = 0.1;
-- 反伤效果
EffectManager.ThornsConfig_Zoom_Time = 0.2;--反伤放大时间
EffectManager.ThornsConfig_Animation_Time = 1;--反伤动画运行时间

--动作微调值
EffectManager.EFFECT_TRIMMING_VALUSE = 1;

--震动调整值 角色震动调整值
EffectManager.SHAKE_ADJUST_0 = 10;
EffectManager.SHAKE_TIME_0 = 0.3;
--震动调整值 全屏震动
EffectManager.SHAKE_ADJUST_1 = 10;
EffectManager.SHAKE_TIME_1 = 0.3;

--技能施法位置
EffectManager.SkillCastPos = {
	--阵营范围
	["campscope"] = {
		attackcamp = { x = 320 ,y = 420},
		defendcamp = { x = 960 ,y = 420},
	},
}

--[[得到施法效果位置
]]
function EffectManager:getEffectCasetPos( index ,camp )
	local posData = self.SkillCastPos[index];
	if camp == Data_Battle.CONST_CAMP_PLAYER then
		return posData.attackcamp;
	else
		return posData.defendcamp;
	end
end

--[[得到效果横排施法位置
	index 横排数
	camp 阵营
	return 对应横排中心位置(地图位置)
]]
function  EffectManager:getEffectHorizontalCasetPos( index ,camp )
	local campInfo = BattlefieldFormationPosInfo.defendCamp;
	if camp == Data_Battle.CONST_CAMP_PLAYER then
		campInfo = BattlefieldFormationPosInfo.attckCamp;
	end
	local pos = 1;
	if index == 1 then
		pos = 4;
	elseif index == 2 then
		pos = 5;
	elseif index == 3 then
		pos = 6;
	end
	return campInfo[pos];
end


--解析事件类型
function EffectManager:analysisEventType( event )
	-- print(event)
	local index = string.find(event,"_",1);
	if not index then
		return "",event;
	end
	local eventType = string.sub(event,1,index - 1);
	local info = string.sub(event,index + 1,-1);
	return eventType ,info;
end

--[[创建效果模板
	parame = {
		name = "",--效果名称
		x ,
		y ,
		zorder
		isfinishdestroy = false,--是否完成销毁
	}
]]
function EffectManager:CreateArmature( parame )
	local view = classtemplate_armature.new();
	view:setArmatureData( parame );
	return view;
end

function EffectManager:CreateArmature_1( parame )
	local view = classtemplate_armature.new();
	view:setArmatureData_1( parame );
	return view;
end

--[[创建装饰动画
	index = "",--效果名称
	x ,
	y ,
	zorder
	isfinishdestroy = false,--是否完成销毁
]]
function EffectManager:CreateDecorateArmature( parame)
	print("CreateDecorateArmature",parame.index);
	local resdata = EffectConfig[parame.index];
	local view = classtemplate_armature.new();
	view:setArmatureData( {
		name = resdata.armature,--效果名称
		x = parame.x + resdata.x,
		y = parame.y + resdata.y,
		zorder = parame.zorder + resdata.zorder;
		isfinishdestroy = resdata.isfinishdestroy,--是否完成销毁
		} );
	view:playAnimationByID( resdata.armaturename ,nil ,-1);
	-- view:setPosition(cc.p(display.cx,display.cy))
	-- cc.Director:getInstance():getRunningScene():addChild(view);

	--添加到显示界面
	dispatchGlobaleEvent( "battleshowlayer" ,"event_addshowobject" ,{view,resdata.layer,nil});
end

--[[创建伤害提示
	params = {
		hurtType = 1, --类型(比如2暴击，1普通伤害 ,3miss )
		aim = nil , -- 目标
		valuse = 10, -- 值
		offsettime = 0,-- 等待时间
	}
]]
EffectManager.CreateHPHurtPrompt = function ( params )
	local view = require("app.effect.hurtprompt.HurtPrompt_view").new();
	view:createHurtHPShow( params );
	--添加到显示界面
	dispatchGlobaleEvent( "battleshowlayer" ,"event_addshowobject" ,{view,3,params.aim.Map_x + params.aim.Map_y});

	return view;
end

--[[创建英雄入场效果

]]
EffectManager.CreateHeroEntranceEffect = function (callback)
	local effect = require("app.effect.entrance.effectControl_HeroEntrance").new();
	-- effect:setData(params);
	effect:setFinishCallback(callback)
	print("CreateHeroEntranceEffect",tostring(effect))
	battleShowManager:addLogicbject(effect);
	-- dispatchGlobaleEvent( "battleshowlayer" ,"event_addlogicbject" ,effect);
	-- effect:EntranceLogic();
	return effect;
end

--[[创建技能提示
	params = {
		target ,--目标
		name ,--技能名称
		res ,--技能名称资源
	}
]]
EffectManager.CreateBattleSkillPrompt = function ( params ,callfun)
	local effect = require("app.actors.controller.controller_skillName").new();
	effect:setData(params);
	effect:setFinishCallback(callfun);
	dispatchGlobaleEvent( "battleshowlayer" ,"event_addlogicbject" ,effect);
	return effect;
end

--[[创建技能效果
	parame = {
		name --技能名称
		release --释放者
		releaseCamp --释放者阵营
		aimCamp --目标阵营
		aimData -- 目标
		hurtData --目标伤害数据
	}
]]
EffectManager.CreateSkillDescribe = function ( params )
	local effect = require("app.effect.skill_effect.skilleffect_describe.lua").new();
	effect:setData(params);
	return effect;
end

--[[创建普通近战效果
	parame = {
		name --技能名称
		release --释放者
		releaseCamp --释放者阵营
		aimCamp --目标阵营
		aimData -- 目标
		hurtData --目标伤害数据
	}
]]
EffectManager.CreateEffect[20000] = function ( params )
	local effect = require("app.effect.skill_effect.skilleffect_infighting_common.lua").new();
	effect:setData(params);
	return effect;
end

--[[创建防御塔攻击效果
	parame = {
		name --技能名称
		release --释放者
		releaseCamp --释放者阵营
		aimCamp --目标阵营
		aimData -- 目标
		hurtData --目标伤害数据
	}
]]
EffectManager.CreateEffect[20001] = function ( params )
	local effect = require("app.effect.skill_effect.skilleffect_Remote_tower.lua").new();
	effect:setData(params);
	return effect;
end

-----------------------------------一些效果片-------------------------------------------

--[[创建计时效果
	params 计时值
]]
function EffectManager.CreatePiece_Timer( params )
	local effect = require("app.effect.effectpiece.TimeEffect.lua").new();
	effect:setData(params);
	return effect;
end

--[[ 震动效果
	params = {
		view = nil, --
		offset = 3,--偏移量
		runtime = 2,
		finishCallBack = nil,
	}
]]
EffectManager.CreateShakeEffect = function ( params )
	local effect = require("app.effect.effectpiece.Effect_Shake.lua").new();
	--添加到显示界面
	dispatchGlobaleEvent( "battleshowlayer" ,"event_addshowobject" ,{effect,2});
	effect:setData(params);
	return effect;
end

--[[震动
 	time 时间
]]
function EffectManager:CreatePiece_Shake_1( time )
	local effect = require("app.effect.effectpiece.Effect_shake_1.lua").new();
	--添加到显示界面
	dispatchGlobaleEvent( "battleshowlayer" ,"event_addshowobject" ,{effect,5,nil});
	effect:setData(time);
	return effect;
end

--[[ 战斗场景聚焦效果
	params = {
		dataType = 0,
		target = nil, -- 作用的目标(此目标必须是 actorview 类型)
		attackAim = nil,--- 攻击目标
		camp = 1, --阵营
		isshowTemplate = 0,
		callback = nil, -- 结束回调函数
	}
	params = {
		dataType = 1;-- 0 setData 1 setData_1
		camp = 1, --阵营
		cast_x = 0,
		cast_y = 0,
		rect_w = 1,
		rect_h = 1,
		isshowTemplate = 0,
		callback = nil, -- 结束回调函数
	}
]]
EffectManager.CreateCastFocusEffect = function ( params ,callback)
	local effect = require("app.effect.effectpiece.Effect_CastFocus").new();
	-- Uniquify_Battle.BattleView:addChild(effect,BattleManager.CONST_COMBAT_ORDER - 1);
	-- dispatchGlobaleEvent( "battleshowlayer" ,"event_addlogicbject" ,effect);
	dispatchGlobaleEvent( "battleshowlayer" ,"event_addshowobject" ,{effect,1 ,80})
	if params.dataType and params.dataType == 1 then
		effect:setData_1(params);
	else
		effect:setData(params);
	end
	effect:setFinishCallBack(callback)
	return effect;
end

--添加黑色模板
EffectManager.CreateCastFouseEffect_Black = function (  )
	local effect = require("app.effect.effectpiece.Effect_CastFocus").new();
	dispatchGlobaleEvent( "battleshowlayer" ,"event_addshowobject" ,{effect,1 ,80})
	effect:setData_2();
	return effect;
end