--
-- Author: LiYang
-- Date: 2015-07-07 10:58:40
-- 粒子旋转效果

local Effect_1 = class("Effect_1", cc.Node)

function Effect_1:ctor(  )
    --设置效果 (注意有粒子效果的时候消耗时间 要根据粒子效果设置时间销毁效果)
   
    self.effectNode = cc.ParticleSystemQuad:create("particle/bright.plist");
    self.effectNode:setBlendAdditive(true);
    self.effectNode:setDuration(-1);
    self.effectNode:setAutoRemoveOnFinish(true);--设置完成后自动销毁
    self.effectNode:setPosition(ccp(0,0));--设置发射位置
    -- self.pEmitter:setScale(0.7);
    self:addChild(self.effectNode);--将粒子效果放入效果成

end

--[[设置效果数据
    params = {
        run_Width = nil, --运行的宽度
        run_Height = nil, --运行的高度
        tension = 0;
        speed = 200, -- 运行速度600
        x = 0,
        y = 0,
        radius = 50, --运行的半径
        -- runtime = 1,--运行时间
    }
]]
function Effect_1:setData( params )
    self.run_Width = params.run_Width;
    self.run_Height = params.run_Height;
    self.tension = params.tension or 0;
    self.speed = params.speed or 400;

    self.runTime = (self.run_Width*2 + self.run_Height*2) / self.speed;
    self.runTime_x = self.run_Width / self.speed;
    self.runTime_y = self.run_Height / self.speed;
    self:setPosition(ccp(params.x, params.y))

    self.time = 0;
    self.runTime = 1.6;
    self.UnitTime = 0.05;
    self.UnitAngle = self.UnitTime * 360 / self.runTime;
    self.radius = 50;
    self.CurrentAngle = 0;

    --显示尺寸
    -- self.showPixelSize = 100;
    -- self.rootNode.effectSprite:setScale(self.showPixelSize / 260);
    -- 运行动作
    self:EffectAction();
    -- self:ExecuteEffectAction(  );
end

function Effect_1:EffectAction()
    --[[效果说明
        旋转移动动作
    ]]
    local pointArr = CCPointArray:create(4);
    pointArr:add(ccp(-self.run_Width/2 , self.run_Height/2))
    pointArr:add(ccp(self.run_Width/2 , self.run_Height/2))
    pointArr:add(ccp(self.run_Width/2 , -self.run_Height/2))
    pointArr:add(ccp(-self.run_Width/2 , -self.run_Height/2))
    pointArr:add(ccp(-self.run_Width/2 , self.run_Height/2))
    -- pointArr:add(ccp(0 , 0))
    -- pointArr:add(ccp(self.run_Width , 0))
    -- pointArr:add(ccp(self.run_Width , -self.run_Height))
    -- pointArr:add(ccp(0 , -self.run_Height))
    -- pointArr:add(ccp(0, 0))
    local action = CCCardinalSplineTo:create(self.runTime, pointArr, 0);
    

    self.rootNode.attackEffect:runAction(CCRepeatForever:create(action));
end



--设置完成回调函数
function Effect_1:setFinishCallback( callfun )
    self.FinishCallback = callfun;
end


return Effect_1;
