--
-- Author: Li Yang
-- Date: 2014-06-26 15:45:53
-- 新手引导管理类

require("app.effect.newbieguide.NewbieGuideReactionCongig")
require("app.effect.newbieguide.control_newbieGuide")

NewbieGuideManager = {};

--[[新手引导显示表现
	dialog 对话
	controlpos 控制显示位置
	openstory 开场剧情
	prompt 提示信息
]]
NewbieGuideManager.ShowConfig = {"dialog","controlpos","openstory","prompt","lightspotEffect"};

---------------------------------一些引导外部显示效果管理----------------------------------------------
NewbieGuideManager.externalEffectPool = {};

function NewbieGuideManager:addExternalEffect( key ,object )
	if not self.externalEffectPool[key] then
		self.externalEffectPool[key] = {};
	end
	self.externalEffectPool[key][object] = object;
end

function NewbieGuideManager:removeExternalEffectShow( key )
	if self.externalEffectPool[key] == nil then
		return;
	end
	for k,v in pairs(self.externalEffectPool[key]) do
		if v then
			v:removeFromParentAndCleanup(true);
		end
	end
	self.externalEffectPool[key] = nil;
end
------------------------------------------------------------------------------------------------
--[[example 具体事例
	view_dialog = {
		data = nil,
		callBack = function ()
		end,
	},
	--
	controlIndex = "",--显示的位置值
	--prompt
	PromptPart = {
		Content = "newbieguide_drama_6",--"点击主页按钮",--提示内容
		entranceAction = 1,--入场动作
		pos_x = CONFIG_SCREEN_WIDTH / 2,--放置位置
		pos_y = 100 / 2 - 100,
		buttonType = nil,
	},
	--开场剧情
]]


NewbieGuideManager.EexecuteMark = 0;

--新手引导执行的步骤编号
NewbieGuideManager.EexecuteStepPos = 100;--新手引导界面(1 开始)
NewbieGuideManager.NewbieGuideUI = nil;
NewbieGuideManager.IsFinish = true;
--新手引导当前步骤执行的位置
NewbieGuideManager.CurrentStepPos = 1;

--阵营礼包选择
NewbieGuideManager.LogicStep_Valuse = 100

--一些判断逻辑参数
NewbieGuideManager.logicConfig = {};

function NewbieGuideManager:ExecuteTeshuLogicStep(  )
	if self.EexecuteStepPos < 100 and user.player.lv >= 30 then
		UIManager:CreateZhenYinPrompt( display.getRunningScene() );
	end
end

--检查步骤执行数据
function NewbieGuideManager:CheckEexecuteStepPos(  )
	
	for k,v in pairs(NewbieGuideConfig) do
		if v and v.OrderKey and v.OrderKey >= self.EexecuteStepPos then
			self.IsFinish = false;
			break;
		end
	end
	--功能引导检查
	-- self.IsFinish = true;
end


--得到新手引导参数值
function NewbieGuideManager:getGuideStepOrderByID( stepconfig ,id )
	if stepconfig == nil then
		return 0;
	end
	for i,v in ipairs(stepconfig.executeOrder) do
		if v == id then
			return i;
		end
	end
end

--[[执行新手引导
	step 步骤
	order 顺序值
]]
function NewbieGuideManager:CreateNewbieGuide( step ,steppos)
	if self.IsFinish then
		return;
	end
	print("NewbieGuideManager:CreateNewbieGuide",step,steppos)
	--检查是否有对应步骤数据
	local checkData = NewbieGuideConfig[step];
	if checkData == nil then
		print("新手引导","引导执行步骤数据为nil->"..step);
		return ;
	end
	--检查步骤key值是否对应
	local checkKey = checkData.OrderKey;
	if checkKey ~= self.EexecuteStepPos then
		--引导结束
		print("引导结束 或错误 ","信息->"..step);
		return;
	end
	--检查步骤对应的order数据是否有
	local orderpos = checkData.executeOrder[steppos];
	local orderConfig = checkData[orderpos];
	if orderConfig == nil then
		print("新手引导","引导错误:"..step..",第"..steppos.."步,key:"..orderpos);
		return;
	end
	--创建新手引导界面
	self.CurrentStepPos = steppos;

	--判断是否关闭移动事件
	if orderConfig.MoveTounchSwitch then
		self.IsCloseMoveTounch = true;
	else
		self.IsCloseMoveTounch = false;
	end
	print("============>CreateNewbieGuideUI",step ,steppos)
	dispatchGlobaleEvent( "newbieguide","create" ,{step,steppos});
end

--[[设置显示引导
	step 步骤
	steporderID 步骤顺序ID
	params 显示控制(true false)
]]
function NewbieGuideManager:SetGuidDisplayContrl( step , steporderID , params )
	if self.IsFinish then
		return false;
	end
	--检查是否有对应步骤数据
	local checkData = NewbieGuideConfig[step];
	if checkData == nil then
		logPrint("新手引导","引导执行步骤数据为nil->"..step);
		return false;
	end
	if self.EexecuteStepPos ~= checkData.OrderKey then
		return false;
	end
	--判断是否有显示控制
	--检查步骤对应的order数据是否有
	local orderConfig = checkData[steporderID];
	if orderConfig == nil then
		logPrint("新手引导","引导错误:"..step..","..steporderID);
		return;
	end
	if self.NewbieGuideUI then
		self.NewbieGuideUI:setDisplayControl(params);
	end
end

--完成步骤逻辑
function NewbieGuideManager:FinishStepLogic( step , steporderID ,nextstep)
	print("FinishStepLogic",step , steporderID ,nextstep);
	if self.IsFinish then
		return false;
	end
	--检查是否有对应步骤数据
	local checkData = NewbieGuideConfig[step];
	if checkData == nil then
		print("新手引导","引导执行步骤数据为nil->"..step);
		return false;
	end
	if self.EexecuteStepPos ~= checkData.OrderKey then
		return false;
	end
	if self.CurrentStepPos ~= steporderID then
		print("新手引导完成执行步骤不同步",self.CurrentStepPos,steporderID)
		return false;
	end
	--得到下一步数据
	-- local nextStep = NewbieGuideConfig[checkData.nextStep];
	--判断是否发送更新步骤消息
	if checkData.finishOrder == steporderID then
		--发送消息
		self.EexecuteMark = 1 + self.EexecuteMark;
		print("网络日志"," 发送引导更新消息:MSG_C2MS_UPDATE_GUIDE_STEP:"..self.EexecuteMark)
	    gameTcp:SendMessage(MSG_C2MS_UPDATE_GUIDE_STEP, {self.EexecuteMark});
	end
	--销毁当前步骤
	-- if self.NewbieGuideUI then
	-- 	--结束逻辑
	-- 	if self.NewbieGuideUI.EndLogic then
	-- 		self.NewbieGuideUI.EndLogic("Finish");
	-- 	end
	-- 	self.NewbieGuideUI:removeFromParentAndCleanup(true);
	-- 	print("销毁新手引导",step , steporderID)
	-- 	self.NewbieGuideUI = nil;
	-- 	TounchContrlScheduler(-1);
	-- end
	print("完成新手引导",step , steporderID)
	dispatchGlobaleEvent( "newbieguide","finish");

	--判断此步骤是否完成
	if steporderID == checkData.sumStep then
		self.CurrentStepPos = 1;
		print("新手引导完成一步")
		--步骤完成
		self.EexecuteStepPos = self.EexecuteStepPos + 1;
		--检查新手引导是否完成
		self:CheckEexecuteStepPos(  );
	else
		self.CurrentStepPos = self.CurrentStepPos + 1;
	end
	
	return true;
end

--检查当前执行的是否是指定步骤
function NewbieGuideManager:CheckCurrentExecute( step , steporderID )
	if self.IsFinish then
		return false;
	end
	--检查是否有对应步骤数据
	local checkData = NewbieGuideConfig[step];
	if checkData == nil then
		logPrint("新手引导","引导执行步骤数据为nil->"..step);
		return false;
	end
	if self.EexecuteStepPos ~= checkData.OrderKey then
		return false;
	end
	if self.CurrentStepPos == steporderID then
	 	return true;
	end 
	return false;
end

--------------------------控制区域逻辑--------------------------------------

--[[
	----------------主页相关位置-----------------
	mainpage_zhanyi1 战役1位置
	mainpage_shop 主页商店
	mainpage_duiwu 主页队伍
	mainpage_ronglian 主页熔炼
	mainpage_renwu 主页任务
	mainpage_beibao 主页背包

	---------------商店相关位置信息--------------
	shop_zhaomu 商店招募按钮
	shop_zhaomu_pos_3 招募位置3
	shop_zhaomu_queding 招募确定
	shop_exit 商店退出按钮

	---------------队伍相关位置信息----------------
	duiwu_yjzb 队伍的一键装备
	duiwu_pos_2 队伍2位置
	duiwu_button_change 队伍换将按钮
	duiwu_choose_1 选择上阵武将 1
	duiwu_button_form 队伍阵型按钮
	duiwu_form_6 阵型选择6位置
	duiwu_exit 队伍退出按钮

	---------------熔炼相关位置信息----------------
	ronglian_button_yjzb 熔炼一键装备按钮
	ronglian_button_ok 熔炼确定按钮
	ronglian_button_shop

	------------奇遇位置信息相关
	qiyu_item1_1 奇遇第一个按钮1

	------------任务相关位置信息---------------------
	renwu_choose_renwu 选择任务
	renwu_item_1 选择第一个item
	renwu_exit 选择退出
	------------装备相关位置信息-------------------
	beibao_shenqi 背包神器
	beibao_shenqi_item1_hecheng 背包神器第一个item 合成
	beibao_zhuangbei 背包装备列表
	beibao_zhuangbei_item_1 背包装备列表第一项
	zhuangbei_info_shengjie 装备信息 升阶按钮
	zhuangbei_info_shengjie_ok 装备信息界面 升阶确定按钮
	beibao_zhuangbeiinfo_eixt 装备背包信息退出
	beibao_exit 背包退出
]]
NewbieGuideManager.ControlPos = {
	["denglu"] = nil;
}

--更新新手引导的控制部分信息
function NewbieGuideManager:SetNewbieGuideConfigByPos( index ,params )
	self.ControlPos[index] = params;
end

--得到引导位置
function NewbieGuideManager:getNewbieGuideConfigPosByKey( key )
	return self.ControlPos[key];
end


--添加新手引导信息
function NewbieGuideManager:initGuidePos()
	self.IsCloseMoveTounch = false;
	--确定提示按钮
	NewbieGuideManager:SetNewbieGuideConfigByPos( "testpos" ,{
			pos_x = display.cx,
			pos_y = display.cy,
			w = 200,
			h = 100,
		} );

end

NewbieGuideManager:initGuidePos();

--特殊处理的逻辑参数
NewbieGuideManager.EmbattleGuideCheckPos = -1;



--布阵引导逻辑
function NewbieGuideManager:EmbattleGuideLogic( params )
	
end

function NewbieGuideManager:EnterGameExecute(  )
	print("EnterGameExecute",self.IsFinish,self.EexecuteStepPos)
	if self.IsFinish then
		return;
	end
	local checkData = self:getNewbieGuideConfigByKey( self.EexecuteStepPos );
	if checkData == nil then
		return;
	end
	if NewbieGuideManager.logicConfig["UI_Onhook_offline"] then
		return;
	end
	--执行对应引导
	if checkData.createLogic then
		checkData.createLogic();
	else
		self:CreateNewbieGuide( checkData.key ,1);
	end
	print("执行引导",checkData.key ,1)
end

--通过key得到新手引导数据
function NewbieGuideManager:getNewbieGuideConfigByKey( key )
	-- local tempkey = NewbieGuideConfig.executeOrder[key];
	-- if tempkey == nil then
	-- 	return nil;
	-- end
	for k,v in pairs(NewbieGuideConfig) do
		if v and v.OrderKey == key then
			return v;
		end
	end
	return nil;
end



--新手引导config
NewbieGuideConfig = {
	--新模板
	-- [2] = {
	-- 		orderKey = 1,
	-- 		IsCloseBlack = false, -- 是否关闭黑色模板
	-- 		IsDisplayContrl = true,--是否显示控制
	-- 		MoveTounchSwitch = true,--是否关闭移动事件
	-- 		--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
	-- 		showConfig = {
	-- 			-- [1] = {
	-- 			-- 	showType = "openstory",--显示类型
	-- 			-- 	data = "",
	-- 			-- 	x = 0,
	-- 			-- 	y = 0,
	-- 			-- 	zorder = 0,
	-- 			-- },
	-- 			[1] = {
	-- 				showType = "controlpos",--显示类型控制区域
	-- 				data = "zuxiao",
	-- 				x = 0,
	-- 				y = 0,
	-- 				zorder = 0,
	-- 			},
	-- 			--提示
	-- 			[2] = {
	-- 				showType = "prompt",--显示类型控制区域
	-- 				Content = "newbieguide_drama_1",--提示内容
	-- 				entranceAction = 1,--入场动作
	-- 				x = CONFIG_SCREEN_WIDTH / 2,--放置位置
	-- 				y = 100 / 2 - 100,
	-- 				buttonType = nil,
	-- 			},
	-- 		},
	-- 		--开始逻辑
	-- 		startLogic = function (  )

	-- 		end,
	-- 		--结束逻辑
	-- 		EndLogic = function (  )

	-- 		end,
	-- 	},
	--执行顺序
	executeOrder = {"bosschanage","getaward","changeonhooklevel","quickfight","zhaomu","renwu","sqhc","changeanddress","changeformation","ronglian"},
	--开场剧情
	["bosschanage"] = {
		describe = "测试引导",
		key = "bosschanage",
		OrderKey = 1,--引导顺序key(这个值是服务器记录值)
		finishOrder = 3,--完成编号标示
		sumStep = 5,--总共步骤
		nextStep = "getaward",--下一步编号
		executeOrder = {1,2,3,4,5},--执行顺序
		[1] = {
			orderKey = 1,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_1",
					x = display.cx - 400,
					y = display.cy,
					zorder = 0,
					callBack = function (  )
						print("对话完成")
						-- NewbieGuideManager:FinishStepLogic( "openStory" ,2);
					end,
				},
				[2] = {
					showType = "controlpos",--显示类型控制区域
					data = "mainpage_zhanyi1",
					x = 0,
					y = 0,
					zorder = 0,
				},

			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示 "NULLCLICK" 点击非控制区域
			EndLogic = function ( params )
				print("================================>"..params)
				-- if params == "click" then
				-- 	NewbieGuideManager:FinishStepLogic( "openStory" ,1);
				-- 	NewbieGuideManager:CreateNewbieGuide( "openStory" ,2);
				-- end
			end,
		},
		[2] = {
			orderKey = 2,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件 
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "onhook_button_levellist",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑
			EndLogic = function (  )

			end,
		},
		[3] = {
			orderKey = 3,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_2",
					x = display.cx,
					y = display.cy + 200,
					zorder = 0,
					callBack = function (  )
						
					end,
				},
				[2] = {
					showType = "controlpos",--显示类型控制区域
					data = "onhook_level1_challenge",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑
			EndLogic = function (  )

			end,
		},
		[4] = {
			orderKey = 4,
			IsContrlTounch = true,--是否控制按键事件
			IsShowBlack = false, -- 是否关闭黑色模板
			IsDisplayContrl = false,--是否显示控制
			MoveTounchSwitch = false,--是否关闭移动事件
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {

			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑
			EndLogic = function (  )

			end,
		},
		[5] = {
			orderKey = 5,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件 
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "battleover_button_lingqu",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑
			EndLogic = function (  )

			end,
		},
	},
	["getaward"] = {
		describe = "领取过关奖励",
		key = "getaward";
		OrderKey = 2,--引导顺序key(这个值是服务器记录值)
		finishOrder = 3,--完成编号标示
		sumStep = 4,--总共步骤
		executeOrder = {1,2,3,4},--执行顺序
		nextStep = "changeonhooklevel",--下一步编号
		[1] = {
			orderKey = 1,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_1",
					x = display.cx - 400,
					y = display.cy,
					zorder = 0,
					callBack = function (  )

					end,
				},
				[2] = {
					showType = "controlpos",--显示类型控制区域
					data = "mainpage_zhanyi1",
					x = 0,
					y = 0,
					zorder = 0,
				},

			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示 "NULLCLICK" 点击非控制区域
			EndLogic = function ( params )

			end,
		},
		[2] = {
			orderKey = 2,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件 
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "onhook_button_levellist",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑
			EndLogic = function (  )

			end,
		},
		[3] = {
			--选择领取宝箱界面
			orderKey = 3,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "onhook_level1_baoxiang",
					x = 0,
					y = 0,
					zorder = 0,
				},
				[2] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_3",
					x = display.cx,
					y = display.cy + 200,
					zorder = 0,
					callBack = function (  )
						
					end,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
		[4] = {
			--选择退出过关奖励领取界面
			orderKey = 4,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "goods_get_button_exit",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
	},
	--切换挂机关卡
	["changeonhooklevel"] = {
		describe = "切换挂机关卡",
		key = "changeonhooklevel";
		OrderKey = 3,--引导顺序key(这个值是服务器记录值)
		finishOrder = 3,--完成编号标示
		sumStep = 4,--总共步骤
		executeOrder = {1,2,3,4},--执行顺序
		nextStep = "quickfight",--下一步编号
		[1] = {
			orderKey = 1,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_1",
					x = display.cx - 400,
					y = display.cy,
					zorder = 0,
					callBack = function (  )

					end,
				},
				[2] = {
					showType = "controlpos",--显示类型控制区域
					data = "mainpage_zhanyi1",
					x = 0,
					y = 0,
					zorder = 0,
				},

			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示 "NULLCLICK" 点击非控制区域
			EndLogic = function ( params )

			end,
		},
		[2] = {
			orderKey = 2,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件 
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "onhook_button_levellist",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑
			EndLogic = function (  )

			end,
		},
		[3] = {
			--选择切换的关卡
			orderKey = 3,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "onhook_level2_onhook",
					x = 0,
					y = 0,
					zorder = 0,
				},
				[2] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_4",
					x = display.cx,
					y = display.cy + 200,
					zorder = 0,
					callBack = function (  )
						
					end,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
		[4] = {
			--选择退出过关奖励领取界面
			orderKey = 4,
			IsContrlTounch = true,--是否控制按键事件
			IsShowBlack = false, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_4_1",
					x = display.cx,
					y = display.cy + 200,
					zorder = 0,
					callBack = function (  )
						
					end,
				},
			},
			--被点击事件
			clickLogic = function (  )
				NewbieGuideManager:FinishStepLogic( "changeonhooklevel" , 4 );
				NewbieGuideManager:CreateNewbieGuide( "quickfight" ,3 );
			end,
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
		
	},
	--快速战斗
	["quickfight"] = {
		describe = "快速战斗",
		key = "quickfight";
		OrderKey = 4,--引导顺序key(这个值是服务器记录值)
		finishOrder = 4,--完成编号标示
		sumStep = 6,--总共步骤
		executeOrder = {1,2,3,4,5,6},--执行顺序
		nextStep = "zhaomu",--下一步编号
		[1] = {
			orderKey = 1,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_1",
					x = display.cx - 400,
					y = display.cy,
					zorder = 0,
					callBack = function (  )

					end,
				},
				[2] = {
					showType = "controlpos",--显示类型控制区域
					data = "mainpage_zhanyi1",
					x = 0,
					y = 0,
					zorder = 0,
				},

			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示 "NULLCLICK" 点击非控制区域
			EndLogic = function ( params )

			end,
		},
		[2] = {
			orderKey = 2,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件 
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "onhook_button_levellist",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑
			EndLogic = function (  )

			end,
		},
		[3] = {
			--选择快速战斗
			orderKey = 3,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "onhook_button_quickcombat",
					x = 0,
					y = 0,
					zorder = 0,
				},
				[2] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_5",
					x = display.cx,
					y = display.cy + 200,
					zorder = 0,
					callBack = function (  )
						
					end,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
		[4] = {
			--选择确定界面
			orderKey = 4,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "quickfight_button_ok",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--被点击事件
			clickLogic = function (  )

			end,
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},

		[5] = {
			--选择快速战斗信息界面
			orderKey = 5,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "onhook_offline_exit",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--被点击事件
			clickLogic = function (  )
				
			end,
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},

		[6] = {
			--关闭战斗界面
			orderKey = 6,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下 
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "onhook_button_exit",
					x = 0,
					y = 0,
					zorder = 0,
				},
				[2] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_6",
					x = display.cx,
					y = display.cy + 200,
					zorder = 0,
					callBack = function (  )
						
					end,
				},
			},
			--被点击事件
			clickLogic = function (  )
				
			end,
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
		
	},
	--招募
	["zhaomu"] = {
		describe = "招募英雄",
		key = "zhaomu";
		OrderKey = 5,--引导顺序key(这个值是服务器记录值)
		finishOrder = 4,--完成编号标示
		sumStep = 5,--总共步骤
		executeOrder = {1,2,3,4,5},--执行顺序
		nextStep = "changeanddress",--下一步编号
		[1] = {
			orderKey = 1,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_7",
					x = display.cx,
					y = display.cy,
					zorder = 0,
					callBack = function (  )

					end,
				},
				[2] = {
					showType = "controlpos",--显示类型控制区域
					data = "mainpage_shop",--商店选择按钮位置
					x = 0,
					y = 0,
					zorder = 0,
				},

			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示 "NULLCLICK" 点击非控制区域
			EndLogic = function ( params )

			end,
		},
		--商店招募按钮位置
		[2] = {
			orderKey = 2,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件 
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "shop_zhaomu",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑
			EndLogic = function (  )

			end,
		},
		[3] = {
			--招募选择3位置
			orderKey = 3,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "shop_zhaomu_pos_3",
					x = 0,
					y = 0,
					zorder = 0,
				},
				[2] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_8",
					x = display.cx,
					y = display.cy + 200,
					zorder = 0,
					callBack = function (  )
						
					end,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
		[4] = {
			--选择确定界面
			orderKey = 4,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "shop_zhaomu_queding",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--被点击事件
			clickLogic = function (  )

			end,
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},

		[5] = {
			--关闭商店界面
			orderKey = 5,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下 
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "shop_exit",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--被点击事件
			clickLogic = function (  )
				
			end,
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
	},

	--任务
	["renwu"] = {
		describe = "任务",
		key = "renwu";
		OrderKey = 6,--引导顺序key(这个值是服务器记录值)
		finishOrder = 3,--完成编号标示
		sumStep = 4,--总共步骤
		executeOrder = {1,2,3,4},--执行顺序
		nextStep = "sqhc",--下一步编号
		[1] = {
			orderKey = 1,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_19",
					x = display.cx,
					y = display.cy,
					zorder = 0,
					callBack = function (  )

					end,
				},
				[2] = {
					showType = "controlpos",--显示类型控制区域
					data = "mainpage_renwu",
					x = 0,
					y = 0,
					zorder = 0,
				},

			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示 "NULLCLICK" 点击非控制区域
			EndLogic = function ( params )

			end,
		},
		[2] = {
			--点击第一个任务领取
			orderKey = 2,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件 
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "renwu_choose_renwu",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑
			EndLogic = function (  )

			end,
		},
		[3] = {
			--点击关闭
			orderKey = 3,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "renwu_item_1",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
		[4] = {
			--选择熔炼
			orderKey = 4,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "renwu_exit",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
	},

	--神器合成
	["sqhc"] = {
		describe = "神器合成",
		key = "sqhc";
		OrderKey = 7,--引导顺序key(这个值是服务器记录值)
		finishOrder = 3,--完成编号标示
		sumStep = 10,--总共步骤
		executeOrder = {1,2,3,4,5,6,7,8,9,10},--执行顺序
		nextStep = "quickfight",--下一步编号
		[1] = {
			orderKey = 1,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_20",
					x = display.cx,
					y = display.cy,
					zorder = 0,
					callBack = function (  )

					end,
				},
				[2] = {
					showType = "controlpos",--显示类型控制区域
					data = "mainpage_beibao",
					x = 0,
					y = 0,
					zorder = 0,
				},

			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示 "NULLCLICK" 点击非控制区域
			EndLogic = function ( params )

			end,
		},
		[2] = {
			--选择神器列表
			orderKey = 2,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件 
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "beibao_shenqi",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑
			EndLogic = function (  )

			end,
		},
		[3] = {
			--点击合成
			orderKey = 3,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "beibao_shenqi_item1_hecheng",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
		[4] = {
			--选择装备列表
			orderKey = 4,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "beibao_zhuangbei",
					x = 0,
					y = 0,
					zorder = 0,
				},
				[2] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_21",
					x = display.cx,
					y = display.cy,
					zorder = 0,
					callBack = function (  )

					end,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
		[5] = {
			--选择装备列表
			orderKey = 5,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "beibao_zhuangbei_item_1",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},

		[6] = {
			--选择装备列表
			orderKey = 6,
			IsContrlTounch = true,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_22",
					x = display.cx - 400,
					y = display.cy,
					zorder = 0,
					callBack = function (  )

					end,
				},
			},
			--被点击事件
			clickLogic = function (  )
				NewbieGuideManager:FinishStepLogic( "sqhc" , 6 );
				NewbieGuideManager:CreateNewbieGuide( "sqhc" ,7 );
			end,
			--开始逻辑
			startLogic = function (  )
				
			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},

		[7] = {
			--点击装备信息界面升阶按钮
			orderKey = 7,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "zhuangbei_info_shengjie",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},

		[8] = {
			--升阶确定按钮
			orderKey = 8,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "zhuangbei_info_shengjie_ok",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},

		[9] = {
			--装备信息退出
			orderKey = 9,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "beibao_zhuangbeiinfo_eixt",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},

		

		[10] = {
			--装备界面退出
			orderKey = 10,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "beibao_exit",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
	},

	--装备穿戴和武将切换
	["changeanddress"] = {
		describe = "武将换将和装备穿戴",
		key = "changeanddress";
		OrderKey = 8,--引导顺序key(这个值是服务器记录值)
		finishOrder = 5,--完成编号标示
		sumStep = 6,--总共步骤
		executeOrder = {1,2,3,4,5,6},--执行顺序
		nextStep = "changeformation",--下一步编号
		[1] = {
			orderKey = 1,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_9",
					x = display.cx,
					y = display.cy - 200,
					zorder = 0,
					callBack = function (  )

					end,
				},
				[2] = {
					showType = "controlpos",--显示类型控制区域
					data = "mainpage_duiwu",--商店选择按钮位置
					x = 0,
					y = 0,
					zorder = 0,
				},

			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示 "NULLCLICK" 点击非控制区域
			EndLogic = function ( params )

			end,
		},
		--队伍一键换装
		[2] = {
			orderKey = 2,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件 
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "duiwu_yjzb",
					x = 0,
					y = 0,
					zorder = 0,
				},
				[2] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_10",
					x = display.cx,
					y = display.cy + 200,
					zorder = 0,
					callBack = function (  )
						
					end,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑
			EndLogic = function (  )

			end,
		},
		[3] = {
			--队伍位置2
			orderKey = 3,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "duiwu_pos_2",
					x = 0,
					y = 0,
					zorder = 0,
				},
				[2] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_11",
					x = display.cx,
					y = display.cy - 200,
					zorder = 0,
					callBack = function (  )
						
					end,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
		[4] = {
			--选择更换武将
			orderKey = 4,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "duiwu_button_change",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--被点击事件
			clickLogic = function (  )

			end,
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},

		[5] = {
			--选择英雄列表1
			orderKey = 5,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下 
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "duiwu_choose_1",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--被点击事件
			clickLogic = function (  )
				
			end,
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
		--队伍一键换装
		[6] = {
			orderKey = 6,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件 
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "duiwu_yjzb",
					x = 0,
					y = 0,
					zorder = 0,
				},
				[2] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_10",
					x = display.cx,
					y = display.cy + 200,
					zorder = 0,
					callBack = function (  )
						
					end,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑
			EndLogic = function (  )

			end,
		},
	},

	--切换阵型
	["changeformation"] = {
		describe = "改变阵型",
		key = "changeformation";
		OrderKey = 9,--引导顺序key(这个值是服务器记录值)
		finishOrder = 3,--完成编号标示
		sumStep = 4,--总共步骤
		executeOrder = {1,2,3,4},--执行顺序
		nextStep = "cardUpgrade",--下一步编号
		[1] = {
			orderKey = 1,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "mainpage_duiwu",--商店选择按钮位置
					x = 0,
					y = 0,
					zorder = 0,
				},
				[2] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_12",
					x = display.cx,
					y = display.cy - 200,
					zorder = 0,
					callBack = function (  )
						
					end,
				},

			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示 "NULLCLICK" 点击非控制区域
			EndLogic = function ( params )

			end,
		},
		
		[2] = {
			--左边按钮队伍阵型
			orderKey = 2,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件 
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "duiwu_button_form",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑
			EndLogic = function (  )

			end,
		},
		[3] = {
			--阵型位置6
			orderKey = 3,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "duiwu_form_6",
					x = 0,
					y = 0,
					zorder = 0,
				},
				[2] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_12",
					x = display.cx,
					y = display.cy - 200,
					zorder = 0,
					callBack = function (  )
						
					end,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
		[4] = {
			--退出队伍界面
			orderKey = 4,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "duiwu_exit",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--被点击事件
			clickLogic = function (  )

			end,
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
	},
	--熔炼
	["ronglian"] = {
		describe = "熔炼",
		key = "ronglian";
		OrderKey = 10,--引导顺序key(这个值是服务器记录值)
		finishOrder = 3,--完成编号标示
		sumStep = 4,--总共步骤
		executeOrder = {1,2,3,4},--执行顺序
		nextStep = "renwu",--下一步编号
		[1] = {
			orderKey = 1,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_13",
					x = display.cx - 300,
					y = display.cy,
					zorder = 0,
					callBack = function (  )

					end,
				},
				[2] = {
					showType = "controlpos",--显示类型控制区域
					data = "mainpage_ronglian",
					x = 0,
					y = 0,
					zorder = 0,
				},

			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示 "NULLCLICK" 点击非控制区域
			EndLogic = function ( params )

			end,
		},
		[2] = {
			--熔炼一键选择装备
			orderKey = 2,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件 
			--显示config dialog 对话 controlpos 控制显示位置 openstory 开场剧情 prompt 提示信息
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "ronglian_button_yjzb",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑
			EndLogic = function (  )

			end,
		},
		[3] = {
			--选择熔炼
			orderKey = 3,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "ronglian_button_ok",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
		[4] = {
			--选择熔炼
			orderKey = 4,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "controlpos",--显示类型控制区域
					data = "ronglian_button_shop",
					x = 0,
					y = 0,
					zorder = 0,
				},
				[2] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_14",
					x = display.cx,
					y = display.cy + 300,
					zorder = 0,
					callBack = function (  )

					end,
				},
			},
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},
	},

	
};




--[[执行功能引导	
	step 步骤
	order 步数
]]
function NewbieGuideManager:CreateFunctionGuide( step ,order)
	--检查是否有对应步骤数据
	local checkData = FunctionGuideConfig[step];
	if checkData == nil then
		print("功能引导","引导执行步骤数据为nil->"..step);
		return ;
	end
	--检查步骤是否能响应
	if not checkData.isOpen then
		--引导结束
		print("功能引导 ","当前功能引导未开启"..step);
		return;
	end
	--检查步骤对应的order数据是否有
	local orderConfig = checkData[order];
	if orderConfig == nil then
		print("功能引导","引导错误:"..step..","..order);
		return;
	end
	print("功能引导创建",step ,order)
	dispatchGlobaleEvent( "newbieguide","create" ,{step,order,1});
end

--[[完成功能引导步骤逻辑
	step 引导可以
	order 对应的步骤
]]
function NewbieGuideManager:FinishFunctionGuideStepLogic( step , order)
	--检查是否有对应步骤数据
	local checkData = FunctionGuideConfig[step];
	if checkData == nil then
		print("功能引导","引导执行步骤数据为nil->"..step);
		return false;
	end
	--检查步骤是否能响应
	if not checkData.isOpen then
		--引导结束
		print("功能引导 ","当前功能引导未开启"..step);
		return;
	end
	--判断是否发送更新步骤消息
	if checkData.finishOrder == order then
		--发送消息
		-- checkData:finishLog();
	end
	dispatchGlobaleEvent( "newbieguide","finish");
	--判断此步骤是否完成
	if order == checkData.sumStep then
		--步骤完成
		-- checkData.isOpen = false;
	end
	return true;
end

--功能引导开启检查
function NewbieGuideManager:FunctionGuideCheckLogic(  )
	for k,v in pairs(FunctionGuideConfig) do
		if v then
			v.checkLog(  );
		end
	end
end

--功能引导
FunctionGuideConfig = {
	--雇佣引导
	["guyong"] = {
		describe = "雇佣引导",
		key = "guyong",--引导key值
		isOpen = false,--是否开启
		OrderKey = 1,--引导顺序key(这个值是服务器记录值)
		finishOrder = 1,--完成编号标示
		sumStep = 1,--总共步骤
		executeOrder = {1},--执行顺序
		nextStep = "",--下一步编号
		checkLog = function (  ) --检查逻辑
			local markkey = math.modf(NewbieGuideManager.EexecuteMark % 1000 / 100);
			if markkey > 0 then
				FunctionGuideConfig["guyong"].isOpen = true;
			end
		end,
		openLog = function ( openlv ) --开启逻辑
			--后端发送等级 到前端 
			print("奇遇引导:",FunctionGuideConfig["guyong"].isOpen)
			if FunctionGuideConfig["guyong"].isOpen then
				return false;
			end
			FunctionGuideConfig["guyong"].isOpen = true;
			NewbieGuideManager:CreateFunctionGuide( "guyong" ,1);
			--重置完成标示
			FunctionGuideConfig["guyong"].finishLog();
			return true;
		end,
		--完成逻辑
		finishLog = function (  )
			NewbieGuideManager.EexecuteMark = 100 + NewbieGuideManager.EexecuteMark;
			print("网络日志"," 发送引导更新消息:MSG_C2MS_UPDATE_GUIDE_STEP:"..NewbieGuideManager.EexecuteMark)
		    gameTcp:SendMessage(MSG_C2MS_UPDATE_GUIDE_STEP, {NewbieGuideManager.EexecuteMark});
		end,
		[1] = {
			--选择退出过关奖励领取界面
			orderKey = 1,
			IsContrlTounch = true,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_14_2",
					x = display.cx,
					y = display.cy + 200,
					zorder = 0,
					callBack = function (  )
						
					end,
				},
			},
			--被点击事件
			clickLogic = function (  )
				NewbieGuideManager:FinishFunctionGuideStepLogic( "guyong" , 1 );
			end,
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},

	},
	--奇遇引导
	["qiyu"] = {
		describe = "奇遇引导",
		key = "qiyu",--引导key值
		isOpen = false,--是否开启
		OrderKey = 1,--引导顺序key(这个值是服务器记录值)
		finishOrder = 1,--完成编号标示
		sumStep = 1,--总共步骤
		executeOrder = {1},--执行顺序
		nextStep = "",--下一步编号
		checkLog = function (  ) --检查逻辑
			local markkey = math.modf(NewbieGuideManager.EexecuteMark % 10000 / 1000);
			if markkey > 0 then
				FunctionGuideConfig["qiyu"].isOpen = true;
			end
		end,
		openLog = function ( openlv ) --开启逻辑
			print("奇遇引导:",FunctionGuideConfig["qiyu"].isOpen)
			if FunctionGuideConfig["qiyu"].isOpen then
				return false;
			end
			FunctionGuideConfig["qiyu"].isOpen = true;
			NewbieGuideManager:CreateFunctionGuide( "qiyu" ,1);
			--重置完成标示
			FunctionGuideConfig["qiyu"].finishLog();
			return true;
		end,
		--完成逻辑
		finishLog = function (  )
			NewbieGuideManager.EexecuteMark = 1000 + NewbieGuideManager.EexecuteMark;
			print("网络日志"," 发送引导更新消息:MSG_C2MS_UPDATE_GUIDE_STEP:"..NewbieGuideManager.EexecuteMark)
		    gameTcp:SendMessage(MSG_C2MS_UPDATE_GUIDE_STEP, {NewbieGuideManager.EexecuteMark});
		end,
		[1] = {
			--选择退出过关奖励领取界面
			orderKey = 1,
			IsContrlTounch = false,--是否控制按键事件
			IsShowBlack = true, -- 是否关闭黑色模板
			IsDisplayContrl = true,--是否显示控制
			MoveTounchSwitch = true,--是否关闭移动事件
			--战役按钮按下
			showConfig = {
				[1] = {
					showType = "dialog",--显示类型控制区域
					data = "newbieguide_drama_16_2",
					x = display.cx,
					y = display.cy - 80,
					zorder = 0,
					callBack = function (  )
						
					end,
				},
				[2] = {
					showType = "controlpos",--显示类型控制区域
					data = "qiyu_item1_1",
					x = 0,
					y = 0,
					zorder = 0,
				},
			},
			--被点击事件
			clickLogic = function (  )
				
			end,
			--开始逻辑
			startLogic = function (  )

			end,
			--结束逻辑 "click" 控制点击标示 "Finish" 完成标示
			EndLogic = function ( params )

			end,
		},

	},
};