--
-- Author: LiYang
-- Date: 2015-09-23 14:54:41
--
local NewbieGuide_view = class("NewbieGuide_view", cc.load("mvc").ViewBase)

NewbieGuide_view.RESOURCE_FILENAME = "ui_instance/guide/newguide_node.csb"
function NewbieGuide_view:onCreate()

    self.tounchNode = self.resourceNode_:getChildByName("shadow_layout");
    self.tounchNode:setLocalZOrder(20);
    -- self.tounchNode:setTouchEnabled(true);

    self.showNode = self.resourceNode_:getChildByName("show_view");
    --提示节点
    self.promptNode = self.resourceNode_:getChildByName("promptNode");
    --关卡名称
    self.width = self.tounchNode:getContentSize().width;
    self.height = self.tounchNode:getContentSize().height;

    self:CreateTounchControlLayer();
    self:registerEvent();

    self.BackTemple = false;
    self.showNode:setVisible(self.BackTemple);

    self.tounchNode:setTouchEnabled(false);
   

    local function onNodeEvent(event)
            if "enter" == event then
                print("onNodeEvent:","enter");
            elseif "exit" == event then
                print("onNodeEvent:","exit");
            elseif "enterTransitionFinish" == event then
            	print("enterTransitionFinish:","enterTransitionFinish");
                self:InviView(  );
            end
       end
    self.resourceNode_:registerScriptHandler(onNodeEvent)
end

--设置开场动画 和 
function NewbieGuide_view:openAnimationEffect(  )

end

--注册事件
function NewbieGuide_view:registerEvent(  )
	--点击事件
    local function onTouchBegan(touch, event)
        --没有控制区域
        if not self.checkRect then
            return false;
        end
    	local location = touch:getLocation()
    	print("onTouchBegan",location.x ,location.y)
    	if self:CheckTounchRect( location.x ,location.y) then
    		return false;
    	end
        return true;
    end

    local function onTouchEnded( touch, event )
        
    end

    local listener1 = cc.EventListenerTouchOneByOne:create()
    listener1:setSwallowTouches(true)
    listener1:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN )
    local eventDispatcher = self.resourceNode_:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener1, self.ColordrawNode)
	
    --按键控制
    local function onhookClicked(sender)
        print("NewbieGuide_view onhookClicked",self.isControlTounch)
        if self.isControlTounch then
            dispatchGlobaleEvent( "newbieguide","tounch_click");
        end
    end
    self.tounchNode:addClickEventListener(onhookClicked)
end

--初始化界面
function NewbieGuide_view:InviView(  )
    --按键控制
    -- self.tounchNode:setTouchEnabled(true);
    --关闭黑色模板
    self.BackTemple = false;
    self.showNode:setVisible(self.BackTemple);
    --清空检查区域
    self.checkRect = nil;
    self.clipTemple:setPosition(cc.p(-1000,0))
    --清空所有提示
    self.promptNode:removeAllChildren();
    self.promptNode:setVisible(false);--关闭提示节点

    --按键控制
    self.isControlTounch = false;
    self.tounchNode:setTouchEnabled(false);
end

--检查点击区域
function NewbieGuide_view:CheckTounchRect( x , y)
	if not self.checkRect then
		return false;
	end
	if x < self.checkRect.x - self.checkRect.width / 2 or x > self.checkRect.x + self.checkRect.width / 2 or 
		y < self.checkRect.y - self.checkRect.height / 2 or y > self.checkRect.y + self.checkRect.height / 2 then
		return false;
	end
	return true;
end

--设置按键控制区域
function NewbieGuide_view:setTounchControlRect(  pos_x, pos_y ,width , height )
    ----------设置检查区域----------
    self.checkRect = cc.rect(pos_x,pos_y,width,height)
    self.ShowRectScale_x = width / 86;
    self.ShowRectScale_y = height / 86;
end

--是否显示黑色底板
function NewbieGuide_view:setIsShowBackTemple( isshow )
    self.BackTemple = isshow;
end

--是否控制按键
function NewbieGuide_view:setIsControlTounch( isshow )
    self.isControlTounch = isshow;
end

--创建按键控制层
function NewbieGuide_view:CreateTounchControlLayer(  )
    --设置聚焦效果
    self.clip = cc.ClippingNode:create();
    --设置裁剪模板
    self.clipTemple = cc.Sprite:createWithSpriteFrameName("ui_image/common/image/blank2.png");

    self.clipTemple:setPosition(cc.p(-1000,0))

    -- print(self.clipTemple:getLineStipple())
    -- self.clipTemple:setLineStippleEnabled(true);
    self.clip:setStencil(self.clipTemple);

    local s = cc.Director:getInstance():getWinSize()
    self.ColordrawNode = cc.LayerColor:create(cc.c4b(0, 0, 0, 0), s.width, 900)
    self.ColordrawNode:setCascadeColorEnabled(false)

    self.ColordrawNode:setAnchorPoint(cc.p(0, 0));
    self.clip:setAnchorPoint(cc.p(0, 0));
    self.clip:setInverted(true); --设置裁剪显示的方式
    self.clip:setAlphaThreshold(0);
    self.clip:addChild(self.ColordrawNode);

    self.showNode:addChild(self.clip,1);
end

--创建引导显示效果
function NewbieGuide_view:startGuideEffect(  )
    --是否控制按键
    self.tounchNode:setTouchEnabled(true);
    --开启引导黑底
    self.showNode:setVisible(self.BackTemple);
    --判断是否有控制区域
    if not self.checkRect then
        --移动完成
        self.tounchNode:setTouchEnabled(self.isControlTounch);
        self.promptNode:setVisible(true);
        return;
    end
    local show_x = self.checkRect.x;
    local show_y = self.checkRect.y;
    self.clipTemple:setPosition(cc.p(show_x,show_y));
	self.clipTemple:setScale( 1300 / 100 );
	local scale_0 = cc.ScaleTo:create(0.3, self.ShowRectScale_x , self.ShowRectScale_y);
	local callback = cc.CallFunc:create(function (  )
		--移动完成
		self.tounchNode:setTouchEnabled(self.isControlTounch);
        self.promptNode:setVisible(true);
        self:createClickPromptEffect(  );
	end)
	self.clipTemple:runAction(cc.Sequence:create(scale_0,callback));
    
end

function NewbieGuide_view:createClickPromptEffect(  )
    -- if self.ClickEffect then
    --     self.ClickEffect:setPosition(cc.p(self.checkRect.x,self.checkRect.y));
    --     self.ClickEffect:setVisible(true);
    --     return;
    -- end
    --加载动画
    ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("animation/clickprompt/clickprompt.ExportJson")

    self.ClickEffect = ccs.Armature:create("clickprompt")
    self.promptNode:addChild(self.ClickEffect)
    self.ClickEffect:setPosition(cc.p(self.checkRect.x,self.checkRect.y));
    self.ClickEffect:getAnimation():play("Animation1",-1,1);
end

function NewbieGuide_view:AddPromptView( view )
    self.promptNode:addChild(view);
end


return NewbieGuide_view;