--
-- Author: LiYang
-- Date: 2015-08-12 14:23:59
-- 新手引导控制器

local control_newbieGuide = class("control_newbieGuide");
--[[事件说明
	发送更新位置事件
	dispatchGlobaleEvent( "newbieguide","updatapos");
]]

function control_newbieGuide:ctor()
	self.registerConfig = {
        {"newbieguide","initialize",1},--观看挂机
        {"newbieguide","create",1},--创建引导
        {"newbieguide","reaction",1},--新手感应位置
        {"newbieguide","finish",1},--完成一步
        {"newbieguide","tounch_click",1},--新手引导被点击
    };

    self:register_event(  );

end

function control_newbieGuide:getInstance(  )
    if control_newbieGuide.instance == nil then
        control_newbieGuide.instance = control_newbieGuide.new()
    end
    return control_newbieGuide.instance
end

--注册事件
function control_newbieGuide:register_event(  )

    local defaultCallbacks = {
        newbieguide_initialize = handler(self, self.InitializeNewbieGuide),
        newbieguide_create = handler(self, self.CreateNewbieGuide),
        newbieguide_reaction = handler(self, self.CreateNewbieGuideReaction),--创建新手引导感应位置
        newbieguide_finish = handler(self, self.event_guide_finish),--新手引导完成一步
        newbieguide_tounch_click =  handler(self, self.event_tounch_click),
    }
    self.eventlisen = {};
    for i,v in ipairs(self.registerConfig) do
        local eventname = createGlobaleEventName( v[1], v[2] )
        print("注册事件",eventname);
        if defaultCallbacks[eventname] then
            createGlobalEventListener( v[1], v[2], defaultCallbacks[eventname], v[3] )
        end
    end
end


--初始化新手引导
function control_newbieGuide:InitializeNewbieGuide( event )
	--检查引导是否结束
	-- NewbieGuideManager:CheckEexecuteStepPos(  );
	if NewbieGuideManager.IsFinish then
		return;
	end
	--创建引导控制层
	self.NewbieGuide_view = require("app.effect.newbieguide.NewbieGuide_view").new();
	APP:getCurScene():addChildToLayer(LAYER_ID_GUIDE, self.NewbieGuide_view);
	print("新手引导初始化完成")
end

--创建新手引导
function control_newbieGuide:CreateNewbieGuide( event )
	
	self.currentStep = event._usedata[1];
	self.currentStepPos = event._usedata[2];
	self.operationType = event._usedata[3] or 0;
	if self.operationType == 0 then
		self.ExecuteConfig = NewbieGuideConfig[self.currentStep][self.currentStepPos];
	else
		self.ExecuteConfig = FunctionGuideConfig[self.currentStep][self.currentStepPos];
		if not self.NewbieGuide_view then
			self.NewbieGuide_view = require("app.effect.newbieguide.NewbieGuide_view").new();
			APP:getCurScene():addChildToLayer(LAYER_ID_GUIDE, self.NewbieGuide_view);
		end
	end
	if not self.ExecuteConfig then
		print("引导数据为nil")
		return;
	end

	--是否显示黑板
	self.NewbieGuide_view:setIsShowBackTemple( self.ExecuteConfig.IsShowBlack );
	--是否控制按键
	self.NewbieGuide_view:setIsControlTounch( self.ExecuteConfig.IsContrlTounch );
	--执行界面显示信息
	for i,v in ipairs(self.ExecuteConfig.showConfig) do
		if v then
			self:CreateShowView( v );
		end
	end
	--开始引导效果
	self.NewbieGuide_view:startGuideEffect(  );
end

function control_newbieGuide:CreateNewbieGuideReaction( event )
	local classname = event._usedata[1];
	local reactionname = event._usedata[2];
	local des = event._usedata[3];
	NewbieGuideReaction.ExecuteNewbieGuideReaction(classname,reactionname,des);
end

--注册完成一步
function control_newbieGuide:event_guide_finish( event )
	self.NewbieGuide_view:InviView(  );
end

function control_newbieGuide:event_tounch_click( event )
	if self.ExecuteConfig.clickLogic then
		self.ExecuteConfig.clickLogic();
	end
end

function control_newbieGuide:CreateShowView( config )
	if config.showType == "controlpos" then
		--控制区域显示
		local controlpos = NewbieGuideManager.ControlPos[config.data];
		self.ControlRect = controlpos;
		if controlpos == nil then
			print("引导位置为nil值",config.data);
		end
		print("NewbieGuide:CreateShowView",controlpos.pos_x,controlpos.pos_y,controlpos.w,controlpos.h)
		--创建控制
		self.NewbieGuide_view:setTounchControlRect( controlpos.pos_x,controlpos.pos_y,controlpos.w,controlpos.h )
	elseif config.showType == "lightspotEffect" then
		--高量区域
	elseif config.showType == "prompt" then
		
	elseif config.showType == "dialog" then
		--对话
		-- local teststr = {
  --           { color = cc.c3b(255, 255, 255),str = "测试引导提示测试引导提示测试引导提示测试"},
  --           { color = cc.c3b(255, 0, 0),str = "测试"},
  --           { color = cc.c3b(255, 255, 255),str = "测试引导提示测试引导提示测试引导提示测试提示测试引导提示测试"},
  --       }
        local showConfig = NewbieGuidePromptConfig[config.data];
        local view = UIManager:CreatePrompt_Guide( {
            content = showConfig,
            x = config.x,
            y = config.y,
            } )
       	self.NewbieGuide_view:AddPromptView( view );
	elseif config.showType == "openstory" then
		
	end
end


control_NewbieGuide = control_newbieGuide.getInstance( );

return control_newbieGuide;
