--
-- Author: LiYang
-- Date: 2015-07-22 14:49:32
-- BAY技能效果1(远程攻击)普通攻击

local skilleffect_Remote_tower = class("skilleffect_Remote_tower")

function skilleffect_Remote_tower:ctor()
	-- body
end

--[[设置技能数据
	parame = {
		name --技能名称
		release --释放者
		aimData -- 目标
		hurtData --目标伤害数据
	}
]]
function skilleffect_Remote_tower:setData( parame )
	self.Release = parame.release;
	-- self.ReleaseCamp = parame.releaseCamp;
	-- self.AimCamp = parame.aimCamp;
	self.AimData = parame.aimData;
	self.HurtData = parame.hurtData;
	self:analysisData();
	self:CreateAttackEffect();
end

--解析数据
function skilleffect_Remote_tower:analysisData(  )
	--攻击的目标
	local  aiminfo = Data_Battle_Msg:analysisAttackAimProtagonistFirst(self.AimData);
	self.FirstAim = control_Combat:getActorByGuid( aiminfo.aimGuid);
	self.ReleasePos_x,self.ReleasePos_y = self.Release:getCellPos(  );
	self.endPos_x,self.endPos_y = self.FirstAim:getCellPos(  );
	local dir = cc.pSub(cc.p(self.endPos_x,self.endPos_y),cc.p(self.ReleasePos_x,self.ReleasePos_y));
	--判断进攻方向
	local attackDis = self.Release:pointToDir( dir );

	--改变方向
	self.Release:changeDirection( attackDis );

	--获得施法点开始位置
	self.startPoint_x ,self.startPoint_y = self.Release:getSkillCastPostion();
	self.startPoint_y = self.startPoint_y + 70;
end

--创建攻击动作
function skilleffect_Remote_tower:CreateAttackEffect(  )
	-- local actor = control_Combat:getActorByPos(self.Release.);
	
	--重置施法者z位置
	-- self.Release:setActorLocalZOrder( self.FirstAim.Map_x + self.FirstAim.Map_y + 3 )
	
	--执行攻击动作
	-- self.Release:doEvent("event_attack",{Callback = handler(self, self.setAttackEffectListen)});
	
	self:CreateAttackBlowEffect(  );
end

--创建打击效果
function skilleffect_Remote_tower:CreateAttackBlowEffect(  )
	--解析目标数据
	--解析目标计数
	local aimlist ,aimcount = Data_Battle_Msg:analysisAttackAimProtagonist( self.AimData )
	self.EffectCount = aimcount;
	for i,v in ipairs(aimlist) do
		--解析目标
		local aim = control_Combat:getActorByGuid( v.aimGuid);
		if aim then
			--得到坐标位置
			self:CreateFlyingEffect( aim )
		else
			print("施法：" , "目标为nil")
		end
	end 

	AudioManager.playSoundByKey("t_attack")
end

--创建飞行效果
function skilleffect_Remote_tower:CreateFlyingEffect( aim )
	--得到坐标位置
	local x ,y= aim:getBehitPostion();
	--两点距离 得到速度 和角度
	local ccpsubValuse = cc.p(x - self.startPoint_x,y - self.startPoint_y);
	local dist = cc.pGetLength(ccpsubValuse) ;
	local angle = -cc.pToAngleSelf(ccpsubValuse)*180/math.pi;--两点间角度

	local cell_x ,cell_y = Data_Battle.mapData:getWorldToCell( self.startPoint_x ,self.startPoint_y );
	local moveLength = dist;
	local armatureInfo = getAnimateCfgByID( 40001 )
	local play_x = self.startPoint_x;
	local play_y = self.startPoint_y;
	
	self.FlyingEffect = EffectManager:CreateArmature( {
		name = 40001,--效果名称
		x = self.startPoint_x,
		y = self.startPoint_y,
		zorder = cell_x + cell_y + 1,
		isfinishdestroy = true,--是否完成销毁
	} );
	--添加到显示界面
	dispatchGlobaleEvent( "battleDisplay" ,"add" ,{self.FlyingEffect,2 ,nil})
	self.FlyingEffect:setRotation(angle);
	self.FlyingEffect:playAnimationByID( armatureInfo.act_id ,nil ,-1);
	self.FlyingEffect:setCallback(handler(self, self.setAttackEffectListen));--飞行监听
	--执行缩放值
	self.LowerScale = dist / 60;
	
	-- print("执行 CreateFlyingEffect",scale,dist)
	return self.FlyingEffect;
end



--创建伤害效果
function skilleffect_Remote_tower:CreateHurtEffect(  )
	-- self.FirstAim:doEvent("event_behit");
	--震动
	-- dispatchGlobaleEvent( "battleDisplay" ,"shake" ,{0.2});
	-- EffectManager:CreatePiece_Shake_1( 0.2 );
end

--创建伤害逻辑
function skilleffect_Remote_tower:CreateHurtLogic( pos )
	print("CreateHurtLogic",pos)
	Data_Battle_Msg:analysisSkillHurtDataExecuteLogic( self.HurtData , pos ,self.Release);
end

--执行完成逻辑
function skilleffect_Remote_tower:executeFinishLogic(  )
	print("攻击动画执行完成")
	self.Release:doEvent("event_idle");
	self:CreateHurtLogic();
	if self.FinishCallback then
		self.FinishCallback();
	end
end

--设置完成回调函数
function skilleffect_Remote_tower:setFinishCallback( callfun )
	self.FinishCallback = callfun;
end

---------------------------------------------------


--攻击效果回调监听
function skilleffect_Remote_tower:setAttackEffectListen( listenerType,mark,armatureName,movementType ,object )
	print("skilleffect_Remote_tower",listenerType,armatureName,movementType ,object)
	if listenerType == "AnimationEvent" then
		if movementType == ccs.MovementEventType.complete then
			self.EffectCount = self.EffectCount - 1;
			if self.EffectCount < 1 then
				self:executeFinishLogic(  );
			end
		end
	elseif listenerType == "FrameEvent" then
		--帧事件监听
		if movementType == "fly" then
			print("防御塔 fly")
			-- self:CreateHurtEffect(  );
			-- self:CreateHurtLogic();
			self.FlyingEffect:setScaleX(self.LowerScale);
		end
	end
end

return skilleffect_Remote_tower;
