--
-- Author: liYang
-- Date: 2015-06-15 11:40:29
-- 战场服务器数据

--[[监听全局事件名预览
eventModleName: netMsg
eventName:
	tostring(MSG_MS2C_WAR_HOOK_DATA) --挂机战斗数据
]]
local socket = require "socket"
local model_msg = class("model_msg")

--[[
	开始战斗事件 eFDT_Begin
	eventData = {
		eventType = eFDT_Begin
	}
	添加角色事件 eFDT_AddUnit
	eventData = {
		eventType = eFDT_AddUnit,
		executeTime = 12000,--执行时间
		templateID = 1,--模板ID
		guid = "",单位key
		id = 10,单位ID
		x,
		y
	}

	移动事件 eFDT_Move
	eventData = {
		eventType = eFDT_Move,
		id = 10,单位ID
		x,目的地
		y
	}

	移动事件 eFDT_Atk
	eventData = {
		eventType = eFDT_Atk,
		releaseId = 10,施法者ID
		aimId = 10,目标id
		skillId = 10,
		//伤害数据
		hurtData = {
			
		}
	}

	结束事件 eFDT_Block
	eventData = {
		eventType = eFDT_Block,
	}

	战斗结束事件 eFDT_End
	eventData = {
		eventType = eFDT_End,
	}
]]

function model_msg:ctor()
	--场景ID
	-- self.SceneID = 1;
	-- --战场攻击方角色
	-- self.attackcamp = {};
	-- --防守方角色
	-- self.defendcamp = {};
	-- --战斗数据
	-- self.fightData = {};
	-- --战斗结果资料
	-- self.ResultData = {};
	-- --战斗编码
	-- self.BattleCode = 0;
	 -- frompos = v.pos,
    --         mark = 100 + v.pos,
    --         templateid = v.actorID,
    --         isshowname = v.isShowName,
    --         bossmark = v.BossMark,
	--角色测试数据
	self.roleList = {
		-- [1] = { cell_x = 48 ,cell_y = 48 ,camp = 1,actorID = 1 ,isshowname = false,bossmark = false},
	}

	self:_registGlobalEventListeners();
	--数据执行列表
	self.dataList = {
		-- {
		-- 	executeTime = 0;--执行时间
		-- 	unitType = eFDT_AddUnit;--单位类型
		-- 	templateID = 1;--模板ID
		-- 	unitKey = "1";--单位key
		-- 	guid = 1;--单位ID
		-- 	x = 48;
		-- 	y = 44;
		-- },
	};

	--每个记录执行数据
	self.currentEcecuteIndex = 0;

	self.count = 0;

	--执行队列的长度
	self.QueueLen = 1;

	-- self:setTestData();
	--初始化载入
	self.LoadInviData = -1;

	self.startEcecuteTime = nil;
	--数据开始时间
	self.dataStartTime = 0;
	--开始进攻标识
	self.startActTime = -1;
	--资源总数
	self.resourceSumValuse = 1;
	--资源剩余值
	self.resourceSurplusValuse = 0;
	--队伍列表
	self.teamList = {
		-- [1] = {
		-- 	name = "123456",--名称
		-- 	num = 10--人数
		-- }
	}
end

function model_msg:ResetData( event )
	--数据执行列表
	self.dataList = {};
	self.roleList = {};
	--每个记录执行数据
	self.currentEcecuteIndex = 0;

	self.count = 0;
	self.dataStartTime = 0;
	--执行队列的长度
	self.QueueLen = 1;
	--服务器时间(即服务器 和 前端时间差)
	self.ServerTimeD = 0;

	--初始化载入
	self.LoadInviData = -1;

	self.startActTime = -1;

	self.resourceSumValuse = 1;

	self.resourceSurplusValuse = 0;
	--队伍列表
	self.teamList = {
		
	}
end

--注册全局事件监听器
function model_msg:_registGlobalEventListeners()
	self._globalEventListeners = {}
	local configs = {
		--初始化加载的数据
		-- {modelName = "netMsg", eventName = "load_invi_data", callBack=handler(self, self.setLoadInviData)},
		--挂机战斗数据
		{modelName = "netMsg", eventName = tostring(MSG_MS2C_WAR_HOOK_DATA), callBack=handler(self, self.createBattlefieldLogic)},

		--挑战boss战斗数据
		{modelName = "netMsg", eventName = tostring(MSG_MS2C_WAR_BOSS_RESULT), callBack=handler(self, self.createBattlefieldLogic)},
		--奇遇战斗数据
		{modelName = "netMsg", eventName = "qiyu_result", callBack=handler(self, self.createBattlefieldLogic)},
		--好友战斗数据
		{modelName = "netMsg", eventName = "friendfight_result", callBack=handler(self, self.createBattlefieldLogic)},
		--竞技场数据
		{modelName = "netMsg", eventName = "jjc_result", callBack=handler(self, self.createBattlefieldLogic)},
		--军团战战斗数据
		{modelName = "net", eventName = "createBattlefieldLogic_jtz", callBack=handler(self, self.createBattlefieldLogic)},
		--世界boss数据
		{modelName = "battleNetMsg", eventName = "startDo", callBack=handler(self, self.register_event_startDo)},
	}
	self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end

--注册添加执行数据事件
function model_msg:register_event_add( event )

	local  data = event._usedata[1];
	local index = #self.dataList;
	self.dataList[index + 1] = data;
	self.sumEvent = index + 1;
	print("当前收到执行总数:",index,data.index)
end

--[[
	设置战场开始时间
]]
function model_msg:setBattlefieldStartTime( time )
	self.dataStartTime = time;
end

--获得战斗剩余时间
function model_msg:getBattlefieldSurplusTime(  )
	--当前服务器时间
	print(def_CombatInfo.time,g_time,self.LoadInviData,os.time())
	return def_CombatInfo.time - TIME_HELPER:clientTimeToServerTime(os.time()) + self.LoadInviData;
end

--解析战斗开始时间
function model_msg:analysisCombatSchedule( time )
	if self.LoadInviData >= 0 then
		return;
	end
	-- self.LoadInviData = true;
	local data = self.dataList[#self.dataList];
	self:setStartDoEventTime(data.executeTime);
	self.LoadInviData = data.executeTime;
	print("切换到战斗界面:",data.executeTime)
	--进入战斗
	dispatchGlobaleEvent( "battlefield" ,"loadcut");
end

--注册开始执行事件
function model_msg:register_event_startDo( event )

	--标记开始时间
	self.startExecute = true;
	self.currentEcecuteIndex = 1;
end

--执行逻辑
function model_msg:doEventScheduleLogic( time )
	--没有数据执行
	-- self.startEcecuteTime = self.startEcecuteTime + time * 1000;
	-- print("doEventScheduleLogic:",self.startEcecuteTime,self.startExecute)

	--获得当前服务器时间
	self.startEcecuteTime = TIME_HELPER:clientTimeToServerTime( socket.gettime() )
	--没有开始执行
	if not self.startExecute then
		return;
	end
	--判断是否有执行数据
	local exData = self.dataList[self.currentEcecuteIndex];
	-- if exData then
	-- 	print(exData,exData.executeTime,exData.eventType)
	-- end
	while exData and self.startEcecuteTime >= exData.executeTime do
		print("执行数据:",self.startEcecuteTime,exData.eventType)
		self:eventLogic( exData );
		self.currentEcecuteIndex = self.currentEcecuteIndex + 1;
		exData = self.dataList[self.currentEcecuteIndex];
		
	end
	-- print("doEventScheduleLogic:",self.currentEcecuteIndex)
end

--[[
	战斗回放执行逻辑
]]
function model_msg:doEventScheduleLogic_VCR( time )
	--没有数据执行
	-- self.startEcecuteTime = self.startEcecuteTime + time * 1000;
	-- print("doEventScheduleLogic:",self.startEcecuteTime,self.startExecute)

	--获得当前服务器时间
	self.startEcecuteTime = self.startEcecuteTime + time;
	--没有开始执行
	if not self.startExecute then
		return;
	end
	--判断是否有执行数据
	local exData = self.dataList[self.currentEcecuteIndex];
	while exData and self.startEcecuteTime >= exData.executeTime do
		-- print("执行数据:",self.startEcecuteTime,exData.eventType)
		self:eventLogic( exData );
		self.currentEcecuteIndex = self.currentEcecuteIndex + 1;
		exData = self.dataList[self.currentEcecuteIndex];
		
	end
	-- print("doEventScheduleLogic:",self.currentEcecuteIndex)
end

--设置开始执行时间
function model_msg:setStartDoEventTime( time )
	self.startEcecuteTime = time;
	self.timer = socket.gettime();
	if Data_Battle:getBattlefieldType(  ) == Data_Battle.CONST_BATTLE_TYPE_VCR then
		self.startEcecuteTime = self.dataStartTime;
		self.do_Scheduler = GLOBAL_SCHEDULER:scheduleScriptFunc(
            handler(self, self.doEventScheduleLogic_VCR),
            0, 
            false
    	)
	else
		self.do_Scheduler = GLOBAL_SCHEDULER:scheduleScriptFunc(
            handler(self, self.doEventScheduleLogic),
            0, 
            false
    	)
	end
	
end


--[[设置战场执行时间
]]
function model_msg:setBattlefieldExecuteTime( time )
	if Data_Battle:getBattlefieldType(  ) == Data_Battle.CONST_BATTLE_TYPE_ROB then
		--进攻领地
		-- self.ServerTimeD = 
	else
		self.ServerTimeD = time - os.time();
	end
end

function model_msg:getBuildTemplateID( msgType,id )
	local buildType = 0;
	if msgType == eFUT_Shelter then
		buildType = 1;
	elseif msgType == eFUT_Build then
		buildType = 2;
	end
	return 1000 * buildType + id
end

function model_msg:getObjectCamp( msgType )
	if msgType == 1 then
		return Data_Battle.CONST_CAMP_ATTACK;
	else
		return Data_Battle.CONST_CAMP_DEFEND;
	end
	
end

--[[获得服务器执行时间
	time 服务器返回的毫秒相差数
]]
function model_msg:getServerExecuteTime( time )
	return self.dataStartTime + time / 1000;
end


function model_msg:eventLogic( data )
	--添加角色事件
	if data.eventType == eFDT_AddUnit then
		if data.unitType == eFUT_Monster or data.unitType == eFUT_Soldier then
			print("添加士兵:",data.guid,data.templateID)
			local soldierInfo = {
		        cell_x = data.x,
		        cell_y = data.y,
		        camp = self:getObjectCamp( data.camp ),
		        playname = data.playername;
		        guid = data.guid,
		        actorID = data.templateID,
		        isshowname = false,
		        bossmark = false,
		    }
		    self:refreshPlayerList( data.playername );

    		dispatchGlobaleEvent("battlefield", "add_soldier", {soldierInfo});
		elseif data.unitType == eFUT_Shelter or data.unitType == eFUT_Build then
			--建筑
			dispatchGlobaleEvent("battlefield", "add_build", {{
				cell_x = data.x,
				cell_y = data.y,
				guid = data.guid,
				camp = self:getObjectCamp( data.camp ),
				playname = data.playername;
				iscreate = false,
				templeateId = self:getBuildTemplateID( data.unitType,data.templateID ) 
				}});
		end
		
	elseif data.eventType == eFDT_Move then --执行移动事件
		dispatchGlobaleEvent("battlefield", "move_soldier", {data});
	elseif data.eventType == eFDT_Atk then --执行攻击事件事件
		dispatchGlobaleEvent("battlefield", "attack", {data});
	elseif data.eventType == eFDT_Begin then
		--开始执行
	elseif data.eventType == eFDT_Do then
		self.startActTime = 0;
		self.LoadInviData = TIME_HELPER:clientTimeToServerTime( os.time());
		print("战斗日志==>开始时间:",self.LoadInviData)
		dispatchGlobaleEvent("battle_ui_time", "update", {def_CombatInfo.time - self.LoadInviData});
	elseif data.eventType == eFDT_End then
		--执行结束
		GLOBAL_SCHEDULER:unscheduleScriptEntry(self.do_Scheduler);
		self.startActTime = -1;
		self.startExecute = false;
		if Data_Battle.BattleType == Data_Battle.CONST_BATTLE_TYPE_VCR then
			--显示结果
			dispatchGlobaleEvent("battlefield", "create_result", {nil,Data_Battle_Msg.VCRResult});
		end
	end
end

--[[
	添加玩家
]]
function model_msg:addPlayer( data )

	if not self.teamList[data.name] then
		self.teamList[data.name] = data;
		dispatchGlobaleEvent("controler_battle_ui_attack_bottom", "update_player", data);
	end
	
end

--[[
	刷新玩家列表列表
]]
function model_msg:refreshPlayerList( playname )
	if self.teamList[playname] then
		self.teamList[playname].num = self.teamList[playname].num - 1;
		--刷新显示
		dispatchGlobaleEvent("controler_battle_ui_attack_bottom", "update_player", self.teamList[playname]);
	end
	
end


--得到回合数据
function model_msg:get_BattleBoutData( Schedule , boutcount )
	return self.fightData[Schedule][boutcount];
end

--保存资料
function model_msg:SaveBattleData( battleData )
	--保存角色资料
	local roleStrData = serialize(battleData);
	local path = string.gsub(device.writablePath, "[\\\\/]+$", "") .. "/BattleData.txt";
	ManageResUpdate:writeFile(path, roleStrData);

end

--添加战斗的执行数据
function model_msg:addExecuteFightData( data )
	if self.currentEcecuteIndex + self.QueueLen == self.count then
		print("数据执行队列满了")
		return;
	end
	self.count = self.count + 1;
	self.dataList[self.count] = data;
end

function model_msg:removeFightData( index )
	self.dataList[index] = nil;
end

--更新执行数据
function model_msg:updateExecuteData(  )
	--清除显示的数据
	self.dataList[self.currentEcecuteIndex] = nil;
	self.currentEcecuteIndex = self.currentEcecuteIndex + 1;
end

--得到当前战斗数据
function model_msg:getCurrentFightData()
	if not self.dataList[self.currentEcecuteIndex] then
		print("战斗资料出错",self.currentEcecuteIndex);
	end
	return self.dataList[self.currentEcecuteIndex];
end


--特殊逻辑参数
--[[
	params = {
		TypeId = 10, --逻辑ID
		buffData = nil,--buf伤害数据
		skillHurtData = nil, -- 技能伤害数据
	}
]]
model_msg.SpecialLogicConfig = {};

--执行被动buf特殊逻辑
--一些因为后端逻辑执行先后顺序 和前端表现顺序产生错误后的 特殊处理
function model_msg:ExecuteSpecialLogic( params )
	if params.TypeId == 1726 then
		-- --治疗共享
		-- local gxActor = params.buffData.affectAim[1]
		-- if not gxActor then
		-- 	return;
		-- end
		-- -- gxActor.aimcamp = aimcamp;
		-- -- gxActor.aimpos = aimpos;
		-- -- gxActor.hurtvaluse = hurtvaluse;
		-- -- gxActor.hp = hp;
		-- -- local actorID = gxActor.;--资料的角色ID
		-- for k,v in pairs(params.skillHurtData) do
		-- 	if v and v.aimcamp == gxActor.aimcamp and v.aimpos == gxActor.aimpos  then
		-- 		-- v.aimcamp = aimcamp;
		-- 		-- v.aimpos = aimpos;
		-- 		-- v.aimtype = aimtype;
		-- 		-- v.bufID = bufID;
		-- 		-- v.miss = miss;
		-- 		-- v.crit = crit;
		-- 		-- v.hurtvaluse = hurtvaluse;
		-- 		gxActor.hp = v.Hp;
		-- 		v.Hp = v.Hp - gxActor.hurtvaluse;
		-- 		return;
		-- 	end
		-- end
	elseif params.TypeId == 1711 then
		--[[反击
			1.如果伤害者目标 有施法者则血量对换
		]]
		--行动数据
		local actiondata = params.actionData;
		local gxActor = params.buffData.affectAim[1];
		
		for k,v in pairs(params.skillHurtData) do
			--检验伤害者资料里面是否有攻击者
			if v and v.aimcamp == actiondata.attackcamp and v.aimpos == actiondata.pos  then
				
				gxActor.Hp = v.Hp;
				v.Hp = v.Hp - gxActor.hurtvaluse;
				print("ExecuteSpecialLogic:",gxActor.Hp,v.Hp)
				return;
			end
		end
	elseif params.TypeId == 1710 then
		-- --伤害转换为治疗
		-- local gxActor = params.buffData.affectAim[1]
		-- if not gxActor then
		-- 	return;
		-- end
		-- local isDelet = false;
		-- for k,v in pairs(params.skillHurtData) do
		-- 	if v and v.aimcamp == gxActor.aimcamp and v.aimpos == gxActor.aimpos  then
		-- 		if v.Hp <= 0 then
		-- 			isDelet = true;
		-- 		end
		-- 		break;
		-- 	end
		-- end
		-- -- buf.releasecamp = aimcamp;--施法者阵营
		-- -- buf.releasepos = aimpos;
		-- if not isDelet then
		-- 	return;
		-- end
		-- local markpos = 0;
		-- for k,v in pairs(params.skillHurtData) do
		-- 	if v and v.buffData then
		-- 		for j,k in pairs(v.buffData) do
		-- 			if k and k.bufID == 1710 and 
		-- 				k.releasecamp == params.buffData.releasecamp and 
		-- 				k.releasepos == params.buffData.releasepos then
		-- 				v.buffData[j] = nil;
		-- 				v.bufcount = v.bufcount - 1;
		-- 				-- markpos = j;
		-- 				return;
		-- 			end
		-- 		end
		-- 	end
		-- end
	end
end

--得到战斗局数据
function model_msg:getCombatInningData( index )
	return self:getCurrentFightData().fightData.InningsData[index];
end

--[[得到回合数据
]]
function model_msg:getBoutData( inningindex , boutindex )
	local inningdata = self:getCombatInningData( inningindex );
	if not inningdata then
		return nil;
	end
	return inningdata.boutData[boutindex];
end

--转换阵营数据
function model_msg:ConvertCampData( msgcamp )
	local Camp = Data_Battle.CONST_CAMP_ENEMY;
	if msgcamp == 1 then
		Camp = Data_Battle.CONST_CAMP_PLAYER;
	end
	return Camp;
end

--解析
function model_msg:analysisAttackAimProtagonistCount( msgdata )
	local count = 0;
	for k,v in pairs(msgdata) do
		if v.aimtype == 1 then
			count = count + 1;
		end
	end
	return count;
end

--解析攻击的主目标
function model_msg:analysisAttackAimProtagonist( msgdata )
	local count = 0;
	local aimlist = {};
	for k,v in pairs(msgdata) do
		if v.aimtype == 1 then
			count = count + 1;
			aimlist[count] = v;
		end
	end
	return aimlist , count;
end

--[[解析攻击主要目标的第一个
	主要用于单对单 技能
]]
function model_msg:analysisAttackAimProtagonistFirst( msgdata ,executeMark)
	for k,v in pairs(msgdata) do
		--表示是被动技能资料
		if executeMark == 3 then
			return v;
		end
		if v.aimtype == 1 then
			return  v ;
		end
	end
	return nil;
end

function model_msg:analysisAttackAimBy( msgdata ,pos )
	for i,v in ipairs(msgdata) do
		--解析目标
		if pos == v.aimpos then
			local Camp = self:ConvertCampData( v.aimcamp );
			local hurtAim = control_Combat:getActorByPos( v.aimpos , Camp);
			return hurtAim
		end
	end
	return nil;
end

--[[解析伤害类型
	1 普通伤害
	2 暴击伤害
	3 miss
]]
function model_msg:analysisHurtType( msgdata)
	--解析伤害类型

	local hurttype = 1;
	if msgdata.crit > 0 then
	 	--暴击
	 	hurttype = 2;
	end
	if msgdata.miss > 0 then
	 	--miss
	 	hurttype = 3;
	end
end

-- function model_msg:analysisHurtDataExecute( ... )
-- 	-- body
-- end


--[[解析技能伤害数据执行逻辑
	msgdata 伤害数据
	pos [数据对象 nil将全部执行]
]]
function model_msg:analysisSkillHurtDataExecuteLogic( msgdata , pos, release)
	--执行伤害逻辑
	local function isexecute( aimpos )
		if not pos then
			return true;
		else
			if pos == aimpos then
				return true;
			end
		end
	end
	for i,v in ipairs(msgdata) do
		--解析目标
		local isexecute = isexecute( v.aimpos );
		local hurtAim = control_Combat:getActorByGuid( v.aimGuid );
		print("analysisSkillHurtDataExecuteLogic:",v.aimGuid,v.Hp,v.hurtvaluse)
		if hurtAim and (not hurtAim:isDead()) and isexecute then
			hurtAim:setHPDisplayTime(  );
			if v.hurtvaluse ~= 0 or v.miss > 0 then
				--解析伤害类型
				local hurttype = 1;
				if v.crit > 0 then
				 	--暴击
				 	hurttype = 2;
				end
				if v.miss > 0 then
				 	--miss
				 	hurttype = 3;
				end
				-- HurtPromptManager:AddPromptObject( {
				-- 	hurtType = hurttype, --类型(比如暴击，普通伤害 ,miss)
				-- 	release = release, --施法者
				-- 	aim = hurtAim, -- 目标
				-- 	valuse = v.hurtvaluse, -- 值
				-- } );
				--设置剩余血量
				if v.Hp == -1 then
					hurtAim:UpDataCurrentHp( v.hurtvaluse ,v.isDead);
				else
					hurtAim:updata_hp(v.Hp);
				end
			end

			------------------目标添加buff-------------------------
			-- if v.newsbuff and v.newsbuff > 0 then
			-- 	--执行buf数据
			-- 	print("--LY--313:commonAttack-------------> 添加buff:",v.bufID);
			-- 	-- EffectManager.CreateBuffEffect({
			-- 	-- 	aim = BattleManager:getActorView( hurtdata),--buff作用目标
			-- 	-- 	skillID = v.bufID,--buffID
			-- 	-- 	});
			-- end
		end
		if isexecute and pos then
			return;
		end
	end
end

function model_msg:analysisBufHurtDataExecuteLogic( msgdata , pos, release )
	print("model_msg:analysisBufHurtDataExecuteLogic")
	--执行伤害逻辑
	local function isexecute( aimpos )
		if not pos then
			return true;
		else
			if pos == aimpos then
				return true;
			end
		end
	end

	for i,v in ipairs(msgdata) do
		--解析目标
		local isexecute = isexecute( v.aimpos );
		local Camp = self:ConvertCampData( v.aimcamp );
		local hurtAim = control_Combat:getActorByPos( v.aimpos , Camp);
		if hurtAim and (not hurtAim:isDead()) and isexecute then
			if v.hurtvaluse ~= 0 then
				---------------------伤害提示---------------------
				print(v.miss,v.hurtvaluse,v.IsHurt)
				--解析伤害类型
				local hurttype = 1;
				-- print("buf执行伤害逻辑--->" ,hurttype ,v.hurtvaluse);
				--添加伤害提示
				HurtPromptManager:AddPromptObject( {
					hurtType = hurttype, --类型(比如暴击，普通伤害 ,miss)
					release = release, --施法者
					aim = hurtAim, -- 目标
					valuse = v.hurtvaluse, -- 值
				} );
				--更新角色HP进度
				-- print("角色血量---------------------",v.Hp)
				--设置剩余血量
				if v.Hp == -1 then
					hurtAim:UpDataCurrentHp( v.hurtvaluse ,v.isDead);
				else
					hurtAim:updata_hp(v.Hp);
				end
			end

			-- ------------------目标添加buff-------------------------
			-- if v.bufID > 0 then
			-- 	--执行buf数据
			-- 	print("伤害-------------> 添加buff:",v.bufID);
			-- 	bufManager:CreateBuf({
			-- 		aim = hurtAim,--buff作用目标
			-- 		skillID = v.bufID,--buffID
			-- 		});
			-- end
		end
		if isexecute and pos then
			return;
		end
	end
end

--解析战斗资源数据
function model_msg:analysisBattleDataRes( data )
	--解析角色数据

end

--[[
	初始化每局资源
	data 目标数据
	inning 局数
	operation 操作函数
]]
function model_msg:analysisInviInningsRes( data , inning ,operation)
	local inningdata = data.fightData.InningsData[inning];
	--初始化角色资源(入场 idle)
	--攻击方
	local attackcampActor = data.attackcamp[inningdata.AttackTeamId];
	for k,v in pairs(attackcampActor.FirstList) do
		-- print("model_msg:analysisInviInningsRes",v.actorID,inningdata.AttackTeamId)
		if v.actorID > 0 then
			local reslist ,armaturelist = ManagerBattleRes:analysisActorActionRes( v.actorID ,Data_Battle.CONST_CAMP_PLAYER , "entrance" );
			-- print("model_msg:analysisInviInningsRes",table.nums(armaturelist))
			ManagerBattleRes:addDynamicRes( reslist ,armaturelist,operation);
			reslist,armaturelist = ManagerBattleRes:analysisActorActionRes( v.actorID ,Data_Battle.CONST_CAMP_PLAYER , "idle" );
			ManagerBattleRes:addDynamicRes( reslist ,armaturelist,operation);
		end
	end
	--防守方
	local defendcampActor = data.defendcamp[inningdata.DefendTeamId];
	for k,v in pairs(defendcampActor.FirstList) do
		-- print("model_msg:analysisInviInningsRes",v.actorID,inningdata.DefendTeamId)
		if v.actorID > 0 then
			local reslist,armaturelist = ManagerBattleRes:analysisActorActionRes( v.actorID ,Data_Battle.CONST_CAMP_ENEMY , "entrance" );
			ManagerBattleRes:addDynamicRes( reslist ,armaturelist,operation);
			reslist ,armaturelist = ManagerBattleRes:analysisActorActionRes( v.actorID ,Data_Battle.CONST_CAMP_ENEMY , "idle" );
			ManagerBattleRes:addDynamicRes( reslist ,armaturelist,operation);
		end
	end
	--解析回合数据
	for i,v in ipairs(inningdata.boutData) do
		self:analysisBoutRes( data , v ,operation);
	end
end

--[[解析回合资源
	data 局数据
	boutData 回合数据
]]
function model_msg:analysisBoutRes( data ,boutData ,operation)
	for i,v in ipairs(boutData.actionData) do
		local skillID = v.skillID;
		local releasecamp = self:ConvertCampData( v.attackcamp )
		-- attackcamp = 1,
		-- pos = 1,
		local templeID = self:analysisAimActor( data ,v.pos , releasecamp );
		local reslist,armaturelist = ManagerBattleRes:analysisSkillIDRes( skillID , templeID ,releasecamp);
		ManagerBattleRes:addDynamicRes( reslist ,armaturelist,operation);
	end
end

--解析回合释放的资源
function model_msg:analysisBoutDestroyRes( boutData )
	
end

--解析每局释放的资源
function model_msg:analysisInningsDestroyRes( inning )
	
end

--[[解析目标角色
	data 数据
	pos 位置 
	camp 阵营
]]
function model_msg:analysisAimActor( data , pos , camp )
	local actorlist = nil;
	if camp == Data_Battle.CONST_CAMP_PLAYER then
		actorlist = data.attackcamp;
	else
		actorlist = data.defendcamp;
	end
	for i,v in ipairs(actorlist[1].FirstList) do
		if v.pos == pos then
			return v.actorID;
		end
	end
	return nil;
end



return model_msg


