--
-- Author: lipeng
-- Date: 2015-10-15 10:44:50
-- 提示管理

local model_tipManager = class("model_tipManager")


function model_tipManager:ctor()
	self:_initModels()
end

function model_tipManager:_initModels()
	self._tipMap = {
		--[[
			需要客户端改变的状态
		]]
		-------聊天相关-------
		["char_world"] = 0,
		["char_guild"] = 0,
		["char_team"] = 0,
		["char_friend"] = 0,
		["char_system"] = 0,
		["char_news"] =0,
		["guild_news"] = 0,
		--武将是否有合成(0 没有; 1 有)
		-- ["wj_hc"] = 0,
		-- --装备是否有更换(0 没有; 1 有;)
		-- ["zb_gh"] = 0,
		-- --阵位是否有新的开放(0 没有; 1 有)
		-- ["zx_open"] = 0,
		-- --背包是否已满(0 没有; 1 有)
		-- ["bb_full"] = 0,
		-- --神器是否可合成(0 没有; 1 有)
		-- ["sq_hc"] = 0,

		--[[
			需要服务器改变的状态
		]]
		--奇遇条数是否已满(0 没有; 1 有)
		-- ["qy_tsym"] = 0,
		-- --奇遇是否有新的复仇(0 没有; 1 有)
		-- ["qy_fc"] = 0,
		-- --熔炼的兑换列表刷新次数是否已满(0 没有; 1 有)
		-- ["rl_sxcs"] = 0,
		-- --雇佣是否有佣兵(0 没有; 1 有)
		-- ["gy_wyb"] = 0,
		-- --军团进攻次数是否已满(0 没有; 1 有)
		-- ["jt_jgcs"] = 0,
		-- --军团是否有人申请军团(0 没有; 1 有)
		-- ["jt_sq"] = 0,
		-- --商店是否有免费武将招募次数(0 没有; 1 有)
		-- ["sd_mf_wj_zm"] = 0,
		-- --竞技场次数是否已满(0 没有; 1 有)
		-- ["jjc_csym"] = 0,
		-- --钢铁征途通关奖励是否领取(0 没有; 1 有)
		-- ["gtzt_jllq"] = 0,
		-- --钢铁征途Boss进攻次数是否已满(0 没有; 1 有)
		-- ["gtzt_boss_jgcs"] = 0,
		-- --活动是否有次数(0 没有; 1 有)  暂无此功能
		-- ["hd_cs"] = 0,
		-- --活动世界BOSS是否开放(0 没有; 1 有)  暂无此功能
		-- ["hd_worldBoss"] = 0,
		-- --活动: 是否有: 可签到或补签(0 没有; 1 有)
		-- ["hd_qd"] = 0,
		-- --福利: 是否有  可购买的VIP礼包但没有购买(0 没有; 1 有)
		-- ["fl_vip_lb"] = 0,
		-- --福利: 是否有  月卡可领取(0 没有; 1 有)
		-- ["fl_yk"] = 0,
		-- --福利: 是否有  补给可领取(0 没有; 1 有)
		-- ["fl_bj"] = 0,
		-- --任务: 是否有  完成了但没有领取奖励的任务(0 没有; 1 有)
		-- ["rw_wc"] = 0,
		-- --好友: 是否有  好友申请(0 没有; 1 有)
		-- ["hy_sq"] = 0,
		-- --邮件: 是否有  未读邮件(0 没有; 1 有)
		-- ["yj_noReadMail"] = 0
		
	}
end


function model_tipManager:updateTipsWithServerMsg( msgData )
	--没有用clone方式  因为有的数据是客户端进行改变的
	local tipsInfo = msgData.tipsInfo
	for k,v in pairs(tipsInfo) do
		if self._tipMap[k] ~= nil then
			self._tipMap[k] = v
		end
	end

	dispatchGlobaleEvent("model_tipManager", "tipStateChange")
end


--设置提示状态
function model_tipManager:setTipState( tipID, state )
	if self._tipMap[tipID] ~= state then
		self._tipMap[tipID] = state
	end
	print("model_tipManager:setTipState",tipID,state)
	dispatchGlobaleEvent("model_tipManager", "tipStateChange")
end

--获取提示状态
function model_tipManager:getTipState( tipID )
	return self._tipMap[tipID]
end


return model_tipManager



