--
-- Author: 游戏数据操作管理
-- Date: 2015-06-26 17:47:00
-- 登录数据

local model_Login = class("model_user")

model_Login.GameSaveKey = {
	KEY_LOGIN_ACCOUNT = "key_login_account",
	KEY_LOGIN_PASSWORD = "key_login_password",
	KEY_LOGIN_TOKEN = "key_login_token",
	KEY_LOGIN_FIGURE_ID = "key_login_figure_id",
	KEY_LOGIN_CHOOSE_SERVER = "key_login_choose_server",
	KEY_STATE_SOUND = "key_state_sound",
	KEY_STATE_MUSIC = "key_state_music",
	KEY_GSERVER = "key_recover_server",
	KEY_OPERATE_PLAY = "key_operate_play",
	KEY_MAPCACHE_DATA = "key_mapcache_data",
}

function model_Login:ctor()
	--保存资料池
	self.SaveDataList = {};

	--登录IP
	self.LS_IP = "www.urbanmarginal.com"; --192.168.0.208 112.74.68.206
	--登录端口
	self.LS_PORT = 10001;

	--登陆操作判断 1 正常登陆 2 账号切换 3 账号注册
	self.Logic_Operation = 1;

	--服务器列表信息
	self.ServerList = {
		[1] = {name = "一区 乱世天下" ,IP="120.55.98.203",Port=12000,state = 4,id=10000,},
	};
	self.chooseserver = 1;

	self.chooseGameServer = 20001;

	--记录选择服务器列表
	self.RECOVERY_SERVER_LIST = {0,0,0};

	self.account = "";
	self.password = "";

	self.userID = "";
	self.token = "";
	--账户登录方式 0 账号 ，1 手机 , 6 360登录, 7 uc, 4 当乐 
	self.login_type = 0;
	--判断是否是重连状态
	self.ResumeConnect = false;

	self.qihuID = "";

	--服务器显示类型 1 内网 2 外网
	self.ServerShowType = 1

	self.CurrentVersion = "";

	--支付行为
	self.record_playTime = 0;
	--操作行为
	self.record_operate = os.time();

	self.receiveLoginInfo = {};
end

function model_Login.getInstance()
	if model_Login.instance == nil then
		model_Login.instance = model_Login.new()
	end
	return model_Login.instance
end

--初始化数据
function model_Login:InviData()
	--读取数据
	self:LoadGameData(  );
	--初始化服务器列表
	--UpDataMsLogic( self.ServerShowType );
	-- for i,v in ipairs(GAME_SERVER_LIST) do
	-- 	self.ServerList[i] = v;
	-- end
	--登陆服务器IP
	-- self.LS_IP = LS_IP;
	-- -- --登陆服务器埠
	-- self.LS_PORT = LS_PORT;

	--读取存储数据
	self.account = self.SaveDataList[self.GameSaveKey.KEY_LOGIN_ACCOUNT];
	self.password = self.SaveDataList[self.GameSaveKey.KEY_LOGIN_PASSWORD];
	self.chooseserver = self.SaveDataList[self.GameSaveKey.KEY_LOGIN_CHOOSE_SERVER] or 1;
	if not self.ServerList[self.chooseserver] then
		self.chooseserver = 1;
	end
	self.CurrentVersion = "0.0.1.0.0.1" --GAME_VERSION_INFO_NAME.."."..GAME_CURRENT_VERSION_INFO_NAME;
	-- self.CurrentVersion = "1.0.6.0.3.6"
	--音效设置
	AudioManager.AMSOUND = self.SaveDataList[self.GameSaveKey.KEY_STATE_SOUND] or 1;
	AudioManager.AMMUSIC = self.SaveDataList[self.GameSaveKey.KEY_STATE_MUSIC] or 1;
	--上次选择的服务器
	self.RECOVERY_SERVER_LIST[1] = self.SaveDataList[self.GameSaveKey.KEY_GSERVER.."1"];
	self.RECOVERY_SERVER_LIST[2] = self.SaveDataList[self.GameSaveKey.KEY_GSERVER.."2"];
	self.RECOVERY_SERVER_LIST[3] = self.SaveDataList[self.GameSaveKey.KEY_GSERVER.."3"];
	for i,v in ipairs(self.RECOVERY_SERVER_LIST) do
		if not self.ServerList[v] then
			table.remove(self.RECOVERY_SERVER_LIST, i)
		end
	end
	self.record_playTime = self.SaveDataList[self.GameSaveKey.KEY_OPERATE_PLAY] or os.time();
	-- print("model_Login:InviData",self.LS_IP,self.LS_PORT,self.account,self.password,self.CurrentVersion)
end


--保存用户数据
function model_Login:saveToLocal()
	self.SaveDataList[self.GameSaveKey.KEY_STATE_SOUND] = AudioManager.AMSOUND
	self.SaveDataList[self.GameSaveKey.KEY_STATE_MUSIC] = AudioManager.AMMUSIC
	self.SaveDataList[self.GameSaveKey.KEY_GSERVER.."1"] = self.RECOVERY_SERVER_LIST[1]
	self.SaveDataList[self.GameSaveKey.KEY_GSERVER.."2"] = self.RECOVERY_SERVER_LIST[2]
	self.SaveDataList[self.GameSaveKey.KEY_GSERVER.."3"] = self.RECOVERY_SERVER_LIST[3]
	self.SaveDataList[self.GameSaveKey.KEY_LOGIN_ACCOUNT] = self.account;
	self.SaveDataList[self.GameSaveKey.KEY_LOGIN_PASSWORD] = self.password;
	self.SaveDataList[self.GameSaveKey.KEY_LOGIN_CHOOSE_SERVER] = self.chooseserver;
	self.SaveDataList[self.GameSaveKey.KEY_OPERATE_PLAY] = self.record_playTime;
	local savestring = serialize(self.SaveDataList)
	cc.UserDefault:getInstance():setStringForKey("gamesavedata", savestring);
end

function model_Login:LoadGameData(  )
	
	local datastr = cc.UserDefault:getInstance():getStringForKey("gamesavedata");
	self.SaveDataList = unserialize(datastr);
	if not self.SaveDataList  then
		self.SaveDataList = {};
	end
	for k,v in pairs(self.SaveDataList) do
		printInfo("saveData:%s %s",k,v)
	end
end

--记录选择的服务器
function model_Login:RecordChooseServer()
	
	for i=1,3 do
		if self.RECOVERY_SERVER_LIST[i] == self.chooseserver then
			table.remove(self.RECOVERY_SERVER_LIST, i)
			break
		end
	end
	table.insert(self.RECOVERY_SERVER_LIST, 1, self.chooseserver)
	
end

--得到选择服务器信息
function model_Login:getChooseServerData(  )
	-- local data = self.ServerList[self.chooseserver]
	-- if not data then
	-- 	printInfo("ChooseServerData nil");
	-- end
	return self.receiveLoginInfo.IP ,self.receiveLoginInfo.Port;
end

--得到选择服务器信息
function model_Login:getChooseServerDescribe(  )

	local data = self.ServerList[self.chooseserver]
	
	return data;
end

--得到服务器选择的颜色值
function model_Login:getServerStateColour( state )
	local statevaluse = "server_state_"..state;
	return GLOBAL_COLOUR_VALUSE[statevaluse];
end


Data_Login = model_Login.getInstance();

return model_Login;
