--
-- Author: Li yang
-- Date: 2015-11-04 14:04:14
-- 排行榜管理类

local model_RankingManager = class("model_RankingManager")

local rankclass = import(".ranking")

--战力榜
model_RankingManager.CONST_RANKING_POWER = RT_FC;
--等级榜
model_RankingManager.CONST_RANKING_GRADE = RT_LV;
--财富榜
model_RankingManager.CONST_RANKING_WEALTH = RT_GOLD;

function model_RankingManager:ctor()
	--排行榜池
	self.RecordPool = {};
	self.RecordPool[self.CONST_RANKING_POWER] = {};
	self.RecordPool[self.CONST_RANKING_GRADE] = {};
	self.RecordPool[self.CONST_RANKING_WEALTH] = {};
	self.RecordRanking = 5;--榜单记录条数

	--排行榜总数
	self.RankingSum = 0;
end

--添加
function model_RankingManager:addData( data )
	self.RecordPool[data.RankingType][data.CurrentPage] = data ;
end


--得到排行榜数据
function model_RankingManager:getRanking( rankType ,page )
	
	return self.RecordPool[rankType][page];
end

--创建一个排行榜
function model_RankingManager:CreateRanking( rankType ,page )
	local rank = rankclass.new();
	rank:setRankingType( rankType ,page);
	return rank;
end

--得到排行榜自己的位置
function model_RankingManager:getRankingOneselfLocation( rankType )
	local OneselfInfo = MAIN_PLAYER.baseAttr:getName();
	local checkData = self.RecordPool[rankType];
	print(rankType , checkData);
	for i,v in ipairs(checkData) do
		local pageData = v;
		for j,k in ipairs(pageData.RecordPool) do
			if k.roleName == OneselfInfo then
				return k.Ranking;
			end
		end
	end
	return "100+";
end

function model_RankingManager:requestRankData( rankType )
	print("排行榜数据",rankType)
	local rankData = self:getRanking( rankType ,1 );
	if not rankData then
		printInfo("网路日志 发送请求排行榜数据 MSG_C2MS_GET_RANK", rankType,1)
		gameTcp:SendMessage(MSG_C2MS_GET_RANK,{
			rankType,
			1
		})
	else
		--更新排行榜种类信息
		dispatchGlobaleEvent("netMsg", tostring(MSG_MS2C_RANK_RE),{rankType,#self.RecordPool[rankType]});
	end
	
end


--清空邮件
function model_RankingManager:ClearData(  )
	-- self.RecyclePool = self.RecordPool;
	self.RecordPool = {};
	self.RecordPool[self.CONST_RANKING_POWER] = {};
	self.RecordPool[self.CONST_RANKING_GRADE] = {};
	self.RecordPool[self.CONST_RANKING_WEALTH] = {};
end

return model_RankingManager;
