--
-- Author: lipeng
-- Date: 2015-07-01 13:58:16
-- 玩家基本属性

local model_playerBaseAttr = class("model_playerBaseAttr")

--[[发送全局事件名预览
eventModleName: model_playerBaseAttr
eventName: 
	nameChange --玩家名字改变
	goldChange --银两改变
	yuanBaoChange --元宝改变
	tiLiChange --体力改变
	jingLiChange --精力改变
	expChange  --经验改变
	vipLvChange --VIP等级改变
]]

--[[监听全局事件名预览
eventModleName: netMsg
eventName:
	tostring(MSG_MS2C_ROLE_UPDATA_GOLD)
]]


function model_playerBaseAttr:ctor()
	-- self._tiLi = 0 --体力
	-- self._jingLi = 0 --精力
	self._name = "" --名字
	self._sex = 1 --性别
	self._headid = 1 --头像id
	self._gold = 0 --游戏币
	self._yuanBao = 0 --元宝
	self._exp = 0 --当前经验
	self._vipLv = 0 --vip等级
	self._guid = "" --guid
	self._numID = 1 --数字id
	self._headGUid = "";--头像GUID
	-- self._jianghun = 1 --将魂
	-- self._jingyanchi = 0 --存储武将经验的经验池
	self._lv = 0 -- 角色等级
	self._post = 1 --职位 2 副会长 3成员
	-- self._Title = 0 -- 角色爵位
	-- self._TitleExp = 0 -- 角色爵位经验
	-- self._AtkTime = 0 -- 进攻次数
	-- self._AtkTimeBuy = 0 -- 购买进攻次数
	-- self._ronglianzhi = 0 -- 熔炼值
	-- self._gyStrID = "" --已雇佣的玩家ID
	-- self._tuiguang = 1;--推广次数更新
	self._LoctionJNIInfo = "";
	--106.53884,29.580044 (观音桥)
	--106.512106,29.574641 (鸿恩寺)
	--106.525868,29.546366 大坪
	self._LoctionInfo = {
		Longitude = 106.594868,--116.434739,--106.499947,106.581886,29.564212
		Latitude = 29.546366,--39.911836,--29.685241,
		Direction = 0,
		CityCode = 132,
		City = "重庆",
		AddrStr = "重庆观音桥",
	}
	self._MapTile_x = -1;--玩家当地地图坐标
	self._MapTile_y = -1;
	self._playerMoveCell = 0;
	self._playerTileData = require("app.models.player.map.TileInfo.lua").new();
	self._refreshPlayerPos = false;
	self.LocationInfoFile = EQUIPMENT_UPDTE_PATH.."LocationInfo.lua"
	self:_registGlobalEventListeners()

	-- 游戏设置
	self.localset = {
		language = 1,
		effect = 1,	-- 音效
		music = 1,	-- 音乐
		showguild = 1,
		showtower = 1,
		showarea = 1,
		nofriend = 1,
		nearshow = 1,
	}
end

--[[获得分享内容
	0 占领领地
	1 放置塔防
]]
function model_playerBaseAttr:getShareContent( ctype )
	local str = ""
	if ctype == 0 then
		str = self._name.."控制了“"..self._LoctionInfo.AddrStr.."”";
	elseif ctype == 1 then
		str = self._name.."在领地“"..self._LoctionInfo.AddrStr.."”放置了防御塔";
	else
		--todo
	end
    return str;
end

function model_playerBaseAttr:setGUID( guid )
	self._guid = guid
end

function model_playerBaseAttr:getGUID()
	return self._guid
end

function model_playerBaseAttr:changeGameset( set_name, set_value )
	self.localset[set_name] = set_value;
	if 0==self.localset.effect then
		AudioManager.AMSOUND = 0;
	else
		AudioManager.AMSOUND =1;
	end
	if "music"==set_name then
		if 0==self.localset.music then
			AudioManager.AMMUSIC = 0;
			AudioEngine.stopMusic(true)
		else
			AudioManager.AMMUSIC =1;
			AudioManager.rePlayMusic()
		end
	end
end

function model_playerBaseAttr:getGamesetByname( set_name )
	return self.localset[set_name];
end

function model_playerBaseAttr:getGameset()
	return self.localset;
end


function model_playerBaseAttr:setGameset(set)
	self.localset = set;
end

function model_playerBaseAttr:setPost( post )
	self._post = post
end

function model_playerBaseAttr:getPost()
	return self._post
end

--是否能发起战斗
function model_playerBaseAttr:isCanOccupyHandle(  )

	if string.len(MAIN_PLAYER:getGuild():getname()) <= 0 then
		return false;
	end
	if self:getPost() == 1 or self:getPost() == 2 then
		return true;
	end
	return false;
end

function model_playerBaseAttr:setLv(_lv)
	self._lv = _lv
end

function model_playerBaseAttr:getLv()
	return self._lv
end

--设置定位信息
function model_playerBaseAttr:setLoctionInfo( loctioninfo )
	-- self._LoctionJNIInfo = loctioninfo;

	self._LoctionInfo.Longitude = loctioninfo.Longitude;
	self._LoctionInfo.Latitude = loctioninfo.Latitude;
	self._LoctionInfo.Direction = loctioninfo.Direction;
	self._LoctionInfo.AddrStr = loctioninfo.AddrStr;
	print("UpdateLoctionInfo 2",loctioninfo.Longitude,loctioninfo.Latitude,loctioninfo.Direction,loctioninfo.AddrSt)
	dispatchGlobaleEvent("controler_mapPage_map_layer", "updateOneselfpos", {lon = self._LoctionInfo.Longitude,lat = self._LoctionInfo.Latitude,direction = self._LoctionInfo.Direction})
end

function model_playerBaseAttr:UpdateLoctionInfo(  )
	if device.platform == "android" then
		if not cc.FileUtils:getInstance():isFileExist(self.LocationInfoFile) then
	        -- print(self.LocationInfoFile,"文件不存在")
	        return;
	    end
	    replay_require( "LocationInfo.lua" );
	    
		self._LoctionInfo.Longitude = baiDuLoctionInfo.Longitude;
		self._LoctionInfo.Latitude = baiDuLoctionInfo.Latitude;
		self._LoctionInfo.Direction = baiDuLoctionInfo.Direction;
		self._LoctionInfo.CityCode = baiDuLoctionInfo.CityCode;
		self._LoctionInfo.City = baiDuLoctionInfo.City;
		self._LoctionInfo.AddrStr = baiDuLoctionInfo.AddrStr;
		print("UpdateLoctionInfo 2",baiDuLoctionInfo.Longitude,baiDuLoctionInfo.Latitude,baiDuLoctionInfo.Direction,self._LoctionInfo.City,baiDuLoctionInfo.AddrStr)
		dispatchGlobaleEvent("controler_mapPage_map_layer", "updateOneselfpos", {lon = self._LoctionInfo.Longitude,lat = self._LoctionInfo.Latitude,direction = self._LoctionInfo.Direction})
	elseif device.platform == "ios" then
		self._LoctionInfo.Longitude = IOS_BaiDuLoctionInfo.Longitude;
		self._LoctionInfo.Latitude = IOS_BaiDuLoctionInfo.Latitude;
		self._LoctionInfo.Direction = IOS_BaiDuLoctionInfo.Direction;
		self._LoctionInfo.CityCode = IOS_BaiDuLoctionInfo.CityCode;
		self._LoctionInfo.City = IOS_BaiDuLoctionInfo.City;
		self._LoctionInfo.AddrStr = IOS_BaiDuLoctionInfo.AddrStr;
		print("UpdateLoctionInfo 2",IOS_BaiDuLoctionInfo.Longitude,IOS_BaiDuLoctionInfo.Latitude,IOS_BaiDuLoctionInfo.Direction,self._LoctionInfo.City,IOS_BaiDuLoctionInfo.AddrStr)
		dispatchGlobaleEvent("controler_mapPage_map_layer", "updateOneselfpos", {lon = self._LoctionInfo.Longitude,lat = self._LoctionInfo.Latitude,direction = self._LoctionInfo.Direction})
	end
	
end

--更新玩家地图块位置信息
function model_playerBaseAttr:UpdateMapTileInfo( )
	local vec_piexl_x = (self._LoctionInfo.Longitude - MAP_DATA.TileDrawInfo.CurrentMapPieceMarkLocation[1]) / managerMapDownloadInstance.PixelToLongitude;
	local vec_piexl_y = (self._LoctionInfo.Latitude - MAP_DATA.TileDrawInfo.CurrentMapPieceMarkLocation[2]) / managerMapDownloadInstance.PixelToLatitude
	local tile_x ,tile_y = MAP_DATA.TileMarkInfo:getMapPiecePosByPixelCoordinate( vec_piexl_x ,vec_piexl_y );
	if self._MapTile_x ~= tile_x or tile_y ~= self._MapTile_y then
		--发送玩家位置信息
		printLog("网路日志","发送玩家位置改变消息 MSG_C2S_AREA_ENTER")
	    gameTcp:SendMessage(MSG_C2S_AREA_ENTER,{
	            tile_x,
	            tile_y,
	            self._LoctionInfo.AddrStr
	        })

	    --更新地块缩略信息
	    if self._playerMoveCell ~= 0 then
	    	local data = MAP_DATA.TileDrawInfo:getPieceByTilePos( self._MapTile_x , self._MapTile_y  );
			if data then
				data.currentstate = GetTileStateByPlayerNum( data.PlayerNum - 1 );
				dispatchGlobaleEvent( "controler_mapPage_map_Title_layer" ,"update_act_state",data);
			end
	    end
		
		--刷新当前地块信息
	    self._refreshPlayerPos = true;
	    MAP_DATA:sendRequestTileInfo( tile_x , tile_y );
	    self._playerMoveCell = 1;

	    --检查距离中心的位置是否刷新
	    if  MAP_DATA.TileDrawInfo:getCenterDis( tile_x ,tile_y ) > 3 then
	    	MAP_DATA:returnPlayerPos();
	    end
	end
	self._MapTile_x = tile_x;
	self._MapTile_y = tile_y;
end

function model_playerBaseAttr:setName( name )
	self._name = name
	-- dispatchGlobaleEvent("model_playerBaseAttr", "nameChange", {name=self._name})
end

function model_playerBaseAttr:getName()
	return self._name
end

function model_playerBaseAttr:setHeadID( headid )
	self._headid = headid
	-- dispatchGlobaleEvent("model_playerBaseAttr", "headidChange", {headid=self._headid})
end

function model_playerBaseAttr:setSex( sex )
	self._sex = sex
	-- dispatchGlobaleEvent("model_playerBaseAttr", "headidChange", {headid=self._headid})
end

function model_playerBaseAttr:getSex()
	return self._sex
end

function model_playerBaseAttr:getHeadID()
	return self._headid
end

function model_playerBaseAttr:setGold( gold )
	self._gold = gold
	-- dispatchGlobaleEvent("model_playerBaseAttr", "goldChange", {gold=self._gold})
end

function model_playerBaseAttr:changeGold( gold )
	self._gold = self._gold + gold
	dispatchGlobaleEvent("model_playerBaseAttr", "goldChange", {gold=self._gold})
end

function model_playerBaseAttr:getGold()
	return self._gold
end

function model_playerBaseAttr:setYuanBao( yuanBao )
	self._yuanBao = yuanBao
	-- dispatchGlobaleEvent("model_playerBaseAttr", "yuanBaoChange", {yuanBao=self._yuanBao})
end

function model_playerBaseAttr:getYuanBao()
	return self._yuanBao
end

function model_playerBaseAttr:setHeadGUid( tiLi )
	self._headGUid = tiLi
	-- dispatchGlobaleEvent("model_playerBaseAttr", "tiLiChange", {tiLi=self._tiLi, maxTiLi=100})
end

function model_playerBaseAttr:getHeadGUid()
	return self._headGUid
end

-- --获取体力上限
-- function model_playerBaseAttr:getTiliMax()
-- 	return 100
-- end


-- function model_playerBaseAttr:setJingLi( jingLi )
-- 	self._jingLi = jingLi
-- 	dispatchGlobaleEvent("model_playerBaseAttr", "jingLiChange", {jingLi=self._jingLi, maxJingLi=100})
-- end

-- function model_playerBaseAttr:getJingLi()
-- 	return self._jingLi
-- end

-- --获取精力上限
-- function model_playerBaseAttr:getJingLiMax()
-- 	return 100
-- end

function model_playerBaseAttr:setExp( exp )
	self._exp = exp
	-- dispatchGlobaleEvent("model_playerBaseAttr", "expChange", {exp=self._exp, lvUpNeedExp=self:getLvUpNeedExp()})
end

function model_playerBaseAttr:getExp()
	return self._exp
end

--获取当前等级升级所需经验(不算已有经验)
function model_playerBaseAttr:getLvUpNeedExp()
	return Player_GetNeedExp(self._lv)
end

--获取到下一级需要经验(当前级需要经验 - 已有经验)
function model_playerBaseAttr:getToNextLvNeedExp()
	return self:getLvUpNeedExp() - self:getExp()
end

function model_playerBaseAttr:setVIPLv( vipLv )
	self._vipLv = vipLv
	dispatchGlobaleEvent("model_playerBaseAttr", "vipLvChange", {vipLv=self._vipLv})
end

function model_playerBaseAttr:getVIPLv()
	return self._vipLv
end

-- function model_playerBaseAttr:setJingyanchi( jingyanchi )
-- 	self._jingyanchi = jingyanchi
-- 	dispatchGlobaleEvent("model_playerBaseAttr", "jingyanchiChangejingyanchiChange", {jingyanchi=self._jingyanchi})
-- end

-- function model_playerBaseAttr:setJianghun( jianghun )
-- 	self._jianghun = jianghun
-- 	dispatchGlobaleEvent("model_playerBaseAttr", "jianghunChange", {jingyanchi=self._jianghun})
-- end

-- function model_playerBaseAttr:getJianghun()
-- 	return self._jianghun
-- end

function model_playerBaseAttr:setLevel( level )
	self._lv = level
	dispatchGlobaleEvent("model_playerBaseAttr", "levelChange", {lv=self._lv})
end


function model_playerBaseAttr:isVIP()
	return self._vipLv > 0
end

--检查属性值是否足够
function model_playerBaseAttr:checkeAttrEnough( attrtype , valuse )
	local currentvaluse = 0;
	if attrtype == "体力" then
		currentvaluse = self._tiLi
	elseif conditions then
		--todo
	else
		--todo
	end
	if currentvaluse < valuse then
		return false;
	end
	return true;
end

--注册全局事件监听器
function model_playerBaseAttr:_registGlobalEventListeners()
	self._globalEventListeners = {}
	local configs = {
		{modelName = "netMsg", eventName = tostring(MSG_MS2C_ROLE_UPDATA_GOLD), callBack=handler(self, self._onMSG_MS2C_ROLE_UPDATA_GOLD)},
		-- {modelName = "netMsg", eventName = tostring(MSG_MS2C_ROLE_UPDATA_HERO_EXP), callBack=handler(self, self._onMSG_MS2C_ROLE_UPDATA_HERO_EXP)},
		{modelName = "netMsg", eventName = tostring(MSG_MS2C_ROLE_UPDATA_YUANBAO), callBack=handler(self, self._onMSG_MS2C_ROLE_UPDATA_YUANBAO)},
		-- {modelName = "netMsg", eventName = tostring(MSG_MS2C_ROLE_UPDATA_HERO_SOUL), callBack=handler(self, self._onMSG_MS2C_ROLE_UPDATA_HERO_SOUL)},
		{modelName = "netMsg", eventName = tostring(MSG_MS2C_ROLE_UPDATA_LEVEL), callBack=handler(self, self._onMSG_MS2C_ROLE_UPDATA_LEVEL)},
	}
	self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end

-- 响应更新游戏币事件
function model_playerBaseAttr:_onMSG_MS2C_ROLE_UPDATA_GOLD( event )
	local eventUseData = event._usedata.msgData
	self:setGold(eventUseData.gold)
end

-- 响应更新元宝事件
function model_playerBaseAttr:_onMSG_MS2C_ROLE_UPDATA_YUANBAO( event )
	-- body
	local yuanbao = event._usedata.msgData
	self:setYuanBao(yuanbao)
end

-- function model_playerBaseAttr:_onMSG_MS2C_ROLE_UPDATA_HERO_EXP( event )
-- 	-- body
-- 	local jingyanchi = event._usedata.msgData
-- 	self:setJingyanchi(jingyanchi)
-- end

-- function model_playerBaseAttr:_onMSG_MS2C_ROLE_UPDATA_HERO_SOUL( event )
-- 	-- body
-- 	local jianghun = event._usedata.msgData
-- 	self:setJianghun(jianghun)
-- end

-- 响应更新等级事件
function model_playerBaseAttr:_onMSG_MS2C_ROLE_UPDATA_LEVEL( event )
	-- body
	local level = event._usedata.msgData
	self:setLevel(level)
end

-- --获取基本的每日进攻次数
-- function model_playerBaseAttr:getBaseAtkTime()
-- 	local config = GetVipCfg(self:getVIPLv())
-- 	return config.every_day.map_war_play_num 
-- end


-- --获取剩余进攻次数
-- function model_playerBaseAttr:getAtkRemainTime()
-- 	--基本进攻次数 + 已购买次数 - 已经进攻次数
-- 	return self:getBaseAtkTime() + self._AtkTimeBuy - self._AtkTime
-- end


-- --获取爵位
-- function model_playerBaseAttr:getTitle()
-- 	return self._Title
-- end


-- --获取爵位图示
-- function model_playerBaseAttr:getTitleIcon()
-- 	return string.format("icon/juewei/jw%d.png", self:getTitle())
-- end


-- --获取熔炼值
-- function model_playerBaseAttr:getRongLianZhi()
-- 	return self._ronglianzhi
-- end


-- function model_playerBaseAttr:getGuYongID()
-- 	return self._gyStrID
-- end

-- function model_playerBaseAttr:setGuYongID( id )
-- 	self._gyStrID = id
-- end

return model_playerBaseAttr

