--
-- Author: zangqing
-- Date: 2016-1-21 10:10:47
-- Dec: 塔防

local model_tower = class("model_tower")


-- --将英雄的主属性值转换为整数
-- function HeroMainAttrToInt( attrValue )
-- 	return math.floor(attrValue)
-- end

-- --将英雄的副属性值转换为整数
-- function HeroFuAttrToInt( attrValue )
-- 	return math.floor(attrValue * 10000)
-- end

-- --将英雄副属性值转换为百分比字符串
-- function HeroFuAttrToPerStr( attrValue )
-- 	local perValue = HeroFuAttrToInt(attrValue) / 10000 * 100
-- 	return perValue.."%"
-- end

-- --将英雄副属性值转换为百分比字符串(当前仅针对爆伤)
-- function HeroFuAttrToPerStr2( attrValue )
-- 	local perValue = (HeroFuAttrToInt(attrValue) / 10000 + 1) * 100
-- 	return perValue.."%"
-- end

-- new的时候将基本属性初始化
function model_tower:ctor(pAttribute)
	self.id = pAttribute.id -- 范本ID
	self.guid = pAttribute.guid -- 塔防guid
	self.curLv = pAttribute.curLv -- 塔防当前等级，1等级一个属性点
	self.time = pAttribute.time -- 获取时间戳
	self.baseAttribute = pAttribute.baseAttribute -- 基本属性，.atk攻击N点，.hp生命N点
	self.isLocked = 0 -- 锁定状态
	self.ownerPlayer = MAIN_PLAYER -- 所属玩家
	self.gold = pAttribute.gold-- 当前存储的金币
	self.position = 0;-- 塔防摆放位置坐标
end

-- 塔防锁定状态
function model_tower:getisLocked()
	-- body
	return self.isLocked
end

function model_tower:getGUID()
	return self.guid
end

--设置范本ID
function model_tower:setTempleateID(id)
	self.id = id
	-- self.fixProperty = GetHeroTemplate(self.id)
end

--获取范本ID
function model_tower:getTempleateID()
	return self.id
end

--范本ID是否有效
function model_tower:isValidTempleateID()
	return HeroTeampleate_isValideID(self.id)
end

-- function model_tower:getName()
-- 	return self.fixProperty.name
-- end

--设置英雄等级
function model_tower:setLv( lv )
	self.curLv = lv
end

--是否为最高等级
function model_tower:isMaxLv()
	return self.curLv >= towerConfig_GetMaxlevel()
end

--等到剩余未分配点数
function model_tower:getSparepoint()
	-- 根据配置和等级得到最大点数
	local maxpoint = towerConfig_GetMaxPoint(self.curLv);

	local Sparepoint = maxpoint-self.baseAttribute.hp_point-self.baseAttribute.atk_point;
	if 0>Sparepoint then
		Sparepoint = 0;
	end
	return Sparepoint
end

--获取生命值
function model_tower:getBaseHP()
	-- 根据配置和等级得到
	return towerConfig_GetHPValue(self.baseAttribute.hp_point)
end

--获取攻击力
function model_tower:getBaseAttack()
	
	return towerConfig_GetAttickValue(self.baseAttribute.atk_point)
end

function model_tower:decodeServerMsg( recvMsg )
	--[[事例
	self.id = recvMsg:ReadInt()
	...
	]]
end

--获取武将当前等级
function model_tower:getCurLv()
	return self.curLv
end

-- --获取攻击类型
-- function model_tower:getStrAtkType()
-- 	return heroConfig_toStrAtkType(
-- 		heroConfig[self.id].profession
-- 	)
-- end

function model_tower:isInTeam()
	-- body
	return MAIN_PLAYER:getTeamManager():isInTeam(self.guid)
end
