--
-- Author: zangqing
-- Date: 2016-1-21 10:10:47
-- Dec: 塔防
local model_towerManager = class("model_towerManager")

--[[发送全局事件名预览
eventModleName: model_towerManager
eventName: 
	nameChange --玩家名字改变
	goldChange --银两改变
	yuanBaoChange --元宝改变
	tiLiChange --体力改变
	jingLiChange --精力改变
	expChange  --经验改变
	vipLvChange --VIP等级改变
]]

--[[监听全局事件名预览
eventModleName: netMsg
eventName:
	tostring(MSG_MS2C_ROLE_UPDATA_GOLD)
]]


function model_towerManager:ctor()
	-- self._tiLi = 0 --体力
	-- self._jingLi = 0 --精力
	self.id = 1 -- 范本ID
	self._guid = "" -- 塔防guid
	self._lv = 0 -- 塔防当前等级，1等级一个属性点
	self.time = 0 -- 获取时间戳
	self.baseAttribute = {0, 0} -- 基本属性，.atk攻击N点，.hp生命N点
	self.isLocked = 0 -- 锁定状态
	self.ownerPlayer = MAIN_PLAYER -- 所属玩家
	self.gold = 0-- 当前存储的金币
	self.speed = 10-- 每分钟增加10金钱
	self.plot_x = -1;-- 塔防摆放位置坐标
	self.plot_y = -1;-- 塔防摆放位置坐标
	self.placeInfo = "";--塔防位置信息

	self:_registGlobalEventListeners()
end

function model_towerManager:setGUID( guid )
	self._guid = guid
end

function model_towerManager:getGUID()
	return self._guid
end

function model_towerManager:setLv( lv )
	self._lv = lv
end

function model_towerManager:getLv()
	return self._lv
end

function model_towerManager:setPlaceInfo( info )
	self.placeInfo = info;
	print(self.placeInfo)
	if string.len(info) <= 0 then
		self.plot_x = -1;
		self.plot_y = -1;
		return;
	end
	local index = string.find(info,"_");
	info = string.sub(info,index + 1);
	index = string.find(info,"_");
	self.plot_x = string.sub(info,1,index-1);
	self.plot_y = string.sub(info,index + 1);
	self.plot_x = tonumber(self.plot_x)
	self.plot_y = tonumber(self.plot_y)
	print("setPlaceInfo:",self.plot_x,self.plot_y)
end

function model_towerManager:isPlace(  )
	if string.len(self.placeInfo) <= 0 then
		return false;
	end
	return true;
end

function model_towerManager:isPlaceByPos( x ,y )
	if string.len(self.placeInfo) <= 0 then
		return false;
	end
	if self.plot_x == x and self.plot_y == y then
		return true;
	end
	return false;
end

function model_towerManager:setspeed( speed )
	self.speed = speed
end

function model_towerManager:getspeed()
	return self.speed
end

function model_towerManager:setbaseAttribute( baseAttribute )
	self.baseAttribute = baseAttribute
end

function model_towerManager:changebaseAttribute( changeAttribute )
	self.baseAttribute[1] = self.baseAttribute[1] + changeAttribute[1]
	self.baseAttribute[2] = self.baseAttribute[2] + changeAttribute[2]
	-- dispatchGlobaleEvent("model_playerBaseAttr", "setbaseAttribute", {baseAttribute=self.baseAttribute})
end

function model_towerManager:getbaseAttribute()
	return self.baseAttribute
end

function model_towerManager:getlesspoint()
	print("self._lv========="..self._lv)
	print("self.baseAttribute[1]========="..self.baseAttribute[1])
	local lesspoint = self._lv-(self.baseAttribute[1]+self.baseAttribute[2]);
	print("lesspoint==="..lesspoint)
	if 0 > lesspoint then
		lesspoint = 0;
	end
	return lesspoint
end

function model_towerManager:getAttack()
	local Attack = 35+self.baseAttribute[1];
	if 0 > Attack then
		Attack = 0;
	end
	return Attack
end

function model_towerManager:gethp()
	local hp = 250+self.baseAttribute[2];
	if 0 > hp then
		hp = 0;
	end
	return hp
end


function model_towerManager:setName( name )
	self._name = name
	dispatchGlobaleEvent("model_towerManager", "nameChange", {name=self._name})
end

function model_towerManager:getName()
	return self._name
end

function model_towerManager:setHeadID( headid )
	self._headid = headid
	dispatchGlobaleEvent("model_towerManager", "headidChange", {headid=self._headid})
end

function model_towerManager:getHeadID()
	return self._headid
end

function model_towerManager:setGold( gold )
	self.gold = gold
	-- dispatchGlobaleEvent("ui_tower_lvup_layer", "goldChange", {gold=self.gold})
end

function model_towerManager:getGold()
	return self.gold
end


function model_towerManager:setYuanBao( yuanBao )
	self._yuanBao = yuanBao
	-- dispatchGlobaleEvent("model_towerManager", "yuanBaoChange", {yuanBao=self._yuanBao})
end

function model_towerManager:getYuanBao()
	return self._yuanBao
end

-- function model_towerManager:setTili( tiLi )
-- 	self._tiLi = tiLi
-- 	dispatchGlobaleEvent("model_towerManager", "tiLiChange", {tiLi=self._tiLi, maxTiLi=100})
-- end

-- function model_towerManager:getTili()
-- 	return self._tiLi
-- end

-- --获取体力上限
-- function model_towerManager:getTiliMax()
-- 	return 100
-- end


-- function model_towerManager:setJingLi( jingLi )
-- 	self._jingLi = jingLi
-- 	dispatchGlobaleEvent("model_towerManager", "jingLiChange", {jingLi=self._jingLi, maxJingLi=100})
-- end

-- function model_towerManager:getJingLi()
-- 	return self._jingLi
-- end

-- --获取精力上限
-- function model_towerManager:getJingLiMax()
-- 	return 100
-- end

function model_towerManager:setExp( exp )
	self._exp = exp
	dispatchGlobaleEvent("model_towerManager", "expChange", {exp=self._exp, lvUpNeedExp=self:getLvUpNeedExp()})
end

function model_towerManager:getExp()
	return self._exp
end

--获取当前等级升级所需经验(不算已有经验)
function model_towerManager:getLvUpNeedExp()
	return Player_GetNeedExp(self._lv)
end

--获取到下一级需要经验(当前级需要经验 - 已有经验)
function model_towerManager:getToNextLvNeedExp()
	return self:getLvUpNeedExp() - self:getExp()
end

function model_towerManager:setVIPLv( vipLv )
	self._vipLv = vipLv
	dispatchGlobaleEvent("model_towerManager", "vipLvChange", {vipLv=self._vipLv})
end

function model_towerManager:getVIPLv()
	return self._vipLv
end

-- function model_towerManager:setJingyanchi( jingyanchi )
-- 	self._jingyanchi = jingyanchi
-- 	dispatchGlobaleEvent("model_towerManager", "jingyanchiChangejingyanchiChange", {jingyanchi=self._jingyanchi})
-- end

-- function model_towerManager:setJianghun( jianghun )
-- 	self._jianghun = jianghun
-- 	dispatchGlobaleEvent("model_towerManager", "jianghunChange", {jingyanchi=self._jianghun})
-- end

-- function model_towerManager:getJianghun()
-- 	return self._jianghun
-- end

function model_towerManager:setLevel( level )
	self._lv = level
	dispatchGlobaleEvent("model_towerManager", "levelChange", {lv=self._lv})
end


function model_towerManager:isVIP()
	return self._vipLv > 0
end

--检查属性值是否足够
function model_towerManager:checkeAttrEnough( attrtype , valuse )
	local currentvaluse = 0;
	if attrtype == "体力" then
		currentvaluse = self._tiLi
	elseif conditions then
		--todo
	else
		--todo
	end
	if currentvaluse < valuse then
		return false;
	end
	return true;
end

--注册全局事件监听器
function model_towerManager:_registGlobalEventListeners()
	self._globalEventListeners = {}
	local configs = {
		{modelName = "netMsg", eventName = tostring(MSG_MS2C_ROLE_UPDATA_GOLD), callBack=handler(self, self._onMSG_MS2C_ROLE_UPDATA_GOLD)},
		-- {modelName = "netMsg", eventName = tostring(MSG_MS2C_ROLE_UPDATA_HERO_EXP), callBack=handler(self, self._onMSG_MS2C_ROLE_UPDATA_HERO_EXP)},
		{modelName = "netMsg", eventName = tostring(MSG_MS2C_ROLE_UPDATA_YUANBAO), callBack=handler(self, self._onMSG_MS2C_ROLE_UPDATA_YUANBAO)},
		-- {modelName = "netMsg", eventName = tostring(MSG_MS2C_ROLE_UPDATA_HERO_SOUL), callBack=handler(self, self._onMSG_MS2C_ROLE_UPDATA_HERO_SOUL)},
		{modelName = "netMsg", eventName = tostring(MSG_MS2C_ROLE_UPDATA_LEVEL), callBack=handler(self, self._onMSG_MS2C_ROLE_UPDATA_LEVEL)},
	}
	self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end

-- 响应更新游戏币事件
function model_towerManager:_onMSG_MS2C_ROLE_UPDATA_GOLD( event )
	local eventUseData = event._usedata.msgData
	self:setGold(eventUseData.gold)
end

-- 响应更新元宝事件
function model_towerManager:_onMSG_MS2C_ROLE_UPDATA_YUANBAO( event )
	-- body
	local yuanbao = event._usedata.msgData
	self:setYuanBao(yuanbao)
end

-- function model_towerManager:_onMSG_MS2C_ROLE_UPDATA_HERO_EXP( event )
-- 	-- body
-- 	local jingyanchi = event._usedata.msgData
-- 	self:setJingyanchi(jingyanchi)
-- end

-- function model_towerManager:_onMSG_MS2C_ROLE_UPDATA_HERO_SOUL( event )
-- 	-- body
-- 	local jianghun = event._usedata.msgData
-- 	self:setJianghun(jianghun)
-- end

-- 响应更新等级事件
function model_towerManager:_onMSG_MS2C_ROLE_UPDATA_LEVEL( event )
	-- body
	local level = event._usedata.msgData
	self:setLevel(level)
end

-- --获取基本的每日进攻次数
-- function model_towerManager:getBaseAtkTime()
-- 	local config = GetVipCfg(self:getVIPLv())
-- 	return config.every_day.map_war_play_num 
-- end


-- --获取剩余进攻次数
-- function model_towerManager:getAtkRemainTime()
-- 	--基本进攻次数 + 已购买次数 - 已经进攻次数
-- 	return self:getBaseAtkTime() + self._AtkTimeBuy - self._AtkTime
-- end


-- --获取爵位
-- function model_towerManager:getTitle()
-- 	return self._Title
-- end


-- --获取爵位图示
-- function model_towerManager:getTitleIcon()
-- 	return string.format("icon/juewei/jw%d.png", self:getTitle())
-- end


-- --获取熔炼值
-- function model_towerManager:getRongLianZhi()
-- 	return self._ronglianzhi
-- end


-- function model_towerManager:getGuYongID()
-- 	return self._gyStrID
-- end

-- function model_towerManager:setGuYongID( id )
-- 	self._gyStrID = id
-- end

return model_towerManager

