--
-- Author: Wu Hengmin
-- Date: 2015-10-19 16:37:18
-- 事件数据

--[[ 请求初始化数据
*
*	int		事件数量
*	{
*		int		发生时间
*		int		事件类型
*		string	事件描述
*		string	替换目标
*	}

-- 事件类型

-- 竞技场
IET_ARENA

-- 奇遇
IET_QYFC

-- 攻城战
IET_MAP_WAR
*初始化事件数据
]]
Msg_Logic[MSG_MS2C_INTERACT_INIT] = function ( tcp , msg )
	MAIN_PLAYER.notifyManager.data = {}
	printLog("网路日志", "初始化事件数据")
	local count = msg:ReadIntData()
	printLog("网路日志", "初始化事件资料, 数量:"..count)

	for i=1,count do
		local time = msg:ReadIntData()
		local type_ = msg:ReadIntData()
		local des = msg:ReadString()
		local target = msg:ReadString()
		des = string.gsub(des, "$J", tostring(target))
		printLog("网路日志", "时间:"..time.." 类型:"..type_.." 描述:"..des.. " 替换:"..target)
		table.insert(MAIN_PLAYER.notifyManager.data, {time = time, type_ = type_, des = des, target = target})
	end


	
end

--[[ 添加事件
*
*	int		发生时间
*	int		事件类型
*	string	事件描述
*	string	替换目标
*
]]
Msg_Logic[MSG_MS2C_INTERACT_ADD] = function ( tcp , msg )
	printLog("网路日志", "添加事件")
	local time = msg:ReadIntData()
	local type_ = msg:ReadIntData()
	local des = msg:ReadString()
	local target = msg:ReadString()
	des = string.gsub(des, "$J", tostring(target))
	printLog("网路日志", "时间:"..time.." 类型:"..type_.." 描述:"..des.. " 替换:"..target)
	table.insert(MAIN_PLAYER.notifyManager.data, {time = time, type_ = type_, des = des, target = target})
	dispatchGlobaleEvent("netMsg", tostring(MSG_MS2C_INTERACT_ADD), {mode = type_})
end

--[[ 删除事件
*
*	int		事件序号
*
]]
Msg_Logic[MSG_MS2C_INTERACT_DEL] = function ( tcp , msg )
	printLog("网路日志", "删除事件")
	local index = msg:ReadIntData()
	printLog("网路日志", "删除序号:"..index)
	table.remove(MAIN_PLAYER.notifyManager.data, index)
	dispatchGlobaleEvent("netMsg", tostring(MSG_MS2C_INTERACT_DEL))
end

--[[ 获取排行榜信息
*
*	int		榜单类型
*	int		页数
*	int		信息条数
*	{
*		string	名字
*		int		等级
*		int		VIP等级
*		int		战力
*		int		银两	
*	}
*
*
]]
Msg_Logic[MSG_MS2C_RANK_RE] = function ( tcp , msg )
	printLog("网路日志", "获取排行榜信息")
	local ranktype = msg:ReadIntData() --榜单类型
	local rankpage = msg:ReadIntData() --页数
	local count = msg:ReadIntData() --数量
	printLog("网路日志","排行榜类型:"..ranktype..",页数:"..rankpage..",数量:"..count);
	
	local page = 1;
	local rankData = MAIN_PLAYER.rankManager:CreateRanking( ranktype ,page );
	MAIN_PLAYER.rankManager:addData( rankData );
	for i=1,count do
		local data = require("app.models.player.rankingRecord").new();
		local name = msg:ReadString();--名称
		local grade = msg:ReadIntData() --等级
		local vipGrade = msg:ReadIntData() --vip等级
		local power = msg:ReadIntData() --战力值
		local gold = msg:ReadIntData() --银两
		print("  ",name,grade,vipGrade,power,gold)
		data.rankType = ranktype;--排行榜类型
		data.Ranking = i;--名次
		data.roleName = name;--角色名称
		data.rolePowerValue = power;--角色战力值
		data.roleGrade = grade;--角色等级
		data.roleVIPGrade = vipGrade;--角色VIP等级
		data.roleGold = gold;

		rankData:addData( data );
		if i % 10 == 0 then
			page = math.modf(i / 10 + 1);
			rankData = MAIN_PLAYER.rankManager:CreateRanking( ranktype ,page );
			MAIN_PLAYER.rankManager:addData( rankData );
		end
		
	end
	--更新排行榜种类信息
	dispatchGlobaleEvent("netMsg", tostring(MSG_MS2C_RANK_RE),{ranktype,page});
end

--[[ 登陆时签到配置推送
*
*	int		数量
*		int		类型
*		int		奖励物品ID
*		int		奖励物品等级
*		int		奖励物品数量
*
]]
Msg_Logic[MSG_MS2C_QIANDAO_CONFIG] = function ( tcp , msg )
	
	local count = msg:ReadIntData();
	printLog("网路日志", "获取签到数据:"..count)
	qiandao_rewardCfg = {};
	for i=1,count do
		local rewardgoods = {};
		rewardgoods.obj_type = msg:ReadIntData();--奖励类型
		rewardgoods.obj_id = msg:ReadIntData();--奖励id
		rewardgoods.obj_lv = msg:ReadIntData();
		rewardgoods.obj_num =  msg:ReadIntData();
		qiandao_rewardCfg[i] = {};
		qiandao_rewardCfg[i][1] = rewardgoods;
	end
end

