--
-- Author: Wu Hengmin
-- Date: 2014-06-12 09:28:53
--

Msg_Logic[MSG_MS2C_CAMPAIGN_INFO] = function ( tcp , msg  )
	print("MSG_MS2C_CAMPAIGN_INFO")
end

-- 活动子关卡次数更新
Msg_Logic[MSG_MS2C_CAMPAIGN_SUB_INFO] = function ( tcp , msg  )
	print("MSG_MS2C_CAMPAIGN_SUB_INFO")
end

-- 错误信息
Msg_Logic[MSG_MS2C_CAMPAIGN_ERROR] = function ( tcp , msg  )
	local code = msg:ReadIntData()
	printLog("网路日志","错误码:"..code)
	print(getErrorDescribe( code ))
	if code == eC_IsEnd or code == eC_AtkCD then
		--攻打发生错误
		
		--关闭战斗
		
		print("清除下场战斗数据")
		control_Battlefield:RemoveRequestData( {
			battletype = Data_Battle.CONST_BATTLE_TYPE_SJBOSS, --战场类型
		} )
		--检查战斗失败
		dispatchGlobaleEvent( "battlefield" ,"executebattle_fail")
	end
	UIManager:CreatePrompt_Bar( {
  		content = getErrorDescribe( code ),
  	} );
end

-- 世界boss信息
Msg_Logic[MSG_MS2C_CAMPAIGN_BOSS_INFO] = function ( tcp , msg  )
	printLog("网路日志","世界boss信息")
	local ID = msg:ReadIntData()
	printLog("网路日志","世界boss活动ID"..ID)
	if ID > 100 then
		if not MAIN_PLAYER.bossManager.data[ID] then
			MAIN_PLAYER.bossManager.data[ID] = {};
		end
		tmp = MAIN_PLAYER.bossManager.data[ID];
	else
		printLog("网路日志","世界boss活动ID有误")
		return
	end

	local level = msg:ReadIntData()
	tmp.level = level
	printLog("网路日志","世界boss等级"..level)

	local hp = msg:ReadIntData()
	tmp.hp = hp
	printLog("网路日志","世界boss血量"..hp)

	local max = msg:ReadIntData()
	tmp.max = max
	printLog("网路日志","世界boss最大血量"..max)

	local atk = msg:ReadIntData()
	tmp.atk = atk
	printLog("网路日志","攻击力加成"..atk)

	local drum = msg:ReadIntData()
	tmp.isdrum = drum
	printLog("网路日志","是否已鼓舞"..drum)

	local damage = msg:ReadIntData()
	tmp.damage = damage
	printLog("网路日志","造成的伤害"..damage)

	local rank = msg:ReadIntData()
	tmp.rank = rank
	printLog("网路日志","当前排名"..rank)

	local colddown = msg:ReadIntData()

	tmp.colddown = math.ceil(colddown - os.time() - g_time)

	printLog("网路日志","进攻冷却时间"..tmp.colddown)
	if tmp.colddown <= 0 then
		tmp.colddown = -1
	else
		tmp.colddown = tmp.colddown + 1
	end
	printLog("网路日志","服务器冷却时间"..colddown)

	-- 0 攻打中   1 等待复活   2 等待开始
	tmp.state = msg:ReadIntData()
	printLog("网路日志","可进攻状态"..tmp.state)

	tmp.closetime = msg:ReadIntData()
	printLog("网路日志","可进攻状态时间"..tmp.closetime)

	tmp.atksign = msg:ReadIntData()
	printLog("网路日志","可进攻标志"..tmp.atksign)

	tmp.fuhuo1 = msg:ReadIntData()
	tmp.fuhuo2 = msg:ReadIntData()
	printLog("网路日志","复活批次"..tmp.fuhuo1.."/"..tmp.fuhuo2)


	dispatchGlobaleEvent("boss_ctr", "create", {k = ID})
end


-- 世界boss排名
Msg_Logic[MSG_MS2C_CAMPAIGN_BOSS_RANK] = function ( tcp , msg  )
	printLog("网络日志","世界boss排名 MSG_MS2C_CAMPAIGN_BOSS_RANK")
	MAIN_PLAYER.bossManager.ranks = {}
	local ID = msg:ReadIntData()
	MAIN_PLAYER.bossManager.ranks.id = ID
	printLog("网络日志","世界boss活动ID"..ID)

	local level = msg:ReadIntData()
	MAIN_PLAYER.bossManager.ranks.booslevel = level
	printLog("网络日志","世界boss等级"..level)

	-- local hp = msg:ReadIntData()
	-- MAIN_PLAYER.bossManager.ranks.hp = hp
	-- logPrint("网络日志","世界boss血量"..hp)

	local time = msg:ReadIntData()
	MAIN_PLAYER.bossManager.ranks.time = time
	if MAIN_PLAYER.bossManager.ranks.time < 0 then MAIN_PLAYER.bossManager.ranks.time = 0 end
	printLog("网络日志","战斗时间"..time)

	-- local finalname = msg:ReadString()
	-- MAIN_PLAYER.bossManager.ranks.kill.name = finalname
	-- logPrint("网络日志","最后一击玩家名称"..finalname)

	-- local finaldamage = msg:ReadIntData()
	-- MAIN_PLAYER.bossManager.ranks.kill.damage = finaldamage
	-- logPrint("网络日志","最后一击总伤害"..finaldamage)

	local rank10 = msg:ReadIntData()
	printLog("网络日志","获奖数量:"..rank10)
	-- if rank10 == 0 then
	-- 	UIManager:CreatePrompt_1( display.getRunningScene() , "没有玩家参与此次战斗")
	-- 	return
	-- end

	MAIN_PLAYER.bossManager.ranks.ranks = {}
	MAIN_PLAYER.bossManager.ranks.lucks = {}
	MAIN_PLAYER.bossManager.ranks.kill = {}
	for i=1,rank10 do
		local rank = msg:ReadIntData()
		local name = msg:ReadString()
		local damage = msg:ReadIntData()
		printLog("网络日志","排名:"..rank.." 姓名:"..name.." 伤害:"..damage)
		if rank == -1 then

			MAIN_PLAYER.bossManager.ranks.kill.name = name
			MAIN_PLAYER.bossManager.ranks.kill.damage = damage
		elseif rank > 10 then
			table.insert(MAIN_PLAYER.bossManager.ranks.lucks, {name = name})
		else
			MAIN_PLAYER.bossManager.ranks.ranks[rank] = {
				ranking = rank;
				name = name,
				damage = damage,
			}
		end
	end

	-- MAIN_PLAYER.bossManager.ranks.kill = {
	-- 	name = "最后一击",
	-- 	damage = 10000,
	-- }
	-- MAIN_PLAYER.bossManager.ranks.ranks[1] = {
	-- 	ranking = 1;
	-- 	name = "测试1",
	-- 	damage = 10000,
	-- }
	-- MAIN_PLAYER.bossManager.ranks.ranks[2] = {
	-- 	ranking = 2;
	-- 	name = "测试2",
	-- 	damage = 10000,
	-- }
	
	-- TounchContrlScheduler(0, 1)
	dispatchGlobaleEvent("netMsg", "MSG_MS2C_CAMPAIGN_BOSS_RANK")
end

-- 战斗返回结果
Msg_Logic[MSG_MS2C_CAMPAIGN_BOSS_BATTLE_RE] = function ( tcp , msg  )
	-- 1.战斗随机ID
	-- 2.胜负
	-- 3.伤害

	printLog("网路日志","世界boss战斗信息")
	-- 战斗数据
	local battledata = Data_Battle_Msg:analysisBattleData( msg ,Data_Battle.CONST_BATTLE_TYPE_SJBOSS , "世界BOSS");
	local ResultData = {
		result = battledata.battleResult,
		score = 0,
		AttackSumHurt = battledata.AttackSumHurt,
		sumBout = 30,--总回合数
		boutCount = battledata.MaxBoutCount,--回合数
		nextprompt = "世界BOSS战斗结束", --下一场战斗提示
		countdown = 3,--倒计时
		dropout = {},--掉落
	};
	battledata.ResultData = ResultData;

	local resault = msg:ReadIntData()
	printLog("网路日志","战斗结果:"..resault)
	local damage = msg:ReadIntData()
	printLog("网路日志","造成伤害:"..damage)

	
	--隐藏boss挑战界面
	dispatchGlobaleEvent("sjboss_ctrl", "hide")
	--开启战斗显示
	dispatchGlobaleEvent("controler_mainpage_zhanyi1_layer", "zhanyi_touched")
	--发送挂机战斗结果消息
	dispatchGlobaleEvent("netMsg", "sjboss_result",{battledata})
	-----------------------------------------------------------------
end
g_time = 0
times = {}
Msg_Logic[MSG_MS2C_LOGIN_TIME] = function ( tcp , msg  )
	local localtime = msg:ReadIntData()
	printLog("网路日志","本地时间戳:"..localtime)

	local servertime = msg:ReadIntData()
	printLog("网路日志","服务器时间戳:"..servertime)

	local tmptime = os.time()-localtime
	printLog("网路日志","来回耗时:"..tmptime)
	
	if tmptime>3 then
		if #times == 0 then
			table.insert(times, tmptime)
			TIME = os.time()
			printLog("网路日志","发送请求本地时间:"..TIME)
			gameTcp:SendMessage(MSG_C2MS_LOGIN_GET_TIME, {TIME})
			printLog("网路日志","1加入时间池,继续请求")
		elseif #times < 3 then
			for i=1,#times do
				if math.abs(times[i]-tmptime) > 1 then
					printLog("网路日志","误差过大,重新请求")
					times = {}
					table.insert(times, tmptime)
					TIME = os.time()
					printLog("网路日志","发送请求本地时间:"..TIME)
					gameTcp:SendMessage(MSG_C2MS_LOGIN_GET_TIME, {TIME})
					return
				end
			end
			table.insert(times, tmptime)
			printLog("网路日志","2加入时间池,继续请求")
			TIME = os.time()
			printLog("网路日志","发送请求本地时间:"..TIME)
			gameTcp:SendMessage(MSG_C2MS_LOGIN_GET_TIME, {TIME})
		else
			TIME = servertime + (times[1]+times[2]+times[3])/6
			printLog("网路日志","1确认时间戳"..TIME)
			UIManager.gameMain.center:showUI("活动")
			times = {}
			g_time = math.floor(TIME-os.time())
		end
	else
		TIME = servertime + (os.time()-localtime)/2
		printLog("网路日志","2确认时间戳"..TIME)
		-- UIManager.gameMain.center:showUI("活动")
		times = {}
		g_time = math.floor(TIME-os.time())
		-- if g_openactivitor then
		-- 	UIManager.gameMain.center:showUI("活动")
		-- 	g_openactivitor = false
		-- end
	end
	printLog("网路日志","服务器和本地时间差"..g_time)
end

--可操作提示
Msg_Logic[MSG_MS2C_GAME_HINT] = function ( tcp , msg  )
	printNetLog("收到消息 可操作提示(MSG_MS2C_GAME_HINT)")
	
	local msgData = {}
	msgData.tipsInfo = {}
	local tipsInfo = msgData.tipsInfo
	--奇遇条数是否已满(0 没有; 1 有)
	tipsInfo["qy_tsym"] = msg:ReadIntData()
	print("奇遇:"..tipsInfo["qy_tsym"])
	--奇遇是否有新的复仇(0 没有; 1 有)
	tipsInfo["qy_fc"] = msg:ReadIntData()
	--熔炼的兑换列表刷新次数是否已满(0 没有; 1 有)
	tipsInfo["rl_sxcs"] = msg:ReadIntData()
	print("兑换:"..tipsInfo["rl_sxcs"])
	--雇佣是否有佣兵(0 没有; 1 有)
	tipsInfo["gy_wyb"] = msg:ReadIntData()
	--军团进攻次数是否已满(0 没有; 1 有)
	tipsInfo["jt_jgcs"] = msg:ReadIntData()
	--军团是否有人申请军团(0 没有; 1 有)
	tipsInfo["jt_sq"] = msg:ReadIntData()
	--商店是否有免费武将招募次数(0 没有; 1 有)
	tipsInfo["sd_mf_wj_zm"] = msg:ReadIntData()
	--竞技场次数是否已满(0 没有; 1 有)
	tipsInfo["jjc_csym"] = msg:ReadIntData()
	--钢铁征途通关奖励是否领取(0 没有; 1 有)
	tipsInfo["gtzt_jllq"] = msg:ReadIntData()
	--钢铁征途Boss进攻次数是否已满(0 没有; 1 有)
	tipsInfo["gtzt_boss_jgcs"] = msg:ReadIntData()
	--活动是否有次数(0 没有; 1 有)
	tipsInfo["hd_cs"] = msg:ReadIntData()
	--活动世界BOSS是否开放(0 没有; 1 有)
	tipsInfo["hd_worldBoss"] = msg:ReadIntData()
	--福利: 是否有  可购买的VIP礼包但没有购买(0 没有; 1 有)
	tipsInfo["fl_vip_lb"] = msg:ReadIntData()
	--福利: 是否有  补给可领取(0 没有; 1 有)
	tipsInfo["fl_bj"] = msg:ReadIntData()
	--活动: 是否有: 可签到或补签(0 没有; 1 有)
	tipsInfo["hd_qd"] = msg:ReadIntData()
	--任务: 是否有  完成了但没有领取奖励的任务(0 没有; 1 有)
	tipsInfo["rw_wc"] = msg:ReadIntData()
	--好友: 是否有  好友申请(0 没有; 1 有)
	tipsInfo["hy_sq"] = msg:ReadIntData()
	--邮件: 是否有  未读邮件(0 没有; 1 有)
	tipsInfo["yj_noReadMail"] = msg:ReadIntData()
	--福利: 是否有  月卡可领取(0 没有; 1 有)
	tipsInfo["fl_yk"] = msg:ReadIntData()
	
	printNetLog(serialize(msgData))

	GAME_MODEL:getTipManager():updateTipsWithServerMsg(msgData)
end


-- 购买进攻冷却时间返回消息
Msg_Logic[MSG_MS2C_CAMPAIGN_BOSS_BUY_RE] = function ( tcp , msg  )
	print("MSG_MS2C_CAMPAIGN_BOSS_BUY_RE")
	dispatchGlobaleEvent("netMsg", "MSG_MS2C_CAMPAIGN_BOSS_BUY_RE")
end
