--
-- Author: Li Yang
-- Date: 2016-05-21 12:56:30
-- 建筑相关

-- 服务器发送领地建筑数据
Msg_Logic[MSG_S2C_FIELD_Data] = function ( tcp , msg )
	-- 结果
	printInfo("网路日志 %s","收到服务器领地消息 MSG_S2C_FIELD_Data");
	if not Data_Battle.isReceiveMsg or Data_Battle.BattleType ~= Data_Battle.CONST_BATTLE_TYPE_PLANNING then
		return;
	end
	--地块坐标
	local plot_x = msg:ReadIntData();
	local plot_y = msg:ReadIntData();

	--是否有工会庇护所
	local guildkey = msg:ReadString();
	print("网络日志：",plot_x,plot_y,guildkey)
	Data_Battle.plot_x = plot_x;
	Data_Battle.plot_y = plot_y;
	Data_Battle.guild = guildkey;
	BuildManager.guildBfs = guildkey;
	BuildManager.buildPool = {};
	if guildkey == NULL_GUID then
		
	else
		--工会key
		local shelter_id = msg:ReadIntData();
		local shelter_level = msg:ReadIntData();
		--坐标
		local shelter_x = msg:ReadIntData();
		local shelter_y = msg:ReadIntData();
		print("  shelter_id:",shelter_id,shelter_level,shelter_x,shelter_y,GetBuildTempleIDByLevel( 1 ,shelter_level ))
		BuildManager:addBuildData( {
			guid = guildkey,--GUID
			buildType = 1,--建筑类型
			level = shelter_level,--建筑等级
			templateID = GetBuildTempleIDByLevel( 1 ,shelter_level ),
			pos_x = shelter_x,
			pos_y = shelter_y,
			plot_x = plot_x,
			plot_y = plot_y,
			index = shelter_id,
			camp = Data_Battle.CONST_CAMP_ATTACK,
			hp = 100
		}  )
		local towersNum = msg:ReadIntData();
		print("塔防数量:",towersNum)
		for i=1,towersNum do
			local towerskey = msg:ReadString();
			local towers_level = msg:ReadIntData();
			local towers_x = msg:ReadIntData();
			local towers_y = msg:ReadIntData();
			print("  towers:",i,towerskey,towers_level,towers_x,towers_y)
			BuildManager:addBuildData( {
				guid = towerskey,--GUID
				buildType = 2,--建筑类型
				level = towers_level,--建筑等级
				templateID = GetBuildTempleIDByLevel( 2 ,towers_level ),
				pos_x = towers_x,
				pos_y = towers_y,
				plot_x = plot_x,
				plot_y = plot_y,
				camp = Data_Battle.CONST_CAMP_ATTACK,
				hp = 100
			}  )
		end
	end
	
	--收到建筑数据完成进去战场切换
	dispatchGlobaleEvent( "battlefield" ,"loadcut");
end

--[[建筑数据更新消息
]]
Msg_Logic[MSG_S2C_FIELD_DataUpdate] = function ( tcp , msg )
	if not Data_Battle.isReceiveMsg or Data_Battle.BattleType ~= Data_Battle.CONST_BATTLE_TYPE_PLANNING then
		return;
	end
	-- 结果
	printInfo("网路日志 %s","收到服务器领地建筑更新消息 MSG_S2C_FIELD_DataUpdate");
	--地块坐标
	local plot_x = msg:ReadIntData();
	local plot_y = msg:ReadIntData();

	--是否有工会庇护所
	local guildkey = msg:ReadString();
	print("网络日志：",plot_x,plot_y,guildkey)
	Data_Battle.plot_x = plot_x;
	Data_Battle.plot_y = plot_y;
	Data_Battle.guild = guildkey;
	BuildManager.guildBfs = guildkey;
	BuildManager.buildPool = {};
	if guildkey == NULL_GUID then
		
	else
		--工会key
		local shelter_id = msg:ReadIntData();
		local shelter_level = msg:ReadIntData();
		--坐标
		local shelter_x = msg:ReadIntData();
		local shelter_y = msg:ReadIntData();
		print("  shelter_id==>:",shelter_id,shelter_level,shelter_x,shelter_y,GetBuildTempleIDByLevel( 1 ,shelter_level ))
		BuildManager:addBuildData( {
			guid = guildkey,--GUID
			buildType = 1,--建筑类型
			level = shelter_level,--建筑等级
			templateID = GetBuildTempleIDByLevel( 1 ,shelter_level ),
			pos_x = shelter_x,
			pos_y = shelter_y,
			plot_x = plot_x,
			plot_y = plot_y,
			index = shelter_id,
			camp = Data_Battle.CONST_CAMP_ATTACK,
			hp = 100
		}  )
		print("塔防数量开始读取")
		local towersNum = msg:ReadIntData();
		print("塔防数量：",towersNum)
		for i=1,towersNum do
			local towerskey = msg:ReadString();
			local towers_level = msg:ReadIntData();
			local towers_x = msg:ReadIntData();
			local towers_y = msg:ReadIntData();
			BuildManager:addBuildData( {
				guid = towerskey,--GUID
				buildType = 2,--建筑类型
				level = towers_level,--建筑等级
				templateID = GetBuildTempleIDByLevel( 2 ,towers_level ),
				pos_x = towers_x,
				pos_y = towers_y,
				plot_x = plot_x,
				plot_y = plot_y,
				camp = Data_Battle.CONST_CAMP_ATTACK,
				hp = 100
			}  )
		end
	end

	--收到建筑数据更新消息
	dispatchGlobaleEvent( "battlefield" ,"build_update");
end

--[[放置工会建筑结果
]]
Msg_Logic[MSG_S2C_FIELD_ReLayShelter] = function ( tcp , msg )
	-- 结果
	local result = msg:ReadIntData();
	local index = msg:ReadIntData();
	printInfo("网路日志 %s","收到服务器回复放置庇护所结果消息 MSG_S2C_FIELD_ReLayShelter :"..result..","..index);
	if result == ICP_Succeed then
		Data_Battle.guild = MAIN_PLAYER.guild:getGUID();
		--更新工会庇护所状态
		MAIN_PLAYER:getGuild():updateManorlistByIndex( index ,1,cc.p(Data_Battle.plot_x,Data_Battle.plot_y));
		print("更新庇护所放置位置:",Data_Battle.plot_x,Data_Battle.plot_y)
		dispatchGlobaleEvent( "build_ui" ,"update");
		UIManager:CreatePrompt_Operate_1( {
                mark = "build_delete",--接口类型标示
                title = "分享提示",--标题
                content = "  将占领地分享到朋友圈将获得500U币!",--描述文字
                eventlogic = "",--绑定逻辑
                eventlist = "",--注册事件列表
                listenButton = function ( result )
                    -- 1 表示选择1按钮 2表示选择按钮
                    if result == 1 then
                        Lua2J_startShareAction(1,1,MAIN_PLAYER.baseAttr:getShareContent( 0 ),"","https://www.urbanmarginal.com/");
                    end
                end
            } )
	else
		-- dispatchGlobaleEvent("BuildCreate", "over", {0});
		UIManager:CreatePrompt_Bar( {
				content = getErrorDescribe( result ),
			} )
	end
	-- dispatchGlobaleEvent("BuildCreate", "over", {0});
end

--[[取消工会建筑结果
]]
Msg_Logic[MSG_S2C_FIELD_ReTakeShelter] = function ( tcp , msg )
	-- 结果
	local result = msg:ReadIntData();
	local index = msg:ReadIntData();
	printInfo("网路日志 %s","收到服务器回复删除庇护所结果消息 MSG_S2C_FIELD_ReTakeShelter:"..result..","..index);
	if result == ICP_Succeed then
		Data_Battle.guild = NULL_GUID;
		MAIN_PLAYER:getGuild():updateManorlistByIndex( index ,0);
		dispatchGlobaleEvent( "build_ui" ,"update");
	else
		UIManager:CreatePrompt_Bar( {
				content = getErrorDescribe( result ),
			} )
	end
end

--[[工会建筑移动结果
]]
Msg_Logic[MSG_S2C_FIELD_ReMoveShelter] = function ( tcp , msg )
	-- 结果
	local result = msg:ReadIntData();
	printInfo("网路日志 %s","收到服务器回复移动庇护所结果消息 MSG_S2C_FIELD_ReMoveShelter:"..result);
	if result == ICP_Succeed then
		
	else
		UIManager:CreatePrompt_Bar( {
				content = getErrorDescribe( result ),
			} )
	end
end

--[[放置塔结果
]]
Msg_Logic[MSG_S2C_FIELD_ReLayTower] = function ( tcp , msg )
	-- 结果
	local result = msg:ReadIntData();
	printInfo("网路日志 %s","收到服务器回复放置塔结果消息 MSG_S2C_FIELD_ReLayTower :"..result);
	if result == ICP_Succeed then
		MAIN_PLAYER:gettowerManager():setPlaceInfo( "area_"..Data_Battle.plot_x.."_"..Data_Battle.plot_y );
		--更新塔防信息
		gameTcp:SendMessage(MSG_C2S_TOWER_GetInfo,{})
		dispatchGlobaleEvent( "build_ui" ,"update");

		UIManager:CreatePrompt_Operate_1( {
                mark = "build_delete",--接口类型标示
                title = "分享提示",--标题
                content = "  将放置塔防信息分享到朋友圈将获得500U币!",--描述文字
                eventlogic = "",--绑定逻辑
                eventlist = "",--注册事件列表
                listenButton = function ( result )
                    -- 1 表示选择1按钮 2表示选择按钮
                    if result == 1 then
                        Lua2J_startShareAction(1,1,MAIN_PLAYER.baseAttr:getShareContent( 1 ),"","https://www.urbanmarginal.com/");
                    end
                end
            } )
	else
		-- dispatchGlobaleEvent("BuildCreate", "over", {0});
		UIManager:CreatePrompt_Bar( {
				content = getErrorDescribe( result ),
			} )
	end
end

--[[移动塔结果
]]
Msg_Logic[MSG_S2C_FIELD_ReMoveTower] = function ( tcp , msg )
	-- 结果
	local result = msg:ReadIntData();
	printInfo("网路日志 %s","收到服务器回复移动塔结果消息 MSG_S2C_FIELD_ReMoveTower :"..result);
	if result == ICP_Succeed then
		
	else
		UIManager:CreatePrompt_Bar( {
				content = getErrorDescribe( result ),
			} )
	end
end

--[[删除塔结果消息
]]
Msg_Logic[MSG_S2C_FIELD_ReTakeTower] = function ( tcp , msg )
	-- 结果
	local result = msg:ReadIntData();
	printInfo("网路日志 %s","收到服务器回复删除塔结果消息 MSG_S2C_FIELD_ReTakeTower :"..result);
	if result == ICP_Succeed then
		MAIN_PLAYER:gettowerManager():setPlaceInfo( "" );
		dispatchGlobaleEvent( "build_ui" ,"update");
	else
		UIManager:CreatePrompt_Bar( {
				content = getErrorDescribe( result ),
			} )
	end
end

--[[服务回应放置庇护所结果
	*
*	int 	结果代码
*
*	成功则有：
*	int 	放置点x坐标
*	int 	放置点y坐标
*	int 	庇护所等级
*
]]
-- Msg_Logic[MSG_S2C_FIELD_MoveShelterBack] = function ( tcp , msg )
-- 	-- 结果
-- 	printInfo("网路日志 %s","收到服务器回复放置庇护所结果消息 MSG_S2C_FIELD_LayShelterBack");
-- 	local result = msg:ReadIntData();
-- 	if result == 1 then
-- 		--地块坐标
-- 		local cell_x = msg:ReadIntData();
-- 		local cell_y = msg:ReadIntData();
-- 		local level = msg:ReadIntData();
-- 	else
-- 		--放置失败
-- 	end
-- end

--[[建筑信息改变通知
	回收
	移动
	升级
	生命改变

]]

--[[放置建筑
]]
