--
-- Author: Li Yang
-- Date: 2016-06-29 10:39:40
-- 战斗消息

--[[
	/** 初始化战斗数据
	*
	*	多条战斗数据(每条数据格式如下)
	*	
	*	{
	*		int		数据类型（根据不同数据类型，有以下数据格式）
	*
	*		-----------------------eFDT_Begin-----------------------
	*		int		当前战斗时间（毫秒）
	*
	*		-----------------------eFDT_AddUnit-----------------------
	*		int		当前战斗时间（毫秒）
	*		int		单位类型
	*		int		单位模版ID
	*		string	单位Key
	*		int		战斗单位ID
	*		int		初始坐标x
	*		int		初始坐标y
	*
	*		-----------------------eFDT_Do-----------------------
	*		int		当前战斗时间（毫秒）
	*
	*		-----------------------eFDT_Move-----------------------
	*		int		当前战斗时间（毫秒）
	*		int		战斗单位ID
	*		int		目的地坐标x
	*		int		目的地坐标y
	*
	*		-----------------------eFDT_Atk-----------------------
	*		int		当前战斗时间（毫秒）
	*		int		战斗单位ID
	*		int		目标单位ID
	*		int		目标地坐标x
	*		int		目标地坐标y
	*		int		伤害值
	*		int		目标剩余血量
	*
	*		-----------------------eFDT_Block-----------------------
	*		（表示数据流结束）
	*
	*		-----------------------eFDT_End-----------------------
	*		int		当前战斗时间（毫秒）
	*	}
	*
	*/
]]
Msg_Logic[MSG_S2C_FIGHTING_AddData] = function ( tcp, msg )
	printLog("网路日志", "收到战斗消息：MSG_S2C_FIGHTING_AddData :")
	if not Data_Battle.isReceiveMsg then
		return;
	end
	
	-- local sum =  msg:ReadIntData();
	local sum = 1000;
	local fightStart = {};
	for i=1,sum do
		local data = {};
		data.eventType = msg:ReadIntData();
		data.index = msg:ReadIntData();
		print("====>",data.index,data.eventType)
		if data.eventType == eFDT_Begin then
			data.executeTime = msg:ReadIntData();--战斗开始时间
			--获得一个服务器当前时间
			-- data.currentServerTime = data.executeTime;--msg:ReadIntData();--服务器时间时间
			if Data_Battle.BattleType == Data_Battle.CONST_BATTLE_TYPE_VCR then
				data.executeTime = os.time();
				data.currentServerTime = os.time();
				g_time = os.time() - data.currentServerTime;
			end
			print(" eFDT_Begin:",data.executeTime)
			--服务器时间
			
			Data_Battle_Msg:setBattlefieldStartTime( data.executeTime )
			print("战斗日志==>收到eFDT_Begin:",data.currentServerTime,g_time)
			-- data.executeTime = 0;
		elseif data.eventType == eFDT_AddAttacker then
			data.executeTime = msg:ReadIntData();--添加时间
			data.executeTime = Data_Battle_Msg:getServerExecuteTime( data.executeTime )--转换为执行时间
			data.name = msg:ReadString();--玩家名称
			data.num = msg:ReadIntData();--数量
			Data_Battle_Msg:addPlayer(data);--添加玩家显示
		elseif data.eventType == eFDT_AddUnit then
			local extime = msg:ReadIntData();--执行时间
			data.executeTime = Data_Battle_Msg:getServerExecuteTime( extime )
			data.unitType = msg:ReadIntData();--单位类型
			data.templateID = msg:ReadIntData();--模板ID
			data.guid = msg:ReadIntData();--单位ID
			data.playername = msg:ReadString();--单位属于玩家名称
			data.camp = msg:ReadIntData();--正营
			data.x = msg:ReadIntData();
			data.y = msg:ReadIntData();
			
			print(" eFDT_AddUnit:",data.guid,data.executeTime,extime,os.time(),data.unitType,data.templateID,data.x,data.y,data.playername,data.camp)
		elseif data.eventType == eFDT_Do then
			local extime = msg:ReadIntData();
			data.executeTime = Data_Battle_Msg:getServerExecuteTime( extime )
			Data_Battle_Msg.resourceSumValuse = msg:ReadIntData();
			Data_Battle_Msg.resourceSurplusValuse = Data_Battle_Msg.resourceSumValuse;
			print(" eFDT_Do:",data.executeTime,extime,Data_Battle_Msg.resourceSumValuse)
		elseif data.eventType == eFDT_Move then
			local extime = msg:ReadIntData();
			data.executeTime = Data_Battle_Msg:getServerExecuteTime( extime )
			data.guid = msg:ReadIntData();--单位ID
			data.x = msg:ReadIntData();--目标点
			data.y = msg:ReadIntData();
			data.moveType = "server";
			print(" eFDT_Move:",data.guid,data.executeTime,extime,data.x,data.y)
		elseif data.eventType == eFDT_Atk then
			local extime = msg:ReadIntData();
			data.executeTime = Data_Battle_Msg:getServerExecuteTime( extime )
			data.attackGuid = msg:ReadIntData();--攻击单位
			data.HurtCount = 1;
			data.buffCount = 0;
			data.AimData = {};
			local aim1 = {};
			aim1.IsHurt = 1;
			aim1.miss = 0;
			aim1.crit = 0;
			aim1.bufcount = 0;
			aim1.aimtype = 1;
			aim1.aimGuid = msg:ReadIntData();--目标单位
			data.attack_x = msg:ReadIntData();--目标点
			data.attack_y = msg:ReadIntData();
			aim1.aim_x = msg:ReadIntData();--目标点
			aim1.aim_y = msg:ReadIntData();
			aim1.hurtvaluse = msg:ReadIntData();
			aim1.bufID = 0;
			aim1.Hp = msg:ReadIntData();--剩余hp值
			Data_Battle_Msg.resourceSurplusValuse = msg:ReadIntData();--剩余资源
			data.AimData[1] = aim1;
			data.HurtData = data.AimData;
			print(" eFDT_Atk:",data.attackGuid,aim1.aimGuid,data.executeTime,extime,data.attack_x,data.attack_y,aim1.aim_x,aim1.aim_y,aim1.hurtvaluse,aim1.Hp,Data_Battle_Msg.resourceSurplusValuse)
		elseif data.eventType == eFDT_End then
			data.executeTime = msg:ReadIntData();
			data.executeTime = Data_Battle_Msg:getServerExecuteTime( data.executeTime )
			print(" eFDT_End:",data.executeTime)
			if Data_Battle.BattleType ~= Data_Battle.CONST_BATTLE_TYPE_VCR then
				break;
			end
		elseif data.eventType == eFDT_LostLog then
			local result = {}
			local num = msg:ReadIntData();--损失数量
			result.num = num;
			for i=1,num do
				local build = {};
				build.buildType = msg:ReadIntData();
				build.haveID = msg:ReadString();
				build.resNum = msg:ReadIntData();
				result[i] = build;
				if build.haveID == MAIN_PLAYER.baseAttr:getGUID() then
					Data_Battle_Msg.VCRResult = resNum;
				end
			end
			break;
		elseif data.eventType == eFDT_Block then
			--结束流
			data.executeTime = msg:ReadIntData();--当前战斗进行时间 --服务器时间时间
			data.currentServerTime = data.executeTime;
			if Data_Battle.BattleType == Data_Battle.CONST_BATTLE_TYPE_VCR then
				data.executeTime = os.time();
				data.currentServerTime = os.time();
			end
			if Data_Battle_Msg.LoadInviData <= 0 then
				g_time = os.time() - data.currentServerTime;
			end
			
			Data_Battle_Msg:analysisCombatSchedule();
			print(" eFDT_Block:",data.executeTime)
			break;
		end
		Data_Battle_Msg:register_event_add( {_usedata = {data}} )
	end
	
	Data_Battle_Msg:analysisCombatSchedule();
	
end

--收到刷怪结果消息
Msg_Logic[MSG_S2C_FIGHT_HuntingResult] = function ( tcp, msg )
	if not Data_Battle.isReceiveMsg then
		return;
	end
	--收到开始战斗结果消息
	local result = {}
	result.result = msg:ReadIntData();
	result.gold = msg:ReadIntData();
	result.exp = msg:ReadIntData();
	--显示战斗结果battlefield
	dispatchGlobaleEvent("battlefield", "create_result", {nil,result});
	print("网路日志", "收到刷怪战斗结果消息：MSG_S2C_FIGHT_HuntingResult",result)
end


--开始战斗结果消息
Msg_Logic[MSG_S2C_FIGHT_ErrorInfo] = function ( tcp, msg )
	if not Data_Battle.isReceiveMsg then
		return;
	end
	--收到开始战斗结果消息
	local result = msg:ReadIntData();
	print("网路日志", "收到战斗错误消息：MSG_S2C_FIGHT_ErrorInfo",result)
	if result == ICCR_NumLimit then
		--元宝刷怪
		UIManager:CreatePrompt_Operate_1( {
                mark = "build_delete",--接口类型标示
                title = "确认提示",--标题
                content = "   本区域没有怪物了,到其它区域看看吧!也可以花费10U币吸引一波怪物!",--描述文字
                eventlogic = "",--绑定逻辑
                eventlist = "",--注册事件列表
                displayType = 1,
                listenButton = function ( result )
                    -- 1 表示选择1按钮 2表示选择按钮
                    if result == 1 then
                        printInfo("网路日志 %s","发送探索消息信息 MSG_C2S_FIGHT_Hunting")
        				gameTcp:SendMessage(MSG_C2S_FIGHT_Hunting,{1})
                    end
                end
            } )
	else
		UIManager:CreatePrompt_Bar( {
				content = getErrorDescribe( result )
			} )
	end
	
end

Msg_Logic[MSG_S2C_FIGHT_DelSoldier] = function ( tcp, msg )
	if not Data_Battle.isReceiveMsg then
		return;
	end
	--收到开始战斗结果消息
	local id = msg:ReadIntData();
	MAIN_PLAYER:getsolderManager():set_solderNum( id ,-1)

	--更新显示
	dispatchGlobaleEvent("controler_battle_ui_attack_bottom", "update_soldier", {id});
	print("网路日志", "收到战斗删除创建角色消息消息：MSG_S2C_FIGHT_DelSoldier:",id)
end

---------------掠夺战-------------------------

--攻城战准备时间
Msg_Logic[MSG_S2C_FIGHT_AttackReady] = function ( tcp, msg )
	local data = {};
	data.guildKey = msg:ReadString();--工会key
	data.plot_x = msg:ReadIntData();
	data.plot_y = msg:ReadIntData();
	data.time = msg:ReadIntData();
	print("网络日志","收到战斗准备消息：MSG_S2C_FIGHT_AttackReady",data.guildKey,data.time,data.plot_x,data.plot_y)
	dispatchGlobaleEvent("battlefield", "guild_msg", data);
end

--收到进入攻城战加入消息
Msg_Logic[MSG_S2C_FIGHT_Join] = function ( tcp, msg )
	Data_Battle.isReceiveMsg = true;
	Data_Battle:setBattlefieldType( Data_Battle.CONST_BATTLE_TYPE_GUILDACT );
	print("网络日志","收到攻城战进入消息：MSG_S2C_FIGHT_Join")

end



Msg_Logic[MSG_S2C_FIGHT_AttackBegin] = function ( tcp, msg )
	if not Data_Battle.isReceiveMsg then
		return;
	end
	--收到开始战斗结果消息
	local plot_x = msg:ReadIntData();
	local plot_y = msg:ReadIntData();
	
	Data_Battle.plot_x = plot_x;
	Data_Battle.plot_y = plot_y;
	
	print("网路日志", "收到收到掠夺战开始消息：MSG_S2C_FIGHT_AttackBegin:",x,y)
end

Msg_Logic[MSG_S2C_FIGHT_RobResult] = function ( tcp, msg )
	if not Data_Battle.isReceiveMsg then
		return;
	end
	--收到开始战斗结果消息
	local result = {}
	result.gold = msg:ReadIntData();
	result.result = 1;
	result.exp = 0;
	dispatchGlobaleEvent("battlefield", "create_result", {nil,result});
	print("网路日志", "收到收到掠夺战结果消息：MSG_S2C_FIGHT_RobResult:",result.result)
end


--[[攻城战结果
]]
Msg_Logic[MSG_S2C_FIGHT_AttackResult] = function ( tcp, msg )
	if not Data_Battle.isReceiveMsg then
		return;
	end
	local result = {}
	result.result = msg:ReadIntData();
	result.gold = msg:ReadIntData();
	result.exp = 0;
	--显示战斗结果battlefield
	dispatchGlobaleEvent("battlefield", "create_result", {nil,result});
	print("网路日志", "收到攻城战结果消息：MSG_S2C_FIGHT_AttackResult",result.result)
end

--收到观看录像消息结果
Msg_Logic[MSG_S2C_FIGHT_Replay] = function ( tcp, msg )
	Data_Battle.isReceiveMsg = true;
	Data_Battle:setBattlefieldType( Data_Battle.CONST_BATTLE_TYPE_VCR );

	print("网络日志","收到战斗录像消息：MSG_S2C_FIGHT_Replay")

	-- local sum =  msg:ReadIntData();
	local sum = 1000;
	local fightStart = {};
	for i=1,sum do
		local data = {};
		data.eventType = msg:ReadIntData();
		data.index = msg:ReadIntData();
		print("====>",data.index,data.eventType)
		if data.eventType == eFDT_Begin then
			data.executeTime = msg:ReadIntData();--战斗开始时间
			--获得一个服务器当前时间
			-- data.currentServerTime = data.executeTime;--msg:ReadIntData();--服务器时间时间
			if Data_Battle.BattleType == Data_Battle.CONST_BATTLE_TYPE_VCR then
				data.executeTime = os.time();
				data.currentServerTime = os.time();
				g_time = os.time() - data.currentServerTime;
			end
			print(" eFDT_Begin:",data.executeTime)
			--服务器时间
			
			Data_Battle_Msg:setBattlefieldStartTime( data.executeTime )
			print("战斗日志==>收到eFDT_Begin:",data.currentServerTime,g_time)
			-- data.executeTime = 0;
		elseif data.eventType == eFDT_AddAttacker then
			data.executeTime = msg:ReadIntData();--添加时间
			data.executeTime = Data_Battle_Msg:getServerExecuteTime( data.executeTime )--转换为执行时间
			data.name = msg:ReadString();--玩家名称
			data.num = msg:ReadIntData();--数量
			Data_Battle_Msg:addPlayer(data);--添加玩家显示
		elseif data.eventType == eFDT_AddUnit then
			local extime = msg:ReadIntData();--执行时间
			data.executeTime = Data_Battle_Msg:getServerExecuteTime( extime )
			data.unitType = msg:ReadIntData();--单位类型
			data.templateID = msg:ReadIntData();--模板ID
			data.guid = msg:ReadIntData();--单位ID
			data.playername = msg:ReadString();--单位属于玩家名称
			data.camp = msg:ReadIntData();--正营
			data.x = msg:ReadIntData();
			data.y = msg:ReadIntData();
			
			print(" eFDT_AddUnit:",data.guid,data.executeTime,extime,os.time(),data.unitType,data.templateID,data.x,data.y,data.playername,data.camp)
		elseif data.eventType == eFDT_Do then
			local extime = msg:ReadIntData();
			data.executeTime = Data_Battle_Msg:getServerExecuteTime( extime )
			Data_Battle_Msg.resourceSumValuse = msg:ReadIntData();
			Data_Battle_Msg.resourceSurplusValuse = Data_Battle_Msg.resourceSumValuse;
			print(" eFDT_Do:",data.executeTime,extime,Data_Battle_Msg.resourceSumValuse)
		elseif data.eventType == eFDT_Move then
			local extime = msg:ReadIntData();
			data.executeTime = Data_Battle_Msg:getServerExecuteTime( extime )
			data.guid = msg:ReadIntData();--单位ID
			data.x = msg:ReadIntData();--目标点
			data.y = msg:ReadIntData();
			data.moveType = "server";
			print(" eFDT_Move:",data.guid,data.executeTime,extime,data.x,data.y)
		elseif data.eventType == eFDT_Atk then
			local extime = msg:ReadIntData();
			data.executeTime = Data_Battle_Msg:getServerExecuteTime( extime )
			data.attackGuid = msg:ReadIntData();--攻击单位
			data.HurtCount = 1;
			data.buffCount = 0;
			data.AimData = {};
			local aim1 = {};
			aim1.IsHurt = 1;
			aim1.miss = 0;
			aim1.crit = 0;
			aim1.bufcount = 0;
			aim1.aimtype = 1;
			aim1.aimGuid = msg:ReadIntData();--目标单位
			data.attack_x = msg:ReadIntData();--目标点
			data.attack_y = msg:ReadIntData();
			aim1.aim_x = msg:ReadIntData();--目标点
			aim1.aim_y = msg:ReadIntData();
			aim1.hurtvaluse = msg:ReadIntData();
			aim1.bufID = 0;
			aim1.Hp = msg:ReadIntData();--剩余hp值
			Data_Battle_Msg.resourceSurplusValuse = msg:ReadIntData();--剩余资源
			data.AimData[1] = aim1;
			data.HurtData = data.AimData;
			print(" eFDT_Atk:",data.attackGuid,aim1.aimGuid,data.executeTime,extime,data.attack_x,data.attack_y,aim1.aim_x,aim1.aim_y,aim1.hurtvaluse,aim1.Hp,Data_Battle_Msg.resourceSurplusValuse)
		elseif data.eventType == eFDT_End then
			data.executeTime = msg:ReadIntData();
			data.executeTime = Data_Battle_Msg:getServerExecuteTime( data.executeTime )
			print(" eFDT_End:",data.executeTime)
			if Data_Battle.BattleType ~= Data_Battle.CONST_BATTLE_TYPE_VCR then
				break;
			end
		elseif data.eventType == eFDT_LostLog then
			
			local result = {}
			local num = msg:ReadIntData();--损失数量
			result.num = num;
			result.fightType = Data_Battle.CONST_BATTLE_TYPE_VCR;
			print(" eFDT_LostLog:",num)
			result.resValuse = 0;
			for i=1,num do
				local build = {};
				build.buildType = msg:ReadIntData();
				build.haveID = msg:ReadString();
				build.resNum = msg:ReadIntData();
				
				if build.haveID == MAIN_PLAYER.baseAttr:getGUID() then
					result.resValuse = build.resNum;
				end
				-- print(build.haveID,"===",MAIN_PLAYER.baseAttr:getGUID(),build.resNum,result.resValuse)
			end
			Data_Battle_Msg.VCRResult = result;
			break;
		elseif data.eventType == eFDT_Block then
			--结束流
			data.executeTime = msg:ReadIntData();--当前战斗进行时间 --服务器时间时间
			data.currentServerTime = data.executeTime;
			if Data_Battle.BattleType == Data_Battle.CONST_BATTLE_TYPE_VCR then
				data.executeTime = os.time();
				data.currentServerTime = os.time();
			end
			g_time = os.time() - data.currentServerTime;
			Data_Battle_Msg:analysisCombatSchedule();
			print(" eFDT_Block:",data.executeTime)
			break;
		end
		Data_Battle_Msg:register_event_add( {_usedata = {data}} )
	end
	
	Data_Battle_Msg:analysisCombatSchedule();

end




