--
-- Author: Wu Hengmin
-- Date: 2014-06-23 17:20:57
--


Msg_Logic[MSG_MS2C_PVP_INFO_RE] = function ( tcp , msg  )
	printLog("网路日志", "竞技场基本信息")
	MAIN_PLAYER.JJCManager.rank = msg:ReadIntData()
	printLog("网路日志", "排名:"..MAIN_PLAYER.JJCManager.rank)
	gameTcp:SendMessage(MSG_C2MS_PVP_GET_TARGET)
end

-- 获取竞技场排行信息
Msg_Logic[MSG_MS2C_PVP_RANK_INFO_RE] = function ( tcp , msg  )
	printLog("网路日志", "获取玩家排名信息")
	local count = msg:ReadIntData()
	printLog("网路日志", "获取玩家排名信息,数量："..count)

	for i=1,count do
		local rank = msg:ReadIntData()
		local script = msg:ReadString()
		MAIN_PLAYER.JJCManager.rankplayer[i] = {rank = rank, data = unserialize(script)}
		printLog("网路日志", "排名:"..rank)
	end

	table.sort(MAIN_PLAYER.JJCManager.rankplayer, function (a, b)
		-- body
		return a.rank > b.rank
	end)

	dispatchGlobaleEvent("netMsg", tostring(MSG_MS2C_PVP_RANK_INFO_RE))
end

-- 获取可挑战玩家信息
Msg_Logic[MSG_MS2C_PVP_TARGET_RE] = function ( tcp , msg  )
	printLog("网路日志", "获取可挑战玩家信息")
	local count = msg:ReadIntData()
	printLog("网路日志", "获取可挑战玩家信息,数量："..count)

	for i=1,count do
		local rank = msg:ReadIntData()
		local script = msg:ReadString()
		MAIN_PLAYER.JJCManager.targetplayer[i] = {rank = rank, data = unserialize(script)}
		printLog("网路日志", "排名:"..rank)
	end

	table.sort(MAIN_PLAYER.JJCManager.targetplayer, function (a, b)
		-- body
		return a.rank > b.rank
	end)

	dispatchGlobaleEvent("netMsg", tostring(MSG_MS2C_PVP_TARGET_RE))
end

-- 更新一个PVP的次数信息
Msg_Logic[MSG_MS2C_PVP_PLAY_NUM_UDDATE] = function ( tcp , msg  )
	printLog("网路日志", "更新一个PVP的次数信息")
	MAIN_PLAYER.JJCManager.atttime = msg:ReadIntData()
	MAIN_PLAYER.JJCManager.getatk = msg:ReadIntData()
	printLog("网路日志", "可挑战次数:"..MAIN_PLAYER.JJCManager.atttime.."已购买次数:"..MAIN_PLAYER.JJCManager.getatk)
	dispatchGlobaleEvent("netMsg", tostring(MSG_MS2C_PVP_PLAY_NUM_UDDATE))
end

--[[ 竞技场战斗结果通知
*
*	int		操作结果
*	如果操作成功：
*	int		结果 1=胜利 0=失败
*	
]]
Msg_Logic[MSG_MS2C_PVP_PLAY_RESULT] = function ( tcp , msg  )
	printLog("网路日志", "竞技场战斗结果通知")
	local result = msg:ReadIntData()
	-- MAIN_PLAYER.JJCManager.rank = msg:ReadIntData()
	-- printLog("网路日志", "排名:"..MAIN_PLAYER.JJCManager.rank)
	if result == ePVP_Succed then
		local playresult = msg:ReadIntData()
		if playresult == 1 then
			print("赢")

		elseif playresult == 0 then
			print("输")
		end
		MAIN_PLAYER.JJCManager:AddLog(playresult)

		-- 战斗数据
		local battledata = Data_Battle_Msg:analysisBattleData( msg ,Data_Battle.CONST_BATTLE_TYPE_JJC , MAIN_PLAYER.baseAttr._name.." VS "..PVPQC);
		local ResultData = {
			result = battledata.battleResult,
			score = 0,
			AttackSumHurt = battledata.AttackSumHurt,
			sumBout = 30,--总回合数
			boutCount = battledata.MaxBoutCount,--回合数
			nextprompt = "竞技场战斗结束", --下一场战斗提示
			countdown = 5,--倒计时
			dropout = {},--掉落
		};
		battledata.ResultData = ResultData;
		--发送挂机战斗结果消息
		dispatchGlobaleEvent("netMsg", "jjc_result",{battledata})
		-----------------------------------------------------------------
		-- 奖励数据 --
		local count = msg:ReadIntData()
		local tmpdata = {}
		for i=1,count do
			local type_ = msg:ReadIntData()
			local id = msg:ReadIntData()
			local lv = msg:ReadIntData()
			local num = msg:ReadIntData()
			printLog("网路日志", "奖励数据type = "..type_.." id = "..id.." num = "..num)
			table.insert(tmpdata, {ID = id, type_ = type_, num = num, lv = lv})
		end
		if count > 0 then
			UIManager:JJCSave(tmpdata)
		end

		gameTcp:SendMessage(MSG_C2MS_PVP_GET_TARGET)
	elseif ePVP_TargetErr == result then
		print("竞技场错误",result)
		dispatchGlobaleEvent( "battlefield" ,"executebattle_fail")
	else
		print(getErrorDescribe( result ))
	end

	-- 重新请求竞技场信息

end


--[[ 购买商品
*
*	int 结果
]]
Msg_Logic[MSG_MS2C_PVP_BUY_GOODS] = function ( tcp , msg  )
	printLog("网路日志", "购买商品")
	local result = msg:ReadIntData()
	if ePVP_Succed == result then
		-- UIManager:CreatePrompt_Bar( {content = "购买成功"})
	else
		local errorDec = getErrorDescribe( result ) or "未知错误"
		UIManager:CreatePrompt_Bar( {content = errorDec})
	end
	dispatchGlobaleEvent("netMsg", tostring(MSG_MS2C_PVP_BUY_GOODS))
end



Msg_Logic[MSG_MS2C_PVP_BUY_PLAY_NUM_RE] = function ( tcp , msg  )
	printLog("网路日志", "购买次数")
	local result = msg:ReadIntData()
	if ePVP_Succed == result then
		UIManager:CreatePrompt_Bar( {content = "购买成功"})
	else
		local errorDec = getErrorDescribe( result ) or "未知错误"
		UIManager:CreatePrompt_Bar( {content = errorDec})
	end
end

-- 挑战错误提示信息
Msg_Logic[MSG_MS2C_PVP_PLAY_ERROR] = function ( tcp , msg  )
	printLog("网路日志", "挑战错误提示信息")
	printLog("网路日志", getErrorDescribe( result ))
end
