--
-- Author: zkz
-- Date: 2014-03-24 10:17:34
-- BUFF效果配置


--取得BUFF
function GetBuff(buff_key)
	if GET_CONFIG_CHECK and nil == BuffConfig[buff_key] then
		print_log(debug.traceback());
		print_log("Not found buff("..buff_key..")");
		return BuffConfig[0];
	end
	return BuffConfig[buff_key];
end

--[[
	BUFF属性说明：

	name				BUFF名字

	turns				持续回合数

	removeable			可否被清除

	superposition		最大叠加层数

	breakable			可否被打断

	--得到效果表
	get_effect(this, attacker, target)

	--战斗单位响应添加buff
	--返回处理后的效果表
	on_add(this, battle_unit, effect, last_effect)

	--战斗单位响应移除buff
	on_remove(this, battle_unit, effect)

	--战斗单位响应回合执行
	on_bout_begin(this, battle_unit, effect)

	--伤害响应
	on_damage = function (this, damage, self_pos, self_array, attacker_pos, attacker_array, effect)
		-- body
	end
		返回值
		{
			--伤害修改
			change_damage,
			--此buff已取消标记
			cancel,
			
			--反击效果数组
			strike_backs
			{
				--目标方位（true=己方，false=敌方）
				is_self, 
				--目标位置
				pos,

				--基本伤害
				damage_base,
				--伤害倍率
				damage_scale,
				--是否神圣伤害
				holy,
				--剩余血量
				odd_hp,
				--buff
				add_buff_id,
			},
		}

	
					

]]


--控制BUFF_ID记录，用于不吃控制的判定
CtrlBuffID = 
{
	[2201] = true,
	[2202] = true,
	[2401] = true,
};

--眩晕BUFF_ID记录，用于不吃眩晕的判定
FreezeBuffID =
{
	[2201] = true,
	[2202] = true,
};

--自身复活的BUFF_ID记录，用于相关判定
SelfReliveBuffID =
{
	[1716] = true,
};

--得到buf显示效果颜色值
function getBuffEffectColor( index )
	if index == 1 then
		return cc.c4b(0, 255, 0, 255);
	elseif index == 2 then
		return cc.c4b(255, 0, 0, 255);
	end
end

--BUFF数据
BuffConfig = 
{
	[0] = 
	{
		name = "无效BUFF",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 1,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
		end,
	},

	[1301] = 
	{
		name = "无敌",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 1,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			--非覆盖情况，添加计数
			if not last_effect then
				battle_unit.state.invincible_count = battle_unit.state.invincible_count + 1;
				battle_unit.state.buff_invincible_count = battle_unit.state.buff_invincible_count + 1;
			end
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.invincible_count = battle_unit.state.invincible_count - 1;
			battle_unit.state.buff_invincible_count = battle_unit.state.buff_invincible_count - 1;
		end,
	},

	[1302] = 
	{
		name = "免伤60%+3%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "减免伤害"},
		},
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 0.6 + attacker:SkillLv() * 0.03;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		--伤害响应
		on_damage = function (this, damage, self_pos, self_array, attacker_pos, attacker_array, effect)
			if 0 > damage then
				return 
				{
					change_damage = -damage * effect,
					strike_backs = {},
				};
			end
		end
	},

	[1303] = 
	{
		name = "无敌 + 不吃BUFF",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			--非覆盖情况，添加计数
			if not last_effect then
				battle_unit.state.invincible_count = battle_unit.state.invincible_count + 1;
				battle_unit.state.buff_invincible_count = battle_unit.state.buff_invincible_count + 1;
				battle_unit.state.cant_buff_count = battle_unit.state.cant_buff_count + 1;
			end
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.invincible_count = battle_unit.state.invincible_count - 1;
			battle_unit.state.buff_invincible_count = battle_unit.state.buff_invincible_count - 1;
			battle_unit.state.cant_buff_count = battle_unit.state.cant_buff_count - 1;
		end,
	},

	[1304] = 
	{
		name = "打击无敌（BUFF可以造成伤害）",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			--非覆盖情况，添加计数
			if not last_effect then
				battle_unit.state.invincible_count = battle_unit.state.invincible_count + 1;
			end
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.invincible_count = battle_unit.state.invincible_count - 1;
		end,
	},

	[1501] = 
	{
		name = "暴击、暴伤叠加 +5",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "暴击叠加"},
			{color = 1,des = "暴伤叠加"},
		},
		CastingBufIcon = {5001,5009},
		turns = 30,
		OverlapName = "爆伤",
		max_overlap = 5,

		get_effect = function (this, attacker, target)
			return 0.1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 叠加，技能覆盖
			if last_effect then
				if this.max_overlap > overlap_num then
					-- 添加本次效果
					battle_unit.state.delta_crit = battle_unit.state.delta_crit + effect;
					battle_unit.state.delta_crit_damage = battle_unit.state.delta_crit_damage + effect;
					-- 总变化量记录
					effect = effect + last_effect;
				else
					effect = last_effect;
				end
			else
				battle_unit.state.delta_crit = battle_unit.state.delta_crit + effect;
				battle_unit.state.delta_crit_damage = battle_unit.state.delta_crit_damage + effect;
			end
			
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_crit = battle_unit.state.delta_crit - effect;
			battle_unit.state.delta_crit_damage = battle_unit.state.delta_crit_damage - effect;
		end,
	},

	[1502] = 
	{
		name = "闪避提升叠加",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "闪避叠加"},
		},
		CastingBufIcon = {5004},
		turns = 30,
		OverlapName = "闪避",
		max_overlap = 10,

		get_effect = function (this, attacker, target)
			return 0.03;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 叠加，技能覆盖
			if last_effect then
				if this.max_overlap > overlap_num then
					-- 添加本次效果
					battle_unit.state.delta_miss = battle_unit.state.delta_miss + effect;
					-- 总变化量记录
					effect = effect + last_effect;
				else
					effect = last_effect;
				end
			else
				battle_unit.state.delta_miss = battle_unit.state.delta_miss + effect;
			end
			
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_miss = battle_unit.state.delta_miss - effect;
		end,
	},

	[1503] = 
	{
		name = "闪避提升",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "闪避提升"},
		},
		CastingBufIcon = {5004},
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 0.1 + attacker:SkillLv() * 0.005;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_miss = battle_unit.state.delta_miss - last_effect;
			end
			-- 添加本次效果
			battle_unit.state.delta_miss = battle_unit.state.delta_miss + effect;
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_miss = battle_unit.state.delta_miss - effect;
		end,
	},

	[1504] = 
	{
		name = "巨象（不吃眩晕）",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 30,	

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			--非覆盖情况，添加计数
			if not last_effect then
				battle_unit.state.cant_freeze_count = battle_unit.state.cant_freeze_count + 1;
			end
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.cant_freeze_count = battle_unit.state.cant_freeze_count - 1;
		end,
	},

	[1505] = 
	{
		name = "攻击提升",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "攻击提升"},
		},
		CastingBufIcon = {5002},
		turns = 1,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return target:Atk() * (0.10 + attacker:SkillLv() * 0.005);
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_atk = battle_unit.state.delta_atk - last_effect;
			end
			-- 添加本次效果
			battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_atk = battle_unit.state.delta_atk - effect;
		end,
	},

	[1506] = 
	{
		name = "命中闪避提升",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "闪避提升"},
			{color = 1,des = "命中提升"},
		},
		CastingBufIcon = {5004,5003},
		turns = 30,
		OverlapName = "爆闪",
		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 0.05 + attacker:SkillLv() * 0.0025;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_miss = battle_unit.state.delta_miss - last_effect;
				battle_unit.state.delta_hit = battle_unit.state.delta_crit - last_effect;
			end
			-- 添加本次效果
			battle_unit.state.delta_miss = battle_unit.state.delta_miss + effect;
			battle_unit.state.delta_hit = battle_unit.state.delta_hit + effect;
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_miss = battle_unit.state.delta_miss - effect;
			battle_unit.state.delta_crit = battle_unit.state.delta_crit - effect;
		end,
	},

	[1508] = 
	{
		name = "攻击提升（叠加）",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "攻击提升"},
			{color = 1,des = "攻击叠加"},
		},
		CastingBufIcon = {5002},
		turns = 2,
		OverlapName = "攻+15%",
		max_overlap = 5,

		get_effect = function (this, attacker, target)
			return target:Atk() * (0.15 + attacker:SkillLv() * 0.0075);
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 叠加，技能覆盖
			if last_effect then
				if this.max_overlap > overlap_num then
					-- 添加本次效果
					battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
					-- 总变化量记录
					effect = effect + last_effect;
				else
					effect = last_effect;
				end
			else
				battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
			end
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_atk = battle_unit.state.delta_atk - effect;
		end,
	},

	[1509] = 
	{
		name = "防御提升10% +0.5%(叠加)",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "防御提升"},
			{color = 1,des = "防御叠加"},
		},
		CastingBufIcon = {5006},
		turns = 30,
		OverlapName = "防+10%",
		max_overlap = 6,

		get_effect = function (this, attacker, target)
			return 
			{
				target:PDef() * (0.1 + attacker:SkillLv() * 0.005),
				target:MDef() * (0.1 + attacker:SkillLv() * 0.005),
			};
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 叠加，技能覆盖
			if last_effect then
				if this.max_overlap > overlap_num then
					-- 添加本次效果
					battle_unit.state.delta_pdef = battle_unit.state.delta_pdef + effect[1];
					battle_unit.state.delta_mdef = battle_unit.state.delta_mdef + effect[2];
					-- 总变化量记录
					effect[1] = effect[1] + last_effect[1];
					effect[2] = effect[2] + last_effect[2];
				else
					effect = last_effect;
				end
			else
				battle_unit.state.delta_pdef = battle_unit.state.delta_pdef + effect[1];
				battle_unit.state.delta_mdef = battle_unit.state.delta_mdef + effect[2];
			end
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - effect[1];
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - effect[2];
		end,
	},

	[1510] = 
	{
		name = "生命提升5% + 0.25%（叠加）",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "生命提升"},
			{color = 1,des = "生命叠加"},
		},
		CastingBufIcon = {5005},
		turns = 30,
		OverlapName = "HP+5%",
		max_overlap = 6,

		get_effect = function (this, attacker, target)
			return target:BaseHp() * (0.1 + attacker:SkillLv() * 0.005);
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 叠加，技能覆盖
			if last_effect then
				if this.max_overlap > overlap_num then
					-- 添加本次效果
					battle_unit.state.delta_hp = battle_unit.state.delta_hp + effect;
					battle_unit.state.hp = battle_unit.state.hp + effect;
					-- 总变化量记录
					effect = effect + last_effect;
				else
					effect = last_effect;
				end
			else
				battle_unit.state.delta_hp = battle_unit.state.delta_hp + effect;
				battle_unit.state.hp = battle_unit.state.hp + effect;
			end
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_hp = battle_unit.state.delta_hp - effect;
		end,
	},

	[1511] = 
	{
		name = "攻击提升（叠加）",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "攻击提升"},
			{color = 1,des = "攻击叠加"},
		},
		CastingBufIcon = {5002},
		turns = 30,
		OverlapName = "攻+5%",
		max_overlap = 6,

		get_effect = function (this, attacker, target)
			return target:Atk() * (0.05 + attacker:SkillLv() * 0.0025);
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 叠加，技能覆盖
			if last_effect then
				if this.max_overlap > overlap_num then
					-- 添加本次效果
					battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
					-- 总变化量记录
					effect = effect + last_effect;
				else
					effect = last_effect;
				end
			else
				battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
			end
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_atk = battle_unit.state.delta_atk - effect;
		end,
	},

	[1512] = 
	{
		name = "防御提升",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "防御提升"},
		},
		CastingBufIcon = {5006},
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 
			{
				target:PDef() * (0.2 + attacker:SkillLv() * 0.01),
				target:MDef() * (0.2 + attacker:SkillLv() * 0.01),
			};
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - last_effect[1];
				battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - last_effect[2];
			end
			-- 添加本次效果
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef + effect[1];
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef + effect[2];
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - effect[1];
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - effect[2];
		end,
	},

	[1513] = 
	{
		name = "攻击、防御提升",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "攻击提升"},
			{color = 1,des = "防御提升"},
		},
		CastingBufIcon = {5002,5006},
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 
			{
				target:Atk() * (0.05 + attacker:SkillLv() * 0.0025),
				target:PDef() * (0.05 + attacker:SkillLv() * 0.0025),
				target:MDef() * (0.05 + attacker:SkillLv() * 0.0025),
			};
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_atk = battle_unit.state.delta_atk - last_effect[1];
				battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - last_effect[2];
				battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - last_effect[3];
			end
			-- 添加本次效果
			battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect[1];
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef + effect[2];
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef + effect[3];
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_atk = battle_unit.state.delta_atk - effect[1];
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - effect[2];
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - effect[3];
		end,
	},

	[1514] = 
	{
		name = "攻击提升",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "攻击提升"},
		},
		CastingBufIcon = {5002},
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return target:Atk() * (0.1 + attacker:SkillLv() * 0.005);
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_atk = battle_unit.state.delta_atk - last_effect;
			end
			-- 添加本次效果
			battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_atk = battle_unit.state.delta_atk - effect;
		end,
	},

	[1515] = 
	{
		name = "物理免伤20% +1%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "物伤减免"},
		},
		CastingBufIcon = {5006},
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 0.2 + 0.01 * attacker:SkillLv();
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		--伤害响应
		on_damage = function (this, damage, self_pos, self_array, attacker_pos, attacker_array, effect)
			if 0 > damage and eHT_Physical == attacker_array[attacker_pos]:AtkType() then
				return 
				{
					change_damage = -damage * effect,
					strike_backs = {},
				};
			end
		end
	},

	[1516] = 
	{
		name = "法抗提升",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "法抗提升"},
		},
		CastingBufIcon = {5006},
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return target:MDef() * (0.2 + attacker:SkillLv() * 0.01);
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - last_effect;
			end
			-- 添加本次效果
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef + effect;
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - effect;
		end,
	},

	[1517] = 
	{
		name = "攻击提升 +10",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "攻击提升"},
		},
		CastingBufIcon = {5002},
		turns = 30,
		OverlapName = "攻+20%",
		max_overlap = 5,

		get_effect = function (this, attacker, target)
			return target:Atk() * (0.2 + attacker:SkillLv() * 0.01);
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 叠加，技能覆盖
			if last_effect then
				if this.max_overlap > overlap_num then
					-- 添加本次效果
					battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
					-- 总变化量记录
					effect = effect + last_effect;
				else
					effect = last_effect;
				end
			else
				battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
			end
			
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_atk = battle_unit.state.delta_atk - effect;
		end,
	},

	[1518] = 
	{
		name = "物抗提升",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "物抗提升"},
		},
		CastingBufIcon = {5006},
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return target:PDef() * (0.2 + attacker:SkillLv() * 0.01);
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - last_effect;
			end
			-- 添加本次效果
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef + effect;
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - effect;
		end,
	},

	[1519] = 
	{
		name = "法术免伤20% +1%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "法伤减免"},
		},
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 0.2 + 0.01 * attacker:SkillLv();
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		--伤害响应
		on_damage = function (this, damage, self_pos, self_array, attacker_pos, attacker_array, effect)
			if 0 > damage and eHT_Magic == attacker_array[attacker_pos]:AtkType() then
				return 
				{
					change_damage = -damage * effect,
					strike_backs = {},
				};
			end
		end
	},

	[1520] = 
	{
		name = "暴击叠加 +5",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "暴击叠加"},
		},
		CastingBufIcon = {5001},
		turns = 30,
		OverlapName = "暴+5%",
		max_overlap = 5,

		get_effect = function (this, attacker, target)
			return 0.1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 叠加，技能覆盖
			if last_effect then
				if this.max_overlap > overlap_num then
					-- 添加本次效果
					battle_unit.state.delta_crit = battle_unit.state.delta_crit + effect;
					-- 总变化量记录
					effect = effect + last_effect;
				else
					effect = last_effect;
				end
			else
				battle_unit.state.delta_crit = battle_unit.state.delta_crit + effect;
			end
			
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_crit = battle_unit.state.delta_crit - effect;
		end,
	},

	[1521] = 
	{
		name = "防御提升15% +0.75%(叠加)",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "防御提升"},
			{color = 1,des = "防御叠加"},
		},
		CastingBufIcon = {5006},
		turns = 30,
		OverlapName = "防+15%",
		max_overlap = 6,

		get_effect = function (this, attacker, target)
			return 
			{
				target:PDef() * (0.15 + attacker:SkillLv() * 0.075),
				target:MDef() * (0.15 + attacker:SkillLv() * 0.075),
			};
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 叠加，技能覆盖
			if last_effect then
				if this.max_overlap > overlap_num then
					-- 添加本次效果
					battle_unit.state.delta_pdef = battle_unit.state.delta_pdef + effect[1];
					battle_unit.state.delta_mdef = battle_unit.state.delta_mdef + effect[2];
					-- 总变化量记录
					effect[1] = effect[1] + last_effect[1];
					effect[2] = effect[2] + last_effect[2];
				else
					effect = last_effect;
				end
			else
				battle_unit.state.delta_pdef = battle_unit.state.delta_pdef + effect[1];
				battle_unit.state.delta_mdef = battle_unit.state.delta_mdef + effect[2];
			end
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - effect[1];
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - effect[2];
		end,
	},

	[1522] = 
	{
		name = "攻击提升",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "攻击提升"},
		},
		CastingBufIcon = {5002},
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return target:Atk() * (0.2 + attacker:SkillLv() * 0.01);
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_atk = battle_unit.state.delta_atk - last_effect;
			end
			-- 添加本次效果
			battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_atk = battle_unit.state.delta_atk - effect;
		end,
	},

	[1523] = 
	{
		name = "命中提升",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "命中提升"},
		},
		CastingBufIcon = {5003},
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 0.1 + attacker:SkillLv() * 0.005;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_hit = battle_unit.state.delta_hit - last_effect;
			end
			-- 添加本次效果
			battle_unit.state.delta_hit = battle_unit.state.delta_hit + effect;
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_hit = battle_unit.state.delta_hit - effect;
		end,
	},

	[1527] = 
	{
		name = "防御提升",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "防御提升"},
		},
		CastingBufIcon = {5006},
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 
			{
				target:PDef() * (0.5 + attacker:SkillLv() * 0.025),
				target:MDef() * (0.5 + attacker:SkillLv() * 0.025),
			};
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - last_effect[1];
				battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - last_effect[2];
			end
			-- 添加本次效果
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef + effect[1];
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef + effect[2];
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - effect[1];
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - effect[2];
		end,
	},

	[1531] = 
	{
		name = "闪避提升",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "闪避提升"},
		},
		CastingBufIcon = {5004},
		turns = 1,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 0.5;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_miss = battle_unit.state.delta_miss - last_effect;
			end
			-- 添加本次效果
			battle_unit.state.delta_miss = battle_unit.state.delta_miss + effect;
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_miss = battle_unit.state.delta_miss - effect;
		end,
	},

	[1532] = 
	{
		name = "闪避提升",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "闪避提升"},
		},
		CastingBufIcon = {5004},
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 0.5;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_miss = battle_unit.state.delta_miss - last_effect;
			end
			-- 添加本次效果
			battle_unit.state.delta_miss = battle_unit.state.delta_miss + effect;
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_miss = battle_unit.state.delta_miss - effect;
		end,
	},

	[1533] = 
	{
		name = "防御提升100% +5%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "防御提升"},
		},
		CastingBufIcon = {5006},
		turns = 1,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 
			{
				target:PDef() * (1 + attacker:SkillLv() * 0.05),
				target:MDef() * (1 + attacker:SkillLv() * 0.05),
			};
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - last_effect[1];
				battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - last_effect[2];
			end
			-- 添加本次效果
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef + effect[1];
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef + effect[2];
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - effect[1];
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - effect[2];
		end,
	},

	[1536] = 
	{
		name = "提升暴击、暴击伤害",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "暴击提升"},
			{color = 1,des = "暴伤提升"},
		},
		CastingBufIcon = {5001},
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 0.1 + 0.005 * attacker:SkillLv() * 0.025;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			if last_effect then
				battle_unit.state.delta_crit = battle_unit.state.delta_crit - last_effect;
				battle_unit.state.delta_crit_damage = battle_unit.state.delta_crit_damage - last_effect;
			end
			-- 添加本次效果
			battle_unit.state.delta_crit = battle_unit.state.delta_crit + effect;
			battle_unit.state.delta_crit_damage = battle_unit.state.delta_crit_damage + effect;
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_crit = battle_unit.state.delta_crit - effect;
			battle_unit.state.delta_crit_damage = battle_unit.state.delta_crit_damage - effect;
		end,
	},

	[1538] = 
	{
		name = "提高200%防御",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "防御提升"},
		},
		CastingBufIcon = {5006},
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 
			{
				target:PDef() * 2,
				target:MDef() * 2,
			};
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - last_effect[1];
				battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - last_effect[2];
			end
			-- 添加本次效果
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef + effect[1];
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef + effect[2];
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - effect[1];
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - effect[2];
		end,
	},

	[1539] = 
	{
		name = "物抗提升",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "物抗提升"},
		},
		CastingBufIcon = {5006},
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return target:PDef() * (1 + attacker:SkillLv() * 0.05);
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - last_effect;
			end
			-- 添加本次效果
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef + effect;
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - effect;
		end,
	},

	[1540] = 
	{
		name = "物理免伤80%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "物伤减免"},
		},
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		--伤害响应
		on_damage = function (this, damage, self_pos, self_array, attacker_pos, attacker_array, effect)
			if 0 > damage and eHT_Physical == attacker_array[attacker_pos]:AtkType() then
				return 
				{
					change_damage = -damage * 0.8,
					strike_backs = {},
				};
			end
		end
	},

	[1541] = 
	{
		name = "法术免伤80%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 1,des = "法伤减免"},
		},
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		--伤害响应
		on_damage = function (this, damage, self_pos, self_array, attacker_pos, attacker_array, effect)
			if 0 > damage and eHT_Magic == attacker_array[attacker_pos]:AtkType() then
				return 
				{
					change_damage = -damage * 0.8,
					strike_backs = {},
				};
			end
		end
	},

	[1542] = 
	{
		name = "免控（不吃眩晕、混乱）",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		turns = 30,	

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			--非覆盖情况，添加计数
			if not last_effect then
				battle_unit.state.cant_ctrl_count = battle_unit.state.cant_ctrl_count + 1;
			end
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.cant_ctrl_count = battle_unit.state.cant_ctrl_count - 1;
		end,
	},

	[1701] = 
	{
		name = "反弹全军",
		CastingactionID = 1006,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = 1,
		CastingNameShow = 0;
		CastingTime = 0,
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		--伤害响应
		on_damage = function (this, damage, self_pos, self_array, attacker_pos, attacker_array, effect)
			if 0 > damage then
				local unit = self_array[self_pos];
				local target_pos = find_target_all(attacker_array);
				local damage_scale = 0.05 + 0.0025 * unit:SkillLv();
				local re = 
				{
					change_damage = 0,
					strike_backs = {},
				};
				for k, pos in ipairs(target_pos) do
					table.insert(re.strike_backs, 
						{
							is_self = (self_array == attacker_array), 
							pos = pos,
							damage_base = damage,
							damage_scale = damage_scale,
							pvp_decreased = true,
							holy = true,
						}
					);
				end
				return re;
			end
		end
	},

	[1702] = 
	{
		name = "回合加血",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return attacker:Atk() * (0.2 + 0.01 * attacker:SkillLv());
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		on_bout_begin = function (this, battle_unit, effect)
			return {buff_id = 1702, damage = effect};
		end,
	},

	[1703] = 
	{
		name = "闭月 回合加血",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return attacker:BaseHp() * (0.05 + 0.0025 * attacker:SkillLv());
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		on_bout_begin = function (this, battle_unit, effect)
			return {buff_id = 1703, damage = effect};
		end,
	},

	[1704] = 
	{
		name = "伤害转移HP最高队友",
		CastingactionID = 0,
		CastingEffectID = 20013,
		CastingHurtEffectID = 0,
		CastingType = 1,
		CastingNameShow = 0,
		CastingTime = 1,
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 0.3 + attacker:SkillLv() * 0.015;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		--伤害响应
		on_damage = function (this, damage, self_pos, self_array, attacker_pos, attacker_array, effect)
			
			if 0 > damage and math.random() < effect then
				local target_pos = find_target_highest_hp_no_me(self_array, self_pos);
				if target_pos and 0 ~= target_pos then
					return 
					{
						change_damage = -damage;

						strike_backs = 
						{
							{
								is_self = true, 
								pos = target_pos,
								damage_base = damage,
								damage_scale = 1,
								pvp_decreased = true,
								holy = true,
							},
						}
					};
				end
			end
		end
	},

	[1705] = 
	{
		name = "眩晕攻击者",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		--伤害响应
		on_damage = function (this, damage, self_pos, self_array, attacker_pos, attacker_array, effect)
			
			if 0 > damage then
				local unit = self_array[self_pos];
				if math.random() < 0.2 + 0.01 * unit:SkillLv() then
					return 
					{
						change_damage = 0,

						strike_backs = 
						{
							{
								is_self = (self_array == attacker_array), 
								pos = attacker_pos,
								damage_base = 0,
								damage_scale = 0,
								pvp_decreased = true,
								holy = false,
								add_buff_id = 2202,
							},
						},
					};
				end
			end
		end
	},

	[1709] = 
	{
		name = "暴击标记",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
		end,
	},

	[1710] = 
	{
		name = "伤害转换治疗",
		CastingactionID = 0,--1010,
		CastingEffectID = 0,--2014,
		CastingHurtEffectID = 0,
		CastingType = 1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		--伤害响应
		on_damage = function (this, damage, self_pos, self_array, attacker_pos, attacker_array, effect)
			
			if 0 > damage then
				local unit = self_array[self_pos];
				if unit:AbleMiss() then
					return 
					{
						change_damage = 0,

						strike_backs = 
						{
							{
								is_self = true, 
								pos = find_target_lowest_hp_scale(self_array, 1)[1],
								damage_base = unit:Atk(),
								damage_scale = 0.4 + 0.02 * unit:SkillLv();
								holy = true,
							},
						}
					};
				end
			end
		end
	},

	[1711] = 
	{
		name = "反击",
		CastingactionID = 0,
		CastingEffectID = 20024,
		CastingHurtEffectID = 0,
		CastingType = 1,
		CastingNameShow = 0;
		CastingTime = 0.9,
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		--伤害响应
		on_damage = function (this, damage, self_pos, self_array, attacker_pos, attacker_array, effect)
			
			if 0 > damage and self_array ~= attacker_array then
				local unit = self_array[self_pos];
				if not unit:Freeze() then
					return 
					{
						change_damage = 0,

						strike_backs = 
						{
							{
								is_self = false, 
								pos = attacker_pos,
								damage_base = -unit:Atk(),
								damage_scale = 1.5 + 0.075 * unit:SkillLv();
								holy = false,
							},
						}
					};
				end
			end
		end
	},

	[1712] = 
	{
		name = "谦虚（不吃BUFF）",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			--非覆盖情况，添加计数
			if not last_effect then
				battle_unit.state.cant_buff_count = battle_unit.state.cant_buff_count + 1;
			end
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.cant_buff_count = battle_unit.state.cant_buff_count - 1;
		end,
	},

	[1716] = 
	{
		name = "复活",
		CastingactionID = 0,--1002
		CastingEffectID = 0,--2014
		CastingHurtEffectID = 0,
		CastingType = 1,
		CastingNameShow = 1;
		CastingTime = 0,
		turns = 1,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			battle_unit.state.able_relive = 1;
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

	},

	[1719] = 
	{
		name = "瞄准标记",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
		end,
	},

	[1721] = 
	{
		name = "斗转星移",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = 1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		--伤害响应
		on_damage = function (this, damage, self_pos, self_array, attacker_pos, attacker_array, effect)
			
			if 0 > damage then
				local target_pos = find_one_target_random(self_array, self_pos);
				if target_pos then
					local unit = self_array[self_pos];
					local change_damage = -damage * (0.4 + 0.02 * self_array[self_pos]:SkillLv());
					return 
					{
						change_damage = change_damage;

						strike_backs = 
						{
							{
								is_self = true, 
								pos = target_pos,
								damage_base = -change_damage,
								damage_scale = 1,
								pvp_decreased = true,
								holy = false,
							},
						}
					};
				end
			end
		end
	},

	[1724] = 
	{
		name = "反弹攻击者",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = 1,
		CastingNameShow = 0;
		CastingTime = 0,
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		--伤害响应
		on_damage = function (this, damage, self_pos, self_array, attacker_pos, attacker_array, effect)
			if 0 > damage then
				local unit = self_array[self_pos];
				return 
				{
					change_damage = 0,
					strike_backs = 
					{
						{
							is_self = (self_array == attacker_array), 
							pos = attacker_pos,
							damage_base = damage,
							damage_scale = 0.2 + 0.01 * unit:SkillLv(),
							pvp_decreased = true,
							holy = true,
						}
					},
				};
			end
		end
	},

	[1725] = 
	{
		name = "鞭挞（损失HP比例转换为攻击比例）",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			--非覆盖情况，添加计数
			if not last_effect then
				battle_unit.state.hp_to_atk_count = battle_unit.state.hp_to_atk_count + 1;
			end
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.hp_to_atk_count = battle_unit.state.hp_to_atk_count - 1;
		end,
	},

	[1726] = 
	{
		name = "治疗共享",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = 1,
		CastingNameShow = 1,
		CastingTime = 0,
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 0.3 + attacker:SkillLv() * 0.015;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		--伤害响应
		on_damage = function (this, damage, self_pos, self_array, attacker_pos, attacker_array, effect)
			
			if 0 < damage then
				local target_pos = find_one_lowest_hp_scale_no_me(self_array, self_pos);
				if 0 ~= target_pos then
					return
					{
						change_damage = 0,

						strike_backs = 
						{
							{
								is_self = true,
								pos = target_pos,
								damage_base = damage * effect,
								damage_scale = 1,
								pvp_decreased = true,
								holy = true,
							},
						}
					};
				end
			end
		end
	},

	[1730] = 
	{
		name = "闭月（BOSS） 回合加血50%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return attacker:BaseHp() * 0.5;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		on_bout_begin = function (this, battle_unit, effect)
			return {buff_id = 1730, damage = effect};
		end,
	},
	[1731] = 
	{
		name = "反弹攻击者（BOSS）",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = 1,
		CastingNameShow = 1;
		CastingTime = 0,
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		--伤害响应
		on_damage = function (this, damage, self_pos, self_array, attacker_pos, attacker_array, effect)
			if 0 > damage then
				local unit = self_array[self_pos];
				return 
				{
					change_damage = 0,
					strike_backs = 
					{
						{
							is_self = (self_array == attacker_array), 
							pos = attacker_pos,
							damage_base = damage,
							damage_scale = 2,
							pvp_decreased = true,
							holy = true,
						}
					},
				};
			end
		end
	},

	[1732] = 
	{
		name = "眩晕攻击者（BOSS）",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 30,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		--伤害响应
		on_damage = function (this, damage, self_pos, self_array, attacker_pos, attacker_array, effect)
			
			if 0 > damage then
				return 
				{
					change_damage = 0,

					strike_backs = 
					{
						{
							is_self = (self_array == attacker_array), 
							pos = attacker_pos,
							damage_base = 0,
							damage_scale = 0,
							pvp_decreased = true,
							holy = false,
							add_buff_id = 2202,
						},
					},
				};
			end
		end
	},

	[2101] = 
	{
		name = "流血1合",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 1,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return attacker:Atk() * 0.1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		on_bout_begin = function (this, battle_unit, effect)
			return {buff_id = 2102, damage = -effect};
		end,
	},

	[2102] = 
	{
		name = "流血2合",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return attacker:Atk() * 0.1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		on_bout_begin = function (this, battle_unit, effect)
			return {buff_id = 2102, damage = -effect};
		end,
	},

	[2103] = 
	{
		name = "灼烧",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return attacker:Atk() * (0.2 + attacker:SkillLv() * 0.01);
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		on_bout_begin = function (this, battle_unit, effect)
			return {buff_id = 2104, damage = -effect};
		end,
	},

	[2104] = 
	{
		name = "焚烧 +30",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 1,
		OverlapName = "焚烧",
		max_overlap = 30,

		get_effect = function (this, attacker, target)
			return attacker:Atk() * (0.05 + attacker:SkillLv() * 0.0025);
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			if last_effect then
				if this.max_overlap > overlap_num then
					effect = effect + last_effect;
				else
					effect = last_effect;
				end
			end
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		on_bout_begin = function (this, battle_unit, effect)
			return {buff_id = 2104, damage = -effect};
		end,
	},

	[2105] = 
	{
		name = "降低闪避30% + 1.5%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 2,des = "闪避降低"},
		},
		CastingBufIcon = {5102},
		turns = 1,
		OverlapName = "闪避-30%",
		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return -0.3 - 0.015 * attacker:SkillLv();
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 叠加，技能覆盖
			if last_effect then
				if this.max_overlap > overlap_num then
					-- 添加本次效果
					battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
					-- 总变化量记录
					effect = effect + last_effect;
				else
					effect = last_effect;
				end
			else
				battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
			end
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_atk = battle_unit.state.delta_atk - effect;
		end,
	},


	[2106] = 
	{
		name = "瘴气 +5",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 3,
		OverlapName = "瘴气",
		max_overlap = 5,

		get_effect = function (this, attacker, target)
			return attacker:Atk() * (0.5 + attacker:SkillLv() * 0.025);
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			if last_effect then
				if this.max_overlap > overlap_num then
					effect = effect + last_effect;
				else
					effect = last_effect;
				end
			end
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		on_bout_begin = function (this, battle_unit, effect)
			return {buff_id = 2106, damage = -effect};
		end,
	},

	[2107] = 
	{
		name = "毒气 +5",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 3,
		OverlapName = "毒气",
		max_overlap = 30,

		get_effect = function (this, attacker, target)
			return attacker:Atk() * (0.2 + attacker:SkillLv() * 0.01);
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			if last_effect then
				if this.max_overlap > overlap_num then
					effect = effect + last_effect;
				else
					effect = last_effect;
				end
			end
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
		end,

		on_bout_begin = function (this, battle_unit, effect)
			return {buff_id = 2107, damage = -effect};
		end,
	},

	[2201] = 
	{
		name = "眩晕（行为冻结）",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 1,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			--非覆盖情况，添加计数
			if not last_effect then
				battle_unit.state.freeze_count = battle_unit.state.freeze_count + 1;
				battle_unit.state.cant_miss_count = battle_unit.state.cant_miss_count + 1;
			end
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.freeze_count = battle_unit.state.freeze_count - 1;
			battle_unit.state.cant_miss_count = battle_unit.state.cant_miss_count - 1;
		end,
	},

	[2202] = 
	{
		name = "眩晕（行为冻结）",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			--非覆盖情况，添加计数
			if not last_effect then
				battle_unit.state.freeze_count = battle_unit.state.freeze_count + 1;
				battle_unit.state.cant_miss_count = battle_unit.state.cant_miss_count + 1;
			end
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.freeze_count = battle_unit.state.freeze_count - 1;
			battle_unit.state.cant_miss_count = battle_unit.state.cant_miss_count - 1;
		end,
	},

	[2401] = 
	{
		name = "混乱（普通攻击己方）",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 2,des = "混乱"},
		},
		turns = 1,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			--非覆盖情况，添加计数
			if not last_effect then
				battle_unit.state.confusion_count = battle_unit.state.confusion_count + 1;
				battle_unit.state.cant_miss_count = battle_unit.state.cant_miss_count + 1;
			end
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.confusion_count = battle_unit.state.confusion_count - 1;
			battle_unit.state.cant_miss_count = battle_unit.state.cant_miss_count - 1;
		end,
	},

	[2601] = 
	{
		name = "攻击降低10% + 0.5%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 2,des = "攻击降低"},
		},
		CastingBufIcon = {5102},
		turns = 1,
		OverlapName = "攻-10%",
		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return -target:Atk() * (0.1 + 0.005 * attacker:SkillLv());
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 叠加，技能覆盖
			if last_effect then
				if this.max_overlap > overlap_num then
					-- 添加本次效果
					battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
					-- 总变化量记录
					effect = effect + last_effect;
				else
					effect = last_effect;
				end
			else
				battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
			end
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_atk = battle_unit.state.delta_atk - effect;
		end,
	},

	[2602] = 
	{
		name = "降低命中10% + 0.5%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 2,des = "命中降低"},
		},
		CastingBufIcon = {5103},
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return -0.1 - 0.005 * attacker:SkillLv();
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_hit = battle_unit.state.delta_hit - effect;
			end
			-- 添加本次效果
			battle_unit.state.delta_hit = battle_unit.state.delta_hit + effect;
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_hit = battle_unit.state.delta_hit - effect;
		end,
	},

	[2603] = 
	{
		name = "攻击降低90%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 2,des = "攻击降低"},
		},
		CastingBufIcon = {5102},
		turns = 1,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return -target:Atk() * 0.9;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_atk = battle_unit.state.delta_atk - last_effect;
			end
			-- 添加本次效果
			battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_atk = battle_unit.state.delta_atk - effect;
		end,
	},

	[2604] = 
	{
		name = "防御降低50%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 2,des = "防御降低"},
		},
		CastingBufIcon = {5106},
		turns = 1,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 
			{
				-target:PDef() * 0.5,
				-target:MDef() * 0.5,
			};
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - last_effect[1];
				battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - last_effect[2];
			end
			-- 添加本次效果
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef + effect[1];
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef + effect[2];
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - effect[1];
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - effect[2];
		end,
	},

	[2605] = 
	{
		name = "降低命中50%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 2,des = "命中降低"},
		},
		CastingBufIcon = {5104},
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return -0.5;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_hit = battle_unit.state.delta_hit - effect;
			end
			-- 添加本次效果
			battle_unit.state.delta_hit = battle_unit.state.delta_hit + effect;
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_hit = battle_unit.state.delta_hit - effect;
		end,
	},

	[2606] = 
	{
		name = "合击标记",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 1,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
		end,
	},

	[2607] = 
	{
		name = "连环（不可闪避）",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			--非覆盖情况，添加计数
			if not last_effect then
				battle_unit.state.cant_miss_count = battle_unit.state.cant_miss_count + 1;
			end
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.cant_miss_count = battle_unit.state.cant_miss_count - 1;
		end,
	},

	[2608] = 
	{
		name = "防御降低10% + 0.5%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 2,des = "防御降低"},
		},
		CastingBufIcon = {5106},
		turns = 30,
		OverlapName = "防-10%",
		max_overlap = 10,

		get_effect = function (this, attacker, target)
			return 
			{
				-target:PDef() * (0.1 + 0.005 * attacker:SkillLv()),
				-target:MDef() * (0.1 + 0.005 * attacker:SkillLv()),
			};
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 叠加，技能覆盖
			
			if last_effect then
				--print_face("max_overlap="..this.max_overlap.." overlap_num="..overlap_num);
				if this.max_overlap > overlap_num then
					-- 添加本次效果
					battle_unit.state.delta_pdef = battle_unit.state.delta_pdef + effect[1];
					battle_unit.state.delta_mdef = battle_unit.state.delta_mdef + effect[2];
					-- 总变化量记录
					effect[1] = effect[1] + last_effect[1];
					effect[2] = effect[2] + last_effect[2];
				else
					effect = last_effect;
				end
			else
				battle_unit.state.delta_pdef = battle_unit.state.delta_pdef + effect[1];
				battle_unit.state.delta_mdef = battle_unit.state.delta_mdef + effect[2];
			end
			--print_face("2608 pdef="..battle_unit:PDef());
			--print_face("delta_pdef="..battle_unit.state.delta_pdef.." effect[1]"..effect[1]);
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - effect[1];
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - effect[2];
		end,
	},

	[2609] = 
	{
		name = "攻击降低20% + 1%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 2,des = "攻击降低"},
		},
		CastingBufIcon = {5102},
		turns = 1,
		OverlapName = "攻-20%",
		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return -target:Atk() * (0.2 + 0.01 * attacker:SkillLv());
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 叠加，技能覆盖
			if last_effect then
				if this.max_overlap > overlap_num then
					-- 添加本次效果
					battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
					-- 总变化量记录
					effect = effect + last_effect;
				else
					effect = last_effect;
				end
			else
				battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
			end
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_atk = battle_unit.state.delta_atk - effect;
		end,
	},

	[2610] = 
	{
		name = "防御降低20% + 1%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 2,des = "防御降低"},
		},
		CastingBufIcon = {5106},
		turns = 30,
		OverlapName = "防-10%",
		max_overlap = 5,

		get_effect = function (this, attacker, target)
			return 
			{
				-target:PDef() * (0.2 + 0.01 * attacker:SkillLv()),
				-target:MDef() * (0.2 + 0.01 * attacker:SkillLv()),
			};
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 叠加，技能覆盖
			
			if last_effect then
				--print_face("max_overlap="..this.max_overlap.." overlap_num="..overlap_num);
				if this.max_overlap > overlap_num then
					-- 添加本次效果
					battle_unit.state.delta_pdef = battle_unit.state.delta_pdef + effect[1];
					battle_unit.state.delta_mdef = battle_unit.state.delta_mdef + effect[2];
					-- 总变化量记录
					effect[1] = effect[1] + last_effect[1];
					effect[2] = effect[2] + last_effect[2];
				else
					effect = last_effect;
				end
			else
				battle_unit.state.delta_pdef = battle_unit.state.delta_pdef + effect[1];
				battle_unit.state.delta_mdef = battle_unit.state.delta_mdef + effect[2];
			end
			--print_face("2608 pdef="..battle_unit:PDef());
			--print_face("delta_pdef="..battle_unit.state.delta_pdef.." effect[1]"..effect[1]);
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_pdef = battle_unit.state.delta_pdef - effect[1];
			battle_unit.state.delta_mdef = battle_unit.state.delta_mdef - effect[2];
		end,
	},

	[2611] = 
	{
		name = "复活已使用标记",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		turns = 30,

		max_overlap = 10,

		get_effect = function (this, attacker, target)
			return 1;
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			return 1;
		end,

		on_remove = function (this, battle_unit, effect)
		end,
	},

	[2612] = 
	{
		name = "攻击降低30% + 1.5%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 2,des = "攻击降低"},
		},
		CastingBufIcon = {5102},
		turns = 1,
		OverlapName = "攻-10%",
		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return -target:Atk() * (0.3 + 0.015 * attacker:SkillLv());
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 叠加，技能覆盖
			if last_effect then
				if this.max_overlap > overlap_num then
					-- 添加本次效果
					battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
					-- 总变化量记录
					effect = effect + last_effect;
				else
					effect = last_effect;
				end
			else
				battle_unit.state.delta_atk = battle_unit.state.delta_atk + effect;
			end
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_atk = battle_unit.state.delta_atk - effect;
		end,
	},

	[2613] = 
	{
		name = "降低命中20% + 1%",
		CastingactionID = 0,
		CastingEffectID = 0,
		CastingHurtEffectID = 0,
		CastingType = -1,
		CastingNameShow = 0,
		CastingTime = 0,
		EffectDes = {
			{color = 2,des = "命中降低"},
		},
		CastingBufIcon = {5103},
		turns = 2,

		max_overlap = 1,

		get_effect = function (this, attacker, target)
			return -0.2 - 0.01 * attacker:SkillLv();
		end,

		on_add = function (this, battle_unit, effect, overlap_num, last_effect)
			-- 无叠加，技能覆盖，取消上次效果
			if last_effect then
				battle_unit.state.delta_hit = battle_unit.state.delta_hit - effect;
			end
			-- 添加本次效果
			battle_unit.state.delta_hit = battle_unit.state.delta_hit + effect;
			return effect;
		end,

		on_remove = function (this, battle_unit, effect)
			battle_unit.state.delta_hit = battle_unit.state.delta_hit - effect;
		end,
	},
}





