--
-- Author: Li Yang
-- Date: 2014-01-21 13:56:00
-- 副本配置文件


--得到副本页配置表
function get_instancing_page( page_key )
	if GET_CONFIG_CHECK and nil == CarbonConfig[page_key] then
		print_log(debug.traceback());
		print_log("Not found page("..page_key..")");
	end
	return CarbonConfig[page_key];
end


--得到副本大关配置
function get_instancing_group( group_key )
	if GET_CONFIG_CHECK and nil == GroupData[group_key] then
		print_log(debug.traceback());
		print_log("Not found group("..group_key..")");
	end
	return GroupData[group_key];
end


--得到副本小关配置
function get_instancing_level( level_key )
	if GET_CONFIG_CHECK and nil == LevelData[level_key] then
		print_log(debug.traceback());
		print_log("Not found level("..level_key..")");
	end
	return LevelData[level_key];
end


--关卡分类ID
PAGE_JU_QING = 1;
PAGE_WU_JIANG = 2;


--副本关卡结构
CarbonConfig = 
{

[1]={Key = 1,name = "普通副本",openLevel = 1,LevelListId = {1,  },},
[2]={Key = 2,name = "精英副本",openLevel = 30,LevelListId = {1001, },},


	-- 普通副本数据
	-- page_1 = 
	-- {
	-- 	Key = "page_1",
	-- 	name = "普通副本",
	-- 	nameIcon = "",-- 名字icon
	-- 	openLevel = 1, -- 开启等级
	-- 	LevelListId = {"1", "2", "3"}, -- 关卡组
	-- },

	
}

--[[关卡组
	命名规则
	普通副本 group_(0 + id) 
	精英副本 group_(1000 + id)
	苦难副本 group_(2000 + id)
]]
-------------------------------------------------------------------------------------------------------------------------------
GroupData = 
{
	--普通战役
	----------------------------------------------------------
[1]={Key = 1, name = "小乔",map_id = "zhanyi_1001", CarbonOpenLevel = 1, CarbonLevelList = {101, }, perfect_drop_id = 42001, pass_drop_id = 41001,DialogueData = {dialogueKey = "Dialogue_152",logicID = 1,actionType = 1}, Rewards = {{rewardstype = eDT_Card,templateid = 30017, number = 1},{rewardstype = eDT_Card,templateid = 30501, number = 1},}, psss_Rewards = {{rewardstype = eDT_Gold,templateid = 0, number = 50000},{rewardstype = eDT_YuanBao,templateid = 0, number = 100},},CarbonShowModen = 20019},



	--精英战役
	----------------------------------------------------------
[1001]={Key = 1001, name = "桃园结义",map_id = "zhanyi_1001", CarbonOpenLevel = 30, CarbonLevelList = {10101, }, perfect_drop_id = 43001, pass_drop_id = 44001,Rewards = {{rewardstype = eDT_Gold,templateid = 0, number = 50000},{rewardstype = eDT_YuanBao,templateid = 0, number = 100},}, DialogueData = {}, psss_Rewards = {{rewardstype =eDT_Equip,templateid = 10001, number = 1},{rewardstype =eDT_Equip,templateid = 10002, number = 1},{rewardstype =eDT_Equip,templateid = 10003, number = 1},{rewardstype =eDT_Equip,templateid = 10004, number = 1},},},



	--困难战役
	----------------------------------------------------------

	-- group_1 =
	-- {
	-- 	Key = "group_1",
	-- 	CarbonName = "哀嚎", -- 副本名称
	-- 	CarbonState = 0, -- 副本状态 0 没有开启 1 开启 2 通关 3 新开启
	-- 	CarbonOpenLevel = 1, -- 副本开启等级
	-- 	CarbonLevelList = {"level_1", "level_2", "level_3",}, -- 副本关卡列表
	-- 	-- gold=1500, 
	-- 	-- yuanBao=1500,
	-- 	Rewards = {{rewardstype = 1,templateid = 1, number = 3}}, --三星通关奖励
	-- },

	
}




-- 关卡数据
-------------------------------------------------------------------------------------------------------------------------------
LevelData = {
	--普通关
	----------------------------------------------------------
[101]={Key = 101, Name = "雄图皖城", ranking = 0, Icon = 0, sceneID = 4,ConsumeVigor = 6, LimitNum = 999, MonsterCfgID = 101, gold = 2000, first_drop_id = 99999, drop_id = 101,DialogueData = {}, Rewards = {},},



	--精英关
	----------------------------------------------------------
[10101]={Key = 10101, Name = "桃园三结义", ranking = 0, Icon = 0, sceneID = 1,ConsumeVigor = 6, LimitNum = 8, MonsterCfgID = 10101, gold = 2000, first_drop_id = 0, drop_id = 10101,DialogueData = {}, Rewards = {},},



	--困难关
	----------------------------------------------------------



	--活动
	----------------------------------------------------------


};



--配置处理
if GET_CONFIG_CHECK then
	local level_error = false;
	for k, LevelCfg in pairs(LevelData) do
		if nil == get_level_monster_cfg_array(LevelCfg.MonsterCfgID) then
			print_log("can't find the MonsterCfgID["..LevelCfg.MonsterCfgID.."] with level["..k.."]");
			level_error = true;
		end
		if 0 ~= LevelCfg.drop_id and nil == GetDrop(LevelCfg.drop_id) then
			print_log("can't find the drop_id["..LevelCfg.drop_id.."] with level["..k.."]");
			level_error = true;
		end
	end
	if level_error then
		print_face("monster config error!!!");
		assert(false);
	end
end








