--
-- Author: 
-- Date: 
-- 战役配置


--得到一个战役关卡配置
function GetCityCfg(city_id)
	if GET_CONFIG_CHECK and nil == CityConfig[city_id] then
		print_log("Not found city("..city_id..") of config");
		print_log(debug.traceback());
	end
	return CityConfig[city_id];
end

--获取城市icon
function CityCfg_getIconName( city_id )
	local quality = GetCityCfg(city_id).quality
	
	return string.format(
		"ui_image/guild/guild_battle/guild_battle_city%d.png",
		quality
	)
end


--获取产出物资数量
--@holdPosNum 被占领位置数量
function CityCfg_getProduceSuppliesNum( cityID, holdPosNum )
	local gxNum = CityCfg_getProduceGXNum(cityID)

	return holdPosNum * gxNum
end

--获取产出资源数量
function CityCfg_getProduceGXNum( cityID )
	return GetCityCfg(cityID).score
end

--是否显示
function CityCfg_isVisible( cityID )
	return GetCityCfg(cityID).xianshi == 1
end


--每日攻打次数
MW_PLAY_NUM_PER_DAY = 5;
--产出间隔时间, 单位: 分钟
MW_PRODUCE_INTERVAL_TIME = 10
--无效城市ID
MW_INVALID_CITY_ID = 0
--无效城市位置索引
MW_INVALID_CITY_POS_IDX = 0


CityConfig = 
{
	[1] = { name = "邺", quality = 2, volume = 4, score = 15, xianshi = 1},
	[2] = { name = "洛阳", quality = 3, volume = 6, score = 20, xianshi = 1},
	[3] = { name = "许昌", quality = 2, volume = 4, score = 15, xianshi = 1},
	[4] = { name = "长安", quality = 2, volume = 4, score = 15, xianshi = 1},
	[5] = { name = "成都", quality = 2, volume = 4, score = 15, xianshi = 1},
	[6] = { name = "襄阳", quality = 2, volume = 4, score = 15, xianshi = 0},
	[7] = { name = "建邺", quality = 2, volume = 4, score = 15, xianshi = 1},
	[8] = { name = "南皮", quality = 2, volume = 4, score = 15, xianshi = 0},
	[9] = { name = "平原", quality = 2, volume = 4, score = 15, xianshi = 0},
	[10] = { name = "陈留", quality = 1, volume = 2, score = 10, xianshi = 1},
	[11] = { name = "汝南", quality = 2, volume = 4, score = 15, xianshi = 0},
	[12] = { name = "寿春", quality = 2, volume = 4, score = 15, xianshi = 0},
	[13] = { name = "濮阳", quality = 2, volume = 4, score = 15, xianshi = 0},
	[14] = { name = "下邳", quality = 2, volume = 4, score = 15, xianshi = 1},
	[15] = { name = "西凉", quality = 1, volume = 2, score = 10, xianshi = 1},
	[16] = { name = "天水", quality = 1, volume = 2, score = 10, xianshi = 0},
	[17] = { name = "幸潼", quality = 1, volume = 2, score = 10, xianshi = 0},
	[18] = { name = "江州", quality = 1, volume = 2, score = 10, xianshi = 0},
	[19] = { name = "庐江", quality = 1, volume = 2, score = 10, xianshi = 0},
	[20] = { name = "柴桑", quality = 1, volume = 2, score = 10, xianshi = 0},
	[21] = { name = "吴", quality = 1, volume = 2, score = 10, xianshi = 0},
	[22] = { name = "会稽", quality = 1, volume = 2, score = 10, xianshi = 0},
	[23] = { name = "云南", quality = 1, volume = 2, score = 10, xianshi = 1},
	[24] = { name = "蘘平", quality = 1, volume = 2, score = 10, xianshi = 0},
	[25] = { name = "北平", quality = 1, volume = 2, score = 10, xianshi = 1},
	[26] = { name = "蓟", quality = 1, volume = 2, score = 10, xianshi = 0},
	[27] = { name = "晋阳", quality = 1, volume = 2, score = 10, xianshi = 0},
	[28] = { name = "宛", quality = 1, volume = 2, score = 10, xianshi = 0},
	[29] = { name = "小沛", quality = 1, volume = 2, score = 10, xianshi = 1},
	[30] = { name = "北海", quality = 1, volume = 2, score = 10, xianshi = 1},
	[31] = { name = "汉中", quality = 1, volume = 2, score = 10, xianshi = 1},
	[32] = { name = "永安", quality = 1, volume = 2, score = 10, xianshi = 0},
	[33] = { name = "新野", quality = 1, volume = 2, score = 10, xianshi = 1},
	[34] = { name = "上庸", quality = 1, volume = 2, score = 10, xianshi = 0},
	[35] = { name = "江陵", quality = 1, volume = 2, score = 10, xianshi = 1},
	[36] = { name = "武陵", quality = 1, volume = 2, score = 10, xianshi = 0},
	[37] = { name = "零陵", quality = 1, volume = 2, score = 10, xianshi = 0},
	[38] = { name = "长沙", quality = 1, volume = 2, score = 10, xianshi = 1},
	[39] = { name = "桂阳", quality = 1, volume = 2, score = 10, xianshi = 0},
	[40] = { name = "江夏", quality = 1, volume = 2, score = 10, xianshi = 0},

};








