--
-- Author: zkz
-- Date: 2014-09-13 16:00:00
-- 迷宫探宝




--取得迷宫配置
function GetGuildMazeCfg(maze_id)
	return GuildMazeConfig[maze_id];
end

--取得迷宫地图配置
function GetGuildMazeFloorCfg(floor_id)
	return GuildMazeFloors[floor_id];
end



--获取迷宫总探索度
--如果mazeFloorID为nil, 那么总探索度为迷宫所有层探索度总和
--否则, 总探索度为0层至mazeFloorID层的探索度总和
function GuildMazeCfg_getTotal_tanSuoDu( mazeID, mazeFloorID )
	local mazeConfig = GetMazeCfg(mazeID)
	local mazeFloor = nil
	--总探索度
	local total_tanSuoDu = 0

	--计算总探索度
	for k,v in pairs(mazeConfig.floors) do
		mazeFloor = GetMazeFloorCfg(v)
		if nil ~= mazeFloor then
			total_tanSuoDu = total_tanSuoDu + mazeFloor.depth
			if v == mazeFloorID then
				break
			end
		end
	end

	return total_tanSuoDu
end




--获取目标迷宫第一层的配置信息
function GuildMazeCfg_getFirstFloorCfg( mazeID )
	return GetGuildMazeFloorCfg(GetGuildMazeCfg(mazeID).floors[1])
end


--获取目标迷宫最后一层的配置信息
function GuildMazeCfg_getLastFloorCfg( mazeID )
	local floors = GetGuildMazeCfg(mazeID).floors
	return GetGuildMazeFloorCfg(floors[#floors])
end






--地图配置
GuildMazeConfig = 
{
	[1] = 
	{
		--
		id = 1,
		--地图名
		Name = "黄巾战场",
		--图层配置
		floors = {101, 102, 103, 104,},
		--限制等级
		limit_lvl = 60,

		--进场函数
		--进场函数
		on_enter = function(player, maze_data, msg)
			local items_pack = player:GetPieceSys(ePST_Items);
			local zz_num = items_pack:GetPieceNum(60101);
			local lz_num = items_pack:GetPieceNum(10015);
			local item_num = 0;
			if zz_num > 0 then
				item_num = item_num + 1;
			end
			if lz_num > 0 then
				item_num = item_num + 1;
			end
			msg:WriteInt(item_num);
			if zz_num > 0 then
				msg:WriteInt(eDT_Item);
				msg:WriteInt(60101);
				msg:WriteInt(0);
				msg:WriteInt(zz_num);

				local drop_qb = 
				{
					obj_type = eDT_Item,
					obj_id = 60101,
					obj_lv = 0,
					obj_num = zz_num,
				};

				DelItem(player, 60101, zz_num, "带入战场道具");
				GuildMazeAddDrop(player, player:GetGuildMazeData(), drop_qb, "带入战场道具", true);
			end
			if lz_num > 0 then
				msg:WriteInt(eDT_Item);
				msg:WriteInt(10015);
				msg:WriteInt(0);
				msg:WriteInt(lz_num);

				local drop_qb = 
				{
					obj_type = eDT_Item,
					obj_id = 10015,
					obj_lv = 0,
					obj_num = lz_num,
				};

				DelItem(player, 10015, lz_num, "带入战场道具");
				GuildMazeAddDrop(player, player:GetGuildMazeData(), drop_qb, "带入战场道具", true);
			end
		end,
	},

};


--地图层
GuildMazeFloors = 
{
	-------------------------------黄巾战场-------------------------------
	[101] = 
	{
		--maze_cfg：自动添加所在迷宫配置
		--
		id = 101,
		last_id = nil,
		next_id = 102,
		--
		Name = "战场外围",
		--信息
		Info = "秋风去，沙尘扬，天下儿郎上战场！",
		--地图深度
		depth = 20,
		--探索需要精力
		vigour = 0,
		--PK类型（0=不允许， 1=允许）
		pk = 1,
		--PK失败减少深度
		pk_less_depth = 0,
		--战场背景ID
		battlefield_id = 5,
		--场景ID
		field_id = 20,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_23.png"
	},

	[102] = 
	{
		--
		id = 102,
		last_id = 101,
		next_id = 103,
		--
		Name = "八州城邑",
		--信息
		Info = "八州联军们从四面八方蚕食着黄巾贼的地盘，它们的死期就要降临了。",
		--地图深度
		depth = 20,
		--探索需要精力
		vigour = 0,
		--PK类型（0=不允许， 1=允许）
		pk = 1,
		--PK失败减少深度
		pk_less_depth = 10,
		--战场背景ID
		battlefield_id = 5,
		--场景ID
		field_id = 25,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_24.png"
	},

	[103] = 
	{
		--
		id = 103,
		last_id = 102,
		next_id = 104,
		--
		Name = "逐鹿台",
		--信息
		Info = "群雄逐鹿，死生各安！",
		--地图深度
		depth = 20,
		--探索需要精力
		vigour = 0,
		--PK类型（0=不允许， 1=允许）
		pk = 1,
		--PK失败减少深度
		pk_less_depth = 10,
		--战场背景ID
		battlefield_id = 5,
		--场景ID
		field_id = 23,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_25.png"
	},

	[104] = 
	{
		--
		id = 104,
		last_id = 103,
		next_id = nil,
		--
		Name = "黄巾虎穴",
		--信息
		Info = "苍天已死，黄天当立！岁在甲子，天下大吉！",
		--地图深度
		depth = 20,
		--探索需要精力
		vigour = 0,
		--PK类型（0=不允许， 1=允许）
		pk = 1,
		--PK失败减少深度
		pk_less_depth = 10,
		--战场背景ID
		battlefield_id = 5,
		--场景ID
		field_id = 27,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_26.png"
	},


};



if GET_CONFIG_CHECK then
	local maze_error = false;
	for maze_id, maze in pairs(GuildMazeConfig) do
		for idx, floor_id in pairs(maze.floors) do
			local floor = GetGuildMazeFloorCfg(floor_id);
			if floor then
				--添加所在迷宫的配置
				floor.maze_cfg = maze;
			else
				print_log("can't find the floor["..floor_id.."] with maze["..maze_id.."]");
				maze_error = true;
			end
		end
	end

	for i, floor in ipairs(GuildMazeFloors) do
		if not floor.maze_cfg then
			print_log("nil == floor.maze_cfg id="..floor.ids);
		end
	end

	if maze_error then
		print_face("maze config error!!!");
		assert(false);
	end
end



--讨伐黄巾缴纳资源配置
HuangJinTaskCfg = 
{
	{
		--资源数
		res = 1000, 
		--功勋
		gx = 100,
	},
	{
		res = 2000, 
		gx = 100,
	},
	{
		res = 3000, 
		gx = 100,
	},
	{
		res = 4000, 
		gx = 100,
	},
	{
		res = 5000, 
		gx = 100,
	},
};
