--
-- Author: zkz
-- Date: 2014-09-13 16:00:00
-- 迷宫探宝




--取得迷宫配置
function GetMazeCfg(maze_id)
	return MazeConfig[maze_id];
end

--取得迷宫地图配置
function GetMazeFloorCfg(floor_id)
	return MazeFloors[floor_id];
end


--获得PK等级
function GetPkLv(pk)
	for i, info in ipairs(PK_LEVEL) do
		if info.line > pk then
			return i - 1;
		end
	end
	return #PK_LEVEL;
end


--将pk类型转换为字符串
function MazeCfg_pkTypeToString( pkType )
	if 0 == pkType then
		return "无法PK"
	elseif 1 == pkType then
		return "允许PK"
	end

	return ""
end

--获取迷宫总探索度
--如果mazeFloorID为nil, 那么总探索度为迷宫所有层探索度总和
--否则, 总探索度为0层至mazeFloorID层的探索度总和
function MazeCfg_getTotal_tanSuoDu( mazeID, mazeFloorID )
	local mazeConfig = GetMazeCfg(mazeID)
	local mazeFloor = nil
	--总探索度
	local total_tanSuoDu = 0

	--计算总探索度
	for k,v in pairs(mazeConfig.floors) do
		mazeFloor = GetMazeFloorCfg(v)
		if nil ~= mazeFloor then
			total_tanSuoDu = total_tanSuoDu + mazeFloor.depth
			if v == mazeFloorID then
				break
			end
		end
	end

	return total_tanSuoDu
end


--获取目标迷宫第一层的配置信息
function MazeCfg_getFirstFloorCfg( mazeID )
	return GetMazeFloorCfg(GetMazeCfg(mazeID).floors[1])
end


--获取目标迷宫最后一层的配置信息
function MazeCfg_getLastFloorCfg( mazeID )
	local floors = GetMazeCfg(mazeID).floors
	return GetMazeFloorCfg(floors[#floors])
end


--杀人增加PK值
KILL_INCR = 30;
--Pk值等级
PK_LEVEL = 
{
	{line = 10, },
	{line = 40, },
	{line = 70, },
	{line = 100, },
	{line = 130, },
	{line = 160, },
	{line = 190, },
	{line = 220, },
	{line = 250, },
	{line = 280, },
};
--被抢减少探索度
BK_DEPTH_DESC = 3;


--地图配置
MazeConfig = 
{
	[1] = 
	{
		--
		id = 1,
		--地图名
		Name = "蒙氏之遗",
		--图层配置
		floors = {101, 102, 103, 104, },
		--限制等级
		limit_lvl = 20,

		--进场函数
		on_enter = function(player, maze_data, msg)
			local items_pack = player:GetPieceSys(ePST_Items);
			local qb_num = items_pack:GetPieceNum(eSTID_QinBi);
			if qb_num > 0 then
				msg:WriteInt(1);

				msg:WriteInt(eDT_Item);
				msg:WriteInt(eSTID_QinBi);
				msg:WriteInt(0);
				msg:WriteInt(qb_num);

				local drop_qb = 
				{
					obj_type = eDT_Item,
					obj_id = eSTID_QinBi,
					obj_lv = 0,
					obj_num = qb_num,
				};

				DelItem(player, eSTID_QinBi, qb_num, "带入蒙氏之遗道具");
				MazeAddDrop(player, player:GetMazeData(), drop_qb, "带入蒙氏之遗道具");
			else
				msg:WriteInt(0);
			end
		end,
	},

	[2] = 
	{
		--
		id = 2,
		--地图名
		Name = "杂货铺",
		--图层配置
		floors = {201,},
		--限制等级
		limit_lvl = 20,

		--进场函数
		on_enter = function(player, maze_data, msg)
			local items_pack = player:GetPieceSys(ePST_Items);
			local qb_num = items_pack:GetPieceNum(eSTID_QinBi);
			if qb_num > 0 then
				msg:WriteInt(1);

				msg:WriteInt(eDT_Item);
				msg:WriteInt(eSTID_QinBi);
				msg:WriteInt(0);
				msg:WriteInt(qb_num);

				local drop_qb = 
				{
					obj_type = eDT_Item,
					obj_id = eSTID_QinBi,
					obj_lv = 0,
					obj_num = qb_num,
				};

				DelItem(player, eSTID_QinBi, qb_num, "带入杂货铺道具");
				MazeAddDrop(player, player:GetMazeData(), drop_qb, "带入杂货铺道具");
			else
				msg:WriteInt(0);
			end
		end,
	},

	[3] = 
	{
		--
		id = 3,
		--地图名
		Name = "杀神之墓",
		--图层配置
		floors = {301, 302, 303, 304,},
		--限制等级
		limit_lvl = 50,

		--进场函数
		on_enter = function(player, maze_data, msg)
			local items_pack = player:GetPieceSys(ePST_Items);
			local qb_num = items_pack:GetPieceNum(eSTID_QinBi);
			if qb_num > 0 then
				msg:WriteInt(1);

				msg:WriteInt(eDT_Item);
				msg:WriteInt(eSTID_QinBi);
				msg:WriteInt(0);
				msg:WriteInt(qb_num);

				local drop_qb = 
				{
					obj_type = eDT_Item,
					obj_id = eSTID_QinBi,
					obj_lv = 0,
					obj_num = qb_num,
				};

				DelItem(player, eSTID_QinBi, qb_num, "带入杀神之墓道具");
				MazeAddDrop(player, player:GetMazeData(), drop_qb, "带入杀神之墓道具");
			else
				msg:WriteInt(0);
			end
		end,
	},

	[4] = 
	{
		--
		id = 4,
		--地图名
		Name = "秦始皇陵",
		--图层配置
		floors = {401, 402, 403, 404, },
		--限制等级
		limit_lvl = 70,

		--进场函数
		on_enter = function(player, maze_data, msg)
			local items_pack = player:GetPieceSys(ePST_Items);
			local qb_num = items_pack:GetPieceNum(eSTID_QinBi);
			if qb_num > 0 then
				msg:WriteInt(1);

				msg:WriteInt(eDT_Item);
				msg:WriteInt(eSTID_QinBi);
				msg:WriteInt(0);
				msg:WriteInt(qb_num);

				local drop_qb = 
				{
					obj_type = eDT_Item,
					obj_id = eSTID_QinBi,
					obj_lv = 0,
					obj_num = qb_num,
				};

				DelItem(player, eSTID_QinBi, qb_num, "带入秦始皇陵道具");
				MazeAddDrop(player, player:GetMazeData(), drop_qb, "带入秦始皇陵道具");
			else
				msg:WriteInt(0);
			end
		end,
	},

	[5] = 
	{
		--
		id = 5,
		--地图名
		Name = "大商行",
		--图层配置
		floors = {501, },
		--限制等级
		limit_lvl = 60,

		--进场函数
		on_enter = function(player, maze_data, msg)
			local items_pack = player:GetPieceSys(ePST_Items);
			local qb_num = items_pack:GetPieceNum(eSTID_QinBi);
			if qb_num > 0 then
				msg:WriteInt(1);

				msg:WriteInt(eDT_Item);
				msg:WriteInt(eSTID_QinBi);
				msg:WriteInt(0);
				msg:WriteInt(qb_num);

				local drop_qb = 
				{
					obj_type = eDT_Item,
					obj_id = eSTID_QinBi,
					obj_lv = 0,
					obj_num = qb_num,
				};

				DelItem(player, eSTID_QinBi, qb_num, "带入大商行道具");
				MazeAddDrop(player, player:GetMazeData(), drop_qb, "带入大商行道具");
			else
				msg:WriteInt(0);
			end
		end,
	},


	[6] = 
	{
		--
		id = 6,
		--
		Name = "草湾山",
		--
		floors = {601, 602, 603, 604, },
		--
		limit_lvl = 30,

		--进场函数
		on_enter = function(player, maze_data, msg)
			local items_pack = player:GetPieceSys(ePST_Items);
			local qb_num = items_pack:GetPieceNum(eSTID_QinBi);
			local cbt_num = items_pack:GetPieceNum(eSTID_QinBi);
			if cbt_num > 0 then
				msg:WriteInt(1);

				msg:WriteInt(eDT_Item);
				msg:WriteInt(eSTID_QinBi);
				msg:WriteInt(0);
				msg:WriteInt(cbt_num);

				local drop_qb = 
				{
					obj_type = eDT_Item,
					obj_id = eSTID_QinBi,
					obj_lv = 0,
					obj_num = cbt_num,
				};

				DelItem(player, eSTID_QinBi, cbt_num, "带入霸王秘藏道具");
				MazeAddDrop(player, player:GetMazeData(), drop_qb, "带入霸王秘藏道具");
			else
				msg:WriteInt(0);
			end
		end
	},

	[7] = 
	{
		--
		id = 7,
		--
		Name = "霸王密藏",
		--
		floors = {701, 702, 703, 704, },
		--
		limit_lvl = 70,

		--进场函数
		on_enter = function(player, maze_data, msg)
			local items_pack = player:GetPieceSys(ePST_Items);
			local qb_num = items_pack:GetPieceNum(eSTID_QinBi);
			local cbt_num = items_pack:GetPieceNum(eSTID_QinBi);
			if cbt_num > 0 then
				msg:WriteInt(1);

				msg:WriteInt(eDT_Item);
				msg:WriteInt(eSTID_QinBi);
				msg:WriteInt(0);
				msg:WriteInt(cbt_num);

				local drop_qb = 
				{
					obj_type = eDT_Item,
					obj_id = eSTID_QinBi,
					obj_lv = 0,
					obj_num = cbt_num,
				};

				DelItem(player, eSTID_QinBi, cbt_num, "带入霸王秘藏道具");
				MazeAddDrop(player, player:GetMazeData(), drop_qb, "带入霸王秘藏道具");
			else
				msg:WriteInt(0);
			end
		end
	},

};


--地图层
MazeFloors = 
{
	-------------------------------蒙氏之遗-------------------------------
	[101] = 
	{
		--maze_cfg：自动添加所在迷宫配置
		--
		id = 101,
		last_id = nil,
		next_id = 102,
		--
		Name = "蒙阴村头",
		--信息
		Info = "[color=255|65|65]蒙阴村头：[/]\n过去的种种似乎都成为一抹肃杀的记忆，记忆中的海市蜃楼。"..word_color[1].."野兽[/]和生活无数年的"..word_color[1].."古村怨魂[/]在附近游荡……",
		--地图深度
		depth = 20,
		--探索需要精力
		vigour = 1,
		--PK类型（0=不允许， 1=允许）
		pk = 0,
		--PK失败减少深度
		pk_less_depth = 0,
		--战场背景ID
		battlefield_id = 10,
		--场景ID
		field_id = 1,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_11.png"
	},

	[102] = 
	{
		--
		id = 102,
		last_id = 101,
		next_id = 103,
		--
		Name = "蒙阴故里",
		--信息
		Info = "[color=255|65|65]蒙阴故里：[/]\n昔日这里因为蒙恬大将军的庇护，而繁荣昌盛。在那么多年的战火过后，山青绿水的桃源景象早已不复存在。",
		--地图深度
		depth = 20,
		--探索需要精力
		vigour = 2,
		--PK类型（0=不允许， 1=允许）
		pk = 1,
		--PK失败减少深度
		pk_less_depth = 10,
		--战场背景ID
		battlefield_id = 12,
		--场景ID
		field_id = 11,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_12.png"
	},

	[103] = 
	{
		--
		id = 103,
		last_id = 102,
		next_id = 104,
		--
		Name = "将军亭",
		--信息
		Info = "[color=255|65|65]将军亭：[/]\n一副铠甲，破烂如锈铁。它是曾经的"..word_color[2].."公祠扈从[/]，如今依然守候在这里。",
		--地图深度
		depth = 1,
		--探索需要精力
		vigour = 1,
		--PK类型（0=不允许， 1=允许）
		pk = 0,
		--PK失败减少深度
		pk_less_depth = 0,
		--战场背景ID
		battlefield_id = 12,
		--场景ID
		field_id = 13,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_9.png"
	},

	[104] = 
	{
		--
		id = 104,
		last_id = 103,
		next_id = nil,
		--
		Name = "蒙公祠",
		--信息
		Info = "[color=255|65|65]蒙公祠：[/]\n你能感受到数千年前的桀骜之气吗？这里，那一位大将军长眠着。",
		--地图深度
		depth = 10,
		--探索需要精力
		vigour = 2,
		--PK类型（0=不允许， 1=允许）
		pk = 1,
		--PK失败减少深度
		pk_less_depth = 10,
		--战场背景ID
		battlefield_id = 12,
		--场景ID
		field_id = 5,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_10.png"
	},

     -------------------------------杂货铺-------------------------------
	[201] = 
	{
		--
		id = 201,
		last_id = nil,
		next_id = nil,
		--
		Name = "杂货铺",
		--信息
		Info = "[color=255|65|65]杂货铺：[/]\n这里有高级装备卖？不不不，那是大商会才有的本事。这些商人都只剩一缕魂魄，除了古币，其余的都不感兴趣。",
		--地图深度
		depth = 5,
		--探索需要精力
		vigour = 0,
		--PK类型（0=不允许， 1=允许）
		pk = 0,
		--PK失败减少深度
		pk_less_depth = 0,
		--战场背景ID
		battlefield_id = 5,
		--场景ID
		field_id = 17,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_21.png"
	},

     -------------------------------杀神之墓-------------------------------  
	[301] = 
	{
		--
		id = 301,
		last_id = nil,
		next_id = 302,
		--
		Name = "谷口冥灵",
		--信息
		Info = "[color=255|65|65]谷口冥灵：[/]\n十万魂灵过谷口，冥兵阴枪探来人。被活埋的俘虏，胸中憋着无尽的怨恨，正等着你的到来。",
		--地图深度
		depth = 20,
		--探索需要精力
		vigour = 2,
		--PK类型（0=不允许， 1=允许）
		pk = 0,
		--PK失败减少深度
		pk_less_depth =  0,
		--战场背景ID
		battlefield_id = 12,
		--场景ID
		field_id = 1,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_7.png"
	},

	[302] = 
	{
		--
		id = 302,
		last_id = 301,
		next_id = 303,
		--
		Name = "千岁白府",
		--信息
		Info = "[color=255|65|65]千岁白府：[/]\n破落的门第似乎在向后人昭示什么，那杀戮成性的可惧？还是那背负十万怨灵的可恨？",
		--地图深度
		depth = 20,
		--探索需要精力
		vigour = 2,
		--PK类型（0=不允许， 1=允许）
		pk = 1,
		--PK失败减少深度
		pk_less_depth = 10,
		--战场背景ID
		battlefield_id = 12,
		--场景ID
		field_id = 4,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_15.png"
	},

	[303] = 
	{
		--
		id = 303,
		last_id = 302,
		next_id = 304,
		--
		Name = "宗庙祠堂",
		--信息
		Info = "[color=255|65|65]宗庙祠堂：[/]\n有东西在等着你，等着你来揭开桎梏了无数年的愤怒，和尝尝这愤怒之中的焚天烈火。",
		--地图深度
		depth = 1,
		--探索需要精力
		vigour = 1,
		--PK类型（0=不允许， 1=允许）
		pk = 0,
		--PK失败减少深度
		pk_less_depth = 0,
		--战场背景ID
		battlefield_id = 12,
		--场景ID
		field_id = 5,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_22.png"
	},

	[304] = 
	{
		--
		id = 304,
		last_id = 303,
		next_id = nil,
		--
		Name = "杀戮之殿",
		--信息
		Info = "[color=255|65|65]杀戮之殿：[/]\n有人尊他赞他为战神，有人厌他恨他如屠夫。到现在，一切却都不是那么重要了。",
		--地图深度
		depth = 10,
		--探索需要精力
		vigour = 2,
		--PK类型（0=不允许， 1=允许）
		pk = 1,
		--PK失败减少深度
		pk_less_depth = 10,
		--战场背景ID
		battlefield_id = 14,
		--场景ID
		field_id = 6,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_17.png"
	},
    
    -------------------------------秦始皇陵-------------------------------
    [401] = 
	{
		--
		id = 401,
		last_id = nil,
		next_id = 402,
		--
		Name = "大秦遗迹",
		--信息
		Info = "[color=255|65|65]大秦遗迹：[/]\n这里是探险者的天堂，到处是散落的在地的宝物，这里也是探险者的坟墓，弱肉强食的丛林规则在这里体现的淋漓尽致。",
		--地图深度
		depth = 20,
		--探索需要精力
		vigour = 2,
		--PK类型（0=不允许， 1=允许）
		pk = 0,
		--PK失败减少深度
		pk_less_depth = 10,
		--战场背景ID
		battlefield_id = 10,
		--场景ID
		field_id = 9,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_5.png"
	},

	[402] = 
	{
		--
		id = 402,
		last_id = 401,
		next_id = 403,
		--
		Name = "兵佣校场",
		--信息
		Info = "[color=255|65|65]兵俑校场：[/]\n昔日守护帝王的军队在此集结，如今已是一片阴森空旷，毫无萧杀之意。只有零星散落在地的一些辎重遗迹，还能依稀表达出当年的盛况。",
		--地图深度
		depth = 20,
		--探索需要精力
		vigour = 2,
		--PK类型（0=不允许， 1=允许）
		pk = 1,
		--PK失败减少深度
		pk_less_depth = 10,
		--战场背景ID
		battlefield_id = 12,
		--场景ID
		field_id = 2,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_3.png"
	},

	[403] = 
	{
		--
		id = 403,
		last_id = 402,
		next_id = 404,
		--
		Name = "寝宫护卫",
		--信息
		Info = "[color=255|65|65]寝宫护卫：[/]\n这些虎卫曾被关押在终日不见天日的地牢，靠互相残杀生吃血肉为生，而现在，他们的手上尽是愚笨的闯入者的鲜血。",
		--地图深度
		depth = 1,
		--探索需要精力
		vigour = 1,
		--PK类型（0=不允许， 1=允许）
		pk = 0,
		--PK失败减少深度
		pk_less_depth = 0,
		--战场背景ID
		battlefield_id = 12,
		--场景ID
		field_id = 3,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_16.png"
	},

	[404] = 
	{
		--
		id = 404,
		last_id = 403,
		next_id = nil,
		--
		Name = "北麓皇陵",
		--信息
		Info = "[color=255|65|65]北麓皇陵：[/]\n水银为百川江河大海、珍珠宝石为天文星宿之象、金山碧土以示河山。爱卿，你既然已经来了，陪朕说说话可好？",
		--地图深度
		depth = 10,
		--探索需要精力
		vigour = 2,
		--PK类型（0=不允许， 1=允许）
		pk = 1,
		--PK失败减少深度
		pk_less_depth = 10,
		--战场背景ID
		battlefield_id = 14,
		--场景ID
		field_id = 7,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_2.png"
	},

	-------------------------------大商会-------------------------------

	[501] = 
	{
		--
		id = 501,
		last_id = nil,
		next_id = nil,
		--
		Name = "大商会",
		--信息
		Info = "[color=255|65|65]大商会：[/]\n那些老奸巨猾的商贾，他们的眼神可是从来没有离开过你的钱包半寸。",
		--地图深度
		depth = 5,
		--探索需要精力
		vigour = 0,
		--PK类型（0=不允许， 1=允许）
		pk = 0,
		--PK失败减少深度
		pk_less_depth = 0,
		--战场背景ID
		battlefield_id = 5,
		--场景ID
		field_id = 18,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_6.png"
	},

    -------------------------------草湾山-------------------------------
	[601] = 
	{
		--maze_cfg：自动添加所在迷宫配置
		--
		id = 601,
		last_id = nil,
		next_id = 602,
		--
		Name = "草湾山脚",
		--信息
		Info = "[color=255|65|65]草湾山脚：[/]\n在这山青水绿的外表下，也许藏着一副血腥地狱的画卷。",
		--地图深度
		depth = 20,
		--探索需要精力
		vigour = 2,
		--PK类型（0=不允许， 1=允许）
		pk = 0,
		--PK失败减少深度
		pk_less_depth = 0,
		--战场背景ID
		battlefield_id = 6,
		--场景ID-
		field_id = 15,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_4.png"
	},

	[602] = 
	{
		--
		id = 602,
		last_id = 601,
		next_id = 603,
		--
		Name = "山中小径",
		--信息
		Info = "[color=255|65|65]山中小径：[/]\n荒山野岭，劫匪好些年都不曾出现了，也许，是很多年没有人再敢从这里走过的原因。",
		--地图深度
		depth = 1,
		--探索需要精力
		vigour = 2,
		--PK类型（0=不允许， 1=允许）
		pk = 0,
		--PK失败减少深度
		pk_less_depth = 0,
		--战场背景ID
		battlefield_id = 6,
		--场景ID
		field_id = 12,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_18.png"
	},

	[603] = 
	{
		--
		id = 603,
		last_id = 602,
		next_id = 604,
		--
		Name = "后山",
		--信息
		Info = "[color=255|65|65]后山：[/]\n后山有一些奇怪的东西，一接近就会遭受它猛烈的攻击，这里一度被当地人视为禁地。",
		--地图深度
		depth = 20,
		--探索需要精力
		vigour = 2,
		--PK类型（0=不允许， 1=允许）
		pk = 1,
		--PK失败减少深度
		pk_less_depth = 0,
		--战场背景ID
		battlefield_id = 6,
		--场景ID
		field_id = 10,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_8.png"
	},

	[604] = 
	{
		--
		id = 604,
		last_id = 603,
		next_id = nil,
		--
		Name = "神秘山洞",
		--信息
		Info = "[color=255|65|65]神秘山洞：[/]\n如果你的身边还有同伴，请你一定要记住他的劝告。",
		--地图深度
		depth = 10,
		--探索需要精力
		vigour = 2,
		--PK类型（0=不允许， 1=允许）
		pk = 1,
		--PK失败减少深度
		pk_less_depth = 10,
		--战场背景ID
		battlefield_id = 11,
		--场景ID
		field_id = 8,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_19.png"
	},

    -------------------------------霸王密藏-------------------------------
	[701] = 
	{
		--
		id = 701,
		last_id = nil,
		next_id = 702,
		--
		Name = "秘藏甬道",
		--信息
		Info = "[color=255|65|65]秘藏甬道：[/]\n从地上散落的钱物来看，这里应该是进入宝库的通道了",
		--地图深度
		depth = 20,
		--探索需要精力
		vigour = 2,
		--PK类型（0=不允许， 1=允许）
		pk = 0,
		--PK失败减少深度
		pk_less_depth = 10,
		--战场背景ID
		battlefield_id = 11,
		--场景ID
		field_id = 3,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_13.png"
	},

	[702] = 
	{
		--
		id = 702,
		last_id = 701,
		next_id = 703,
		--
		Name = "宝库遗址",
		--信息
		Info = "[color=255|65|65]宝库遗址：[/]\n到处是堆积如山的生锈钱币……",
		--地图深度
		depth = 20,
		--探索需要精力
		vigour = 2,
		--PK类型（0=不允许， 1=允许）
		pk = 1,
		--PK失败减少深度
		pk_less_depth = 10,
		--战场背景ID
		battlefield_id = 11,
		--场景ID
		field_id = 16,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_27.png"
		
	},

	[703] = 
	{
		--
		id = 703,
		last_id = 702,
		next_id = 704,
		--
		Name = "武库遗址",
		--信息
		Info = "[color=255|65|65]武库遗址：[/]\n这里密密麻麻的堆满了成捆的刀枪剑戟……",
		--地图深度
		depth = 20,
		--探索需要精力
		vigour = 2,
		--PK类型（0=不允许， 1=允许）
		pk = 1,
		--PK失败减少深度
		pk_less_depth = 10,
		--战场背景ID
		battlefield_id = 11,
		--场景ID
		field_id = 19,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_20.png"
	},

	[704] = 
	{
		--
		id = 704,
		last_id = 703,
		next_id = nil,
		--
		Name = "霸王之藏",
		--信息
		Info = "[color=255|65|65]霸王之藏：乱石块垒横矩成阵，蛛网蝠洞探顶为查，哪怕你有勇气直面它们，但最里面的那位恐怖人物，你又能挤出多少胆量？[/]\n",
		--地图深度
		depth = 10,
		--探索需要精力
		vigour = 2,
		--PK类型（0=不允许， 1=允许）
		pk = 1,
		--PK失败减少深度
		pk_less_depth = 10,
		--战场背景ID
		battlefield_id = 8,
		--场景ID
		field_id = 14,
		--战场标题图片名
		battleTitleImageName = "word_mazeTitle_1.png"
	},

};



if GET_CONFIG_CHECK then
	local maze_error = false;
	for maze_id, maze in pairs(MazeConfig) do
		for idx, floor_id in pairs(maze.floors) do
			local floor = GetMazeFloorCfg(floor_id);
			if floor then
				--添加所在迷宫的配置
				floor.maze_cfg = maze;
			else
				print_log("can't find the floor["..floor_id.."] with maze["..maze_id.."]");
				maze_error = true;
			end
		end
	end

	for i, floor in ipairs(MazeFloors) do
		if not floor.maze_cfg then
			print_log("nil == floor.maze_cfg id="..floor.ids);
		end
	end

	if maze_error then
		print_face("maze config error!!!");
		assert(false);
	end
end




