--
-- Author: 张科智
-- Date: 2014-03-17
-- 技能配置



function GetSkill( skill_id )
	if GET_CONFIG_CHECK and nil == SkillConfig[skill_id] then
		print_log(debug.traceback());
		print_log("Not found skill("..skill_id..")");
		--return SkillConfig[-1];
	end
	return SkillConfig[skill_id];
end



--获取技能书名字
function getSkillBookName( skill_id )
	local config = GetSkill(skill_id)

	if config.pinZhi == 1 then
		return "绿色技能书"

	elseif config.pinZhi == 2 then
		return "蓝色技能书"

	elseif config.pinZhi == 3 then
		return "紫色技能书"

	elseif config.pinZhi == 4 then
		return "橙色技能书"
	end
end

function SkillConfig_getIcon( id )
	return SkillConfig[id].icon
end

--战前动画时间
g_BeforeTime = 9;
--一次战斗动作的等待时间
g_ActionTime = 1.3;
g_UnitSpeedUpValuse = 0.3
--战斗速度比 公式 (1+g_UnitSpeedUpValuse * (speedValuse - 1))
g_SpeedScale = 
{
	1,
	1+g_UnitSpeedUpValuse * 1,
	1.3+(g_UnitSpeedUpValuse - 0.2) * 2,
	1.3+(g_UnitSpeedUpValuse - 0.2) * 3,
	1.3+(g_UnitSpeedUpValuse - 0.2) * 4,
	1.3+(g_UnitSpeedUpValuse - 0.1) * 8,
	1.3+(g_UnitSpeedUpValuse - 0.1) * 8,
	1.3+(g_UnitSpeedUpValuse - 0.1) * 10,
	1.3+(g_UnitSpeedUpValuse - 0.1) * 10,
};

--[[
	技能属性说明：

	name			技能名称
	description		技能介绍
	castingactionID = 1, -- 施法动作ID 0 表示没有
	CastingEffectID = 1, -- 施法效果ID 0 表示没有
	CastingHurtEffectID = 1, -- 施法伤害效果ID 0 表示没有

	execute_fun		执行函数（
						skill_lv:技能等级, 
						self_pos:自己位置, 
						self_array:己方阵容, 
						enemy_array:地方阵容
					）
					返回值（数组）：
					{
						{
							--目标方位（true=己方，false=敌方）
							is_self, 
							--目标位置
							pos,
							--直接HP伤害（或增加）
							damage,
							--造成buff
							buff_id,
						},
					}
]]



--混乱攻击技能ID
Confusion_Single_ID = 1510001;
--自己复活技能ID
Self_Relive_ID = 1010101;


--技能配置
SkillConfig = 
{
	[1000001]=
	{
		id = 1000001,
		name = "",
		icon = 50003,
		description = "对敌军单体造成(100%+5%*强度)的伤害",
		CastingactionID = 1103,--施法动作ID
		CastingEffectID = 20000,--施法效果ID
		CastingHurtEffectID = 1,--伤害效果
		CastingType = 1,--施法类型
		CastingNameShow = 0,--是否显示名称
		-- execute_fun = ClientSkillConfig or Skill_Single(1, 0.05, false, 1),
		CastingTotalDamage  = 0,
		CastingTime = 0,--施法时间
	},

	[1000002]=
	{
		id = 1000002,
		name = "",
		icon = 50003,
		description = "对敌军单体造成(100%+5%*强度)的伤害",
		CastingactionID = 0,--施法动作ID
		CastingEffectID = 20001,--施法效果ID
		CastingHurtEffectID = 1,--伤害效果
		CastingType = 1,--施法类型
		CastingNameShow = 0,--是否显示名称
		-- execute_fun = ClientSkillConfig or Skill_Single(1, 0.05, false, 1),
		CastingTotalDamage  = 0,
		CastingTime = 0,--施法时间
	},

	[1000003]=
	{
		id = 1000003,
		name = "",
		icon = 50003,
		description = "对敌军单体造成(100%+5%*强度)的伤害",
		CastingactionID = 1103,--施法动作ID
		CastingEffectID = 20000,--施法效果ID
		CastingHurtEffectID = 1,--伤害效果
		CastingType = 1,--施法类型
		CastingNameShow = 0,--是否显示名称
		-- execute_fun = ClientSkillConfig or Skill_Single(1, 0.05, false, 1),
		CastingTotalDamage  = 0,
		CastingTime = 0,--施法时间
	},
}





