--
-- Author: zkz
-- Date: 2014-03-24 10:17:34
-- VIP配置




--取得VIP配置
function GetVipCfg(vip_lvl)
	if GET_CONFIG_CHECK and nil == VipConfig[vip_lvl] then
		print_log(debug.traceback());
		print_log("Not found vip_lvl("..vip_lvl..")");
		return VipConfig[0];
	end
	return VipConfig[vip_lvl];
end

--得到VIP等级
function GetVipLevel(recharge_amount)
	for i, vip_cfg in ipairs(VipConfig) do
		if recharge_amount < vip_cfg.recharge_amount then
			return i - 1;
		end
	end
	return #VipConfig;
end

MaxStamina = 12;
MaxVigour = 60;
ReshOpenLv = 1;

--VIP数据
VipConfig = 
{
[0] = {recharge_amount = 0, gift_id = 0, buy_friend = 8, buy_equip = 15, able_rush = 0, every_day = {jjc_num = 5, buy_jjc = 0, boss_num = 3, buy_boss = 0, buy_quick = 3, quick_item_num = 10, peerage_exp = 40, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 1, refresh_save = 3, }, info = "☆每日可购买3次快速战斗\n☆每日可使用速战令10\n☆每日获得声望上限40\n", },
[1] = {recharge_amount = 10, gift_id = 1, buy_friend = 8, buy_equip = 15, able_rush = 1, every_day = {jjc_num = 5, buy_jjc = 0, boss_num = 3, buy_boss = 1, buy_quick = 4, quick_item_num = 12, peerage_exp = 42, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 3, refresh_save = 4, }, info = "★累计充值1元★\n☆每日可购买4次快速战斗\n☆每日可购买1次挑战BOSS\n☆每日可使用速战令12\n☆每日获得声望上限42\n☆重铸列表刷新次数可累计4次\n☆可扫荡BOSS\n☆可购买VIP1特惠礼包\n", },
[2] = {recharge_amount = 100, gift_id = 2, buy_friend = 8, buy_equip = 15, able_rush = 1, every_day = {jjc_num = 5, buy_jjc = 1, boss_num = 3, buy_boss = 2, buy_quick = 4, quick_item_num = 14, peerage_exp = 44, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 5, refresh_save = 4, }, info = "★累计充值10元★\n☆每日可购买4次快速战斗\n☆每日可购买2次挑战BOSS\n☆每日可购买1次竞技场进攻次数\n☆每日可使用速战令14\n☆每日获得声望上限44\n☆重铸列表刷新次数可累计4次\n☆可扫荡BOSS\n☆可购买VIP2特惠礼包\n", },
[3] = {recharge_amount = 300, gift_id = 3, buy_friend = 8, buy_equip = 15, able_rush = 1, every_day = {jjc_num = 5, buy_jjc = 2, boss_num = 3, buy_boss = 3, buy_quick = 5, quick_item_num = 16, peerage_exp = 46, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 7, refresh_save = 4, }, info = "★累计充值30元★\n☆每日可购买5次快速战斗\n☆每日可购买3次挑战BOSS\n☆每日可购买2次竞技场进攻次数\n☆每日可使用速战令16\n☆每日获得声望上限46\n☆重铸列表刷新次数可累计4次\n☆可扫荡BOSS\n☆可购买VIP3特惠礼包\n", },
[4] = {recharge_amount = 500, gift_id = 4, buy_friend = 8, buy_equip = 15, able_rush = 1, every_day = {jjc_num = 5, buy_jjc = 3, boss_num = 3, buy_boss = 4, buy_quick = 5, quick_item_num = 18, peerage_exp = 48, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 9, refresh_save = 4, }, info = "★累计充值50元★\n☆每日可购买5次快速战斗\n☆每日可购买4次挑战BOSS\n☆每日可购买3次竞技场进攻次数\n☆每日可使用速战令18\n☆每日获得声望上限48\n☆重铸列表刷新次数可累计4次\n☆可扫荡BOSS\n☆可购买VIP4特惠礼包\n", },
[5] = {recharge_amount = 1000, gift_id = 5, buy_friend = 8, buy_equip = 15, able_rush = 1, every_day = {jjc_num = 5, buy_jjc = 4, boss_num = 3, buy_boss = 5, buy_quick = 6, quick_item_num = 20, peerage_exp = 50, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 11, refresh_save = 5, }, info = "★累计充值100元★\n☆每日可购买6次快速战斗\n☆每日可购买5次挑战BOSS\n☆每日可购买4次竞技场进攻次数\n☆每日可使用速战令20\n☆每日获得声望上限50\n☆重铸列表刷新次数可累计5次\n☆可扫荡BOSS\n☆可购买VIP5特惠礼包\n", },
[6] = {recharge_amount = 2000, gift_id = 6, buy_friend = 8, buy_equip = 15, able_rush = 1, every_day = {jjc_num = 5, buy_jjc = 5, boss_num = 3, buy_boss = 6, buy_quick = 6, quick_item_num = 22, peerage_exp = 52, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 13, refresh_save = 5, }, info = "★累计充值200元★\n☆每日可购买6次快速战斗\n☆每日可购买6次挑战BOSS\n☆每日可购买5次竞技场进攻次数\n☆每日可使用速战令22\n☆每日获得声望上限52\n☆重铸列表刷新次数可累计5次\n☆可扫荡BOSS\n☆可购买VIP6特惠礼包\n", },
[7] = {recharge_amount = 3000, gift_id = 7, buy_friend = 8, buy_equip = 15, able_rush = 1, every_day = {jjc_num = 5, buy_jjc = 6, boss_num = 3, buy_boss = 7, buy_quick = 7, quick_item_num = 24, peerage_exp = 54, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 15, refresh_save = 5, }, info = "★累计充值300元★\n☆每日可购买7次快速战斗\n☆每日可购买7次挑战BOSS\n☆每日可购买6次竞技场进攻次数\n☆每日可使用速战令24\n☆每日获得声望上限54\n☆重铸列表刷新次数可累计5次\n☆可扫荡BOSS\n☆可购买VIP7特惠礼包\n", },
[8] = {recharge_amount = 5000, gift_id = 8, buy_friend = 8, buy_equip = 15, able_rush = 1, every_day = {jjc_num = 5, buy_jjc = 7, boss_num = 3, buy_boss = 8, buy_quick = 7, quick_item_num = 26, peerage_exp = 56, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 17, refresh_save = 5, }, info = "★累计充值500元★\n☆每日可购买7次快速战斗\n☆每日可购买8次挑战BOSS\n☆每日可购买7次竞技场进攻次数\n☆每日可使用速战令26\n☆每日获得声望上限56\n☆重铸列表刷新次数可累计5次\n☆可扫荡BOSS\n☆可购买VIP8特惠礼包\n", },
[9] = {recharge_amount = 7000, gift_id = 9, buy_friend = 8, buy_equip = 15, able_rush = 1, every_day = {jjc_num = 5, buy_jjc = 8, boss_num = 3, buy_boss = 9, buy_quick = 8, quick_item_num = 28, peerage_exp = 58, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 19, refresh_save = 6, }, info = "★累计充值700元★\n☆每日可购买8次快速战斗\n☆每日可购买9次挑战BOSS\n☆每日可购买8次竞技场进攻次数\n☆每日可使用速战令28\n☆每日获得声望上限58\n☆重铸列表刷新次数可累计6次\n☆可扫荡BOSS\n☆可购买VIP9特惠礼包\n", },
[10] = {recharge_amount = 10000, gift_id = 10, buy_friend = 8, buy_equip = 15, able_rush = 1, every_day = {jjc_num = 5, buy_jjc = 9, boss_num = 3, buy_boss = 10, buy_quick = 8, quick_item_num = 30, peerage_exp = 60, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 21, refresh_save = 6, }, info = "★累计充值1000元★\n☆每日可购买8次快速战斗\n☆每日可购买10次挑战BOSS\n☆每日可购买9次竞技场进攻次数\n☆每日可使用速战令30\n☆每日获得声望上限60\n☆重铸列表刷新次数可累计6次\n☆可扫荡BOSS\n☆可购买VIP10特惠礼包\n", },
[11] = {recharge_amount = 15000, gift_id = 11, buy_friend = 8, buy_equip = 15, able_rush = 1, every_day = {jjc_num = 5, buy_jjc = 10, boss_num = 3, buy_boss = 11, buy_quick = 9, quick_item_num = 32, peerage_exp = 62, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 23, refresh_save = 6, }, info = "★累计充值1500元★\n☆每日可购买9次快速战斗\n☆每日可购买11次挑战BOSS\n☆每日可购买10次竞技场进攻次数\n☆每日可使用速战令32\n☆每日获得声望上限62\n☆重铸列表刷新次数可累计6次\n☆可扫荡BOSS\n☆可购买VIP11特惠礼包\n", },
[12] = {recharge_amount = 20000, gift_id = 12, buy_friend = 8, buy_equip = 15, able_rush = 1, every_day = {jjc_num = 5, buy_jjc = 11, boss_num = 3, buy_boss = 12, buy_quick = 9, quick_item_num = 34, peerage_exp = 64, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 25, refresh_save = 6, }, info = "★累计充值2000元★\n☆每日可购买9次快速战斗\n☆每日可购买12次挑战BOSS\n☆每日可购买11次竞技场进攻次数\n☆每日可使用速战令34\n☆每日获得声望上限64\n☆重铸列表刷新次数可累计6次\n☆可扫荡BOSS\n☆可购买VIP12特惠礼包\n", },
[13] = {recharge_amount = 30000, gift_id = 13, buy_friend = 8, buy_equip = 15, able_rush = 1, every_day = {jjc_num = 5, buy_jjc = 12, boss_num = 3, buy_boss = 13, buy_quick = 10, quick_item_num = 36, peerage_exp = 66, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 27, refresh_save = 7, }, info = "★累计充值3000元★\n☆每日可购买10次快速战斗\n☆每日可购买13次挑战BOSS\n☆每日可购买12次竞技场进攻次数\n☆每日可使用速战令36\n☆每日获得声望上限66\n☆重铸列表刷新次数可累计7次\n☆可扫荡BOSS\n☆可购买VIP13特惠礼包\n", },
[14] = {recharge_amount = 50000, gift_id = 14, buy_friend = 8, buy_equip = 15, able_rush = 1, every_day = {jjc_num = 5, buy_jjc = 13, boss_num = 3, buy_boss = 14, buy_quick = 10, quick_item_num = 38, peerage_exp = 68, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 29, refresh_save = 7, }, info = "★累计充值5000元★\n☆每日可购买10次快速战斗\n☆每日可购买14次挑战BOSS\n☆每日可购买13次竞技场进攻次数\n☆每日可使用速战令38\n☆每日获得声望上限68\n☆重铸列表刷新次数可累计7次\n☆可扫荡BOSS\n☆可购买VIP14特惠礼包\n", },
[15] = {recharge_amount = 70000, gift_id = 15, buy_friend = 8, buy_equip = 15, able_rush = 1, every_day = {jjc_num = 5, buy_jjc = 14, boss_num = 3, buy_boss = 15, buy_quick = 11, quick_item_num = 40, peerage_exp = 70, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 31, refresh_save = 7, }, info = "★累计充值7000元★\n☆每日可购买11次快速战斗\n☆每日可购买15次挑战BOSS\n☆每日可购买14次竞技场进攻次数\n☆每日可使用速战令40\n☆每日获得声望上限70\n☆重铸列表刷新次数可累计7次\n☆可扫荡BOSS\n☆可购买VIP15特惠礼包\n", },
[16] = {recharge_amount = 100000, gift_id = 16, buy_friend = 8, buy_equip = 15, able_rush = 1, every_day = {jjc_num = 5, buy_jjc = 15, boss_num = 3, buy_boss = 16, buy_quick = 12, quick_item_num = 42, peerage_exp = 72, map_war_play_num = 5, buy_map_war_num = 99, draw_num = 1, buy_gold = 33, refresh_save = 7, }, info = "★累计充值10000元★\n☆每日可购买12次快速战斗\n☆每日可购买16次挑战BOSS\n☆每日可购买15次竞技场进攻次数\n☆每日可使用速战令42\n☆每日获得声望上限72\n☆重铸列表刷新次数可累计7次\n☆可扫荡BOSS\n☆可购买VIP16特惠礼包\n", },



};


-- 购买挑战次数元宝数量
-------------------------------------------------------
ArenaPlayPrice = 
{
	[1] = 50,
	[2] = 50,
	[3] = 50,
	[4] = 50,
	[5] = 50,
	[6] = 50,
	[7] = 50,
	[8] = 50,
	[9] = 50,
	[10] = 50,
	[11] = 50,
	[12] = 50,
	[13] = 50,
	[14] = 50,
	[15] = 50,
};


-- 购买BOSS次数元宝数量
-------------------------------------------------------
BossPlayPrice = 
{
	[1] = 20,
	[2] = 40,
	[3] = 60,
	[4] = 80,
	[5] = 100,
	[6] = 120,
	[7] = 140,
	[8] = 160,
	[9] = 180,
	[10] = 200,
	[11] = 220,
	[12] = 240,
	[13] = 260,
	[14] = 280,
	[15] = 300,
	[16] = 320,
};

-- 购买快速战斗次数元宝数量
-------------------------------------------------------
QuickPlayPrice = 
{
	[1] = 20,
	[2] = 40,
	[3] = 60,
	[4] = 80,
	[5] = 100,
	[6] = 120,
	[7] = 140,
	[8] = 160,
	[9] = 180,
	[10] = 200,
	[11] = 220,
	[12] = 240,
	[13] = 260,
	[14] = 280,
	[15] = 300,
};


-- 购买攻城次数元宝数量
-------------------------------------------------------
MAP_WAR_PAYE_PRICE = 50;

-- 抽卡元宝价格
-------------------------------------------------------
DRAW_CARD_PRICE = 100;
MULTIPLE_DRAW_CARD_PRICE = 800;



