
--得到大本营配置
function GetShelterCfg(shelter_lv)
	local re = ShelterCfg[shelter_lv];
	if re then
		return re;
	end
	print_log(debug.traceback());
end

--得到塔防配置
function GetTowerCfg(tower_lv)
	local re = TowerCfg[tower_lv];
	if re then
		return re;
	end
	print_log(debug.traceback());
end

--得到地块等级配置
function GetAreaLvCfg(human_num)
	local lv_t = AreaLvCfg[1];
	for i, v in ipairs(AreaLvCfg) do
		if v.human_num <= human_num then
			lv_t = v;
		end
	end
	return lv_t;
end

--[[建筑配置
	index 建筑下标 type * 1000 + level
	buildtype 建筑类型 1 工会大本营 2 个人塔防
	lv 建筑等级 
	des 建筑描述
	builddrawinfo 建筑表现文件
	gold 金币
	tnum 工会大本营塔防数量
	width 占地面积
	height
	protectScope = {x = -1,y = -1,w= 4,h = 4},保护范围
	atk=0, hp=1900, range=0, fanwei=0, atk_invl=0, move_invl=0 , vol=487属性值
]]

ShelterCfg = 
{
[1]= {lv=1, des="庇护所1", resID=30000, skillID=0, gold=10, tnum=3, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=1200, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=30000, },
[2]= {lv=2, des="庇护所1", resID=30000, skillID=0, gold=162, tnum=3, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=1300, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=40500, },
[3]= {lv=3, des="庇护所1", resID=30000, skillID=0, gold=612, tnum=4, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=1400, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=68000, },
[4]= {lv=4, des="庇护所1", resID=30000, skillID=0, gold=1312, tnum=4, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=1500, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=82000, },
[5]= {lv=5, des="庇护所1", resID=30000, skillID=0, gold=3000, tnum=5, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=1600, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=120000, },
[6]= {lv=6, des="庇护所1", resID=30000, skillID=0, gold=4950, tnum=5, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=1700, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=137500, },
[7]= {lv=7, des="庇护所1", resID=30000, skillID=0, gold=9114, tnum=6, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=1800, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=186000, },
[8]= {lv=8, des="庇护所1", resID=30000, skillID=0, gold=13248, tnum=6, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=1900, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=207000, },
[9]= {lv=9, des="庇护所1", resID=30000, skillID=0, gold=21546, tnum=7, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=2000, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=266000, },
[10]= {lv=10, des="庇护所1", resID=30000, skillID=0, gold=29050, tnum=7, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=2100, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=290500, },
[11]= {lv=11, des="庇护所1", resID=30000, skillID=0, gold=43560, tnum=8, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=2200, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=360000, },
[12]= {lv=12, des="庇护所1", resID=30000, skillID=0, gold=55872, tnum=8, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=2300, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=388000, },
[13]= {lv=13, des="庇护所1", resID=30000, skillID=0, gold=79092, tnum=9, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=2400, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=468000, },
[14]= {lv=14, des="庇护所1", resID=30000, skillID=0, gold=97902, tnum=9, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=2500, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=499500, },
[15]= {lv=15, des="庇护所1", resID=30000, skillID=0, gold=132750, tnum=10, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=2600, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=590000, },
[16]= {lv=16, des="庇护所1", resID=30000, skillID=0, gold=160000, tnum=10, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=2700, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=625000, },
[17]= {lv=17, des="庇护所1", resID=30000, skillID=0, gold=209814, tnum=11, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=2800, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=726000, },
[18]= {lv=18, des="庇护所1", resID=30000, skillID=0, gold=247698, tnum=11, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=2900, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=764500, },
[19]= {lv=19, des="庇护所1", resID=30000, skillID=0, gold=316236, tnum=12, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=3000, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=876000, },
[20]= {lv=20, des="庇护所1", resID=30000, skillID=0, gold=367200, tnum=12, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=3100, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=918000, },
[21]= {lv=21, des="庇护所1", resID=30000, skillID=0, gold=458640, tnum=13, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=3200, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=1040000, },
[22]= {lv=22, des="庇护所1", resID=30000, skillID=0, gold=525382, tnum=13, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=3300, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=1085500, },
[23]= {lv=23, des="庇护所1", resID=30000, skillID=0, gold=644322, tnum=14, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=3400, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=1218000, },
[24]= {lv=24, des="庇护所1", resID=30000, skillID=0, gold=729792, tnum=14, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=3500, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=1267000, },
[25]= {lv=25, des="庇护所1", resID=30000, skillID=0, gold=881250, tnum=15, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=3600, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=1410000, },
[26]= {lv=26, des="庇护所1", resID=30000, skillID=0, gold=988650, tnum=15, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=3700, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=1462500, },
[27]= {lv=27, des="庇护所1", resID=30000, skillID=0, gold=1178064, tnum=16, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=3800, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=1616000, },
[28]= {lv=28, des="庇护所1", resID=30000, skillID=0, gold=1310848, tnum=16, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=3900, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=1672000, },
[29]= {lv=29, des="庇护所1", resID=30000, skillID=0, gold=1544076, tnum=17, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=4000, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=1836000, },
[30]= {lv=30, des="庇护所1", resID=30000, skillID=0, gold=1705950, tnum=17, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=4100, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=1895500, },
[31]= {lv=31, des="庇护所1", resID=30000, skillID=0, gold=1989270, tnum=18, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=4200, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=2070000, },
[32]= {lv=32, des="庇护所1", resID=30000, skillID=0, gold=2184192, tnum=18, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=4300, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=2133000, },
[33]= {lv=33, des="庇护所1", resID=30000, skillID=0, gold=2524302, tnum=19, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=4400, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=2318000, },
[34]= {lv=34, des="庇护所1", resID=30000, skillID=0, gold=2756482, tnum=19, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=4500, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=2384500, },
[35]= {lv=35, des="庇护所1", resID=30000, skillID=0, gold=3160500, tnum=20, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=4600, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=2580000, },
[36]= {lv=36, des="庇护所1", resID=30000, skillID=0, gold=3434400, tnum=20, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=4700, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=2650000, },
[37]= {lv=37, des="庇护所1", resID=30000, skillID=0, gold=3909864, tnum=21, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=4800, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=2856000, },
[38]= {lv=38, des="庇护所1", resID=30000, skillID=0, gold=4230198, tnum=21, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=4900, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=2929500, },
[39]= {lv=39, des="庇护所1", resID=30000, skillID=0, gold=4785066, tnum=22, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=5000, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=3146000, },
[40]= {lv=40, des="庇护所1", resID=30000, skillID=0, gold=5156800, tnum=22, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=5100, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=3223000, },
[41]= {lv=41, des="庇护所1", resID=30000, skillID=0, gold=5799450, tnum=23, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=5200, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=3450000, },
[42]= {lv=42, des="庇护所1", resID=30000, skillID=0, gold=6227802, tnum=23, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=5300, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=3530500, },
[43]= {lv=43, des="庇护所1", resID=30000, skillID=0, gold=6967032, tnum=24, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=5400, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=3768000, },
[44]= {lv=44, des="庇护所1", resID=30000, skillID=0, gold=7457472, tnum=24, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=5500, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=3852000, },
[45]= {lv=45, des="庇护所1", resID=30000, skillID=0, gold=8302500, tnum=25, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=5600, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=4100000, },
[46]= {lv=46, des="庇护所1", resID=30000, skillID=0, gold=8860750, tnum=25, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=5700, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=4187500, },
[47]= {lv=47, des="庇护所1", resID=30000, skillID=0, gold=9821214, tnum=26, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=5800, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=4446000, },
[48]= {lv=48, des="庇护所1", resID=30000, skillID=0, gold=10453248, tnum=26, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=5900, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=4537000, },
[49]= {lv=49, des="庇护所1", resID=30000, skillID=0, gold=11539206, tnum=27, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=6000, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=4806000, },
[50]= {lv=50, des="庇护所1", resID=30000, skillID=0, gold=12251250, tnum=27, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=6100, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=4900500, },
[51]= {lv=51, des="庇护所1", resID=30000, skillID=0, gold=13473180, tnum=28, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=6200, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=5180000, },
[52]= {lv=52, des="庇护所1", resID=30000, skillID=0, gold=14271712, tnum=28, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=6300, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=5278000, },
[53]= {lv=53, des="庇护所1", resID=30000, skillID=0, gold=15640512, tnum=29, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=6400, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=5568000, },
[54]= {lv=54, des="庇护所1", resID=30000, skillID=0, gold=16532262, tnum=29, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=6500, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=5669500, },
[55]= {lv=55, des="庇护所1", resID=30000, skillID=0, gold=18059250, tnum=30, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=6600, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=5970000, },
[56]= {lv=56, des="庇护所1", resID=30000, skillID=0, gold=19051200, tnum=30, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=6700, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=6075000, },
[57]= {lv=57, des="庇护所1", resID=30000, skillID=0, gold=20748114, tnum=31, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=6800, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=6386000, },
[58]= {lv=58, des="庇护所1", resID=30000, skillID=0, gold=21847498, tnum=31, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=6900, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=6494500, },
[59]= {lv=59, des="庇护所1", resID=30000, skillID=0, gold=23726496, tnum=32, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=7000, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=6816000, },
[60]= {lv=60, des="庇护所1", resID=30000, skillID=0, gold=24940800, tnum=32, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=7100, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=6928000, },
[61]= {lv=61, des="庇护所1", resID=30000, skillID=0, gold=27014460, tnum=33, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=7200, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=7260000, },
[62]= {lv=62, des="庇护所1", resID=30000, skillID=0, gold=28351422, tnum=33, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=7300, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=7375500, },
[63]= {lv=63, des="庇护所1", resID=30000, skillID=0, gold=30632742, tnum=34, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=7400, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=7718000, },
[64]= {lv=64, des="庇护所1", resID=30000, skillID=0, gold=32100352, tnum=34, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=7500, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=7837000, },
[65]= {lv=65, des="庇护所1", resID=30000, skillID=0, gold=34602750, tnum=35, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=7600, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=8190000, },
[66]= {lv=66, des="庇护所1", resID=30000, skillID=0, gold=36209250, tnum=35, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=7700, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=8312500, },
[67]= {lv=67, des="庇护所1", resID=30000, skillID=0, gold=38946564, tnum=36, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=7800, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=8676000, },
[68]= {lv=68, des="庇护所1", resID=30000, skillID=0, gold=40700448, tnum=36, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=7900, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=8802000, },
[69]= {lv=69, des="庇护所1", resID=30000, skillID=0, gold=43686936, tnum=37, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=8000, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=9176000, },
[70]= {lv=70, des="庇护所1", resID=30000, skillID=0, gold=45596950, tnum=37, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=8100, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=9305500, },
[71]= {lv=71, des="庇护所1", resID=30000, skillID=0, gold=48847290, tnum=38, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=8200, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=9690000, },
[72]= {lv=72, des="庇护所1", resID=30000, skillID=0, gold=50922432, tnum=38, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=8300, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=9823000, },
[73]= {lv=73, des="庇护所1", resID=30000, skillID=0, gold=54451722, tnum=39, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=8400, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=10218000, },
[74]= {lv=74, des="庇护所1", resID=30000, skillID=0, gold=56701242, tnum=39, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=8500, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=10354500, },
[75]= {lv=75, des="庇护所1", resID=30000, skillID=0, gold=60525000, tnum=40, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=8600, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=10760000, },
[76]= {lv=76, des="庇护所1", resID=30000, skillID=0, gold=62958400, tnum=40, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=8700, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=10900000, },
[77]= {lv=77, des="庇护所1", resID=30000, skillID=0, gold=67092564, tnum=41, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=8800, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=11316000, },
[78]= {lv=78, des="庇护所1", resID=30000, skillID=0, gold=69719598, tnum=41, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=8900, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=11459500, },
[79]= {lv=79, des="庇护所1", resID=30000, skillID=0, gold=74180526, tnum=42, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=9000, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=11886000, },
[80]= {lv=80, des="庇护所1", resID=30000, skillID=0, gold=77011200, tnum=42, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=9100, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=12033000, },
[81]= {lv=81, des="庇护所1", resID=30000, skillID=0, gold=81815670, tnum=43, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=9200, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=12470000, },
[82]= {lv=82, des="庇护所1", resID=30000, skillID=0, gold=84860242, tnum=43, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=9300, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=12620500, },
[83]= {lv=83, des="庇护所1", resID=30000, skillID=0, gold=90025452, tnum=44, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=9400, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=13068000, },
[84]= {lv=84, des="庇护所1", resID=30000, skillID=0, gold=93294432, tnum=44, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=9500, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=13222000, },
[85]= {lv=85, des="庇护所1", resID=30000, skillID=0, gold=98838000, tnum=45, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=9600, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=13680000, },
[86]= {lv=86, des="庇护所1", resID=30000, skillID=0, gold=102342150, tnum=45, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=9700, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=13837500, },
[87]= {lv=87, des="庇护所1", resID=30000, skillID=0, gold=108282114, tnum=46, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=9800, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=14306000, },
[88]= {lv=88, des="庇护所1", resID=30000, skillID=0, gold=112032448, tnum=46, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=9900, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=14467000, },
[89]= {lv=89, des="庇护所1", resID=30000, skillID=0, gold=118387266, tnum=47, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=10000, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=14946000, },
[90]= {lv=90, des="庇护所1", resID=30000, skillID=0, gold=122395050, tnum=47, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=10100, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=15110500, },
[91]= {lv=91, des="庇护所1", resID=30000, skillID=0, gold=129183600, tnum=48, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=10200, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=15600000, },
[92]= {lv=92, des="庇护所1", resID=30000, skillID=0, gold=133460352, tnum=48, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=10300, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=15768000, },
[93]= {lv=93, des="庇护所1", resID=30000, skillID=0, gold=140701932, tnum=49, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=10400, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=16268000, },
[94]= {lv=94, des="庇护所1", resID=30000, skillID=0, gold=145259422, tnum=49, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=10500, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=16439500, },
[95]= {lv=95, des="庇护所1", resID=30000, skillID=0, gold=152973750, tnum=50, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=10600, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=16950000, },
[96]= {lv=96, des="庇护所1", resID=30000, skillID=0, gold=157824000, tnum=50, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=10700, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=17125000, },
[97]= {lv=97, des="庇护所1", resID=30000, skillID=0, gold=162775700, tnum=50, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=10800, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=17300000, },
[98]= {lv=98, des="庇护所1", resID=30000, skillID=0, gold=167829900, tnum=50, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=10800, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=17475000, },
[99]= {lv=99, des="庇护所1", resID=30000, skillID=0, gold=172987650, tnum=50, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=10800, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=17650000, },
[100]= {lv=100, des="庇护所1", resID=30000, skillID=0, gold=178250000, tnum=50, cell_w=3, cell_h=3, protectScope = { x=-8, y=-8, w=20, h=20, }, atk=0, hp=10800, range=0, fanwei=0, atk_invl=0, move_invl=0, vol=17825000, },


};




TowerCfg = 
{
[1] = {lv=1, des="建筑1", resID=30001, skillID=1000002, gold=0, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=18, hp=618, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=5000, gold_out=50, },
[2] = {lv=2, des="建筑1", resID=30001, skillID=1000002, gold=250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=20, hp=687, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=5500, gold_out=55, },
[3] = {lv=3, des="建筑1", resID=30001, skillID=1000002, gold=700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=22, hp=757, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=6000, gold_out=60, },
[4] = {lv=4, des="建筑1", resID=30001, skillID=1000002, gold=1450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=24, hp=827, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=6500, gold_out=65, },
[5] = {lv=5, des="建筑1", resID=30001, skillID=1000002, gold=2500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=26, hp=898, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=7000, gold_out=70, },
[6] = {lv=6, des="建筑1", resID=30001, skillID=1000002, gold=3850, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=28, hp=970, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=7500, gold_out=75, },
[7] = {lv=7, des="建筑1", resID=30001, skillID=1000002, gold=5500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=30, hp=1042, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=8000, gold_out=80, },
[8] = {lv=8, des="建筑1", resID=30001, skillID=1000002, gold=7450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=32, hp=1115, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=8500, gold_out=85, },
[9] = {lv=9, des="建筑1", resID=30001, skillID=1000002, gold=9700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=34, hp=1189, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=9000, gold_out=90, },
[10] = {lv=10, des="建筑1", resID=30001, skillID=1000002, gold=12250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=36, hp=1263, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=9500, gold_out=95, },
[11] = {lv=11, des="建筑1", resID=30001, skillID=1000002, gold=15100, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=38, hp=1338, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=10000, gold_out=100, },
[12] = {lv=12, des="建筑1", resID=30001, skillID=1000002, gold=18250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=40, hp=1414, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=10500, gold_out=105, },
[13] = {lv=13, des="建筑1", resID=30001, skillID=1000002, gold=21700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=42, hp=1491, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=11000, gold_out=110, },
[14] = {lv=14, des="建筑1", resID=30001, skillID=1000002, gold=25450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=44, hp=1568, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=11500, gold_out=115, },
[15] = {lv=15, des="建筑1", resID=30001, skillID=1000002, gold=29500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=46, hp=1646, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=12000, gold_out=120, },
[16] = {lv=16, des="建筑1", resID=30001, skillID=1000002, gold=33850, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=48, hp=1725, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=12500, gold_out=125, },
[17] = {lv=17, des="建筑1", resID=30001, skillID=1000002, gold=38500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=50, hp=1804, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=13000, gold_out=130, },
[18] = {lv=18, des="建筑1", resID=30001, skillID=1000002, gold=43450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=52, hp=1884, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=13500, gold_out=135, },
[19] = {lv=19, des="建筑1", resID=30001, skillID=1000002, gold=48700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=54, hp=1965, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=14000, gold_out=140, },
[20] = {lv=20, des="建筑1", resID=30001, skillID=1000002, gold=54250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=56, hp=2046, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=14500, gold_out=145, },
[21] = {lv=21, des="建筑1", resID=30001, skillID=1000002, gold=60100, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=58, hp=2128, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=15000, gold_out=150, },
[22] = {lv=22, des="建筑1", resID=30001, skillID=1000002, gold=66250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=60, hp=2211, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=15500, gold_out=155, },
[23] = {lv=23, des="建筑1", resID=30001, skillID=1000002, gold=72700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=62, hp=2294, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=16000, gold_out=160, },
[24] = {lv=24, des="建筑1", resID=30001, skillID=1000002, gold=79450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=64, hp=2378, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=16500, gold_out=165, },
[25] = {lv=25, des="建筑1", resID=30001, skillID=1000002, gold=86500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=65, hp=2432, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=17000, gold_out=170, },
[26] = {lv=26, des="建筑1", resID=30001, skillID=1000002, gold=93850, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=66, hp=2487, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=17500, gold_out=175, },
[27] = {lv=27, des="建筑1", resID=30001, skillID=1000002, gold=101500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=67, hp=2542, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=18000, gold_out=180, },
[28] = {lv=28, des="建筑1", resID=30001, skillID=1000002, gold=109450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=68, hp=2597, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=18500, gold_out=185, },
[29] = {lv=29, des="建筑1", resID=30001, skillID=1000002, gold=117700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=69, hp=2653, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=19000, gold_out=190, },
[30] = {lv=30, des="建筑1", resID=30001, skillID=1000002, gold=126250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=70, hp=2709, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=19500, gold_out=195, },
[31] = {lv=31, des="建筑1", resID=30001, skillID=1000002, gold=135100, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=71, hp=2766, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=20000, gold_out=200, },
[32] = {lv=32, des="建筑1", resID=30001, skillID=1000002, gold=144250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=72, hp=2823, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=20500, gold_out=205, },
[33] = {lv=33, des="建筑1", resID=30001, skillID=1000002, gold=153700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=73, hp=2881, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=21000, gold_out=210, },
[34] = {lv=34, des="建筑1", resID=30001, skillID=1000002, gold=163450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=74, hp=2939, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=21500, gold_out=215, },
[35] = {lv=35, des="建筑1", resID=30001, skillID=1000002, gold=173500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=75, hp=2997, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=22000, gold_out=220, },
[36] = {lv=36, des="建筑1", resID=30001, skillID=1000002, gold=183850, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=76, hp=3056, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=22500, gold_out=225, },
[37] = {lv=37, des="建筑1", resID=30001, skillID=1000002, gold=194500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=77, hp=3115, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=23000, gold_out=230, },
[38] = {lv=38, des="建筑1", resID=30001, skillID=1000002, gold=205450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=78, hp=3175, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=23500, gold_out=235, },
[39] = {lv=39, des="建筑1", resID=30001, skillID=1000002, gold=216700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=79, hp=3235, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=24000, gold_out=240, },
[40] = {lv=40, des="建筑1", resID=30001, skillID=1000002, gold=228250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=80, hp=3296, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=24500, gold_out=245, },
[41] = {lv=41, des="建筑1", resID=30001, skillID=1000002, gold=240100, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=81, hp=3357, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=25000, gold_out=250, },
[42] = {lv=42, des="建筑1", resID=30001, skillID=1000002, gold=252250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=82, hp=3419, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=25500, gold_out=255, },
[43] = {lv=43, des="建筑1", resID=30001, skillID=1000002, gold=264700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=83, hp=3481, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=26000, gold_out=260, },
[44] = {lv=44, des="建筑1", resID=30001, skillID=1000002, gold=277450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=84, hp=3543, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=26500, gold_out=265, },
[45] = {lv=45, des="建筑1", resID=30001, skillID=1000002, gold=290500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=85, hp=3606, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=27000, gold_out=270, },
[46] = {lv=46, des="建筑1", resID=30001, skillID=1000002, gold=303850, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=86, hp=3669, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=27500, gold_out=275, },
[47] = {lv=47, des="建筑1", resID=30001, skillID=1000002, gold=317500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=87, hp=3733, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=28000, gold_out=280, },
[48] = {lv=48, des="建筑1", resID=30001, skillID=1000002, gold=331450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=88, hp=3797, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=28500, gold_out=285, },
[49] = {lv=49, des="建筑1", resID=30001, skillID=1000002, gold=345700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=89, hp=3862, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=29000, gold_out=290, },
[50] = {lv=50, des="建筑1", resID=30001, skillID=1000002, gold=360250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=90, hp=3927, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=29500, gold_out=295, },
[51] = {lv=51, des="建筑1", resID=30001, skillID=1000002, gold=375100, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=91, hp=3993, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=30000, gold_out=300, },
[52] = {lv=52, des="建筑1", resID=30001, skillID=1000002, gold=390250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=92, hp=4059, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=30500, gold_out=305, },
[53] = {lv=53, des="建筑1", resID=30001, skillID=1000002, gold=405700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=93, hp=4125, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=31000, gold_out=310, },
[54] = {lv=54, des="建筑1", resID=30001, skillID=1000002, gold=421450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=94, hp=4192, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=31500, gold_out=315, },
[55] = {lv=55, des="建筑1", resID=30001, skillID=1000002, gold=437500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=95, hp=4259, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=32000, gold_out=320, },
[56] = {lv=56, des="建筑1", resID=30001, skillID=1000002, gold=453850, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=96, hp=4327, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=32500, gold_out=325, },
[57] = {lv=57, des="建筑1", resID=30001, skillID=1000002, gold=470500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=97, hp=4395, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=33000, gold_out=330, },
[58] = {lv=58, des="建筑1", resID=30001, skillID=1000002, gold=487450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=98, hp=4464, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=33500, gold_out=335, },
[59] = {lv=59, des="建筑1", resID=30001, skillID=1000002, gold=504700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=99, hp=4533, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=34000, gold_out=340, },
[60] = {lv=60, des="建筑1", resID=30001, skillID=1000002, gold=522250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=100, hp=4602, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=34500, gold_out=345, },
[61] = {lv=61, des="建筑1", resID=30001, skillID=1000002, gold=540100, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=101, hp=4672, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=35000, gold_out=350, },
[62] = {lv=62, des="建筑1", resID=30001, skillID=1000002, gold=558250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=102, hp=4742, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=35500, gold_out=355, },
[63] = {lv=63, des="建筑1", resID=30001, skillID=1000002, gold=576700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=103, hp=4813, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=36000, gold_out=360, },
[64] = {lv=64, des="建筑1", resID=30001, skillID=1000002, gold=595450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=104, hp=4884, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=36500, gold_out=365, },
[65] = {lv=65, des="建筑1", resID=30001, skillID=1000002, gold=614500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=105, hp=4956, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=37000, gold_out=370, },
[66] = {lv=66, des="建筑1", resID=30001, skillID=1000002, gold=633850, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=106, hp=5028, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=37500, gold_out=375, },
[67] = {lv=67, des="建筑1", resID=30001, skillID=1000002, gold=653500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=107, hp=5101, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=38000, gold_out=380, },
[68] = {lv=68, des="建筑1", resID=30001, skillID=1000002, gold=673450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=108, hp=5174, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=38500, gold_out=385, },
[69] = {lv=69, des="建筑1", resID=30001, skillID=1000002, gold=693700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=109, hp=5247, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=39000, gold_out=390, },
[70] = {lv=70, des="建筑1", resID=30001, skillID=1000002, gold=714250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=110, hp=5321, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=39500, gold_out=395, },
[71] = {lv=71, des="建筑1", resID=30001, skillID=1000002, gold=735100, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=111, hp=5395, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=40000, gold_out=400, },
[72] = {lv=72, des="建筑1", resID=30001, skillID=1000002, gold=756250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=112, hp=5470, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=40500, gold_out=405, },
[73] = {lv=73, des="建筑1", resID=30001, skillID=1000002, gold=777700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=113, hp=5545, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=41000, gold_out=410, },
[74] = {lv=74, des="建筑1", resID=30001, skillID=1000002, gold=799450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=114, hp=5621, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=41500, gold_out=415, },
[75] = {lv=75, des="建筑1", resID=30001, skillID=1000002, gold=821500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=115, hp=5697, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=42000, gold_out=420, },
[76] = {lv=76, des="建筑1", resID=30001, skillID=1000002, gold=843850, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=116, hp=5774, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=42500, gold_out=425, },
[77] = {lv=77, des="建筑1", resID=30001, skillID=1000002, gold=866500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=117, hp=5851, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=43000, gold_out=430, },
[78] = {lv=78, des="建筑1", resID=30001, skillID=1000002, gold=889450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=118, hp=5928, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=43500, gold_out=435, },
[79] = {lv=79, des="建筑1", resID=30001, skillID=1000002, gold=912700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=6006, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=44000, gold_out=440, },
[80] = {lv=80, des="建筑1", resID=30001, skillID=1000002, gold=936250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=6084, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=44500, gold_out=445, },
[81] = {lv=81, des="建筑1", resID=30001, skillID=1000002, gold=960100, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=6163, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=45000, gold_out=450, },
[82] = {lv=82, des="建筑1", resID=30001, skillID=1000002, gold=984250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=6242, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=45500, gold_out=455, },
[83] = {lv=83, des="建筑1", resID=30001, skillID=1000002, gold=1008700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=6322, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=46000, gold_out=460, },
[84] = {lv=84, des="建筑1", resID=30001, skillID=1000002, gold=1033450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=6402, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=46500, gold_out=465, },
[85] = {lv=85, des="建筑1", resID=30001, skillID=1000002, gold=1058500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=6482, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=47000, gold_out=470, },
[86] = {lv=86, des="建筑1", resID=30001, skillID=1000002, gold=1083850, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=6563, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=47500, gold_out=475, },
[87] = {lv=87, des="建筑1", resID=30001, skillID=1000002, gold=1109500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=6644, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=48000, gold_out=480, },
[88] = {lv=88, des="建筑1", resID=30001, skillID=1000002, gold=1135450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=6726, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=48500, gold_out=485, },
[89] = {lv=89, des="建筑1", resID=30001, skillID=1000002, gold=1161700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=6808, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=49000, gold_out=490, },
[90] = {lv=90, des="建筑1", resID=30001, skillID=1000002, gold=1188250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=6891, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=49500, gold_out=495, },
[91] = {lv=91, des="建筑1", resID=30001, skillID=1000002, gold=1215100, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=6974, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=50000, gold_out=500, },
[92] = {lv=92, des="建筑1", resID=30001, skillID=1000002, gold=1242250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=7058, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=50500, gold_out=505, },
[93] = {lv=93, des="建筑1", resID=30001, skillID=1000002, gold=1269700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=7142, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=51000, gold_out=510, },
[94] = {lv=94, des="建筑1", resID=30001, skillID=1000002, gold=1297450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=7226, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=51500, gold_out=515, },
[95] = {lv=95, des="建筑1", resID=30001, skillID=1000002, gold=1325500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=7311, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=52000, gold_out=520, },
[96] = {lv=96, des="建筑1", resID=30001, skillID=1000002, gold=1353850, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=7396, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=52500, gold_out=525, },
[97] = {lv=97, des="建筑1", resID=30001, skillID=1000002, gold=1382500, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=7482, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=53000, gold_out=530, },
[98] = {lv=98, des="建筑1", resID=30001, skillID=1000002, gold=1411450, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=7568, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=53500, gold_out=535, },
[99] = {lv=99, des="建筑1", resID=30001, skillID=1000002, gold=1440700, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=7655, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=54000, gold_out=540, },
[100] = {lv=100, des="建筑1", resID=30001, skillID=1000002, gold=1470250, cell_w=2, cell_h=2, protectScope = {x=-5, y=-5, w=13, h=13, }, atk=119, hp=7742, range=7.5, fanwei=0, atk_invl=1000, move_invl=0, gold_vol=54500, gold_out=545, },


};

AreaLvCfg = 
{
	[1]= {human_num=0, gold_amend=1, exp_amend=1, color=1, },
	[2]= {human_num=1, gold_amend=1.2, exp_amend=1.1, color=2, },
	[3]= {human_num=3, gold_amend=1.4, exp_amend=1.2, color=3, },

};


BuildConfig = 
{
	-- [1] = { key = "build_1",des = "建筑1", resID = 30000,skillID = 1000002,cell_w = 3,cell_h = 3, protectScope = {x = -1,y = -1,w= 4,h = 4} ,hp = 1000, displayEffect = function ( hp , state )
	-- 	return "build/build_1.tmx";
	-- end},
};

--[[
	建筑创建配置
]]
BuildTypeCfg = {
	[1] = {buildtype = 1,buildTempleID = 1,lv = 1,des = "庇护所",icon = "icon/build/build_icon_0.png",checkLogic = function ( params )
		-- 判断是否是工会会长 或工会副会长
		if MAIN_PLAYER.guild:isHaveGuid() and (MAIN_PLAYER.guild:getGUID() ~= Data_Battle.guild or Data_Battle.guild == NULL_GUID) and MAIN_PLAYER.baseAttr:getPost() < 3 then
			return true;
		end
		return false;
	end},
	[2] = {buildtype = 2,buildTempleID = 1,lv = 1,des = "塔防",icon = "icon/build/build_icon_0.png",checkLogic = function ( params )
		--判断是否已放置塔防
		--判断是否有公会
		if MAIN_PLAYER.guild:isHaveGuid() and MAIN_PLAYER.guild:getGUID() == Data_Battle.guild and (not MAIN_PLAYER:gettowerManager():isPlace()) then
			return true;
		end
		return false;
	end},
}

--创建前端建筑配置
function CreateClientBuildConfig(  )
	-- 工会建筑
	local index = 1;
	for i,v in ipairs(ShelterCfg) do
		v.buildtype = 1;
		index = v.buildtype * 1000 + v.lv;
		v.index = index;
		BuildConfig[index] = v;
	end

	for i,v in ipairs(TowerCfg) do
		v.buildtype = 2;
		index = v.buildtype * 1000 + v.lv;
		v.index = index;
		BuildConfig[index] = v;
	end

	for i,v in ipairs(BuildTypeCfg) do
		v.buildTempleID = v.buildtype * 1000 + v.lv;
	end
end

CreateClientBuildConfig();

function GetBuildTempleIDByLevel( buildtype ,level )
	local index = buildtype * 1000 + level;
	return index;
end

function GetBuildCfgByLevel( buildtype ,level )
	local index = buildtype * 1000 + level;
	return BuildConfig[index];
end

function GetBuildCfgByIndex( index )
	return BuildConfig[index];
end

--得到一个地图配置
function GetBuildCfg(id)
	if GET_CONFIG_CHECK and nil == BuildConfig[id] then
		-- print_log("Not found city("..city_id..") of config");
		-- print_log(debug.traceback());
	end
	return BuildConfig[id];
end

--=========================================庇护所添加配置=====================================

-- 根据数量得到添加一个庇护所需要的金币
function add_shelter_cost(num)
	-- body
	local shel_cfg = GetShelterCfg(num);
	if shel_cfg then
		return shel_cfg.gold;
	else
		return 0;
	end
end