--
-- Author: Li Yang
-- Date: 2014-04-25 13:54:19
-- 阵型配置

--上阵位置开放等级
BATTLE_POS_OPEN_LV = {
	[1] = { lv=0,	tipStr="0级开放"},
	[2] = { lv=5,	tipStr="5级开放"},
	[3] = { lv=11,	tipStr="11级开放"},
	[4] = { lv=17,	tipStr="17级开放"},
	[5] = { lv=23,	tipStr="23级开放"},
	[6] = { lv=30,	tipStr="30级开放"},
	[7] = { lv=1000,	tipStr="暂未开放"},
	[8] = { lv=1000,	tipStr="暂未开放"},
	[9] = { lv=1000,	tipStr="暂未开放"},
	[10] = { lv=1000,	tipStr="暂未开放"},
	[11] = { lv=1000,	tipStr="暂未开放"},
	[12] = { lv=1000,	tipStr="暂未开放"}
}


function BATTLE_POS_OPEN_LV_CHECK( playerLv, posIdx )
	return BATTLE_POS_OPEN_LV[posIdx].lv <= playerLv
end

function BATTLE_POS_OPEN_LV_TIP( posIdx )
	return BATTLE_POS_OPEN_LV[posIdx].tipStr
end


--[[
	battlepos 阵型的战场位置坐标
	describe 阵型描述
	Openpos 开放的位置
	openlv 开放等级
	image 阵型image
]]
formationConfig = {
	[1] = {
		id = 1,
		name = "锥形阵",
		battlepos = {{0 , 0},{0,-105}, {0 , 0 },{ -113 , -235 },{ 0 ,0 },{113 , -235 },{-226,-365},{0 , -365}, {226 , -365 }},
		empos = {{0 , 0},{0,210}, {0 , 0 },{ -90 , 110 },{ 0 , 0 },{ 90 , 110 },{ -190 , 10},{0 , 10}, { 190 , 10 }},
		adaptive_L = 0,
		Openpos = {2,4,6,7,8,9},
		describe = "",
		openlv = 1,
		image = "formation_icon_1.png",
	},
	[2] = {
		id = 2,
		name = "偃月阵",
		battlepos = {{0 , 0},{0,-105}, {0 , 0 },{ -113 , -270 },{0 , -270 },{ 113 ,-270 },{-226,-365}, {0 , 0 },{226 , -365}},
		empos = {{0 , 0},{0,210}, {0 , 0 },{ -103 , 110 },{ 0 , 110 },{ 103 , 110 },{ -190 , 10}, { 0 , 0 },{190 , 10}},
		adaptive_L = 2,
		Openpos = {2,4,5,6,7,9},
		describe = "",
		openlv = 1,
		image = "formation_icon_2.png",
	},
	[3] = {
		id = 3,
		name = "鹤翼阵",
		battlepos = {{-226,-105},{0 , 0 },{226 , -105}, {0 , 0 },{ 0 , -200 },{ 0 ,0 },{-113,-365},{0 , -365}, {113 , -365}},
		empos = {{-190,210}, {0 , 0 },{190 , 210},{ 0 , 0 },{ 0 , 110 },{ 0 , 0 },{ -103 , 10},{0 , 10}, { 103 , 10 }},
		adaptive_L = 3,
		Openpos = {1,3,5,7,8,9},
		describe = "",
		openlv = 1,
		image = "formation_icon_3.png",
	},
	[4] = {
		id = 4,
		name = "鱼鳞阵",
		battlepos = {{-226,-105},{0 , 0 },{226 , -105}, { -113 , -200 },{0 , -200 },{ 113,-200 },{0 , 0},{0,-365}, {0 , 0 }},
		empos = {{-190,210},{0 , 0 },{190 , 210}, { -103 , 110 },{ 0 , 110 },{ 103 , 110 },{0 , 0},{ 0 , 10}, { 0 , 0 }},
		adaptive_L = 2,
		Openpos = {1,3,4,5,6,8},
		describe = "",
		openlv = 13,
		image = "formation_icon_4.png",
	},
	[5] = {
		id = 5,
		name = "锋失阵",
		battlepos = {{-113,-105},{0 , -105}, {113 , -105 },{0 , 0 },{ 0 , -270 },{ 0 ,0 },{-226,-365}, {0 , 0 },{226 , -365}},
		empos = {{-103,210},{0 , 210}, {103 , 210 },{ 0 , 0 },{ 0 , 110 },{ 0 , 0 },{ -190 , 10}, { 0 , 0 },{190 , 10}},
		adaptive_L = 1,
		Openpos = {1,2,3,5,7,9},
		describe = "",
		openlv = 20,
		image = "formation_icon_5.png",
	},
	[6] = {
		id = 6,
		name = "雁形阵",
		battlepos = {{-226,-105},{0 , -105}, {226 , -105 },{ -113 , -235 },{ 0 ,0 },{113 , -235 },{0 , 0},{0,-365}, {0 , 0 }},
		empos = {{-190,210},{0 , 210}, {190 , 210 },{ -90 , 110 },{ 0 , 0 },{ 90 , 110 },{0 , 0},{ 0 , 10}, { 0 , 0 }},
		adaptive_L = 0,
		Openpos = {1,2,3,4,6,8},
		describe = "",
		openlv = 30,
		image = "formation_icon_6.png",
	},
	[7] = {
		id = 7,
		battlepos = {{0 , 0},{0 , 0}, {0 , 0 },{ -190 , -235 },{ 0 ,-235 },{190 , -235 },{0 , 0},{0 , 0}, {0 , 0 }},
		adaptive_L = 0,
		Openpos = {4,5,6},
		describe = "",
		openlv = 1,
		image = "formation_icon_6.png",
	},
	[8] = {
		id = 8,
		battlepos = {{-190,-105},{0 , 0}, {190 , -105 },{ 0 , 0 },{ 0 ,-235 },{0 , 0 },{-190 , -365},{0 , 0}, {190 , -365 }},
		adaptive_L = 0,
		Openpos = {1,3,5,7,9},
		describe = "",
		openlv = 1,
		image = "formation_icon_6.png",
	},
	[9] = {
		id = 9,
		battlepos = {{-190,-105},{0 , 0}, {190 , -105 },{ 0 , 0 },{ 0 ,-235 },{0 , 0 },{-190 , -365},{0 , 0}, {190 , -365 }},
		adaptive_L = 0,
		Openpos = {1,3,4,5,6,7,8,9},
		describe = "",
		openlv = 1,
		image = "formation_icon_6.png",
	},

}

--战场阵型位置信息
-- BattlefieldFormationPosInfo = {
-- 	defendCamp = {
-- 		{20,28},{20,24},{20,20},
-- 		{16,28},{16,24},{16,20},
-- 		{12,28},{12,24},{12,20},
-- 	},
-- 	attckCamp = {
-- 		{28,28},{28,24},{28,20},
-- 		{32,28},{32,24},{32,20},
-- 		{36,28},{36,24},{36,20},
-- 	}
-- }

BattlefieldFormationPosInfo = {
	
	defendCamp = {
		{20,12},{21,15},{22,18},
		{23,12},{24,15},{25,18},
		{26,12},{27,15},{28,18},
	},
	attckCamp = {
		{12,12},{11,15},{10,18},
		{9,12},{8,15},{7,18},
		{6,12},{5,15},{4,18},
	}
}

--入场阵型
EntranceFormation = {
	invipos = {{0 , -900},{-800,-150}, {800 , -150 },{ 0 ,-900 },{ -800 , -320 },{800 , -320 }},
	battlepos = {{0 , -150},{-140,-150}, {140 , -150 },{ 0 ,-320 },{ -140 , -320 },{140 , -320 }},
}

--得到阵型数据
function get_formationData( formation_id )
	if GET_CONFIG_CHECK and nil == formationConfig[formation_id] then
		print_log(debug.traceback());
		print_log("Not found formationConfig("..formation_id..")");
	end
	return formationConfig[formation_id];
end

--查找阵型中是否包含某个位置
function check_formation_pos(formation, pos)
	for k, v in pairs(formation.Openpos) do
		if pos == v then
			return true;
		end
	end
	return false;
end

function formationConfig_getImageName( id )
	return get_formationData(id).image
end

--获取玩家阵型ID列表
function formationConfig_getPlayerFormationIDList()
	return {1, 2, 3, 4, 5, 6}
end

--获取阵型名
function formationConfig_getFormationName(id)
	return get_formationData(id).name
end

--获取站立位置
function formationConfig_getStandPos( id, openPosIdx )
	return get_formationData(id).Openpos[openPosIdx]
end


--是否存在指定的站立位置
function formationConfig_hasStandPos( id, standPos )
	local poses = get_formationData(id).Openpos
	for i,v in ipairs(poses) do
		if v == standPos then
			return true
		end
	end
	return false
end

--获取开放位置的索引号, 通过站立位置
function formationConfig_getOpenposIdxWithStandPos( formationID, standPos )
	local poses = get_formationData(formationID).Openpos

	for i,v in ipairs(poses) do
		if v == standPos then
			return i
		end
	end
end