--
-- Author: zkz
-- Date: 2014-03-24 10:17:34
-- VIP配置

info_check = {};

--0~10属于C++保留ID
last_info_code = 10;

function _make_info(class_type, sub_type)
	local info_code;
	if not class_type then
		info_code = last_info_code + 1;
	elseif sub_type then
		info_code = class_type * 10000 + sub_type;
	else
		error("_make_info()，参数有空值！"..debug.traceback());
	end


	if nil == info_check[info_code] then
		last_info_code = info_code;
		info_check[info_code] = true;
		return info_code;
	end
	error("消息代码重复("..class_type..","..sub_type..") "..debug.traceback());	
end

-- 官职定义

-- 会长
Guild_Boss = 1;
-- 副会长
Guild_Assistant = 2;
-- 会员
Guild_Member = 3;
-- 平民，没有工会的
Guild_Civilian = 4;


-- 世界频道
chat_channel_world = 1;

-- 公会频道
chat_channel_guild = 2;

-- 队伍频道
chat_channel_team = 3;

-- 好友频道
chat_channel_friend = 4;

-- 系统频道
chat_channel_system = 5;

--****************************************************************************************
--信息代码——类型定义
--****************************************************************************************

--公共使用
INFO_CODE_PUBLIC					= _make_info();

--创建角色信息提示
INFO_CODE_CREATE_ROLE				= _make_info();

--创建角色信息提示
INFO_CODE_MAP						= _make_info();

--公会
INFO_CODE_GUILD						= _make_info();

--战斗
INFO_CODE_FIGHT						= _make_info();

--好友
INFO_CODE_FRIEND					= _make_info();

--****************************************************************************************
--详细信息定义
--****************************************************************************************


--=============================公共使用===============================
--操作成功
ICP_Succeed							= _make_info(INFO_CODE_PUBLIC, 1);
--操作失败
ICP_Failed							= _make_info();


--资源不足
ICP_ResNotEnough					= _make_info();
--元宝不足
ICP_YBNotEnough						= _make_info();



--=============================创建角色信息提示===============================
--昵称重复
ICCR_NameRe							= _make_info(INFO_CODE_CREATE_ROLE, 1);
--只能改一次名字
ICCR_NameChanged					= _make_info();
--有屏蔽字符
ICCR_IllegalWord					= _make_info();


--=============================封地操作===============================
--已被他人占领
ICCR_Seized							= _make_info(INFO_CODE_MAP, 1);
--没有占领
ICCR_NoSeized						= _make_info();
--目标位阻挡
ICCR_PosBlock						= _make_info();
--塔已放置
ICCR_TowerLaid						= _make_info();
--塔已放置，先撤塔
ICCR_NeedDestoryTower				= _make_info();


--=============================公会操作===============================

--权限不足
ICCR_NoQuanxian						= _make_info(INFO_CODE_GUILD, 1);

--不允许加入
ICCR_RefuseJoin						= _make_info();

--资源不足，无法添加
ICCR_No_Res							= _make_info();

--对方已经有公会了
ICCR_Had_Guild						= _make_info();

--已经申请过了
ICCR_Had_Apply						= _make_info();

--重名
ICCR_Re_Name						= _make_info();

--公会不存在
ICCR_Guild_Dismis					= _make_info();

--申请已发送
ICCR_Apply_Succed					= _make_info();

--成功加入公会
ICCR_Join_Succed					= _make_info();

--搜索成功
ICCR_Sousuo_Succed					= _make_info();

--没有此公会
ICCR_No_Guild						= _make_info();

--=============================战斗操作失败原因===============================

--上一场战斗没有结束
ICCR_ReFight						= _make_info(INFO_CODE_FIGHT, 1);

--其他人正在攻打该区域
ICCR_OtherFighting					= _make_info();


--要加入的战斗已结束
ICCR_FightEnd						= _make_info();

--不同公会不能进入战斗
ICCR_DiffGuild						= _make_info();

--没有人占领这个区域
ICCR_NullField						= _make_info();

--没有兵
ICCR_NoSoldier						= _make_info();

--该区域狩猎次数达到上限
ICCR_NumLimit						= _make_info();

--=============================好友操作失败原因===============================
-- 不能删除系统好友
ICFR_NoDel_Sys 						= _make_info(INFO_CODE_FRIEND, 1);

-- 添加好友成功
ICFR_Add_Succed 					= _make_info();

-- 已经有这个好友了
ICFR_Had_Friend 					= _make_info();
































