--
-- Author: zkz
-- Date: 
-- 道具效果配置


--取得道具配置
function GetItemCfg(item_key)
	if GET_CONFIG_CHECK and nil == ItemsConfig[item_key] then
		print_log(debug.traceback());
		print_log("Not found item("..item_key..")");
	end
	return ItemsConfig[item_key];
end

--按掉落表添加道具掉落，并通知
function AddItemDrop(player, drop_t, log_info)
	local msg = create_msg(MSG_MS2C_GET_NOTICE);
	msg:WriteInt(#drop_t);

	for drop_i, drop in ipairs(drop_t) do
		PlayerAddDrop(player, drop, log_info);

		msg:WriteInt(drop.obj_type);
		msg:WriteInt(drop.obj_id);
		msg:WriteInt(drop.obj_lv);
		msg:WriteInt(drop.obj_num);
	end

	SendMsg(player:GetNetID(), msg);
end



--特殊道具ID
--------------------------------------------------------
--技能升级书-初级
eSTID_SkillBook1 = 10001;
--技能升级书-中级
eSTID_SkillBook2 = 10002;
--技能升级书-高级
eSTID_SkillBook3 = 10003;
--神将令
eSTID_ShenJiangLing = 10004;
--征集令
eSTID_ZhengJiLing = 10006;
--求贤令
eSTID_QiuXianLing = 10007;
--清除世界BOSS攻击CD的道具
eSTID_ClearBossCD = 10005;

--速战令
eSTID_QuickPlay = 10010;
--强攻令
eSTID_BossPlay = 10011;

--装备强化材料
eSTID_Euip_SS = 90002;
--装备进阶材料
eSTID_Euip_US = 90003;

--秦币
eSTID_QinBi = 60001;
--霸王宝藏藏宝图
eSTID_CBT = 60012;
--黄巾辎重
eSTID_HJZC = 60101;

--[[
	道具属性说明
	{
		--道具名称
		name,

		--道具简介
		info,

		--道具品质
		quality,

		-- 出售单价（未空则不可出售）
		price,

		-- 资源id
		res_id,

		--道具使用函数（未空则道具不可使用）
		use_fun,
	},
]]

ItemsConfig = 
{
	
[10001]=
{
	name = "技能书",
	info = "用于武将技能强度（1-3）升级\n获得方式：宝箱、奇遇",
	quality = 2,
	price = 2000,
	res_id = 0,
	
},
[10002]=
{
	name = "技能书",
	info = "用于武将技能强度（4-6）升级\n获得方式：宝箱、奇遇",
	quality = 3,
	price = 10000,
	res_id = 1,
	
},
[10003]=
{
	name = "技能书",
	info = "用于武将技能强度（7-9）升级\n获得方式：宝箱、奇遇",
	quality = 4,
	price = 50000,
	res_id = 2,
	
},
[10004]=
{
	name = "神将令",
	info = "用于兑换竞技场奖励\n获得方式：竞技场每日排名奖励",
	quality = 3,
	price = 0,
	res_id = 3,
	
},
[10005]=
{
	name = "强攻号角",
	info = "清除攻打世界BOSS的复活时间\n获得方式：商店、宝箱、奇遇",
	quality = 3,
	price = 0,
	res_id = 4,
	
},
[10006]=
{
	name = "招募令",
	info = "随机招募一名武将\n获得方式：宝箱、奇遇",
	quality = 3,
	price = 0,
	res_id = 62,
	
},
[10007]=
{
	name = "高级招募令",
	info = "随机招募一名名将",
	quality = 4,
	price = 0,
	res_id = 62,
	
},
[10008]=
{
	name = "扫荡符",
	info = "用于扫荡次数用完后，充抵扫荡次数",
	quality = 3,
	price = 0,
	res_id = 6,
	
},
[10009]=
{
	name = "洗练石",
	info = "用于洗炼装备副属性",
	quality = 3,
	price = 0,
	res_id = 24,
	
},
[10010]=
{
	name = "速战令",
	info = "快速战斗次数用完后可快速战斗半小时\n获得方式：商店、宝箱",
	quality = 4,
	price = 0,
	res_id = 83,
	
},
[10011]=
{
	name = "挑战令",
	info = "BOSS挑战次数用完后可挑战BOSS\n获得方式：商店、宝箱",
	quality = 4,
	price = 0,
	res_id = 84,
	
},
[10012]=
{
	name = "刷新令",
	info = "可刷新熔炼兑换列表\n获得方式：奇遇、宝箱",
	quality = 4,
	price = 0,
	res_id = 82,
	
},

[20001]=
{
	name = "体力丹",
	info = "使用后增加10点体力",
	quality = 1,
	price = 0,
	res_id = 7,
	
},
[20002]=
{
	name = "体力丹",
	info = "使用后增加30点体力",
	quality = 2,
	price = 0,
	res_id = 8,
	
},
[20003]=
{
	name = "体力丹",
	info = "使用后增加60点体力",
	quality = 3,
	price = 0,
	res_id = 9,
	
},
[20004]=
{
	name = "体力丹",
	info = "使用后增加120点体力",
	quality = 4,
	price = 0,
	res_id = 10,
	
},
[20005]=
{
	name = "精力丹",
	info = "使用后增加5点精力",
	quality = 1,
	price = 0,
	res_id = 11,
	
},
[20006]=
{
	name = "精力丹",
	info = "使用后增加15点精力",
	quality = 2,
	price = 0,
	res_id = 12,
	
},
[20007]=
{
	name = "精力丹",
	info = "使用后增加30点精力",
	quality = 3,
	price = 0,
	res_id = 13,
	
},
[20008]=
{
	name = "精力丹",
	info = "使用后增加60点精力",
	quality = 4,
	price = 0,
	res_id = 14,
	
},

[30001]=
{
	name = "招募令-魏",
	info = "随机获得一个蓝色魏国名将",
	quality = 3,
	price = 0,
	res_id = 15,
	
},
[30002]=
{
	name = "招募令-蜀",
	info = "随机获得一个蓝色蜀国名将",
	quality = 3,
	price = 0,
	res_id = 16,
	
},
[30003]=
{
	name = "招募令-吴",
	info = "随机获得一个蓝色吴国名将",
	quality = 3,
	price = 0,
	res_id = 17,
	
},
[30004]=
{
	name = "招募令-群",
	info = "随机获得一个蓝色群雄名将",
	quality = 3,
	price = 0,
	res_id = 18,
	
},
[30005]=
{
	name = "招募令-魏",
	info = "随机获得一个紫色魏国名将",
	quality = 4,
	price = 0,
	res_id = 58,
	
},
[30006]=
{
	name = "招募令-蜀",
	info = "随机获得一个紫色蜀国名将",
	quality = 4,
	price = 0,
	res_id = 59,
	
},
[30007]=
{
	name = "招募令-吴",
	info = "随机获得一个紫色吴国名将",
	quality = 4,
	price = 0,
	res_id = 60,
	
},
[30008]=
{
	name = "招募令-群",
	info = "随机获得一个紫色群雄名将",
	quality = 4,
	price = 0,
	res_id = 61,
	
},
[30009]=
{
	name = "招募令-副将",
	info = "随机获得一个紫色副将",
	quality = 4,
	price = 0,
	res_id = 35,
	
},
[30017]=
{
	name = "五星招募令",
	info = "随机获得一个橙色名将",
	quality = 5,
	price = 0,
	res_id = 23,
	
},
[30018]=
{
	name = "四星招募令",
	info = "随机获得一个紫色名将",
	quality = 4,
	price = 0,
	res_id = 66,
	
},

[40001]=
{
	name = "朱雀宝箱",
	info = "开启获得经验卡牌，世界BOSS活动奖励",
	quality = 3,
	price = 0,
	res_id = 19,
	
},
[40002]=
{
	name = "玄武宝箱",
	info = "开启获得将魂，世界BOSS活动奖励",
	quality = 3,
	price = 0,
	res_id = 20,
	
},
[40003]=
{
	name = "青龙宝箱",
	info = "开启获得银两，世界BOSS活动奖励",
	quality = 3,
	price = 0,
	res_id = 21,
	
},
[40004]=
{
	name = "白虎宝箱",
	info = "开启获得铁矿石，世界BOSS活动奖励",
	quality = 3,
	price = 0,
	res_id = 22,
	
},
[40005]=
{
	name = "真·朱雀宝箱",
	info = "开启获得大量经验卡牌，世界BOSS活动奖励",
	quality = 4,
	price = 0,
	res_id = 37,
	
},
[40006]=
{
	name = "真·玄武宝箱",
	info = "开启获得大量将魂，世界BOSS活动奖励",
	quality = 4,
	price = 0,
	res_id = 38,
	
},
[40007]=
{
	name = "真·青龙宝箱",
	info = "开启获得大量银两，世界BOSS活动奖励",
	quality = 4,
	price = 0,
	res_id = 39,
	
},
[40008]=
{
	name = "真·白虎宝箱",
	info = "开启获得大量铁矿石，世界BOSS活动奖励",
	quality = 4,
	price = 0,
	res_id = 40,
	
},

[50001]=
{
	name = "将魂匣",
	info = "开启获得500将魂",
	quality = 3,
	price = 0,
	res_id = 26,
	
},
[50002]=
{
	name = "将魂匣",
	info = "开启获得1000将魂",
	quality = 4,
	price = 0,
	res_id = 27,
	
},
[50003]=
{
	name = "将魂匣",
	info = "开启获得2000将魂",
	quality = 5,
	price = 0,
	res_id = 28,
	
},
[50004]=
{
	name = "恶狼卡匣",
	info = "开启获得10张“恶狼”经验卡牌",
	quality = 3,
	price = 0,
	res_id = 29,
	
},
[50005]=
{
	name = "狂熊卡匣",
	info = "开启获得5张“狂熊”经验卡牌",
	quality = 4,
	price = 0,
	res_id = 30,
	
},
[50006]=
{
	name = "虎王卡匣",
	info = "开启获得5张“虎王”经验卡牌",
	quality = 5,
	price = 0,
	res_id = 25,
	
},

[60001]=
{
	name = "古币",
	info = "寻宝特产，可交换道具",
	quality = 2,
	price = 0,
	res_id = 31,
	
},
[60002]=
{
	name = "玉璧",
	info = "古代宝物、出售可获得银两",
	quality = 4,
	price = 99999,
	res_id = 32,
	
},
[60003]=
{
	name = "青铜鼎",
	info = "古代宝物、出售可获得银两",
	quality = 3,
	price = 49999,
	res_id = 33,
	
},
[60004]=
{
	name = "铜镜",
	info = "古代宝物、出售可获得银两",
	quality = 2,
	price = 19999,
	res_id = 34,
	
},

[60011]=
{
	name = "楚币",
	info = "霸王秘藏的特产物品，某些特殊交易需要",
	quality = 2,
	price = 0,
	res_id = 41,
	
},
[60012]=
{
	name = "藏宝图",
	info = "找到霸王秘藏的关键物品",
	quality = 4,
	price = 0,
	res_id = 42,
	
},

[60101]=
{
	name = "黄巾物资",
	info = "军团【黄巾战场】获得的战利品，每日提交军团换取功勋",
	quality = 2,
	price = 1,
	res_id = 64,
	
},

[70001]=
{
	name = "VIP1宝箱",
	info = "给尊贵的VIP1准备的礼包",
	quality = 5,
	price = 0,
	res_id = 36,
	
},
[70002]=
{
	name = "VIP2宝箱",
	info = "给尊贵的VIP2准备的礼包",
	quality = 5,
	price = 0,
	res_id = 36,
	
},
[70003]=
{
	name = "VIP3宝箱",
	info = "给尊贵的VIP3准备的礼包",
	quality = 5,
	price = 0,
	res_id = 36,
	
},
[70004]=
{
	name = "VIP4宝箱",
	info = "给尊贵的VIP4准备的礼包",
	quality = 5,
	price = 0,
	res_id = 36,
	
},
[70005]=
{
	name = "VIP5宝箱",
	info = "给尊贵的VIP5准备的礼包",
	quality = 5,
	price = 0,
	res_id = 36,
	
},
[70006]=
{
	name = "VIP6宝箱",
	info = "给尊贵的VIP6准备的礼包",
	quality = 5,
	price = 0,
	res_id = 36,
	
},
[70007]=
{
	name = "VIP7宝箱",
	info = "给尊贵的VIP7准备的礼包",
	quality = 5,
	price = 0,
	res_id = 36,
	
},
[70008]=
{
	name = "VIP8宝箱",
	info = "给尊贵的VIP8准备的礼包",
	quality = 5,
	price = 0,
	res_id = 36,
	
},
[70009]=
{
	name = "VIP9宝箱",
	info = "给尊贵的VIP9准备的礼包",
	quality = 5,
	price = 0,
	res_id = 36,
	
},
[70010]=
{
	name = "VIP10宝箱",
	info = "给尊贵的VIP10准备的礼包",
	quality = 5,
	price = 0,
	res_id = 36,
	
},
[70011]=
{
	name = "VIP11宝箱",
	info = "给尊贵的VIP11准备的礼包",
	quality = 5,
	price = 0,
	res_id = 36,
	
},
[70012]=
{
	name = "VIP12宝箱",
	info = "给尊贵的VIP12准备的礼包",
	quality = 5,
	price = 0,
	res_id = 36,
	
},
[70013]=
{
	name = "VIP13宝箱",
	info = "给尊贵的VIP13准备的礼包",
	quality = 5,
	price = 0,
	res_id = 36,
	
},
[70014]=
{
	name = "VIP14宝箱",
	info = "给尊贵的VIP14准备的礼包",
	quality = 5,
	price = 0,
	res_id = 36,
	
},
[70015]=
{
	name = "VIP15宝箱",
	info = "给尊贵的VIP15准备的礼包",
	quality = 5,
	price = 0,
	res_id = 36,
	
},
[70016]=
{
	name = "VIP16宝箱",
	info = "给尊贵的VIP16准备的礼包",
	quality = 5,
	price = 0,
	res_id = 36,
	
},

[80001]=
{
	name = "好友礼包",
	info = "打开随机获得各种道具资源",
	quality = 3,
	price = 0,
	res_id = 43,
	
},

[80002]=
{
	name = "1天登录礼包",
	info = "扫荡符x10、小体力丹x1",
	quality = 3,
	price = 0,
	res_id = 63,
	
},
[80003]=
{
	name = "2天登录礼包",
	info = "扫荡符x20、小精力丹x1",
	quality = 3,
	price = 0,
	res_id = 63,
	
},
[80004]=
{
	name = "3天登录礼包",
	info = "扫荡符x30、中体力丹x1",
	quality = 3,
	price = 0,
	res_id = 63,
	
},
[80005]=
{
	name = "4天登录礼包",
	info = "扫荡符x40、强攻号角x5、中精力丹x1",
	quality = 3,
	price = 0,
	res_id = 63,
	
},
[80006]=
{
	name = "5天登录礼包",
	info = "扫荡符x50、强攻号角x10、体力丹x1",
	quality = 3,
	price = 0,
	res_id = 63,
	
},
[80007]=
{
	name = "6天登录礼包",
	info = "扫荡符x60、强攻号角x20、精力丹x1",
	quality = 3,
	price = 0,
	res_id = 63,
	
},
[80008]=
{
	name = "7天登录礼包",
	info = "神将令x100(用于兑换竞技场神将)",
	quality = 3,
	price = 0,
	res_id = 63,
	
},
[80009]=
{
	name = "百万经验包",
	info = "虎王x3、狂熊x6、野狼x10",
	quality = 5,
	price = 0,
	res_id = 63,
	
},

[81001]=
{
	name = "铜宝箱",
	info = "可获得武将碎片、元宝、各种道具",
	quality = 3,
	price = 0,
	res_id = 85,
	
},
[81002]=
{
	name = "银宝箱",
	info = "可获得名将碎片、元宝、各种道具",
	quality = 4,
	price = 0,
	res_id = 88,
	
},
[81003]=
{
	name = "金宝箱",
	info = "可获得神器、名将碎片、元宝、各种道具",
	quality = 5,
	price = 0,
	res_id = 75,
	
},
[81011]=
{
	name = "铜钥匙",
	info = "打开铜宝箱的钥匙\n获得方式：商店、奇遇",
	quality = 3,
	price = 0,
	res_id = 86,
	
},
[81012]=
{
	name = "银钥匙",
	info = "打开银宝箱的钥匙\n获得方式：商店、奇遇",
	quality = 4,
	price = 0,
	res_id = 89,
	
},
[81013]=
{
	name = "金钥匙",
	info = "打开金宝箱的钥匙\n获得方式：商店、奇遇",
	quality = 5,
	price = 0,
	res_id = 76,
	
},
[81004]=
{
	name = "名将宝箱",
	info = "有几率获得名将碎片",
	quality = 4,
	price = 0,
	res_id = 77,
	
},
[81005]=
{
	name = "神器宝箱",
	info = "有几率获得神器碎片",
	quality = 5,
	price = 0,
	res_id = 80,
	
},
[81006]=
{
	name = "职业宝箱",
	info = "随机获得一种职业强化材料",
	quality = 4,
	price = 0,
	res_id = 90,
	
},

[90001]=
{
	name = "觉醒丹",
	info = "武将觉醒所需材料\n获得方式：商店、宝箱、奇遇、挑战BOSS",
	quality = 3,
	price = 0,
	res_id = 74,
	
},
[90002]=
{
	name = "强化石",
	info = "装备强化所需材料\n获得方式：商店、宝箱、奇遇、挑战BOSS",
	quality = 3,
	price = 0,
	res_id = 78,
	
},
[90003]=
{
	name = "升阶石",
	info = "神器进阶所需材料\n获得方式：商店、宝箱、奇遇",
	quality = 5,
	price = 0,
	res_id = 81,
	
},

[90011]=
{
	name = "玄武甲",
	info = "防御职业强化所需材料\n获得方式：商店、宝箱、奇遇、挑战BOSS",
	quality = 4,
	price = 0,
	res_id = 87,
	
},
[90021]=
{
	name = "白虎牙",
	info = "物攻职业强化所需材料\n获得方式：商店、宝箱、奇遇、挑战BOSS",
	quality = 4,
	price = 0,
	res_id = 73,
	
},
[90031]=
{
	name = "青龙胆",
	info = "平衡职业强化所需材料\n获得方式：商店、宝箱、奇遇、挑战BOSS",
	quality = 4,
	price = 0,
	res_id = 79,
	
},
[90041]=
{
	name = "朱雀羽",
	info = "法攻职业强化所需材料\n获得方式：商店、宝箱、奇遇、挑战BOSS",
	quality = 4,
	price = 0,
	res_id = 91,
	
},





};



-------------------------------------------------------------------------------
--
--道具使用函数添加
--
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
--
function AddItemRandomCard(player, dorp_set, use_num, drop_info)
	local drop_t = {};
	for i=1, use_num do
		table.insert(drop_t, 
			{
				obj_type = eDT_Card,
				obj_id = dorp_set[math.random(#dorp_set)],
				obj_lv = 1,
				obj_num = 1,
			}
		);
	end
	AddItemDrop(player, drop_t, drop_info);
end

--
function MmultDrop(player, drop_id, drop_num)
	local re = {};
	for i=1, drop_num do
		local drop_t = GetDrop(drop_id, player);
		for i,drop in ipairs(drop_t) do
			table.insert(re, drop);
		end
	end
	return re;
end

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
--粽子相关功能
--[[
ItemsConfig[10010].use_fun = function(player, use_num)
	use_num = use_num or 1;
	AddItemDrop(player, MmultDrop(player, 35401, use_num), "道具 10010");
	return true;
end

ItemsConfig[10011].use_fun = function(player, use_num)
	use_num = use_num or 1;
	AddItemDrop(player, MmultDrop(player, 35402, use_num), "道具 10011");
	return true;
end


ItemsConfig[10012].use_fun = function(player, use_num)
	use_num = use_num or 1;
	local items_pack = player:GetPieceSys(ePST_Items);
	if items_pack:GetPieceNum(10013) >= use_num and 
		items_pack:GetPieceNum(10014) >= use_num then
		DelItem(player, 10013, use_num, "使用道具");
		DelItem(player, 10014, use_num, "使用道具");
		--10012在使用消息时扣了
		AddItemDrop(player, MmultDrop(player, 35403, use_num), "使用道具");
		return true;
	else
		SendItemErrorMsg(eIE_NotEnough, player:GetNetID());
		return false;
	end
end

ItemsConfig[10013].use_fun = function(player, use_num)
	use_num = use_num or 1;
	local items_pack = player:GetPieceSys(ePST_Items);
	if items_pack:GetPieceNum(10012) >= use_num and 
		items_pack:GetPieceNum(10014) >= use_num then
		DelItem(player, 10012, use_num, "使用道具");
		DelItem(player, 10014, use_num, "使用道具");
		--10012在使用消息时扣了
		AddItemDrop(player, MmultDrop(player, 35403, use_num), "使用道具");
		return true;
	else
		SendItemErrorMsg(eIE_NotEnough, player:GetNetID());
		return false;
	end
end

ItemsConfig[10014].use_fun = function(player, use_num)
	use_num = use_num or 1;
	local items_pack = player:GetPieceSys(ePST_Items);
	if items_pack:GetPieceNum(10012) >= use_num and 
		items_pack:GetPieceNum(10013) >= use_num then
		DelItem(player, 10012, use_num, "使用道具");
		DelItem(player, 10013, use_num * 2, "使用道具");
		--10012在使用消息时扣了
		AddItemDrop(player, MmultDrop(player, 35403, use_num), "使用道具");
		return true;
	else
		SendItemErrorMsg(eIE_NotEnough, player:GetNetID());
		return false;
	end
end


ItemsConfig[10015].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if "21" ~= os.date("%H") then
		AddItemDrop(
			player, 
			{
				{
					obj_type = eDT_GongXun,
					obj_id = 0,
					obj_lv = 0,
					obj_num = use_num * 100,
				},
			},
			"使用道具"
		);
		return true;
	else
		SendItemErrorMsg(eIE_InRaceTime, player:GetNetID());
	end
	return false;
end
]]

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

ItemsConfig[20001].use_fun = function(player, use_num)
	use_num = use_num or 1;
	--PlayerChangeStamina(player, 10 * use_num, "道具 20001");
	return true;
end

ItemsConfig[20002].use_fun = function(player, use_num)
	use_num = use_num or 1;
	--PlayerChangeStamina(player, 30 * use_num, "道具 20002");
	return true;
end

ItemsConfig[20003].use_fun = function(player, use_num)
	use_num = use_num or 1;
	--PlayerChangeStamina(player, 60 * use_num, "道具 20003");
	return true;
end

ItemsConfig[20004].use_fun = function(player, use_num)
	use_num = use_num or 1;
	--PlayerChangeStamina(player, 120 * use_num, "道具 20004");
	return true;
end

ItemsConfig[20005].use_fun = function(player, use_num)
	use_num = use_num or 1;
	--PlayerChangeVigour(player, 5 * use_num, "道具 20005");
	return true;
end

ItemsConfig[20006].use_fun = function(player, use_num)
	use_num = use_num or 1;
	--PlayerChangeVigour(player, 15 * use_num, "道具 20006");
	return true;
end

ItemsConfig[20007].use_fun = function(player, use_num)
	use_num = use_num or 1;
	--PlayerChangeVigour(player, 30 * use_num, "道具 20007");
	return true;
end

ItemsConfig[20008].use_fun = function(player, use_num)
	use_num = use_num or 1;
	--PlayerChangeVigour(player, 60 * use_num, "道具 20008");
	return true;
end



-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

--[[
ItemsConfig[30001].use_fun = function(player, use_num)
	use_num = use_num or 1;
	AddItemRandomCard(player, Cards_Wei_3, use_num, "道具 30001");
	return true;
end
]]
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
ItemsConfig[10006].use_fun = function(player, use_num)
	use_num = use_num or 1;
	AddItemDrop(player, MmultDrop(player, 35607, use_num), "道具 招募令");
	return true;
end

ItemsConfig[10007].use_fun = function(player, use_num)
	use_num = use_num or 1;
	AddItemDrop(player, MmultDrop(player, 35608, use_num), "道具 高级招募令");
	return true;
end

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

ItemsConfig[40001].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35001, use_num), "道具 40001");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[40002].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35002, use_num), "道具 40002");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[40003].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35003, use_num), "道具 40003");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[40004].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35004, use_num), "道具 40004");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[40005].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35005, use_num), "道具 40005");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[40006].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35006, use_num), "道具 40006");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[40007].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35007, use_num), "道具 40007");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[40008].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35008, use_num), "道具 40008");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
ItemsConfig[50001].use_fun = function(player, use_num)
	use_num = use_num or 1;
	AddItemDrop(
		player, 
		{
			{
				obj_type = eDT_JiangHun,
				obj_id = 0,
				obj_lv = 0,
				obj_num = 500 * use_num,
			},
		}, 
		"道具 50001"
	);
	return true;
end

ItemsConfig[50002].use_fun = function(player, use_num)
	use_num = use_num or 1;
	AddItemDrop(
		player, 
		{
			{
				obj_type = eDT_JiangHun,
				obj_id = 0,
				obj_lv = 0,
				obj_num = 1000 * use_num,
			},
		}, 
		"道具 50002"
	);
	return true;
end

ItemsConfig[50003].use_fun = function(player, use_num)
	use_num = use_num or 1;
	AddItemDrop(
		player, 
		{
			{
				obj_type = eDT_JiangHun,
				obj_id = 0,
				obj_lv = 0,
				obj_num = 2000 * use_num,
			},
		}, 
		"道具 50003"
	);
	return true;
end

ItemsConfig[50004].use_fun = function(player, use_num)
	use_num = use_num or 1;
	AddItemDrop(
		player, 
		{
			-- {
			-- 	obj_type = eDT_Card,
			-- 	obj_id = 30501,
			-- 	obj_lv = 1,
			-- 	obj_num = 10 * use_num,
			-- },
		}, 
		"道具 50004"
	);
	return true;
end

ItemsConfig[50005].use_fun = function(player, use_num)
	use_num = use_num or 1;
	AddItemDrop(
		player, 
		{
			-- {
			-- 	obj_type = eDT_Card,
			-- 	obj_id = 40501,
			-- 	obj_lv = 1,
			-- 	obj_num = 5 * use_num,
			-- },
		}, 
		"道具 50005"
	);
	return true;
end

ItemsConfig[50006].use_fun = function(player, use_num)
	use_num = use_num or 1;
	AddItemDrop(
		player, 
		{
			-- {
			-- 	obj_type = eDT_Card,
			-- 	obj_id = 50501,
			-- 	obj_lv = 1,
			-- 	obj_num = 5 * use_num,
			-- },
		}, 
		"道具 50006"
	);
	return true;
end


-------------------------------------------------------------------------------
--
-------------------------------------------------------------------------------
ItemsConfig[70001].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35101, use_num), "道具 70001");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[70002].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35102, use_num), "道具 70002");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[70003].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35103, use_num), "道具 70003");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[70004].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35104, use_num), "道具 70004");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[70005].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35105, use_num), "道具 70005");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[70006].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35106, use_num), "道具 70006");
		return true;
	end
end

ItemsConfig[70007].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35107, use_num), "道具 70007");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[70008].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35108, use_num), "道具 70008");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[70009].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35109, use_num), "道具 70009");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[70010].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35110, use_num), "道具 70010");
		return true;
	end
end

ItemsConfig[70011].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35111, use_num), "道具 70011");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[70012].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35112, use_num), "道具 70012");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[70013].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35113, use_num), "道具 70013");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[70014].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35114, use_num), "道具 70014");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[70015].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35115, use_num), "道具 70015");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[70016].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35116, use_num), "道具 70016");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[80001].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35201, use_num), "道具 80001");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[80002].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 38002, use_num), "道具 80002");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end
ItemsConfig[80003].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 38003, use_num), "道具 80003");
		return true;
	end
end

ItemsConfig[80004].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 38004, use_num), "道具 80004");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end
ItemsConfig[80005].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 38005, use_num), "道具 80005");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end
ItemsConfig[80006].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 38006, use_num), "道具 80006");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end
ItemsConfig[80007].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 38007, use_num), "道具 80007");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end
ItemsConfig[80008].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 38008, use_num), "道具 80008");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end
ItemsConfig[80009].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 38009, use_num), "道具 80009");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end
ItemsConfig[81001].use_fun = function(player, use_num)
	use_num = use_num or 1;
	local items_pack = player:GetPieceSys(ePST_Items);
	if items_pack:GetPieceNum(81011) >= use_num then
		DelItem(player, 81011, use_num, "使用道具");
		--10012在使用消息时扣了
		AddItemDrop(player, MmultDrop(player, 35601, use_num), "使用道具");
		return true;
	else
		SendItemErrorMsg(eIE_NotEnough, player:GetNetID());
		return false;
	end
end
ItemsConfig[81002].use_fun = function(player, use_num)
	use_num = use_num or 1;
	local items_pack = player:GetPieceSys(ePST_Items);
	if items_pack:GetPieceNum(81012) >= use_num then
		DelItem(player, 81012, use_num, "使用道具");
		--10012在使用消息时扣了
		AddItemDrop(player, MmultDrop(player, 35602, use_num), "使用道具");
		return true;
	else
		SendItemErrorMsg(eIE_NotEnough, player:GetNetID());
		return false;
	end
end
ItemsConfig[81003].use_fun = function(player, use_num)
	use_num = use_num or 1;
	local items_pack = player:GetPieceSys(ePST_Items);
	if items_pack:GetPieceNum(81013) >= use_num then
		DelItem(player, 81013, use_num, "使用道具");
		--10012在使用消息时扣了
		AddItemDrop(player, MmultDrop(player, 35603, use_num), "使用道具");
		return true;
	else
		SendItemErrorMsg(eIE_NotEnough, player:GetNetID());
		return false;
	end
end

ItemsConfig[81004].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35604, use_num), "道具 名将宝箱");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end
ItemsConfig[81005].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35605, use_num), "道具 神器宝箱");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end
ItemsConfig[81006].use_fun = function(player, use_num)
	use_num = use_num or 1;
	if PlayerEquipPackEnough(CVipSys.new(player)) then
		AddItemDrop(player, MmultDrop(player, 35606, use_num), "道具 职业宝箱");
		return true;
	else
		local msg = create_msg(MSG_MS2C_ERROR_INFO);
		msg:WriteInt(eDC_NotEnougthEquipSpace);
		SendMsg(player:GetNetID(), msg);
	end
end

ItemsConfig[81011].use_fun = function(player, use_num)
	use_num = use_num or 1;
	local items_pack = player:GetPieceSys(ePST_Items);
	if items_pack:GetPieceNum(81001) >= use_num then
		DelItem(player, 81001, use_num, "使用道具");
		--10012在使用消息时扣了
		AddItemDrop(player, MmultDrop(player, 35601, use_num), "使用道具");
		return true;
	else
		SendItemErrorMsg(eIE_NotEnough, player:GetNetID());
		return false;
	end
end
ItemsConfig[81012].use_fun = function(player, use_num)
	use_num = use_num or 1;
	local items_pack = player:GetPieceSys(ePST_Items);
	if items_pack:GetPieceNum(81002) >= use_num then
		DelItem(player, 81002, use_num, "使用道具");
		--10012在使用消息时扣了
		AddItemDrop(player, MmultDrop(player, 35602, use_num), "使用道具");
		return true;
	else
		SendItemErrorMsg(eIE_NotEnough, player:GetNetID());
		return false;
	end
end
ItemsConfig[81013].use_fun = function(player, use_num)
	use_num = use_num or 1;
	local items_pack = player:GetPieceSys(ePST_Items);
	if items_pack:GetPieceNum(81003) >= use_num then
		DelItem(player, 81003, use_num, "使用道具");
		--10012在使用消息时扣了
		AddItemDrop(player, MmultDrop(player, 35603, use_num), "使用道具");
		return true;
	else
		SendItemErrorMsg(eIE_NotEnough, player:GetNetID());
		return false;
	end
end



getItemDisplayConfig = function (id)
	if ItemsConfig[id] then
		return ItemsConfig[id]
	elseif SimilarItemDisplayConfig[id] then
		return SimilarItemDisplayConfig[id]
	end
end

SimilarItemDisplayConfig = {
	[11001]=
	{
		name = "VIP经验奖励",
		info = " ",
		quality = 5,
		price = 0,
		res_id = 101,
	},
	[11002]=
	{
		name = "购买精力",
		info = " ",
		quality = 4,
		price = 0,
		res_id = 102,
	},
	[11003]=
	{
		name = "购买体力",
		info = " ",
		quality = 4,
		price = 0,
		res_id = 103,
	},
	[11004]=
	{
		name = "好友上限",
		info = " ",
		quality = 4,
		price = 0,
		res_id = 104,
	},
	[11005]=
	{
		name = "将魂",
		info = "武将觉醒所需材料\n获得方式：分解武将碎片、奇遇",
		quality = 4,
		price = 0,
		res_id = 105,
	},
	[11006]=
	{
		name = "经验奖励",
		info = " ",
		quality = 3,
		price = 0,
		res_id = 106,
	},
	[11007]=
	{
		name = "卡牌背包",
		info = " ",
		quality = 4,
		price = 0,
		res_id = 107,
	},
	[11008]=
	{
		name = "卡牌仓库",
		info = " ",
		quality = 4,
		price = 0,
		res_id = 108,
	},
	[11009]=
	{
		name = "士气奖励",
		info = " ",
		quality = 5,
		price = 0,
		res_id = 109,
	},
	[11010]=
	{
		name = "3星随机卡牌",
		info = " ",
		quality = 3,
		price = 0,
		res_id = 110,
	},
	[11011]=
	{
		name = "4星随机卡牌",
		info = " ",
		quality = 4,
		price = 0,
		res_id = 111,
	},
	[11012]=
	{
		name = "万能碎片",
		info = " ",
		quality = 5,
		price = 0,
		res_id = 112,
	},
	[11013]=
	{
		name = "银两",
		info = " ",
		quality = 3,
		price = 0,
		res_id = 113,
	},
	[11014]=
	{
		name = "邮件道具",
		info = " ",
		quality = 1,
		price = 0,
		res_id = 114,
	},
	[11015]=
	{
		name = "元宝",
		info = " ",
		quality = 4,
		price = 0,
		res_id = 115,
	},
	[11016]=
	{
		name = "装备背包",
		info = " ",
		quality = 4,
		price = 0,
		res_id = 116,
	},
	[11017]=
	{
		name = "礼包",
		info = " ",
		quality = 4,
		price = 0,
		res_id = 117,
	},
	[11018]=
	{
		name = "礼包",
		info = " ",
		quality = 5,
		price = 0,
		res_id = 118,
	},
	[11019]=
	{
		name = "功勋",
		info = " ",
		quality = 5,
		price = 0,
		res_id = 119,
	},
	[11020]=
	{
		name = "棒棒糖",
		info = " ",
		quality = 3,
		price = 0,
		res_id = 120,
	},
	[11021]=
	{
		name = "糖葫芦",
		info = " ",
		quality = 3,
		price = 0,
		res_id = 121,
	},
	[11022]=
	{
		name = "冰棍",
		info = " ",
		quality = 3,
		price = 0,
		res_id = 122,
	},
	[11023]=
	{
		name = "经验池",
		info = " ",
		quality = 3,
		price = 0,
		res_id = 123,
	},
	[11024]=
	{
		name = "空白",
		info = " ",
		quality = 3,
		price = 0,
		res_id = 124,
	},
	[11025]=
	{
		name = "熔炼值",
		info = " ",
		quality = 3,
		price = 0,
		res_id = 125,
	},
	[11026]=
	{
		name = "乞丐行乞",
		info = " ",
		quality = 2,
		price = 0,
		res_id = 126,
	},
	[11027]=
	{
		name = "pk 副本",
		info = " ",
		quality = 2,
		price = 0,
		res_id = 127,
	},
	[11028]=
	{
		name = "宝箱跟锦囊",
		info = " ",
		quality = 2,
		price = 0,
		res_id = 128,
	},
	[11029]=
	{
		name = "财宝",
		info = " ",
		quality = 2,
		price = 0,
		res_id = 129,
	},
	[11030]=
	{
		name = "藏宝图",
		info = " ",
		quality = 2,
		price = 0,
		res_id = 130,
	},
	[11031]=
	{
		name = "岔路",
		info = " ",
		quality = 2,
		price = 0,
		res_id = 131,
	},
	[11032]=
	{
		name = "发光的大堆元宝",
		info = " ",
		quality = 2,
		price = 0,
		res_id = 132,
	},
	[11033]=
	{
		name = "发光的井口",
		info = " ",
		quality = 2,
		price = 0,
		res_id = 133,
	},
	[11034]=
	{
		name = "老头仙人",
		info = " ",
		quality = 2,
		price = 0,
		res_id = 134,
	},
	[11035]=
	{
		name = "墓地",
		info = " ",
		quality = 2,
		price = 0,
		res_id = 135,
	},
	[11036]=
	{
		name = "破烂商铺",
		info = " ",
		quality = 2,
		price = 0,
		res_id = 136,
	},
	[11037]=
	{
		name = "山中关卡",
		info = " ",
		quality = 2,
		price = 0,
		res_id = 137,
	},
	[11038]=
	{
		name = "声望",
		info = " ",
		quality = 2,
		price = 0,
		res_id = 138,
	},
	[11039]=
	{
		name = "竞技场",
		info = " ",
		quality = 3,
		price = 0,
		res_id = 139,
	},
	[11040]=
	{
		name = "公会战",
		info = " ",
		quality = 3,
		price = 0,
		res_id = 140,
	},
	
}
