--
-- Author: Wu Hengmin
-- Date: 2015-09-22 11:27:57
--

AudioManager = {}

AudioManager.AMSOUND = 1 	-- 1播放0停止播放
AudioManager.AMMUSIC = 1	-- 1播放0停止播放
AudioManager.AMBATTLESOUND = 0;

--[[
	播放音效,返回音效ID
]]
AudioManager.playSound = function (file)
	-- body
	if AudioManager.AMSOUND ~= 1 then return -1 end
	--------------------------------------------
	return AudioEngine.playEffect(file)
end

--[[
	播放按键音效
]]
AudioManager.playButton = function ()
	-- body
	return AudioManager.playSound(AudioManager.effects.button.name)
end


--[[
	播放换装按键音效
]]
AudioManager.playChangeEquipButton = function ()
	-- body
	return AudioManager.playSound(AudioManager.effects.changeEquipButton.name)
end


--[[
	播放音效,返回音效ID
]]
AudioManager.playSoundByKey = function (key)
	
	if AudioManager.effects[key] then
		if AudioManager.AMBATTLESOUND == 0 and AudioManager.effects[key].mark == 2 then
			return -1;
		end
		AudioManager.playSound(AudioManager.effects[key].name)
	end
end

--播放战场被击音效
AudioManager.playBattleBehitSound = function ( params )
	if params == 1 then
		AudioManager.playSoundByKey("sound_hurt4")
	elseif params == 2 then
		AudioManager.playSoundByKey("sound_hurt3")
	end
end

--[[
	通过音效ID结束正在播放的音效
]]
AudioManager.stopSound = function (soundId)
	-- body
	AudioEngine.stopEffect(soundId)
end

--[[
	播放背景音乐
]]
AudioManager.playMusic = function (file, bLoop)
	-- body
	if AudioManager.AMMUSIC ~= 1 then return end
	--------------------------------------------
	if AudioEngine.isMusicPlaying() then
		AudioEngine.stopMusic(true)
	end
	AudioEngine.recovery = file
	AudioEngine.playMusic(file, bLoop or true)
end

AudioManager.rePlayMusic = function ()
	-- body
	if AudioManager.AMMUSIC ~= 1 then return end
	--------------------------------------------
	if AudioEngine.isMusicPlaying() then
		AudioEngine.stopMusic(true)
	end
	if AudioEngine.recovery then
		AudioEngine.playMusic(AudioEngine.recovery, true)
	else
		AudioManager.playMusic(AudioManager.musics.main1, true)
	end
end

--[[
	mark 1 主接口音效 2 战斗音效
]]
AudioManager.effects = {
	button = {describe = "按钮剩余",mark = 1,name = "music/s_button.mp3"},
	fangbing = {describe = "方兵",mark = 1,name = "music/s_fangbing.mp3"},
	jz_attack = {describe = "近战攻击",mark = 1,name = "music/s_jingzhan.mp3"},
	yc_attack = {describe = "远程攻击",mark = 1,name = "music/s_yuanc.mp3"},
	t_attack = {describe = "塔防攻击",mark = 1,name = "music/s_t_0.mp3"},
	s_friendmsg = {describe = "好友消息提示音",mark = 1,name = "music/s_friendmsg.mp3"},
	s_huadong = {describe = "滑动提示音",mark = 1,name = "music/s_huadong.mp3"},

	------------------------战斗模块-------------------------------
	["sound_win"] = {describe = "",mark = 2,name = "music/s_battle_win.mp3"},--胜利音效
	["sound_fail"] = {describe = "",mark = 2,name = "music/s_battle_lose.mp3"},--失败音效
	----------------------技能音效--------------------------
	
}

AudioManager.musics = {
	main = "music/m_main_0.mp3",
	attack_0 = "music/m_battle_0.mp3",
	attack_1 = "music/m_battle_1.mp3",

}
