--
-- Author: Wu Hengmin
-- Date: 2015-07-09 20:15:02
--

function globalTouchEvent(sender,eventType)
    if eventType == ccui.TouchEventType.began then
        sender.MarkIsMove = false
        sender.Record_pos = sender:convertToWorldSpace(cc.p(0, 0))
    elseif eventType == ccui.TouchEventType.moved then
        if not sender.MarkIsMove then
            local pos = sender:convertToWorldSpace(cc.p(0, 0))
            if cc.pGetLength(cc.p(pos.x - sender.Record_pos.x, pos.y - sender.Record_pos.y)) > 20 then
                sender.MarkIsMove = true
            end
        end
    elseif eventType == ccui.TouchEventType.ended then
        if not sender.MarkIsMove then
            return true
        end
    elseif eventType == ccui.TouchEventType.canceled then
        
    end
    return false
end

PNG_SIGNATURE = {0x89, 0x50, 0x4e, 0x47, 0x0d, 0x0a, 0x1a, 0x0a};

function isPngByFileName( filename )
   local data = cc.FileUtils:getInstance():getStringFromFile(filename);
   local len = string.len(data);
   if len < 8 then
       return false;
   end
   local checkdata = 0;
   for i=1,8 do
       checkdata = string.byte(data,i);
       if checkdata ~= PNG_SIGNATURE[i] then
           return false;
       end
   end

    return true;
end

function LoadPngImageByFileName( filename )
   
    local image = cc.Image:new()
    local issucces = image:initWithImageFile(filename);
    if not issucces then
        print("图片加载失败")
        return false;
    end
    local texturename = cc.FileUtils:getInstance():fullPathForFilename(filename);
    GLOBAL_TEXTURE_CACHE:addImage(image, texturename);
    return true;
end

function MillierConvertion( lon,lat )

    local L = 6381372 * math.pi * 2;--地球周长  
    local W=L;-- 平面展开后，x轴等于周长  
    local H=L/2;-- y轴约等于周长一半  
    local mill=2.3;-- 米勒投影中的一个常数，范围大约在正负2.3之间  
    local x = lon * math.pi / 180;-- 将经度从度数转换为弧度  
    local y = lat * math.pi / 180;-- 将纬度从度数转换为弧度  
    y=1.25 * math.log( math.tan( 0.25 * math.pi + 0.4 * y ) );-- 米勒投影的转换  
    -- 弧度转为实际距离  
    x = ( W / 2 ) + ( W / (2 * math.pi) ) * x;  
    y = ( H / 2 ) - ( H / ( 2 * mill ) ) * y; 
    return x,y;  
end

--把一个非表变量转换为字符串
function CoverToStr(var)
  if "string" == type(var) then
    return "\""..var.."\"";
  elseif "number" == type(var) then
    return ""..var;
  elseif "boolean" == type(var) then
    return if_a_else_b(var, "true", "false");
  else
    return "["..type(var).."]";
  end
end

--打印表
function print_tab(t, indent)
  indent = (indent or 0);
  print(string.rep("\t", indent).."{")
  for k, v in pairs(t) do
    if "table" == type(v) then
      print(string.rep("\t", indent + 1)..CoverToStr(k).." =");
      print_tab(v, indent + 1);
    else
      print(string.rep("\t", indent + 1)..CoverToStr(k).." = "..CoverToStr(v));
    end
  end
  print(string.rep("\t", indent).."},")
end