--
-- Author: Li Yang
-- Date: 2014-07-18 14:12:09
-- 样式

local Spannable = class("Spannable");


function Spannable:ctor()
	-------------------基础信息-------------------------
	--文字列表
	-- self.TextList = {};
	-- --当前显示的位置
	-- self.CurrentPos = 1;
	-- --样式列表
	-- self.SpanList = {};
	--样式开始位置
	self.StartPos = 1;
	--样式结束位置
	self.EndPos = 1;

	--字体大小
	self.fontSize = 1;
	--字体
	self.Typeface = nil;
	--字体风格
	self.StyleSpan = nil;
	--字体背景颜色
	self.BackGroundColor = nil;
	--字体前景颜色(即字体颜色)
	self.ForegroundColor = nil;
	--是否下划线
	self.IsNnderline = false;

	self.CallBackMark = nil;
end
--[[设置样式参数
	params = {
		startpos = 1,--开始位置
		endpos = 1,--结束位置
		fontsize = 1,--字体大小
		typeface = nil,--字体
		styleSpan = nil,--字体风格
		isNnderline = nil,--是否有下划线
		backGroundColor = nil,--背景颜色
		foregroundColor = nil,--字体颜色
		callBackMark = nil; --回调标示
	},
]]
function Spannable:setSpanConfig( params)
	--样式开始位置
	self.StartPos = params.startpos;
	--样式结束位置
	self.EndPos = params.endpos;
	--字体大小
	self.fontSize = params.fontsize;
	--字体
	self.Typeface = params.typeface;
	--字体风格
	self.StyleSpan = params.styleSpan;
	--字体背景颜色
	self.BackGroundColor = params.backGroundColor;
	--字体前景颜色(即字体颜色)
	self.ForegroundColor = params.foregroundColor;
	--是否下划线
	self.IsNnderline = params.isNnderline or false;
	self.CallBackMark = params.callBackMark;
end

return Spannable;
