--
-- Author: Li Yang
-- Date: 2014-07-18 14:12:09
-- 扫描文字

local SpannableString = class("SpannableString");


function SpannableString:ctor()
	-------------------基础信息-------------------------
	--文字列表
	self.ShowContent = "";
	--当前显示的位置
	self.CurrentTextPos = 1;
	--样式列表
	self.SpanList = {};
	self.CurrentSpanPos = 1;

	self.AbsoluteSpan = nil;

	--偏移量
	self.Offset_x = 0;
	self.Offset_y = 0;

	self.Offset_Char = 0;--缩进的字符数

end

--设置默认样式
function SpannableString:SetDefaultSpan( params )
	self.AbsoluteSpan = params;
end

function SpannableString:appendString( params )
	self.ShowContent = self.ShowContent..params;
	-- self.TextList[self.CurrentPos] = params;
	-- self.CurrentPos = self.CurrentPos + 1;
	-- return self.CurrentPos - 1;
end

function SpannableString:setSpan( params )
	self.SpanList[self.CurrentSpanPos] = params;
	self.CurrentSpanPos = self.CurrentSpanPos + 1;
end

--设置偏移值
function SpannableString:setOffsetValuse( x , y , char)
	self.Offset_x = x or 0;
	self.Offset_y = y or 0;
	self.Offset_Char = char or 0;
end

function SpannableString:getCurrentSpan( pos )
	--判断是否有新的span ,有则返回结束位置
	for i,v in ipairs(self.SpanList) do
		if v then
			if pos >= v.StartPos and pos <= v.EndPos  then
				return v , v.EndPos;
			end
		end
	end
	--没有返回默认样式 位置返回-1
	return self.AbsoluteSpan , -1;
end

return SpannableString;
