--
-- Author: LiYang
-- Date: 2014-04-14 13:56:26
-- 富文本修改：LiYang 2014-07-8
-- 参考文献: 
-- 		cocos2dx文本支持不同颜色的方法: http://my.oschina.net/u/816723/blog/133361
--[[

-- 当前支持功能
-- 1、添加不同颜色的文字
-- 2、支持自动换行
-- 3、字体可变
-- 4. 支持文本集
-- 5. 支持多样式文本(比如 ，下划线，描边，黑影,背景颜色)
-- 6. 支持字符串 事件响应

--缺点：
--暂时 没有找到测量字符准确宽度的方法


]]

local SpannableStringClass = require("app.views.base.SpannableString")
local SpannableClass = require("app.views.base.Spannable")

local UI_RichText = class("UI_RichText", function()
    return display.newNode()
end)


--[[
	w 文本宽
	h 文本高
	fontSize 字体大小
	writeWidth 可写区域宽
	writeHeight 可写区域高
]]
function UI_RichText:ctor(w, h, fontSize, writeWidth, writeHeight)

	self.curEleDrawPos = ccp(0, writeHeight - 40) --当前元素的绘制位置
	self.fontSize = fontSize
	self.writeWidth = writeWidth --可写区域宽度
	self.writeHeight = writeHeight -- 可写区域高度
	self.curOffsetY = 0 -- y方向当前偏移量
	self.endTextOnLine = 1 -- 最后一个文字所在行
	self.maxWriteLine = writeHeight / fontSize --可写的最大行数

	--显示的文字内容
	self.ShowSpannableList = {};
	self.AddPos = 1;

	--区域回调事件
	--[[
		ID,
		rectscope,
		callBackMark,
	]]
	self.RectCallBack = {};
	self.RectAmount = 0;
	--回调处理函数
	self.CallBack = nil;
	--创建画板的大小
	self.Practical_W = writeWidth + 30;
	self.Practical_H = writeHeight;
	
	-- self.renderTexture = cc.RenderTexture:create( self.Practical_W, self.Practical_H ) 
	-- self.renderTexture:getSprite():getTexture():setAntiAliasTexParameters(); 
	-- -- 为了提升绘制效率, 如果将每个元素都直接addChild到self的话, 那么会有元素个数次draw(),
	-- -- 而通过renderTexture方式, 先将renderTexture添加(addChild)至self, 再将元素先绘制到renderTexture上,
	-- -- 这样只会调用一次draw()
	-- -- 总的来说如果没有加入到child中的元素, 不会调用draw()
	-- print("当前的Y坐标：",self.renderTexture:getPositionX(),self.renderTexture:getPositionY())
	-- --画板位置center_top 对齐方式
	-- self.renderTexture:setPositionY( - self.Practical_H/2);
	-- self:setContentSize( CCSize( w , h ) )
	-- self:addChild( self.renderTexture )

	self.ClickP = -1;
	--按键事件
	-- self:setTouchMode(cc.TOUCH_MODE_ONE_BY_ONE)
	-- self:setTouchEnabled(true);
	-- self:addNodeEventListener(cc.NODE_TOUCH_CAPTURE_EVENT, function(event)
	-- 	if self.RectAmount == 0 then
	-- 		return false;
	-- 	end
	-- 	-- 转换为node 本地相对坐标
	-- 	local nodePoint = self.renderTexture:convertToNodeSpace(ccp(event.x,event.y));
	-- 	-- print("点击事件 start:",nodePoint.x,nodePoint.y)
	-- 	nodePoint.x = nodePoint.x + self.Practical_W / 2;
	-- 	nodePoint.y = nodePoint.y + self.Practical_H / 2;
	-- 	-- print("点击事件",nodePoint.x,nodePoint.y) 
	-- 	if event.name == "began" then
	-- 		for i,v in ipairs(self.RectCallBack) do
	-- 			if v then
	-- 				local rect = v.rectscope;
	-- 				if  (nodePoint.x - rect.x) >= 0 and (nodePoint.x - rect.x) < rect.w and
	-- 					(nodePoint.y - rect.y) >= 0 and (nodePoint.y - rect.y) < rect.h then
	-- 					self.ClickP = i;
	-- 					return true
	-- 				end
	-- 			end
	-- 		end
	-- 	elseif event.name == "ended" then
	-- 		if self.ClickP ~= -1 then
	-- 			local rect  = self.RectCallBack[self.ClickP].rectscope;
	-- 			if rect then
	-- 				if (nodePoint.x - rect.x) >= 0 and (nodePoint.x - rect.x) < rect.w and
	-- 					(nodePoint.y - rect.y) >= 0 and (nodePoint.y - rect.y) < rect.h then
	-- 					--运行区域事件
	-- 					print("点击区域标示：",self.RectCallBack[self.ClickP].callBackMark);
	-- 					if self.CallBack then
	-- 						self.CallBack(self.RectCallBack[self.ClickP].callBackMark);
	-- 					end
	-- 					self.ClickP = -1;
	-- 				end
	-- 			end
				
	-- 		end
	-- 	end
	-- 	-- print("点击事件")
	-- 	return false;
	-- end)
	
	self.ttfLabel = nil;
end

--设置当前字体样式
function UI_RichText:SetCurrentSpannable( params )
	self.fontSize = params.fontSize;
	-- print(params);
	if self.ttfLabel == nil then
		self.ttfLabel = ui.newTTFLabel({text="", font=params.Typeface, size=params.fontSize })
		self.ttfLabel:setColor(params.ForegroundColor);
	else
		self.ttfLabel:setString("");
		self.ttfLabel:setFontName(params.Typeface);
		self.ttfLabel:setFontSize(params.fontSize);
		self.ttfLabel:setColor(params.ForegroundColor);
	end
	--设置绘制用的ttf根据格式来设置
	-- if params.StyleSpan then
	-- 	--todo
	-- end
	
end

function UI_RichText:appendString( str )
	local spanStr = SpannableStringClass.new();
	spanStr:appendString( str )
	self.ShowSpannableList[self.AddPos] = spanStr;
	self.AddPos = self.AddPos + 1;
	return spanStr;
	-- self.ShowSpannableString:append( str );
end

--绘制文字
function UI_RichText:renderText(  )
	--文字一行 一行绘制
	local posr = {}
	posr[1] = self.curEleDrawPos.y
	for i,v in ipairs(self.ShowSpannableList) do
		local operationData = v;
		if operationData then
			table.insert(posr, self:renderUnitText( operationData ))
		end
	end

	for i=1,#posr-1 do
		posr[i] = posr[i]-posr[i+1]
		if i > 1 then
			posr[i] = posr[i]+posr[i-1]
		end
	end
	table.remove(posr, #posr)
	for i=1,#posr do
		print("posr["..i.."]"..posr[i])
	end
	return posr
end


--渲染单个text
function UI_RichText:renderUnitText( params )
	--当前pos位置
	local curStrPos = 1
	--操作的string
	local operationStr = params.ShowContent;
	--字符总长度
	local SumLen = string.len(operationStr); --operationStr:len();
	--当前字符的绘制位置
	local curCharDrawPos = self.curEleDrawPos;

	--初始位置
	local InviDrawPosX = curCharDrawPos.x + params.Offset_x;
	local InviDrawPosY = curCharDrawPos.y + params.Offset_y;
	-- print("初始化位置:",InviDrawPosX,InviDrawPosY)

	--字符串绘制位置
	local itrDrawPosX = InviDrawPosX;
	local itrDrawPosY = InviDrawPosY;



	--得到当前操作样式和位置
	local spanType ,endPos = params:getCurrentSpan( curStrPos );--得到当前字符段样式和节点位置
	self:SetCurrentSpannable( spanType );--设置当前字符段参数
	local StartPos = curStrPos;--设置字符段提取开始位置

	-- print("初始化类型",spanType.fontSize ,endPos);

	--绘制的起始位置
	local drawStartPos_x = itrDrawPosX + params.Offset_Char * self:computeCharOfPixelHeight();--设置字符段绘制位置
	local drawStartPos_y = itrDrawPosY;
	local draw_W = 0;
	local draw_H = 0;

	--换行标示
	local isChangeLine = false;
	while curStrPos <= SumLen do
		--得到字符
		local char, nextStrPos = self:getChar(operationStr, curStrPos);
		local curCharOfPixelWidth = 0;
		local curCharOfPixelHeight = 0;
		local curOperationStr = nil;
		--判断字符串是否是'\n'
		if char == '\n' then
			--更新下次绘制位置
			itrDrawPosX = InviDrawPosX
			itrDrawPosY = itrDrawPosY - self:computeCharOfPixelHeight()
			isChangeLine = true
		else
			--当前字符绘制的区域是否超出可绘制区域宽
			curOperationStr = string.sub(operationStr,StartPos,nextStrPos - 1);--curStrPos
			curCharOfPixelWidth ,curCharOfPixelHeight = self:computeCharOfPixelWidth(curOperationStr)
			-- print(char,nextStrPos,curCharOfPixelWidth,drawStartPos_x,drawStartPos_y);
			if drawStartPos_x + curCharOfPixelWidth >= self.writeWidth then
				itrDrawPosX = InviDrawPosX
				itrDrawPosY = itrDrawPosY - self:computeCharOfPixelHeight()
				isChangeLine = true
			end
		end
		
		
		--换行处理
		if isChangeLine then
			-- print("换行处理");
			--绘制
			local drawStr = string.sub(operationStr,StartPos,nextStrPos - 1); 
			--绘制
			self:drwaText( drawStr, self.ttfLabel,  ccp(drawStartPos_x, drawStartPos_y))
			--从新得到开始位置
			-- if char == '\n' then
			-- 	StartPos = nextStrPos;
				
			-- else
			-- 	StartPos = curStrPos;
			-- 	-- itrDrawPosX = drawStartPos_x + curCharOfPixelWidth;
			-- end
			StartPos = nextStrPos;
			--直接得到下一行字符的样式
			--重新取得样式和结束位置
			spanType ,endPos = params:getCurrentSpan( nextStrPos);
			self:SetCurrentSpannable( spanType );

			drawStartPos_x = itrDrawPosX ; --InviDrawPosX;
			drawStartPos_y = itrDrawPosY;
			isChangeLine = false;
		else
			--不换行处理
			itrDrawPosX = drawStartPos_x + curCharOfPixelWidth;--当前字符的坐标x
			--判断是否超过样式结束位置
			if endPos == -1 then
				--默认样式(检查是否有新的样式)
				local checkspanType ,checkendPos = params:getCurrentSpan( nextStrPos );--curStrPos
				if checkendPos ~= endPos then
					-- print("新样式切换:",checkendPos,endPos);
					--表示要嵌入新的样式
					local drawStr = string.sub(operationStr,StartPos,nextStrPos - 1);--curStrPos
					--绘制
					self:drwaText( drawStr, self.ttfLabel,  ccp(drawStartPos_x, drawStartPos_y))
					--重新取得样式和结束位置
					StartPos = nextStrPos;--curStrPos;
					endPos = checkendPos;
					spanType = checkspanType;
					self:SetCurrentSpannable( spanType );
					drawStartPos_x = itrDrawPosX;
					drawStartPos_y = itrDrawPosY;
					-- print("改变：",drawStartPos_x,drawStartPos_y)
				end
			else
				if nextStrPos > endPos then --curStrPos
					local drawStr = string.sub(operationStr,StartPos,nextStrPos - 1); --curStrPos
					-- print("绘制新样式字符串:",curStrPos,endPos,drawStr,spanType.ForegroundColor);
					--绘制
					local pixelWidth,pixelHeight = self:drwaText( drawStr, self.ttfLabel,  ccp(drawStartPos_x, drawStartPos_y))
					--判断是否有回调
					self:AddRectCallBack( spanType,drawStartPos_x,drawStartPos_y,pixelWidth,pixelHeight );
					--重新取得样式和结束位置
					StartPos = nextStrPos; -- curStrPos
					spanType ,endPos = params:getCurrentSpan( nextStrPos ); --curStrPos
					self:SetCurrentSpannable( spanType );
					drawStartPos_x = itrDrawPosX;
					drawStartPos_y = itrDrawPosY;
					-- print("改变：",drawStartPos_x,drawStartPos_y)
				end
			end
			
		end
		curStrPos = nextStrPos;
		
		--绘制最后一排
		if curStrPos >= SumLen then
			-- print("最后一行");
			--绘制
			local drawStr = string.sub(operationStr,StartPos,curStrPos - 1);
			--绘制
			self:drwaText( drawStr, self.ttfLabel,  ccp(drawStartPos_x, drawStartPos_y))
		end
	end

	--更新下一个绘制的起点
	self.curEleDrawPos.x = 0;
	self.curEleDrawPos.y = itrDrawPosY - self:computeCharOfPixelHeight();
	
	return self.curEleDrawPos.y
end

--得到当前绘制的位置
function UI_RichText:getCurEleDrawPos(  )
	return self.curEleDrawPos;
end

--得到当前文本的高度
function UI_RichText:getCurTextHeight(  )
	return self.Practical_H - self.curEleDrawPos.y;
end

function UI_RichText:AddRectCallBack( span,start_x,start_y,w,h )
	if not span.CallBackMark then
		return;
	end
	
	local rectCallBackData = {};
	rectCallBackData.ID = 1001;
	rectCallBackData.rectscope = {};
	rectCallBackData.rectscope.x = start_x;
	rectCallBackData.rectscope.y = start_y;
	rectCallBackData.rectscope.w = w;
	rectCallBackData.rectscope.h = h;
	rectCallBackData.callBackMark = span.CallBackMark;
	print("添加区域事件:",start_x,start_y,w,h,span.CallBackMark)
	self.RectAmount = self.RectAmount + 1;
	self.RectCallBack[self.RectAmount] = rectCallBackData;
end

--设置文本回调处理函数
function UI_RichText:SetCallBack( callback )
	self.CallBack = callback;
end

--[[更新Spannable
	spanStr 文字
	pos 对应的位置
]]
function UI_RichText:UpDataSpannableBypos( spanStr,pos )
	--得到当前操作样式和位置
	local spanType ,endPos = params:getCurrentSpan( curStrPos );
	--更新当前使用的样式
	self:SetCurrentSpannable( spanType );

end





--获取可写文本最大高度
function UI_RichText:getWriteTextHeight()
	return self.writeHeight
end

--获取当前Y方向的偏移量
function UI_RichText:getCurOffsetY()
	return	self.curOffsetY
end


--获取可向上偏移的最大值
function UI_RichText:getUpOffsetMaxValue()
	return self.endTextOnLine * self.fontSize - self:getContentSize().height
end




--清除所有文字
function UI_RichText:clearStrings()
	--显示的文字内容
	self.ShowSpannableList = {};
	self.AddPos = 1;
	self.renderTexture:clear(0, 0, 0, 0)
	self.curEleDrawPos = ccp(0, self.writeHeight - 40)
	self.endTextOnLine = 1
	self.ttfLabel = nil;
end


--重置偏移位置
function UI_RichText:resetOffsetPos()
	--暂时没用到
	self:setPositionY(self:getPositionY()-self.curOffsetY)
	self.curOffsetY = 0
end



--设置文本Y方向上的偏移量
function UI_RichText:offsetTextY(offsetY)
	offsetY = math.ceil(offsetY)
	--向上偏移
	if offsetY > 0 then
		--向上偏移的最大值
		local upOffsetMaxValue = self.endTextOnLine * self.fontSize - self:getContentSize().height

		if upOffsetMaxValue - math.abs(self.curOffsetY) > 0 then
			local destOffsetY = self.curOffsetY + offsetY
			if upOffsetMaxValue - math.abs(self.curOffsetY) <= 0 then
				offsetY = upOffsetMaxValue - self.curOffsetY
				self.curOffsetY = upOffsetMaxValue
			else
				self.curOffsetY = self.curOffsetY + offsetY
			end
		else
			offsetY = 0
		end
	--向下偏移
	else
		
		if self.curOffsetY + offsetY < 0 then
			offsetY = -self.curOffsetY
			self.curOffsetY = 0
		else
			self.curOffsetY = self.curOffsetY + offsetY
		end
		
	end

	self:setPositionY(self:getPositionY() + offsetY)
end

--换行
function UI_RichText:changeLine()
	self.endTextOnLine = self.endTextOnLine + 1
end



--[[获得字符(如果该位置是中文, 则返回的是中文字,字符串的起始位置从1开始
例如:
 str = "我1a啊"
 print(self:getChar(str, 1))  -- 输出:  我
 print(self:getChar(str, 4))  -- 输出:  1
 print(self:getChar(str, 5))  -- 输出:  a
 print(self:getChar(str, 6))  -- 输出:  啊
 )
	]]
function UI_RichText:getChar( str, pos )
	local char = str:sub(pos, pos)
	local charBitWidth = self:computeCharOfBitWidth(char)
	
	char = str:sub(pos, pos + charBitWidth - 1)

	local nextPos = pos + charBitWidth

	return char, nextPos
end



--计算指定字符位宽
function UI_RichText:computeCharOfBitWidth( char )
	--utf8站位大小
	local arr  = {0, 0xc0, 0xe0, 0xf0, 0xf8, 0xfc}
	local tmp = char:byte();
	--UTF-8中, 中文占位为3
	-- if char:byte() >0x80 then
	-- 	charWidth=3
	-- --英文为1
	-- else
	-- 	charWidth=1
	-- end
	local arrLen = #arr;
	while arr[arrLen] do
        if tmp == nil then
            break
        end
        if tmp >= arr[arrLen] then
            break
        end
         arrLen = arrLen - 1
    end
	return arrLen;
end


--计算单个字符的像素宽度
function UI_RichText:computeCharOfPixelWidth( char )
	if self.ttfLabel == nil then
		return 0;
	end
	self.ttfLabel:setString(char);
	local pixelWidth = self.ttfLabel:getContentSize().width;
	local pixelHight = self.ttfLabel:getContentSize().height;
	-- local charWidth = self:computeCharOfBitWidth(char)
	-- -- print(charWidth);
	-- local pixelWidth = 0
	-- if charWidth == 3 then
	-- 	pixelWidth = self.fontSize
	-- else
	-- 	pixelWidth = self.fontSize / 2
	-- end
	-- print(pixelWidth);


	return pixelWidth,pixelHight;
end

--计算单个字符高度
function UI_RichText:computeCharOfPixelHeight()
	return self.fontSize + 3;
end

-- function UI_RichText:Destroy(  )
-- 	self.renderTexture:
-- 	self.ttfLabel:autorelease();
-- end

-- --绘制字符串
-- function UI_RichText:drwaText( str, fontName, fontColor, position )
-- 	--lable的释放通过cocos2dx内存管理的自动释放机制处理
-- 	local label = ui.newTTFLabel({text=str, font=fontName, size=self.fontSize })
-- 	label:setColor(fontColor)
-- 	label:setAnchorPoint( ccp(0,1) )
-- 	self.renderTexture:begin()
-- 	label:setPosition( position )
-- 	label:visit()
-- 	self.renderTexture:endToLua()
-- end

-- --绘制字符串
-- function UI_RichText:drwaText( str, spannable, position )
-- 	--lable的释放通过cocos2dx内存管理的自动释放机制处理
-- 	--样式：newTTFLabelWithOutline ,newTTFLabelWithShadow,
-- 	--1.下划线 2.背景颜色 3.区域点击 4.
-- 	print("调用绘制",position.x,position.y);
-- 	local label = ui.newTTFLabel({text=str, font=spannable.Typeface, size=spannable.fontSize })
-- 	label:setColor(spannable.ForegroundColor)
-- 	label:setAnchorPoint( ccp(0,1) )
-- 	self.renderTexture:begin()
-- 	label:setPosition( position )
-- 	label:visit()
-- 	--判断是否有回调事件

-- 	self.renderTexture:endToLua()
-- end

--绘制字符串
function UI_RichText:drwaText( str, ttflabel, position )
	--lable的释放通过cocos2dx内存管理的自动释放机制处理
	--样式：newTTFLabelWithOutline ,newTTFLabelWithShadow,
	--1.下划线 2.背景颜色 3.区域点击 4.
	-- print("调用绘制",str,position.x,position.y,ttflabel);
	-- local label = ui.newTTFLabel({text=str, font=spannable.Typeface, size=spannable.fontSize })
	-- label:setColor(spannable.ForegroundColor)
	ttflabel:setAnchorPoint( ccp(0,0) )
	ttflabel:setString(str);
	local pixelWidth = ttflabel:getContentSize().width;
	local pixelHight = ttflabel:getContentSize().height;
	self.renderTexture:begin()
	ttflabel:setPosition(position)
	ttflabel:visit()
	-- 判断是否有回调事件
	self.renderTexture:endToLua()

	-- self.renderTexture:setAntiAliasTexParameters();
	return pixelWidth,pixelHight;
end

return UI_RichText;

