--
-- Author: LiYang
-- Date: 2016-04-16 15:00:08
-- 战场显示管理
--[[
	次逻辑代码
	主要处理游戏显示对象的屏蔽关系
]]

--[[监听全局事件名预览
eventModleName: mainpage_popup_buttons2
eventName:
	zhandou_touched -- 点击主线按钮
]]

local class_controler_battlefield_map_operation = require("app.views.battlefield.controller.controler_battlefield_map_operation.lua")

local battleDisplayLayerManager = class("battleDisplayLayerManager");

function battleDisplayLayerManager:ctor(target)
	self.target_ = target;

	self.registerConfig = {
		-- {"controler_mainpage_zhanyi1_layer","zhanyi_touched",1},
		-- {"battleshowlayer","event_addshowobject",1},--添加显示对象
		-- {"battleshowlayer","event_removeshowobject",1},--删除显示对象
		-- {"battleshowlayer","event_createmap",1},--创建地图
		-- {"battleshowlayer","event_addlogicbject",1},--添加逻辑对象
		-- {"battleshowlayer","event_hide",1},--隐藏战斗显示
		-- {"battleshowlayer","event_show",1},--显示
		-- {"battleshowlayer","event_cut",1},--切换
		-- {"battlefield","event_create",1}, --战场创建
		{"battlefield","exit",1},--退出战斗界面
		
		{"battleDisplay","create",1},--创建显示
		{"battleDisplay","hide",1},--地图隐藏
		{"battleDisplay","show",1},--显示
		{"battleDisplay","add",1},--添加显示
		{"battleDisplay","remove",1},--删除显示
		{"battleDisplay","shake",1},--战场震动
		{"battleDisplay","focus",1},--战场聚焦
		{"battleDisplay","move",1},--显示移动事件
		{"battleDisplay","scale",1},--显示缩放事件
	}

	--添加对象
	--删除对象

	--地图对象
	self.map = nil;
	--管理对象池
	self.objectPool = {};
	--战场显示状态 0 不显示 1 显示
	self.battleShowState = false;

	-- self:register_event_createmap( nil );

	--显示缩放值
	self.DisplayScale = 1.0;

	--当前位置
	self.CurrentBottomPos = { x = 0 ,y = 0};

	self:register_event(  );
end


--注册事件
function battleDisplayLayerManager:register_event(  )
	local defaultCallbacks = {
		-- controler_mainpage_zhanyi1_layer_zhanyi_touched = handler(self, self.register_event_into_battle),
		-- battlefield_event_create = handler(self, self.register_event_create),
  --       battleshowlayer_event_addshowobject = handler(self, self.register_event_addshowobject),
  --       battleshowlayer_event_addlogicbject = handler(self, self.register_event_addLogicbject),
  --       battleshowlayer_event_removeshowobject = handler(self, self.register_event_removeshowobject),
  --       battleshowlayer_event_cut = handler(self, self.register_event_cut),
        battlefield_exit = handler(self, self.register_event_exit),

  		battleDisplay_create = handler(self, self.register_event_create),
        battleDisplay_add = handler(self, self.register_event_addshowobject),
        battleDisplay_remove = handler(self, self.register_event_removeshowobject),
        battleDisplay_hide = handler(self, self.register_event_hide),
        battleDisplay_show = handler(self, self.register_event_show),
        battleDisplay_shake = handler(self, self.register_event_shake),
        battleDisplay_focus = handler(self, self.register_event_focus),
        battleDisplay_move = handler(self, self.register_event_move),
        battleDisplay_scale = handler(self, self.register_event_scale),
    }
    self.eventlisen = {};
	for i,v in ipairs(self.registerConfig) do
		local eventname = createGlobaleEventName( v[1], v[2] )
		if defaultCallbacks[eventname] then
			self.eventlisen[eventname] = createGlobalEventListener( v[1], v[2], defaultCallbacks[eventname], v[3] )
		end
	end

	self.EventOper_logic = class_controler_battlefield_map_operation.new();


end

function battleDisplayLayerManager:addExecuteEvent( eventname )
	if not eventname then
		return;
	end
	for i,v in ipairs(eventname) do
		table.insert(self.registerConfig, 1, eventname)
	end
end

--注册关闭事件
function battleDisplayLayerManager:register_event_close(  )
	--清除事件监听
	for k,v in pairs(self.eventlisen) do
		GLOBAL_EVENT_DISPTACHER:removeEventListener(v);
	end
	-- self.target_:removeFromParent();
end


--创建战斗界面
function battleDisplayLayerManager:register_event_create( event )
	--开始游戏按钮
	local battleisshow = event._usedata[1];--是否显示
    local screenSize = cc.Director:getInstance():getWinSize()
    print("screenSize:",screenSize.width,screenSize.height)
    --添加战场显示
    self.target_ = require("app.views.battlefield.battleDisplayLayer").new();
    self.scene = APP:getCurScene()
	self.scene:addChildToLayer(LAYER_ID_UI, self.target_)
    self.target_:setPosition(cc.p(display.cx,display.cy));
    --创建地图
    self.mapview = require("app.views.battlefield.map.battlefieldmap").new();
    self.mapview:InitMapData( 1 );
    self.target_.mapLayer:addChild(self.mapview);
    print("battleDisplayLayerManager map",self.mapview:getPosition())
    
    --创建Ui
    dispatchGlobaleEvent( "battlefieldui" ,"initialize");
    
    --判读是否显示
    -- if battleisshow then
    -- 	self:register_event_show();
    -- else
    -- 	self:register_event_hide();
    -- end

    self.EventOper_logic:setLogicInfo( {
		scale = 0.0
		} )
end


--隐藏
function battleDisplayLayerManager:register_event_hide( event )
	-- print("battleDisplayLayerManager:register_event_hide",self.target_)
	self.battleShowState = false;
	-- dispatchGlobaleEvent("controler_mainPage_ui_layer", "setUIVisible", {visibleType="showAll"})
 --    dispatchGlobaleEvent("controler_mainpage_top_layer", "setUIVisible", {visibleType="showAll"})
 --    dispatchGlobaleEvent("model_playerBaseAttr", "setUIVisible", {visibleType="showAll"})
    self.target_:setVisible(false);
    self.target_:hide();
    AudioManager.AMBATTLESOUND = 0;
end

--显示
function battleDisplayLayerManager:register_event_show( event )
	-- print("battleDisplayLayerManager:register_event_show",self.target_)
	self.battleShowState = true;
	-- dispatchGlobaleEvent("controler_mainPage_ui_layer", "setUIVisible", {visibleType="hideAll"})
 --    dispatchGlobaleEvent("controler_mainpage_top_layer", "setUIVisible", {visibleType="hideAll"})
    -- dispatchGlobaleEvent("model_playerBaseAttr", "setUIVisible", {visibleType="hideAll"})
    self.target_:setVisible(true);
    self.target_:show();
    AudioManager.AMBATTLESOUND = 1;
end


--战役切换
-- function battleDisplayLayerManager:register_event_cut( event )
-- 	local operation = event._usedata[1];
-- 	print("battleDisplayLayerManager:register_event_cut",operation);
-- 	if operation == 1 then
-- 		self.target_:show();
-- 	elseif operation == 0 then
-- 		self.target_:hide();
-- 	elseif operation == 2 then
-- 		self.target_:cut();
-- 	end
	
-- end

--添加对象
function battleDisplayLayerManager:register_event_addshowobject( event )
	local object = event._usedata[1];
	local layer = event._usedata[2];
	local zorder = event._usedata[3];
	print("register_event_addshowobject:",object,layer,zorder)
	if zorder then
		object:setLocalZOrder(zorder);
	end
	-- print("==========",object.mark)
	self.objectPool[object] = object;
	if layer == 0 then
		self.target_.effectLayer_0:addChild(object)
	elseif layer == 1 then
		self.target_.effectLayer_1:addChild(object)
	elseif layer == 2 then
		self.target_.effectLayer_2:addChild(object)
	elseif layer == 3 then
		self.target_.effectLayer_3:addChild(object)
	elseif layer == 4 then
		print("register_event_addshowobject",object,layer,zorder,self.target_.uiLayer)
		--ui层
		self.target_.uiLayer:addChild(object);
	elseif layer == 5 then
		--全屏效果层
		self.target_.effect_screen:addChild(object);
	end
end

-- function battleDisplayLayerManager:register_event_addLogicbject( event )
-- 	print("register_event_addLogicbject",tostring(event._usedata))
-- 	self.target_.LogicNode:addChild(event._usedata)
-- end

function battleDisplayLayerManager:addLogicbject( objece )
	print("register_event_addLogicbject",tostring(objece))
	self.target_.LogicNode:addChild(objece)
end

function battleDisplayLayerManager:register_event_removeshowobject( object )
	if self.objectPool[object] then
		self.objectPool[object]:removeFromParent();
		self.objectPool[object] = nil;
	end
end

function battleDisplayLayerManager:register_event_shake( event )
	local time = event._usedata[1];
	--添加全屏震动效果
	if not self.ShakeEffect then
		self.ShakeEffect = require("app.effect.effectpiece.Effect_Shake").new();
		self.target_.LogicNode:addChild(self.ShakeEffect);
		self.ShakeEffect:setData({
			view = self.target_.showList,
			offset = 10,--偏移量
			runtime = time,
			finishCallBack = nil,
			});
	else
		self.ShakeEffect:setShackeTime( time );
	end
end

--聚焦效果
function battleDisplayLayerManager:register_event_focus( event )
	local action = event._usedata[1];
	self.target_.BottomLayer:runAction(action);
end

--清理战场
function battleDisplayLayerManager:register_event_exit( event )
	--清理效果 0 1 2 3
	self.target_.effectLayer_0:removeAllChildren();
	self.target_.effectLayer_1:removeAllChildren();
	self.target_.effectLayer_2:removeAllChildren();
	self.target_.effectLayer_3:removeAllChildren();
	self.objectPool = {};
	--显示缩放值
	self.DisplayScale = 1.0;
	--当前位置
	self.CurrentBottomPos = { x = 0 ,y = 0};
	self.target_:executeBottomLayerMove( {
		pos = {x = 0, y = 0},
		moveModel = 1,
		distance = 0,
		} )
	self.target_:executeBottomLayerScale( 1 );
	--结束战场聚焦效果
	self:UpdataAnchorPoint(  0, 0 )
	self.target_.BottomLayer:setScale(1, 1);
	self.target_.BottomLayer:setPosition(cc.p(0,0));
	--结束战斗伤害提示
	-- control_Battlefield.HurtPromptManager:clearPrompt(  );
	-- self.target_ = nil;
end

--底层事件移动
function battleDisplayLayerManager:register_event_move( event )
	-- pos 移动的向量
 --    moveModel 移动的模式 1 设置 2 动作移动
 --    distance 移动的距离
	local vec_pos = event._usedata[1];
	local moveM = event._usedata[2] or 1;
	local moveL = event._usedata[3];
	self.target_:executeBottomLayerMove( {
		pos = vec_pos,
		moveModel = moveM,
		distance = moveL,
		} )
end

--显示的缩放
function battleDisplayLayerManager:register_event_scale( event )
	local scaleV = event._usedata[1];
	self.target_:executeBottomLayerScale( scaleV );
end

--重置游戏
-- function battleDisplayLayerManager:ResetGame( event )
-- 	--清理效果 0 1 2 3
-- 	self.target_.effectLayer_0:removeAllChildren();
-- 	self.target_.effectLayer_1:removeAllChildren();
-- 	self.target_.effectLayer_2:removeAllChildren();
-- 	self.target_.effectLayer_3:removeAllChildren();
-- 	self.objectPool = {};
-- 	--结束战场聚焦效果
-- 	self:UpdataAnchorPoint(  0, 0 )
-- 	self.target_.BottomLayer:setScale(1, 1);
-- 	self.target_.BottomLayer:setPosition(cc.p(0,0));
-- 	--结束战斗伤害提示
-- 	control_Battlefield.HurtPromptManager:clearPrompt(  );

-- 	self.target_:removeFromParent();
-- 	self.target_ = nil;
-- 	self.ShakeEffect = nil;
-- 	--地图对象
-- 	self.map = nil;
-- 	--管理对象池
-- 	self.objectPool = {};
-- 	--战场显示状态 0 不显示 1 显示
-- 	self.battleShowState = false;

-- end

function battleDisplayLayerManager:updateShowOrderLogic()
	for i,v in pairs(self.objectPool) do
		--屏蔽关系 x + y
		-- local order = v.map_x + v.map_y;
		if v then
			v:setLocalZOrder(v.map_x + v.map_y)
		end
	end
end

function battleDisplayLayerManager:isShow(  )
	
	return self.battleShowState;
end

--[[修改焦点 battleShowManager:UpdataAnchorPoint(  300 , 300 );
]]
function battleDisplayLayerManager:UpdataAnchorPoint(  x , y )
	self.Focus_x = x;
	self.Focus_y = y;
	local pos_x = 0;
	local pos_y = 0;
	if x == 0 then
		pos_x = 0;
	else
		pos_x = -x;
	end
	if y == 0 then
		pos_y = 0;
	else
		pos_y = -y;
	end
	self.target_.FocusControl:setPosition(cc.p(pos_x, pos_y));
	self.target_.BottomLayer:setPosition(cc.p(x, y));
end

function battleDisplayLayerManager:getInstance(  )
    if battleDisplayLayerManager.instance == nil then
        battleDisplayLayerManager.instance = battleDisplayLayerManager.new()
    end
    return battleDisplayLayerManager.instance
end

battleDisplayManager = battleDisplayLayerManager.getInstance( );

return battleDisplayLayerManager;
