--
-- Author: LiYang
-- Date: 2015-08-12 14:23:59
-- 战场控制

local control_battlefield = class("control_battlefield");

function control_battlefield:ctor()
	--注册地图事件
	self.registerConfig = {
        {"battlefield","initialize",1},--战场初始化
        {"battlefield","loadcut",1},--战场加载切换
        {"battlefield","create",1},--战场创建
        {"battlefield","pause",1},--暂停战场
        {"battlefield","recover",1},--恢复战场
        {"battlefield","refresh",1},--执行战斗数据刷新
        {"battlefield","destroy",1},--执行战斗数据销毁
        {"battlefield","guild_msg",1},--执行战斗通知消息
        {"battlefield","end",1},--退出战场
    };
    self:register_event();

	self.executeIndex = 0;
	--战场执行状态 0 停止 1 执行
	self.executeState = 1;

	self.CurrentExecuteData = nil;--当前执行数据

	self.operateListen = 0;--操作监听
end

function control_battlefield:getInstance(  )
    if control_battlefield.instance == nil then
        control_battlefield.instance = control_battlefield.new()
    end
    return control_battlefield.instance
end

--注册事件
function control_battlefield:register_event(  )
    local defaultCallbacks = {
        battlefield_initialize = handler(self, self.register_event_init),
        battlefield_loadcut = handler(self, self.register_event_loadcut),
        battlefield_create = handler(self, self.register_event_create),
        battlefield_pause = handler(self, self.register_event_pause),
        battlefield_recover = handler(self, self.register_event_recover),
        battlefield_refresh = handler(self, self.register_event_refresh),
        battlefield_destroy = handler(self, self.register_event_destroy),
        battlefield_end = handler(self, self.register_event_exit),
        battlefield_guild_msg = handler(self, self.register_event_guild_notification),
    }
    self.eventlisen = {};
    for i,v in ipairs(self.registerConfig) do
        local eventname = createGlobaleEventName( v[1], v[2] )
        if defaultCallbacks[eventname] then
            createGlobalEventListener( v[1], v[2], defaultCallbacks[eventname], v[3] )
        end
    end
end

--[[注册战场初始化
    1 规划领地
        {
            battleType = Data_Battle.CONST_BATTLE_TYPE_PLANNING,
            cell_x = 0,
            cell_y = 0,
        }
    2 进攻领地
        {
            battleType = Data_Battle.CONST_BATTLE_TYPE_ROB,
            cell_x = 0,
            cell_y = 0,
        }
    3 刷怪
        {
            battleType = Data_Battle.CONST_BATTLE_TYPE_TANSUO,
            cell_x = 0,
            cell_y = 0,
        }
]]
function control_battlefield:register_event_init( event )
    --执行战斗数据
    -- if self.CurrentExecuteData then
    --     return;
    -- end
    print("control_battlefield:register_event_init")
    self.CurrentExecuteData = event._usedata;
    self:RequestBattleData();
    Data_Battle.isReceiveMsg = true;
end

--[[
请求战斗数据
]]
function control_battlefield:RequestBattleData(  )
    Data_Battle:setBattlefieldType( self.CurrentExecuteData.battleType );--设置战斗类型
    if self.CurrentExecuteData.battleType == Data_Battle.CONST_BATTLE_TYPE_PLANNING then
        
        printInfo("网路日志 %s","发送请求地块建筑信息 MSG_C2S_FIELD_GetData".."x:".. self.CurrentExecuteData.cell_x .."y:"..self.CurrentExecuteData.cell_y)
        gameTcp:SendMessage(MSG_C2S_FIELD_GetData,{
            self.CurrentExecuteData.cell_x,
            self.CurrentExecuteData.cell_y,
            })
    elseif self.CurrentExecuteData.battleType == Data_Battle.CONST_BATTLE_TYPE_TANSUO then
         -- Data_Battle:setBattlefieldType( Data_Battle.CONST_BATTLE_TYPE_TANSUO );--设置战斗类型
        printInfo("网路日志 %s","发送探索消息信息 MSG_C2S_FIGHT_Hunting")
        gameTcp:SendMessage(MSG_C2S_FIGHT_Hunting,{0})
    elseif self.CurrentExecuteData.battleType == Data_Battle.CONST_BATTLE_TYPE_ROB then
         -- Data_Battle:setBattlefieldType( Data_Battle.CONST_BATTLE_TYPE_TANSUO );--设置战斗类型
        printInfo("网路日志 %s","发送掠夺战斗消息信息 MSG_C2S_FIGHT_Rob")
        gameTcp:SendMessage(MSG_C2S_FIGHT_Rob,{
            -- self.CurrentExecuteData.cell_x,
            -- self.CurrentExecuteData.cell_y,
            })
    elseif self.CurrentExecuteData.battleType == Data_Battle.CONST_BATTLE_TYPE_GUILDACT then
        printInfo("网路日志 %s","发送开始工会战信息 MSG_C2S_FIGHT_AttackBegin")
        gameTcp:SendMessage(MSG_C2S_FIGHT_AttackBegin,{
            -- self.CurrentExecuteData.cell_x,
            -- self.CurrentExecuteData.cell_y,
            })
     elseif self.CurrentExecuteData.battleType == Data_Battle.CONST_BATTLE_TYPE_VCR then
        printInfo("网路日志 %s","发送战斗回放信息 MSG_C2S_FIGHT_Replay")
        gameTcp:SendMessage(MSG_C2S_FIGHT_Replay,{
            self.CurrentExecuteData.key,
            })
    else

    end

end

--[[战场切换
]]
function control_battlefield:register_event_loadcut( event )
    --切换横竖屏
    Lua2J_ScreenOrientation:Lua2J_SetScreenOrientation( 0 );
    dispatchGlobaleEvent( "models_loadres" ,"create");
end

--[[工会战通知消息
]]
function control_battlefield:register_event_guild_notification( event )
    local data = event._usedata
    if data.guildKey ~= MAIN_PLAYER.guild:getGUID() then
        return;
    end
    print(MAIN_PLAYER.baseAttr._MapTile_x,MAIN_PLAYER.baseAttr._MapTile_y)
    if MAIN_PLAYER.baseAttr._MapTile_x ~= data.plot_x or MAIN_PLAYER.baseAttr._MapTile_y ~= data.plot_y then
       return;
    end
    --判断是否是在战斗状态
    if MAIN_PLAYER.currentState == "BattlefieldScene" then
        return;
    end

    local view = UIManager:CreatePrompt_GuildAct(  );
    view:setData( data.time )
end

--[[战场创建
]]
function control_battlefield:register_event_create( event )
   APP:toScene(SCENE_ID_BATTLE);
end


--[[战场暂停
]]
function control_battlefield:register_event_pause( event )

end

--[[战场恢复
]]
function control_battlefield:register_event_recover( event )

end

--[[战场刷新
]]
function control_battlefield:register_event_refresh( event )
	
end

--执行战斗数据销毁
function control_battlefield:register_event_executebattle_destroy( event )
	
end

--退出公会
function control_battlefield:register_event_exit( event )
    control_Combat:doEvent("event_exit_battle");
end


control_Battlefield = control_battlefield.getInstance( );

return control_battlefield;
