--
-- Author: Liyang
-- Date: 2015-06-26 17:28:09
-- 战斗系统 Ui接口

--[[发送全局事件名预览
eventModleName: zhanyi_ctrl -- 战役接口内部控制
eventName: 
	choose_zhanyi 选择战役
	zhanyi_ctrl_choose_zhanyilevel 选择战役关卡
	zhanyi_ctrl_zhanyilevel_refresh 战役关卡刷新
]]

--[[监听全局事件名预览
eventModleName: battlefield
eventName:
	ui_initialize --战斗初始化界面
	create_result -- 创建战斗结果

]]

local control_zhandouui = class("control_zhandouui")

local class_result = import(".ui.UI_BattleResult")

local class_result_1 = import(".ui.UI_BattleResult_VCR")

function control_zhandouui:ctor(target)

	self.target_ = target;

	self.registerConfig = {
		--初始化数据
		{"battlefieldui","initialize",1},
		{"battlefield","create_result",1},--创建战斗结果
		{"battlefield","exit",1},--退出战斗界面

		{"battlefieldui","updata_bout",1},--更新战场回合数
		{"battlefieldui","updata_info",1},--更新战场信息
		{"battlefieldui","updata_next_info",1},--更新下一次信息描述
	}
	self:register_event();

	self.CurrentScheduleMark = 0;

end

--注册事件
function control_zhandouui:register_event(  )
	local defaultCallbacks = {
		battlefieldui_initialize = handler(self, self.event_create),
		battlefield_create_result = handler(self, self.event_create_result),
		battlefield_exit = handler(self, self.event_exit),

		battlefieldui_updata_bout = handler(self, self.event_updata_bout),
		battlefieldui_updata_info = handler(self, self.event_updata_info),
		battlefieldui_updata_next_info = handler(self, self.event_updata_next_info),
    }
    self.eventlisen = {};
	for i,v in ipairs(self.registerConfig) do
		local eventname = createGlobaleEventName( v[1], v[2] )
		print("注册事件",eventname);
		if defaultCallbacks[eventname] then
			createGlobalEventListener( v[1], v[2], defaultCallbacks[eventname], v[3] )
		end
	end
end

function control_zhandouui:addExecuteEvent( eventname )
	if not eventname then
		return;
	end
	for i,v in ipairs(eventname) do
		table.insert(self.registerConfig, 1, eventname)
	end
	
end

--初始化数据
function control_zhandouui:event_create( event )
	--显示UI
	if Data_Battle:getBattlefieldType() == Data_Battle.CONST_BATTLE_TYPE_PLANNING then
		self.battleUI = require("app.views.battlefield.ui.controler_battle_ui_layer_0.lua").new();
	elseif Data_Battle:getBattlefieldType() == Data_Battle.CONST_BATTLE_TYPE_TANSUO or Data_Battle:getBattlefieldType() == Data_Battle.CONST_BATTLE_TYPE_ROB or Data_Battle:getBattlefieldType() == Data_Battle.CONST_BATTLE_TYPE_GUILDACT then
		self.battleUI = require("app.views.battlefield.ui.controler_battle_ui_attack.lua").new();
	elseif Data_Battle:getBattlefieldType() == Data_Battle.CONST_BATTLE_TYPE_VCR then
		self.battleUI = require("app.views.battlefield.ui.controler_battle_ui_attack.lua").new();
	end
	
end

--[[创建战斗UI0
]]
function control_zhandouui:createBattleUI_0(  )
	
end

--[[创建战斗UI1
]]
function control_zhandouui:createBattleUI_1(  )
	-- body
end

--[[创建战斗结果显示

]]
function control_zhandouui:event_create_result( event )
	--类型
	local battletype = event._usedata[1];
	--结果资料
	local resultData = event._usedata[2]
	resultData.fightType = battletype;
	print("control_zhandouui:event_create_result",battletype)
	self.zhandouResult = nil;
	if Data_Battle:getBattlefieldType() == Data_Battle.CONST_BATTLE_TYPE_VCR then
		self.zhandouResult = class_result_1.new();
	else
		self.zhandouResult = class_result.new();
	end
	
	--设置结果资料
	self.zhandouResult:refreshView( resultData );
	self.zhandouResult:setPosition(cc.p(-640 ,-360))
	--设置战斗结果效果
	-- APP:getCurScene():addChildToLayer(LAYER_ID_NOTICE, self.zhandouResult)
	dispatchGlobaleEvent( "battleDisplay" ,"add" ,{self.zhandouResult, 4 ,0});
	-- GLOBAL_COMMON_ACTION:popupOut({node = self.zhandouResult.rootNode,
	-- 		shadowNode = self.zhandouResult.shadowNode,
	-- 	});
	self:battleResultLogic( battletype ,resultData);

	-- --取消跳过
	-- if self.button_skip then
	-- 	self.button_skip:removeFromParent();
	-- 	self.button_skip = nil;
	-- end
end

--战斗结果逻辑
function control_zhandouui:battleResultLogic( battletype ,resultData)
	if battletype == Data_Battle.CONST_BATTLE_TYPE_ONHOOK then
		--挂机战斗
	elseif battletype == Data_Battle.CONST_BATTLE_TYPE_BOSS then
		--重新恢复挂机
		dispatchGlobaleEvent( "challengeboss" ,"over",{resultData});
	elseif battletype == Data_Battle.CONST_BATTLE_TYPE_QIYU then
		UIManager:QiyuDisplay()
		dispatchGlobaleEvent( "qiyu" ,"over");
	elseif battletype == Data_Battle.CONST_BATTLE_TYPE_JTZ then
		--军团战结束 操作
		dispatchGlobaleEvent( "juntuan" ,"over",{resultData});
	elseif battletype == Data_Battle.CONST_BATTLE_TYPE_FRIEND then
		--好友切磋结束 操作
		-- print("好友切磋结束操作CONST_BATTLE_TYPE_FRIEND")
		dispatchGlobaleEvent( "friendsfight" ,"over");
	elseif battletype == Data_Battle.CONST_BATTLE_TYPE_JJC then
		--竞技场结束 操作
		UIManager:JJCDisplay()
		-- print("竞技场战斗结束操作CONST_BATTLE_TYPE_JJC")
		dispatchGlobaleEvent( "jjc" ,"over");
	elseif battletype == Data_Battle.CONST_BATTLE_TYPE_SJBOSS then
		dispatchGlobaleEvent( "sjboss" ,"over");
	end
end

function control_zhandouui:event_exit( event )
	print("战斗结果UI",self.zhandouResult)
	if self.zhandouResult then
		self.zhandouResult:removeFromParent();
	end
	self.zhandouResult = nil;
	-- self:remove_event();
	if self.UI_CloseButton then
		self.UI_CloseButton:removeFromParent();
		self.UI_CloseButton = nil;
	end

	--关闭下场提示
	self.UI_CutView:setVisible(false);
end

--更新回合数
function control_zhandouui:event_updata_bout( event )
	local bout = event._usedata[1];
	self.info_bout:setString(bout);
end

--更新描述信息
function control_zhandouui:event_updata_info( event )
	local des = event._usedata[1];
	self.info_des:setString(des);
end

--更新下场描述
function control_zhandouui:event_updata_next_info( event )
	local des = event._usedata[1];
	local lenth = string.len(des);
	local isshow = true;
	if lenth <= 0 then
		isshow = false;
	end
	self.cutInfo:setString(des);
	self.UI_CutView:setVisible(isshow);
end

----------------------------一些逻辑事件---------------------------

--创建Ui 退出按钮
function control_zhandouui:CreateBattleUI_exit( callfun )
	self.Button_ExitLogic = callfun;
	--添加关闭ui
	self.UI_CloseButton = createViewWithCSB("ui_instance/battlefield/battle_ui_close.csb");
	-- self.info_des = self.ui_fightInfo:getChildByName("back"):getChildByName("Text_1");
	self.UI_CloseButton:setPosition(cc.p( display.width / 2 - 80, -display.height / 2 + 80));
	--添加到显示接口
	dispatchGlobaleEvent( "battleshowlayer" ,"event_addshowobject" ,{self.UI_CloseButton, 4 ,1});

	--注册事件 close
	local buttonclose = self.UI_CloseButton:getChildByName("close");
	local function exitClicked(sender)
        print("退出战斗 隐藏战斗")
        -- dispatchGlobaleEvent( "battleshowlayer" ,"event_hide" );
        self.Button_ExitLogic();
    end
    buttonclose:addClickEventListener(exitClicked)
    buttonclose:setPressedActionEnabled(true)
    return self.UI_CloseButton;
end

--关闭UI退出按钮
function control_zhandouui:CloseBattleUI_eixt(  )
	self.boss_CloseButton:removeFromParent();
end

--创建跳过按钮
function control_zhandouui:CreateBattleUI_Skip( battletype )
	if battletype == Data_Battle.CONST_BATTLE_TYPE_ONHOOK or battletype == Data_Battle.CONST_BATTLE_TYPE_BOSS then
		return;
	end

	self.button_skip = createViewWithCSB("ui_instance/battlefield/battle_ui_skip.csb");
	self.button_skip:setPosition(cc.p( 0, -display.height / 2 + 100));
	--添加到显示接口
	dispatchGlobaleEvent( "battleshowlayer" ,"event_addshowobject" ,{self.button_skip, 4 ,1});

	--注册事件 close
	local buttonskip = self.button_skip:getChildByName("skip");
	local function skipClicked(sender)
        print("跳过战斗")
        --执行结果
        
		self.button_skip:setVisible(false);
		self.button_skip:removeFromParent();
		self.button_skip = nil;
		control_Combat:setPause(true);
		control_Combat:setSkip(true);
		control_Combat:doEvent("event_fight_over");
    end
    buttonskip:addClickEventListener(skipClicked)
    buttonskip:setPressedActionEnabled(true)
end


--注册关闭事件
function control_zhandouui:remove_event(  )
	--清除事件监听
	for k,v in pairs(self.eventlisen) do
		GLOBAL_EVENT_DISPTACHER:removeEventListener(v);
	end
end

function control_zhandouui:getInstance(  )
    if control_zhandouui.instance == nil then
        control_zhandouui.instance = control_zhandouui.new()
    end
    return control_zhandouui.instance
end

Control_BattleUI= control_zhandouui.getInstance( );

return control_zhandouui;
