--
-- Author: LiYang
-- Date: 2015-06-26 17:28:09
-- 军团战斗系统

--[[发送全局事件名预览
eventModleName: onhook -- 战役接口内部控制
eventName: 
	choose_zhanyi 选择战役
	zhanyi_ctrl_choose_zhanyilevel 选择战役关卡
	zhanyi_ctrl_zhanyilevel_refresh 战役关卡刷新
]]

--[[监听全局事件名预览
eventModleName: battlefield
eventName:
	ui_initialize --战斗初始化界面
	create_result -- 创建战斗结果

]]


local control_JuntuanSystem = class("control_JuntuanSystem")

control_JuntuanSystem.CONST_STATE_INVI = "CONST_STATE_INVI";   -- 初始化

function control_JuntuanSystem:ctor()

	self.registerConfig = {
		--初始化数据
		{"juntuan","initialize",1},--挑战boss初始化
		{"juntuan","create",1},--创建挑战boss战场
		{"juntuan","over",1},--boss 挑战结束 
		{"juntuan","execute_request_msg",1},--
	}
	self:register_event();

	self.challengLevel = nil;

	--逻辑状态 0 暂停 1 执行
	self.LogicState = 0;
end

function control_JuntuanSystem:getInstance(  )
    if control_JuntuanSystem.instance == nil then
        control_JuntuanSystem.instance = control_JuntuanSystem.new()
    end
    return control_JuntuanSystem.instance
end

--注册事件
function control_JuntuanSystem:register_event(  )
	local defaultCallbacks = {
		juntuan_initialize = handler(self, self.register_event_initialize), --register_event_initialize
		juntuan_create = handler(self, self.register_event_create),
		juntuan_over = handler(self, self.register_event_over),
		juntuan_execute_request_msg = handler(self, self.register_event_execute_request_msg),
    }
    self.eventlisen = {};
	for i,v in ipairs(self.registerConfig) do
		local eventname = createGlobaleEventName( v[1], v[2] )
		print("注册事件",eventname);
		if defaultCallbacks[eventname] then
			createGlobalEventListener( v[1], v[2], defaultCallbacks[eventname], v[3] )
		end
	end

end

function control_JuntuanSystem:addExecuteEvent( eventname )
	if not eventname then
		return;
	end
	for i,v in ipairs(eventname) do
		table.insert(self.registerConfig, 1, eventname)
	end
end

--初始化数据
function control_JuntuanSystem:register_event_initialize( event )
	--逻辑状态为执行中
	self.LogicState = 1;

	dispatchGlobaleEvent( "control_JuntuanSystem" ,"initialize" );

	print("control_JuntuanSystem:register_event_initialize")
	-----------------------------创建UI----------------------------
	--创建挑战bossUi
	-- self.boss_CloseButton = createViewWithCSB("ui_instance/battlefield/battle_ui_close.csb");
	-- -- self.info_des = self.ui_fightInfo:getChildByName("back"):getChildByName("Text_1");
	-- self.boss_CloseButton:setPosition(cc.p( display.width / 2 - 80, -display.height / 2 + 80));
	-- --添加到显示接口
	-- dispatchGlobaleEvent( "battleshowlayer" ,"event_addshowobject" ,{self.boss_CloseButton, 4 ,1});

	-- --注册事件 close
	-- local buttonclose = self.boss_CloseButton:getChildByName("close");
	-- local function exitClicked(sender)
 --        print("退出战斗 隐藏战斗")
 --        dispatchGlobaleEvent( "control_JuntuanSystem" ,"exitClicked" );
 --        dispatchGlobaleEvent( "battleshowlayer" ,"event_hide" );
 --    end
 --    buttonclose:addClickEventListener(exitClicked)
 --    buttonclose:setPressedActionEnabled(true)
 	self.boss_CloseButton = Control_BattleUI:CreateBattleUI_exit( function (  )
 		dispatchGlobaleEvent( "control_JuntuanSystem" ,"exitClicked" );
 		dispatchGlobaleEvent( "battleshowlayer" ,"event_hide" );
 	end )

    self:register_event_create(  );
end


--执行 进攻城池(MSG_C2MS_MAPWAR_ATTACK) 数据请求
function control_JuntuanSystem:register_event_execute_request_msg( event )
	local sendData = event._usedata.sendData

	gameTcp:SendMessage(MSG_C2MS_MAPWAR_ATTACK, sendData)
	printNetLog("发送消息 进攻城池(MSG_C2MS_MAPWAR_ATTACK)")
end

--创建战场
function control_JuntuanSystem:register_event_create( event )
	--去除战斗暂停
	control_Combat:setPauseInfo( -1 , -1 ,-1 );
	--创建战场
	Data_Battle:setBattlefieldType( Data_Battle.CONST_BATTLE_TYPE_JTZ );--设置战斗类型
	--更新挂机数据
	Data_Battle_Msg:updateExecuteData();
    --战场切换效果
    dispatchGlobaleEvent( "battleshowlayer" ,"event_cut" ,{2});
	--执行数据
	control_Combat:doEvent("event_initialize");
    local delay_1 = cc.DelayTime:create(1);
    local callfun = cc.CallFunc:create(function (  )
        control_Combat:doEvent("event_entrance");
    end)
    self.boss_CloseButton:runAction(cc.Sequence:create(delay_1,callfun));

    GLOBAL_TOUCH_CONTROL:TounchContrlScheduler(0);
    -- dispatchGlobaleEvent("controler_mainpage_zhanyi1_layer", "zhanyi_touched")

end

--boss挑战结束
function control_JuntuanSystem:register_event_over( event )
	if self.LogicState == 0 then
		return;
	end
	print("function control_JuntuanSystem:register_event_over( event )")
	dispatchGlobaleEvent( "control_JuntuanSystem" ,"battle_over" );

	self.LogicState = 0;
	--清空ui
	-- self.boss_CloseButton:removeFromParent();
	-- self.boss_CloseButton = nil；
	--直接执行挂机
	-- dispatchGlobaleEvent( "onhook" ,"recover" );

	dispatchGlobaleEvent( "battleshowlayer" ,"event_hide" );

	local resultData = event._usedata[1];
	for k,v in pairs(resultData) do
		print(k,v)
	end
	--printNetLog(resultData)
	--boss挑战结果资料
	ManagerBattle:CreateFightResultAward( resultData )

end


--注册关闭事件
function control_JuntuanSystem:remove_event(  )
	--清除事件监听
	for k,v in pairs(self.eventlisen) do
		GLOBAL_EVENT_DISPTACHER:removeEventListener(v);
	end
end

control_JuntuanSystem= control_JuntuanSystem.getInstance( );

return control_JuntuanSystem;
