--
-- Author: LiYang
-- Date: 2015-06-26 17:28:09
-- 世界boss系统

--[[发送全局事件名预览
eventModleName: onhook -- 战役接口内部控制
eventName: 
	choose_zhanyi 选择战役
	zhanyi_ctrl_choose_zhanyilevel 选择战役关卡
	zhanyi_ctrl_zhanyilevel_refresh 战役关卡刷新
]]

--[[监听全局事件名预览
eventModleName: battlefield
eventName:
	ui_initialize --战斗初始化界面
	create_result -- 创建战斗结果

]]


local control_SJBOSSSystem = class("control_SJBOSSSystem")

control_SJBOSSSystem.CONST_STATE_INVI = "CONST_STATE_INVI";   -- 初始化

function control_SJBOSSSystem:ctor()

	self.registerConfig = {
		--初始化数据
		{"sjboss","initialize",1},--奇遇初始化
		{"sjboss","create",1},--创建奇遇战场
		{"sjboss","over",1},--奇遇结束 
		{"sjboss","execute_request_msg",1},--
	}
	self:register_event();

	--逻辑状态 0 暂停 1 执行
	self.LogicState = 0;
end

function control_SJBOSSSystem:getInstance(  )
    if control_SJBOSSSystem.instance == nil then
        control_SJBOSSSystem.instance = control_SJBOSSSystem.new()
    end
    return control_SJBOSSSystem.instance
end

--注册事件
function control_SJBOSSSystem:register_event(  )
	local defaultCallbacks = {
		sjboss_initialize = handler(self, self.register_event_initialize), --register_event_initialize
		sjboss_create = handler(self, self.register_event_create),
		sjboss_over = handler(self, self.register_event_over),
		sjboss_execute_request_msg = handler(self, self.register_event_execute_request_msg),
    }
    self.eventlisen = {};
	for i,v in ipairs(self.registerConfig) do
		local eventname = createGlobaleEventName( v[1], v[2] )
		print("注册事件",eventname);
		if defaultCallbacks[eventname] then
			createGlobalEventListener( v[1], v[2], defaultCallbacks[eventname], v[3] )
		end
	end

end

function control_SJBOSSSystem:addExecuteEvent( eventname )
	if not eventname then
		return;
	end
	for i,v in ipairs(eventname) do
		table.insert(self.registerConfig, 1, eventname)
	end
end

--初始化数据
function control_SJBOSSSystem:register_event_initialize( event )
	--逻辑状态为执行中
	self.LogicState = 1;
	
	print("control_SJBOSSSystem:register_event_initialize")
	-----------------------------创建UI----------------------------
	
 	self.boss_CloseButton = Control_BattleUI:CreateBattleUI_exit( function (  )
 		dispatchGlobaleEvent( "battleshowlayer" ,"event_hide" );
 		dispatchGlobaleEvent("sjboss_ctrl" ,"close")
 	end )

    self:register_event_create(  );

end


--执行世界boss 数据请求
function control_SJBOSSSystem:register_event_execute_request_msg( event )
	--挑战的关卡数据
	local bossid = event._usedata[1]
	local teamdex = event._usedata[2]

	print("队伍:"..teamdex)

	printInfo("网路日志 请求世界boss战斗数据 MSG_C2MS_CAMPAIGN_BOSS_BEGIN")
	gameTcp:SendMessage(MSG_C2MS_CAMPAIGN_BOSS_BEGIN,{
		bossid,
		teamdex,
		})
end

--创建战场
function control_SJBOSSSystem:register_event_create( event )
	--去除战斗暂停
	control_Combat:setPauseInfo( -1 , -1 ,-1 );
	--创建战场
	Data_Battle:setBattlefieldType( Data_Battle.CONST_BATTLE_TYPE_SJBOSS );--设置战斗类型
	--更新数据
	Data_Battle_Msg:updateExecuteData();
    --战场切换效果
    dispatchGlobaleEvent( "battleshowlayer" ,"event_cut" ,{2});
	--执行数据
	control_Combat:doEvent("event_initialize");
    local delay_1 = cc.DelayTime:create(1);
    local callfun = cc.CallFunc:create(function (  )
        control_Combat:doEvent("event_entrance");
    end)
    self.boss_CloseButton:runAction(cc.Sequence:create(delay_1,callfun));
end

--boss挑战结束
function control_SJBOSSSystem:register_event_over( event )
	if self.LogicState == 0 then
		return;
	end
	self.LogicState = 0;
	--清空ui
	-- self.boss_CloseButton:removeFromParent()
	-- self.boss_CloseButton = nil；
	--直接执行挂机
	-- dispatchGlobaleEvent( "onhook" ,"recover" )

	dispatchGlobaleEvent( "battleshowlayer" ,"event_hide" )
	dispatchGlobaleEvent("sjboss_ctrl" ,"unhide")
end


--注册关闭事件
function control_SJBOSSSystem:remove_event(  )
	--清除事件监听
	for k,v in pairs(self.eventlisen) do
		GLOBAL_EVENT_DISPTACHER:removeEventListener(v);
	end
end

control_SJBOSSSystem= control_SJBOSSSystem.getInstance( );

return control_SJBOSSSystem;
