--
-- Author: LiYang
-- Date: 2016-05-02 23:00:38
-- 控制地图移动缩放逻辑

local controler_battlefield_map_operation = class("controler_battlefield_map_operation")

function controler_battlefield_map_operation:ctor(tan)
    --注册的事件
    self.registerConfig = {
        {"BattleTouchEvent","start",2},--战场触摸事件开始
        {"BattleTouchEvent","onemove",2},--战场单点移动触摸事件
        {"BattleTouchEvent","allmove",2},--战场多点移动触摸事件
        {"BattleTouchEvent","end",1},--战场触摸事件结束
    };
    self:register_event(  );
    --操作的建筑
    self._OperationBuild = nil;

    --当前缩放值
    self._CurrentScale = 1.0;
    --当前显示位置
    self._CurrentPos = { x = 0, y = 0};
    --地图缩放范围值
    self._Scalescope = {0.7,2};
end

--[[设置逻辑参数
    pos 位置
    scale 缩放值
]]
function controler_battlefield_map_operation:setLogicInfo( params )
    -- self._CurrentPos = params.pos;
    -- self._CurrentScale = params.scale;
    --操作的建筑
    self._OperationBuild = nil;

    --当前缩放值
    self._CurrentScale = 1.0;
    --当前显示位置
    self._CurrentPos = { x = 0, y = 0};
    
    self:register_event_BattleTouchEvent_Allmove( {_usedata = {scaleV = params.scale}} )
end

function controler_battlefield_map_operation:register_event(  )

    local defaultCallbacks = {
        BattleTouchEvent_start = handler(self, self.register_event_BattleTouchEvent_start),
        BattleTouchEvent_onemove = handler(self, self.register_event_BattleTouchEvent_Onemove),
        BattleTouchEvent_allmove = handler(self, self.register_event_BattleTouchEvent_Allmove),
        BattleTouchEvent_end = handler(self, self.register_event_BattleTouchEvent_end),
    }
    self.eventlisen = {};
    for i,v in ipairs(self.registerConfig) do
        local eventname = createGlobaleEventName( v[1], v[2] )
        print("注册事件",eventname);
        if defaultCallbacks[eventname] then
            createGlobalEventListener( v[1], v[2], defaultCallbacks[eventname], v[3] )
        end
    end
end

--点击开始事件
function controler_battlefield_map_operation:register_event_BattleTouchEvent_start( event )
    print("controler_battlefield_map_operation start")
    self.startTwoParam = event._usedata[1];
    print(self.startTwoParam.pos_1.x,self.startTwoParam.pos_1.y)
end

--点击单点移动事件
function controler_battlefield_map_operation:register_event_BattleTouchEvent_Onemove( event )
    print("controler_battlefield_map_operation Onemove")
    if BattleOperation.build then
        return;
    end
    local movepos = {x = 0, y = 0};
    movepos.x = event._usedata.moveV.x / self._CurrentScale;
    movepos.y = event._usedata.moveV.y / self._CurrentScale;
    local screen_w = display.width / self._CurrentScale;
    local screen_h = display.height / self._CurrentScale;
    if movepos.x + self._CurrentPos.x - screen_w / 2 < Data_Battle.mapData.DisplayScope.left then
        movepos.x = Data_Battle.mapData.DisplayScope.left + screen_w / 2 - self._CurrentPos.x;
    elseif movepos.x + self._CurrentPos.x + screen_w / 2 > Data_Battle.mapData.DisplayScope.right then
        movepos.x = Data_Battle.mapData.DisplayScope.right - screen_w / 2 - self._CurrentPos.x;
    end

    if movepos.y + self._CurrentPos.y - screen_h / 2 < Data_Battle.mapData.DisplayScope.bottom then
        movepos.y = Data_Battle.mapData.DisplayScope.bottom + screen_h / 2 - self._CurrentPos.y;
    elseif movepos.y + self._CurrentPos.y + screen_h / 2 > Data_Battle.mapData.DisplayScope.top then
        movepos.y = Data_Battle.mapData.DisplayScope.top - screen_h / 2 - self._CurrentPos.y;
    end
    if movepos.x == 0 and movepos.y == 0 then
        return;
    end
    dispatchGlobaleEvent("battleDisplay", "move", {
        movepos
    });
    self._CurrentPos.x = self._CurrentPos.x + movepos.x;
    self._CurrentPos.y = self._CurrentPos.y + movepos.y;
    -- print("=======",self._CurrentPos.x,self._CurrentPos.y,self._CurrentScale)
end

--点击多点移动事件
function controler_battlefield_map_operation:register_event_BattleTouchEvent_Allmove( event )
    --缩放值
    local scale = event._usedata.scaleV
    --实际缩放值
    local realityScale = self._CurrentScale + scale;
    if realityScale < self._Scalescope[1] then
        realityScale = self._Scalescope[1];
    elseif realityScale > self._Scalescope[2] then
        realityScale = self._Scalescope[2];
    end
    self._CurrentScale = realityScale;
    --判断是否缩放到最小

    local movepos = {x = 0, y = 0};
    local screen_w = display.width / self._CurrentScale;
    local screen_h = display.height / self._CurrentScale;
    if movepos.x + self._CurrentPos.x - screen_w / 2 < Data_Battle.mapData.DisplayScope.left then
        movepos.x = Data_Battle.mapData.DisplayScope.left + screen_w / 2 - self._CurrentPos.x;
    elseif movepos.x + self._CurrentPos.x + screen_w / 2 > Data_Battle.mapData.DisplayScope.right then
        movepos.x = Data_Battle.mapData.DisplayScope.right - screen_w / 2 - self._CurrentPos.x;
    end

    if movepos.y + self._CurrentPos.y - screen_h / 2 < Data_Battle.mapData.DisplayScope.bottom then
        movepos.y = Data_Battle.mapData.DisplayScope.bottom + screen_h / 2 - self._CurrentPos.y;
    elseif movepos.y + self._CurrentPos.y + screen_h / 2 > Data_Battle.mapData.DisplayScope.top then
        movepos.y = Data_Battle.mapData.DisplayScope.top - screen_h / 2 - self._CurrentPos.y;
    end
    dispatchGlobaleEvent("battleDisplay", "move", {
        movepos
    });
    self._CurrentPos.x = self._CurrentPos.x + movepos.x;
    self._CurrentPos.y = self._CurrentPos.y + movepos.y;
    
    Data_Battle.mapData:setMapScale( realityScale );
    dispatchGlobaleEvent("battleDisplay", "scale", {
        realityScale
    });
end

--点击结束事件
function controler_battlefield_map_operation:register_event_BattleTouchEvent_end( event )
    -- body
end

return controler_battlefield_map_operation;
