--
-- Author: liyang
-- Date: 2016-01-02 09:37:59
-- 地图点击事件层 主要监听多点触控


local controler_battlefield_map_tounch_layer = class("controler_battlefield_map_tounch_layer")

--[[监听全局事件名预览
eventModleName: controler_battlefield_map_tounch_layer
eventName: 
    BattleTouchEvent   start  {pos_x pos_y} 地图触摸事件开始
    BattleTouchEvent   onemove 地图单点移动
    BattleTouchEvent    end 地图触摸事件结束
]]



function controler_battlefield_map_tounch_layer:ctor(mainPage_ui_layer)
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    --根层
    self._view_layer = mainPage_ui_layer
    self:_initModels()

    self:_createControlerForUI()
    --
    self:_registGlobalEventListeners()

    self:_registNodeEvent()

    self:_registUIEvent()

    self.TounchEventType = 0;
    --[[当前执行的操作类型
        0 没有执行
        1 建筑移动
        2 地图移动
    ]]
    self.CurrentExcuteType = 0;
end


function controler_battlefield_map_tounch_layer:getView()
    return self._view_layer
end


function controler_battlefield_map_tounch_layer:_initModels()
    self._controlerMap = {}
end

--创建控制器: UI
function controler_battlefield_map_tounch_layer:_createControlerForUI()

end


function controler_battlefield_map_tounch_layer:_registGlobalEventListeners()
    self._globalEventListeners = {}
    -- local configs = {
    --     {modelName = "controler_battlefield_map_tounch_layer", eventName = "setVisible", callBack=handler(self, self._onSetUIVisible)},
    --     {modelName = "controler_battlefield_map_tounch_layer", eventName = "updateImage", callBack=handler(self, self._updaeImage)},
    -- }
    -- self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end


--注册节点事件
function controler_battlefield_map_tounch_layer:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
        elseif "enterTransitionFinish" == event then
            --todo
        end
    end
    self._view_layer:registerScriptHandler(onNodeEvent)
end


--移除全局事件监听器
function controler_battlefield_map_tounch_layer:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end

--判断点是否在屏幕内
function controler_battlefield_map_tounch_layer:isPointInTopHalfAreaOfScreen(pt)
    local winSize = cc.Director:getInstance():getWinSize()
    if pt.y >= winSize.height then
        return true
    end
    
    return false
end

--判断某点是否在节点内
function controler_battlefield_map_tounch_layer:isPointInNode(pt, node)
    --转换为node坐标
    local locationInNode = node:convertToNodeSpace(pt)
    local s = node:getContentSize()
    local rect = cc.rect(0, 0, s.width, s.height)
    if cc.rectContainsPoint(rect, locationInNode) then
        return true
    end
    return false
end

function controler_battlefield_map_tounch_layer:_registUIEvent()
    
    --多点触控
    local function onTouchesBegan(touches, event)
        print("onTouchesBegan",#touches)
        local target = event:getCurrentTarget()
        
        -- local locationInNode = target:convertToNodeSpace(touch:getLocation())
        -- local s = target:getContentSize()
        -- print("locationInNode ==>",locationInNode.x,locationInNode.y,s.width,s.height);

        -- local pos = touches[1]:getLocation();
        -- CallAndroidPrint( "onTouchesBegan:"..#touches..","..pos.x..","..pos.y..",TounchEventType:"..self.TounchEventType);
        
        if self.startTwoParam then
            -- self.startTwoParam.pos_2 = touches[1]:getLocation();
            -- self.startTwoParam.dis = cc.pGetDistance(self.startTwoParam.pos_1,self.startTwoParam.pos_2);
            -- self.TounchEventType = 2;--多点触控
        else
            local mapNodePostion = target:convertToNodeSpace(touches[1]:getLocation());
            local cell_x ,cell_y = Data_Battle.mapData:getWorldToCell( mapNodePostion.x,mapNodePostion.y)

            -- local actor_x ,actor_y = control_Combat:getTestActor(  ):getCellPosByMap(  )
            -- Data_Battle.mapData.m_Astar:searchPath( {
            --         start_x = actor_x,
            --         start_y = actor_y,
            --         end_x = cell_x,
            --         end_y = cell_y
            --     } )
            print("点击地块:",cell_x ,cell_y);
            -- control_Combat:getTestActor(  ):setMoveTest( Data_Battle.mapData.m_Astar.path )
            self.startTwoParam = {};
            self.startTwoParam.beginPos = touches[1]:getLocation();
            self.startTwoParam.pos_1 = touches[1]:getLocation();
            self.startTwoParam.cell_1 = {x = cell_x ,y = cell_y};
            self.startTwoParam.beginCell = {x = cell_x ,y = cell_y};
            self.TounchEventType = 1;--单点触控
            self.startTime = os.time();
            self.IsTounchEvent = true;
            self:TouchesBeganlogic();
        end
    end

    local function onTounchesMove( touches, event )
        --得到触摸点数
        if not self.IsTounchEvent then
            return;
        end
        print("onTounchesMove")
        local target = event:getCurrentTarget()

        local tounchesNumber = table.nums(touches);
        -- CallAndroidPrint( "onTounchesMove:"..#touches);
        local touchesL_1 =  touches[1]:getLocation()
        if tounchesNumber >= 2 then
            local touchesL_2 =  touches[2]:getLocation()
            if self.TounchEventType == 1 then
                self.startTwoParam = {};
                self.startTwoParam.pos_1 = touchesL_1;
                self.startTwoParam.pos_2 = touchesL_2;
                self.startTwoParam.dis = cc.pGetDistance(self.startTwoParam.pos_1,self.startTwoParam.pos_2);
                self.TounchEventType = 2
            end
            self:TouchesAllMoveLogic( touchesL_1 ,touchesL_2 );
        else
            self:TounchesOneMoveLogic( touchesL_1 );
        end
    end

    local function onTouchesEnd(touches, event)
        
        local target = event:getCurrentTarget()
        print("onTouchesEnd:",#touches)
        local tounchL_1 = touches[1]:getLocation();
        -- CallAndroidPrint("onTouchesEnd==>"..#touches..",x = "..dd.x)
        self:TouchesAllEndLogic( tounchL_1 )
    end

    local touchAllAtOnceListener = cc.EventListenerTouchAllAtOnce:create()
    -- touchAllAtOnceListener:setSwallowTouches(true)
    touchAllAtOnceListener:registerScriptHandler(onTouchesBegan,cc.Handler.EVENT_TOUCHES_BEGAN )
    touchAllAtOnceListener:registerScriptHandler(onTounchesMove,cc.Handler.EVENT_TOUCHES_MOVED )
    touchAllAtOnceListener:registerScriptHandler(onTouchesEnd,cc.Handler.EVENT_TOUCHES_ENDED )
    
    local eventDispatcher = self._view_layer:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(touchAllAtOnceListener, self._view_layer)
    -- local size = self._view_layer:getContentSize()
    -- print("==================>",self._view_layer:getDescription(),self._view_layer:getChildrenCount(),size.height)

    -- self._view_layer:setSwallowTouches(true)
    -- print("=====",touchAllAtOnceListener:isSwallowTouches());
end

controler_battlefield_map_tounch_layer.MapHandleConfig = {
    minMoveDis = 20,--最小移动像素
    unitScale = 0.04,--单位缩放大小

}

--[[战场操作
    build
]]
BattleOperation = {};

-------------------------------------移动事件逻辑---------------------------------

--按键开始逻辑
function controler_battlefield_map_tounch_layer:TouchesBeganlogic(  )
    --判断是否能是造兵操作
    if control_Combat:executeDispatchSoldier( self.startTwoParam.cell_1.x , self.startTwoParam.cell_1.y ,true) then
        return;
    end
    --广播地图点击事件
    dispatchGlobaleEvent("BattleTouchEvent", "start", {self.startTwoParam});
end

--[[多点移动事件逻辑
]]
function controler_battlefield_map_tounch_layer:TouchesAllMoveLogic( pos_1 ,pos_2 )
    if not (self.TounchEventType == 2) then
        return;
    end
    -- CallAndroidPrint( "tounchesNumber TouchesAllMoveLogic 0")
    local dis_1 = cc.pGetDistance(self.startTwoParam.pos_1,pos_1)
    local dis_2 = cc.pGetDistance(self.startTwoParam.pos_2,pos_2)
    if dis_1 < self.MapHandleConfig.minMoveDis and dis_2 < self.MapHandleConfig.minMoveDis then
        -- CallAndroidPrint( "tounchesNumber TouchesAllMoveLogic:"..dis_1..","..dis_2)
        return;
    end

    local dis = cc.pGetDistance(pos_1,pos_2);
    local scalevaluse = (dis - self.startTwoParam.dis) / self.MapHandleConfig.minMoveDis * self.MapHandleConfig.unitScale;
    --重置初始点
    self.startTwoParam.pos_1 = pos_1;
    self.startTwoParam.pos_2 = pos_2;
    self.startTwoParam.dis = dis;
    dispatchGlobaleEvent("BattleTouchEvent", "allmove", {
        scaleV = scalevaluse
        });
    -- local issucess = MAP_DATA:updateMapScale( scalevaluse);
    -- -- CallAndroidPrint( "tounchesNumber TouchesAllMoveLogic change:"..scalevaluse..","..MAP_DATA.Map_scale)
    -- --更新缩放表现
    -- if issucess then
    --     self._operate_view:updateMapShow( nil , MAP_DATA.Map_scale , nil);
    -- else
    --     -- MAP_DATA.IsTwoTounchEvent = false;
    --     self.IsTounchEvent = false;
    --     self.TounchEventType = 0;
    --     self.startTwoParam = nil;
    -- end
end


--[[单点移动事件逻辑
]]
function controler_battlefield_map_tounch_layer:TounchesOneMoveLogic( pos_1 )
    -- CallAndroidPrint("TounchesOneMoveLogic"..self.TounchEventType)
    if not (self.TounchEventType == 1) then
        return;
    end
    -- print("TounchesOneMoveLogic move ",self.startTwoParam.pos_1.x ,self.startTwoParam.pos_1.y)
    local dis_1 = cc.pGetDistance(self.startTwoParam.pos_1,pos_1)
    if dis_1 < self.MapHandleConfig.minMoveDis then
        return;
    end
    local movepos = cc.pSub(pos_1,self.startTwoParam.pos_1);
    self.startTwoParam.pos_1 = pos_1;
    local NodePos = self._view_layer:convertToNodeSpace(pos_1);
    local cell_x ,cell_y = Data_Battle.mapData:getWorldToCell( NodePos.x , NodePos.y );
    -- print("controler_battlefield_map_tounch_layer onemove:",cell_x ,cell_y);
    --执行单点移动事件
    dispatchGlobaleEvent("BattleTouchEvent", "onemove", {
        moveV = movepos,
        pos = pos_1,
        cell_x = cell_x,
        cell_y = cell_y,
        });

    
    -- print(movepos.x,movepos.y)
    -- MAP_DATA:updateMapPostion( movepos );
    -- --设置移动点
    -- self._operate_view:updateMapShow( MAP_DATA.CurrentPos , nil , nil);
end

--[[点击结束逻辑

]]
function controler_battlefield_map_tounch_layer:TouchesAllEndLogic( endpos )
    -- CallAndroidPrint("TouchesAllEndLogic_1")
    control_Combat:executeDispatchSoldier(nil,nil,false);
    local nodepos = self._view_layer:convertToNodeSpace(endpos);
    -- print(endpos.x , endpos.y,jj.x,jj.y)
    local cell_x ,cell_y = Data_Battle.mapData:getWorldToCell(nodepos.x , nodepos.y);
    print("controler_battlefield_map_tounch_layer end:",cell_x ,cell_y);
    dispatchGlobaleEvent("BattleTouchEvent", "end", {
        pos = endpos,
        cell_x = cell_x,
        cell_y = cell_y
    });
    
    -- MAP_DATA.IsTwoTounchEvent = false;
    self.IsTounchEvent = false;
    self.TounchEventType = 0;
    self.startTwoParam = nil;
    -- CallAndroidPrint("TouchesAllEndLogic"..self.TounchEventType)
end


function controler_battlefield_map_tounch_layer:_onSetUIVisible( event )
    local eventUseData = event._usedata
    local visibleType = eventUseData.visibleType

    --隐藏所有
    if visibleType == "hideAll" then
        self._view_layer:setVisible(false)

    --显示所有
    elseif visibleType == "showAll" then
        self._view_layer:setVisible(true)
    end
    
end


return controler_battlefield_map_tounch_layer
