--
-- Author: liyang
-- Date: 2015-06-11 14:56:30
-- 战斗底部UI


local UI_BattleOnhook_Bottom = class("UI_BattleOnhook_Bottom", cc.load("mvc").ViewBase)

UI_BattleOnhook_Bottom.RESOURCE_FILENAME = "ui_instance/battlefield/battle_ui_bottom.csb"

local class_levelitem = import(".UI_OnhookLevel_item")

function UI_BattleOnhook_Bottom:onCreate()
    
    --战役列表
    self.rootNode = self.resourceNode_:getChildByName("main_layout");

    --关卡节点 
    self.LevelListNode = self.rootNode:getChildByName("levellistnode");

    --boss挑战信息显示
    self.Info_challenge = self.LevelListNode:getChildByName("main_layout"):getChildByName("bossinfo"):getChildByName("bossvaluse");

    --更新时间
    -- self.Info_challengeChangeTime = self.LevelListNode:getChildByName("main_layout"):getChildByName("revertinfo"):getChildByName("valuse");

    --关卡列表
    self.LevelList = self.LevelListNode:getChildByName("main_layout"):getChildByName("level_list");

    --滑动框
    self.levelslider = self.LevelListNode:getChildByName("level_slider");
    self.levelslider:setPercent(10);

    --item 范本
    self.levelItem = self.LevelList:getChildByName("levelitem");

    self.innerWidth = self.LevelList:getContentSize().width;
    self.innerHeight = self.LevelList:getContentSize().height;

    self.itemunit_w = self.levelItem:getContentSize().width;
    self.itemunit_h = self.levelItem:getContentSize().height;

    self.current_x = 0;
    self.current_y = 0;

    self.interval = 10;

    self.unitPercent = 1;

    self.Info_win = self.rootNode:getChildByName("info"):getChildByName("text");
    
    self.levelItem:removeFromParent();
    -- self:refreshView();
    self:registerEvent();

    local function onNodeEvent(event)
            if "enter" == event then
                -- print("onNodeEvent:","enter");
            elseif "exit" == event then
                -- print("onNodeEvent:","exit");
            elseif "cleanup" == event then

            elseif "enterTransitionFinish" == event then
                self:updateGuidePos();
            end
        end
    self.resourceNode_:registerScriptHandler(onNodeEvent)
end

--设置开场动画 和 
function UI_BattleOnhook_Bottom:openAnimationEffect(  )
    
end

--注册事件
function UI_BattleOnhook_Bottom:registerEvent(  )
    --战斗关闭
    local battleOnhookClose = self.rootNode:getChildByName("close")
    local function exitClicked(sender)
        print("退出挂机")
        AudioManager.playButton();
        dispatchGlobaleEvent( "newbieguide","reaction" ,{"战斗","onhookbutton_exit"});
        dispatchGlobaleEvent( "onhook" ,"closeonhook");
        
       
    end
    battleOnhookClose:addClickEventListener(exitClicked)
    battleOnhookClose:setPressedActionEnabled(true)

    --战斗信息
    local battleOnhook_info = self.rootNode:getChildByName("info")
    local function infoClicked(sender)
        print("挂机信息点击")
        AudioManager.playButton();
        dispatchGlobaleEvent( "onhook" ,"create_info");
    end
    battleOnhook_info:addClickEventListener(infoClicked)
    battleOnhook_info:setPressedActionEnabled(true)

    --快速战斗
    local battleOnhook_quickcombat = self.rootNode:getChildByName("quickcombat")
    local function quickcombatClicked(sender)
        print("挂机 快速战斗")
        AudioManager.playButton();
        dispatchGlobaleEvent( "newbieguide","reaction" ,{"战斗","onhookbutton_qucikfight"});
        dispatchGlobaleEvent( "onhook" ,"create_quickcombat");
    end
    battleOnhook_quickcombat:addClickEventListener(quickcombatClicked)
    battleOnhook_quickcombat:setPressedActionEnabled(true)

    --装备出售
    -- local battleOnhook_sell = self.rootNode:getChildByName("sell")
    -- local function sellClicked(sender)
    --     print("挂机 快速战斗")
    --     dispatchGlobaleEvent( "onhook" ,"create_sell");
    -- end
    -- battleOnhook_sell:addClickEventListener(sellClicked)

    --关卡信息
    local battleOnhook_level = self.rootNode:getChildByName("level")
    local function levelClicked(sender)
        print("挂机 关卡信息");
        AudioManager.playButton();
        dispatchGlobaleEvent( "newbieguide","reaction" ,{"战斗","onhookbutton_levellist"});
        dispatchGlobaleEvent( "onhook" ,"ui_operation_level");
    end
    battleOnhook_level:addClickEventListener(levelClicked)
    battleOnhook_level:setPressedActionEnabled(true)

    --注册滑动框
    local function sliderEvent(sender,eventType)
        if eventType == ccui.SliderEventType.percentChanged then
            local slider = sender
            local percent = slider:getPercent();
            print(percent);
            self.LevelList:jumpToPercentHorizontal(percent);
            -- self._displayValueLabel:setString(percent)
        end
    end
    self.levelslider:addEventListener(sliderEvent)
    -- local delay_1 = cc.DelayTime:create(1);
    -- local callfun = cc.CallFunc:create(function (  )
    --     self:setRevertTime( Data_Battle_Onhook:getRevertTimeDes(  ) );
    --     self:setBossChallenge( Data_Battle_Onhook:getCurEnergy() )
    -- end)
    -- local action = cc.Sequence:create(delay_1,callfun);
    -- self.Info_challengeChangeTime:runAction(cc.RepeatForever:create(action));
    --注册接口更新
    -- createGlobalEventListener( "zhanyilevel_ctrl", "refresh", handler(self, self.refreshView), 1 )
end

--添加关卡列表
function UI_BattleOnhook_Bottom:addLevelItem( data )

    local levelitem = class_levelitem.new();
    if data then
        levelitem:UpdateShowData( data );
    end
    levelitem:setPosition(cc.p(self.current_x,self.current_y));
    levelitem:setTag(data.Key);
    self.LevelList:addChild(levelitem);
    
    self.current_x = self.current_x + self.itemunit_w + self.interval;
    return levelitem;
end

--重置关卡列表显示信息
function UI_BattleOnhook_Bottom:resetLevelListShowInfo( onhookitem , mark)
    self.Container_w = self.current_x - self.interval;
     if self.Container_w < self.innerWidth then
        self.Container_w = self.innerWidth;
    end
    self.LevelList:setInnerContainerSize(cc.size(self.Container_w, self.innerHeight));
    -- self.LevelList:jumpToLeft();

    self.levelSlider_w = 1240;

    self.unitPercent = self.Container_w / self.levelSlider_w;
    if mark == "start" then
        print("挂机关卡",onhookitem:getTag())
        self:jumpToOnhookLevel( onhookitem );
    elseif mark == "add" then
        self.LevelList:jumpToRight();
    end
    
end

--设置关卡显示的百分比
function UI_BattleOnhook_Bottom:setShowLevelPercent( percent )
    self.levelslider:setPercent(percent);
    self.LevelList:jumpToPercentHorizontal(percent);
end

--跳转到挂机关卡
function UI_BattleOnhook_Bottom:jumpToOnhookLevel( item )
    local x = item:getPositionX() + item.width;
    local percent = x / self.Container_w * 100;
    if percent > 100 then
        percent = 100;
    elseif percent < 0 then
        percent = 0;
    end
    print("jumpToOnhookLevel",percent,x,self.Container_w)
    self:setShowLevelPercent( percent );
end

--设置胜率
function UI_BattleOnhook_Bottom:setWinFficiency( valuse )
    self.Info_win:setString("胜率"..valuse.."%");
end

--设置boss挑战次数
function UI_BattleOnhook_Bottom:setBossChallenge( valuse )
    self.Info_challenge:setString(valuse);
end

--设置恢复时间
function UI_BattleOnhook_Bottom:setRevertTime( valuse )
   
    -- self.Info_challengeChangeTime:setString(valuse)
end

--隐藏关卡列表
function UI_BattleOnhook_Bottom:Effect_HideLevelList(  )
    local action = createActionWithCSB( self.RESOURCE_FILENAME );
    self.rootNode:runAction(action);
    action:play( "levelhide" ,false);
end

--显示关卡列表
function UI_BattleOnhook_Bottom:Effect_ShowLevelList(  )
    local action = createActionWithCSB( self.RESOURCE_FILENAME );
    self.rootNode:runAction(action);
    local function onFrameEvent(frame)
        
        if nil == frame then
            return
        end

        local str = frame:getEvent()
        if str == "finish" then
            self:updateGuidePos();
            dispatchGlobaleEvent( "newbieguide","reaction" ,{"战斗","onhookbutton_levellist_show"});
        end
    end
    action:setFrameEventCallFunc(onFrameEvent)
    action:play( "levelshow" ,false);
end

function UI_BattleOnhook_Bottom:exit()
    self:removeFromParent();
end

--更新引导坐标
function UI_BattleOnhook_Bottom:updateGuidePos()
    --关卡列表
    local pos = self.rootNode:getChildByName("level"):convertToWorldSpace(cc.p(60,60));
    NewbieGuideManager:SetNewbieGuideConfigByPos( "onhook_button_levellist" ,{
            pos_x = pos.x,
            pos_y = pos.y,
            w = 120;
            h = 120;
        } );
    pos = self.rootNode:getChildByName("quickcombat"):convertToWorldSpace(cc.p(60,60));
    NewbieGuideManager:SetNewbieGuideConfigByPos( "onhook_button_quickcombat" ,{
            pos_x = pos.x,
            pos_y = pos.y,
            w = 120;
            h = 120;
        } );
    pos = self.rootNode:getChildByName("close"):convertToWorldSpace(cc.p(60,60));
    NewbieGuideManager:SetNewbieGuideConfigByPos( "onhook_button_exit" ,{
            pos_x = pos.x,
            pos_y = pos.y,
            w = 120;
            h = 120;
        } );
    --第一关挑战boss按钮 getGuidePos(params)
    local view = self.LevelList:getChildByTag(1);
    if view then
        pos = view:getGuidePos("challenge");
        NewbieGuideManager:SetNewbieGuideConfigByPos( "onhook_level1_challenge" ,{
                pos_x = pos.x + 74,
                pos_y = pos.y + 21,
                w = 148;
                h = 43;
            } );
        --第一关 过关宝箱位置
        pos = view:getGuidePos("baoxiang");
        NewbieGuideManager:SetNewbieGuideConfigByPos( "onhook_level1_baoxiang" ,{
                pos_x = pos.x,
                pos_y = pos.y,
                w = 80;
                h = 80;
            } );

    end
    --第二关挂机关卡 
    local view = self.LevelList:getChildByTag(2);
    if view then
        pos = view:getGuidePos("onhook");
        NewbieGuideManager:SetNewbieGuideConfigByPos( "onhook_level2_onhook" ,{
                pos_x = pos.x + 74,
                pos_y = pos.y + 21,
                w = 148;
                h = 43;
            } );
    end
    
end

return UI_BattleOnhook_Bottom


