--
-- Author: liyang
-- Date: 2015-06-11 14:56:30
-- 建筑选择item


local UI_build_choose_item = class("UI_build_choose_item", cc.load("mvc").ViewBase)

UI_build_choose_item.RESOURCE_FILENAME = "ui_instance/battlefield/build_choose_item.csb"
function UI_build_choose_item:onCreate()

    self.width = self.resourceNode_:getContentSize().width;
    self.height = self.resourceNode_:getContentSize().height;

    self:registerEvent();

    self.buildData = nil;
end

--注册事件
function UI_build_choose_item:registerEvent(  )
    
    local function touchEvent(sender,eventType)
        if eventType == ccui.TouchEventType.began then
            local beginpos = sender:getTouchBeganPosition()
            self.chooseEffect:setVisible(true);
            print("  begin:",beginpos.x,beginpos.y)
        elseif eventType == ccui.TouchEventType.moved then
            local movepos = sender:convertToNodeSpace(sender:getTouchMovePosition());
            -- print(movepos.x , movepos.y ,sender:getBoundingBox())
            if self.IsTounchEvent then
                self:TounchesOneMoveLogic( sender:getTouchMovePosition() );
                return;
            end

            if not cc.rectContainsPoint(sender:getBoundingBox(),movepos) then
                self:executeAddBuild( sender:getTouchMovePosition() );
            end
        elseif eventType == ccui.TouchEventType.ended then
            print("end")
            self:TouchesAllEndLogic(  sender:getTouchEndPosition() )
        elseif eventType == ccui.TouchEventType.canceled then
            print("canceled")
            self:TouchesAllEndLogic(  sender:getTouchEndPosition() )
        end
    end
    local buildbtn = self.resourceNode_:getChildByName("btn_build_item")
    buildbtn:addTouchEventListener(touchEvent);

    self.chooseEffect = buildbtn:getChildByName("chooseeffect")
    self.chooseEffect:setVisible(false);
end

--执行添加建筑
function UI_build_choose_item:executeAddBuild( pos )
    --判断当前是否在执行添加建筑
    if BuildManager.addNewsBuildData then
        return;
    end
    --得到相对于地图坐标
    local mapNodePostion = battleDisplayManager.mapview:convertToNodeSpace(pos);
    local cell_x ,cell_y = Data_Battle.mapData:getWorldToCell( mapNodePostion.x,mapNodePostion.y)
    print("点击地块:",cell_x ,cell_y,self.buildData.buildTempleID);
    self.startTwoParam = {};
    self.startTwoParam.beginPos = pos;
    self.startTwoParam.pos_1 = pos;
    self.startTwoParam.cell_1 = {x = cell_x ,y = cell_y};
    self.startTwoParam.beginCell = {x = cell_x ,y = cell_y};
    self.TounchEventType = 1;--单点触控
    self.startTime = os.time();
    self.IsTounchEvent = true;
    --设置新建筑
    BuildManager:setAddNewsBuild( {
        guid = "planbuild",
        templeateId = self.buildData.index,
        pos_x = cell_x,
        pos_y = cell_y,
        hp = 100
    } )
    --创建显示
    dispatchGlobaleEvent("battlefield", "add_build" ,{ {guid = "planbuild"}});
    --添加建筑移动事件
    dispatchGlobaleEvent("BuildCreateTounchEvent", "start",{
        self.startTwoParam
        });
end


UI_build_choose_item.MapHandleConfig = {
    minMoveDis = 20,--最小移动像素
    unitScale = 0.04,--单位缩放大小

}
--[[单点移动事件逻辑
]]
function UI_build_choose_item:TounchesOneMoveLogic( pos_1 )

    local dis_1 = cc.pGetDistance(self.startTwoParam.pos_1,pos_1)
    if dis_1 < self.MapHandleConfig.minMoveDis then
        return;
    end
    local movepos = cc.pSub(pos_1,self.startTwoParam.pos_1);
    self.startTwoParam.pos_1 = pos_1;
    local NodePos = battleDisplayManager.mapview:convertToNodeSpace(pos_1);
    local cell_x ,cell_y = Data_Battle.mapData:getWorldToCell( NodePos.x , NodePos.y );
    print("controler_battlefield_map_tounch_layer onemove:",cell_x ,cell_y);
    --执行单点移动事件
    dispatchGlobaleEvent("BuildCreateTounchEvent", "move", {
        moveV = movepos,
        pos = pos_1,
        cell_x = cell_x,
        cell_y = cell_y,
        });

    
end

--[[点击结束逻辑

]]
function UI_build_choose_item:TouchesAllEndLogic( endpos )
    -- CallAndroidPrint("TouchesAllEndLogic_1")
    if not self.IsTounchEvent then
        return;
    end
    local nodepos = battleDisplayManager.mapview:convertToNodeSpace(endpos);
    -- print(endpos.x , endpos.y,jj.x,jj.y)
    local cell_x ,cell_y = Data_Battle.mapData:getWorldToCell(nodepos.x , nodepos.y);
    print("controler_battlefield_map_tounch_layer end:",cell_x ,cell_y);
    -- dispatchGlobaleEvent("BuildCreateTounchEvent", "end", {
    --     pos = endpos,
    --     cell_x = cell_x,
    --     cell_y = cell_y
    -- });

    --发送创建建筑
    --     string  公会key
    -- *   int     地块x坐标
    -- *   int     地块y坐标
    -- *   int     放置点x坐标
    -- *   int     放置点y坐标
    -- *   int     庇护所索引
    --判断此处 是否能放置建筑
    BuildManager.addNewsBuildData.view:checkBuildMoveState(  );
    --[[判断是否能放置塔
        1.如果为公会建筑 不能放2个
        2.如果
    ]]
    if BuildManager.addNewsBuildData.view._MoveBuildState == 1 then
        BuildManager:sendBuildAddMsg( {
            templeID = self.buildData.index,
            guid = MAIN_PLAYER.guild:getGUID(),
            plot_x = Data_Battle.plot_x,
            plot_y = Data_Battle.plot_y,
            cell_x = BuildManager.addNewsBuildData.view.cell_x,
            cell_y = BuildManager.addNewsBuildData.view.cell_y,
            index = self.buildData.guild
        } );
        dispatchGlobaleEvent("BuildCreate", "over", {0});
    else
        --此处不能放置建筑
        UIManager:CreatePrompt_Bar( {
                content = "此处不能放置建筑!"
            } )
        dispatchGlobaleEvent("BuildCreate", "over", {0});
    end
    
    
    self.IsTounchEvent = false;
    self.startTwoParam = nil;
    self.chooseEffect:setVisible(false);
end

function UI_build_choose_item:setBuildData( builddata )
    self.buildData = builddata;
    self:refresh(  );
end

function UI_build_choose_item:refresh(  )
   local buildicon = self.resourceNode_:getChildByName("btn_build_item"):getChildByName("buildicon")
   print("refresh:",self.buildData.resID)
   local iconInfo = ResIDConfig:getResConfifByID( self.buildData.resID )
   buildicon:loadTexture(iconInfo.smelliconImage, ccui.TextureResType.plistType);
   --local des = self.resourceNode_:getChildByName("btn_build_item"):getChildByName("des_bag"):getChildByName("text")
end

return UI_build_choose_item


