--
-- Author: liyang
-- Date: 2016-01-02 09:37:59
-- 战斗进攻UI

-- 主页UI层里面的几个分支类实例
local class_controler_ui_left_bottom = require("app.views.battlefield.ui.controler_battle_ui_attack_bottom.lua")
local class_controler_ui_top = require("app.views.battlefield.ui.controler_battle_ui_attack_top.lua")

---=============================================================-----------------
-- 整个主页UI的管理类
local controler_battle_ui_attack = class("controler_battle_ui_attack")

--[[监听全局事件名预览
eventModleName: controler_battle_ui_attack
eventName: 
    setUIVisible     --设置显示状态

]]


function controler_battle_ui_attack:ctor()
    self:_initModels()

    local visibleSize = cc.Director:getInstance():getVisibleSize()
    --根层
    -- self._mainPage_ui_layer = mainPage_ui_layer
    -- self._mainPage_ui_layer:setContentSize(visibleSize)
    -- ccui.Helper:doLayout(self._mainPage_ui_layer)

    --UI容器

    self:_createControlerForUI()

    --
    self:_registGlobalEventListeners()

    self:_registNodeEvent()

    self:_registUIEvent()
end


function controler_battle_ui_attack:getView()
    return self._mainPage_ui_layer
end


function controler_battle_ui_attack:_initModels()
    self._controlerMap = {}
end

--创建控制器: UI
function controler_battle_ui_attack:_createControlerForUI()
    --UI左下部分控制器
    self._controlerMap.parts_left_bottom = class_controler_ui_left_bottom.new(
        self:LoadBottomView()
    )

    --ui右上部分控制器
    self._controlerMap.parts_top = class_controler_ui_top.new(
        self:LoadTopView()
    )
end


function controler_battle_ui_attack:_registGlobalEventListeners()
    self._globalEventListeners = {}
    local configs = {
        {modelName = "controler_battle_ui_attack", eventName = "setUIVisible", callBack=handler(self, self._onSetUIVisible)},
        -- {modelName = "netMsg", eventName = tostring(MSG_MS2C_INTERACT_ADD), callBack=handler(self, self.addNotifyAni)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end

--注册节点事件
function controler_battle_ui_attack:_registNodeEvent()
    -- local function onNodeEvent(event)
    --     if "exit" == event then
    --         self:_removeAllGlobalEventListeners()
    --     end
    -- end
    -- self._mainPage_ui_layer:registerScriptHandler(onNodeEvent)
end


--移除全局事件监听器
function controler_battle_ui_attack:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end

function controler_battle_ui_attack:_registUIEvent()
    -- local btn_shuaguai = self._mainPage_ui_layer:getChildByName("parts_r_b"):getChildByName("btn_shuaguai")
    -- local shuaguaiClick = function (  )
    --     -- if false==self._controlerMap.mapinfoListLayer:getVisible() then
    --         -- self._controlerMap.mapinfoListLayer:getView():setVisible(true);
    --     -- end
    -- end
    -- btn_shuaguai:addClickEventListener(shuaguaiClick)
end


function controler_battle_ui_attack:_onSetUIVisible( event )
    local eventUseData = event._usedata
    local visibleType = eventUseData.visibleType

    --隐藏所有
    if visibleType == "hideAll" then
        -- self._mainPage_ui_layer:setVisible(false)

    --显示所有
    elseif visibleType == "showAll" then
        -- self._mainPage_ui_layer:setVisible(true)
    end
    
end


-- 加载UI
function controler_battle_ui_attack:LoadBottomView()
    return cc.CSLoader:createNode("ui_instance/battlefield/battleUI_1_bottom.csb")
end

function controler_battle_ui_attack:LoadTopView()
    return cc.CSLoader:createNode("ui_instance/battlefield/battleUI_1_top.csb")
end

return controler_battle_ui_attack
