--
-- Author: liyang
-- Date: 2016-01-05 10:37:59
-- 进攻UI 底部

local class_player_item = require("app.views.battlefield.ui.UI_player_item.lua")

local controler_battle_ui_attack_bottom = class("controler_battle_ui_attack_bottom")

--[[监听全局事件名预览
eventModleName: controler_battle_ui_attack_bottom
eventName: 
    setUIVisible     --设置显示状态

]]


function controler_battle_ui_attack_bottom:ctor(mainPage_ui_layer)
    self:_initModels()

    --根层
    self._view_node = mainPage_ui_layer
    local visibleSize = self._view_node:getContentSize();
    local screenSize = cc.Director:getInstance():getVisibleSize()
    self._view_node:setPosition(cc.p(-visibleSize.width / 2 ,-screenSize.height / 2))
    dispatchGlobaleEvent( "battleDisplay" ,"add" ,{self._view_node, 4 ,0});
    -- self._mainPage_ui_layer:setContentSize(visibleSize)
    -- ccui.Helper:doLayout(self._mainPage_ui_layer)

    self:_createControlerForUI()
    --
    self:_registGlobalEventListeners()

    self:_registNodeEvent()

    self:_registUIEvent()
end


function controler_battle_ui_attack_bottom:getView()
    return self._view_node
end


function controler_battle_ui_attack_bottom:_initModels()
    self._controlerMap = {}

    self.itemModel_player = cc.CSLoader:createNode("ui_instance/battlefield/attack_player_item.csb")
    self.itemModel_player:retain()

end

--创建控制器: UI
function controler_battle_ui_attack_bottom:_createControlerForUI()
    
end


function controler_battle_ui_attack_bottom:_registGlobalEventListeners()
    self._globalEventListeners = {}
    local configs = {
        {modelName = "controler_battle_ui_attack_bottom", eventName = "setUIVisible", callBack=handler(self, self._onSetUIVisible)},
        {modelName = "controler_battle_ui_attack_bottom", eventName = "update_soldier", callBack=handler(self, self.refreshSoldierList)},
        {modelName = "controler_battle_ui_attack_bottom", eventName = "update_player", callBack=handler(self, self.refreshPlayerList)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end




--注册节点事件
function controler_battle_ui_attack_bottom:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then

            self:_removeAllGlobalEventListeners()
        end
    end
    self._view_node:registerScriptHandler(onNodeEvent)

end


--移除全局事件监听器
function controler_battle_ui_attack_bottom:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
    self.itemModel_player:release()
end

function controler_battle_ui_attack_bottom:_registUIEvent()
    self._CurrentScale = 1;
    -- 设置按钮对象
    local btn_exit = self._view_node:getChildByName("btn_exit")
    local exitClick = function (  )
        print("退出")
        --发送退出战斗消息
        -- self._CurrentScale = self._CurrentScale + 0.1;
        -- -- Data_Battle.mapData:setMapScale( self._CurrentScale );
        -- dispatchGlobaleEvent("BattleTouchEvent", "allmove", {
        --     scaleV = 0.1
        -- });
        AudioManager.playButton();
        dispatchGlobaleEvent( "battlefield" ,"end");
    end
    -- 添加事件监听函数
    btn_exit:addClickEventListener(exitClick)
    ---------------加速相关--------------
    self.currentChooseSpeed = 1;--当前速度
    self.speedScope = { 1,2,4};--速度范围
    self.unitAddSpeed = 0.2;
    --加速按钮
    self.btn_speed = self._view_node:getChildByName("speedUp")
    local speedClick = function (  )
        print("点击加速按钮")
        AudioManager.playButton();
        self.currentChooseSpeed = self.currentChooseSpeed + 1;
        if self.currentChooseSpeed < 1 then
            self.currentChooseSpeed = #self.speedScope;
        elseif self.currentChooseSpeed > #self.speedScope then
            self.currentChooseSpeed = 1;
        end
        GLOBAL_SCHEDULER:setTimeScale(self.speedScope[self.currentChooseSpeed]);
        self.btn_speed:setTitleText("X"..self.speedScope[self.currentChooseSpeed])
    end
    self.btn_speed:addClickEventListener(speedClick);

    if Data_Battle:getBattlefieldType() == Data_Battle.CONST_BATTLE_TYPE_VCR then
        self.btn_speed:setVisible(true);
    else
        self.btn_speed:setVisible(false);
        local choosePool = self._view_node:getChildByName("chooseIconList")
        choosePool:removeAllChildren();
        --得到兵种数据
        local solderList = MAIN_PLAYER:getsolderManager()._solder;
        self.displayData = {};
        for k,v in pairs(solderList) do
            self.displayData[k] = v;
        end
        print("controler_battle_ui_attack_bottom:",#self.displayData)
        local index = 1;
        self.ChooseViewList = {};
        for k,v in ipairs(self.displayData) do
            print(k,v[2])
            local item = self:createHeroItem( {
                templeID = v[1],--模板ID
                num = v[2],-- 数量
                mark = v[1],--标识
                } )
            choosePool:addChild(item);
            item:setPosition(cc.p(100 * (index - 1),0));
            item:registerClickEvent( handler(self, self.registerItemClickChooseEvent) )
            self.ChooseViewList[k] = item;
            index = index + 1;
        end
    end

    --添加显示参与人员信息
    self.actPlayerView = self._view_node:getChildByName("playerList")
    self.PlayItems = {};
    for i,v in pairs(Data_Battle_Msg.teamList) do
        self.PlayItems[i] = self:createPlayerItem(v);
        self.actPlayerView:pushBackCustomItem(self.PlayItems[i]:getResourceNode())
    end
end

--[[
    刷新修建列表
]]
function controler_battle_ui_attack_bottom:refreshSoldierList( event )
    local index = event._usedata[1];
    for i,v in ipairs(self.displayData) do
        if v[1] == index then
            self.ChooseViewList[i]:setData(  {
                templeID = self.displayData[i][1],--模板ID
                num = self.displayData[i][2],-- 数量
                mark = self.displayData[i][1],--标识
                }  );
            return;
        end
    end
    -- self.displayData[index][2] = self.displayData[index][2] - 1;
    -- if self.ChooseViewList[index] then
    --     self.ChooseViewList[index]:setData(  {
    --         templeID = self.displayData[index][1],--模板ID
    --         num = self.displayData[index][2],-- 数量
    --         mark = self.displayData[index][1],--标识
    --         }  );
    -- end
end

--[[
    刷新玩家列表
]]
function controler_battle_ui_attack_bottom:refreshPlayerList( event )
    local data = event._usedata;
    if self.PlayItems[data.name] then
        self.PlayItems[data.name]:refresh();
    else
        local item = self:createPlayerItem(data);
        self.actPlayerView:pushBackCustomItem(item:getResourceNode());
        self.PlayItems[data.name] = item;
    end
    
end

--[[注册点击选择事件

]]
function controler_battle_ui_attack_bottom:registerItemClickChooseEvent( mark )
    print("====>",mark)
    AudioManager.playButton();
    for k,v in pairs(self.ChooseViewList) do
        if v.mark == mark then
            if self.chooseView == v then
                v:setChooseEffect( false );
                self.chooseView = nil;
            else
                v:setChooseEffect( true );
                self.chooseView = v;
            end
           
        else
            v:setChooseEffect( false );
        end
    end
    --设置选择的兵种
    local chooseSoldierTemplate = nil;
    if self.chooseView then
        chooseSoldierTemplate = self.chooseView.heroData.templeID
    end
    control_Combat:setAttackSolderInfo( chooseSoldierTemplate );
end

--[[创建放置士兵item
    data = {
        templeID = 1,模板ID
        num 数量
        buildType = 1,
    }
]]
function controler_battle_ui_attack_bottom:createHeroItem( data )
    local item = require("app.views.battlefield.ui.UI_hero_choose_item.lua").new();
    -- local showData = GetBuildCfgByLevel( data.buildtype ,data.level );
    item:setData( data );
    return item;
end

function controler_battle_ui_attack_bottom:createPlayerItem( data )
    local item = class_player_item.new(
            self.itemModel_player:getChildByName("player_item_info"):clone()
        );
    -- local showData = GetBuildCfgByLevel( data.buildtype ,data.level );
    item:setData( data );
    return item;
end


function controler_battle_ui_attack_bottom:_onSetUIVisible( event )
    local eventUseData = event._usedata
    local visibleType = eventUseData.visibleType

    --隐藏所有
    if visibleType == "hideAll" then
        self._mainPage_ui_layer:setVisible(false)

    --显示所有
    elseif visibleType == "showAll" then
        self._mainPage_ui_layer:setVisible(true)
    end
end


return controler_battle_ui_attack_bottom
