--
-- Author: liyang
-- Date: 2016-01-05 10:37:59
-- 地图建筑UI左下


local controler_battle_ui_attack_top = class("controler_battle_ui_attack_top")

--[[监听全局事件名预览
eventModleName: controler_battle_ui_attack_top
eventName: 
    setUIVisible     --设置显示状态

]]


function controler_battle_ui_attack_top:ctor(mainPage_ui_layer)
    self:_initModels()

    --根层
    self._view_node = mainPage_ui_layer
    local visibleSize = self._view_node:getContentSize();
    local screenSize = cc.Director:getInstance():getVisibleSize()
    self._view_node:setPosition(cc.p(-visibleSize.width / 2 ,screenSize.height / 2 - visibleSize.height))
    dispatchGlobaleEvent( "battleDisplay" ,"add" ,{self._view_node, 4 ,0});
    -- self._mainPage_ui_layer:setContentSize(visibleSize)
    -- ccui.Helper:doLayout(self._mainPage_ui_layer)

    self:_createControlerForUI()
    --
    self:_registGlobalEventListeners()

    self:_registNodeEvent()

    self:_registUIEvent()

    self.speedValuse = 1;
end


function controler_battle_ui_attack_top:getView()
    return self._view_node
end


function controler_battle_ui_attack_top:_initModels()
    self._controlerMap = {}
end

--创建控制器: UI
function controler_battle_ui_attack_top:_createControlerForUI()
    self.ziyuanView = self._view_node:getChildByName("ziyuan")
    self.ziyuanValuse = self.ziyuanView:getChildByName("valuse")
    if Data_Battle:getBattlefieldType() == Data_Battle.CONST_BATTLE_TYPE_ROB then
        --掠夺战
        self.ziyuanView:setVisible(true);
    else
        self.ziyuanView:setVisible(false);
    end
end


function controler_battle_ui_attack_top:_registGlobalEventListeners()
    self._globalEventListeners = {}
    local configs = {
        {modelName = "controler_battle_ui_attack_top", eventName = "setUIVisible", callBack=handler(self, self._onSetUIVisible)},
        {modelName = "battle_ui_time", eventName = "update", callBack=handler(self, self._onSetTimeUpdate)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end




--注册节点事件
function controler_battle_ui_attack_top:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
            
        end
    end
    self._view_node:registerScriptHandler(onNodeEvent)

end


--移除全局事件监听器
function controler_battle_ui_attack_top:_removeAllGlobalEventListeners()
    
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end

    if self.do_Scheduler then
        GLOBAL_SCHEDULER:unscheduleScriptEntry(self.do_Scheduler);
    end
end

function controler_battle_ui_attack_top:_registUIEvent()

    -- 设置按钮对象
    self.textTime = self._view_node:getChildByName("time")
    self.textDes = self._view_node:getChildByName("Text_1")

end

--[[
    更新时间显示
]]
function controler_battle_ui_attack_top:updataTimeDisplay( time )
    if Data_Battle_Msg.startActTime < 0 then
        
        return;
    end

    if Data_Battle:getBattlefieldType() == Data_Battle.CONST_BATTLE_TYPE_VCR then
        self.disTime = self.disTime - time;
    else
        --获得进行了多少时间
        self.disTime = math.floor(Data_Battle_Msg:getBattlefieldSurplusTime()) * self.speedValuse;
    end
    print("updataTimeDisplay:",self.disTime,self.speedValuse,GLOBAL_SCHEDULER:getTimeScale())
    -- print(self.disTime)
    if self.disTime <= 0 then
        GLOBAL_SCHEDULER:unscheduleScriptEntry(self.do_Scheduler);
        self.do_Scheduler = nil;
        self.disTime = 0;
    end

    local disData = TIME_HELPER:secondToTime_2( self.disTime )
    self.textTime:setString(string.format("%02d%s%02d", disData.min, ".", disData.sec));
    if self.ziyuanView:isVisible() then
        self.ziyuanValuse:setString(Data_Battle_Msg.resourceSurplusValuse.."/"..Data_Battle_Msg.resourceSumValuse);
    end
    
end

function controler_battle_ui_attack_top:_onSetTimeUpdate( event )
    self.disTime = event._usedata[1];
    if Data_Battle:getBattlefieldType() == Data_Battle.CONST_BATTLE_TYPE_VCR then
       self.disTime = 180;
    end
    self.textDes:setString("离战斗结束时间")
    self.do_Scheduler = GLOBAL_SCHEDULER:scheduleScriptFunc(
            handler(self, self.updataTimeDisplay),
            1, 
            false
    )
end


function controler_battle_ui_attack_top:_onSetUIVisible( event )
    local eventUseData = event._usedata
    local visibleType = eventUseData.visibleType

    --隐藏所有
    if visibleType == "hideAll" then
        self._view_node:setVisible(false)

    --显示所有
    elseif visibleType == "showAll" then
        self._view_node:setVisible(true)
    end
end


return controler_battle_ui_attack_top
