--
-- Author: zangqing
-- Date: 2016-01-05 10:37:59
-- 中部显示

local class_friend_item = require("app.views.gameWorld.chatsys.itemset.friend_info_item.lua")

local controler_ui_friend_list = class("controler_ui_friend_list")

--[[监听全局事件名预览
eventModleName: controler_ui_map_info_mid
eventName: 
    setUIVisible     --设置显示状态

]]


function controler_ui_friend_list:ctor(mainPage_ui_layer)
    self:_initModels()

    --根层
    self._view_node = mainPage_ui_layer
    -- self._view_node:setContentSize(visibleSize)
    -- ccui.Helper:doLayout(self._view_node)


    self:_createControlerForUI()

    --
    self:_registGlobalEventListeners()

    self:_registNodeEvent()

    self:_registUIEvent()

    self:setItemTemple()

    self:updateViewShow();
end


function controler_ui_friend_list:getView()
    return self._view_node
end

function controler_ui_friend_list:createItem( itemdata )
    -- 复制一个item
    local itemview = self.itemModel:getChildByName("item"):clone();
    local item = class_friend_item.new(itemview)
    item:update(itemdata);
    return item;
end
function controler_ui_friend_list:setItemTemple(  )
    self.ItemTemple = cc.CSLoader:createNode("ui_instance/chatchannel/viewnode/friend_info_item.csb")
    -- 保存到内存
    self.ItemTemple:retain()
end
--
function controler_ui_friend_list:update(listdata)
    -- body
end


function controler_ui_friend_list:_initModels()
    self._controlerMap = {}
    self.itemInfo = {
        interval = 10,--item 间隔
        height = 114,--item高度
        scroll_weight = 652,--滚动 宽度
        scroll_height = 750,--滚动 高度
        fj_height = 67,--附件项高度
        base_height = 200 --基础滚动区域
    }
    self.items = {};
    self.itemModel = cc.CSLoader:createNode("ui_instance/chatchannel/viewnode/friend_info_item.csb")
    self.itemModel:retain()
end

--创建控制器: UI
function controler_ui_friend_list:_createControlerForUI()
    
end


function controler_ui_friend_list:_registGlobalEventListeners()
    self._globalEventListeners = {}
    local configs = {
        {modelName = "controler_ui_friend_list", eventName = "setUIVisible", callBack=handler(self, self._onSetUIVisible)},
        {modelName = "controler_ui_friend_list", eventName = "updateViewShow", callBack=handler(self, self.updateViewShow)},
        {modelName = "controler_ui_friend_list", eventName = "updateTips", callBack=handler(self, self.updateTips)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
    -- dispatchGlobaleEvent("controler_ui_friend_list", "setUIVisible", {visibleType="hideAll"})
end


--注册节点事件
function controler_ui_friend_list:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
        end
    end
    self._view_node:registerScriptHandler(onNodeEvent)
end


--移除全局事件监听器
function controler_ui_friend_list:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end

function controler_ui_friend_list:_registUIEvent()
    --好友列表
    self.node_FriendList = self._view_node:getChildByName("ScrollView_1");
end


function controler_ui_friend_list:_onSetUIVisible( event )
    local eventUseData = event._usedata
    local visibleType = eventUseData.visibleType

    --隐藏所有
    if visibleType == "hideAll" then
        self._view_node:setVisible(false)

    --显示所有
    elseif visibleType == "showAll" then
        self._view_node:setVisible(true)
    end
end

function controler_ui_friend_list:updateTips( event )
    local eventUseData = event._usedata[1];
    print("updateTips:",eventUseData)
    for i,v in ipairs(self.items) do
        if v.data.name == eventUseData then
            v.data.red_sign = 1;
            v:update(v.data);
            return;
        end
    end
end

--更新界面显示
function controler_ui_friend_list:updateViewShow()
    print("controler_ui_friend_list 0")
    -- 获得玩家的等级
    -- local playerlv = 10;
    -- -- 等级显示的文本控件
    -- local txt_tower_lv = self._view_node:getChildByName("btn_rect"):getChildByName("info_valuse");


    --创建玩家列表
    self.items = {};
    self.node_FriendList:removeAllChildren();

    local y = - self.itemInfo.height;
    local container = ccui.Layout:create();

    local friend_list = MAIN_PLAYER:getfriendMgr():getfriendList();
    local index = #friend_list;
    print("==========#friend_list"..index)
    if friend_list then
        for i = 1,#friend_list do -- 
            if not self.items[i] then
               self.items[i] = class_friend_item.new(
                    self.itemModel:getChildByName("item"):clone()
                )
                self.items[i]:update(friend_list[i])
                container:addChild(self.items[i]:getResourceNode());
            end
            
            self.items[i]:getResourceNode():setPosition(cc.p(0,y))
            self.items[i]:setClickListen( handler(self, self.clickListener) );
            y = y - self.itemInfo.height - self.itemInfo.interval;
        end
    end
    for i=index + 1,#self.items do
        self.items[i]:getResourceNode():removeFromParent();
        self.items[i] = nil;
    end
    --设置滚动区域
    local height = math.abs(y);
    if height < self.itemInfo.scroll_height then
        if height > self.itemInfo.scroll_height - self.itemInfo.base_height then
            height = height + self.itemInfo.base_height;
        else
            height = self.itemInfo.scroll_height
        end
    end
    
    self.node_FriendList:setInnerContainerSize(cc.size(self.itemInfo.scroll_weight,height));
    self.node_FriendList:addChild(container)
    container:setPosition(cc.p(0,height))
    self.node_FriendList:jumpToTop();

    -- self.node_FriendList:removeAllItems();
    -- --领地庇护所列表
    -- self.items = {};
    -- local friend_list = MAIN_PLAYER:getGuild():Get_all_guild();
    -- print("==========#friend_list"..#friend_list)
    -- for i=1,#friend_list do
    --     self.items[i] = class_friend_item.new(
    --             self.itemModel:getChildByName("item"):clone()
    --         )
    --     self.items[i]:update(friend_list[i]);
    --     self.node_FriendList:pushBackCustomItem(self.items[i]:getResourceNode())
    -- end
end

--点击监听
function controler_ui_friend_list:clickListener( params )
    print("点击item ",params)
    AudioManager.playButton();
    if self.currentShowFjItem == params then
        self:showAppendInfoLgoic( self.currentShowFjItem , false);
        self.currentShowFjItem = nil;
        return;
    end
    if self.currentShowFjItem then
        self:showAppendInfoLgoic( self.currentShowFjItem , false);
    end
    self.currentShowFjItem = params;
    self:showAppendInfoLgoic( self.currentShowFjItem , true);
end

--列表显示附件信息逻辑
function controler_ui_friend_list:showAppendInfoLgoic( object , isshow)
    local moveDis = self.itemInfo.fj_height;
    if isshow then
        moveDis = moveDis * -1;
    end
    local mark = -1;
    for i,v in ipairs(self.items) do
        print(v:getResourceNode(),object)
        if mark > 0 then
           local x ,y = v:getResourceNode():getPosition();
           v:getResourceNode():setPosition(cc.p(x,y + moveDis ));
        end
        if v:getResourceNode() == object then
            v:setShowAppendInfo(isshow);
            mark = i;
        end

    end
end

--更新界面显示
function controler_ui_friend_list:updatesingerViewShow(info)
    -- 获得玩家的等级
    -- local playerlv = 10;
    -- -- 等级显示的文本控件
    -- local txt_tower_lv = self._view_node:getChildByName("btn_rect"):getChildByName("info_valuse");

    --更新塔防等级

    --庇护所列表
    self.node_FriendList = self._view_node:getChildByName("ListView_3");
    self.node_FriendList:removeAllItems();
    --领地庇护所列表
    self.items = {};
    self.items[1] = class_friend_item.new(
            self.itemModel:getChildByName("item"):clone()
        )
    self.items[1]:update(info);
    self.node_FriendList:pushBackCustomItem(self.items[1]:getResourceNode())
end


return controler_ui_friend_list
