--
-- Author: zang qing 
-- Date: 2016-1-12 14:20:26
-- 聊天内容item


local chat_info_item = class("chat_info_item")

function chat_info_item:ctor(node)
	
	self._rootNode = node
	-- self._rootNode:setContentSize(visibleSize)
	-- ccui.Helper:doLayout(self._rootNode)
	
	self:init()
	self:_registGlobalEventListeners()
	self:_registUIEvent()

end

function chat_info_item:init()
	-- body
	-- self._rootNode:setCascadeOpacityEnabled(true)
	self.richtext = ccui.RichText:create();
    self.richtext:ignoreContentAdaptWithSize(false)
    self.richtext:setContentSize(cc.size(600, 10))
    self.richtext:setAnchorPoint(cc.p(0.5,0.5));

    self._rootNode:addChild(self.richtext,80);

    self.richElement = {};
end

function chat_info_item:getResourceNode()
	-- body
	return self._rootNode
end
function chat_info_item:_registGlobalEventListeners()
    self._globalEventListeners = {}
    local configs = {
        {modelName = "head", eventName = "update", callBack=handler(self, self.registerHeadUpdate)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
    -- dispatchGlobaleEvent("controler_ui_map_info_guild", "setUIVisible", {visibleType="hideAll"})
end

function chat_info_item:_registUIEvent()
	-- body
	-- local charitem = self._rootNode:getChildByName("Image_1")
	local function onClicked()
		print("点击对话消息")
		
		if self.data.fight_id and string.len(self.data.fight_id) > 0 then
			--弹出提示框
			UIManager:CreatePrompt_Operate_1( {
                mark = "battle_vcr",--接口类型标示
                title = "战斗回放",--标题
                content = "  是否观看战斗回放?",--描述文字
                eventlogic = "",--绑定逻辑
                eventlist = "",--注册事件列表
                displayType = 1,
                listenButton = function ( result )
                    -- 1 表示选择1按钮 2表示选择按钮
                    if result == 1 then
                        dispatchGlobaleEvent( "battlefield" ,"initialize", {
				            battleType = Data_Battle.CONST_BATTLE_TYPE_VCR,
				            key = self.data.fight_id
				        });
                    end
                end
            } )
		end
		if self.CallBack then
			self.CallBack(self.data);
		end
	end
	self._rootNode:addClickEventListener(onClicked)


end

--[[更新数据
	data 显示数据
	{
		[1] = { content = " 李阳:" ,color = cc.c3b(255, 255, 255) ,size = 30 },
		[2] = { content = " 你好!" ,color = cc.c3b(255, 255, 255) ,size = 30 }
	}
]]
function chat_info_item:update(data)
	self.data = data
	--清理显示
	-- print("chat_info_item:update",self,table.nums(self.richElement))
	-- if table.nums(self.richElement) > 0 then
	-- 	for i,v in ipairs(self.richElement) do
	-- 		print("removeElement",i,v)
	-- 		self.richtext:removeElement(v);
	-- 	end
	-- 	self.richtext:formatText()
	-- else
	-- 	for i,v in ipairs(data) do
	-- 		print("add",i,v.content)
	-- 		self.richElement[i] = ccui.RichElementText:create(i, v.color,255, v.content, "font/simhei", v.size);
	--     	self.richtext:pushBackElement(self.richElement[i])
	-- 	end
	--     self.richtext:formatText()
	-- end
	for i,v in ipairs(self.richElement) do
		-- print("removeElement",i,v)
		self.richtext:removeElement(v);
	end
	for i,v in ipairs(data) do
		-- print("add",i,v.content)
		self.richElement[i] = ccui.RichElementText:create(i, v.color,255, v.content, "font/simhei", v.size);
    	self.richtext:pushBackElement(self.richElement[i])
	end
    self.richtext:formatText()

    local size = self.richtext:getContentSize();
    print("chat_info_item:update",size.width,size.height)

    self.height = size.height;
    if self.height < 65 then
    	self.height = 65;
    end
    self._rootNode:setContentSize(cc.size(720,self.height))

    self.richtext:setPosition(cc.p(400,self.height - size.height / 2))
    
    print("=====>", self.data.head_id);
    --更新头像
	local headRes = ManagerHeadRes:LoadHeadRes( self.data.head_id )
	local headImage = self._rootNode:getChildByName("headback"):getChildByName("icon");
	if headRes then
		headImage:loadTexture(headRes);
	else
		headImage:loadTexture("ui_image/common/image/syshead.png");
	end

    self._rootNode:getChildByName("headback"):setPositionY(self.height - 30)
end

--设置点击回调
function chat_info_item:setClickCallBack( callback )
	self.CallBack = callback;
end


--更新头像
function chat_info_item:upDateHeadImage(  )
	local headImage = self._rootNode:getChildByName("headback"):getChildByName("icon");
	headImage:loadTexture(ManagerHeadRes:getHeadResPath( self.data.head_id ));
end

function chat_info_item:registerHeadUpdate( event )
	local headGuid = event._usedata[1]
	if headGuid ~= self.data.head_id then
		return;
	end
	self:upDateHeadImage();
end

return chat_info_item
