--
-- Author: zangqing
-- Date: 2016-01-09 10:19:02
-- 排行榜界面

-- 此类本身就是UI的显示layer,self.resourceNode_才是根节点
local ui_chatlist_layer = class("ui_chatlist_layer", cc.load("mvc").ViewBase)
local class_chat_info_item = import(".itemset.chat_info_item")
local class_controler_chat_friend = import(".controler_ui_friend_list")
-- local class_controler_ui_map_info_player = import(".controler_ui_map_info_player")
-- local class_controler_ui_map_info_guild = import(".controler_ui_map_info_guild")
-- local class_controler_ui_map_info_list = import(".controler_ui_map_info_list")

ui_chatlist_layer.RESOURCE_FILENAME = "ui_instance/chatchannel/ui_chatchannel_layer.csb"


function ui_chatlist_layer:onCreate()
    self.items = {};
    self:setItemTemple();
    self:_registNodeEvent()
    self:_registGlobalEventListeners()
    --创建ui控制器
    self:_createControlerForUI()
    --初始化资源分配
    self:_initDynamicResConfig()
    --注册按钮事件
    self:_registButtonEvent()



    -- local size= cc.Director:getInstance():getVisibleSize()
    -- local rootNode = self:getResourceNode()
    -- rootNode:setContentSize(size)
    -- ccui.Helper:doLayout(rootNode)
    -- rootNode:setPosition(cc.p(display.cx - 640 ,display.cy - 360))

    -- local shadow_layout = rootNode:getChildByName("shadow_layout")
    -- shadow_layout:setContentSize(size)
    -- ccui.Helper:doLayout(shadow_layout)

    -- self.CurrentPage = 1;
    -- self.SumPage = 10;
    -- self.CurrentDisplayData = nil;
    -- self.CurrentShowRanking = 0;
    -- self.CurrentRankDes = "当前战力值:"
    -- self.CurrentRankType = MAIN_PLAYER.rankManager.CONST_RANKING_POWER;

    -- self:_doEventCallBack( nil, nil, 1 );

    
end

function ui_chatlist_layer:setItemTemple(  )
    self.ItemTemple = cc.CSLoader:createNode("ui_instance/chatchannel/viewnode/chat_show_item.csb")
    -- 保存到内存
    self.ItemTemple:retain()
end
function ui_chatlist_layer:createItem( itemdata )
    -- 复制一个item
    local itemview = self.ItemTemple:getChildByName("item"):clone();
    local item = chat_info_item.new(itemview)
    item:update(itemdata);
    return item;
end
--注册节点事件
function ui_chatlist_layer:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
        elseif "enterTransitionFinish" == event then
            GAME_MODEL:getTipManager():setTipState( "char_world", 0 );
            self:updateTips(  );
        end
    end
    self.resourceNode_:registerScriptHandler(onNodeEvent)
end

--注册全局事件
function ui_chatlist_layer:_registGlobalEventListeners()
    -- body
    self._globalEventListeners = {}
    local configs = {
        {modelName = "ui_chatlist_layer", eventName = "refreshlist", callBack=handler(self, self.updateDataPage)},--注册地图信息控制 刷新列表
        {modelName = "ui_chatlist_layer", eventName = "close", callBack=handler(self, self.close)},--注册地图信息控制 关闭
        -- {modelName = "ui_chatlist_layer", eventName = "changechat", callBack=handler(self, self.updatechatList)},--更新显示聊天内容
        {modelName = "ui_chatlist_layer", eventName = "showfriend_list", callBack=handler(self, self.showfriend_list)},--更新显示聊天内容
        {modelName = "ui_chatlist_layer", eventName = "closefriend_list", callBack=handler(self, self.closefriend_list)},
        {modelName = "ui_chatlist_layer", eventName = "openFriendChat", callBack=handler(self, self.openFriendChat)},
        {modelName = "model_tipManager", eventName = "tipStateChange", callBack=handler(self, self.updateTips)},
        {modelName = "ui_chatlist_layer", eventName = "showfriendname", callBack=handler(self, self.showfriendname)},
        -- {modelName = "ui_chatlist_layer", eventName = "setUIVisible", callBack=handler(self, self._onSetUIVisible)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end

-- 创建UI控制器
function ui_chatlist_layer:_createControlerForUI()
    -- -- print("ui_chatlist_layer:_createControlerForUI=========")
    self._controlerMap = {}

    --列表框
    self.node_friend = self.resourceNode_:getChildByName("friend");
    
    -- -- 上部的按钮控制器
    self._controlerMap.node_friend = class_controler_chat_friend.new(
        self.node_friend
    )

    -- -- 中部UI控制器（玩家信息）
    -- self._controlerMap.node_infoshow_mid = class_controler_ui_map_info_player.new(
    --     self.resourceNode_:getChildByName("node_infoshow_mid")
    -- )

    -- -- 中部UI控制器（公会信息信息）
    -- self._controlerMap.node_infoguild_mid = class_controler_ui_map_info_guild.new(
    --     self.resourceNode_:getChildByName("node_infoguild_mid")
    -- )

    -- -- 下方UI控制器（玩家列表）
    -- self._controlerMap.node_list_bottom = class_controler_ui_map_info_list.new(
    --     self.resourceNode_:getChildByName("node_list_bottom")
    -- )
    self.node_PlayerList = self.resourceNode_:getChildByName("node_chat_info"):getChildByName("item_chat_info");
    
    self.node_PlayerList_1 = self.node_PlayerList:getChildByName("content");
    
    
end

function ui_chatlist_layer:_registButtonEvent()
    -- 关闭按钮
    
    -- self.btn_exit = self.resourceNode_:getChildByName("btn_exit")
    -- local function exitClicked(sender)
    --     AudioManager.playButton()
    --     self:close(self._dynamicResConfigIDs)
    -- end
    -- self.btn_exit:addClickEventListener(exitClicked)


    --附近
    self.button_near = self.resourceNode_:getChildByName("node_top_button"):getChildByName("btn_near")
    --门派
    self.button_guild = self.resourceNode_:getChildByName("node_top_button"):getChildByName("btn_guild")
    --队伍
    self.btn_team = self.resourceNode_:getChildByName("node_top_button"):getChildByName("btn_team")
    --好友
    self.button_friend = self.resourceNode_:getChildByName("node_top_button"):getChildByName("btn_friend")

    self.button_near:setSelected(true);
    self.button_guild:setSelected(false);
    self.btn_team:setSelected(false);
    self.button_friend:setSelected(false);

    
    local function nearClicked(sender,eventType)
        AudioManager.playButton();
        dispatchGlobaleEvent( "ui_chatlist_layer","showfriendname", {name = "",});
        print("附近玩家按钮")
        if eventType == ccui.CheckBoxEventType.selected then
            self:_OnCheckBos( "附近" )
        elseif eventType == ccui.CheckBoxEventType.unselected then
            if self.cuttentChoose == "附近" then
                self.button_near:setSelected(true);
            end
        end
    end
    self.button_near:addEventListener(nearClicked)
    
    local function guildClicked(sender,eventType)
        AudioManager.playButton();
        dispatchGlobaleEvent( "ui_chatlist_layer","showfriendname", {name = "",});
        print("公会玩家按钮")
        if eventType == ccui.CheckBoxEventType.selected then
            self:_OnCheckBos( "公会" )
        elseif eventType == ccui.CheckBoxEventType.unselected then
            if self.cuttentChoose == "公会" then
                self.button_guild:setSelected(true);
            end
        end
    end
    self.button_guild:addEventListener(guildClicked)
    
    local function teamClicked(sender,eventType)
        AudioManager.playButton();
        dispatchGlobaleEvent( "ui_chatlist_layer","showfriendname", {name = "",});
        print("队伍玩家按钮")
        if eventType == ccui.CheckBoxEventType.selected then
            self:_OnCheckBos( "队伍" )
        elseif eventType == ccui.CheckBoxEventType.unselected then
            if self.cuttentChoose == "队伍" then
                self.btn_team:setSelected(true);
            end
        end
    end
    self.btn_team:addEventListener(teamClicked)
    
    
    local function friendClicked(sender,eventType)
        AudioManager.playButton();
        dispatchGlobaleEvent( "ui_chatlist_layer","showfriendname", {name = "",});
        print("好友按钮")
        if eventType == ccui.CheckBoxEventType.selected then
            self:_OnCheckBos( "好友" )
        elseif eventType == ccui.CheckBoxEventType.unselected then
            if self.cuttentChoose == "好友" then
                self.button_friend:setSelected(true);
            end
        end
        
    end
    self.button_friend:addEventListener(friendClicked)
    
    --发送聊天内容
    self.button_send = self.resourceNode_:getChildByName("node_chatchannel"):getChildByName("node_input"):getChildByName("btn_send")
    local function sendClicked(sender)
        AudioManager.playButton();
        -- 添加聊天内容
        local input_txt = self.resourceNode_:getChildByName("node_chatchannel"):getChildByName("node_input"):getChildByName("txt_chat_input");
        local chatinfo = input_txt:getString();
        
        print("发送聊天内容按钮",self.cuttentChoose)
        local lenth = string.len(chatinfo)
        if lenth >= 60 then
            UIManager:CreatePrompt_Bar( {
                content = "发送聊天内容超长",
            } )
        else
            if self.displayChatChannel == chat_channel_guild then
                if not MAIN_PLAYER.guild:isHaveGuid() then
                    UIManager:CreatePrompt_Bar( {
                        content = "你还没有参加公会!"
                    } )
                    return;
                end
            end
            if self.displayChatChannel == chat_channel_friend then
                 gameTcp:SendMessage(MSG_C2S_SEND_CHAT, {self.displayChatChannel , chatinfo, self.friendData.id});
            else
                 gameTcp:SendMessage(MSG_C2S_SEND_CHAT, {self.displayChatChannel , chatinfo, ""});
            end
           
            input_txt:setString("");
        end

        -- 清空输入框内容
        
        
    end
    self.button_send:addClickEventListener(sendClicked)

    -- 返回按钮
    self.btn_return = self.resourceNode_:getChildByName("node_chatchannel"):getChildByName("node_input"):getChildByName("btn_return")
    local function returnClicked(sender)
        print("好友按钮")
        AudioManager.playButton();
        if eventType == ccui.CheckBoxEventType.selected then
            self:_OnCheckBos( "好友" )
        elseif eventType == ccui.CheckBoxEventType.unselected then
            if self.cuttentChoose == "好友" then
                self.button_friend:setSelected(true);
            end
        end
        gameTcp:SendMessage(MSG_C2S_Friend_GetFriend, {});
    end
    self.btn_return:addClickEventListener(returnClicked)

    self.displayChatChannel = chat_channel_world;
    self:updateDataPage(self.displayChatChannel);
    
    self:friend_setVisible(false);
end

function ui_chatlist_layer:_OnCheckBos( parame )
    
    self.button_near:setSelected(false);
    self.button_guild:setSelected(false);
    self.btn_team:setSelected(false);
    self.button_friend:setSelected(false);
    print("_OnCheckBos:",parame)
    if parame == "附近" then
        self.button_near:setSelected(true);
    end

    if parame == "公会" then
        print("===公会")
        self.button_guild:setSelected(true);
    end

    if parame == "队伍" then
        self.btn_team:setSelected(true);
    end

    if parame == "好友" then
        self.button_friend:setSelected(true);
    end
    if parame == self.cuttentChoose then
        return;
    end
    self.cuttentChoose = parame
   
    self:_OnDisplayItem( self.cuttentChoose )
end

function ui_chatlist_layer:setEventCallBack( callfun )
    self._controlerEventCallBack = callfun;
end

function ui_chatlist_layer:_doEventCallBack( sender, eventName, data )
    -- GLOBAL_TOUCH_CONTROL:TounchContrlScheduler(0.8);
    -- local rankType = MAIN_PLAYER.rankManager.CONST_RANKING_POWER;
    -- if data == 2 then
    --     rankType = MAIN_PLAYER.rankManager.CONST_RANKING_GRADE;
    -- elseif data == 3 then
    --     rankType = MAIN_PLAYER.rankManager.CONST_RANKING_WEALTH;
    -- end
    -- MAIN_PLAYER.rankManager:requestRankData( rankType )
    -- if self._controlerEventCallBack ~= nil then
    --  self._controlerEventCallBack(sender, eventName, data)
    -- end
end



function ui_chatlist_layer:recordID(params)
    -- body
    self.recordID = params._usedata.recordID
end

function ui_chatlist_layer:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end


function ui_chatlist_layer:close(res)

    -- self.ranking_view:clear( );
    --清空数据
    -- MAIN_PLAYER.rankManager:ClearData(  );
    if res == nil then
        res = self._dynamicResConfigIDs
    end
    -- GLOBAL_COMMON_ACTION:popupBack({
    --         node = self.resourceNode_,
    --         -- shadowNode = self.resourceNode_:getChildByName("shadow_layout"),
    --         callback = function ()
    --             -- body
    self:removeFromParent(true)
    -- release_res(res)
        --     end
        -- })
end

-- ui用到独有的资源管理
function ui_chatlist_layer:_initDynamicResConfig()
    -- ResConfig["ui_image/mapinfolist"] = {
    --     restype = "plist",
    --     respath = "ui_image/mapinfolist/",
    --     res = {"mapinfo"},
    -- }

    -- self._dynamicResConfigIDs = {
    --     "ui_image/mapinfolist",
    -- }
end

-- --执行频道检查逻辑
function ui_chatlist_layer:checkChannelLogic( data )
    if data.chatchannel == chat_channel_friend then
        print("===>",self.friendData.name ,"  ::",data.name)
        if self.friendData.name ~= data.name and self.friendData.name ~= data.objname then
            return false;
        end
    end
    return true;
end

function ui_chatlist_layer:getChatDisplayData(  )
    if self.displayChatChannel == chat_channel_friend then
        return MAIN_PLAYER:getchatManager():getchatMaillist()
    else
        return MAIN_PLAYER:getchatManager():getchatlist()
    end
end

-- 更新页面显示信息
function ui_chatlist_layer:updateDataPage(  )
    print("===更新聊天显示内容",self.displayChatChannel)
   
    local y = 0
    local interval = 5;
    local chardata = self:getChatDisplayData(  );
    local ilen = #chardata;
    print("ui_chatlist_layer:updateDataPage",chardata,ilen)
    local oper = 1;
    for i = 1,20 do
        if not chardata[ilen-i+1] then
            break;
        end
        if chardata[ilen-i+1].chatchannel == self.displayChatChannel and self:checkChannelLogic( chardata[ilen-i+1] ) then
            if not self.items[oper] then
                print("创建新的item",i)
                self.items[oper] = class_chat_info_item.new(
                    self.ItemTemple:getChildByName("item"):clone()
                )
                self.node_PlayerList_1:addChild(self.items[oper]:getResourceNode())
            end
            self.items[oper]:getResourceNode():setVisible(true);
            self.items[oper]:update(chardata[ilen-i+1])
            self.items[oper]:getResourceNode():setPosition(cc.p(0,y));
            print(self.items[oper].height)
            if i == 1 then
                y = y + self.items[oper].height;
            else
                y = y + interval + self.items[oper].height;
            end
           
            oper = oper + 1;
        end
    end
    for i=oper,#self.items do
       self.items[i]:getResourceNode():setVisible(false);
    end

    self.node_PlayerList_1:setContentSize(cc.size(720,y - interval))
    local height = y - interval
    if height < 740 then
        height = 740;
    end
    self.node_PlayerList:setInnerContainerSize(cc.size(720, height));
    self.node_PlayerList:jumpToBottom();
end

--[[注册事件回调刷新显示列表
    玩家信息
    kind 
]]
function ui_chatlist_layer:_OnDisplayItem( parame )
    if parame == "附近" then
        print("执行 附近")
        GAME_MODEL:getTipManager():setTipState( "char_world", 0 );
        self.displayChatChannel = chat_channel_world;
        self:updateDataPage(  )
        self.btn_return:setVisible(false);
        dispatchGlobaleEvent("ui_chatlist_layer", "closefriend_list")
    elseif parame == "公会" then
        GAME_MODEL:getTipManager():setTipState( "char_guild", 0 );
        self.displayChatChannel = chat_channel_guild;
        self:updateDataPage(  )
        self.btn_return:setVisible(false);
        dispatchGlobaleEvent("ui_chatlist_layer", "closefriend_list")
    elseif parame == "队伍" then
        GAME_MODEL:getTipManager():setTipState( "char_team", 0 );
        self.displayChatChannel = chat_channel_team;
        self:updateDataPage(  )
        self.btn_return:setVisible(false);
        dispatchGlobaleEvent("ui_chatlist_layer", "closefriend_list")
    elseif parame == "好友" then
        gameTcp:SendMessage(MSG_C2S_Friend_GetFriend, {});
        GAME_MODEL:getTipManager():setTipState( "char_friend", 0 );
        self.displayChatChannel = chat_channel_friend;
        -- self:updateDataPage(  )
    end
end

--更新页数显示
function ui_chatlist_layer:updateInfo(  )
    -- --页数
    -- self.resourceNode_:getChildByName("ranking"):getChildByName("pageNode"):getChildByName("text_pageValue"):setString(self.CurrentPage.."/"..self.SumPage);
    -- --排名
    -- self.resourceNode_:getChildByName("ranking"):getChildByName("playerRank"):getChildByName("infotext_0"):setString(self.CurrentShowRanking);
    
    -- self.resourceNode_:getChildByName("ranking"):getChildByName("playerInfo"):getChildByName("infotext"):setString(self.CurrentRankDes);

end

-- 创建UI控制器
function ui_chatlist_layer:friend_setVisible(isvisible)
    self.node_friend:setVisible(isvisible);
    -- print("设置返回按钮逻辑",isvisible)
    -- if isvisible then
    --     self.btn_return:setVisible(isvisible);
    -- end
end

function ui_chatlist_layer:showfriend_list()
    -- print("=====>")
    self:friend_setVisible(true);
end

function ui_chatlist_layer:closefriend_list()
    self:friend_setVisible(false);
end

function ui_chatlist_layer:showfriendname(event)
    -- print("===========>showfriendname", event._usedata.name);
    -- self.friendData = event._usedata;
    local friend_name = self.resourceNode_:getChildByName("node_chatchannel"):getChildByName("txt_friend_name");
    friend_name:setString(event._usedata.name);
end
-- if inserttab.chatchannel == chat_channel_world then
--         GAME_MODEL:getTipManager():setTipState( "char_world", 1 );
--     elseif inserttab.chatchannel == chat_channel_guild then
--         GAME_MODEL:getTipManager():setTipState( "char_guild", 1 );
--     elseif inserttab.chatchannel == chat_channel_team then
--         GAME_MODEL:getTipManager():setTipState( "char_team", 1 );
--     elseif inserttab.chatchannel == chat_channel_friend then
--         GAME_MODEL:getTipManager():setTipState( "char_friend", 1 );
--     elseif inserttab.chatchannel == chat_channel_system then
--         GAME_MODEL:getTipManager():setTipState( "char_system", 1 );
--     end

--[[
    更新信息提示框
]]
function ui_chatlist_layer:updateTips(  )
    -- print("ui_chatlist_layer ==>",GAME_MODEL:getTipManager()._tipMap["char_world"])
    local tips_fj = self.button_near:getChildByName("tipimage")
    if GAME_MODEL:getTipManager()._tipMap["char_world"] > 0 then
        if self.displayChatChannel == chat_channel_world then
            tips_fj:setVisible(false)
            GAME_MODEL:getTipManager()._tipMap["char_world"] = 0;
        else
            tips_fj:setVisible(true)
        end
        
    else
        tips_fj:setVisible(false)
    end

    local tips_guild = self.button_guild:getChildByName("tipimage")
    if GAME_MODEL:getTipManager()._tipMap["char_guild"] > 0 then
        if self.displayChatChannel == chat_channel_guild then
            tips_guild:setVisible(false)
        else
            tips_guild:setVisible(true)
        end
        
    else
        tips_guild:setVisible(false)
    end

    local tips_team = self.btn_team:getChildByName("tipimage")
    if GAME_MODEL:getTipManager()._tipMap["char_team"] > 0 then
        if self.displayChatChannel == chat_channel_team then
            tips_team:setVisible(false)
        else
            tips_team:setVisible(true)
        end
        
    else
        tips_team:setVisible(false)
    end

    local tips_friend = self.button_friend:getChildByName("tipimage")
    if GAME_MODEL:getTipManager()._tipMap["char_friend"] > 0 then
        print("好友",self.displayChatChannel,chat_channel_friend)
        if self.displayChatChannel == chat_channel_friend then
            tips_friend:setVisible(false)
            GAME_MODEL:getTipManager()._tipMap["char_friend"] = 0;
        else
            tips_friend:setVisible(true)
        end
        
    else
        tips_friend:setVisible(false)
    end
end

--开启好友聊天
function ui_chatlist_layer:openFriendChat( event )
    self.friendData = event._usedata;
    self:closefriend_list();

    self.displayChatChannel = chat_channel_friend;
    self:updateDataPage(  )

    self.btn_return:setVisible(true);
end

return ui_chatlist_layer
