--
-- Author: zangqing
-- Date: 2016-01-09 10:19:02
-- 设置公会名称

-- 此类本身就是UI的显示layer,self.resourceNode_才是根节点
local ui_create_guild_layer = class("ui_create_guild_layer", cc.load("mvc").ViewBase)

ui_create_guild_layer.RESOURCE_FILENAME = "ui_instance/guildpage/ui_guild_create_layer.csb"

function ui_create_guild_layer:onCreate()

    self.m_Choose = 1;
    self:_registNodeEvent()
    self:_registGlobalEventListeners()

    --创建ui控制器
    self:_createControlerForUI()
    --注册按钮事件
    self:_registButtonEvent()

    
end

--注册节点事件
function ui_create_guild_layer:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
        end
    end
    self.resourceNode_:registerScriptHandler(onNodeEvent)
end

--注册全局事件
function ui_create_guild_layer:_registGlobalEventListeners()
    -- body
    self._globalEventListeners = {}
    local configs = {
        {modelName = "ui_create_guild_layer", eventName = "refreshlist", callBack=handler(self, self.updateDisplay)},--注册地图信息控制 刷新列表
        {modelName = "ui_create_guild_layer", eventName = "close", callBack=handler(self, self.close)},--控制 关闭
        -- {modelName = "netMsg", eventName = tostring(MSG_MS2C_RANK_RE), callBack=handler(self, self.updateDisplayKind)},
        -- {modelName = "ui_create_guild_layer", eventName = "setUIVisible", callBack=handler(self, self._onSetUIVisible)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end

-- 创建UI控制器
function ui_create_guild_layer:_createControlerForUI()
    -- -- print("ui_create_guild_layer:_createControlerForUI=========")
    -- self._controlerMap = {}

    -- -- 上部的按钮控制器
    -- self._controlerMap.node_btn_top = class_controler_ui_map_info_btn.new(
    --     self.resourceNode_:getChildByName("node_btn_top")
    -- )

    -- -- 中部UI控制器（玩家信息）
    -- self._controlerMap.node_infoshow_mid = class_controler_ui_map_info_player.new(
    --     self.resourceNode_:getChildByName("node_infoshow_mid")
    -- )

    -- -- 中部UI控制器（公会信息信息）
    -- self._controlerMap.node_infoguild_mid = class_controler_ui_map_info_guild.new(
    --     self.resourceNode_:getChildByName("node_infoguild_mid")
    -- )

    -- -- 下方UI控制器（玩家列表）
    -- self._controlerMap.node_list_bottom = class_controler_ui_map_info_list.new(
    --     self.resourceNode_:getChildByName("node_list_bottom")
    -- )
end

function ui_create_guild_layer:_registButtonEvent()

    --确认
    local button_ok = self.resourceNode_:getChildByName("btn_OK")
    local function okClicked(sender)
        
        print("确认按钮")
        self:create_guild( );
        
    end
    button_ok:addClickEventListener(okClicked)

     --取消
    local button_no = self.resourceNode_:getChildByName("btn_exit_0")
    local function noClicked(sender)
        
        print("取消按钮")
        -- self:resetName();
        self:close(self._dynamicResConfigIDs)
    end
    button_no:addClickEventListener(noClicked)
    
end

function ui_create_guild_layer:setEventCallBack( callfun )
    self._controlerEventCallBack = callfun;
end

function ui_create_guild_layer:resetName( )
    local inputNameView = self.resourceNode_:getChildByName("text_inputname")
    inputNameView:setString("");
end

function ui_create_guild_layer:create_guild( )
    local inputNameView = self.resourceNode_:getChildByName("text_inputname")
    local name = inputNameView:getString();
    --[[
        1.账号大于6，账号必须是邮箱，账号长度不能超过30
        2.密码大于6，密码不能超过20
    ]]
    if name and (string.len(name) < 3 or string.len(name) >= 26)   then
        --账号长度大小在6~30之间
        --创建提示
        UIManager:CreatePrompt_Bar( {
            content = "账号长度大小在3~26之间",
            } )
    else
        -- 发送验证消息
        printInfo("网路日志 %s","发送创建公会才做，公会的昵称是：",name)
        local guild_obj = MAIN_PLAYER:getGuild();
        if nil==guild_obj then
            print("发送MSG_C2S_GUILD_Create,军团名称为: "..name);
            -- 发送创建
            gameTcp:SendMessage(MSG_C2S_GUILD_Create,{name,});
        else
            if ""~=guild_obj:getname() then
                print("MSG_C2S_GUILD_Info,取得当前军团信息,");
                gameTcp:SendMessage(MSG_C2S_GUILD_Info,{});
            else
                print("发送MSG_C2S_GUILD_Create,军团名称为: "..name);
                -- 发送创建
                gameTcp:SendMessage(MSG_C2S_GUILD_Create,{name,});
            end
        end
        -- self:close(self._dynamicResConfigIDs)
    end
end


function ui_create_guild_layer:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end


function ui_create_guild_layer:close(res)

    -- self.ranking_view:clear( );
    --清空数据
    -- MAIN_PLAYER.rankManager:ClearData(  );
    if res == nil then
        res = self._dynamicResConfigIDs
    end
    -- GLOBAL_COMMON_ACTION:popupBack({
    --         node = self.resourceNode_,
    --         -- shadowNode = self.resourceNode_:getChildByName("shadow_layout"),
    --         callback = function ()
    --             -- body
    self:removeFromParent(true)
    -- release_res(res)
        --     end
        -- })
end



return ui_create_guild_layer
