--
-- Author: liyang
-- Date: 2016-01-02 09:37:59
-- 地图点击事件层 主要监听多点触控


local controler_mapPage_map_tounch_layer = class("controler_mapPage_map_tounch_layer")

--[[监听全局事件名预览
eventModleName: controler_mapPage_map_tounch_layer
eventName: 
    setUIVisible     --设置显示状态

]]


function controler_mapPage_map_tounch_layer:ctor(mainPage_ui_layer)
    

    local visibleSize = cc.Director:getInstance():getVisibleSize()
    --根层
    self._view_layer = mainPage_ui_layer
    self:_initModels()

    self:_createControlerForUI()

    --
    self:_registGlobalEventListeners()

    self:_registNodeEvent()

    self:_registUIEvent()

end


function controler_mapPage_map_tounch_layer:getView()
    return self._view_layer
end


function controler_mapPage_map_tounch_layer:_initModels()
    self._controlerMap = {}
end

--创建控制器: UI
function controler_mapPage_map_tounch_layer:_createControlerForUI()

end


function controler_mapPage_map_tounch_layer:_registGlobalEventListeners()
    -- self._globalEventListeners = {}
    -- local configs = {
    --     {modelName = "controler_mapPage_map_tounch_layer", eventName = "setVisible", callBack=handler(self, self._onSetUIVisible)},
    --     {modelName = "controler_mapPage_map_tounch_layer", eventName = "updateImage", callBack=handler(self, self._updaeImage)},
    -- }
    -- self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end


--注册节点事件
function controler_mapPage_map_tounch_layer:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
        end
    end
    self._view_layer:registerScriptHandler(onNodeEvent)
end


--移除全局事件监听器
function controler_mapPage_map_tounch_layer:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end

--判断点是否在屏幕内
function controler_mapPage_map_tounch_layer:isPointInTopHalfAreaOfScreen(pt)
    local winSize = cc.Director:getInstance():getWinSize()
    if pt.y >= winSize.height / 2 then
        return true
    end
    
    return false
end

--判断某点是否在节点内
function controler_mapPage_map_tounch_layer:isPointInNode(pt, node)
    --转换为node坐标
    local locationInNode = node:convertToNodeSpace(pt)
    local s = node:getContentSize()
    local rect = cc.rect(0, 0, s.width, s.height)
    if cc.rectContainsPoint(rect, locationInNode) then
        return true
    end
    return false
end

function controler_mapPage_map_tounch_layer:_registUIEvent()
    
    --多点触控
    local function onTouchesBegan(touches, event)
        print("onTouchesBegan")
        if self:isPointInTopHalfAreaOfScreen(touches[1]:getLocation()) then
            print("onTouchesBegan")
            return false
        end

        --得到触摸点数
        local tounchesNumber = table.nums(touches);
        print("tounchesNumber",tounchesNumber)
        if tounchesNumber >= 2 then
           --起始参数
            self.startTwoParam = {};
            self.startTwoParam.pos_1 = touches[1]:getLocation();
            self.startTwoParam.pos_2 = touches[2]:getLocation();
            self.startTwoParam.dis = cc.pGetDistance(self.startTwoParam.pos_1,self.startTwoParam.pos_2);
        else
            self.startOneParam = {};
            self.startTwoParam.pos = touches[1]:getLocation();
        end
        
        -- --得到当前的target
        -- local target = event:getCurrentTarget()


        -- if self:isPointInNode(touches[1]:getLocation(), target) then
        --     target:setOpacity(180)
        -- end
        -- event:stopPropagation()
    end

    local function onTounchesMove( touches, event )
        --得到触摸点数
        local tounchesNumber = table.nums(touches);
        if tounchesNumber >= 2 then
            self:TouchesAllMoveLogic( touches[1]:getLocation() ,touches[2]:getLocation() );
        else
            self:TounchesOneMoveLogic( touches[1]:getLocation() );
        end
    end

    local function onTouchesEnd(touches, event)
         print("onTouchesEnd")
        if self:isPointInTopHalfAreaOfScreen(touches[1]:getLocation()) then

            return false;
        end
    end

    local touchAllAtOnceListener = cc.EventListenerTouchAllAtOnce:create()
    -- touchAllAtOnceListener:setSwallowTouches(true)
    touchAllAtOnceListener:registerScriptHandler(onTouchesBegan,cc.Handler.EVENT_TOUCHES_BEGAN )
    touchAllAtOnceListener:registerScriptHandler(onTounchesMove,cc.Handler.EVENT_TOUCHES_MOVED )
    touchAllAtOnceListener:registerScriptHandler(onTouchesEnd,cc.Handler.EVENT_TOUCHES_ENDED )
    
    local eventDispatcher = APP:getCurScene():getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(touchAllAtOnceListener, self._view_layer)
    -- local size = self._view_layer:getContentSize()
    -- print("==================>",self._view_layer:getDescription(),self._view_layer:getChildrenCount(),size.height)

    -- self._view_layer:setSwallowTouches(true)
end

controler_mapPage_map_tounch_layer.MapHandleConfig = {
    minMoveDis = 20,--最小移动像素
    unitScale = 0.1,--单位缩放大小
}

-------------------------------------移动事件逻辑---------------------------------

--[[多点移动事件逻辑
]]
function controler_mapPage_map_tounch_layer:TouchesAllMoveLogic( pos_1 ,pos_2 )
    if not self.startTwoParam then
        return;
    end
    local dis_1 = cc.pGetDistance(self.startTwoParam.pos_1,pos_1)
    local dis_2 = cc.pGetDistance(self.startTwoParam.pos_2,pos_2)
    if dis_1 < self.MapHandleConfig.minMoveDis and dis_2 < self.MapHandleConfig.minMoveDis then
        return;
    end
    local dis = cc.pGetDistance(pos_1,pos_2);
    local scalevaluse = (dis - self.startTwoParam.dis) / self.MapHandleConfig.minMoveDis * self.MapHandleConfig.unitScale;
    --重置初始点
    self.startTwoParam.pos_1 = pos_1;
    self.startTwoParam.pos_2 = pos_2;
    self.startTwoParam.dis = dis;
end


--[[单点移动事件逻辑
]]
function controler_mapPage_map_tounch_layer:TounchesOneMoveLogic( pos_1 )
    if not self.startTwoParam then
        return;
    end
    local dis_1 = cc.pGetDistance(self.startTwoParam.pos,pos_1)
    if dis_1 < self.MapHandleConfig.minMoveDis then
        return;
    end
    
    local movepos = cc.pSub(pos_1,self.startTwoParam.pos);
    self.startTwoParam.pos = pos_1;
    --设置移动点
end

--[[点击结束逻辑

]]
function controler_mapPage_map_tounch_layer:TouchesAllEndLogic(  )
    --得到2点之间的距离
    local distance = cc.pGetDistance(startP,endP)
    --处理图片更新
end


function controler_mapPage_map_tounch_layer:_onSetUIVisible( event )
    local eventUseData = event._usedata
    local visibleType = eventUseData.visibleType

    --隐藏所有
    if visibleType == "hideAll" then
        self._view_layer:setVisible(false)

    --显示所有
    elseif visibleType == "showAll" then
        self._view_layer:setVisible(true)
    end
    
end


return controler_mapPage_map_tounch_layer
