--
-- Author: liyang
-- Date: 2016-01-02 09:37:59
--

-- 主页UI层里面的几个分支类实例
local class_controler_mainPage_ui_btn_bottonm = import(".controler_mainPage_ui_btn_bottonm")
local class_controler_mainPage_ui_info_top = import(".controler_mainPage_ui_info_top")
local class_controler_mainPage_ui_right_needle = import(".controler_mainPage_ui_right_needle")


---=============================================================-----------------
-- 整个主页UI的管理类
local controler_mainPage_ui_layer = class("controler_mainPage_ui_layer")

--[[监听全局事件名预览
eventModleName: controler_mainPage_ui_layer
eventName: 
    setUIVisible     --设置显示状态

]]


function controler_mainPage_ui_layer:ctor(mainPage_ui_layer)
    self:_initModels()

    local visibleSize = cc.Director:getInstance():getVisibleSize()
    --根层
    self._mainPage_ui_layer = mainPage_ui_layer
    self._mainPage_ui_layer:setContentSize(visibleSize)
    ccui.Helper:doLayout(self._mainPage_ui_layer)

    --UI容器
    -- self._UIContainer = self._mainPage_ui_layer:getChildByName("UIContainer")
    -- self._UIContainer:setContentSize(visibleSize)
    -- ccui.Helper:doLayout(self._UIContainer)

    self:_createControlerForUI()

    --
    self:_registGlobalEventListeners()

    self:_registNodeEvent()

    self:_registUIEvent()
end


function controler_mainPage_ui_layer:getView()
    return self._mainPage_ui_layer
end


function controler_mainPage_ui_layer:_initModels()
    self._controlerMap = {}
end

--创建控制器: UI
function controler_mainPage_ui_layer:_createControlerForUI()
    --UI下部按钮
    self._controlerMap.parts_btn_bottonm = class_controler_mainPage_ui_btn_bottonm.new(
        self:_createUIBottomLayer()
    )
    --ui顶部控制器
    self._controlerMap.parts_right_top = class_controler_mainPage_ui_info_top.new(
        self._mainPage_ui_layer:getChildByName("parts_info_top")
    )
    --ui右上部控制器
    self._controlerMap.parts_right_needle = class_controler_mainPage_ui_right_needle.new(
        self._mainPage_ui_layer:getChildByName("parts_right_needle")
    )

    -- -- -- 弹出框部分控制器
    -- self._controlerMap.mapinfoListLayer = class_controler_ui_map_info_layer.new(cc.CSLoader:createNode("ui_instance/mapinfolist/ui_map_info_layer.csb"))
    -- -- print("controler_mainPage_ui_layer 2")
end


function controler_mainPage_ui_layer:_registGlobalEventListeners()
    self._globalEventListeners = {}
    local configs = {
        {modelName = "controler_mainPage_ui_layer", eventName = "setUIVisible", callBack=handler(self, self._onSetUIVisible)},
        {modelName = "netMsg", eventName = tostring(MSG_MS2C_INTERACT_ADD), callBack=handler(self, self.addNotifyAni)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end


function controler_mainPage_ui_layer:addNotifyAni(params)
    -- body
    self._controlerMap.functionbuttons:addNotifyAni(params._usedata.mode)
end


--注册节点事件
function controler_mainPage_ui_layer:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
        end
    end
    self._mainPage_ui_layer:registerScriptHandler(onNodeEvent)
end


--移除全局事件监听器
function controler_mainPage_ui_layer:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end

function controler_mainPage_ui_layer:_registUIEvent()
    --多点触控
    local function onTouchesBegan(touches, event)
        print("onTouchesBegan")
        if self:isPointInTopHalfAreaOfScreen(touches[1]:getLocation()) then
            print("onTouchesBegan")
            return false
        end

        --得到触摸点数
        local tounchesNumber = table.nums(touches);
        print("tounchesNumber",tounchesNumber)
        if tounchesNumber >= 2 then
           --起始参数
            self.startTwoParam = {};
            self.startTwoParam.pos_1 = touches[1]:getLocation();
            self.startTwoParam.pos_2 = touches[2]:getLocation();
            self.startTwoParam.dis = cc.pGetDistance(self.startTwoParam.pos_1,self.startTwoParam.pos_2);
        else
            self.startOneParam = {};
            self.startTwoParam.pos = touches[1]:getLocation();
        end
        
        -- --得到当前的target
        -- local target = event:getCurrentTarget()


        -- if self:isPointInNode(touches[1]:getLocation(), target) then
        --     target:setOpacity(180)
        -- end
        -- event:stopPropagation()
    end
end

function controler_mainPage_ui_layer:_createUIBottomLayer()
    return cc.CSLoader:createNode("ui_instance/mainpage/viewparts/ui_main_btn_bottonm.csb")
end

function controler_mainPage_ui_layer:_onSetUIVisible( event )
    local eventUseData = event._usedata
    local visibleType = eventUseData.visibleType

    --隐藏所有
    if visibleType == "hideAll" then
        self._mainPage_ui_layer:setVisible(false)

    --显示所有
    elseif visibleType == "showAll" then
        self._mainPage_ui_layer:setVisible(true)
    end
    
end

-- -- 打开地图信息弹出框
-- function controler_mainPage_ui_layer:_openmapinfolistLayer()
--     self._controlerMap.mapinfoListLayer = class_controler_ui_map_info_layer.new(self:_createmapinfoLayer())
    
-- end

-- UI底部
function controler_mainPage_ui_layer:loadUIBottomView()
    return cc.CSLoader:createNode("ui_instance/mainpage/viewparts/ui_main_btn_bottonm.csb")
end

return controler_mainPage_ui_layer
