--
-- Author: zangqing
-- Date: 2016-01-05 10:37:59
-- 中部显示
local class_item = import(".map_info_item")

local controler_ui_map_info_guild = class("controler_ui_map_info_guild")

--[[监听全局事件名预览
eventModleName: controler_ui_map_info_mid
eventName: 
    setUIVisible     --设置显示状态

]]


function controler_ui_map_info_guild:ctor(mainPage_ui_layer)
    self:_initModels()

    --根层
    self._view_node = mainPage_ui_layer
    -- self._view_node:setContentSize(visibleSize)
    -- ccui.Helper:doLayout(self._view_node)


    self:_createControlerForUI()

    --
    self:_registGlobalEventListeners()

    self:_registNodeEvent()

    self:_registUIEvent()
    self.excuteState = 1;--占领工会 申请加入工会
end


function controler_ui_map_info_guild:getView()
    return self._view_node
end


function controler_ui_map_info_guild:_initModels()
    self._controlerMap = {}

    self.itemInfo = {
        interval = 10,--item 间隔
        height = 114,--item高度
        scroll_weight = 720,--滚动 宽度
        scroll_height = 850,--滚动 宽度
        fj_height = 67,--附件项高度
        base_height = 200 --基础滚动区域
    }
    self.items = {};
    self.itemModel = cc.CSLoader:createNode("ui_instance/mapinfolist/viewnode/map_info_item.csb")
    self.itemModel:retain()
end

--创建控制器: UI
function controler_ui_map_info_guild:_createControlerForUI()
    self.guildIcon = self._view_node:getChildByName("info"):getChildByName("sp_guild_icon");
    self.guildLevel = self.guildIcon:getChildByName("sp_guild_lv"):getChildByName("txt_guild_lv");
    self.guidName = self._view_node:getChildByName("info"):getChildByName("txt_name")
end


function controler_ui_map_info_guild:_registGlobalEventListeners()
    self._globalEventListeners = {}
    local configs = {
        {modelName = "controler_ui_map_info_guild", eventName = "setUIVisible", callBack=handler(self, self._onSetUIVisible)},
        {modelName = "controler_ui_map_info_guild", eventName = "update", callBack=handler(self, self.updateViewShow)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
    -- dispatchGlobaleEvent("controler_ui_map_info_guild", "setUIVisible", {visibleType="hideAll"})
end


--注册节点事件
function controler_ui_map_info_guild:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
        end
    end
    self._view_node:registerScriptHandler(onNodeEvent)
end


--移除全局事件监听器
function controler_ui_map_info_guild:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end

function controler_ui_map_info_guild:_registUIEvent()
    -- 刷新在线玩家列表
    self.btn_addguild = self._view_node:getChildByName("info"):getChildByName("btn_join")
    local addguildClick = function (  )
        AudioManager.playButton();
        if self.excuteState == 1 then
            print(MSG_S2C_FIELD_Data)
            printInfo("网路日志 %s","地块信息发送-->".."x:".. MAP_DATA.lookatTileData.pos_x .."y:"..MAP_DATA.lookatTileData.pos_y)
            --发送玩家位置信息
            -- gameTcp:SendMessage(MSG_C2S_AREA_SEIZE,{
            --         MAP_DATA.lookatTileData.pos_x,
            --         MAP_DATA.lookatTileData.pos_y
            --     })
            dispatchGlobaleEvent( "battlefield" ,"initialize", {
                 battleType = Data_Battle.CONST_BATTLE_TYPE_PLANNING,
                cell_x = MAP_DATA.lookatTileData.pos_x,
                cell_y = MAP_DATA.lookatTileData.pos_y,
                });
        elseif self.excuteState == 2 then
            --发送加入工会消息
            gameTcp:SendMessage(MSG_C2S_GUILD_ApplyJoinGuild,{MAP_DATA.lookatTileData.guildGuid });
            UIManager:CreatePrompt_Bar( {
                        content = "加入工会申请已发送",
                    } )
        else
            
        end
        
    end
    self.btn_addguild:addClickEventListener(addguildClick)
end


function controler_ui_map_info_guild:_onSetUIVisible( event )
    local eventUseData = event._usedata
    local visibleType = eventUseData.visibleType

    --隐藏所有
    if visibleType == "hideAll" then
        self._view_node:setVisible(false)

    --显示所有
    elseif visibleType == "showAll" then
        self._view_node:setVisible(true)
    end
end

--更新界面显示
function controler_ui_map_info_guild:updateViewShow()
    -- 获得玩家的等级
    self.btn_addguild:setVisible(true);
    self.btn_addguild:setBright(true);
    self.btn_addguild:setTouchEnabled(true);
    if string.len(MAP_DATA.lookatTileData.guildGuid ) <= 0 then
        self.guildIcon:setVisible(false);
        self.guidName:setString("未被占领");
        local btn_name = self.btn_addguild:getChildByName("btn_name")
        --判断自己是否有工会 判断自己是能发起占领
        -- if MAIN_PLAYER.baseAttr:isCanOccupyHandle() then
        --     btn_name:setString("占  领")
        --     self.excuteState = 1;
        -- else
        --     self.btn_addguild:setVisible(false);
        -- end
        self.btn_addguild:setVisible(false);
       
    else
        self.guildIcon:setVisible(true);
        self.guildLevel:setString(MAP_DATA.lookatTileData.guildLevel);
        self.guidName:setString(MAP_DATA.lookatTileData.guildGuid);
        local btn_name = self.btn_addguild:getChildByName("btn_name")
        print("updateViewShow:",MAP_DATA.lookatTileData.guildGuid ,MAIN_PLAYER:getGuild():getGUID())
        if MAP_DATA.lookatTileData.guildGuid == MAIN_PLAYER:getGuild():getGUID() then
            -- btn_name:setString("进入领地")
            btn_name:loadTexture("ui_image/mapinfolist/jinrulingdi.png",ccui.TextureResType.localType)
            self.excuteState = 1;
            if MAP_DATA.lookatTileData.pos_x ~= MAIN_PLAYER.baseAttr._playerTileData.pos_x or MAP_DATA.lookatTileData.pos_y ~= MAIN_PLAYER.baseAttr._playerTileData.pos_y then
                self.btn_addguild:setBright(false);
                self.btn_addguild:setTouchEnabled(false);
            end
        else
            btn_name:loadTexture("ui_image/mapinfolist/gonghui_shenqingjiaru.png",ccui.TextureResType.localType)
            if MAIN_PLAYER:getGuild():isHaveGuid() then
                --self.btn_addguild:setVisible(false);
                self.btn_addguild:setBright(false);
                self.btn_addguild:setTouchEnabled(false);
            else
                self.excuteState = 2;
                -- btn_name:setString("申请加入");
            end
           
        end
    end

    --玩家列表
    self.node_PlayerList = self._view_node:getChildByName("playlist"):getChildByName("ScrollView_1");
    
    
    --创建玩家列表
   
    local y = - self.itemInfo.height;
    local container = ccui.Layout:create();
    for i = 1,MAP_DATA.lookatTileData.guildPlayerNum do -- 
        if not self.items[i] then
            self.items[i] = class_item.new(
                self.itemModel:getChildByName("item"):clone()
            )
            self.items[i]:update(MAP_DATA.lookatTileData.guildPlayerList[i])
            container:addChild(self.items[i]:getResourceNode());
        end
        
        self.items[i]:getResourceNode():setPosition(cc.p(0,y))
        self.items[i]:setClickListen( handler(self, self.clickListener) );
        y = y - self.itemInfo.height - self.itemInfo.interval;
    end
    --设置滚动区域
    local height = math.abs(y);
    if height < self.itemInfo.scroll_height then
        if height > self.itemInfo.scroll_height - self.itemInfo.base_height then
            height = height + self.itemInfo.base_height;
        else
            height = self.itemInfo.scroll_height
        end
    end
    
    self.node_PlayerList:setInnerContainerSize(cc.size(self.itemInfo.scroll_weight,height));
    self.node_PlayerList:addChild(container)
    container:setPosition(cc.p(0,height))
    self.node_PlayerList:jumpToTop();

    self.currentShowFjItem = nil;

end

--点击监听
function controler_ui_map_info_guild:clickListener( params )
    print("点击item ",params)
    if self.currentShowFjItem == params then
        self:showAppendInfoLgoic( self.currentShowFjItem , false);
        self.currentShowFjItem = nil;
        return;
    end
    if self.currentShowFjItem then
        self:showAppendInfoLgoic( self.currentShowFjItem , false);
    end
    self.currentShowFjItem = params;
    self:showAppendInfoLgoic( self.currentShowFjItem , true);
end

--列表显示附件信息逻辑
function controler_ui_map_info_guild:showAppendInfoLgoic( object , isshow)
    local moveDis = self.itemInfo.fj_height;
    if isshow then
        moveDis = moveDis * -1;
    end
    local mark = -1;
    for i,v in ipairs(self.items) do
        if mark > 0 then
           local x ,y = v:getResourceNode():getPosition();
           v:getResourceNode():setPosition(cc.p(x,y + moveDis ));
        end
        if v:getResourceNode() == object then
            v:setShowAppendInfo(isshow);
            mark = i;
        end

    end
end


return controler_ui_map_info_guild
