--
-- Author: zangqing
-- Date: 2016-01-05 10:37:59
-- 中部显示
local class_item = import(".map_info_item")

local controler_ui_map_info_player = class("controler_ui_map_info_player")

--[[监听全局事件名预览
eventModleName: controler_ui_map_info_mid
eventName: 
    setUIVisible     --设置显示状态

]]


function controler_ui_map_info_player:ctor(mainPage_ui_layer)
    self:_initModels()

    --根层
    self._view_node = mainPage_ui_layer
    -- self._view_node:setContentSize(visibleSize)
    -- ccui.Helper:doLayout(self._view_node)


    self:_createControlerForUI()

    --
    self:_registGlobalEventListeners()

    self:_registNodeEvent()

    self:_registUIEvent()
end


function controler_ui_map_info_player:getView()
    return self._view_node
end


function controler_ui_map_info_player:_initModels()
    self._controlerMap = {}

    self.itemInfo = {
        interval = 10,--item 间隔
        height = 114,--item高度
        scroll_weight = 720,--滚动 宽度
        scroll_height = 850,--滚动 宽度
        fj_height = 67,--附件项高度
        base_height = 200 --基础滚动区域
    }
    self.items = {};
    self.itemModel = cc.CSLoader:createNode("ui_instance/mapinfolist/viewnode/map_info_item.csb")
    self.itemModel:retain()
end

--创建控制器: UI
function controler_ui_map_info_player:_createControlerForUI()
    
end


function controler_ui_map_info_player:_registGlobalEventListeners()
    self._globalEventListeners = {}
    local configs = {
        {modelName = "controler_ui_map_info_player", eventName = "setUIVisible", callBack=handler(self, self._onSetUIVisible)},
        -- {modelName = "netMsg", eventName = tostring(MSG_MS2C_INTERACT_ADD), callBack=handler(self, self.addNotifyAni)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
    -- dispatchGlobaleEvent("controler_ui_map_info_player", "setUIVisible", {visibleType="hideAll"})
end


--注册节点事件
function controler_ui_map_info_player:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
        elseif "enterTransitionFinish" == event then

        end
    end
    self._view_node:registerScriptHandler(onNodeEvent)
end


--移除全局事件监听器
function controler_ui_map_info_player:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
    self.itemModel:release()
end

function controler_ui_map_info_player:_registUIEvent()
    -- 刷新在线玩家列表
   
end


function controler_ui_map_info_player:_onSetUIVisible( event )
    local eventUseData = event._usedata
    local visibleType = eventUseData.visibleType

    --隐藏所有
    if visibleType == "hideAll" then
        self._view_node:setVisible(false)

    --显示所有
    elseif visibleType == "showAll" then
        self._view_node:setVisible(true)
    end
end

--更新界面显示
function controler_ui_map_info_player:updateViewShow()
    local showData = GetTileCfg(MAP_DATA.lookatTileData.JiaCheng)
    --等级 
    self.node_image = self._view_node:getChildByName("tileInfo"):getChildByName("img_dikuai");
    self.node_sp_level = self._view_node:getChildByName("tileInfo"):getChildByName("img_dikuai"):getChildByName("sp_level"):getChildByName("txt_level");
    --加成
    self.node_jiacheng_valuse = self._view_node:getChildByName("tileInfo"):getChildByName("txt_jiacheng_number");
    --人数
    self.node_player_number = self._view_node:getChildByName("tileInfo"):getChildByName("txt_map_plauer_number");
    --玩家列表
    self.node_PlayerList = self._view_node:getChildByName("playlist"):getChildByName("ScrollView_1");

    --初始化数据
    self.node_image:loadTexture(showData.image, ccui.TextureResType.plistType);
    self.node_sp_level:setString(MAP_DATA.lookatTileData.JiaCheng);
    self.node_jiacheng_valuse:setString(showData.expup);
    self.node_player_number:setString("人数:"..MAP_DATA.lookatTileData.PlayerNum);

    --创建玩家列表
   
    local y = - self.itemInfo.height;
    local container = ccui.Layout:create();
    for i = 1,MAP_DATA.lookatTileData.PlayerNum do -- 
        if not self.items[i] then
            self.items[i] = class_item.new(
                self.itemModel:getChildByName("item"):clone()
            )
            self.items[i]:update(MAP_DATA.lookatTileData.playerList[i])
            container:addChild(self.items[i]:getResourceNode());
        end
        
        self.items[i]:getResourceNode():setPosition(cc.p(0,y))
        self.items[i]:setClickListen( handler(self, self.clickListener) );
        y = y - self.itemInfo.height - self.itemInfo.interval;
    end
    --设置滚动区域
    local height = math.abs(y);
    if height < self.itemInfo.scroll_height then
        if height > self.itemInfo.scroll_height - self.itemInfo.base_height then
            height = height + self.itemInfo.base_height;
        else
            height = self.itemInfo.scroll_height
        end
    end
    
    self.node_PlayerList:setInnerContainerSize(cc.size(self.itemInfo.scroll_weight,height));
    self.node_PlayerList:addChild(container)
    container:setPosition(cc.p(0,height))
    self.node_PlayerList:jumpToTop();

    self.currentShowFjItem = nil;
end

--点击监听
function controler_ui_map_info_player:clickListener( params )
    print("点击item ",params)
    if self.currentShowFjItem == params then
        self:showAppendInfoLgoic( self.currentShowFjItem , false);
        self.currentShowFjItem = nil;
        return;
    end
    if self.currentShowFjItem then
        self:showAppendInfoLgoic( self.currentShowFjItem , false);
    end
    self.currentShowFjItem = params;
    self:showAppendInfoLgoic( self.currentShowFjItem , true);
end

--列表显示附件信息逻辑
function controler_ui_map_info_player:showAppendInfoLgoic( object , isshow)
    local moveDis = self.itemInfo.fj_height;
    if isshow then
        moveDis = moveDis * -1;
    end
    local mark = -1;
    for i,v in ipairs(self.items) do
        if mark > 0 then
           local x ,y = v:getResourceNode():getPosition();
           v:getResourceNode():setPosition(cc.p(x,y + moveDis ));
        end
        if v:getResourceNode() == object then
            v:setShowAppendInfo(isshow);
            mark = i;
        end

    end
end


return controler_ui_map_info_player
