--
-- Author: li yang 
-- Date: 2015-08-26 11:20:26
-- 地图信息item


local map_info_item = class("map_info_item")

function map_info_item:ctor(node)
	
	self._rootNode = node
	-- self._rootNode:setContentSize(visibleSize)
	-- ccui.Helper:doLayout(self._rootNode)

	self:init()

	self:_registGlobalEventListeners()

    self:_registNodeEvent()

	self:_registUIEvent()
end

function map_info_item:init()
	-- body
	-- self._rootNode:setCascadeOpacityEnabled(true)
end

function map_info_item:getResourceNode()
	-- body
	return self._rootNode
end

function map_info_item:_registGlobalEventListeners()
    self._globalEventListeners = {}
    local configs = {
        {modelName = "head", eventName = "update", callBack=handler(self, self.registerHeadUpdate)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
    -- dispatchGlobaleEvent("controler_ui_map_info_guild", "setUIVisible", {visibleType="hideAll"})
end

--注册节点事件
function map_info_item:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
        end
    end
    self._rootNode:registerScriptHandler(onNodeEvent)
end

--移除全局事件监听器
function map_info_item:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end

function map_info_item:_registUIEvent()
	-- body
	local imageback = self._rootNode:getChildByName("backimage")
	local function imageClick(sender, eventType)
		-- body
		if eventType == ccui.TouchEventType.began then

	    elseif eventType == ccui.TouchEventType.moved then

	    elseif eventType == ccui.TouchEventType.ended then
	    	--判断是否是好友
	    	print(self.data.guid , " ::",MAIN_PLAYER.baseAttr:getGUID())
	    	AudioManager.playButton();
	    	if MAIN_PLAYER.friendMgr:checkfriend( self.data.guid ) or self.data.guid == MAIN_PLAYER.baseAttr:getGUID() then
	    		if self.fj_view:isVisible() then
	    			if self.clickItemListen then
						self.clickItemListen(self._rootNode);
					end
	    		end
	    		return;
	    	end
	        if self.clickItemListen then
				self.clickItemListen(self._rootNode);
			end
	    elseif eventType == ccui.TouchEventType.canceled then

	    end
	end
	imageback:addTouchEventListener(imageClick)

	local btn_friend = self._rootNode:getChildByName("img_fujia"):getChildByName("btn_add_friend")
    local function firendClicked()
    	--发送好友消息 
    	printInfo("网路日志 %s","发送添加好友信息 MSG_C2S_Friend_AddFriend")
        gameTcp:SendMessage(MSG_C2S_Friend_AddFriend,{self.data.guid})
        UIManager:CreatePrompt_Bar( {
                        content = "添加好友消息已发送",
                    } )
        AudioManager.playButton();
    end
    btn_friend:addClickEventListener(firendClicked)

	self.fj_view = self._rootNode:getChildByName("img_fujia")

end

--[[更新数据
	data 显示数据
]]
function map_info_item:update(data)
	self.data = data
	--更新显示信息
	-- --更新名次 
	local name = self._rootNode:getChildByName("txt_name");
	name:setString(data.name);
	--更新等级
	local rolegrade = self._rootNode:getChildByName("txt_role_lv");
	rolegrade:setString("LV."..data.level);
	--更新塔防等级
	local rolepower = self._rootNode:getChildByName("txt_tower_lv");
	rolepower:setString("LV."..data.towerlevel);
	-- if name == MAIN_PLAYER.baseAttr:getName() then
	-- 	self._rootNode:getChildByName("friendmark"):setVisible(false);
	-- end

	--更新头像
	local headRes = ManagerHeadRes:LoadHeadRes( self.data.headguid )
	if headRes then
		local headImage = self._rootNode:getChildByName("img_head_icon"):getChildByName("headImage");
		headImage:loadTexture(headRes);
	end
end

--是否显示附件信息
function map_info_item:setShowAppendInfo( isshow )
	self.fj_view:setVisible(isshow);
end

function map_info_item:setClickListen( listener )
	self.clickItemListen = listener;
end

--更新头像
function map_info_item:upDateHeadImage(  )
	local headImage = self._rootNode:getChildByName("img_head_icon"):getChildByName("headImage");
	headImage:loadTexture(ManagerHeadRes:getHeadResPath( self.data.headguid ));
end

function map_info_item:registerHeadUpdate( event )
	local headGuid = event._usedata[1]
	if headGuid ~= self.data.headguid then
		return;
	end
	self:upDateHeadImage();
end


return map_info_item
