--
-- Author: zangqing
-- Date: 2016-01-09 10:19:02
-- 排行榜界面

-- 此类本身就是UI的显示layer,self.resourceNode_才是根节点
local ui_map_info_layer = class("ui_map_info_layer", cc.load("mvc").ViewBase)

local class_controler_ui_map_info_btn = import(".controler_ui_map_info_btn")
local class_controler_ui_map_info_player = import(".controler_ui_map_info_player")
local class_controler_ui_map_info_guild = import(".controler_ui_map_info_guild")

ui_map_info_layer.RESOURCE_FILENAME = "ui_instance/mapinfolist/ui_map_info_layer.csb"


function ui_map_info_layer:onCreate()


    self:_registNodeEvent()
    self:_registGlobalEventListeners()

    --创建ui控制器
    self:_createControlerForUI()
    --初始化资源分配
    self:_initDynamicResConfig()
    --注册按钮事件
    self:_registButtonEvent()

    -- local size= cc.Director:getInstance():getVisibleSize()
    -- local rootNode = self:getResourceNode()
    -- rootNode:setContentSize(size)
    -- ccui.Helper:doLayout(rootNode)
    -- rootNode:setPosition(cc.p(display.cx - 640 ,display.cy - 360))

    -- local shadow_layout = rootNode:getChildByName("shadow_layout")
    -- shadow_layout:setContentSize(size)
    -- ccui.Helper:doLayout(shadow_layout)

    -- self.CurrentPage = 1;
    -- self.SumPage = 10;
    -- self.CurrentDisplayData = nil;
    -- self.CurrentShowRanking = 0;
    -- self.CurrentRankDes = "当前战力值:"
    -- self.CurrentRankType = MAIN_PLAYER.rankManager.CONST_RANKING_POWER;

    -- self:_doEventCallBack( nil, nil, 1 );

end

--注册节点事件
function ui_map_info_layer:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
        end
    end
    self.resourceNode_:registerScriptHandler(onNodeEvent)
end

--注册全局事件
function ui_map_info_layer:_registGlobalEventListeners()
    -- body
    self._globalEventListeners = {}
    local configs = {
        {modelName = "ui_map_info_layer", eventName = "refreshlist", callBack=handler(self, self.updateDisplay)},--注册地图信息控制 刷新列表
        {modelName = "ui_map_info_layer", eventName = "close", callBack=handler(self, self.close)},--注册地图信息控制 关闭
        {modelName = "ui_map_info_layer", eventName = "create", callBack=handler(self, self.showChooseItem)},
        {modelName = "ui_map_info_layer", eventName = "updateName", callBack=handler(self, self.updateName)},
        guildinfo
        -- {modelName = "ui_map_info_layer", eventName = "setUIVisible", callBack=handler(self, self._onSetUIVisible)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end

-- 创建UI控制器
function ui_map_info_layer:_createControlerForUI()
    -- print("ui_map_info_layer:_createControlerForUI=========")
    self._controlerMap = {}

    -- 上部的按钮控制器
    self._controlerMap.node_btn_top = class_controler_ui_map_info_btn.new(
        self.resourceNode_:getChildByName("node_btn_top")
    )

    -- 中部UI控制器（玩家信息）
    self._controlerMap.node_infoshow = class_controler_ui_map_info_player.new(
        self.resourceNode_:getChildByName("playerinfo")
    )
    self._controlerMap.node_infoshow:updateViewShow();

    -- 中部UI控制器（公会信息信息）
    self._controlerMap.node_infoguild = class_controler_ui_map_info_guild.new(
        self.resourceNode_:getChildByName("guildinfo")
    )
    self._controlerMap.node_infoguild:updateViewShow()

end

function ui_map_info_layer:_registButtonEvent()

end

function ui_map_info_layer:setEventCallBack( callfun )
    self._controlerEventCallBack = callfun;
end

function ui_map_info_layer:_doEventCallBack( sender, eventName, data )
    -- GLOBAL_TOUCH_CONTROL:TounchContrlScheduler(0.8);
    -- local rankType = MAIN_PLAYER.rankManager.CONST_RANKING_POWER;
    -- if data == 2 then
    --     rankType = MAIN_PLAYER.rankManager.CONST_RANKING_GRADE;
    -- elseif data == 3 then
    --     rankType = MAIN_PLAYER.rankManager.CONST_RANKING_WEALTH;
    -- end
    -- MAIN_PLAYER.rankManager:requestRankData( rankType )
    -- if self._controlerEventCallBack ~= nil then
    --  self._controlerEventCallBack(sender, eventName, data)
    -- end
end

function ui_map_info_layer:showChooseItem( event )
    local showType = event._usedata
    print("showChooseItem:",showType)
    if showType == "player" then
        dispatchGlobaleEvent("controler_ui_map_info_player", "setUIVisible", {visibleType="showAll"})
        dispatchGlobaleEvent("controler_ui_map_info_guild", "setUIVisible", {visibleType="hideAll"})
    else
        dispatchGlobaleEvent("controler_ui_map_info_player", "setUIVisible", {visibleType="hideAll"})
        dispatchGlobaleEvent("controler_ui_map_info_guild", "setUIVisible", {visibleType="showAll"})
    end
end

-- 创建UI控制器
function ui_map_info_layer:updateName(name)
    local txtname = self.resourceNode_:getChildByName("info"):getChildByName("txt_name")
    txtname:setString(name)
end


function ui_map_info_layer:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end


function ui_map_info_layer:close(res)

    -- self.ranking_view:clear( );
    --清空数据
    -- MAIN_PLAYER.rankManager:ClearData(  );
    if res == nil then
        res = self._dynamicResConfigIDs
    end

    self:removeFromParent(true)
    --清除没有使用资源
    GLOBAL_TEXTURE_CACHE:removeUnusedTextures();
    -- release_res(res)
        --     end
        -- })
end

-- ui用到独有的资源管理
function ui_map_info_layer:_initDynamicResConfig()
    -- ResConfig["ui_image/mapinfolist"] = {
    --     restype = "plist",
    --     respath = "ui_image/mapinfolist/",
    --     res = {"mapinfo"},
    -- }

    -- self._dynamicResConfigIDs = {
    --     "ui_image/mapinfolist",
    -- }
end



return ui_map_info_layer
