--
-- Author: liyang
-- Date: 2016-01-05 10:37:59
-- 图块信息显示

local class_item = import(".map_info_item")

local ui_map_info_player = class("ui_map_info_player", cc.load("mvc").ViewBase)

--[[监听全局事件名预览
eventModleName: controler_ui_map_info_mid
eventName: 
    setUIVisible     --设置显示状态

]]

ui_map_info_player.RESOURCE_FILENAME = "ui_instance/mapinfolist/viewnode/ui_map_info_player.csb"

function ui_map_info_player:onCreate()
    self:_initModels()

    self:_createControlerForUI()

    --
    self:_registGlobalEventListeners()

    self:_registNodeEvent()

    self:_registUIEvent()
end


function ui_map_info_player:_initModels()
    self._controlerMap = {}

    self.itemModel = cc.CSLoader:createNode("ui_instance/mapinfolist/viewnode/map_info_item.csb")
    self.itemModel:retain()
end

--创建控制器: UI
function ui_map_info_player:_createControlerForUI()
    --等级
    self.node_sp_level = self.resourceNode_:getChildByName("img_dikuai"):getChildByName("sp_level"):getChildByName("txt_level");
    --加成
    self.node_jiacheng_valuse = self.resourceNode_:getChildByName("txt_jiacheng_number");
    --人数
    self.node_player_number = self.resourceNode_:getChildByName("txt_map_plauer_number");
    --玩家列表
    self.node_PlayerList = self.resourceNode_:getChildByName("playlist"):getChildByName("list_1");

    --初始化数据
    self.node_sp_level:setString(MAP_DATA.lookatTileData.SpLevel);
    self.node_jiacheng_valuse:setString(MAP_DATA.lookatTileData.JiaCheng);
    self.node_player_number:setString(MAP_DATA.lookatTileData.PlayerNum);

    --创建玩家列表
    self.items = {};
    for i = 1,MAP_DATA.lookatTileData.PlayerNum do
        self.items[i] = class_item.new(
                self.itemModel:getChildByName("item"):clone()
            )
        self.node_PlayerList:pushBackCustomItem(self.items[i]:getResourceNode())
    end
end


function ui_map_info_player:_registGlobalEventListeners()
    self._globalEventListeners = {}
    local configs = {
        {modelName = "ui_map_info_player", eventName = "setUIVisible", callBack=handler(self, self._onSetUIVisible)},
        -- {modelName = "netMsg", eventName = tostring(MSG_MS2C_INTERACT_ADD), callBack=handler(self, self.addNotifyAni)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
    -- dispatchGlobaleEvent("ui_map_info_player", "setUIVisible", {visibleType="hideAll"})
end



--注册节点事件
function ui_map_info_player:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
        end
    end
    self.resourceNode_:registerScriptHandler(onNodeEvent)
end


--移除全局事件监听器
function ui_map_info_player:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end

function ui_map_info_player:_registUIEvent()
    -- 刷新在线玩家列表
   
end


function ui_map_info_player:_onSetUIVisible( event )
    local eventUseData = event._usedata
    local visibleType = eventUseData.visibleType

    --隐藏所有
    if visibleType == "hideAll" then
        self:setVisible(false)

    --显示所有
    elseif visibleType == "showAll" then
        self:setVisible(true)
    end
end

--更新界面显示
function ui_map_info_player:updateViewShow()
    -- 获得玩家的等级
    -- local playerlv = 10;
    -- -- 等级显示的文本控件
    -- local txt_tower_lv = self._view_node:getChildByName("btn_rect"):getChildByName("info_valuse");

    --更新塔防等级
end


return ui_map_info_player
