--
-- Author: zangqing
-- Date: 2016-01-09 10:19:02
-- 设置公会名称

-- 此类本身就是UI的显示layer,self.resourceNode_才是根节点
local ui_introduce_layer = class("ui_introduce_layer", cc.load("mvc").ViewBase)

ui_introduce_layer.RESOURCE_FILENAME = "ui_instance/rolelvup/ui_introduce_layer.csb"

function ui_introduce_layer:onCreate()
    
    self:_registNodeEvent()
    self:_registGlobalEventListeners()

    --创建ui控制器
    self:_createControlerForUI()
    --注册按钮事件
    self:_registButtonEvent()

    --注册UI事件
    self:_registUIEvent()

    -- self:updatesoldiershow()
end

--注册节点事件
function ui_introduce_layer:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
        end
    end
    self.resourceNode_:registerScriptHandler(onNodeEvent)
end

--注册全局事件
function ui_introduce_layer:_registGlobalEventListeners()
    -- body
    self._globalEventListeners = {}
    local configs = {
        {modelName = "ui_introduce_layer", eventName = "refreshlist", callBack=handler(self, self.updateDisplay)},--注册地图信息控制 刷新列表
        {modelName = "ui_introduce_layer", eventName = "close", callBack=handler(self, self.close)},--控制 关闭
        {modelName = "ui_introduce_layer", eventName = "updatesoldiershow", callBack=handler(self, self.updatesoldiershow)},
        -- {modelName = "netMsg", eventName = tostring(MSG_MS2C_RANK_RE), callBack=handler(self, self.updateDisplayKind)},
        -- {modelName = "ui_introduce_layer", eventName = "setUIVisible", callBack=handler(self, self._onSetUIVisible)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end

-- 创建UI控制器
function ui_introduce_layer:_createControlerForUI()
    -- -- print("ui_introduce_layer:_createControlerForUI=========")
    -- self._controlerMap = {}

    -- -- 上部的按钮控制器
    -- self._controlerMap.node_btn_top = class_controler_ui_map_info_btn.new(
    --     self.resourceNode_:getChildByName("node_btn_top")
    -- )

    -- -- 中部UI控制器（玩家信息）
    -- self._controlerMap.node_infoshow_mid = class_controler_ui_map_info_player.new(
    --     self.resourceNode_:getChildByName("node_infoshow_mid")
    -- )

    -- -- 中部UI控制器（公会信息信息）
    -- self._controlerMap.node_infoguild_mid = class_controler_ui_map_info_guild.new(
    --     self.resourceNode_:getChildByName("node_infoguild_mid")
    -- )

    -- -- 下方UI控制器（玩家列表）
    -- self._controlerMap.node_list_bottom = class_controler_ui_map_info_list.new(
    --     self.resourceNode_:getChildByName("node_list_bottom")
    -- )

    
end

--ui 事件注册
function ui_introduce_layer:_registUIEvent()
    -- 兵种图片显示
    self.img_solder = self.resourceNode_:getChildByName("img_top_back"):getChildByName("img_solder");
    -- 兵种相关文字显示
    self.txt_name = self.resourceNode_:getChildByName("txt_name");
    -- 兵种介绍显示
    self.txt_shuoming = self.resourceNode_:getChildByName("txt_shuoming");
    -- 攻击力
    self.txt_attk = self.resourceNode_:getChildByName("txt_attk");
    -- 生命
    self.txt_hp = self.resourceNode_:getChildByName("txt_hp");
    -- 攻击速度
    self.txt_atk_speed = self.resourceNode_:getChildByName("txt_atk_speed");
    -- 移动速度
    self.txt_move_speed = self.resourceNode_:getChildByName("txt_move_speed");
    -- 攻击距离
    self.txt_shecheng = self.resourceNode_:getChildByName("txt_shecheng");
    -- 攻击类型
    self.txt_atk_type = self.resourceNode_:getChildByName("txt_atk_type");

end
-- 更新显示
function ui_introduce_layer:updatesoldiershow(sid)
    -- body
    
    self.soldier_tmp = GetSoldierSetup(sid);

    local iconInfo = ResIDConfig:getResConfifByID( self.soldier_tmp.resID );
    -- print("=====ui_introduce_layer:updatesoldiershow: ", self.soldier_tmp.resID)
    -- print("=====iconInfo.smelliconImage: ", iconInfo.smelliconImage)
    self.img_solder:loadTexture(iconInfo.smelliconImage,ccui.TextureResType.plistType)
    
    self.txt_name:setString(self.soldier_tmp.name);
    
    self.txt_shuoming:setString(self.soldier_tmp.shuoming);

    self.txt_attk:setString(tostring(self.soldier_tmp.atk));
    

    self.txt_hp:setString(self.soldier_tmp.hp);
    
    local atk_speed = tostring(self.soldier_tmp.atk_invl/1000).."秒"
    self.txt_atk_speed:setString(atk_speed);
    

    self.txt_move_speed:setString(tostring(self.soldier_tmp.move_invl));
    

    self.txt_shecheng:setString(tostring(self.soldier_tmp.range));
    
    if 0==self.soldier_tmp.fanwei then
        self.txt_atk_type:setString("单体攻击");
    else
        self.txt_atk_type:setString("范围攻击");
    end
end


function ui_introduce_layer:_registButtonEvent()

    --取消
    self.btn_exit = self.resourceNode_:getChildByName("btn_exit")
    local function noClicked(sender)
        AudioManager.playButton();
        print("退出按钮")
        -- self:resetName();
        self:close(self._dynamicResConfigIDs)
    end
    self.btn_exit:addClickEventListener(noClicked)
    
end

function ui_introduce_layer:setEventCallBack( callfun )
    self._controlerEventCallBack = callfun;
end

function ui_introduce_layer:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end


function ui_introduce_layer:close(res)

    -- self.ranking_view:clear( );
    --清空数据
    -- MAIN_PLAYER.rankManager:ClearData(  );
    if res == nil then
        res = self._dynamicResConfigIDs
    end
    -- GLOBAL_COMMON_ACTION:popupBack({
    --         node = self.resourceNode_,
    --         -- shadowNode = self.resourceNode_:getChildByName("shadow_layout"),
    --         callback = function ()
    --             -- body
    self:removeFromParent(true)
    -- release_res(res)
        --     end
        -- })
end



return ui_introduce_layer
