--
-- Author: Liyang
-- Date: 2015-06-26 17:28:09
-- 更新逻辑

local event_loadres_battle = class("event_loadres_battle")

function event_loadres_battle:ctor()
    self.target_ = nil;

    self.registerConfig = {
        {"models_loadres","create",1},--创建载入资源
        {"models_loadres","show",1},--加载界面显示
        {"models_loadres","update_logic_schedule",1},--更新逻辑进度
        {"models_loadres","finish",1},--载入完成
    }
    self.nameList = {};

    self:register_event();

    --单位长度
    self.Unit_Change_Lenth = 947 / 100;

    --当前的长度
    self.Current_Len = 0;

    --进度显示值
    self.schedule_Showvaluse = 1;

    --当前资源加载逻辑进度
    self.schedule_Logicvaluse = 1;

    self.executeRun = 0;

    --单位改变值
    self.Unit_Change = 0.3;

    --进度条改变时间
    self.ActionTime = 0.2;
   
end

--注册事件
function event_loadres_battle:register_event(  )
    local defaultCallbacks = {
        models_loadres_create = handler(self, self.register_event_create),
        models_loadres_show = handler(self, self.register_event_show),
        models_loadres_update_logic_schedule = handler(self, self.register_event_update_logic_schedule),
        models_loadres_finish = handler(self, self.register_event_finish),
        -- models_loadres_updatename = handler(self, self.register_event_updatename),
        -- models_loadres_random_name = handler(self, self.register_event_random_name),
    }
    self.eventlisen = {};
    --createGlobalEventListener( modelName, eventName, callBack, fixedPriority )
    for i,v in ipairs(self.registerConfig) do
        local eventname = createGlobaleEventName( v[1], v[2] )
        if defaultCallbacks[eventname] then
            self.eventlisen[eventname] = createGlobalEventListener( v[1], v[2], defaultCallbacks[eventname], v[3] )
        end
    end
end

function event_loadres_battle:addExecuteEvent( eventname )
    if not eventname then
        return;
    end
    for i,v in ipairs(eventname) do
        table.insert(self.registerConfig, 1, eventname)
    end
    
end

--关闭事件
function event_loadres_battle:register_event_close(  )
    printInfo("register_event_close %s", "event")
    --清除事件监听
    for k,v in pairs(self.eventlisen) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v);
    end
end

--[[检查结果处理
    0 更新失败
    1 更新成功
    2 下载进度提示
    3 更新檔大小
]]
function event_loadres_battle:register_event_create( event )
    --进入资源加载界面
    APP:toScene(SCENE_ID_GAMEWORLD_RES_LOADING);
end

--[[资源加载显示
]]
function event_loadres_battle:register_event_show( event )

    self.target_ = APP:getCurScene()
    self.loadview = cc.CSLoader:createNode("ui_instance/load/loadview.csb")
    local viewsize = self.loadview:getContentSize();
    self.loadview:setPosition(cc.p(display.cx - viewsize.width/2,display.cy - viewsize.height/2));
    self.target_ :addChildToLayer(LAYER_ID_UI, self.loadview,1)

    self.loadBar = self.loadview:getChildByName("barbg"):getChildByName("LoadingBar_1");

    self.loadview:scheduleUpdateWithPriorityLua(handler(self, self.updateUI),1);
    --请求其他数据
    self:requestMsgData(  );
    self:register_event_update_logic_schedule( {_usedata = {100}} )
end

--更新逻辑进度值
function event_loadres_battle:register_event_update_logic_schedule( event )
    self.schedule_Logicvaluse = event._usedata[1];
    --执行进度更新
    self.executeRun = 1;
    self:SetRunConfig( self.schedule_Logicvaluse );
end

--载入完成
function event_loadres_battle:register_event_finish( event )
    print("载入完成 register_event_finish")
    --ManagerSDK.GameStartLogic();
    self.loadview:unscheduleUpdate();
    --载入完成
    --APP:toScene(SCENE_ID_GAMEWORLD);
    dispatchGlobaleEvent( "battlefield" ,"create");
end

--更新进入
function event_loadres_battle:updateUI( time )
    if self.schedule_Showvaluse >= 100 then
        self:register_event_finish(  );
        return;
    end
    --标示进度
    if self.executeRun == 0 then
        return; 
    end

    -- print("updateUI",self.schedule_Showvaluse,time,self.Unit_Change,self.ActionTime)
    if time > self.ActionTime then
        time = self.ActionTime / 10;
    end
    --进度条长度设置
    self.schedule_Showvaluse = self.schedule_Showvaluse + time / self.ActionTime * self.Unit_Change;

    self:SetGamePercentage(self.schedule_Showvaluse);

    if self.schedule_Showvaluse > self.schedule_Logicvaluse then
        self.executeRun = 0;
        --执行下一个
        self:excuteLoadListLogic(  );
    end
  
end

--载入列表萝莉
function event_loadres_battle:excuteLoadListLogic(  )
    --数据接收完成 50 ;
    if self.schedule_Logicvaluse == 50 then
        self:LoadGameRes(  );
    end
end

--请求数据
function event_loadres_battle:requestMsgData(  )
    --得到其他数据
    --Msg_Logic.requestData();
end

function event_loadres_battle:LoadGameRes(  )
    --初始化角色资源
   
    ResLoad:setLoadList(
        {
            "icon/heros.png",
            "icon/skills.png",
            "icon/equip.png",
            "icon/goods.png",
            -- "ui_image/mainpage/anim/zhanyi/zy3/effect_zhanyi3.png",
            -- "ui_image/mainpage/anim/zhanyi/zy3/effect_zhanyi3_mengban.png"
        },
        "event_loadres_battle",
        1
    )
    ResLoad:setCallback( function (  )
        print("event_loadres_battle:LoadGameRes finish")
    end );
    ResLoad:LoadResAndList()

    -- print("event_loadres_battle:LoadGameRes")
    --加载首次战斗数据
    ManagerBattleRes:InitBattleUseRes( Data_Battle_Msg.LoadInviData, 1,function (  )
        print("加载格式",cc.Texture2D:getDefaultAlphaPixelFormat())
        dispatchGlobaleEvent( "models_loadres" ,"update_logic_schedule",{100});
        UIManager:initializeUI();
    end);
end

--设置进度运行的参数
function event_loadres_battle:SetRunConfig( valuse)
    self.Unit_Change = valuse - self.schedule_Showvaluse;
end

--设置游戏进度值
function event_loadres_battle:SetGamePercentage( value )
    --print(value)
    self.loadBar:setPercent(value)
end



return event_loadres_battle;
