--
-- Author: liyang
-- Date: 2016-01-02 09:37:59
-- 登录UI控制

local class_controler_ui_login_layer= import(".controler_ui_login_layer")
local class_controler_register_layer= import(".controler_ui_register_layer")
---=============================================================-----------------
-- 整个主页UI的管理类
local controler_ui_layer = class("controler_ui_layer")

--[[监听全局事件名预览
eventModleName: controler_ui_layer
eventName: 
    setUIVisible     --设置显示状态

]]


function controler_ui_layer:ctor()
    self:_initModels()

    -- local visibleSize = cc.Director:getInstance():getVisibleSize()
    -- --根层
    -- self._ui_layer = mainPage_ui_layer
    -- self._ui_layer:setContentSize(visibleSize)
    -- ccui.Helper:doLayout(self._ui_layer)

    --UI容器
    -- self._UIContainer = self._ui_layer:getChildByName("UIContainer")
    -- self._UIContainer:setContentSize(visibleSize)
    -- ccui.Helper:doLayout(self._UIContainer)

    self:_createControlerForUI()

    --
    self:_registGlobalEventListeners()

    self:_registNodeEvent()

    self:_registUIEvent()
end


function controler_ui_layer:getView()
    return self._ui_layer
end


function controler_ui_layer:_initModels()
    self._controlerMap = {}
end

--创建控制器: UI
function controler_ui_layer:_createControlerForUI()
    self._controlerMap.controlLogin = class_controler_ui_login_layer.new(
        self:_createUILayer_login()
    )

    self._controlerMap.controlRegister = class_controler_register_layer.new(
       self:_createUILayer_register()
    )
    --隐藏注册界面
    self._controlerMap.controlRegister:_onSetUIVisible( {_usedata = {visibleType= "hideAll"} } )
end


function controler_ui_layer:_registGlobalEventListeners()
    self._globalEventListeners = {}
    local configs = {
        {modelName = "Login_ui_layer", eventName = "setUIVisible", callBack=handler(self, self._onSetUIVisible)},
        {modelName = "netMsg", eventName = tostring(MSG_LS2C_LOGIN_Register), callBack=handler(self, self.onRegisterSucceed)},
        {modelName = "netMsg", eventName = tostring(MSG_LS2C_LOGIN_GATEWAY_INFO), callBack=handler(self, self.onRegisterSucceed)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end


function controler_ui_layer:addNotifyAni(params)
    -- body
    self._controlerMap.functionbuttons:addNotifyAni(params._usedata.mode)
end


--注册节点事件
function controler_ui_layer:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
        end
    end
    self._controlerMap.controlLogin:getView():registerScriptHandler(onNodeEvent)
end


--移除全局事件监听器
function controler_ui_layer:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end

function controler_ui_layer:_registUIEvent()
    -- local btn_shuaguai = self._ui_layer:getChildByName("parts_r_b"):getChildByName("btn_shuaguai")
    -- local shuaguaiClick = function (  )
    --     -- if false==self._controlerMap.mapinfoListLayer:getVisible() then
    --         -- self._controlerMap.mapinfoListLayer:getView():setVisible(true);
    --     -- end
    -- end
    -- btn_shuaguai:addClickEventListener(shuaguaiClick)
end

--注册成功
function controler_ui_layer:onRegisterSucceed(  )
    --保存资料
    Data_Login:saveToLocal();
    self._controlerMap.controlRegister:_closeRegisterView(  )
    self._controlerMap.controlLogin:registerBackInfo(1)
end

--登录界面
function controler_ui_layer:_createUILayer_login()
    return cc.CSLoader:createNode("ui_instance/loginpage/ui_login_backmap_layer.csb")
end

--注册界面
function controler_ui_layer:_createUILayer_register()
    return cc.CSLoader:createNode("ui_instance/loginpage/ui_register_backmap_layer.csb")
end

function controler_ui_layer:_onSetUIVisible( event )
    local eventUseData = event._usedata
    local visibleType = eventUseData.visibleType
    local viewmark = eventUseData.view
    local view = nil;
    if viewmark == "注册" then
        view = self._controlerMap.controlRegister
    else
        view = self._controlerMap.controlLogin
    end
    --隐藏所有
    view:_onSetUIVisible( {_usedata = {visibleType= visibleType} } )
   
end


return controler_ui_layer
