--
-- Author: liyang
-- Date: 2016-01-02 09:37:59
-- 登录UI注册界面


---=============================================================-----------------
-- 整个主页UI的管理类
local controler_ui_register_layer = class("controler_ui_register_layer")

--[[监听全局事件名预览
eventModleName: controler_ui_register_layer
eventName: 
    setUIVisible     --设置显示状态

]]


function controler_ui_register_layer:ctor(mainPage_ui_layer)
    self:_initModels()

    local visibleSize = cc.Director:getInstance():getVisibleSize()
    --根层
    self._ui_layer = mainPage_ui_layer
    self.scene = APP:getCurScene()
    self.scene:addChildToLayer(LAYER_ID_UI, self._ui_layer)
    self.node_btn = self._ui_layer:getChildByName("node_btn")
    -- self._ui_layer:setContentSize(visibleSize)
    -- ccui.Helper:doLayout(self._ui_layer)

    --UI容器
    -- self._UIContainer = self._ui_layer:getChildByName("UIContainer")
    -- self._UIContainer:setContentSize(visibleSize)
    -- ccui.Helper:doLayout(self._UIContainer)

    self:_createControlerForUI()

    --
    self:_registGlobalEventListeners()

    self:_registNodeEvent()

    self:_registUIEvent()
end


function controler_ui_register_layer:getView()
    return self._ui_layer
end


function controler_ui_register_layer:_initModels()
    self._controlerMap = {}
end

--创建控制器: UI
function controler_ui_register_layer:_createControlerForUI()
end


function controler_ui_register_layer:_registGlobalEventListeners()
    self._globalEventListeners = {}
    local configs = {
        {modelName = "controler_ui_register_layer", eventName = "setUIVisible", callBack=handler(self, self._onSetUIVisible)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end


function controler_ui_register_layer:addNotifyAni(params)
    -- body
    self._controlerMap.functionbuttons:addNotifyAni(params._usedata.mode)
end


--注册节点事件
function controler_ui_register_layer:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
        end
    end
    self._ui_layer:registerScriptHandler(onNodeEvent)
end


--移除全局事件监听器
function controler_ui_register_layer:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end

function controler_ui_register_layer:_registUIEvent()
    self.contrl_show = 0;
    local btn_back = self.node_btn:getChildByName("btn_back")
    local backClick = function (  )
        print("注册返回")
        AudioManager.playButton();
        self:getView():setVisible(false);
        local inputAccountView = self.node_btn:getChildByName("sp_input_back_zhanghao"):getChildByName("txt_input_zhanghao")
        local account = inputAccountView:setString("");
        local inputPasswordView = self.node_btn:getChildByName("sp_input_back_psw"):getChildByName("txt_input_psw")
        local password = inputPasswordView:setString("");
        local inputagainPasswordView = self.node_btn:getChildByName("sp_input_back_psw_0"):getChildByName("txt_input_psw")
        local againpassword = inputagainPasswordView:setString("");
        dispatchGlobaleEvent( "Login_ui_layer" ,"setUIVisible", {visibleType = "showAll",view = "登录"});
    end
    btn_back:addClickEventListener(backClick)

    local btn_register = self.node_btn:getChildByName("btn_kuaisu_zhuce")
    local registerClick = function (  )
        print("账号注册")
        AudioManager.playButton();
        self:executeRegister(  );
    end
    btn_register:addClickEventListener(registerClick)

    self.contrl_show = 1;
    -- local btn_reset = self._ui_layer:getChildByName("btn_change_psw")
    -- local resetClick = function (  )
    --     print("修改密码")
    --     -- APP:toScene(SCENE_ID_GAMEWORLD)
       
    -- end
    -- btn_reset:addClickEventListener(resetClick)

end

function controler_ui_register_layer:_closeRegisterView(  )
    self:getView():setVisible(false);
    local inputAccountView = self.node_btn:getChildByName("sp_input_back_zhanghao"):getChildByName("txt_input_zhanghao")
    local account = inputAccountView:setString("");
    local inputPasswordView = self.node_btn:getChildByName("sp_input_back_psw"):getChildByName("txt_input_psw")
    local password = inputPasswordView:setString("");
    local inputagainPasswordView = self.node_btn:getChildByName("sp_input_back_psw_0"):getChildByName("txt_input_psw")
    local againpassword = inputagainPasswordView:setString("");
end

function controler_ui_register_layer:executeRegister(  )
    local inputAccountView = self.node_btn:getChildByName("sp_input_back_zhanghao"):getChildByName("txt_input_zhanghao")
    local account = inputAccountView:getString();
    local inputPasswordView = self.node_btn:getChildByName("sp_input_back_psw"):getChildByName("txt_input_psw")
    local password = inputPasswordView:getString();
    local inputagainPasswordView = self.node_btn:getChildByName("sp_input_back_psw_0"):getChildByName("txt_input_psw")
    local againpassword = inputagainPasswordView:getString();
    
    --[[
        1.账号大于6，账号必须是邮箱，账号长度不能超过30
        2.密码大于6，密码不能超过20
    ]]
    if account and (string.len(account) < 6 or string.len(account) >= 20)   then
        --账号长度大小在6~30之间
        UIManager:CreatePrompt_Bar( {
            content = "账号长度大小在6~20之间",
            } )
    -- elseif not string.find(account,"@") then
    --  --不是邮箱
    --  self.rootNode.errorText:setString("账号必须是邮箱");
    elseif password and (string.len(password) < 6 or string.len(password) >= 20) then
        --密码长度大小在6~20之间
        UIManager:CreatePrompt_Bar( {
            content = "密码长度大小在6~20之间",
            } )
    elseif password ~= againpassword then
        UIManager:CreatePrompt_Bar( {
            content = "两次输入密码不一样",
            } )
    else
        -- 发送账号注册消息
        Data_Login.account = account;
        Data_Login.password = password;--crypto.md5(password);
        Data_Login.Logic_Operation = 3;--注册账户
        Msg_Logic.ConnectLS_Logic();
    end
end


function controler_ui_register_layer:_onSetUIVisible( event )
    local eventUseData = event._usedata
    local visibleType = eventUseData.visibleType

    --隐藏所有
    if visibleType == "hideAll" then
        self._ui_layer:setVisible(false)

    --显示所有
    elseif visibleType == "showAll" then
        self._ui_layer:setVisible(true)
    end
    
end


return controler_ui_register_layer
