--
-- Author: li yang
-- Date: 2016-01-09 14:17:45
-- 下载地图文件

local DowanMapImage = class("DowanMapImage");

function DowanMapImage:ctor()
	--下载工具
	self.dowanTool = nil;
	--更新的位置
	self.dowanInfo = nil;

	self.requestCount = 0;
end

function DowanMapImage:InitTool(  )
	self.dowanTool = cc.AssetsManagerM:new();
    self.dowanTool:retain();
    self.dowanTool:setDelegate(handler(self, self.CallBack_Error),cc.ASSETSMANAGER_PROTOCOL_ERROR );
    self.dowanTool:setDelegate(handler(self, self.CallBack_Progress), cc.ASSETSMANAGER_PROTOCOL_PROGRESS)
    self.dowanTool:setDelegate(handler(self, self.CallBack_Success), cc.ASSETSMANAGER_PROTOCOL_SUCCESS )
    self.dowanTool:setDelegate(function ( state )
    	-- body
    end, cc.ASSETSMANAGER_PROTOCOL_STATE )
    self.dowanTool:setConnectionTimeout(0)
    print(self.dowanTool);
end

--错误回调
function DowanMapImage:CallBack_Error( valuse )
	print("DowanMapImage","CallBack_Error:"..valuse);
	if self.requestCount < 2 then
		self:executeDowanMapImage( self.Url , self.savefile ,self.dowanInfo );
	else
		--去掉处理记录列表
		managerMapDownloadInstance:removeRecordList_CurrentDisposeMapTileList(self.dowanInfo.des);
		self:clear();
	end
	if self.errorLogic then
		self.errorLogic(valuse);
	end

end

--进度回调
function DowanMapImage:CallBack_Progress( valuse )
	print("DowanMapImage","CallBack_Progress:"..valuse..tostring(self));
	if self.progressLogic then
		self.progressLogic(valuse);
	end
end

--完成回调
function DowanMapImage:CallBack_Success(  )
	print("DowanMapImage","CallBack_Success:");
	--判断下载是否成功
	local issuccess = false;
	local filesize = 0;
	if cc.FileUtils:getInstance():isFileExist(self.savefile) then
		--得到数据
        filesize = cc.FileUtils:getInstance():getFileSize(self.savefile);
        if filesize / 1024 > 50 then
        	issuccess = true;
        else
        	managerMapDownloadInstance.requestFailList[self.dowanInfo.des] = 1;
        end
    end
   if issuccess then
   		issuccess = LoadPngImageByFileName( "maptile/"..MAP_DATA.CurrentCacheMapCityCode.."/"..self.dowanInfo.des );
	    if not issuccess then
	        print("LoadPngImageByFileName 失败")
	        managerMapDownloadInstance.requestFailList[self.dowanInfo.des] = 1;
	    end
   end
	print("CallBack_Success ",issuccess,filesize)

	if issuccess then
		--创建精灵
		dispatchGlobaleEvent("controler_mapPage_map_layer", "updateMapImageTitle", 
			{
				imagename = "maptile/"..MAP_DATA.CurrentCacheMapCityCode.."/"..self.dowanInfo.des,
				x = self.dowanInfo.center[1] * 1024,
				y = self.dowanInfo.center[2] * 1024,
			}
		)
		if self.successLogic then
			self.successLogic(valuse);
		end
		--去掉处理记录列表
		managerMapDownloadInstance:removeRecordList_CurrentDisposeMapTileList(self.dowanInfo.des);
		--添加缓存列表
		managerMapDownloadInstance:AddRecordList_CurrentBufferMapTile(self.dowanInfo);
		--添加显示列表
        managerMapDownloadInstance:AddRecordList_CurrentShowMapTile(self.dowanInfo);
		self:clear();
	else
		if self.requestCount < 2 then
			self:executeDowanMapImage( self.Url , self.savefile ,self.dowanInfo );
		else
			--去掉处理记录列表
			managerMapDownloadInstance:removeRecordList_CurrentDisposeMapTileList(self.dowanInfo.des);
			self:clear();
		end
	end

	
end

function DowanMapImage:executeDowanMapImage( url , savepath ,info)
	self.dowanTool:update(url,savepath);
	self.Url = url;
	self.dowanInfo = info;
	self.savefile = savepath;
	self.requestCount = self.requestCount + 1;
end

function DowanMapImage:setDowanCallBack( success , progress ,error )
	self.errorLogic = error;
	self.successLogic = success;
	self.progressLogic = progress;
end

function DowanMapImage:clear()
	self.dowanTool:release();
end

return DowanMapImage;