--
-- Author: liyang
-- Date: 2016-01-02 09:37:59
-- 地图块渲染层


local controler_mapPage_map_Title_layer = class("controler_mapPage_map_Title_layer")

local class_map_piece_item = require("app.views.map.view.map_piece_item")

local class_unitTile = require("app.models.player.map.unitTile")

--[[监听全局事件名预览
eventModleName: controler_mapPage_map_Title_layer
eventName: 
    setUIVisible     --设置显示状态

]]


function controler_mapPage_map_Title_layer:ctor(mainPage_ui_layer )
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    --根层
    self._view_layer = mainPage_ui_layer

    self._view_layer:setCascadeOpacityEnabled(true)
    self._view_layer:setOpacity(200);

    self:_initModels()

    self:_createControlerForUI()

    self:_registGlobalEventListeners()

    self:_registNodeEvent()

    self:_registUIEvent()

    self.MapPiecePool = {};
end


function controler_mapPage_map_Title_layer:getView()
    return self._view_layer
end


function controler_mapPage_map_Title_layer:_initModels()
    self._controlerMap = {}
end

--创建控制器: UI
function controler_mapPage_map_Title_layer:_createControlerForUI()

end


function controler_mapPage_map_Title_layer:_registGlobalEventListeners()
    self._globalEventListeners = {}
    local configs = {
        {modelName = "controler_mapPage_map_Title_layer", eventName = "updateshow", callBack=handler(self, self.onUpdateMapPieceInfo)},
        {modelName = "controler_mapPage_map_Title_layer", eventName = "update_act_state", callBack=handler(self, self.onUpdateMapPieceActState)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end


--注册节点事件
function controler_mapPage_map_Title_layer:_registNodeEvent()
    -- local function onNodeEvent(event)
    --     if "exit" == event then
    --         self:_removeAllGlobalEventListeners()
    --     elseif "enterTransitionFinish" == event then

    --     end
    -- end
    -- self._view_layer:registerScriptHandler(onNodeEvent)
end


--移除全局事件监听器
function controler_mapPage_map_Title_layer:_removeAllGlobalEventListeners()
    print("controler_mapPage_map_Title_layer:_removeAllGlobalEventListeners")
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end


function controler_mapPage_map_Title_layer:_registUIEvent()
    
end

--[[更新图块信息
]]
function controler_mapPage_map_Title_layer:onUpdateMapPieceInfo( event )

    local isUpdate_pos = event._usedata.poschange;--位置更新
    local isUpdate_scale = event._usedata.scalechange;--zoom 更新
    local isUpdate_state = event._usedata.statechange;--状态更新
    --根据中心点位置设置坐标
    if isUpdate_pos then
        local x , y = MAP_DATA.TileDrawInfo:getTitleMapDrawLocation(  )
        self._view_layer:setPosition(cc.p(x , y))
    end
    
    print("更新图块信息:","scale:",isUpdate_scale,"state:",isUpdate_state,"pos:",isUpdate_pos,MAP_DATA.CurrentTileInfo.vectorType)
    --更新缩放比例
    if isUpdate_scale or isUpdate_state then
        for y=-MAP_DATA.TileDrawInfo.draw_height / 2,MAP_DATA.TileDrawInfo.draw_height / 2 do
            for x=-MAP_DATA.TileDrawInfo.draw_width / 2,MAP_DATA.TileDrawInfo.draw_width / 2 do
                local index = x.."_"..y;
                if self.MapPiecePool[index] then
                    local draw_x , draw_y = MAP_DATA.CurrentTileInfo:getPixelLocationByMapPos( { x = x ,y = y} )
                    -- print(x,y,draw_x , draw_y)
                    self.MapPiecePool[index]:setShowPostion( draw_x ,draw_y );
                    self.MapPiecePool[index]:update(MAP_DATA.TileDrawInfo:getPiece( index ))
                end
            end
        end
    end
end

function controler_mapPage_map_Title_layer:onUpdateMapPieceActState( event )
    local data = event._usedata;
    local index = data.pos_x.."_"..data.pos_y;
    if self.MapPiecePool[index] then
        self.MapPiecePool[index]:update(data);
    end
end

--[[绘制图块信息
    paramsv = {
        showNode = null,

    }
]]
function controler_mapPage_map_Title_layer:_InitDrawTitle(  )
    for y=-MAP_DATA.TileDrawInfo.draw_height / 2,MAP_DATA.TileDrawInfo.draw_height / 2 do
        for x=-MAP_DATA.TileDrawInfo.draw_width / 2,MAP_DATA.TileDrawInfo.draw_width / 2 do
            local data = MAP_DATA.TileDrawInfo:getPiece( x.."_"..y );
            -- print(x,y , data);
            local piece = self:CreateMapPieceItem( data );
            local draw_x , draw_y = MAP_DATA.CurrentTileInfo:getPixelLocationByMapPos( { x = x ,y = y} )
            print("_InitDrawTitle",x,y,draw_x , draw_y)
            piece:setShowPostion( draw_x ,draw_y );
            self._view_layer:addChild(piece:getResourceNode(), 10);
            self.MapPiecePool[x.."_"..y] = piece;
        end
    end

    --根据中心点位置设置坐标
    local x , y = MAP_DATA.TileDrawInfo:getTitleMapDrawLocation(  )
    print("_DrawTitle",x,y)
    self._view_layer:setPosition(cc.p(x , y))
end


function controler_mapPage_map_Title_layer:MapPieceItemModel(  )
    return cc.CSLoader:createNode("ui_instance/mainpage/mapparts/map_piece_node.csb");
    -- self.MapPieceItemModel = piece
end

function controler_mapPage_map_Title_layer:CreateMapPieceItem( data )
    local piece = class_map_piece_item.new(self:MapPieceItemModel(  ));
    piece:update(data);
    return piece;
end

function controler_mapPage_map_Title_layer:_onSetUIVisible( event )
    local eventUseData = event._usedata
    local visibleType = eventUseData.visibleType

    --隐藏所有
    if visibleType == "hideAll" then
        self._view_layer:setVisible(false)

    --显示所有
    elseif visibleType == "showAll" then
        self._view_layer:setVisible(true)
    end
    
end


return controler_mapPage_map_Title_layer
