--
-- Author: liyang
-- Date: 2016-01-02 09:37:59
-- 主界面地图层

local class_controler_mapPage_map_tounch_layer = import(".controler_mapPage_map_tounch_layer")
local class_controler_mapPage_map_Title_layer = import(".controler_mapPage_map_Title_layer")


local controler_mapPage_map_layer = class("controler_mapPage_map_layer")

--[[监听全局事件名预览
eventModleName: controler_mapPage_map_layer
eventName: 
    setUIVisible     --设置显示状态

]]


function controler_mapPage_map_layer:ctor(mainPage_ui_layer)
    
    -- MAIN_PLAYER.mapManager:setMapInfo( {
    --                 width = 200,
    --             } );
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    --根层
    self._view_layer = mainPage_ui_layer
    self:_initModels()
    -- self._view_layer:setContentSize(visibleSize)
    -- ccui.Helper:doLayout(self._view_layer)

    --UI容器
    -- self._UIContainer = self._view_layer:getChildByName("UIContainer")
    -- self._UIContainer:setContentSize(visibleSize)
    -- ccui.Helper:doLayout(self._UIContainer)

    self:_createControlerForUI()

    --
    self:_registGlobalEventListeners()

    self:_registNodeEvent()

    self:_registUIEvent()

    self.MapTileSpriteList = {};
end


function controler_mapPage_map_layer:getView()
    return self._view_layer
end


function controler_mapPage_map_layer:_initModels()
    self._controlerMap = {}
    
    self.backShowNode_0 = self._view_layer:getChildByName("map"):getChildByName("shownode");
    self.backShowNode_1 = self._view_layer:getChildByName("map"):getChildByName("shownode0");
    -- self.operateNode_0 = self.backShowNode:getChildByName("operatenode");
    -- self.operateNode_1 = self.backShowNode:getChildByName("operatenode_0");
    self.shadeNode = self._view_layer:getChildByName("Panel_1");
    self:setCurrentOperateLayer( 0 );
end

--创建控制器: UI
function controler_mapPage_map_layer:_createControlerForUI()
    --UI右下部分控制器
    -- self._controlerMap.parts_right_bottom = class_controler_mainPage_ui_right_bottom.new(
    --     self._view_layer:getChildByName("parts_r_b")
    -- )
    -- --ui右上部分控制器
    -- self._controlerMap.parts_right_top = class_controler_mainPage_ui_right_top.new(
    --     self._view_layer:getChildByName("parts_info")
    -- )
    self._controlerMap.parts_TounchControl = class_controler_mapPage_map_tounch_layer.new( self._view_layer:getChildByName("tounchLayer"),self)
    self.TileNode = cc.Node:create();
    self.TileNode:retain();
    -- local _sprite_0 = cc.Sprite:createWithSpriteFrameName("ui_image/common/button/btn_jian_0.png");
    -- self.TileNode:addChild(_sprite_0, 100);
    self._controlerMap.parts_Title = class_controler_mapPage_map_Title_layer.new(self.TileNode);
    -- print("controler_mapPage_map_layer 2")


end


function controler_mapPage_map_layer:_registGlobalEventListeners()
    self._globalEventListeners = {}
    local configs = {
        {modelName = "controler_mapPage_map_layer", eventName = "setVisible", callBack=handler(self, self._onSetUIVisible)},
        -- {modelName = "controler_mapPage_map_layer", eventName = "updateMapInfo", callBack=handler(self, self.updateMapShow)},
        {modelName = "controler_mapPage_map_layer", eventName = "updateMapImageTitle", callBack=handler(self, self._createMapTileSprite)},
        {modelName = "controler_mapPage_map_layer", eventName = "checkImageSpiteShow", callBack=handler(self, self._CheckMapTileSpriteShow)},
        {modelName = "controler_mapPage_map_layer", eventName = "updateOneselfpos", callBack=handler(self, self.drawOneselfPos)},
    }
    self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end


--[[设置当前操作的节点(主要用于zoom 切换)
    1.将当前操作节点顶至
    2.更新操作的一些节点
    3.0 标示 backShowNode_0 1 backShowNode_1
]]
function controler_mapPage_map_layer:setCurrentOperateLayer( params )
    self.CurrentOperateLayer = params;
    if params == 0 then
        self.CurrentBackShowNode = self.backShowNode_0;
        self.backShowNode_0:setLocalZOrder(1);
        self.backShowNode_1:setLocalZOrder(0);
    else
        self.CurrentBackShowNode = self.backShowNode_1;
        self.backShowNode_0:setLocalZOrder(0);
        self.backShowNode_1:setLocalZOrder(1);
    end
    self.CurrentOperateNode = self.CurrentBackShowNode:getChildByName("operatenode");
    self.pieceShowNode = self.CurrentOperateNode:getChildByName("pieceViewPool");
    self.backImage = self.CurrentOperateNode:getChildByName("backimage")
    --更新图块显示
    if self.TileNode then
        self.TileNode:removeFromParent();
        self.pieceShowNode:addChild(self.TileNode,1);
        print("setCurrentOperateLayer")
        -- self.TileNode:setScale(1 / MAP_DATA.CONST_ZOOM_RATION[MAP_DATA.Map_zoom]);
        -- MAP_DATA.TileInfo:SetTitleInfo( {
        --     width = 200, --* 1 / MAP_DATA.CONST_ZOOM_RATION[MAP_DATA.Map_zoom],
        --     scale = { x = 1, y = 1},
        --     }  )
    end
    
    --遮罩模板
    self.shadeNode:removeFromParent();
    self.pieceShowNode:addChild(self.shadeNode,0);
    -- self.shadeNode:setVisible(false);
    self:refreshShadePostion(  )
    if self.OneselfSprite then
        self.OneselfSprite:removeFromParent();
        self.CurrentOperateNode:addChild(self.OneselfSprite);
    end
end

function controler_mapPage_map_layer:SwitchOperateLayer( pos )
    if self.CurrentOperateLayer == 0 then
        self:setCurrentOperateLayer( 1 )
    else
        self:setCurrentOperateLayer( 0 )
    end
    if pos then
        self:_updatemapPotion( pos );
    end
    self:_updatemapScale( 1 );
end


--绘制自己位置
function controler_mapPage_map_layer:drawOneselfPos( event )
    print("drawOneselfPos")
    local lon = event._usedata.lon;
    local lat = event._usedata.lat;
    local direction = event._usedata.direction;
    local x ,y = managerMapDownloadInstance:getMapPosByLonAndLat( lon , lat );
    if not self.OneselfSprite then
        self.OneselfSprite = cc.Sprite:create("ui_image/common/button/btn_arrow_n.png");
        self.OneselfSprite:retain();
        self.CurrentOperateNode:addChild(self.OneselfSprite,10);
    end
    self.OneselfSprite:setPosition(cc.p(x,y));
    self.OneselfSprite:setRotation(direction);
end

function controler_mapPage_map_layer:refreshShadePostion(  )

    local pos = self.pieceShowNode:convertToNodeSpace(display.CENTER)
    self.shadeNode:setPosition(cc.p(pos.x + 500,pos.y + 700));
end

--更新地图显示
function controler_mapPage_map_layer:updateMapShow( pos , scale , image)
    if pos then
        self:_updatemapPotion( pos )
    end

    if scale then
        self:_updatemapScale( scale )
    end

    if image then
        self:_updaeImage(  )
    end
end

--检查地图精灵显示
function controler_mapPage_map_layer:_CheckMapTileSpriteShow( event )
    local checkList =  event._usedata;
    for k,v in pairs(checkList) do
        if self.MapTileSpriteList["maptile/"..MAP_DATA.CurrentCacheMapCityCode.."/"..k] then
            print("清理地图精灵",k);
            self.MapTileSpriteList["maptile/"..MAP_DATA.CurrentCacheMapCityCode.."/"..k]:removeFromParent();
            --清除纹理
            GLOBAL_TEXTURE_CACHE:removeTextureForKey("maptile/"..MAP_DATA.CurrentCacheMapCityCode.."/"..k);
        end
    end
end

--创建地图块
function controler_mapPage_map_layer:_createMapTileSprite( event )
    local imagename = event._usedata.imagename;
    local draw_x = event._usedata.x;
    local draw_y = event._usedata.y;
    print("controler_mapPage_map_layer:_createMapTileSprite",imagename)
    local imagesprite = cc.Sprite:create(imagename);
    if imagesprite then
        self.backImage:addChild(imagesprite);
        imagesprite:setPosition(cc.p(draw_x,draw_y));
        self.MapTileSpriteList[imagename] = imagesprite;
    end
end

--地图背景改变
function controler_mapPage_map_layer:_updaeImage(  )
    -- self.backImage:loadTexture("map/blank2.png");
    -- cc.Director:getInstance():getTextureCache():removeTextureForKey("map_image_0.png")
    -- self.backImage:loadTexture("map_image_0.png");
end

--地图缩放逻辑
function controler_mapPage_map_layer:_updatemapScale( scalevaluse )
    self.CurrentBackShowNode:setScale(scalevaluse);
end

--地图移动效果
function controler_mapPage_map_layer:_updatemapPotion( pos )
    self.CurrentOperateNode:setPosition(cc.p(pos.x ,pos.y));
    self:refreshShadePostion(  );
end


--注册节点事件
function controler_mapPage_map_layer:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
            managerMapDownloadInstance:clear();
        elseif "enterTransitionFinish" == event then
            --开启地图更新模式
            self:_initMapDataInfo( );
            
        end
    end
    self._view_layer:registerScriptHandler(onNodeEvent)
end

--初始地图数据
function controler_mapPage_map_layer:_initMapDataInfo(  )
    -- 设置图块信息
    MAP_DATA:initData(  );
    print("开启地图检查计时器")
    managerMapDownloadInstance:openMapTileUpdateScheduler(  );
    print("初始绘制地图块")
    --绘制地图6边行块
    self:DrawTitleNode();
    print("初始绘制自己位置")
    --绘制自己位置
    self:drawOneselfPos( {_usedata = {lon = MAIN_PLAYER.baseAttr._LoctionInfo.Longitude,lat = MAIN_PLAYER.baseAttr._LoctionInfo.Latitude ,direction = 0}});
    
    --更新玩家当前位置
    MAP_DATA:returnPlayerPos();

    --执行遮罩层移动
    self.shadeEffeftNode = self._view_layer:getChildByName("shadeLayer"):getChildByName("shade_rect");
    -- local effectAction = cc.CSLoader:createTimeline("ui_instance/mainpage/ui_main_map_shade_layer.csb")
    -- self.shadeEffeftNode:runAction(effectAction)
    -- effectAction:gotoFrameAndPlay(0,true);
end


function controler_mapPage_map_layer:DrawTitleNode(  )
    self._controlerMap.parts_Title:_InitDrawTitle(  );
    self.pieceShowNode:addChild(self.TileNode,1)
end


--移除全局事件监听器
function controler_mapPage_map_layer:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end

--判断点是否在屏幕内
function controler_mapPage_map_layer:isPointInTopHalfAreaOfScreen(pt)
    local winSize = cc.Director:getInstance():getWinSize()
    if pt.y >= winSize.height / 2 then
        return true
    end
    
    return false
end

--判断某点是否在节点内
function controler_mapPage_map_layer:isPointInNode(pt, node)
    --转换为node坐标
    local locationInNode = node:convertToNodeSpace(pt)
    local s = node:getContentSize()
    local rect = cc.rect(0, 0, s.width, s.height)
    if cc.rectContainsPoint(rect, locationInNode) then
        return true
    end
    return false
end

function controler_mapPage_map_layer:_registUIEvent()
    
    -- local shuaguaiClick = function (  )
    --     print("btn_shuaguai clickcallback")
    -- end
    -- btn_shuaguai:addClickEventListener(shuaguaiClick)

    -- local mapNode = self._view_layer:getChildByName("map")
    -- --监听按键事件
    -- local function touchEvent(sender,eventType)
    --     if eventType == ccui.TouchEventType.began then
    --         -- self._displayValueLabel:setString("Touch Down")
    --         print("Touch Down")
    --     elseif eventType == ccui.TouchEventType.moved then
    --         print("Touch Move")
    --     elseif eventType == ccui.TouchEventType.ended then
    --         print("Touch Up")
    --     elseif eventType == ccui.TouchEventType.canceled then
    --         print("Touch Cancelled")
    --     end
    -- end
    -- self.backImage:addTouchEventListener(touchEvent);
    -- self._view_layer:getChildByName("tounchLayer"):setLocalZOrder(2);
    self._view_layer:getChildByName("map"):setSwallowTouches(false)
    -- self._view_layer:getChildByName("Panel_3"):setPropagateTouchEvents(true)
    -- print("==================>",self._view_layer:getChildByName("Panel_3"):getDescription(),self._view_layer:getChildByName("Panel_3"):isTouchEnabled())
end


function controler_mapPage_map_layer:_onSetUIVisible( event )
    local eventUseData = event._usedata
    local visibleType = eventUseData.visibleType

    --隐藏所有
    if visibleType == "hideAll" then
        self._view_layer:setVisible(false)

    --显示所有
    elseif visibleType == "showAll" then
        self._view_layer:setVisible(true)
    end
end



return controler_mapPage_map_layer
