--
-- Author: liyang
-- Date: 2016-01-02 09:37:59
-- 地图点击事件层 主要监听多点触控


local controler_mapPage_map_tounch_layer = class("controler_mapPage_map_tounch_layer")

--[[监听全局事件名预览
eventModleName: controler_mapPage_map_tounch_layer
eventName: 
    setUIVisible     --设置显示状态

]]


function controler_mapPage_map_tounch_layer:ctor(mainPage_ui_layer , operatenode)
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    --根层
    self._view_layer = mainPage_ui_layer
    self._operate_view = operatenode;
    self:_initModels()

    self:_createControlerForUI()
    --
    self:_registGlobalEventListeners()

    self:_registNodeEvent()

    self:_registUIEvent()

    self.TounchEventType = 0;

    self.referencePos = {x = 360,y = 706};
end


function controler_mapPage_map_tounch_layer:getView()
    return self._view_layer
end


function controler_mapPage_map_tounch_layer:_initModels()
    self._controlerMap = {}
end

--创建控制器: UI
function controler_mapPage_map_tounch_layer:_createControlerForUI()

end


function controler_mapPage_map_tounch_layer:_registGlobalEventListeners()
    self._globalEventListeners = {}
    -- local configs = {
    --     {modelName = "controler_mapPage_map_tounch_layer", eventName = "setVisible", callBack=handler(self, self._onSetUIVisible)},
    --     {modelName = "controler_mapPage_map_tounch_layer", eventName = "updateImage", callBack=handler(self, self._updaeImage)},
    -- }
    -- self._globalEventListeners = createGlobalEventListenerWithConfig(configs)
end


--注册节点事件
function controler_mapPage_map_tounch_layer:_registNodeEvent()
    local function onNodeEvent(event)
        if "exit" == event then
            self:_removeAllGlobalEventListeners()
        elseif "enterTransitionFinish" == event then
            --todo
        end
    end
    self._view_layer:registerScriptHandler(onNodeEvent)
end


--移除全局事件监听器
function controler_mapPage_map_tounch_layer:_removeAllGlobalEventListeners()
    for k,v in pairs(self._globalEventListeners) do
        GLOBAL_EVENT_DISPTACHER:removeEventListener(v)
    end
end

--判断点是否在屏幕内
function controler_mapPage_map_tounch_layer:isPointInTopHalfAreaOfScreen(pt)
    --判断距离是否
    --local winSize = cc.Director:getInstance():getWinSize()

    local dir = cc.pGetDistance(pt,self.referencePos);
    print("isPointInTopHalfAreaOfScreen",dir)
    if dir > 320 then
        return true
    end
    
    return false
end

--判断某点是否在节点内
function controler_mapPage_map_tounch_layer:isPointInNode(pt, node)
    --转换为node坐标
    local locationInNode = node:convertToNodeSpace(pt)
    local s = node:getContentSize()
    local rect = cc.rect(0, 0, s.width, s.height)
    if cc.rectContainsPoint(rect, locationInNode) then
        return true
    end
    return false
end

function controler_mapPage_map_tounch_layer:_registUIEvent()
    
    --多点触控
    local function onTouchesBegan(touches, event)
        print("onTouchesBegan",#touches)
        local pos = touches[1]:getLocation();
        -- CallAndroidPrint( "onTouchesBegan:"..#touches..","..pos.x..","..pos.y..",TounchEventType:"..self.TounchEventType);
        if self:isPointInTopHalfAreaOfScreen(touches[1]:getLocation()) then
            print("onTouchesBegan")
            -- CallAndroidPrint( "onTouchesBegan -1");
            return false
        end
        
        if self.startTwoParam then
            -- self.startTwoParam.pos_2 = touches[1]:getLocation();
            -- self.startTwoParam.dis = cc.pGetDistance(self.startTwoParam.pos_1,self.startTwoParam.pos_2);
            -- self.TounchEventType = 2;--多点触控
        else
            self.startTwoParam = {};
            self.startTwoParam.beginPos = touches[1]:getLocation();
            self.startTwoParam.pos_1 = touches[1]:getLocation();
            self.TounchEventType = 1;--单点触控
            self.IsTounchEvent = true;
        end
    end

    local function onTounchesMove( touches, event )
        --得到触摸点数
        if not self.IsTounchEvent then
            return;
        end

        local tounchesNumber = table.nums(touches);
        -- CallAndroidPrint( "onTounchesMove:"..#touches);

        if tounchesNumber >= 2 then
            if self.TounchEventType == 1 then
                self.startTwoParam = {};
                self.startTwoParam.pos_1 = touches[1]:getLocation();
                self.startTwoParam.pos_2 = touches[2]:getLocation();
                self.startTwoParam.dis = cc.pGetDistance(self.startTwoParam.pos_1,self.startTwoParam.pos_2);
                self.TounchEventType = 2
            end
            self:TouchesAllMoveLogic( touches[1]:getLocation() ,touches[2]:getLocation() );
        else
            self:TounchesOneMoveLogic( touches[1]:getLocation() );
        end
    end

    local function onTouchesEnd(touches, event)
        
        local dd = touches[1]:getLocation();
        -- CallAndroidPrint("onTouchesEnd==>"..#touches..",x = "..dd.x)
        self:TouchesAllEndLogic( dd )
    end

    local touchAllAtOnceListener = cc.EventListenerTouchAllAtOnce:create()
    -- touchAllAtOnceListener:setSwallowTouches(true)
    touchAllAtOnceListener:registerScriptHandler(onTouchesBegan,cc.Handler.EVENT_TOUCHES_BEGAN )
    touchAllAtOnceListener:registerScriptHandler(onTounchesMove,cc.Handler.EVENT_TOUCHES_MOVED )
    touchAllAtOnceListener:registerScriptHandler(onTouchesEnd,cc.Handler.EVENT_TOUCHES_ENDED )
    
    local eventDispatcher = APP:getCurScene():getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(touchAllAtOnceListener, self._view_layer)
    -- local size = self._view_layer:getContentSize()
    -- print("==================>",self._view_layer:getDescription(),self._view_layer:getChildrenCount(),size.height)

    -- self._view_layer:setSwallowTouches(true)
    -- print("=====",touchAllAtOnceListener:isSwallowTouches());
end

controler_mapPage_map_tounch_layer.MapHandleConfig = {
    minMoveDis = 20,--最小移动像素
    unitScale = 0.04,--单位缩放大小
}

-------------------------------------移动事件逻辑---------------------------------

--[[多点移动事件逻辑
]]
function controler_mapPage_map_tounch_layer:TouchesAllMoveLogic( pos_1 ,pos_2 )
    if not (self.TounchEventType == 2) then
        return;
    end
    -- CallAndroidPrint( "tounchesNumber TouchesAllMoveLogic 0")
    local dis_1 = cc.pGetDistance(self.startTwoParam.pos_1,pos_1)
    local dis_2 = cc.pGetDistance(self.startTwoParam.pos_2,pos_2)
    if dis_1 < self.MapHandleConfig.minMoveDis and dis_2 < self.MapHandleConfig.minMoveDis then
        -- CallAndroidPrint( "tounchesNumber TouchesAllMoveLogic:"..dis_1..","..dis_2)
        return;
    end

    local dis = cc.pGetDistance(pos_1,pos_2);
    local scalevaluse = (dis - self.startTwoParam.dis) / self.MapHandleConfig.minMoveDis * self.MapHandleConfig.unitScale;
    --重置初始点
    self.startTwoParam.pos_1 = pos_1;
    self.startTwoParam.pos_2 = pos_2;
    self.startTwoParam.dis = dis;
    local issucess = MAP_DATA:updateMapScale( scalevaluse);
    -- CallAndroidPrint( "tounchesNumber TouchesAllMoveLogic change:"..scalevaluse..","..MAP_DATA.Map_scale)
    --更新缩放表现
    if issucess then
        self._operate_view:updateMapShow( nil , MAP_DATA.Map_scale , nil);
    else
        MAP_DATA.IsTwoTounchEvent = false;
        self.IsTounchEvent = false;
        self.TounchEventType = 0;
        self.startTwoParam = nil;
    end
end


--[[单点移动事件逻辑
]]
function controler_mapPage_map_tounch_layer:TounchesOneMoveLogic( pos_1 )
    -- CallAndroidPrint("TounchesOneMoveLogic"..self.TounchEventType)
    if not (self.TounchEventType == 1) then
        return;
    end
    local dis_1 = cc.pGetDistance(self.startTwoParam.pos_1,pos_1)
    if dis_1 < self.MapHandleConfig.minMoveDis then
        return;
    end
    
    local movepos = cc.pSub(pos_1,self.startTwoParam.pos_1);
    self.startTwoParam.pos_1 = pos_1;
    -- print(movepos.x,movepos.y)
    MAP_DATA:updateMapPostion( movepos );
    --设置移动点
    self._operate_view:updateMapShow( MAP_DATA.CurrentPos , nil , nil);
end

--[[点击结束逻辑

]]
function controler_mapPage_map_tounch_layer:TouchesAllEndLogic( endpos )
    -- CallAndroidPrint("TouchesAllEndLogic_1")
    if self.startTwoParam and self.startTwoParam.beginPos then
        --得到2点之间的距离
        local distance = cc.pGetDistance(self.startTwoParam.beginPos,endpos)
        if distance < self.MapHandleConfig.minMoveDis then
            AudioManager.playButton();
            --执行按键事件
            local checkpos  = self._operate_view.TileNode:convertToNodeSpace(cc.p(endpos.x,endpos.y));
            -- local playpos_x ,playpos_y = MAP_DATA.TileDrawInfo:getCurrentPlayerPos(  )
            -- print(checkpos.x ,checkpos.y,playpos_x ,playpos_y  )
            local pos_x ,pos_y = MAP_DATA.CurrentTileInfo:getMapPiecePosByPixelCoordinate( checkpos.x ,checkpos.y  )
            local showpos_x = pos_x + MAP_DATA.TileDrawInfo.draw_Center.x
            local showpos_y = pos_y + MAP_DATA.TileDrawInfo.draw_Center.y
            --判断图块是否有工会 或者人数是否为0
            local plotData = MAP_DATA.TileDrawInfo:getPieceByTilePos( showpos_x , showpos_y  );
            if plotData and (string.len(plotData.occupyname) > 0 or plotData.currentstate > 1) then
                MAP_DATA:sendRequestTileInfo( showpos_x , showpos_y );
            else
                -- UIManager:CreatePrompt_Bar( {
                --     content = "此地块无玩家,无公会"
                -- } )
            end
            
            print("TouchesAllEndLogic：",pos_x,pos_y,showpos_x,showpos_y,checkpos.x ,checkpos.y,MAP_DATA.Map_scale)
        end
    end
    
    MAP_DATA.IsTwoTounchEvent = false;
    self.IsTounchEvent = false;
    self.TounchEventType = 0;
    self.startTwoParam = nil;
    -- CallAndroidPrint("TouchesAllEndLogic"..self.TounchEventType)
end


function controler_mapPage_map_tounch_layer:_onSetUIVisible( event )
    local eventUseData = event._usedata
    local visibleType = eventUseData.visibleType

    --隐藏所有
    if visibleType == "hideAll" then
        self._view_layer:setVisible(false)

    --显示所有
    elseif visibleType == "showAll" then
        self._view_layer:setVisible(true)
    end
    
end


return controler_mapPage_map_tounch_layer
