-- Date: 2014-07-23 14:09:25
-- 装备配置
-- 

-- 装备类型(位置)  0,武器;1,坐骑;2,防具;3,兵法


AttrType = {

	[E_HP] = "生命",

	[E_ATK] = "攻击",
	[E_PATK] = "物攻",
	[E_MATK] = "法攻",

	[E_DEF] = "防御",
	[E_PDEF] = "物防",
	[E_MDEF] = "法防",

	[E_MISS] = "闪避",
	[E_HIT] = "命中",

	[E_TENACITY] = "韧性",
	[E_CRIT] = "暴击",
	[E_CRIT_DAMAGE] = "暴伤",

	[E_SKILL_LV] = "技能强度",

};

CRIT_DAMAGE_COEFFICIENT = 2

TENACITY_COEFFICIENT = 0.8


--得到装备模版
function GetEquipTemplate( template_id )
	if GET_CONFIG_CHECK and nil == EquipConfig[template_id] then
		print_log(debug.traceback());
		print_log("Not found equip("..template_id..")");
	end
	return EquipConfig[template_id];
end




-------------------------------------------------------------------
--name 			名称
--explain 		说明
--equipmentType 装备部位
--Quality		装备品质
--Needdebris	合成需要碎片数量
--Cost			出售价格
--unitvalue		主属性每级增加值
--suitID		所属套装ID,散件为0


--mainAttr 		主属性
--viceAttr 		副属性
--	AttrType 	属性类型
--	value		属性值
--

EquipConfig = 
{
[10011] = {name = "武器", lv = 1, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 200, swap_atk_price = 10000, main_attr_type = 2, main_attr_value = 60, deputy_attr_num = 2, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20011, 20012, 20013, 20014,}, up_stairs_item_num = 0, },
[20011] = {name = "武器", lv = 1, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 400, swap_atk_price = 10000, main_attr_type = 2, main_attr_value = 60, deputy_attr_num = 3, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30011, 30012, 30013, 30014,}, up_stairs_item_num = 0, },
[30011] = {name = "武器", lv = 1, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 600, swap_atk_price = 10000, main_attr_type = 2, main_attr_value = 60, deputy_attr_num = 4, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40011, 40012, 40013, 40014,}, up_stairs_item_num = 0, },
[40011] = {name = "武器", lv = 1, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 800, swap_atk_price = 10000, main_attr_type = 2, main_attr_value = 60, deputy_attr_num = 5, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50011, 50012, 50013, 50014,}, up_stairs_item_num = 0, },
[50011] = {name = "武器", lv = 1, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 1000, swap_atk_price = 10000, main_attr_type = 2, main_attr_value = 60, deputy_attr_num = 5, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 1, extra_attr_num_max = 1, extra_attr_min = 0.016, extra_attr_max = 0.02, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50011, 50012, 50013, 50014,}, up_stairs_item_num = 0, },
[10012] = {name = "头盔", lv = 1, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 200, swap_atk_price = 10000, main_attr_type = 1, main_attr_value = 500, deputy_attr_num = 2, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20011, 20012, 20013, 20014,}, up_stairs_item_num = 0, },
[20012] = {name = "头盔", lv = 1, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 400, swap_atk_price = 10000, main_attr_type = 1, main_attr_value = 500, deputy_attr_num = 3, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30011, 30012, 30013, 30014,}, up_stairs_item_num = 0, },
[30012] = {name = "头盔", lv = 1, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 600, swap_atk_price = 10000, main_attr_type = 1, main_attr_value = 500, deputy_attr_num = 4, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40011, 40012, 40013, 40014,}, up_stairs_item_num = 0, },
[40012] = {name = "头盔", lv = 1, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 800, swap_atk_price = 10000, main_attr_type = 1, main_attr_value = 500, deputy_attr_num = 5, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50011, 50012, 50013, 50014,}, up_stairs_item_num = 0, },
[50012] = {name = "头盔", lv = 1, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 1000, swap_atk_price = 10000, main_attr_type = 1, main_attr_value = 500, deputy_attr_num = 5, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 1, extra_attr_num_max = 1, extra_attr_min = 0.016, extra_attr_max = 0.02, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50011, 50012, 50013, 50014,}, up_stairs_item_num = 0, },
[10013] = {name = "防具", lv = 1, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 200, swap_atk_price = 10000, main_attr_type = 6, main_attr_value = 20, deputy_attr_num = 2, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20011, 20012, 20013, 20014,}, up_stairs_item_num = 0, },
[20013] = {name = "防具", lv = 1, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 400, swap_atk_price = 10000, main_attr_type = 6, main_attr_value = 20, deputy_attr_num = 3, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30011, 30012, 30013, 30014,}, up_stairs_item_num = 0, },
[30013] = {name = "防具", lv = 1, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 600, swap_atk_price = 10000, main_attr_type = 6, main_attr_value = 20, deputy_attr_num = 4, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40011, 40012, 40013, 40014,}, up_stairs_item_num = 0, },
[40013] = {name = "防具", lv = 1, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 800, swap_atk_price = 10000, main_attr_type = 6, main_attr_value = 20, deputy_attr_num = 5, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50011, 50012, 50013, 50014,}, up_stairs_item_num = 0, },
[50013] = {name = "防具", lv = 1, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 1000, swap_atk_price = 10000, main_attr_type = 6, main_attr_value = 20, deputy_attr_num = 5, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 1, extra_attr_num_max = 1, extra_attr_min = 0.016, extra_attr_max = 0.02, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50011, 50012, 50013, 50014,}, up_stairs_item_num = 0, },
[10014] = {name = "鞋子", lv = 1, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 200, swap_atk_price = 10000, main_attr_type = 7, main_attr_value = 20, deputy_attr_num = 2, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20011, 20012, 20013, 20014,}, up_stairs_item_num = 0, },
[20014] = {name = "鞋子", lv = 1, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 400, swap_atk_price = 10000, main_attr_type = 7, main_attr_value = 20, deputy_attr_num = 3, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30011, 30012, 30013, 30014,}, up_stairs_item_num = 0, },
[30014] = {name = "鞋子", lv = 1, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 600, swap_atk_price = 10000, main_attr_type = 7, main_attr_value = 20, deputy_attr_num = 4, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40011, 40012, 40013, 40014,}, up_stairs_item_num = 0, },
[40014] = {name = "鞋子", lv = 1, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 800, swap_atk_price = 10000, main_attr_type = 7, main_attr_value = 20, deputy_attr_num = 5, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50011, 50012, 50013, 50014,}, up_stairs_item_num = 0, },
[50014] = {name = "鞋子", lv = 1, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 1000, swap_atk_price = 10000, main_attr_type = 7, main_attr_value = 20, deputy_attr_num = 5, deputy_attr_min = 12, deputy_attr_max = 15, extra_attr_num_min = 1, extra_attr_num_max = 1, extra_attr_min = 0.016, extra_attr_max = 0.02, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50011, 50012, 50013, 50014,}, up_stairs_item_num = 0, },
[10051] = {name = "武器", lv = 5, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 1000, swap_atk_price = 50000, main_attr_type = 2, main_attr_value = 64, deputy_attr_num = 2, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20051, 20052, 20053, 20054,}, up_stairs_item_num = 0, },
[20051] = {name = "武器", lv = 5, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 2000, swap_atk_price = 50000, main_attr_type = 2, main_attr_value = 64, deputy_attr_num = 3, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30051, 30052, 30053, 30054,}, up_stairs_item_num = 0, },
[30051] = {name = "武器", lv = 5, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 3000, swap_atk_price = 50000, main_attr_type = 2, main_attr_value = 64, deputy_attr_num = 4, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40051, 40052, 40053, 40054,}, up_stairs_item_num = 0, },
[40051] = {name = "武器", lv = 5, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 4000, swap_atk_price = 50000, main_attr_type = 2, main_attr_value = 64, deputy_attr_num = 5, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50051, 50052, 50053, 50054,}, up_stairs_item_num = 0, },
[50051] = {name = "武器", lv = 5, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 5000, swap_atk_price = 50000, main_attr_type = 2, main_attr_value = 64, deputy_attr_num = 5, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 1, extra_attr_num_max = 1, extra_attr_min = 0.0176, extra_attr_max = 0.022, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50051, 50052, 50053, 50054,}, up_stairs_item_num = 0, },
[10052] = {name = "头盔", lv = 5, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 1000, swap_atk_price = 50000, main_attr_type = 1, main_attr_value = 533, deputy_attr_num = 2, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20051, 20052, 20053, 20054,}, up_stairs_item_num = 0, },
[20052] = {name = "头盔", lv = 5, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 2000, swap_atk_price = 50000, main_attr_type = 1, main_attr_value = 533, deputy_attr_num = 3, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30051, 30052, 30053, 30054,}, up_stairs_item_num = 0, },
[30052] = {name = "头盔", lv = 5, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 3000, swap_atk_price = 50000, main_attr_type = 1, main_attr_value = 533, deputy_attr_num = 4, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40051, 40052, 40053, 40054,}, up_stairs_item_num = 0, },
[40052] = {name = "头盔", lv = 5, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 4000, swap_atk_price = 50000, main_attr_type = 1, main_attr_value = 533, deputy_attr_num = 5, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50051, 50052, 50053, 50054,}, up_stairs_item_num = 0, },
[50052] = {name = "头盔", lv = 5, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 5000, swap_atk_price = 50000, main_attr_type = 1, main_attr_value = 533, deputy_attr_num = 5, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 1, extra_attr_num_max = 1, extra_attr_min = 0.0176, extra_attr_max = 0.022, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50051, 50052, 50053, 50054,}, up_stairs_item_num = 0, },
[10053] = {name = "防具", lv = 5, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 1000, swap_atk_price = 50000, main_attr_type = 6, main_attr_value = 21, deputy_attr_num = 2, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20051, 20052, 20053, 20054,}, up_stairs_item_num = 0, },
[20053] = {name = "防具", lv = 5, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 2000, swap_atk_price = 50000, main_attr_type = 6, main_attr_value = 21, deputy_attr_num = 3, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30051, 30052, 30053, 30054,}, up_stairs_item_num = 0, },
[30053] = {name = "防具", lv = 5, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 3000, swap_atk_price = 50000, main_attr_type = 6, main_attr_value = 21, deputy_attr_num = 4, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40051, 40052, 40053, 40054,}, up_stairs_item_num = 0, },
[40053] = {name = "防具", lv = 5, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 4000, swap_atk_price = 50000, main_attr_type = 6, main_attr_value = 21, deputy_attr_num = 5, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50051, 50052, 50053, 50054,}, up_stairs_item_num = 0, },
[50053] = {name = "防具", lv = 5, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 5000, swap_atk_price = 50000, main_attr_type = 6, main_attr_value = 21, deputy_attr_num = 5, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 1, extra_attr_num_max = 1, extra_attr_min = 0.0176, extra_attr_max = 0.022, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50051, 50052, 50053, 50054,}, up_stairs_item_num = 0, },
[10054] = {name = "鞋子", lv = 5, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 1000, swap_atk_price = 50000, main_attr_type = 7, main_attr_value = 21, deputy_attr_num = 2, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20051, 20052, 20053, 20054,}, up_stairs_item_num = 0, },
[20054] = {name = "鞋子", lv = 5, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 2000, swap_atk_price = 50000, main_attr_type = 7, main_attr_value = 21, deputy_attr_num = 3, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30051, 30052, 30053, 30054,}, up_stairs_item_num = 0, },
[30054] = {name = "鞋子", lv = 5, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 3000, swap_atk_price = 50000, main_attr_type = 7, main_attr_value = 21, deputy_attr_num = 4, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40051, 40052, 40053, 40054,}, up_stairs_item_num = 0, },
[40054] = {name = "鞋子", lv = 5, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 4000, swap_atk_price = 50000, main_attr_type = 7, main_attr_value = 21, deputy_attr_num = 5, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50051, 50052, 50053, 50054,}, up_stairs_item_num = 0, },
[50054] = {name = "鞋子", lv = 5, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 5000, swap_atk_price = 50000, main_attr_type = 7, main_attr_value = 21, deputy_attr_num = 5, deputy_attr_min = 13, deputy_attr_max = 16, extra_attr_num_min = 1, extra_attr_num_max = 1, extra_attr_min = 0.0176, extra_attr_max = 0.022, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50051, 50052, 50053, 50054,}, up_stairs_item_num = 0, },
[10101] = {name = "武器", lv = 10, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 2000, swap_atk_price = 100000, main_attr_type = 2, main_attr_value = 76, deputy_attr_num = 2, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20101, 20102, 20103, 20104,}, up_stairs_item_num = 0, },
[20101] = {name = "武器", lv = 10, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 4000, swap_atk_price = 100000, main_attr_type = 2, main_attr_value = 76, deputy_attr_num = 3, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30101, 30102, 30103, 30104,}, up_stairs_item_num = 0, },
[30101] = {name = "武器", lv = 10, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 6000, swap_atk_price = 100000, main_attr_type = 2, main_attr_value = 76, deputy_attr_num = 4, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40101, 40102, 40103, 40104,}, up_stairs_item_num = 0, },
[40101] = {name = "武器", lv = 10, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 8000, swap_atk_price = 100000, main_attr_type = 2, main_attr_value = 76, deputy_attr_num = 5, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50101, 50102, 50103, 50104,}, up_stairs_item_num = 0, },
[50101] = {name = "武器", lv = 10, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 10000, swap_atk_price = 100000, main_attr_type = 2, main_attr_value = 76, deputy_attr_num = 5, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 1, extra_attr_num_max = 1, extra_attr_min = 0.0192, extra_attr_max = 0.024, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50101, 50102, 50103, 50104,}, up_stairs_item_num = 0, },
[10102] = {name = "头盔", lv = 10, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 2000, swap_atk_price = 100000, main_attr_type = 1, main_attr_value = 630, deputy_attr_num = 2, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20101, 20102, 20103, 20104,}, up_stairs_item_num = 0, },
[20102] = {name = "头盔", lv = 10, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 4000, swap_atk_price = 100000, main_attr_type = 1, main_attr_value = 630, deputy_attr_num = 3, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30101, 30102, 30103, 30104,}, up_stairs_item_num = 0, },
[30102] = {name = "头盔", lv = 10, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 6000, swap_atk_price = 100000, main_attr_type = 1, main_attr_value = 630, deputy_attr_num = 4, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40101, 40102, 40103, 40104,}, up_stairs_item_num = 0, },
[40102] = {name = "头盔", lv = 10, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 8000, swap_atk_price = 100000, main_attr_type = 1, main_attr_value = 630, deputy_attr_num = 5, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50101, 50102, 50103, 50104,}, up_stairs_item_num = 0, },
[50102] = {name = "头盔", lv = 10, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 10000, swap_atk_price = 100000, main_attr_type = 1, main_attr_value = 630, deputy_attr_num = 5, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 1, extra_attr_num_max = 1, extra_attr_min = 0.0192, extra_attr_max = 0.024, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50101, 50102, 50103, 50104,}, up_stairs_item_num = 0, },
[10103] = {name = "防具", lv = 10, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 2000, swap_atk_price = 100000, main_attr_type = 6, main_attr_value = 25, deputy_attr_num = 2, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20101, 20102, 20103, 20104,}, up_stairs_item_num = 0, },
[20103] = {name = "防具", lv = 10, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 4000, swap_atk_price = 100000, main_attr_type = 6, main_attr_value = 25, deputy_attr_num = 3, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30101, 30102, 30103, 30104,}, up_stairs_item_num = 0, },
[30103] = {name = "防具", lv = 10, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 6000, swap_atk_price = 100000, main_attr_type = 6, main_attr_value = 25, deputy_attr_num = 4, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40101, 40102, 40103, 40104,}, up_stairs_item_num = 0, },
[40103] = {name = "防具", lv = 10, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 8000, swap_atk_price = 100000, main_attr_type = 6, main_attr_value = 25, deputy_attr_num = 5, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50101, 50102, 50103, 50104,}, up_stairs_item_num = 0, },
[50103] = {name = "防具", lv = 10, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 10000, swap_atk_price = 100000, main_attr_type = 6, main_attr_value = 25, deputy_attr_num = 5, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 1, extra_attr_num_max = 1, extra_attr_min = 0.0192, extra_attr_max = 0.024, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50101, 50102, 50103, 50104,}, up_stairs_item_num = 0, },
[10104] = {name = "鞋子", lv = 10, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 2000, swap_atk_price = 100000, main_attr_type = 7, main_attr_value = 25, deputy_attr_num = 2, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20101, 20102, 20103, 20104,}, up_stairs_item_num = 0, },
[20104] = {name = "鞋子", lv = 10, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 4000, swap_atk_price = 100000, main_attr_type = 7, main_attr_value = 25, deputy_attr_num = 3, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30101, 30102, 30103, 30104,}, up_stairs_item_num = 0, },
[30104] = {name = "鞋子", lv = 10, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 6000, swap_atk_price = 100000, main_attr_type = 7, main_attr_value = 25, deputy_attr_num = 4, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40101, 40102, 40103, 40104,}, up_stairs_item_num = 0, },
[40104] = {name = "鞋子", lv = 10, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 8000, swap_atk_price = 100000, main_attr_type = 7, main_attr_value = 25, deputy_attr_num = 5, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50101, 50102, 50103, 50104,}, up_stairs_item_num = 0, },
[50104] = {name = "鞋子", lv = 10, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 10000, swap_atk_price = 100000, main_attr_type = 7, main_attr_value = 25, deputy_attr_num = 5, deputy_attr_min = 15, deputy_attr_max = 19, extra_attr_num_min = 1, extra_attr_num_max = 1, extra_attr_min = 0.0192, extra_attr_max = 0.024, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50101, 50102, 50103, 50104,}, up_stairs_item_num = 0, },
[10151] = {name = "武器", lv = 15, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 3000, swap_atk_price = 150000, main_attr_type = 2, main_attr_value = 95, deputy_attr_num = 2, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20151, 20152, 20153, 20154,}, up_stairs_item_num = 0, },
[20151] = {name = "武器", lv = 15, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 6000, swap_atk_price = 150000, main_attr_type = 2, main_attr_value = 95, deputy_attr_num = 3, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30151, 30152, 30153, 30154,}, up_stairs_item_num = 0, },
[30151] = {name = "武器", lv = 15, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 9000, swap_atk_price = 150000, main_attr_type = 2, main_attr_value = 95, deputy_attr_num = 4, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40151, 40152, 40153, 40154,}, up_stairs_item_num = 0, },
[40151] = {name = "武器", lv = 15, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 12000, swap_atk_price = 150000, main_attr_type = 2, main_attr_value = 95, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50151, 50152, 50153, 50154,}, up_stairs_item_num = 0, },
[50151] = {name = "武器", lv = 15, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 15000, swap_atk_price = 150000, main_attr_type = 2, main_attr_value = 95, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 1, extra_attr_num_max = 1, extra_attr_min = 0.0208, extra_attr_max = 0.026, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50151, 50152, 50153, 50154,}, up_stairs_item_num = 0, },
[10152] = {name = "头盔", lv = 15, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 3000, swap_atk_price = 150000, main_attr_type = 1, main_attr_value = 793, deputy_attr_num = 2, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20151, 20152, 20153, 20154,}, up_stairs_item_num = 0, },
[20152] = {name = "头盔", lv = 15, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 6000, swap_atk_price = 150000, main_attr_type = 1, main_attr_value = 793, deputy_attr_num = 3, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30151, 30152, 30153, 30154,}, up_stairs_item_num = 0, },
[30152] = {name = "头盔", lv = 15, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 9000, swap_atk_price = 150000, main_attr_type = 1, main_attr_value = 793, deputy_attr_num = 4, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40151, 40152, 40153, 40154,}, up_stairs_item_num = 0, },
[40152] = {name = "头盔", lv = 15, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 12000, swap_atk_price = 150000, main_attr_type = 1, main_attr_value = 793, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50151, 50152, 50153, 50154,}, up_stairs_item_num = 0, },
[50152] = {name = "头盔", lv = 15, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 15000, swap_atk_price = 150000, main_attr_type = 1, main_attr_value = 793, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 1, extra_attr_num_max = 1, extra_attr_min = 0.0208, extra_attr_max = 0.026, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50151, 50152, 50153, 50154,}, up_stairs_item_num = 0, },
[10153] = {name = "防具", lv = 15, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 3000, swap_atk_price = 150000, main_attr_type = 6, main_attr_value = 32, deputy_attr_num = 2, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20151, 20152, 20153, 20154,}, up_stairs_item_num = 0, },
[20153] = {name = "防具", lv = 15, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 6000, swap_atk_price = 150000, main_attr_type = 6, main_attr_value = 32, deputy_attr_num = 3, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30151, 30152, 30153, 30154,}, up_stairs_item_num = 0, },
[30153] = {name = "防具", lv = 15, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 9000, swap_atk_price = 150000, main_attr_type = 6, main_attr_value = 32, deputy_attr_num = 4, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40151, 40152, 40153, 40154,}, up_stairs_item_num = 0, },
[40153] = {name = "防具", lv = 15, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 12000, swap_atk_price = 150000, main_attr_type = 6, main_attr_value = 32, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50151, 50152, 50153, 50154,}, up_stairs_item_num = 0, },
[50153] = {name = "防具", lv = 15, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 15000, swap_atk_price = 150000, main_attr_type = 6, main_attr_value = 32, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 1, extra_attr_num_max = 1, extra_attr_min = 0.0208, extra_attr_max = 0.026, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50151, 50152, 50153, 50154,}, up_stairs_item_num = 0, },
[10154] = {name = "鞋子", lv = 15, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 3000, swap_atk_price = 150000, main_attr_type = 7, main_attr_value = 32, deputy_attr_num = 2, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20151, 20152, 20153, 20154,}, up_stairs_item_num = 0, },
[20154] = {name = "鞋子", lv = 15, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 6000, swap_atk_price = 150000, main_attr_type = 7, main_attr_value = 32, deputy_attr_num = 3, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30151, 30152, 30153, 30154,}, up_stairs_item_num = 0, },
[30154] = {name = "鞋子", lv = 15, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 9000, swap_atk_price = 150000, main_attr_type = 7, main_attr_value = 32, deputy_attr_num = 4, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40151, 40152, 40153, 40154,}, up_stairs_item_num = 0, },
[40154] = {name = "鞋子", lv = 15, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 12000, swap_atk_price = 150000, main_attr_type = 7, main_attr_value = 32, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50151, 50152, 50153, 50154,}, up_stairs_item_num = 0, },
[50154] = {name = "鞋子", lv = 15, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 15000, swap_atk_price = 150000, main_attr_type = 7, main_attr_value = 32, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 24, extra_attr_num_min = 1, extra_attr_num_max = 1, extra_attr_min = 0.0208, extra_attr_max = 0.026, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50151, 50152, 50153, 50154,}, up_stairs_item_num = 0, },
[10201] = {name = "武器", lv = 20, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 4000, swap_atk_price = 200000, main_attr_type = 2, main_attr_value = 122, deputy_attr_num = 2, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20201, 20202, 20203, 20204,}, up_stairs_item_num = 0, },
[20201] = {name = "武器", lv = 20, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 8000, swap_atk_price = 200000, main_attr_type = 2, main_attr_value = 122, deputy_attr_num = 3, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30201, 30202, 30203, 30204,}, up_stairs_item_num = 0, },
[30201] = {name = "武器", lv = 20, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 12000, swap_atk_price = 200000, main_attr_type = 2, main_attr_value = 122, deputy_attr_num = 4, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40201, 40202, 40203, 40204,}, up_stairs_item_num = 0, },
[40201] = {name = "武器", lv = 20, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 16000, swap_atk_price = 200000, main_attr_type = 2, main_attr_value = 122, deputy_attr_num = 5, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50201, 50202, 50203, 50204,}, up_stairs_item_num = 0, },
[50201] = {name = "武器", lv = 20, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 20000, swap_atk_price = 200000, main_attr_type = 2, main_attr_value = 122, deputy_attr_num = 5, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 1, extra_attr_num_max = 2, extra_attr_min = 0.0224, extra_attr_max = 0.028, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50201, 50202, 50203, 50204,}, up_stairs_item_num = 0, },
[10202] = {name = "头盔", lv = 20, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 4000, swap_atk_price = 200000, main_attr_type = 1, main_attr_value = 1020, deputy_attr_num = 2, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20201, 20202, 20203, 20204,}, up_stairs_item_num = 0, },
[20202] = {name = "头盔", lv = 20, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 8000, swap_atk_price = 200000, main_attr_type = 1, main_attr_value = 1020, deputy_attr_num = 3, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30201, 30202, 30203, 30204,}, up_stairs_item_num = 0, },
[30202] = {name = "头盔", lv = 20, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 12000, swap_atk_price = 200000, main_attr_type = 1, main_attr_value = 1020, deputy_attr_num = 4, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40201, 40202, 40203, 40204,}, up_stairs_item_num = 0, },
[40202] = {name = "头盔", lv = 20, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 16000, swap_atk_price = 200000, main_attr_type = 1, main_attr_value = 1020, deputy_attr_num = 5, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50201, 50202, 50203, 50204,}, up_stairs_item_num = 0, },
[50202] = {name = "头盔", lv = 20, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 20000, swap_atk_price = 200000, main_attr_type = 1, main_attr_value = 1020, deputy_attr_num = 5, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 1, extra_attr_num_max = 2, extra_attr_min = 0.0224, extra_attr_max = 0.028, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50201, 50202, 50203, 50204,}, up_stairs_item_num = 0, },
[10203] = {name = "防具", lv = 20, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 4000, swap_atk_price = 200000, main_attr_type = 6, main_attr_value = 41, deputy_attr_num = 2, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20201, 20202, 20203, 20204,}, up_stairs_item_num = 0, },
[20203] = {name = "防具", lv = 20, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 8000, swap_atk_price = 200000, main_attr_type = 6, main_attr_value = 41, deputy_attr_num = 3, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30201, 30202, 30203, 30204,}, up_stairs_item_num = 0, },
[30203] = {name = "防具", lv = 20, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 12000, swap_atk_price = 200000, main_attr_type = 6, main_attr_value = 41, deputy_attr_num = 4, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40201, 40202, 40203, 40204,}, up_stairs_item_num = 0, },
[40203] = {name = "防具", lv = 20, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 16000, swap_atk_price = 200000, main_attr_type = 6, main_attr_value = 41, deputy_attr_num = 5, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50201, 50202, 50203, 50204,}, up_stairs_item_num = 0, },
[50203] = {name = "防具", lv = 20, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 20000, swap_atk_price = 200000, main_attr_type = 6, main_attr_value = 41, deputy_attr_num = 5, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 1, extra_attr_num_max = 2, extra_attr_min = 0.0224, extra_attr_max = 0.028, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50201, 50202, 50203, 50204,}, up_stairs_item_num = 0, },
[10204] = {name = "鞋子", lv = 20, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 4000, swap_atk_price = 200000, main_attr_type = 7, main_attr_value = 41, deputy_attr_num = 2, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20201, 20202, 20203, 20204,}, up_stairs_item_num = 0, },
[20204] = {name = "鞋子", lv = 20, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 8000, swap_atk_price = 200000, main_attr_type = 7, main_attr_value = 41, deputy_attr_num = 3, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30201, 30202, 30203, 30204,}, up_stairs_item_num = 0, },
[30204] = {name = "鞋子", lv = 20, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 12000, swap_atk_price = 200000, main_attr_type = 7, main_attr_value = 41, deputy_attr_num = 4, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40201, 40202, 40203, 40204,}, up_stairs_item_num = 0, },
[40204] = {name = "鞋子", lv = 20, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 16000, swap_atk_price = 200000, main_attr_type = 7, main_attr_value = 41, deputy_attr_num = 5, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50201, 50202, 50203, 50204,}, up_stairs_item_num = 0, },
[50204] = {name = "鞋子", lv = 20, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 20000, swap_atk_price = 200000, main_attr_type = 7, main_attr_value = 41, deputy_attr_num = 5, deputy_attr_min = 25, deputy_attr_max = 31, extra_attr_num_min = 1, extra_attr_num_max = 2, extra_attr_min = 0.0224, extra_attr_max = 0.028, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50201, 50202, 50203, 50204,}, up_stairs_item_num = 0, },
[10251] = {name = "武器", lv = 25, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 5000, swap_atk_price = 250000, main_attr_type = 2, main_attr_value = 158, deputy_attr_num = 2, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20251, 20252, 20253, 20254,}, up_stairs_item_num = 0, },
[20251] = {name = "武器", lv = 25, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 10000, swap_atk_price = 250000, main_attr_type = 2, main_attr_value = 158, deputy_attr_num = 3, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30251, 30252, 30253, 30254,}, up_stairs_item_num = 0, },
[30251] = {name = "武器", lv = 25, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 15000, swap_atk_price = 250000, main_attr_type = 2, main_attr_value = 158, deputy_attr_num = 4, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40251, 40252, 40253, 40254,}, up_stairs_item_num = 0, },
[40251] = {name = "武器", lv = 25, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 20000, swap_atk_price = 250000, main_attr_type = 2, main_attr_value = 158, deputy_attr_num = 5, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50251, 50252, 50253, 50254,}, up_stairs_item_num = 0, },
[50251] = {name = "武器", lv = 25, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 25000, swap_atk_price = 250000, main_attr_type = 2, main_attr_value = 158, deputy_attr_num = 5, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 1, extra_attr_num_max = 2, extra_attr_min = 0.024, extra_attr_max = 0.03, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50251, 50252, 50253, 50254,}, up_stairs_item_num = 0, },
[10252] = {name = "头盔", lv = 25, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 5000, swap_atk_price = 250000, main_attr_type = 1, main_attr_value = 1313, deputy_attr_num = 2, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20251, 20252, 20253, 20254,}, up_stairs_item_num = 0, },
[20252] = {name = "头盔", lv = 25, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 10000, swap_atk_price = 250000, main_attr_type = 1, main_attr_value = 1313, deputy_attr_num = 3, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30251, 30252, 30253, 30254,}, up_stairs_item_num = 0, },
[30252] = {name = "头盔", lv = 25, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 15000, swap_atk_price = 250000, main_attr_type = 1, main_attr_value = 1313, deputy_attr_num = 4, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40251, 40252, 40253, 40254,}, up_stairs_item_num = 0, },
[40252] = {name = "头盔", lv = 25, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 20000, swap_atk_price = 250000, main_attr_type = 1, main_attr_value = 1313, deputy_attr_num = 5, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50251, 50252, 50253, 50254,}, up_stairs_item_num = 0, },
[50252] = {name = "头盔", lv = 25, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 25000, swap_atk_price = 250000, main_attr_type = 1, main_attr_value = 1313, deputy_attr_num = 5, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 1, extra_attr_num_max = 2, extra_attr_min = 0.024, extra_attr_max = 0.03, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50251, 50252, 50253, 50254,}, up_stairs_item_num = 0, },
[10253] = {name = "防具", lv = 25, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 5000, swap_atk_price = 250000, main_attr_type = 6, main_attr_value = 53, deputy_attr_num = 2, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20251, 20252, 20253, 20254,}, up_stairs_item_num = 0, },
[20253] = {name = "防具", lv = 25, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 10000, swap_atk_price = 250000, main_attr_type = 6, main_attr_value = 53, deputy_attr_num = 3, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30251, 30252, 30253, 30254,}, up_stairs_item_num = 0, },
[30253] = {name = "防具", lv = 25, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 15000, swap_atk_price = 250000, main_attr_type = 6, main_attr_value = 53, deputy_attr_num = 4, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40251, 40252, 40253, 40254,}, up_stairs_item_num = 0, },
[40253] = {name = "防具", lv = 25, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 20000, swap_atk_price = 250000, main_attr_type = 6, main_attr_value = 53, deputy_attr_num = 5, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50251, 50252, 50253, 50254,}, up_stairs_item_num = 0, },
[50253] = {name = "防具", lv = 25, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 25000, swap_atk_price = 250000, main_attr_type = 6, main_attr_value = 53, deputy_attr_num = 5, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 1, extra_attr_num_max = 2, extra_attr_min = 0.024, extra_attr_max = 0.03, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50251, 50252, 50253, 50254,}, up_stairs_item_num = 0, },
[10254] = {name = "鞋子", lv = 25, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 5000, swap_atk_price = 250000, main_attr_type = 7, main_attr_value = 53, deputy_attr_num = 2, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20251, 20252, 20253, 20254,}, up_stairs_item_num = 0, },
[20254] = {name = "鞋子", lv = 25, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 10000, swap_atk_price = 250000, main_attr_type = 7, main_attr_value = 53, deputy_attr_num = 3, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30251, 30252, 30253, 30254,}, up_stairs_item_num = 0, },
[30254] = {name = "鞋子", lv = 25, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 15000, swap_atk_price = 250000, main_attr_type = 7, main_attr_value = 53, deputy_attr_num = 4, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40251, 40252, 40253, 40254,}, up_stairs_item_num = 0, },
[40254] = {name = "鞋子", lv = 25, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 20000, swap_atk_price = 250000, main_attr_type = 7, main_attr_value = 53, deputy_attr_num = 5, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50251, 50252, 50253, 50254,}, up_stairs_item_num = 0, },
[50254] = {name = "鞋子", lv = 25, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 25000, swap_atk_price = 250000, main_attr_type = 7, main_attr_value = 53, deputy_attr_num = 5, deputy_attr_min = 31, deputy_attr_max = 39, extra_attr_num_min = 1, extra_attr_num_max = 2, extra_attr_min = 0.024, extra_attr_max = 0.03, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50251, 50252, 50253, 50254,}, up_stairs_item_num = 0, },
[10301] = {name = "武器", lv = 30, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 6000, swap_atk_price = 300000, main_attr_type = 2, main_attr_value = 200, deputy_attr_num = 2, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20301, 20302, 20303, 20304,}, up_stairs_item_num = 0, },
[20301] = {name = "武器", lv = 30, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 12000, swap_atk_price = 300000, main_attr_type = 2, main_attr_value = 200, deputy_attr_num = 3, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30301, 30302, 30303, 30304,}, up_stairs_item_num = 0, },
[30301] = {name = "武器", lv = 30, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 18000, swap_atk_price = 300000, main_attr_type = 2, main_attr_value = 200, deputy_attr_num = 4, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40301, 40302, 40303, 40304,}, up_stairs_item_num = 0, },
[40301] = {name = "武器", lv = 30, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 24000, swap_atk_price = 300000, main_attr_type = 2, main_attr_value = 200, deputy_attr_num = 5, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50301, 50302, 50303, 50304,}, up_stairs_item_num = 0, },
[50301] = {name = "武器", lv = 30, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 30000, swap_atk_price = 300000, main_attr_type = 2, main_attr_value = 200, deputy_attr_num = 5, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 1, extra_attr_num_max = 3, extra_attr_min = 0.0256, extra_attr_max = 0.032, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50301, 50302, 50303, 50304,}, up_stairs_item_num = 0, },
[10302] = {name = "头盔", lv = 30, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 6000, swap_atk_price = 300000, main_attr_type = 1, main_attr_value = 1670, deputy_attr_num = 2, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20301, 20302, 20303, 20304,}, up_stairs_item_num = 0, },
[20302] = {name = "头盔", lv = 30, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 12000, swap_atk_price = 300000, main_attr_type = 1, main_attr_value = 1670, deputy_attr_num = 3, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30301, 30302, 30303, 30304,}, up_stairs_item_num = 0, },
[30302] = {name = "头盔", lv = 30, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 18000, swap_atk_price = 300000, main_attr_type = 1, main_attr_value = 1670, deputy_attr_num = 4, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40301, 40302, 40303, 40304,}, up_stairs_item_num = 0, },
[40302] = {name = "头盔", lv = 30, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 24000, swap_atk_price = 300000, main_attr_type = 1, main_attr_value = 1670, deputy_attr_num = 5, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50301, 50302, 50303, 50304,}, up_stairs_item_num = 0, },
[50302] = {name = "头盔", lv = 30, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 30000, swap_atk_price = 300000, main_attr_type = 1, main_attr_value = 1670, deputy_attr_num = 5, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 1, extra_attr_num_max = 3, extra_attr_min = 0.0256, extra_attr_max = 0.032, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50301, 50302, 50303, 50304,}, up_stairs_item_num = 0, },
[10303] = {name = "防具", lv = 30, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 6000, swap_atk_price = 300000, main_attr_type = 6, main_attr_value = 67, deputy_attr_num = 2, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20301, 20302, 20303, 20304,}, up_stairs_item_num = 0, },
[20303] = {name = "防具", lv = 30, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 12000, swap_atk_price = 300000, main_attr_type = 6, main_attr_value = 67, deputy_attr_num = 3, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30301, 30302, 30303, 30304,}, up_stairs_item_num = 0, },
[30303] = {name = "防具", lv = 30, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 18000, swap_atk_price = 300000, main_attr_type = 6, main_attr_value = 67, deputy_attr_num = 4, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40301, 40302, 40303, 40304,}, up_stairs_item_num = 0, },
[40303] = {name = "防具", lv = 30, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 24000, swap_atk_price = 300000, main_attr_type = 6, main_attr_value = 67, deputy_attr_num = 5, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50301, 50302, 50303, 50304,}, up_stairs_item_num = 0, },
[50303] = {name = "防具", lv = 30, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 30000, swap_atk_price = 300000, main_attr_type = 6, main_attr_value = 67, deputy_attr_num = 5, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 1, extra_attr_num_max = 3, extra_attr_min = 0.0256, extra_attr_max = 0.032, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50301, 50302, 50303, 50304,}, up_stairs_item_num = 0, },
[10304] = {name = "鞋子", lv = 30, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 6000, swap_atk_price = 300000, main_attr_type = 7, main_attr_value = 67, deputy_attr_num = 2, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20301, 20302, 20303, 20304,}, up_stairs_item_num = 0, },
[20304] = {name = "鞋子", lv = 30, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 12000, swap_atk_price = 300000, main_attr_type = 7, main_attr_value = 67, deputy_attr_num = 3, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30301, 30302, 30303, 30304,}, up_stairs_item_num = 0, },
[30304] = {name = "鞋子", lv = 30, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 18000, swap_atk_price = 300000, main_attr_type = 7, main_attr_value = 67, deputy_attr_num = 4, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40301, 40302, 40303, 40304,}, up_stairs_item_num = 0, },
[40304] = {name = "鞋子", lv = 30, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 24000, swap_atk_price = 300000, main_attr_type = 7, main_attr_value = 67, deputy_attr_num = 5, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50301, 50302, 50303, 50304,}, up_stairs_item_num = 0, },
[50304] = {name = "鞋子", lv = 30, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 30000, swap_atk_price = 300000, main_attr_type = 7, main_attr_value = 67, deputy_attr_num = 5, deputy_attr_min = 40, deputy_attr_max = 50, extra_attr_num_min = 1, extra_attr_num_max = 3, extra_attr_min = 0.0256, extra_attr_max = 0.032, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50301, 50302, 50303, 50304,}, up_stairs_item_num = 0, },
[10351] = {name = "武器", lv = 35, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 7000, swap_atk_price = 350000, main_attr_type = 2, main_attr_value = 251, deputy_attr_num = 2, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20351, 20352, 20353, 20354,}, up_stairs_item_num = 0, },
[20351] = {name = "武器", lv = 35, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 14000, swap_atk_price = 350000, main_attr_type = 2, main_attr_value = 251, deputy_attr_num = 3, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30351, 30352, 30353, 30354,}, up_stairs_item_num = 0, },
[30351] = {name = "武器", lv = 35, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 21000, swap_atk_price = 350000, main_attr_type = 2, main_attr_value = 251, deputy_attr_num = 4, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40351, 40352, 40353, 40354,}, up_stairs_item_num = 0, },
[40351] = {name = "武器", lv = 35, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 28000, swap_atk_price = 350000, main_attr_type = 2, main_attr_value = 251, deputy_attr_num = 5, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50351, 50352, 50353, 50354,}, up_stairs_item_num = 0, },
[50351] = {name = "武器", lv = 35, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 35000, swap_atk_price = 350000, main_attr_type = 2, main_attr_value = 251, deputy_attr_num = 5, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 1, extra_attr_num_max = 3, extra_attr_min = 0.0272, extra_attr_max = 0.034, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50351, 50352, 50353, 50354,}, up_stairs_item_num = 0, },
[10352] = {name = "头盔", lv = 35, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 7000, swap_atk_price = 350000, main_attr_type = 1, main_attr_value = 2093, deputy_attr_num = 2, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20351, 20352, 20353, 20354,}, up_stairs_item_num = 0, },
[20352] = {name = "头盔", lv = 35, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 14000, swap_atk_price = 350000, main_attr_type = 1, main_attr_value = 2093, deputy_attr_num = 3, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30351, 30352, 30353, 30354,}, up_stairs_item_num = 0, },
[30352] = {name = "头盔", lv = 35, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 21000, swap_atk_price = 350000, main_attr_type = 1, main_attr_value = 2093, deputy_attr_num = 4, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40351, 40352, 40353, 40354,}, up_stairs_item_num = 0, },
[40352] = {name = "头盔", lv = 35, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 28000, swap_atk_price = 350000, main_attr_type = 1, main_attr_value = 2093, deputy_attr_num = 5, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50351, 50352, 50353, 50354,}, up_stairs_item_num = 0, },
[50352] = {name = "头盔", lv = 35, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 35000, swap_atk_price = 350000, main_attr_type = 1, main_attr_value = 2093, deputy_attr_num = 5, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 1, extra_attr_num_max = 3, extra_attr_min = 0.0272, extra_attr_max = 0.034, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50351, 50352, 50353, 50354,}, up_stairs_item_num = 0, },
[10353] = {name = "防具", lv = 35, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 7000, swap_atk_price = 350000, main_attr_type = 6, main_attr_value = 84, deputy_attr_num = 2, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20351, 20352, 20353, 20354,}, up_stairs_item_num = 0, },
[20353] = {name = "防具", lv = 35, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 14000, swap_atk_price = 350000, main_attr_type = 6, main_attr_value = 84, deputy_attr_num = 3, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30351, 30352, 30353, 30354,}, up_stairs_item_num = 0, },
[30353] = {name = "防具", lv = 35, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 21000, swap_atk_price = 350000, main_attr_type = 6, main_attr_value = 84, deputy_attr_num = 4, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40351, 40352, 40353, 40354,}, up_stairs_item_num = 0, },
[40353] = {name = "防具", lv = 35, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 28000, swap_atk_price = 350000, main_attr_type = 6, main_attr_value = 84, deputy_attr_num = 5, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50351, 50352, 50353, 50354,}, up_stairs_item_num = 0, },
[50353] = {name = "防具", lv = 35, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 35000, swap_atk_price = 350000, main_attr_type = 6, main_attr_value = 84, deputy_attr_num = 5, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 1, extra_attr_num_max = 3, extra_attr_min = 0.0272, extra_attr_max = 0.034, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50351, 50352, 50353, 50354,}, up_stairs_item_num = 0, },
[10354] = {name = "鞋子", lv = 35, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 7000, swap_atk_price = 350000, main_attr_type = 7, main_attr_value = 84, deputy_attr_num = 2, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20351, 20352, 20353, 20354,}, up_stairs_item_num = 0, },
[20354] = {name = "鞋子", lv = 35, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 14000, swap_atk_price = 350000, main_attr_type = 7, main_attr_value = 84, deputy_attr_num = 3, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30351, 30352, 30353, 30354,}, up_stairs_item_num = 0, },
[30354] = {name = "鞋子", lv = 35, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 21000, swap_atk_price = 350000, main_attr_type = 7, main_attr_value = 84, deputy_attr_num = 4, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40351, 40352, 40353, 40354,}, up_stairs_item_num = 0, },
[40354] = {name = "鞋子", lv = 35, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 28000, swap_atk_price = 350000, main_attr_type = 7, main_attr_value = 84, deputy_attr_num = 5, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50351, 50352, 50353, 50354,}, up_stairs_item_num = 0, },
[50354] = {name = "鞋子", lv = 35, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 35000, swap_atk_price = 350000, main_attr_type = 7, main_attr_value = 84, deputy_attr_num = 5, deputy_attr_min = 50, deputy_attr_max = 63, extra_attr_num_min = 1, extra_attr_num_max = 3, extra_attr_min = 0.0272, extra_attr_max = 0.034, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50351, 50352, 50353, 50354,}, up_stairs_item_num = 0, },
[10401] = {name = "武器", lv = 40, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 8000, swap_atk_price = 400000, main_attr_type = 2, main_attr_value = 310, deputy_attr_num = 2, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20401, 20402, 20403, 20404,}, up_stairs_item_num = 0, },
[20401] = {name = "武器", lv = 40, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 16000, swap_atk_price = 400000, main_attr_type = 2, main_attr_value = 310, deputy_attr_num = 3, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30401, 30402, 30403, 30404,}, up_stairs_item_num = 0, },
[30401] = {name = "武器", lv = 40, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 24000, swap_atk_price = 400000, main_attr_type = 2, main_attr_value = 310, deputy_attr_num = 4, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40401, 40402, 40403, 40404,}, up_stairs_item_num = 0, },
[40401] = {name = "武器", lv = 40, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 32000, swap_atk_price = 400000, main_attr_type = 2, main_attr_value = 310, deputy_attr_num = 5, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50401, 50402, 50403, 50404,}, up_stairs_item_num = 0, },
[50401] = {name = "武器", lv = 40, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 40000, swap_atk_price = 400000, main_attr_type = 2, main_attr_value = 310, deputy_attr_num = 5, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 1, extra_attr_num_max = 4, extra_attr_min = 0.0288, extra_attr_max = 0.036, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50401, 50402, 50403, 50404,}, up_stairs_item_num = 0, },
[10402] = {name = "头盔", lv = 40, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 8000, swap_atk_price = 400000, main_attr_type = 1, main_attr_value = 2580, deputy_attr_num = 2, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20401, 20402, 20403, 20404,}, up_stairs_item_num = 0, },
[20402] = {name = "头盔", lv = 40, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 16000, swap_atk_price = 400000, main_attr_type = 1, main_attr_value = 2580, deputy_attr_num = 3, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30401, 30402, 30403, 30404,}, up_stairs_item_num = 0, },
[30402] = {name = "头盔", lv = 40, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 24000, swap_atk_price = 400000, main_attr_type = 1, main_attr_value = 2580, deputy_attr_num = 4, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40401, 40402, 40403, 40404,}, up_stairs_item_num = 0, },
[40402] = {name = "头盔", lv = 40, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 32000, swap_atk_price = 400000, main_attr_type = 1, main_attr_value = 2580, deputy_attr_num = 5, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50401, 50402, 50403, 50404,}, up_stairs_item_num = 0, },
[50402] = {name = "头盔", lv = 40, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 40000, swap_atk_price = 400000, main_attr_type = 1, main_attr_value = 2580, deputy_attr_num = 5, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 1, extra_attr_num_max = 4, extra_attr_min = 0.0288, extra_attr_max = 0.036, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50401, 50402, 50403, 50404,}, up_stairs_item_num = 0, },
[10403] = {name = "防具", lv = 40, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 8000, swap_atk_price = 400000, main_attr_type = 6, main_attr_value = 103, deputy_attr_num = 2, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20401, 20402, 20403, 20404,}, up_stairs_item_num = 0, },
[20403] = {name = "防具", lv = 40, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 16000, swap_atk_price = 400000, main_attr_type = 6, main_attr_value = 103, deputy_attr_num = 3, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30401, 30402, 30403, 30404,}, up_stairs_item_num = 0, },
[30403] = {name = "防具", lv = 40, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 24000, swap_atk_price = 400000, main_attr_type = 6, main_attr_value = 103, deputy_attr_num = 4, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40401, 40402, 40403, 40404,}, up_stairs_item_num = 0, },
[40403] = {name = "防具", lv = 40, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 32000, swap_atk_price = 400000, main_attr_type = 6, main_attr_value = 103, deputy_attr_num = 5, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50401, 50402, 50403, 50404,}, up_stairs_item_num = 0, },
[50403] = {name = "防具", lv = 40, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 40000, swap_atk_price = 400000, main_attr_type = 6, main_attr_value = 103, deputy_attr_num = 5, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 1, extra_attr_num_max = 4, extra_attr_min = 0.0288, extra_attr_max = 0.036, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50401, 50402, 50403, 50404,}, up_stairs_item_num = 0, },
[10404] = {name = "鞋子", lv = 40, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 8000, swap_atk_price = 400000, main_attr_type = 7, main_attr_value = 103, deputy_attr_num = 2, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20401, 20402, 20403, 20404,}, up_stairs_item_num = 0, },
[20404] = {name = "鞋子", lv = 40, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 16000, swap_atk_price = 400000, main_attr_type = 7, main_attr_value = 103, deputy_attr_num = 3, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30401, 30402, 30403, 30404,}, up_stairs_item_num = 0, },
[30404] = {name = "鞋子", lv = 40, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 24000, swap_atk_price = 400000, main_attr_type = 7, main_attr_value = 103, deputy_attr_num = 4, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40401, 40402, 40403, 40404,}, up_stairs_item_num = 0, },
[40404] = {name = "鞋子", lv = 40, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 32000, swap_atk_price = 400000, main_attr_type = 7, main_attr_value = 103, deputy_attr_num = 5, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50401, 50402, 50403, 50404,}, up_stairs_item_num = 0, },
[50404] = {name = "鞋子", lv = 40, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 40000, swap_atk_price = 400000, main_attr_type = 7, main_attr_value = 103, deputy_attr_num = 5, deputy_attr_min = 62, deputy_attr_max = 77, extra_attr_num_min = 1, extra_attr_num_max = 4, extra_attr_min = 0.0288, extra_attr_max = 0.036, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50401, 50402, 50403, 50404,}, up_stairs_item_num = 0, },
[10451] = {name = "武器", lv = 45, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 9000, swap_atk_price = 450000, main_attr_type = 2, main_attr_value = 376, deputy_attr_num = 2, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20451, 20452, 20453, 20454,}, up_stairs_item_num = 0, },
[20451] = {name = "武器", lv = 45, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 18000, swap_atk_price = 450000, main_attr_type = 2, main_attr_value = 376, deputy_attr_num = 3, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30451, 30452, 30453, 30454,}, up_stairs_item_num = 0, },
[30451] = {name = "武器", lv = 45, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 27000, swap_atk_price = 450000, main_attr_type = 2, main_attr_value = 376, deputy_attr_num = 4, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40451, 40452, 40453, 40454,}, up_stairs_item_num = 0, },
[40451] = {name = "武器", lv = 45, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 36000, swap_atk_price = 450000, main_attr_type = 2, main_attr_value = 376, deputy_attr_num = 5, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50451, 50452, 50453, 50454,}, up_stairs_item_num = 0, },
[50451] = {name = "武器", lv = 45, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 45000, swap_atk_price = 450000, main_attr_type = 2, main_attr_value = 376, deputy_attr_num = 5, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 1, extra_attr_num_max = 4, extra_attr_min = 0.0304, extra_attr_max = 0.038, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50451, 50452, 50453, 50454,}, up_stairs_item_num = 0, },
[10452] = {name = "头盔", lv = 45, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 9000, swap_atk_price = 450000, main_attr_type = 1, main_attr_value = 3133, deputy_attr_num = 2, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20451, 20452, 20453, 20454,}, up_stairs_item_num = 0, },
[20452] = {name = "头盔", lv = 45, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 18000, swap_atk_price = 450000, main_attr_type = 1, main_attr_value = 3133, deputy_attr_num = 3, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30451, 30452, 30453, 30454,}, up_stairs_item_num = 0, },
[30452] = {name = "头盔", lv = 45, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 27000, swap_atk_price = 450000, main_attr_type = 1, main_attr_value = 3133, deputy_attr_num = 4, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40451, 40452, 40453, 40454,}, up_stairs_item_num = 0, },
[40452] = {name = "头盔", lv = 45, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 36000, swap_atk_price = 450000, main_attr_type = 1, main_attr_value = 3133, deputy_attr_num = 5, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50451, 50452, 50453, 50454,}, up_stairs_item_num = 0, },
[50452] = {name = "头盔", lv = 45, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 45000, swap_atk_price = 450000, main_attr_type = 1, main_attr_value = 3133, deputy_attr_num = 5, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 1, extra_attr_num_max = 4, extra_attr_min = 0.0304, extra_attr_max = 0.038, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50451, 50452, 50453, 50454,}, up_stairs_item_num = 0, },
[10453] = {name = "防具", lv = 45, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 9000, swap_atk_price = 450000, main_attr_type = 6, main_attr_value = 125, deputy_attr_num = 2, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20451, 20452, 20453, 20454,}, up_stairs_item_num = 0, },
[20453] = {name = "防具", lv = 45, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 18000, swap_atk_price = 450000, main_attr_type = 6, main_attr_value = 125, deputy_attr_num = 3, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30451, 30452, 30453, 30454,}, up_stairs_item_num = 0, },
[30453] = {name = "防具", lv = 45, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 27000, swap_atk_price = 450000, main_attr_type = 6, main_attr_value = 125, deputy_attr_num = 4, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40451, 40452, 40453, 40454,}, up_stairs_item_num = 0, },
[40453] = {name = "防具", lv = 45, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 36000, swap_atk_price = 450000, main_attr_type = 6, main_attr_value = 125, deputy_attr_num = 5, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50451, 50452, 50453, 50454,}, up_stairs_item_num = 0, },
[50453] = {name = "防具", lv = 45, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 45000, swap_atk_price = 450000, main_attr_type = 6, main_attr_value = 125, deputy_attr_num = 5, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 1, extra_attr_num_max = 4, extra_attr_min = 0.0304, extra_attr_max = 0.038, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50451, 50452, 50453, 50454,}, up_stairs_item_num = 0, },
[10454] = {name = "鞋子", lv = 45, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 9000, swap_atk_price = 450000, main_attr_type = 7, main_attr_value = 125, deputy_attr_num = 2, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20451, 20452, 20453, 20454,}, up_stairs_item_num = 0, },
[20454] = {name = "鞋子", lv = 45, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 18000, swap_atk_price = 450000, main_attr_type = 7, main_attr_value = 125, deputy_attr_num = 3, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30451, 30452, 30453, 30454,}, up_stairs_item_num = 0, },
[30454] = {name = "鞋子", lv = 45, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 27000, swap_atk_price = 450000, main_attr_type = 7, main_attr_value = 125, deputy_attr_num = 4, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40451, 40452, 40453, 40454,}, up_stairs_item_num = 0, },
[40454] = {name = "鞋子", lv = 45, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 36000, swap_atk_price = 450000, main_attr_type = 7, main_attr_value = 125, deputy_attr_num = 5, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50451, 50452, 50453, 50454,}, up_stairs_item_num = 0, },
[50454] = {name = "鞋子", lv = 45, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 45000, swap_atk_price = 450000, main_attr_type = 7, main_attr_value = 125, deputy_attr_num = 5, deputy_attr_min = 75, deputy_attr_max = 94, extra_attr_num_min = 1, extra_attr_num_max = 4, extra_attr_min = 0.0304, extra_attr_max = 0.038, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50451, 50452, 50453, 50454,}, up_stairs_item_num = 0, },
[10501] = {name = "武器", lv = 50, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 10000, swap_atk_price = 500000, main_attr_type = 2, main_attr_value = 450, deputy_attr_num = 2, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20501, 20502, 20503, 20504,}, up_stairs_item_num = 0, },
[20501] = {name = "武器", lv = 50, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 20000, swap_atk_price = 500000, main_attr_type = 2, main_attr_value = 450, deputy_attr_num = 3, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30501, 30502, 30503, 30504,}, up_stairs_item_num = 0, },
[30501] = {name = "武器", lv = 50, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 30000, swap_atk_price = 500000, main_attr_type = 2, main_attr_value = 450, deputy_attr_num = 4, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40501, 40502, 40503, 40504,}, up_stairs_item_num = 0, },
[40501] = {name = "武器", lv = 50, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 40000, swap_atk_price = 500000, main_attr_type = 2, main_attr_value = 450, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50501, 50502, 50503, 50504,}, up_stairs_item_num = 0, },
[50501] = {name = "武器", lv = 50, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 50000, swap_atk_price = 500000, main_attr_type = 2, main_attr_value = 450, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.032, extra_attr_max = 0.04, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50501, 50502, 50503, 50504,}, up_stairs_item_num = 0, },
[10502] = {name = "头盔", lv = 50, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 10000, swap_atk_price = 500000, main_attr_type = 1, main_attr_value = 3750, deputy_attr_num = 2, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20501, 20502, 20503, 20504,}, up_stairs_item_num = 0, },
[20502] = {name = "头盔", lv = 50, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 20000, swap_atk_price = 500000, main_attr_type = 1, main_attr_value = 3750, deputy_attr_num = 3, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30501, 30502, 30503, 30504,}, up_stairs_item_num = 0, },
[30502] = {name = "头盔", lv = 50, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 30000, swap_atk_price = 500000, main_attr_type = 1, main_attr_value = 3750, deputy_attr_num = 4, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40501, 40502, 40503, 40504,}, up_stairs_item_num = 0, },
[40502] = {name = "头盔", lv = 50, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 40000, swap_atk_price = 500000, main_attr_type = 1, main_attr_value = 3750, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50501, 50502, 50503, 50504,}, up_stairs_item_num = 0, },
[50502] = {name = "头盔", lv = 50, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 50000, swap_atk_price = 500000, main_attr_type = 1, main_attr_value = 3750, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.032, extra_attr_max = 0.04, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50501, 50502, 50503, 50504,}, up_stairs_item_num = 0, },
[10503] = {name = "防具", lv = 50, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 10000, swap_atk_price = 500000, main_attr_type = 6, main_attr_value = 150, deputy_attr_num = 2, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20501, 20502, 20503, 20504,}, up_stairs_item_num = 0, },
[20503] = {name = "防具", lv = 50, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 20000, swap_atk_price = 500000, main_attr_type = 6, main_attr_value = 150, deputy_attr_num = 3, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30501, 30502, 30503, 30504,}, up_stairs_item_num = 0, },
[30503] = {name = "防具", lv = 50, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 30000, swap_atk_price = 500000, main_attr_type = 6, main_attr_value = 150, deputy_attr_num = 4, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40501, 40502, 40503, 40504,}, up_stairs_item_num = 0, },
[40503] = {name = "防具", lv = 50, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 40000, swap_atk_price = 500000, main_attr_type = 6, main_attr_value = 150, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50501, 50502, 50503, 50504,}, up_stairs_item_num = 0, },
[50503] = {name = "防具", lv = 50, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 50000, swap_atk_price = 500000, main_attr_type = 6, main_attr_value = 150, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.032, extra_attr_max = 0.04, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50501, 50502, 50503, 50504,}, up_stairs_item_num = 0, },
[10504] = {name = "鞋子", lv = 50, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 10000, swap_atk_price = 500000, main_attr_type = 7, main_attr_value = 150, deputy_attr_num = 2, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20501, 20502, 20503, 20504,}, up_stairs_item_num = 0, },
[20504] = {name = "鞋子", lv = 50, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 20000, swap_atk_price = 500000, main_attr_type = 7, main_attr_value = 150, deputy_attr_num = 3, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30501, 30502, 30503, 30504,}, up_stairs_item_num = 0, },
[30504] = {name = "鞋子", lv = 50, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 30000, swap_atk_price = 500000, main_attr_type = 7, main_attr_value = 150, deputy_attr_num = 4, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40501, 40502, 40503, 40504,}, up_stairs_item_num = 0, },
[40504] = {name = "鞋子", lv = 50, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 40000, swap_atk_price = 500000, main_attr_type = 7, main_attr_value = 150, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50501, 50502, 50503, 50504,}, up_stairs_item_num = 0, },
[50504] = {name = "鞋子", lv = 50, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 50000, swap_atk_price = 500000, main_attr_type = 7, main_attr_value = 150, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 113, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.032, extra_attr_max = 0.04, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50501, 50502, 50503, 50504,}, up_stairs_item_num = 0, },
[10551] = {name = "武器", lv = 55, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 11000, swap_atk_price = 550000, main_attr_type = 2, main_attr_value = 532, deputy_attr_num = 2, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20551, 20552, 20553, 20554,}, up_stairs_item_num = 0, },
[20551] = {name = "武器", lv = 55, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 22000, swap_atk_price = 550000, main_attr_type = 2, main_attr_value = 532, deputy_attr_num = 3, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30551, 30552, 30553, 30554,}, up_stairs_item_num = 0, },
[30551] = {name = "武器", lv = 55, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 33000, swap_atk_price = 550000, main_attr_type = 2, main_attr_value = 532, deputy_attr_num = 4, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40551, 40552, 40553, 40554,}, up_stairs_item_num = 0, },
[40551] = {name = "武器", lv = 55, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 44000, swap_atk_price = 550000, main_attr_type = 2, main_attr_value = 532, deputy_attr_num = 5, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50551, 50552, 50553, 50554,}, up_stairs_item_num = 0, },
[50551] = {name = "武器", lv = 55, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 55000, swap_atk_price = 550000, main_attr_type = 2, main_attr_value = 532, deputy_attr_num = 5, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.042, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50551, 50552, 50553, 50554,}, up_stairs_item_num = 0, },
[10552] = {name = "头盔", lv = 55, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 11000, swap_atk_price = 550000, main_attr_type = 1, main_attr_value = 4433, deputy_attr_num = 2, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20551, 20552, 20553, 20554,}, up_stairs_item_num = 0, },
[20552] = {name = "头盔", lv = 55, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 22000, swap_atk_price = 550000, main_attr_type = 1, main_attr_value = 4433, deputy_attr_num = 3, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30551, 30552, 30553, 30554,}, up_stairs_item_num = 0, },
[30552] = {name = "头盔", lv = 55, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 33000, swap_atk_price = 550000, main_attr_type = 1, main_attr_value = 4433, deputy_attr_num = 4, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40551, 40552, 40553, 40554,}, up_stairs_item_num = 0, },
[40552] = {name = "头盔", lv = 55, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 44000, swap_atk_price = 550000, main_attr_type = 1, main_attr_value = 4433, deputy_attr_num = 5, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50551, 50552, 50553, 50554,}, up_stairs_item_num = 0, },
[50552] = {name = "头盔", lv = 55, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 55000, swap_atk_price = 550000, main_attr_type = 1, main_attr_value = 4433, deputy_attr_num = 5, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.042, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50551, 50552, 50553, 50554,}, up_stairs_item_num = 0, },
[10553] = {name = "防具", lv = 55, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 11000, swap_atk_price = 550000, main_attr_type = 6, main_attr_value = 177, deputy_attr_num = 2, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20551, 20552, 20553, 20554,}, up_stairs_item_num = 0, },
[20553] = {name = "防具", lv = 55, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 22000, swap_atk_price = 550000, main_attr_type = 6, main_attr_value = 177, deputy_attr_num = 3, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30551, 30552, 30553, 30554,}, up_stairs_item_num = 0, },
[30553] = {name = "防具", lv = 55, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 33000, swap_atk_price = 550000, main_attr_type = 6, main_attr_value = 177, deputy_attr_num = 4, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40551, 40552, 40553, 40554,}, up_stairs_item_num = 0, },
[40553] = {name = "防具", lv = 55, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 44000, swap_atk_price = 550000, main_attr_type = 6, main_attr_value = 177, deputy_attr_num = 5, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50551, 50552, 50553, 50554,}, up_stairs_item_num = 0, },
[50553] = {name = "防具", lv = 55, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 55000, swap_atk_price = 550000, main_attr_type = 6, main_attr_value = 177, deputy_attr_num = 5, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.042, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50551, 50552, 50553, 50554,}, up_stairs_item_num = 0, },
[10554] = {name = "鞋子", lv = 55, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 11000, swap_atk_price = 550000, main_attr_type = 7, main_attr_value = 177, deputy_attr_num = 2, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20551, 20552, 20553, 20554,}, up_stairs_item_num = 0, },
[20554] = {name = "鞋子", lv = 55, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 22000, swap_atk_price = 550000, main_attr_type = 7, main_attr_value = 177, deputy_attr_num = 3, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30551, 30552, 30553, 30554,}, up_stairs_item_num = 0, },
[30554] = {name = "鞋子", lv = 55, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 33000, swap_atk_price = 550000, main_attr_type = 7, main_attr_value = 177, deputy_attr_num = 4, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40551, 40552, 40553, 40554,}, up_stairs_item_num = 0, },
[40554] = {name = "鞋子", lv = 55, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 44000, swap_atk_price = 550000, main_attr_type = 7, main_attr_value = 177, deputy_attr_num = 5, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50551, 50552, 50553, 50554,}, up_stairs_item_num = 0, },
[50554] = {name = "鞋子", lv = 55, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 55000, swap_atk_price = 550000, main_attr_type = 7, main_attr_value = 177, deputy_attr_num = 5, deputy_attr_min = 106, deputy_attr_max = 133, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.042, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50551, 50552, 50553, 50554,}, up_stairs_item_num = 0, },
[10601] = {name = "武器", lv = 60, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 12000, swap_atk_price = 600000, main_attr_type = 2, main_attr_value = 622, deputy_attr_num = 2, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20601, 20602, 20603, 20604,}, up_stairs_item_num = 0, },
[20601] = {name = "武器", lv = 60, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 24000, swap_atk_price = 600000, main_attr_type = 2, main_attr_value = 622, deputy_attr_num = 3, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30601, 30602, 30603, 30604,}, up_stairs_item_num = 0, },
[30601] = {name = "武器", lv = 60, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 36000, swap_atk_price = 600000, main_attr_type = 2, main_attr_value = 622, deputy_attr_num = 4, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40601, 40602, 40603, 40604,}, up_stairs_item_num = 0, },
[40601] = {name = "武器", lv = 60, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 48000, swap_atk_price = 600000, main_attr_type = 2, main_attr_value = 622, deputy_attr_num = 5, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50601, 50602, 50603, 50604,}, up_stairs_item_num = 0, },
[50601] = {name = "武器", lv = 60, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 60000, swap_atk_price = 600000, main_attr_type = 2, main_attr_value = 622, deputy_attr_num = 5, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0352, extra_attr_max = 0.044, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50601, 50602, 50603, 50604,}, up_stairs_item_num = 0, },
[10602] = {name = "头盔", lv = 60, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 12000, swap_atk_price = 600000, main_attr_type = 1, main_attr_value = 5180, deputy_attr_num = 2, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20601, 20602, 20603, 20604,}, up_stairs_item_num = 0, },
[20602] = {name = "头盔", lv = 60, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 24000, swap_atk_price = 600000, main_attr_type = 1, main_attr_value = 5180, deputy_attr_num = 3, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30601, 30602, 30603, 30604,}, up_stairs_item_num = 0, },
[30602] = {name = "头盔", lv = 60, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 36000, swap_atk_price = 600000, main_attr_type = 1, main_attr_value = 5180, deputy_attr_num = 4, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40601, 40602, 40603, 40604,}, up_stairs_item_num = 0, },
[40602] = {name = "头盔", lv = 60, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 48000, swap_atk_price = 600000, main_attr_type = 1, main_attr_value = 5180, deputy_attr_num = 5, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50601, 50602, 50603, 50604,}, up_stairs_item_num = 0, },
[50602] = {name = "头盔", lv = 60, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 60000, swap_atk_price = 600000, main_attr_type = 1, main_attr_value = 5180, deputy_attr_num = 5, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0352, extra_attr_max = 0.044, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50601, 50602, 50603, 50604,}, up_stairs_item_num = 0, },
[10603] = {name = "防具", lv = 60, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 12000, swap_atk_price = 600000, main_attr_type = 6, main_attr_value = 207, deputy_attr_num = 2, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20601, 20602, 20603, 20604,}, up_stairs_item_num = 0, },
[20603] = {name = "防具", lv = 60, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 24000, swap_atk_price = 600000, main_attr_type = 6, main_attr_value = 207, deputy_attr_num = 3, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30601, 30602, 30603, 30604,}, up_stairs_item_num = 0, },
[30603] = {name = "防具", lv = 60, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 36000, swap_atk_price = 600000, main_attr_type = 6, main_attr_value = 207, deputy_attr_num = 4, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40601, 40602, 40603, 40604,}, up_stairs_item_num = 0, },
[40603] = {name = "防具", lv = 60, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 48000, swap_atk_price = 600000, main_attr_type = 6, main_attr_value = 207, deputy_attr_num = 5, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50601, 50602, 50603, 50604,}, up_stairs_item_num = 0, },
[50603] = {name = "防具", lv = 60, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 60000, swap_atk_price = 600000, main_attr_type = 6, main_attr_value = 207, deputy_attr_num = 5, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0352, extra_attr_max = 0.044, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50601, 50602, 50603, 50604,}, up_stairs_item_num = 0, },
[10604] = {name = "鞋子", lv = 60, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 12000, swap_atk_price = 600000, main_attr_type = 7, main_attr_value = 207, deputy_attr_num = 2, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20601, 20602, 20603, 20604,}, up_stairs_item_num = 0, },
[20604] = {name = "鞋子", lv = 60, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 24000, swap_atk_price = 600000, main_attr_type = 7, main_attr_value = 207, deputy_attr_num = 3, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30601, 30602, 30603, 30604,}, up_stairs_item_num = 0, },
[30604] = {name = "鞋子", lv = 60, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 36000, swap_atk_price = 600000, main_attr_type = 7, main_attr_value = 207, deputy_attr_num = 4, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40601, 40602, 40603, 40604,}, up_stairs_item_num = 0, },
[40604] = {name = "鞋子", lv = 60, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 48000, swap_atk_price = 600000, main_attr_type = 7, main_attr_value = 207, deputy_attr_num = 5, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50601, 50602, 50603, 50604,}, up_stairs_item_num = 0, },
[50604] = {name = "鞋子", lv = 60, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 60000, swap_atk_price = 600000, main_attr_type = 7, main_attr_value = 207, deputy_attr_num = 5, deputy_attr_min = 124, deputy_attr_max = 155, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0352, extra_attr_max = 0.044, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50601, 50602, 50603, 50604,}, up_stairs_item_num = 0, },
[10651] = {name = "武器", lv = 65, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 13000, swap_atk_price = 650000, main_attr_type = 2, main_attr_value = 719, deputy_attr_num = 2, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20651, 20652, 20653, 20654,}, up_stairs_item_num = 0, },
[20651] = {name = "武器", lv = 65, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 26000, swap_atk_price = 650000, main_attr_type = 2, main_attr_value = 719, deputy_attr_num = 3, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30651, 30652, 30653, 30654,}, up_stairs_item_num = 0, },
[30651] = {name = "武器", lv = 65, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 39000, swap_atk_price = 650000, main_attr_type = 2, main_attr_value = 719, deputy_attr_num = 4, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40651, 40652, 40653, 40654,}, up_stairs_item_num = 0, },
[40651] = {name = "武器", lv = 65, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 52000, swap_atk_price = 650000, main_attr_type = 2, main_attr_value = 719, deputy_attr_num = 5, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50651, 50652, 50653, 50654,}, up_stairs_item_num = 0, },
[50651] = {name = "武器", lv = 65, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 65000, swap_atk_price = 650000, main_attr_type = 2, main_attr_value = 719, deputy_attr_num = 5, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0368, extra_attr_max = 0.046, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50651, 50652, 50653, 50654,}, up_stairs_item_num = 0, },
[10652] = {name = "头盔", lv = 65, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 13000, swap_atk_price = 650000, main_attr_type = 1, main_attr_value = 5993, deputy_attr_num = 2, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20651, 20652, 20653, 20654,}, up_stairs_item_num = 0, },
[20652] = {name = "头盔", lv = 65, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 26000, swap_atk_price = 650000, main_attr_type = 1, main_attr_value = 5993, deputy_attr_num = 3, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30651, 30652, 30653, 30654,}, up_stairs_item_num = 0, },
[30652] = {name = "头盔", lv = 65, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 39000, swap_atk_price = 650000, main_attr_type = 1, main_attr_value = 5993, deputy_attr_num = 4, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40651, 40652, 40653, 40654,}, up_stairs_item_num = 0, },
[40652] = {name = "头盔", lv = 65, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 52000, swap_atk_price = 650000, main_attr_type = 1, main_attr_value = 5993, deputy_attr_num = 5, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50651, 50652, 50653, 50654,}, up_stairs_item_num = 0, },
[50652] = {name = "头盔", lv = 65, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 65000, swap_atk_price = 650000, main_attr_type = 1, main_attr_value = 5993, deputy_attr_num = 5, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0368, extra_attr_max = 0.046, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50651, 50652, 50653, 50654,}, up_stairs_item_num = 0, },
[10653] = {name = "防具", lv = 65, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 13000, swap_atk_price = 650000, main_attr_type = 6, main_attr_value = 240, deputy_attr_num = 2, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20651, 20652, 20653, 20654,}, up_stairs_item_num = 0, },
[20653] = {name = "防具", lv = 65, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 26000, swap_atk_price = 650000, main_attr_type = 6, main_attr_value = 240, deputy_attr_num = 3, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30651, 30652, 30653, 30654,}, up_stairs_item_num = 0, },
[30653] = {name = "防具", lv = 65, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 39000, swap_atk_price = 650000, main_attr_type = 6, main_attr_value = 240, deputy_attr_num = 4, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40651, 40652, 40653, 40654,}, up_stairs_item_num = 0, },
[40653] = {name = "防具", lv = 65, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 52000, swap_atk_price = 650000, main_attr_type = 6, main_attr_value = 240, deputy_attr_num = 5, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50651, 50652, 50653, 50654,}, up_stairs_item_num = 0, },
[50653] = {name = "防具", lv = 65, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 65000, swap_atk_price = 650000, main_attr_type = 6, main_attr_value = 240, deputy_attr_num = 5, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0368, extra_attr_max = 0.046, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50651, 50652, 50653, 50654,}, up_stairs_item_num = 0, },
[10654] = {name = "鞋子", lv = 65, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 13000, swap_atk_price = 650000, main_attr_type = 7, main_attr_value = 240, deputy_attr_num = 2, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20651, 20652, 20653, 20654,}, up_stairs_item_num = 0, },
[20654] = {name = "鞋子", lv = 65, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 26000, swap_atk_price = 650000, main_attr_type = 7, main_attr_value = 240, deputy_attr_num = 3, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30651, 30652, 30653, 30654,}, up_stairs_item_num = 0, },
[30654] = {name = "鞋子", lv = 65, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 39000, swap_atk_price = 650000, main_attr_type = 7, main_attr_value = 240, deputy_attr_num = 4, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40651, 40652, 40653, 40654,}, up_stairs_item_num = 0, },
[40654] = {name = "鞋子", lv = 65, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 52000, swap_atk_price = 650000, main_attr_type = 7, main_attr_value = 240, deputy_attr_num = 5, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50651, 50652, 50653, 50654,}, up_stairs_item_num = 0, },
[50654] = {name = "鞋子", lv = 65, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 65000, swap_atk_price = 650000, main_attr_type = 7, main_attr_value = 240, deputy_attr_num = 5, deputy_attr_min = 144, deputy_attr_max = 180, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0368, extra_attr_max = 0.046, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50651, 50652, 50653, 50654,}, up_stairs_item_num = 0, },
[10701] = {name = "武器", lv = 70, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 14000, swap_atk_price = 700000, main_attr_type = 2, main_attr_value = 824, deputy_attr_num = 2, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20701, 20702, 20703, 20704,}, up_stairs_item_num = 0, },
[20701] = {name = "武器", lv = 70, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 28000, swap_atk_price = 700000, main_attr_type = 2, main_attr_value = 824, deputy_attr_num = 3, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30701, 30702, 30703, 30704,}, up_stairs_item_num = 0, },
[30701] = {name = "武器", lv = 70, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 42000, swap_atk_price = 700000, main_attr_type = 2, main_attr_value = 824, deputy_attr_num = 4, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40701, 40702, 40703, 40704,}, up_stairs_item_num = 0, },
[40701] = {name = "武器", lv = 70, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 56000, swap_atk_price = 700000, main_attr_type = 2, main_attr_value = 824, deputy_attr_num = 5, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50701, 50702, 50703, 50704,}, up_stairs_item_num = 0, },
[50701] = {name = "武器", lv = 70, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 70000, swap_atk_price = 700000, main_attr_type = 2, main_attr_value = 824, deputy_attr_num = 5, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.048, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50701, 50702, 50703, 50704,}, up_stairs_item_num = 0, },
[10702] = {name = "头盔", lv = 70, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 14000, swap_atk_price = 700000, main_attr_type = 1, main_attr_value = 6870, deputy_attr_num = 2, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20701, 20702, 20703, 20704,}, up_stairs_item_num = 0, },
[20702] = {name = "头盔", lv = 70, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 28000, swap_atk_price = 700000, main_attr_type = 1, main_attr_value = 6870, deputy_attr_num = 3, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30701, 30702, 30703, 30704,}, up_stairs_item_num = 0, },
[30702] = {name = "头盔", lv = 70, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 42000, swap_atk_price = 700000, main_attr_type = 1, main_attr_value = 6870, deputy_attr_num = 4, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40701, 40702, 40703, 40704,}, up_stairs_item_num = 0, },
[40702] = {name = "头盔", lv = 70, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 56000, swap_atk_price = 700000, main_attr_type = 1, main_attr_value = 6870, deputy_attr_num = 5, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50701, 50702, 50703, 50704,}, up_stairs_item_num = 0, },
[50702] = {name = "头盔", lv = 70, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 70000, swap_atk_price = 700000, main_attr_type = 1, main_attr_value = 6870, deputy_attr_num = 5, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.048, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50701, 50702, 50703, 50704,}, up_stairs_item_num = 0, },
[10703] = {name = "防具", lv = 70, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 14000, swap_atk_price = 700000, main_attr_type = 6, main_attr_value = 275, deputy_attr_num = 2, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20701, 20702, 20703, 20704,}, up_stairs_item_num = 0, },
[20703] = {name = "防具", lv = 70, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 28000, swap_atk_price = 700000, main_attr_type = 6, main_attr_value = 275, deputy_attr_num = 3, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30701, 30702, 30703, 30704,}, up_stairs_item_num = 0, },
[30703] = {name = "防具", lv = 70, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 42000, swap_atk_price = 700000, main_attr_type = 6, main_attr_value = 275, deputy_attr_num = 4, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40701, 40702, 40703, 40704,}, up_stairs_item_num = 0, },
[40703] = {name = "防具", lv = 70, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 56000, swap_atk_price = 700000, main_attr_type = 6, main_attr_value = 275, deputy_attr_num = 5, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50701, 50702, 50703, 50704,}, up_stairs_item_num = 0, },
[50703] = {name = "防具", lv = 70, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 70000, swap_atk_price = 700000, main_attr_type = 6, main_attr_value = 275, deputy_attr_num = 5, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.048, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50701, 50702, 50703, 50704,}, up_stairs_item_num = 0, },
[10704] = {name = "鞋子", lv = 70, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 14000, swap_atk_price = 700000, main_attr_type = 7, main_attr_value = 275, deputy_attr_num = 2, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20701, 20702, 20703, 20704,}, up_stairs_item_num = 0, },
[20704] = {name = "鞋子", lv = 70, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 28000, swap_atk_price = 700000, main_attr_type = 7, main_attr_value = 275, deputy_attr_num = 3, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30701, 30702, 30703, 30704,}, up_stairs_item_num = 0, },
[30704] = {name = "鞋子", lv = 70, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 42000, swap_atk_price = 700000, main_attr_type = 7, main_attr_value = 275, deputy_attr_num = 4, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40701, 40702, 40703, 40704,}, up_stairs_item_num = 0, },
[40704] = {name = "鞋子", lv = 70, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 56000, swap_atk_price = 700000, main_attr_type = 7, main_attr_value = 275, deputy_attr_num = 5, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50701, 50702, 50703, 50704,}, up_stairs_item_num = 0, },
[50704] = {name = "鞋子", lv = 70, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 70000, swap_atk_price = 700000, main_attr_type = 7, main_attr_value = 275, deputy_attr_num = 5, deputy_attr_min = 165, deputy_attr_max = 206, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.048, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50701, 50702, 50703, 50704,}, up_stairs_item_num = 0, },
[10751] = {name = "武器", lv = 75, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 15000, swap_atk_price = 750000, main_attr_type = 2, main_attr_value = 938, deputy_attr_num = 2, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20751, 20752, 20753, 20754,}, up_stairs_item_num = 0, },
[20751] = {name = "武器", lv = 75, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 30000, swap_atk_price = 750000, main_attr_type = 2, main_attr_value = 938, deputy_attr_num = 3, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30751, 30752, 30753, 30754,}, up_stairs_item_num = 0, },
[30751] = {name = "武器", lv = 75, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 45000, swap_atk_price = 750000, main_attr_type = 2, main_attr_value = 938, deputy_attr_num = 4, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40751, 40752, 40753, 40754,}, up_stairs_item_num = 0, },
[40751] = {name = "武器", lv = 75, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 60000, swap_atk_price = 750000, main_attr_type = 2, main_attr_value = 938, deputy_attr_num = 5, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50751, 50752, 50753, 50754,}, up_stairs_item_num = 0, },
[50751] = {name = "武器", lv = 75, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 75000, swap_atk_price = 750000, main_attr_type = 2, main_attr_value = 938, deputy_attr_num = 5, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.04, extra_attr_max = 0.05, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50751, 50752, 50753, 50754,}, up_stairs_item_num = 0, },
[10752] = {name = "头盔", lv = 75, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 15000, swap_atk_price = 750000, main_attr_type = 1, main_attr_value = 7813, deputy_attr_num = 2, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20751, 20752, 20753, 20754,}, up_stairs_item_num = 0, },
[20752] = {name = "头盔", lv = 75, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 30000, swap_atk_price = 750000, main_attr_type = 1, main_attr_value = 7813, deputy_attr_num = 3, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30751, 30752, 30753, 30754,}, up_stairs_item_num = 0, },
[30752] = {name = "头盔", lv = 75, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 45000, swap_atk_price = 750000, main_attr_type = 1, main_attr_value = 7813, deputy_attr_num = 4, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40751, 40752, 40753, 40754,}, up_stairs_item_num = 0, },
[40752] = {name = "头盔", lv = 75, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 60000, swap_atk_price = 750000, main_attr_type = 1, main_attr_value = 7813, deputy_attr_num = 5, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50751, 50752, 50753, 50754,}, up_stairs_item_num = 0, },
[50752] = {name = "头盔", lv = 75, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 75000, swap_atk_price = 750000, main_attr_type = 1, main_attr_value = 7813, deputy_attr_num = 5, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.04, extra_attr_max = 0.05, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50751, 50752, 50753, 50754,}, up_stairs_item_num = 0, },
[10753] = {name = "防具", lv = 75, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 15000, swap_atk_price = 750000, main_attr_type = 6, main_attr_value = 313, deputy_attr_num = 2, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20751, 20752, 20753, 20754,}, up_stairs_item_num = 0, },
[20753] = {name = "防具", lv = 75, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 30000, swap_atk_price = 750000, main_attr_type = 6, main_attr_value = 313, deputy_attr_num = 3, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30751, 30752, 30753, 30754,}, up_stairs_item_num = 0, },
[30753] = {name = "防具", lv = 75, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 45000, swap_atk_price = 750000, main_attr_type = 6, main_attr_value = 313, deputy_attr_num = 4, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40751, 40752, 40753, 40754,}, up_stairs_item_num = 0, },
[40753] = {name = "防具", lv = 75, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 60000, swap_atk_price = 750000, main_attr_type = 6, main_attr_value = 313, deputy_attr_num = 5, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50751, 50752, 50753, 50754,}, up_stairs_item_num = 0, },
[50753] = {name = "防具", lv = 75, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 75000, swap_atk_price = 750000, main_attr_type = 6, main_attr_value = 313, deputy_attr_num = 5, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.04, extra_attr_max = 0.05, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50751, 50752, 50753, 50754,}, up_stairs_item_num = 0, },
[10754] = {name = "鞋子", lv = 75, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 15000, swap_atk_price = 750000, main_attr_type = 7, main_attr_value = 313, deputy_attr_num = 2, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20751, 20752, 20753, 20754,}, up_stairs_item_num = 0, },
[20754] = {name = "鞋子", lv = 75, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 30000, swap_atk_price = 750000, main_attr_type = 7, main_attr_value = 313, deputy_attr_num = 3, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30751, 30752, 30753, 30754,}, up_stairs_item_num = 0, },
[30754] = {name = "鞋子", lv = 75, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 45000, swap_atk_price = 750000, main_attr_type = 7, main_attr_value = 313, deputy_attr_num = 4, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40751, 40752, 40753, 40754,}, up_stairs_item_num = 0, },
[40754] = {name = "鞋子", lv = 75, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 60000, swap_atk_price = 750000, main_attr_type = 7, main_attr_value = 313, deputy_attr_num = 5, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50751, 50752, 50753, 50754,}, up_stairs_item_num = 0, },
[50754] = {name = "鞋子", lv = 75, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 75000, swap_atk_price = 750000, main_attr_type = 7, main_attr_value = 313, deputy_attr_num = 5, deputy_attr_min = 187, deputy_attr_max = 234, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.04, extra_attr_max = 0.05, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50751, 50752, 50753, 50754,}, up_stairs_item_num = 0, },
[10801] = {name = "武器", lv = 80, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 16000, swap_atk_price = 800000, main_attr_type = 2, main_attr_value = 1058, deputy_attr_num = 2, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20801, 20802, 20803, 20804,}, up_stairs_item_num = 0, },
[20801] = {name = "武器", lv = 80, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 32000, swap_atk_price = 800000, main_attr_type = 2, main_attr_value = 1058, deputy_attr_num = 3, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30801, 30802, 30803, 30804,}, up_stairs_item_num = 0, },
[30801] = {name = "武器", lv = 80, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 48000, swap_atk_price = 800000, main_attr_type = 2, main_attr_value = 1058, deputy_attr_num = 4, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40801, 40802, 40803, 40804,}, up_stairs_item_num = 0, },
[40801] = {name = "武器", lv = 80, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 64000, swap_atk_price = 800000, main_attr_type = 2, main_attr_value = 1058, deputy_attr_num = 5, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50801, 50802, 50803, 50804,}, up_stairs_item_num = 0, },
[50801] = {name = "武器", lv = 80, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 80000, swap_atk_price = 800000, main_attr_type = 2, main_attr_value = 1058, deputy_attr_num = 5, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0416, extra_attr_max = 0.052, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50801, 50802, 50803, 50804,}, up_stairs_item_num = 0, },
[10802] = {name = "头盔", lv = 80, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 16000, swap_atk_price = 800000, main_attr_type = 1, main_attr_value = 8820, deputy_attr_num = 2, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20801, 20802, 20803, 20804,}, up_stairs_item_num = 0, },
[20802] = {name = "头盔", lv = 80, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 32000, swap_atk_price = 800000, main_attr_type = 1, main_attr_value = 8820, deputy_attr_num = 3, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30801, 30802, 30803, 30804,}, up_stairs_item_num = 0, },
[30802] = {name = "头盔", lv = 80, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 48000, swap_atk_price = 800000, main_attr_type = 1, main_attr_value = 8820, deputy_attr_num = 4, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40801, 40802, 40803, 40804,}, up_stairs_item_num = 0, },
[40802] = {name = "头盔", lv = 80, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 64000, swap_atk_price = 800000, main_attr_type = 1, main_attr_value = 8820, deputy_attr_num = 5, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50801, 50802, 50803, 50804,}, up_stairs_item_num = 0, },
[50802] = {name = "头盔", lv = 80, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 80000, swap_atk_price = 800000, main_attr_type = 1, main_attr_value = 8820, deputy_attr_num = 5, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0416, extra_attr_max = 0.052, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50801, 50802, 50803, 50804,}, up_stairs_item_num = 0, },
[10803] = {name = "防具", lv = 80, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 16000, swap_atk_price = 800000, main_attr_type = 6, main_attr_value = 353, deputy_attr_num = 2, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20801, 20802, 20803, 20804,}, up_stairs_item_num = 0, },
[20803] = {name = "防具", lv = 80, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 32000, swap_atk_price = 800000, main_attr_type = 6, main_attr_value = 353, deputy_attr_num = 3, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30801, 30802, 30803, 30804,}, up_stairs_item_num = 0, },
[30803] = {name = "防具", lv = 80, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 48000, swap_atk_price = 800000, main_attr_type = 6, main_attr_value = 353, deputy_attr_num = 4, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40801, 40802, 40803, 40804,}, up_stairs_item_num = 0, },
[40803] = {name = "防具", lv = 80, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 64000, swap_atk_price = 800000, main_attr_type = 6, main_attr_value = 353, deputy_attr_num = 5, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50801, 50802, 50803, 50804,}, up_stairs_item_num = 0, },
[50803] = {name = "防具", lv = 80, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 80000, swap_atk_price = 800000, main_attr_type = 6, main_attr_value = 353, deputy_attr_num = 5, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0416, extra_attr_max = 0.052, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50801, 50802, 50803, 50804,}, up_stairs_item_num = 0, },
[10804] = {name = "鞋子", lv = 80, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 16000, swap_atk_price = 800000, main_attr_type = 7, main_attr_value = 353, deputy_attr_num = 2, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20801, 20802, 20803, 20804,}, up_stairs_item_num = 0, },
[20804] = {name = "鞋子", lv = 80, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 32000, swap_atk_price = 800000, main_attr_type = 7, main_attr_value = 353, deputy_attr_num = 3, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30801, 30802, 30803, 30804,}, up_stairs_item_num = 0, },
[30804] = {name = "鞋子", lv = 80, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 48000, swap_atk_price = 800000, main_attr_type = 7, main_attr_value = 353, deputy_attr_num = 4, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40801, 40802, 40803, 40804,}, up_stairs_item_num = 0, },
[40804] = {name = "鞋子", lv = 80, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 64000, swap_atk_price = 800000, main_attr_type = 7, main_attr_value = 353, deputy_attr_num = 5, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50801, 50802, 50803, 50804,}, up_stairs_item_num = 0, },
[50804] = {name = "鞋子", lv = 80, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 80000, swap_atk_price = 800000, main_attr_type = 7, main_attr_value = 353, deputy_attr_num = 5, deputy_attr_min = 212, deputy_attr_max = 265, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0416, extra_attr_max = 0.052, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50801, 50802, 50803, 50804,}, up_stairs_item_num = 0, },
[10851] = {name = "武器", lv = 85, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 17000, swap_atk_price = 850000, main_attr_type = 2, main_attr_value = 1187, deputy_attr_num = 2, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20851, 20852, 20853, 20854,}, up_stairs_item_num = 0, },
[20851] = {name = "武器", lv = 85, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 34000, swap_atk_price = 850000, main_attr_type = 2, main_attr_value = 1187, deputy_attr_num = 3, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30851, 30852, 30853, 30854,}, up_stairs_item_num = 0, },
[30851] = {name = "武器", lv = 85, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 51000, swap_atk_price = 850000, main_attr_type = 2, main_attr_value = 1187, deputy_attr_num = 4, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40851, 40852, 40853, 40854,}, up_stairs_item_num = 0, },
[40851] = {name = "武器", lv = 85, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 68000, swap_atk_price = 850000, main_attr_type = 2, main_attr_value = 1187, deputy_attr_num = 5, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50851, 50852, 50853, 50854,}, up_stairs_item_num = 0, },
[50851] = {name = "武器", lv = 85, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 85000, swap_atk_price = 850000, main_attr_type = 2, main_attr_value = 1187, deputy_attr_num = 5, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.054, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50851, 50852, 50853, 50854,}, up_stairs_item_num = 0, },
[10852] = {name = "头盔", lv = 85, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 17000, swap_atk_price = 850000, main_attr_type = 1, main_attr_value = 9893, deputy_attr_num = 2, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20851, 20852, 20853, 20854,}, up_stairs_item_num = 0, },
[20852] = {name = "头盔", lv = 85, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 34000, swap_atk_price = 850000, main_attr_type = 1, main_attr_value = 9893, deputy_attr_num = 3, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30851, 30852, 30853, 30854,}, up_stairs_item_num = 0, },
[30852] = {name = "头盔", lv = 85, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 51000, swap_atk_price = 850000, main_attr_type = 1, main_attr_value = 9893, deputy_attr_num = 4, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40851, 40852, 40853, 40854,}, up_stairs_item_num = 0, },
[40852] = {name = "头盔", lv = 85, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 68000, swap_atk_price = 850000, main_attr_type = 1, main_attr_value = 9893, deputy_attr_num = 5, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50851, 50852, 50853, 50854,}, up_stairs_item_num = 0, },
[50852] = {name = "头盔", lv = 85, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 85000, swap_atk_price = 850000, main_attr_type = 1, main_attr_value = 9893, deputy_attr_num = 5, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.054, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50851, 50852, 50853, 50854,}, up_stairs_item_num = 0, },
[10853] = {name = "防具", lv = 85, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 17000, swap_atk_price = 850000, main_attr_type = 6, main_attr_value = 396, deputy_attr_num = 2, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20851, 20852, 20853, 20854,}, up_stairs_item_num = 0, },
[20853] = {name = "防具", lv = 85, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 34000, swap_atk_price = 850000, main_attr_type = 6, main_attr_value = 396, deputy_attr_num = 3, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30851, 30852, 30853, 30854,}, up_stairs_item_num = 0, },
[30853] = {name = "防具", lv = 85, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 51000, swap_atk_price = 850000, main_attr_type = 6, main_attr_value = 396, deputy_attr_num = 4, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40851, 40852, 40853, 40854,}, up_stairs_item_num = 0, },
[40853] = {name = "防具", lv = 85, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 68000, swap_atk_price = 850000, main_attr_type = 6, main_attr_value = 396, deputy_attr_num = 5, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50851, 50852, 50853, 50854,}, up_stairs_item_num = 0, },
[50853] = {name = "防具", lv = 85, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 85000, swap_atk_price = 850000, main_attr_type = 6, main_attr_value = 396, deputy_attr_num = 5, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.054, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50851, 50852, 50853, 50854,}, up_stairs_item_num = 0, },
[10854] = {name = "鞋子", lv = 85, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 17000, swap_atk_price = 850000, main_attr_type = 7, main_attr_value = 396, deputy_attr_num = 2, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20851, 20852, 20853, 20854,}, up_stairs_item_num = 0, },
[20854] = {name = "鞋子", lv = 85, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 34000, swap_atk_price = 850000, main_attr_type = 7, main_attr_value = 396, deputy_attr_num = 3, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30851, 30852, 30853, 30854,}, up_stairs_item_num = 0, },
[30854] = {name = "鞋子", lv = 85, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 51000, swap_atk_price = 850000, main_attr_type = 7, main_attr_value = 396, deputy_attr_num = 4, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40851, 40852, 40853, 40854,}, up_stairs_item_num = 0, },
[40854] = {name = "鞋子", lv = 85, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 68000, swap_atk_price = 850000, main_attr_type = 7, main_attr_value = 396, deputy_attr_num = 5, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50851, 50852, 50853, 50854,}, up_stairs_item_num = 0, },
[50854] = {name = "鞋子", lv = 85, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 85000, swap_atk_price = 850000, main_attr_type = 7, main_attr_value = 396, deputy_attr_num = 5, deputy_attr_min = 238, deputy_attr_max = 297, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.054, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50851, 50852, 50853, 50854,}, up_stairs_item_num = 0, },
[10901] = {name = "武器", lv = 90, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 18000, swap_atk_price = 900000, main_attr_type = 2, main_attr_value = 1324, deputy_attr_num = 2, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20901, 20902, 20903, 20904,}, up_stairs_item_num = 0, },
[20901] = {name = "武器", lv = 90, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 36000, swap_atk_price = 900000, main_attr_type = 2, main_attr_value = 1324, deputy_attr_num = 3, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30901, 30902, 30903, 30904,}, up_stairs_item_num = 0, },
[30901] = {name = "武器", lv = 90, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 54000, swap_atk_price = 900000, main_attr_type = 2, main_attr_value = 1324, deputy_attr_num = 4, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40901, 40902, 40903, 40904,}, up_stairs_item_num = 0, },
[40901] = {name = "武器", lv = 90, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 72000, swap_atk_price = 900000, main_attr_type = 2, main_attr_value = 1324, deputy_attr_num = 5, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50901, 50902, 50903, 50904,}, up_stairs_item_num = 0, },
[50901] = {name = "武器", lv = 90, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 90000, swap_atk_price = 900000, main_attr_type = 2, main_attr_value = 1324, deputy_attr_num = 5, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0448, extra_attr_max = 0.056, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50901, 50902, 50903, 50904,}, up_stairs_item_num = 0, },
[10902] = {name = "头盔", lv = 90, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 18000, swap_atk_price = 900000, main_attr_type = 1, main_attr_value = 11030, deputy_attr_num = 2, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20901, 20902, 20903, 20904,}, up_stairs_item_num = 0, },
[20902] = {name = "头盔", lv = 90, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 36000, swap_atk_price = 900000, main_attr_type = 1, main_attr_value = 11030, deputy_attr_num = 3, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30901, 30902, 30903, 30904,}, up_stairs_item_num = 0, },
[30902] = {name = "头盔", lv = 90, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 54000, swap_atk_price = 900000, main_attr_type = 1, main_attr_value = 11030, deputy_attr_num = 4, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40901, 40902, 40903, 40904,}, up_stairs_item_num = 0, },
[40902] = {name = "头盔", lv = 90, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 72000, swap_atk_price = 900000, main_attr_type = 1, main_attr_value = 11030, deputy_attr_num = 5, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50901, 50902, 50903, 50904,}, up_stairs_item_num = 0, },
[50902] = {name = "头盔", lv = 90, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 90000, swap_atk_price = 900000, main_attr_type = 1, main_attr_value = 11030, deputy_attr_num = 5, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0448, extra_attr_max = 0.056, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50901, 50902, 50903, 50904,}, up_stairs_item_num = 0, },
[10903] = {name = "防具", lv = 90, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 18000, swap_atk_price = 900000, main_attr_type = 6, main_attr_value = 441, deputy_attr_num = 2, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20901, 20902, 20903, 20904,}, up_stairs_item_num = 0, },
[20903] = {name = "防具", lv = 90, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 36000, swap_atk_price = 900000, main_attr_type = 6, main_attr_value = 441, deputy_attr_num = 3, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30901, 30902, 30903, 30904,}, up_stairs_item_num = 0, },
[30903] = {name = "防具", lv = 90, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 54000, swap_atk_price = 900000, main_attr_type = 6, main_attr_value = 441, deputy_attr_num = 4, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40901, 40902, 40903, 40904,}, up_stairs_item_num = 0, },
[40903] = {name = "防具", lv = 90, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 72000, swap_atk_price = 900000, main_attr_type = 6, main_attr_value = 441, deputy_attr_num = 5, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50901, 50902, 50903, 50904,}, up_stairs_item_num = 0, },
[50903] = {name = "防具", lv = 90, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 90000, swap_atk_price = 900000, main_attr_type = 6, main_attr_value = 441, deputy_attr_num = 5, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0448, extra_attr_max = 0.056, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50901, 50902, 50903, 50904,}, up_stairs_item_num = 0, },
[10904] = {name = "鞋子", lv = 90, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 18000, swap_atk_price = 900000, main_attr_type = 7, main_attr_value = 441, deputy_attr_num = 2, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20901, 20902, 20903, 20904,}, up_stairs_item_num = 0, },
[20904] = {name = "鞋子", lv = 90, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 36000, swap_atk_price = 900000, main_attr_type = 7, main_attr_value = 441, deputy_attr_num = 3, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30901, 30902, 30903, 30904,}, up_stairs_item_num = 0, },
[30904] = {name = "鞋子", lv = 90, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 54000, swap_atk_price = 900000, main_attr_type = 7, main_attr_value = 441, deputy_attr_num = 4, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40901, 40902, 40903, 40904,}, up_stairs_item_num = 0, },
[40904] = {name = "鞋子", lv = 90, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 72000, swap_atk_price = 900000, main_attr_type = 7, main_attr_value = 441, deputy_attr_num = 5, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50901, 50902, 50903, 50904,}, up_stairs_item_num = 0, },
[50904] = {name = "鞋子", lv = 90, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 90000, swap_atk_price = 900000, main_attr_type = 7, main_attr_value = 441, deputy_attr_num = 5, deputy_attr_min = 265, deputy_attr_max = 331, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0448, extra_attr_max = 0.056, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50901, 50902, 50903, 50904,}, up_stairs_item_num = 0, },
[10951] = {name = "武器", lv = 95, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 19000, swap_atk_price = 950000, main_attr_type = 2, main_attr_value = 1468, deputy_attr_num = 2, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20951, 20952, 20953, 20954,}, up_stairs_item_num = 0, },
[20951] = {name = "武器", lv = 95, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 38000, swap_atk_price = 950000, main_attr_type = 2, main_attr_value = 1468, deputy_attr_num = 3, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30951, 30952, 30953, 30954,}, up_stairs_item_num = 0, },
[30951] = {name = "武器", lv = 95, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 57000, swap_atk_price = 950000, main_attr_type = 2, main_attr_value = 1468, deputy_attr_num = 4, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40951, 40952, 40953, 40954,}, up_stairs_item_num = 0, },
[40951] = {name = "武器", lv = 95, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 76000, swap_atk_price = 950000, main_attr_type = 2, main_attr_value = 1468, deputy_attr_num = 5, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50951, 50952, 50953, 50954,}, up_stairs_item_num = 0, },
[50951] = {name = "武器", lv = 95, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 95000, swap_atk_price = 950000, main_attr_type = 2, main_attr_value = 1468, deputy_attr_num = 5, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0464, extra_attr_max = 0.058, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50951, 50952, 50953, 50954,}, up_stairs_item_num = 0, },
[10952] = {name = "头盔", lv = 95, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 19000, swap_atk_price = 950000, main_attr_type = 1, main_attr_value = 12233, deputy_attr_num = 2, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20951, 20952, 20953, 20954,}, up_stairs_item_num = 0, },
[20952] = {name = "头盔", lv = 95, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 38000, swap_atk_price = 950000, main_attr_type = 1, main_attr_value = 12233, deputy_attr_num = 3, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30951, 30952, 30953, 30954,}, up_stairs_item_num = 0, },
[30952] = {name = "头盔", lv = 95, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 57000, swap_atk_price = 950000, main_attr_type = 1, main_attr_value = 12233, deputy_attr_num = 4, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40951, 40952, 40953, 40954,}, up_stairs_item_num = 0, },
[40952] = {name = "头盔", lv = 95, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 76000, swap_atk_price = 950000, main_attr_type = 1, main_attr_value = 12233, deputy_attr_num = 5, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50951, 50952, 50953, 50954,}, up_stairs_item_num = 0, },
[50952] = {name = "头盔", lv = 95, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 95000, swap_atk_price = 950000, main_attr_type = 1, main_attr_value = 12233, deputy_attr_num = 5, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0464, extra_attr_max = 0.058, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50951, 50952, 50953, 50954,}, up_stairs_item_num = 0, },
[10953] = {name = "防具", lv = 95, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 19000, swap_atk_price = 950000, main_attr_type = 6, main_attr_value = 489, deputy_attr_num = 2, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20951, 20952, 20953, 20954,}, up_stairs_item_num = 0, },
[20953] = {name = "防具", lv = 95, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 38000, swap_atk_price = 950000, main_attr_type = 6, main_attr_value = 489, deputy_attr_num = 3, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30951, 30952, 30953, 30954,}, up_stairs_item_num = 0, },
[30953] = {name = "防具", lv = 95, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 57000, swap_atk_price = 950000, main_attr_type = 6, main_attr_value = 489, deputy_attr_num = 4, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40951, 40952, 40953, 40954,}, up_stairs_item_num = 0, },
[40953] = {name = "防具", lv = 95, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 76000, swap_atk_price = 950000, main_attr_type = 6, main_attr_value = 489, deputy_attr_num = 5, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50951, 50952, 50953, 50954,}, up_stairs_item_num = 0, },
[50953] = {name = "防具", lv = 95, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 95000, swap_atk_price = 950000, main_attr_type = 6, main_attr_value = 489, deputy_attr_num = 5, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0464, extra_attr_max = 0.058, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50951, 50952, 50953, 50954,}, up_stairs_item_num = 0, },
[10954] = {name = "鞋子", lv = 95, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 19000, swap_atk_price = 950000, main_attr_type = 7, main_attr_value = 489, deputy_attr_num = 2, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {20951, 20952, 20953, 20954,}, up_stairs_item_num = 0, },
[20954] = {name = "鞋子", lv = 95, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 38000, swap_atk_price = 950000, main_attr_type = 7, main_attr_value = 489, deputy_attr_num = 3, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {30951, 30952, 30953, 30954,}, up_stairs_item_num = 0, },
[30954] = {name = "鞋子", lv = 95, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 57000, swap_atk_price = 950000, main_attr_type = 7, main_attr_value = 489, deputy_attr_num = 4, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {40951, 40952, 40953, 40954,}, up_stairs_item_num = 0, },
[40954] = {name = "鞋子", lv = 95, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 76000, swap_atk_price = 950000, main_attr_type = 7, main_attr_value = 489, deputy_attr_num = 5, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {50951, 50952, 50953, 50954,}, up_stairs_item_num = 0, },
[50954] = {name = "鞋子", lv = 95, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 95000, swap_atk_price = 950000, main_attr_type = 7, main_attr_value = 489, deputy_attr_num = 5, deputy_attr_min = 294, deputy_attr_max = 367, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0464, extra_attr_max = 0.058, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {50951, 50952, 50953, 50954,}, up_stairs_item_num = 0, },
[11001] = {name = "武器", lv = 100, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 20000, swap_atk_price = 1000000, main_attr_type = 2, main_attr_value = 1620, deputy_attr_num = 2, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21001, 21002, 21003, 21004,}, up_stairs_item_num = 0, },
[21001] = {name = "武器", lv = 100, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 40000, swap_atk_price = 1000000, main_attr_type = 2, main_attr_value = 1620, deputy_attr_num = 3, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31001, 31002, 31003, 31004,}, up_stairs_item_num = 0, },
[31001] = {name = "武器", lv = 100, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 60000, swap_atk_price = 1000000, main_attr_type = 2, main_attr_value = 1620, deputy_attr_num = 4, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41001, 41002, 41003, 41004,}, up_stairs_item_num = 0, },
[41001] = {name = "武器", lv = 100, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 80000, swap_atk_price = 1000000, main_attr_type = 2, main_attr_value = 1620, deputy_attr_num = 5, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51001, 51002, 51003, 51004,}, up_stairs_item_num = 0, },
[51001] = {name = "武器", lv = 100, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 100000, swap_atk_price = 1000000, main_attr_type = 2, main_attr_value = 1620, deputy_attr_num = 5, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.06, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51001, 51002, 51003, 51004,}, up_stairs_item_num = 0, },
[11002] = {name = "头盔", lv = 100, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 20000, swap_atk_price = 1000000, main_attr_type = 1, main_attr_value = 13500, deputy_attr_num = 2, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21001, 21002, 21003, 21004,}, up_stairs_item_num = 0, },
[21002] = {name = "头盔", lv = 100, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 40000, swap_atk_price = 1000000, main_attr_type = 1, main_attr_value = 13500, deputy_attr_num = 3, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31001, 31002, 31003, 31004,}, up_stairs_item_num = 0, },
[31002] = {name = "头盔", lv = 100, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 60000, swap_atk_price = 1000000, main_attr_type = 1, main_attr_value = 13500, deputy_attr_num = 4, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41001, 41002, 41003, 41004,}, up_stairs_item_num = 0, },
[41002] = {name = "头盔", lv = 100, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 80000, swap_atk_price = 1000000, main_attr_type = 1, main_attr_value = 13500, deputy_attr_num = 5, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51001, 51002, 51003, 51004,}, up_stairs_item_num = 0, },
[51002] = {name = "头盔", lv = 100, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 100000, swap_atk_price = 1000000, main_attr_type = 1, main_attr_value = 13500, deputy_attr_num = 5, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.06, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51001, 51002, 51003, 51004,}, up_stairs_item_num = 0, },
[11003] = {name = "防具", lv = 100, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 20000, swap_atk_price = 1000000, main_attr_type = 6, main_attr_value = 540, deputy_attr_num = 2, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21001, 21002, 21003, 21004,}, up_stairs_item_num = 0, },
[21003] = {name = "防具", lv = 100, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 40000, swap_atk_price = 1000000, main_attr_type = 6, main_attr_value = 540, deputy_attr_num = 3, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31001, 31002, 31003, 31004,}, up_stairs_item_num = 0, },
[31003] = {name = "防具", lv = 100, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 60000, swap_atk_price = 1000000, main_attr_type = 6, main_attr_value = 540, deputy_attr_num = 4, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41001, 41002, 41003, 41004,}, up_stairs_item_num = 0, },
[41003] = {name = "防具", lv = 100, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 80000, swap_atk_price = 1000000, main_attr_type = 6, main_attr_value = 540, deputy_attr_num = 5, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51001, 51002, 51003, 51004,}, up_stairs_item_num = 0, },
[51003] = {name = "防具", lv = 100, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 100000, swap_atk_price = 1000000, main_attr_type = 6, main_attr_value = 540, deputy_attr_num = 5, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.06, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51001, 51002, 51003, 51004,}, up_stairs_item_num = 0, },
[11004] = {name = "鞋子", lv = 100, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 20000, swap_atk_price = 1000000, main_attr_type = 7, main_attr_value = 540, deputy_attr_num = 2, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21001, 21002, 21003, 21004,}, up_stairs_item_num = 0, },
[21004] = {name = "鞋子", lv = 100, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 40000, swap_atk_price = 1000000, main_attr_type = 7, main_attr_value = 540, deputy_attr_num = 3, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31001, 31002, 31003, 31004,}, up_stairs_item_num = 0, },
[31004] = {name = "鞋子", lv = 100, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 60000, swap_atk_price = 1000000, main_attr_type = 7, main_attr_value = 540, deputy_attr_num = 4, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41001, 41002, 41003, 41004,}, up_stairs_item_num = 0, },
[41004] = {name = "鞋子", lv = 100, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 80000, swap_atk_price = 1000000, main_attr_type = 7, main_attr_value = 540, deputy_attr_num = 5, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51001, 51002, 51003, 51004,}, up_stairs_item_num = 0, },
[51004] = {name = "鞋子", lv = 100, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 100000, swap_atk_price = 1000000, main_attr_type = 7, main_attr_value = 540, deputy_attr_num = 5, deputy_attr_min = 324, deputy_attr_max = 405, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.06, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51001, 51002, 51003, 51004,}, up_stairs_item_num = 0, },
[11051] = {name = "武器", lv = 105, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 21000, swap_atk_price = 1050000, main_attr_type = 2, main_attr_value = 1780, deputy_attr_num = 2, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21051, 21052, 21053, 21054,}, up_stairs_item_num = 0, },
[21051] = {name = "武器", lv = 105, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 42000, swap_atk_price = 1050000, main_attr_type = 2, main_attr_value = 1780, deputy_attr_num = 3, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31051, 31052, 31053, 31054,}, up_stairs_item_num = 0, },
[31051] = {name = "武器", lv = 105, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 63000, swap_atk_price = 1050000, main_attr_type = 2, main_attr_value = 1780, deputy_attr_num = 4, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41051, 41052, 41053, 41054,}, up_stairs_item_num = 0, },
[41051] = {name = "武器", lv = 105, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 84000, swap_atk_price = 1050000, main_attr_type = 2, main_attr_value = 1780, deputy_attr_num = 5, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51051, 51052, 51053, 51054,}, up_stairs_item_num = 0, },
[51051] = {name = "武器", lv = 105, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 105000, swap_atk_price = 1050000, main_attr_type = 2, main_attr_value = 1780, deputy_attr_num = 5, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0496, extra_attr_max = 0.062, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51051, 51052, 51053, 51054,}, up_stairs_item_num = 0, },
[11052] = {name = "头盔", lv = 105, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 21000, swap_atk_price = 1050000, main_attr_type = 1, main_attr_value = 14833, deputy_attr_num = 2, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21051, 21052, 21053, 21054,}, up_stairs_item_num = 0, },
[21052] = {name = "头盔", lv = 105, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 42000, swap_atk_price = 1050000, main_attr_type = 1, main_attr_value = 14833, deputy_attr_num = 3, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31051, 31052, 31053, 31054,}, up_stairs_item_num = 0, },
[31052] = {name = "头盔", lv = 105, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 63000, swap_atk_price = 1050000, main_attr_type = 1, main_attr_value = 14833, deputy_attr_num = 4, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41051, 41052, 41053, 41054,}, up_stairs_item_num = 0, },
[41052] = {name = "头盔", lv = 105, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 84000, swap_atk_price = 1050000, main_attr_type = 1, main_attr_value = 14833, deputy_attr_num = 5, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51051, 51052, 51053, 51054,}, up_stairs_item_num = 0, },
[51052] = {name = "头盔", lv = 105, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 105000, swap_atk_price = 1050000, main_attr_type = 1, main_attr_value = 14833, deputy_attr_num = 5, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0496, extra_attr_max = 0.062, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51051, 51052, 51053, 51054,}, up_stairs_item_num = 0, },
[11053] = {name = "防具", lv = 105, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 21000, swap_atk_price = 1050000, main_attr_type = 6, main_attr_value = 593, deputy_attr_num = 2, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21051, 21052, 21053, 21054,}, up_stairs_item_num = 0, },
[21053] = {name = "防具", lv = 105, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 42000, swap_atk_price = 1050000, main_attr_type = 6, main_attr_value = 593, deputy_attr_num = 3, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31051, 31052, 31053, 31054,}, up_stairs_item_num = 0, },
[31053] = {name = "防具", lv = 105, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 63000, swap_atk_price = 1050000, main_attr_type = 6, main_attr_value = 593, deputy_attr_num = 4, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41051, 41052, 41053, 41054,}, up_stairs_item_num = 0, },
[41053] = {name = "防具", lv = 105, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 84000, swap_atk_price = 1050000, main_attr_type = 6, main_attr_value = 593, deputy_attr_num = 5, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51051, 51052, 51053, 51054,}, up_stairs_item_num = 0, },
[51053] = {name = "防具", lv = 105, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 105000, swap_atk_price = 1050000, main_attr_type = 6, main_attr_value = 593, deputy_attr_num = 5, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0496, extra_attr_max = 0.062, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51051, 51052, 51053, 51054,}, up_stairs_item_num = 0, },
[11054] = {name = "鞋子", lv = 105, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 21000, swap_atk_price = 1050000, main_attr_type = 7, main_attr_value = 593, deputy_attr_num = 2, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21051, 21052, 21053, 21054,}, up_stairs_item_num = 0, },
[21054] = {name = "鞋子", lv = 105, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 42000, swap_atk_price = 1050000, main_attr_type = 7, main_attr_value = 593, deputy_attr_num = 3, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31051, 31052, 31053, 31054,}, up_stairs_item_num = 0, },
[31054] = {name = "鞋子", lv = 105, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 63000, swap_atk_price = 1050000, main_attr_type = 7, main_attr_value = 593, deputy_attr_num = 4, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41051, 41052, 41053, 41054,}, up_stairs_item_num = 0, },
[41054] = {name = "鞋子", lv = 105, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 84000, swap_atk_price = 1050000, main_attr_type = 7, main_attr_value = 593, deputy_attr_num = 5, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51051, 51052, 51053, 51054,}, up_stairs_item_num = 0, },
[51054] = {name = "鞋子", lv = 105, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 105000, swap_atk_price = 1050000, main_attr_type = 7, main_attr_value = 593, deputy_attr_num = 5, deputy_attr_min = 356, deputy_attr_max = 445, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0496, extra_attr_max = 0.062, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51051, 51052, 51053, 51054,}, up_stairs_item_num = 0, },
[11101] = {name = "武器", lv = 110, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 22000, swap_atk_price = 1100000, main_attr_type = 2, main_attr_value = 1948, deputy_attr_num = 2, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21101, 21102, 21103, 21104,}, up_stairs_item_num = 0, },
[21101] = {name = "武器", lv = 110, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 44000, swap_atk_price = 1100000, main_attr_type = 2, main_attr_value = 1948, deputy_attr_num = 3, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31101, 31102, 31103, 31104,}, up_stairs_item_num = 0, },
[31101] = {name = "武器", lv = 110, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 66000, swap_atk_price = 1100000, main_attr_type = 2, main_attr_value = 1948, deputy_attr_num = 4, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41101, 41102, 41103, 41104,}, up_stairs_item_num = 0, },
[41101] = {name = "武器", lv = 110, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 88000, swap_atk_price = 1100000, main_attr_type = 2, main_attr_value = 1948, deputy_attr_num = 5, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51101, 51102, 51103, 51104,}, up_stairs_item_num = 0, },
[51101] = {name = "武器", lv = 110, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 110000, swap_atk_price = 1100000, main_attr_type = 2, main_attr_value = 1948, deputy_attr_num = 5, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0512, extra_attr_max = 0.064, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51101, 51102, 51103, 51104,}, up_stairs_item_num = 0, },
[11102] = {name = "头盔", lv = 110, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 22000, swap_atk_price = 1100000, main_attr_type = 1, main_attr_value = 16230, deputy_attr_num = 2, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21101, 21102, 21103, 21104,}, up_stairs_item_num = 0, },
[21102] = {name = "头盔", lv = 110, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 44000, swap_atk_price = 1100000, main_attr_type = 1, main_attr_value = 16230, deputy_attr_num = 3, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31101, 31102, 31103, 31104,}, up_stairs_item_num = 0, },
[31102] = {name = "头盔", lv = 110, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 66000, swap_atk_price = 1100000, main_attr_type = 1, main_attr_value = 16230, deputy_attr_num = 4, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41101, 41102, 41103, 41104,}, up_stairs_item_num = 0, },
[41102] = {name = "头盔", lv = 110, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 88000, swap_atk_price = 1100000, main_attr_type = 1, main_attr_value = 16230, deputy_attr_num = 5, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51101, 51102, 51103, 51104,}, up_stairs_item_num = 0, },
[51102] = {name = "头盔", lv = 110, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 110000, swap_atk_price = 1100000, main_attr_type = 1, main_attr_value = 16230, deputy_attr_num = 5, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0512, extra_attr_max = 0.064, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51101, 51102, 51103, 51104,}, up_stairs_item_num = 0, },
[11103] = {name = "防具", lv = 110, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 22000, swap_atk_price = 1100000, main_attr_type = 6, main_attr_value = 649, deputy_attr_num = 2, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21101, 21102, 21103, 21104,}, up_stairs_item_num = 0, },
[21103] = {name = "防具", lv = 110, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 44000, swap_atk_price = 1100000, main_attr_type = 6, main_attr_value = 649, deputy_attr_num = 3, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31101, 31102, 31103, 31104,}, up_stairs_item_num = 0, },
[31103] = {name = "防具", lv = 110, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 66000, swap_atk_price = 1100000, main_attr_type = 6, main_attr_value = 649, deputy_attr_num = 4, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41101, 41102, 41103, 41104,}, up_stairs_item_num = 0, },
[41103] = {name = "防具", lv = 110, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 88000, swap_atk_price = 1100000, main_attr_type = 6, main_attr_value = 649, deputy_attr_num = 5, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51101, 51102, 51103, 51104,}, up_stairs_item_num = 0, },
[51103] = {name = "防具", lv = 110, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 110000, swap_atk_price = 1100000, main_attr_type = 6, main_attr_value = 649, deputy_attr_num = 5, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0512, extra_attr_max = 0.064, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51101, 51102, 51103, 51104,}, up_stairs_item_num = 0, },
[11104] = {name = "鞋子", lv = 110, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 22000, swap_atk_price = 1100000, main_attr_type = 7, main_attr_value = 649, deputy_attr_num = 2, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21101, 21102, 21103, 21104,}, up_stairs_item_num = 0, },
[21104] = {name = "鞋子", lv = 110, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 44000, swap_atk_price = 1100000, main_attr_type = 7, main_attr_value = 649, deputy_attr_num = 3, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31101, 31102, 31103, 31104,}, up_stairs_item_num = 0, },
[31104] = {name = "鞋子", lv = 110, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 66000, swap_atk_price = 1100000, main_attr_type = 7, main_attr_value = 649, deputy_attr_num = 4, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41101, 41102, 41103, 41104,}, up_stairs_item_num = 0, },
[41104] = {name = "鞋子", lv = 110, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 88000, swap_atk_price = 1100000, main_attr_type = 7, main_attr_value = 649, deputy_attr_num = 5, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51101, 51102, 51103, 51104,}, up_stairs_item_num = 0, },
[51104] = {name = "鞋子", lv = 110, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 110000, swap_atk_price = 1100000, main_attr_type = 7, main_attr_value = 649, deputy_attr_num = 5, deputy_attr_min = 390, deputy_attr_max = 487, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0512, extra_attr_max = 0.064, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51101, 51102, 51103, 51104,}, up_stairs_item_num = 0, },
[11151] = {name = "武器", lv = 115, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 23000, swap_atk_price = 1150000, main_attr_type = 2, main_attr_value = 2123, deputy_attr_num = 2, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21151, 21152, 21153, 21154,}, up_stairs_item_num = 0, },
[21151] = {name = "武器", lv = 115, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 46000, swap_atk_price = 1150000, main_attr_type = 2, main_attr_value = 2123, deputy_attr_num = 3, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31151, 31152, 31153, 31154,}, up_stairs_item_num = 0, },
[31151] = {name = "武器", lv = 115, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 69000, swap_atk_price = 1150000, main_attr_type = 2, main_attr_value = 2123, deputy_attr_num = 4, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41151, 41152, 41153, 41154,}, up_stairs_item_num = 0, },
[41151] = {name = "武器", lv = 115, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 92000, swap_atk_price = 1150000, main_attr_type = 2, main_attr_value = 2123, deputy_attr_num = 5, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51151, 51152, 51153, 51154,}, up_stairs_item_num = 0, },
[51151] = {name = "武器", lv = 115, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 115000, swap_atk_price = 1150000, main_attr_type = 2, main_attr_value = 2123, deputy_attr_num = 5, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.066, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51151, 51152, 51153, 51154,}, up_stairs_item_num = 0, },
[11152] = {name = "头盔", lv = 115, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 23000, swap_atk_price = 1150000, main_attr_type = 1, main_attr_value = 17693, deputy_attr_num = 2, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21151, 21152, 21153, 21154,}, up_stairs_item_num = 0, },
[21152] = {name = "头盔", lv = 115, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 46000, swap_atk_price = 1150000, main_attr_type = 1, main_attr_value = 17693, deputy_attr_num = 3, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31151, 31152, 31153, 31154,}, up_stairs_item_num = 0, },
[31152] = {name = "头盔", lv = 115, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 69000, swap_atk_price = 1150000, main_attr_type = 1, main_attr_value = 17693, deputy_attr_num = 4, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41151, 41152, 41153, 41154,}, up_stairs_item_num = 0, },
[41152] = {name = "头盔", lv = 115, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 92000, swap_atk_price = 1150000, main_attr_type = 1, main_attr_value = 17693, deputy_attr_num = 5, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51151, 51152, 51153, 51154,}, up_stairs_item_num = 0, },
[51152] = {name = "头盔", lv = 115, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 115000, swap_atk_price = 1150000, main_attr_type = 1, main_attr_value = 17693, deputy_attr_num = 5, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.066, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51151, 51152, 51153, 51154,}, up_stairs_item_num = 0, },
[11153] = {name = "防具", lv = 115, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 23000, swap_atk_price = 1150000, main_attr_type = 6, main_attr_value = 708, deputy_attr_num = 2, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21151, 21152, 21153, 21154,}, up_stairs_item_num = 0, },
[21153] = {name = "防具", lv = 115, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 46000, swap_atk_price = 1150000, main_attr_type = 6, main_attr_value = 708, deputy_attr_num = 3, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31151, 31152, 31153, 31154,}, up_stairs_item_num = 0, },
[31153] = {name = "防具", lv = 115, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 69000, swap_atk_price = 1150000, main_attr_type = 6, main_attr_value = 708, deputy_attr_num = 4, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41151, 41152, 41153, 41154,}, up_stairs_item_num = 0, },
[41153] = {name = "防具", lv = 115, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 92000, swap_atk_price = 1150000, main_attr_type = 6, main_attr_value = 708, deputy_attr_num = 5, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51151, 51152, 51153, 51154,}, up_stairs_item_num = 0, },
[51153] = {name = "防具", lv = 115, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 115000, swap_atk_price = 1150000, main_attr_type = 6, main_attr_value = 708, deputy_attr_num = 5, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.066, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51151, 51152, 51153, 51154,}, up_stairs_item_num = 0, },
[11154] = {name = "鞋子", lv = 115, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 23000, swap_atk_price = 1150000, main_attr_type = 7, main_attr_value = 708, deputy_attr_num = 2, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21151, 21152, 21153, 21154,}, up_stairs_item_num = 0, },
[21154] = {name = "鞋子", lv = 115, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 46000, swap_atk_price = 1150000, main_attr_type = 7, main_attr_value = 708, deputy_attr_num = 3, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31151, 31152, 31153, 31154,}, up_stairs_item_num = 0, },
[31154] = {name = "鞋子", lv = 115, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 69000, swap_atk_price = 1150000, main_attr_type = 7, main_attr_value = 708, deputy_attr_num = 4, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41151, 41152, 41153, 41154,}, up_stairs_item_num = 0, },
[41154] = {name = "鞋子", lv = 115, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 92000, swap_atk_price = 1150000, main_attr_type = 7, main_attr_value = 708, deputy_attr_num = 5, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51151, 51152, 51153, 51154,}, up_stairs_item_num = 0, },
[51154] = {name = "鞋子", lv = 115, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 115000, swap_atk_price = 1150000, main_attr_type = 7, main_attr_value = 708, deputy_attr_num = 5, deputy_attr_min = 425, deputy_attr_max = 531, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.066, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51151, 51152, 51153, 51154,}, up_stairs_item_num = 0, },
[11201] = {name = "武器", lv = 120, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 24000, swap_atk_price = 1200000, main_attr_type = 2, main_attr_value = 2306, deputy_attr_num = 2, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21201, 21202, 21203, 21204,}, up_stairs_item_num = 0, },
[21201] = {name = "武器", lv = 120, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 48000, swap_atk_price = 1200000, main_attr_type = 2, main_attr_value = 2306, deputy_attr_num = 3, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31201, 31202, 31203, 31204,}, up_stairs_item_num = 0, },
[31201] = {name = "武器", lv = 120, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 72000, swap_atk_price = 1200000, main_attr_type = 2, main_attr_value = 2306, deputy_attr_num = 4, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41201, 41202, 41203, 41204,}, up_stairs_item_num = 0, },
[41201] = {name = "武器", lv = 120, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 96000, swap_atk_price = 1200000, main_attr_type = 2, main_attr_value = 2306, deputy_attr_num = 5, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51201, 51202, 51203, 51204,}, up_stairs_item_num = 0, },
[51201] = {name = "武器", lv = 120, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 120000, swap_atk_price = 1200000, main_attr_type = 2, main_attr_value = 2306, deputy_attr_num = 5, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0544, extra_attr_max = 0.068, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51201, 51202, 51203, 51204,}, up_stairs_item_num = 0, },
[11202] = {name = "头盔", lv = 120, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 24000, swap_atk_price = 1200000, main_attr_type = 1, main_attr_value = 19220, deputy_attr_num = 2, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21201, 21202, 21203, 21204,}, up_stairs_item_num = 0, },
[21202] = {name = "头盔", lv = 120, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 48000, swap_atk_price = 1200000, main_attr_type = 1, main_attr_value = 19220, deputy_attr_num = 3, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31201, 31202, 31203, 31204,}, up_stairs_item_num = 0, },
[31202] = {name = "头盔", lv = 120, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 72000, swap_atk_price = 1200000, main_attr_type = 1, main_attr_value = 19220, deputy_attr_num = 4, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41201, 41202, 41203, 41204,}, up_stairs_item_num = 0, },
[41202] = {name = "头盔", lv = 120, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 96000, swap_atk_price = 1200000, main_attr_type = 1, main_attr_value = 19220, deputy_attr_num = 5, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51201, 51202, 51203, 51204,}, up_stairs_item_num = 0, },
[51202] = {name = "头盔", lv = 120, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 120000, swap_atk_price = 1200000, main_attr_type = 1, main_attr_value = 19220, deputy_attr_num = 5, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0544, extra_attr_max = 0.068, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51201, 51202, 51203, 51204,}, up_stairs_item_num = 0, },
[11203] = {name = "防具", lv = 120, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 24000, swap_atk_price = 1200000, main_attr_type = 6, main_attr_value = 769, deputy_attr_num = 2, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21201, 21202, 21203, 21204,}, up_stairs_item_num = 0, },
[21203] = {name = "防具", lv = 120, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 48000, swap_atk_price = 1200000, main_attr_type = 6, main_attr_value = 769, deputy_attr_num = 3, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31201, 31202, 31203, 31204,}, up_stairs_item_num = 0, },
[31203] = {name = "防具", lv = 120, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 72000, swap_atk_price = 1200000, main_attr_type = 6, main_attr_value = 769, deputy_attr_num = 4, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41201, 41202, 41203, 41204,}, up_stairs_item_num = 0, },
[41203] = {name = "防具", lv = 120, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 96000, swap_atk_price = 1200000, main_attr_type = 6, main_attr_value = 769, deputy_attr_num = 5, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51201, 51202, 51203, 51204,}, up_stairs_item_num = 0, },
[51203] = {name = "防具", lv = 120, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 120000, swap_atk_price = 1200000, main_attr_type = 6, main_attr_value = 769, deputy_attr_num = 5, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0544, extra_attr_max = 0.068, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51201, 51202, 51203, 51204,}, up_stairs_item_num = 0, },
[11204] = {name = "鞋子", lv = 120, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 24000, swap_atk_price = 1200000, main_attr_type = 7, main_attr_value = 769, deputy_attr_num = 2, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21201, 21202, 21203, 21204,}, up_stairs_item_num = 0, },
[21204] = {name = "鞋子", lv = 120, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 48000, swap_atk_price = 1200000, main_attr_type = 7, main_attr_value = 769, deputy_attr_num = 3, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31201, 31202, 31203, 31204,}, up_stairs_item_num = 0, },
[31204] = {name = "鞋子", lv = 120, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 72000, swap_atk_price = 1200000, main_attr_type = 7, main_attr_value = 769, deputy_attr_num = 4, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41201, 41202, 41203, 41204,}, up_stairs_item_num = 0, },
[41204] = {name = "鞋子", lv = 120, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 96000, swap_atk_price = 1200000, main_attr_type = 7, main_attr_value = 769, deputy_attr_num = 5, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51201, 51202, 51203, 51204,}, up_stairs_item_num = 0, },
[51204] = {name = "鞋子", lv = 120, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 120000, swap_atk_price = 1200000, main_attr_type = 7, main_attr_value = 769, deputy_attr_num = 5, deputy_attr_min = 462, deputy_attr_max = 577, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0544, extra_attr_max = 0.068, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51201, 51202, 51203, 51204,}, up_stairs_item_num = 0, },
[11251] = {name = "武器", lv = 125, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 25000, swap_atk_price = 1250000, main_attr_type = 2, main_attr_value = 2498, deputy_attr_num = 2, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21251, 21252, 21253, 21254,}, up_stairs_item_num = 0, },
[21251] = {name = "武器", lv = 125, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 50000, swap_atk_price = 1250000, main_attr_type = 2, main_attr_value = 2498, deputy_attr_num = 3, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31251, 31252, 31253, 31254,}, up_stairs_item_num = 0, },
[31251] = {name = "武器", lv = 125, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 75000, swap_atk_price = 1250000, main_attr_type = 2, main_attr_value = 2498, deputy_attr_num = 4, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41251, 41252, 41253, 41254,}, up_stairs_item_num = 0, },
[41251] = {name = "武器", lv = 125, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 100000, swap_atk_price = 1250000, main_attr_type = 2, main_attr_value = 2498, deputy_attr_num = 5, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51251, 51252, 51253, 51254,}, up_stairs_item_num = 0, },
[51251] = {name = "武器", lv = 125, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 125000, swap_atk_price = 1250000, main_attr_type = 2, main_attr_value = 2498, deputy_attr_num = 5, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.056, extra_attr_max = 0.07, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51251, 51252, 51253, 51254,}, up_stairs_item_num = 0, },
[11252] = {name = "头盔", lv = 125, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 25000, swap_atk_price = 1250000, main_attr_type = 1, main_attr_value = 20813, deputy_attr_num = 2, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21251, 21252, 21253, 21254,}, up_stairs_item_num = 0, },
[21252] = {name = "头盔", lv = 125, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 50000, swap_atk_price = 1250000, main_attr_type = 1, main_attr_value = 20813, deputy_attr_num = 3, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31251, 31252, 31253, 31254,}, up_stairs_item_num = 0, },
[31252] = {name = "头盔", lv = 125, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 75000, swap_atk_price = 1250000, main_attr_type = 1, main_attr_value = 20813, deputy_attr_num = 4, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41251, 41252, 41253, 41254,}, up_stairs_item_num = 0, },
[41252] = {name = "头盔", lv = 125, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 100000, swap_atk_price = 1250000, main_attr_type = 1, main_attr_value = 20813, deputy_attr_num = 5, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51251, 51252, 51253, 51254,}, up_stairs_item_num = 0, },
[51252] = {name = "头盔", lv = 125, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 125000, swap_atk_price = 1250000, main_attr_type = 1, main_attr_value = 20813, deputy_attr_num = 5, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.056, extra_attr_max = 0.07, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51251, 51252, 51253, 51254,}, up_stairs_item_num = 0, },
[11253] = {name = "防具", lv = 125, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 25000, swap_atk_price = 1250000, main_attr_type = 6, main_attr_value = 833, deputy_attr_num = 2, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21251, 21252, 21253, 21254,}, up_stairs_item_num = 0, },
[21253] = {name = "防具", lv = 125, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 50000, swap_atk_price = 1250000, main_attr_type = 6, main_attr_value = 833, deputy_attr_num = 3, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31251, 31252, 31253, 31254,}, up_stairs_item_num = 0, },
[31253] = {name = "防具", lv = 125, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 75000, swap_atk_price = 1250000, main_attr_type = 6, main_attr_value = 833, deputy_attr_num = 4, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41251, 41252, 41253, 41254,}, up_stairs_item_num = 0, },
[41253] = {name = "防具", lv = 125, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 100000, swap_atk_price = 1250000, main_attr_type = 6, main_attr_value = 833, deputy_attr_num = 5, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51251, 51252, 51253, 51254,}, up_stairs_item_num = 0, },
[51253] = {name = "防具", lv = 125, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 125000, swap_atk_price = 1250000, main_attr_type = 6, main_attr_value = 833, deputy_attr_num = 5, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.056, extra_attr_max = 0.07, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51251, 51252, 51253, 51254,}, up_stairs_item_num = 0, },
[11254] = {name = "鞋子", lv = 125, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 25000, swap_atk_price = 1250000, main_attr_type = 7, main_attr_value = 833, deputy_attr_num = 2, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21251, 21252, 21253, 21254,}, up_stairs_item_num = 0, },
[21254] = {name = "鞋子", lv = 125, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 50000, swap_atk_price = 1250000, main_attr_type = 7, main_attr_value = 833, deputy_attr_num = 3, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31251, 31252, 31253, 31254,}, up_stairs_item_num = 0, },
[31254] = {name = "鞋子", lv = 125, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 75000, swap_atk_price = 1250000, main_attr_type = 7, main_attr_value = 833, deputy_attr_num = 4, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41251, 41252, 41253, 41254,}, up_stairs_item_num = 0, },
[41254] = {name = "鞋子", lv = 125, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 100000, swap_atk_price = 1250000, main_attr_type = 7, main_attr_value = 833, deputy_attr_num = 5, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51251, 51252, 51253, 51254,}, up_stairs_item_num = 0, },
[51254] = {name = "鞋子", lv = 125, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 125000, swap_atk_price = 1250000, main_attr_type = 7, main_attr_value = 833, deputy_attr_num = 5, deputy_attr_min = 499, deputy_attr_max = 624, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.056, extra_attr_max = 0.07, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51251, 51252, 51253, 51254,}, up_stairs_item_num = 0, },
[11301] = {name = "武器", lv = 130, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 26000, swap_atk_price = 1300000, main_attr_type = 2, main_attr_value = 2696, deputy_attr_num = 2, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21301, 21302, 21303, 21304,}, up_stairs_item_num = 0, },
[21301] = {name = "武器", lv = 130, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 52000, swap_atk_price = 1300000, main_attr_type = 2, main_attr_value = 2696, deputy_attr_num = 3, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31301, 31302, 31303, 31304,}, up_stairs_item_num = 0, },
[31301] = {name = "武器", lv = 130, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 78000, swap_atk_price = 1300000, main_attr_type = 2, main_attr_value = 2696, deputy_attr_num = 4, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41301, 41302, 41303, 41304,}, up_stairs_item_num = 0, },
[41301] = {name = "武器", lv = 130, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 104000, swap_atk_price = 1300000, main_attr_type = 2, main_attr_value = 2696, deputy_attr_num = 5, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51301, 51302, 51303, 51304,}, up_stairs_item_num = 0, },
[51301] = {name = "武器", lv = 130, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 130000, swap_atk_price = 1300000, main_attr_type = 2, main_attr_value = 2696, deputy_attr_num = 5, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.072, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51301, 51302, 51303, 51304,}, up_stairs_item_num = 0, },
[11302] = {name = "头盔", lv = 130, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 26000, swap_atk_price = 1300000, main_attr_type = 1, main_attr_value = 22470, deputy_attr_num = 2, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21301, 21302, 21303, 21304,}, up_stairs_item_num = 0, },
[21302] = {name = "头盔", lv = 130, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 52000, swap_atk_price = 1300000, main_attr_type = 1, main_attr_value = 22470, deputy_attr_num = 3, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31301, 31302, 31303, 31304,}, up_stairs_item_num = 0, },
[31302] = {name = "头盔", lv = 130, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 78000, swap_atk_price = 1300000, main_attr_type = 1, main_attr_value = 22470, deputy_attr_num = 4, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41301, 41302, 41303, 41304,}, up_stairs_item_num = 0, },
[41302] = {name = "头盔", lv = 130, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 104000, swap_atk_price = 1300000, main_attr_type = 1, main_attr_value = 22470, deputy_attr_num = 5, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51301, 51302, 51303, 51304,}, up_stairs_item_num = 0, },
[51302] = {name = "头盔", lv = 130, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 130000, swap_atk_price = 1300000, main_attr_type = 1, main_attr_value = 22470, deputy_attr_num = 5, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.072, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51301, 51302, 51303, 51304,}, up_stairs_item_num = 0, },
[11303] = {name = "防具", lv = 130, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 26000, swap_atk_price = 1300000, main_attr_type = 6, main_attr_value = 899, deputy_attr_num = 2, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21301, 21302, 21303, 21304,}, up_stairs_item_num = 0, },
[21303] = {name = "防具", lv = 130, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 52000, swap_atk_price = 1300000, main_attr_type = 6, main_attr_value = 899, deputy_attr_num = 3, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31301, 31302, 31303, 31304,}, up_stairs_item_num = 0, },
[31303] = {name = "防具", lv = 130, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 78000, swap_atk_price = 1300000, main_attr_type = 6, main_attr_value = 899, deputy_attr_num = 4, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41301, 41302, 41303, 41304,}, up_stairs_item_num = 0, },
[41303] = {name = "防具", lv = 130, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 104000, swap_atk_price = 1300000, main_attr_type = 6, main_attr_value = 899, deputy_attr_num = 5, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51301, 51302, 51303, 51304,}, up_stairs_item_num = 0, },
[51303] = {name = "防具", lv = 130, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 130000, swap_atk_price = 1300000, main_attr_type = 6, main_attr_value = 899, deputy_attr_num = 5, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.072, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51301, 51302, 51303, 51304,}, up_stairs_item_num = 0, },
[11304] = {name = "鞋子", lv = 130, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 26000, swap_atk_price = 1300000, main_attr_type = 7, main_attr_value = 899, deputy_attr_num = 2, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21301, 21302, 21303, 21304,}, up_stairs_item_num = 0, },
[21304] = {name = "鞋子", lv = 130, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 52000, swap_atk_price = 1300000, main_attr_type = 7, main_attr_value = 899, deputy_attr_num = 3, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31301, 31302, 31303, 31304,}, up_stairs_item_num = 0, },
[31304] = {name = "鞋子", lv = 130, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 78000, swap_atk_price = 1300000, main_attr_type = 7, main_attr_value = 899, deputy_attr_num = 4, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41301, 41302, 41303, 41304,}, up_stairs_item_num = 0, },
[41304] = {name = "鞋子", lv = 130, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 104000, swap_atk_price = 1300000, main_attr_type = 7, main_attr_value = 899, deputy_attr_num = 5, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51301, 51302, 51303, 51304,}, up_stairs_item_num = 0, },
[51304] = {name = "鞋子", lv = 130, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 130000, swap_atk_price = 1300000, main_attr_type = 7, main_attr_value = 899, deputy_attr_num = 5, deputy_attr_min = 539, deputy_attr_max = 674, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.072, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51301, 51302, 51303, 51304,}, up_stairs_item_num = 0, },
[11351] = {name = "武器", lv = 135, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 27000, swap_atk_price = 1350000, main_attr_type = 2, main_attr_value = 2903, deputy_attr_num = 2, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21351, 21352, 21353, 21354,}, up_stairs_item_num = 0, },
[21351] = {name = "武器", lv = 135, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 54000, swap_atk_price = 1350000, main_attr_type = 2, main_attr_value = 2903, deputy_attr_num = 3, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31351, 31352, 31353, 31354,}, up_stairs_item_num = 0, },
[31351] = {name = "武器", lv = 135, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 81000, swap_atk_price = 1350000, main_attr_type = 2, main_attr_value = 2903, deputy_attr_num = 4, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41351, 41352, 41353, 41354,}, up_stairs_item_num = 0, },
[41351] = {name = "武器", lv = 135, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 108000, swap_atk_price = 1350000, main_attr_type = 2, main_attr_value = 2903, deputy_attr_num = 5, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51351, 51352, 51353, 51354,}, up_stairs_item_num = 0, },
[51351] = {name = "武器", lv = 135, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 135000, swap_atk_price = 1350000, main_attr_type = 2, main_attr_value = 2903, deputy_attr_num = 5, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0592, extra_attr_max = 0.074, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51351, 51352, 51353, 51354,}, up_stairs_item_num = 0, },
[11352] = {name = "头盔", lv = 135, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 27000, swap_atk_price = 1350000, main_attr_type = 1, main_attr_value = 24193, deputy_attr_num = 2, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21351, 21352, 21353, 21354,}, up_stairs_item_num = 0, },
[21352] = {name = "头盔", lv = 135, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 54000, swap_atk_price = 1350000, main_attr_type = 1, main_attr_value = 24193, deputy_attr_num = 3, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31351, 31352, 31353, 31354,}, up_stairs_item_num = 0, },
[31352] = {name = "头盔", lv = 135, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 81000, swap_atk_price = 1350000, main_attr_type = 1, main_attr_value = 24193, deputy_attr_num = 4, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41351, 41352, 41353, 41354,}, up_stairs_item_num = 0, },
[41352] = {name = "头盔", lv = 135, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 108000, swap_atk_price = 1350000, main_attr_type = 1, main_attr_value = 24193, deputy_attr_num = 5, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51351, 51352, 51353, 51354,}, up_stairs_item_num = 0, },
[51352] = {name = "头盔", lv = 135, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 135000, swap_atk_price = 1350000, main_attr_type = 1, main_attr_value = 24193, deputy_attr_num = 5, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0592, extra_attr_max = 0.074, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51351, 51352, 51353, 51354,}, up_stairs_item_num = 0, },
[11353] = {name = "防具", lv = 135, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 27000, swap_atk_price = 1350000, main_attr_type = 6, main_attr_value = 968, deputy_attr_num = 2, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21351, 21352, 21353, 21354,}, up_stairs_item_num = 0, },
[21353] = {name = "防具", lv = 135, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 54000, swap_atk_price = 1350000, main_attr_type = 6, main_attr_value = 968, deputy_attr_num = 3, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31351, 31352, 31353, 31354,}, up_stairs_item_num = 0, },
[31353] = {name = "防具", lv = 135, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 81000, swap_atk_price = 1350000, main_attr_type = 6, main_attr_value = 968, deputy_attr_num = 4, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41351, 41352, 41353, 41354,}, up_stairs_item_num = 0, },
[41353] = {name = "防具", lv = 135, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 108000, swap_atk_price = 1350000, main_attr_type = 6, main_attr_value = 968, deputy_attr_num = 5, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51351, 51352, 51353, 51354,}, up_stairs_item_num = 0, },
[51353] = {name = "防具", lv = 135, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 135000, swap_atk_price = 1350000, main_attr_type = 6, main_attr_value = 968, deputy_attr_num = 5, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0592, extra_attr_max = 0.074, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51351, 51352, 51353, 51354,}, up_stairs_item_num = 0, },
[11354] = {name = "鞋子", lv = 135, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 27000, swap_atk_price = 1350000, main_attr_type = 7, main_attr_value = 968, deputy_attr_num = 2, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21351, 21352, 21353, 21354,}, up_stairs_item_num = 0, },
[21354] = {name = "鞋子", lv = 135, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 54000, swap_atk_price = 1350000, main_attr_type = 7, main_attr_value = 968, deputy_attr_num = 3, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31351, 31352, 31353, 31354,}, up_stairs_item_num = 0, },
[31354] = {name = "鞋子", lv = 135, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 81000, swap_atk_price = 1350000, main_attr_type = 7, main_attr_value = 968, deputy_attr_num = 4, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41351, 41352, 41353, 41354,}, up_stairs_item_num = 0, },
[41354] = {name = "鞋子", lv = 135, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 108000, swap_atk_price = 1350000, main_attr_type = 7, main_attr_value = 968, deputy_attr_num = 5, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51351, 51352, 51353, 51354,}, up_stairs_item_num = 0, },
[51354] = {name = "鞋子", lv = 135, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 135000, swap_atk_price = 1350000, main_attr_type = 7, main_attr_value = 968, deputy_attr_num = 5, deputy_attr_min = 581, deputy_attr_max = 726, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0592, extra_attr_max = 0.074, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51351, 51352, 51353, 51354,}, up_stairs_item_num = 0, },
[11401] = {name = "武器", lv = 140, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 28000, swap_atk_price = 1400000, main_attr_type = 2, main_attr_value = 3118, deputy_attr_num = 2, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21401, 21402, 21403, 21404,}, up_stairs_item_num = 0, },
[21401] = {name = "武器", lv = 140, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 56000, swap_atk_price = 1400000, main_attr_type = 2, main_attr_value = 3118, deputy_attr_num = 3, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31401, 31402, 31403, 31404,}, up_stairs_item_num = 0, },
[31401] = {name = "武器", lv = 140, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 84000, swap_atk_price = 1400000, main_attr_type = 2, main_attr_value = 3118, deputy_attr_num = 4, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41401, 41402, 41403, 41404,}, up_stairs_item_num = 0, },
[41401] = {name = "武器", lv = 140, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 112000, swap_atk_price = 1400000, main_attr_type = 2, main_attr_value = 3118, deputy_attr_num = 5, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51401, 51402, 51403, 51404,}, up_stairs_item_num = 0, },
[51401] = {name = "武器", lv = 140, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 140000, swap_atk_price = 1400000, main_attr_type = 2, main_attr_value = 3118, deputy_attr_num = 5, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0608, extra_attr_max = 0.076, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51401, 51402, 51403, 51404,}, up_stairs_item_num = 0, },
[11402] = {name = "头盔", lv = 140, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 28000, swap_atk_price = 1400000, main_attr_type = 1, main_attr_value = 25980, deputy_attr_num = 2, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21401, 21402, 21403, 21404,}, up_stairs_item_num = 0, },
[21402] = {name = "头盔", lv = 140, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 56000, swap_atk_price = 1400000, main_attr_type = 1, main_attr_value = 25980, deputy_attr_num = 3, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31401, 31402, 31403, 31404,}, up_stairs_item_num = 0, },
[31402] = {name = "头盔", lv = 140, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 84000, swap_atk_price = 1400000, main_attr_type = 1, main_attr_value = 25980, deputy_attr_num = 4, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41401, 41402, 41403, 41404,}, up_stairs_item_num = 0, },
[41402] = {name = "头盔", lv = 140, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 112000, swap_atk_price = 1400000, main_attr_type = 1, main_attr_value = 25980, deputy_attr_num = 5, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51401, 51402, 51403, 51404,}, up_stairs_item_num = 0, },
[51402] = {name = "头盔", lv = 140, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 140000, swap_atk_price = 1400000, main_attr_type = 1, main_attr_value = 25980, deputy_attr_num = 5, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0608, extra_attr_max = 0.076, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51401, 51402, 51403, 51404,}, up_stairs_item_num = 0, },
[11403] = {name = "防具", lv = 140, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 28000, swap_atk_price = 1400000, main_attr_type = 6, main_attr_value = 1039, deputy_attr_num = 2, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21401, 21402, 21403, 21404,}, up_stairs_item_num = 0, },
[21403] = {name = "防具", lv = 140, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 56000, swap_atk_price = 1400000, main_attr_type = 6, main_attr_value = 1039, deputy_attr_num = 3, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31401, 31402, 31403, 31404,}, up_stairs_item_num = 0, },
[31403] = {name = "防具", lv = 140, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 84000, swap_atk_price = 1400000, main_attr_type = 6, main_attr_value = 1039, deputy_attr_num = 4, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41401, 41402, 41403, 41404,}, up_stairs_item_num = 0, },
[41403] = {name = "防具", lv = 140, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 112000, swap_atk_price = 1400000, main_attr_type = 6, main_attr_value = 1039, deputy_attr_num = 5, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51401, 51402, 51403, 51404,}, up_stairs_item_num = 0, },
[51403] = {name = "防具", lv = 140, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 140000, swap_atk_price = 1400000, main_attr_type = 6, main_attr_value = 1039, deputy_attr_num = 5, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0608, extra_attr_max = 0.076, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51401, 51402, 51403, 51404,}, up_stairs_item_num = 0, },
[11404] = {name = "鞋子", lv = 140, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 28000, swap_atk_price = 1400000, main_attr_type = 7, main_attr_value = 1039, deputy_attr_num = 2, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21401, 21402, 21403, 21404,}, up_stairs_item_num = 0, },
[21404] = {name = "鞋子", lv = 140, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 56000, swap_atk_price = 1400000, main_attr_type = 7, main_attr_value = 1039, deputy_attr_num = 3, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31401, 31402, 31403, 31404,}, up_stairs_item_num = 0, },
[31404] = {name = "鞋子", lv = 140, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 84000, swap_atk_price = 1400000, main_attr_type = 7, main_attr_value = 1039, deputy_attr_num = 4, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41401, 41402, 41403, 41404,}, up_stairs_item_num = 0, },
[41404] = {name = "鞋子", lv = 140, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 112000, swap_atk_price = 1400000, main_attr_type = 7, main_attr_value = 1039, deputy_attr_num = 5, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51401, 51402, 51403, 51404,}, up_stairs_item_num = 0, },
[51404] = {name = "鞋子", lv = 140, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 140000, swap_atk_price = 1400000, main_attr_type = 7, main_attr_value = 1039, deputy_attr_num = 5, deputy_attr_min = 623, deputy_attr_max = 779, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0608, extra_attr_max = 0.076, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51401, 51402, 51403, 51404,}, up_stairs_item_num = 0, },
[11451] = {name = "武器", lv = 145, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 29000, swap_atk_price = 1450000, main_attr_type = 2, main_attr_value = 3340, deputy_attr_num = 2, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21451, 21452, 21453, 21454,}, up_stairs_item_num = 0, },
[21451] = {name = "武器", lv = 145, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 58000, swap_atk_price = 1450000, main_attr_type = 2, main_attr_value = 3340, deputy_attr_num = 3, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31451, 31452, 31453, 31454,}, up_stairs_item_num = 0, },
[31451] = {name = "武器", lv = 145, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 87000, swap_atk_price = 1450000, main_attr_type = 2, main_attr_value = 3340, deputy_attr_num = 4, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41451, 41452, 41453, 41454,}, up_stairs_item_num = 0, },
[41451] = {name = "武器", lv = 145, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 116000, swap_atk_price = 1450000, main_attr_type = 2, main_attr_value = 3340, deputy_attr_num = 5, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51451, 51452, 51453, 51454,}, up_stairs_item_num = 0, },
[51451] = {name = "武器", lv = 145, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 145000, swap_atk_price = 1450000, main_attr_type = 2, main_attr_value = 3340, deputy_attr_num = 5, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.078, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51451, 51452, 51453, 51454,}, up_stairs_item_num = 0, },
[11452] = {name = "头盔", lv = 145, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 29000, swap_atk_price = 1450000, main_attr_type = 1, main_attr_value = 27833, deputy_attr_num = 2, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21451, 21452, 21453, 21454,}, up_stairs_item_num = 0, },
[21452] = {name = "头盔", lv = 145, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 58000, swap_atk_price = 1450000, main_attr_type = 1, main_attr_value = 27833, deputy_attr_num = 3, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31451, 31452, 31453, 31454,}, up_stairs_item_num = 0, },
[31452] = {name = "头盔", lv = 145, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 87000, swap_atk_price = 1450000, main_attr_type = 1, main_attr_value = 27833, deputy_attr_num = 4, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41451, 41452, 41453, 41454,}, up_stairs_item_num = 0, },
[41452] = {name = "头盔", lv = 145, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 116000, swap_atk_price = 1450000, main_attr_type = 1, main_attr_value = 27833, deputy_attr_num = 5, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51451, 51452, 51453, 51454,}, up_stairs_item_num = 0, },
[51452] = {name = "头盔", lv = 145, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 145000, swap_atk_price = 1450000, main_attr_type = 1, main_attr_value = 27833, deputy_attr_num = 5, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.078, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51451, 51452, 51453, 51454,}, up_stairs_item_num = 0, },
[11453] = {name = "防具", lv = 145, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 29000, swap_atk_price = 1450000, main_attr_type = 6, main_attr_value = 1113, deputy_attr_num = 2, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21451, 21452, 21453, 21454,}, up_stairs_item_num = 0, },
[21453] = {name = "防具", lv = 145, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 58000, swap_atk_price = 1450000, main_attr_type = 6, main_attr_value = 1113, deputy_attr_num = 3, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31451, 31452, 31453, 31454,}, up_stairs_item_num = 0, },
[31453] = {name = "防具", lv = 145, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 87000, swap_atk_price = 1450000, main_attr_type = 6, main_attr_value = 1113, deputy_attr_num = 4, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41451, 41452, 41453, 41454,}, up_stairs_item_num = 0, },
[41453] = {name = "防具", lv = 145, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 116000, swap_atk_price = 1450000, main_attr_type = 6, main_attr_value = 1113, deputy_attr_num = 5, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51451, 51452, 51453, 51454,}, up_stairs_item_num = 0, },
[51453] = {name = "防具", lv = 145, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 145000, swap_atk_price = 1450000, main_attr_type = 6, main_attr_value = 1113, deputy_attr_num = 5, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.078, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51451, 51452, 51453, 51454,}, up_stairs_item_num = 0, },
[11454] = {name = "鞋子", lv = 145, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 29000, swap_atk_price = 1450000, main_attr_type = 7, main_attr_value = 1113, deputy_attr_num = 2, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21451, 21452, 21453, 21454,}, up_stairs_item_num = 0, },
[21454] = {name = "鞋子", lv = 145, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 58000, swap_atk_price = 1450000, main_attr_type = 7, main_attr_value = 1113, deputy_attr_num = 3, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31451, 31452, 31453, 31454,}, up_stairs_item_num = 0, },
[31454] = {name = "鞋子", lv = 145, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 87000, swap_atk_price = 1450000, main_attr_type = 7, main_attr_value = 1113, deputy_attr_num = 4, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41451, 41452, 41453, 41454,}, up_stairs_item_num = 0, },
[41454] = {name = "鞋子", lv = 145, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 116000, swap_atk_price = 1450000, main_attr_type = 7, main_attr_value = 1113, deputy_attr_num = 5, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51451, 51452, 51453, 51454,}, up_stairs_item_num = 0, },
[51454] = {name = "鞋子", lv = 145, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 145000, swap_atk_price = 1450000, main_attr_type = 7, main_attr_value = 1113, deputy_attr_num = 5, deputy_attr_min = 668, deputy_attr_max = 835, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.078, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51451, 51452, 51453, 51454,}, up_stairs_item_num = 0, },
[11501] = {name = "武器", lv = 150, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 30000, swap_atk_price = 1500000, main_attr_type = 2, main_attr_value = 3570, deputy_attr_num = 2, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21501, 21502, 21503, 21504,}, up_stairs_item_num = 0, },
[21501] = {name = "武器", lv = 150, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 60000, swap_atk_price = 1500000, main_attr_type = 2, main_attr_value = 3570, deputy_attr_num = 3, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31501, 31502, 31503, 31504,}, up_stairs_item_num = 0, },
[31501] = {name = "武器", lv = 150, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 90000, swap_atk_price = 1500000, main_attr_type = 2, main_attr_value = 3570, deputy_attr_num = 4, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41501, 41502, 41503, 41504,}, up_stairs_item_num = 0, },
[41501] = {name = "武器", lv = 150, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 120000, swap_atk_price = 1500000, main_attr_type = 2, main_attr_value = 3570, deputy_attr_num = 5, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51501, 51502, 51503, 51504,}, up_stairs_item_num = 0, },
[51501] = {name = "武器", lv = 150, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 150000, swap_atk_price = 1500000, main_attr_type = 2, main_attr_value = 3570, deputy_attr_num = 5, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.064, extra_attr_max = 0.08, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51501, 51502, 51503, 51504,}, up_stairs_item_num = 0, },
[11502] = {name = "头盔", lv = 150, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 30000, swap_atk_price = 1500000, main_attr_type = 1, main_attr_value = 29750, deputy_attr_num = 2, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21501, 21502, 21503, 21504,}, up_stairs_item_num = 0, },
[21502] = {name = "头盔", lv = 150, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 60000, swap_atk_price = 1500000, main_attr_type = 1, main_attr_value = 29750, deputy_attr_num = 3, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31501, 31502, 31503, 31504,}, up_stairs_item_num = 0, },
[31502] = {name = "头盔", lv = 150, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 90000, swap_atk_price = 1500000, main_attr_type = 1, main_attr_value = 29750, deputy_attr_num = 4, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41501, 41502, 41503, 41504,}, up_stairs_item_num = 0, },
[41502] = {name = "头盔", lv = 150, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 120000, swap_atk_price = 1500000, main_attr_type = 1, main_attr_value = 29750, deputy_attr_num = 5, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51501, 51502, 51503, 51504,}, up_stairs_item_num = 0, },
[51502] = {name = "头盔", lv = 150, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 150000, swap_atk_price = 1500000, main_attr_type = 1, main_attr_value = 29750, deputy_attr_num = 5, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.064, extra_attr_max = 0.08, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51501, 51502, 51503, 51504,}, up_stairs_item_num = 0, },
[11503] = {name = "防具", lv = 150, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 30000, swap_atk_price = 1500000, main_attr_type = 6, main_attr_value = 1190, deputy_attr_num = 2, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21501, 21502, 21503, 21504,}, up_stairs_item_num = 0, },
[21503] = {name = "防具", lv = 150, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 60000, swap_atk_price = 1500000, main_attr_type = 6, main_attr_value = 1190, deputy_attr_num = 3, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31501, 31502, 31503, 31504,}, up_stairs_item_num = 0, },
[31503] = {name = "防具", lv = 150, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 90000, swap_atk_price = 1500000, main_attr_type = 6, main_attr_value = 1190, deputy_attr_num = 4, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41501, 41502, 41503, 41504,}, up_stairs_item_num = 0, },
[41503] = {name = "防具", lv = 150, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 120000, swap_atk_price = 1500000, main_attr_type = 6, main_attr_value = 1190, deputy_attr_num = 5, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51501, 51502, 51503, 51504,}, up_stairs_item_num = 0, },
[51503] = {name = "防具", lv = 150, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 150000, swap_atk_price = 1500000, main_attr_type = 6, main_attr_value = 1190, deputy_attr_num = 5, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.064, extra_attr_max = 0.08, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51501, 51502, 51503, 51504,}, up_stairs_item_num = 0, },
[11504] = {name = "鞋子", lv = 150, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 30000, swap_atk_price = 1500000, main_attr_type = 7, main_attr_value = 1190, deputy_attr_num = 2, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21501, 21502, 21503, 21504,}, up_stairs_item_num = 0, },
[21504] = {name = "鞋子", lv = 150, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 60000, swap_atk_price = 1500000, main_attr_type = 7, main_attr_value = 1190, deputy_attr_num = 3, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31501, 31502, 31503, 31504,}, up_stairs_item_num = 0, },
[31504] = {name = "鞋子", lv = 150, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 90000, swap_atk_price = 1500000, main_attr_type = 7, main_attr_value = 1190, deputy_attr_num = 4, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41501, 41502, 41503, 41504,}, up_stairs_item_num = 0, },
[41504] = {name = "鞋子", lv = 150, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 120000, swap_atk_price = 1500000, main_attr_type = 7, main_attr_value = 1190, deputy_attr_num = 5, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51501, 51502, 51503, 51504,}, up_stairs_item_num = 0, },
[51504] = {name = "鞋子", lv = 150, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 150000, swap_atk_price = 1500000, main_attr_type = 7, main_attr_value = 1190, deputy_attr_num = 5, deputy_attr_min = 714, deputy_attr_max = 893, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.064, extra_attr_max = 0.08, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51501, 51502, 51503, 51504,}, up_stairs_item_num = 0, },
[11551] = {name = "武器", lv = 155, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 31000, swap_atk_price = 1550000, main_attr_type = 2, main_attr_value = 3808, deputy_attr_num = 2, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21551, 21552, 21553, 21554,}, up_stairs_item_num = 0, },
[21551] = {name = "武器", lv = 155, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 62000, swap_atk_price = 1550000, main_attr_type = 2, main_attr_value = 3808, deputy_attr_num = 3, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31551, 31552, 31553, 31554,}, up_stairs_item_num = 0, },
[31551] = {name = "武器", lv = 155, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 93000, swap_atk_price = 1550000, main_attr_type = 2, main_attr_value = 3808, deputy_attr_num = 4, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41551, 41552, 41553, 41554,}, up_stairs_item_num = 0, },
[41551] = {name = "武器", lv = 155, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 124000, swap_atk_price = 1550000, main_attr_type = 2, main_attr_value = 3808, deputy_attr_num = 5, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51551, 51552, 51553, 51554,}, up_stairs_item_num = 0, },
[51551] = {name = "武器", lv = 155, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 155000, swap_atk_price = 1550000, main_attr_type = 2, main_attr_value = 3808, deputy_attr_num = 5, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0656, extra_attr_max = 0.082, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51551, 51552, 51553, 51554,}, up_stairs_item_num = 0, },
[11552] = {name = "头盔", lv = 155, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 31000, swap_atk_price = 1550000, main_attr_type = 1, main_attr_value = 31733, deputy_attr_num = 2, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21551, 21552, 21553, 21554,}, up_stairs_item_num = 0, },
[21552] = {name = "头盔", lv = 155, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 62000, swap_atk_price = 1550000, main_attr_type = 1, main_attr_value = 31733, deputy_attr_num = 3, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31551, 31552, 31553, 31554,}, up_stairs_item_num = 0, },
[31552] = {name = "头盔", lv = 155, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 93000, swap_atk_price = 1550000, main_attr_type = 1, main_attr_value = 31733, deputy_attr_num = 4, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41551, 41552, 41553, 41554,}, up_stairs_item_num = 0, },
[41552] = {name = "头盔", lv = 155, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 124000, swap_atk_price = 1550000, main_attr_type = 1, main_attr_value = 31733, deputy_attr_num = 5, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51551, 51552, 51553, 51554,}, up_stairs_item_num = 0, },
[51552] = {name = "头盔", lv = 155, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 155000, swap_atk_price = 1550000, main_attr_type = 1, main_attr_value = 31733, deputy_attr_num = 5, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0656, extra_attr_max = 0.082, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51551, 51552, 51553, 51554,}, up_stairs_item_num = 0, },
[11553] = {name = "防具", lv = 155, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 31000, swap_atk_price = 1550000, main_attr_type = 6, main_attr_value = 1269, deputy_attr_num = 2, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21551, 21552, 21553, 21554,}, up_stairs_item_num = 0, },
[21553] = {name = "防具", lv = 155, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 62000, swap_atk_price = 1550000, main_attr_type = 6, main_attr_value = 1269, deputy_attr_num = 3, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31551, 31552, 31553, 31554,}, up_stairs_item_num = 0, },
[31553] = {name = "防具", lv = 155, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 93000, swap_atk_price = 1550000, main_attr_type = 6, main_attr_value = 1269, deputy_attr_num = 4, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41551, 41552, 41553, 41554,}, up_stairs_item_num = 0, },
[41553] = {name = "防具", lv = 155, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 124000, swap_atk_price = 1550000, main_attr_type = 6, main_attr_value = 1269, deputy_attr_num = 5, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51551, 51552, 51553, 51554,}, up_stairs_item_num = 0, },
[51553] = {name = "防具", lv = 155, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 155000, swap_atk_price = 1550000, main_attr_type = 6, main_attr_value = 1269, deputy_attr_num = 5, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0656, extra_attr_max = 0.082, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51551, 51552, 51553, 51554,}, up_stairs_item_num = 0, },
[11554] = {name = "鞋子", lv = 155, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 31000, swap_atk_price = 1550000, main_attr_type = 7, main_attr_value = 1269, deputy_attr_num = 2, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21551, 21552, 21553, 21554,}, up_stairs_item_num = 0, },
[21554] = {name = "鞋子", lv = 155, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 62000, swap_atk_price = 1550000, main_attr_type = 7, main_attr_value = 1269, deputy_attr_num = 3, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31551, 31552, 31553, 31554,}, up_stairs_item_num = 0, },
[31554] = {name = "鞋子", lv = 155, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 93000, swap_atk_price = 1550000, main_attr_type = 7, main_attr_value = 1269, deputy_attr_num = 4, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41551, 41552, 41553, 41554,}, up_stairs_item_num = 0, },
[41554] = {name = "鞋子", lv = 155, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 124000, swap_atk_price = 1550000, main_attr_type = 7, main_attr_value = 1269, deputy_attr_num = 5, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51551, 51552, 51553, 51554,}, up_stairs_item_num = 0, },
[51554] = {name = "鞋子", lv = 155, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 155000, swap_atk_price = 1550000, main_attr_type = 7, main_attr_value = 1269, deputy_attr_num = 5, deputy_attr_min = 762, deputy_attr_max = 952, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0656, extra_attr_max = 0.082, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51551, 51552, 51553, 51554,}, up_stairs_item_num = 0, },
[11601] = {name = "武器", lv = 160, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 32000, swap_atk_price = 1600000, main_attr_type = 2, main_attr_value = 4054, deputy_attr_num = 2, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21601, 21602, 21603, 21604,}, up_stairs_item_num = 0, },
[21601] = {name = "武器", lv = 160, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 64000, swap_atk_price = 1600000, main_attr_type = 2, main_attr_value = 4054, deputy_attr_num = 3, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31601, 31602, 31603, 31604,}, up_stairs_item_num = 0, },
[31601] = {name = "武器", lv = 160, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 96000, swap_atk_price = 1600000, main_attr_type = 2, main_attr_value = 4054, deputy_attr_num = 4, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41601, 41602, 41603, 41604,}, up_stairs_item_num = 0, },
[41601] = {name = "武器", lv = 160, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 128000, swap_atk_price = 1600000, main_attr_type = 2, main_attr_value = 4054, deputy_attr_num = 5, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51601, 51602, 51603, 51604,}, up_stairs_item_num = 0, },
[51601] = {name = "武器", lv = 160, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 160000, swap_atk_price = 1600000, main_attr_type = 2, main_attr_value = 4054, deputy_attr_num = 5, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.084, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51601, 51602, 51603, 51604,}, up_stairs_item_num = 0, },
[11602] = {name = "头盔", lv = 160, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 32000, swap_atk_price = 1600000, main_attr_type = 1, main_attr_value = 33780, deputy_attr_num = 2, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21601, 21602, 21603, 21604,}, up_stairs_item_num = 0, },
[21602] = {name = "头盔", lv = 160, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 64000, swap_atk_price = 1600000, main_attr_type = 1, main_attr_value = 33780, deputy_attr_num = 3, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31601, 31602, 31603, 31604,}, up_stairs_item_num = 0, },
[31602] = {name = "头盔", lv = 160, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 96000, swap_atk_price = 1600000, main_attr_type = 1, main_attr_value = 33780, deputy_attr_num = 4, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41601, 41602, 41603, 41604,}, up_stairs_item_num = 0, },
[41602] = {name = "头盔", lv = 160, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 128000, swap_atk_price = 1600000, main_attr_type = 1, main_attr_value = 33780, deputy_attr_num = 5, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51601, 51602, 51603, 51604,}, up_stairs_item_num = 0, },
[51602] = {name = "头盔", lv = 160, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 160000, swap_atk_price = 1600000, main_attr_type = 1, main_attr_value = 33780, deputy_attr_num = 5, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.084, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51601, 51602, 51603, 51604,}, up_stairs_item_num = 0, },
[11603] = {name = "防具", lv = 160, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 32000, swap_atk_price = 1600000, main_attr_type = 6, main_attr_value = 1351, deputy_attr_num = 2, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21601, 21602, 21603, 21604,}, up_stairs_item_num = 0, },
[21603] = {name = "防具", lv = 160, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 64000, swap_atk_price = 1600000, main_attr_type = 6, main_attr_value = 1351, deputy_attr_num = 3, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31601, 31602, 31603, 31604,}, up_stairs_item_num = 0, },
[31603] = {name = "防具", lv = 160, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 96000, swap_atk_price = 1600000, main_attr_type = 6, main_attr_value = 1351, deputy_attr_num = 4, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41601, 41602, 41603, 41604,}, up_stairs_item_num = 0, },
[41603] = {name = "防具", lv = 160, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 128000, swap_atk_price = 1600000, main_attr_type = 6, main_attr_value = 1351, deputy_attr_num = 5, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51601, 51602, 51603, 51604,}, up_stairs_item_num = 0, },
[51603] = {name = "防具", lv = 160, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 160000, swap_atk_price = 1600000, main_attr_type = 6, main_attr_value = 1351, deputy_attr_num = 5, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.084, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51601, 51602, 51603, 51604,}, up_stairs_item_num = 0, },
[11604] = {name = "鞋子", lv = 160, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 32000, swap_atk_price = 1600000, main_attr_type = 7, main_attr_value = 1351, deputy_attr_num = 2, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21601, 21602, 21603, 21604,}, up_stairs_item_num = 0, },
[21604] = {name = "鞋子", lv = 160, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 64000, swap_atk_price = 1600000, main_attr_type = 7, main_attr_value = 1351, deputy_attr_num = 3, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31601, 31602, 31603, 31604,}, up_stairs_item_num = 0, },
[31604] = {name = "鞋子", lv = 160, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 96000, swap_atk_price = 1600000, main_attr_type = 7, main_attr_value = 1351, deputy_attr_num = 4, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41601, 41602, 41603, 41604,}, up_stairs_item_num = 0, },
[41604] = {name = "鞋子", lv = 160, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 128000, swap_atk_price = 1600000, main_attr_type = 7, main_attr_value = 1351, deputy_attr_num = 5, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51601, 51602, 51603, 51604,}, up_stairs_item_num = 0, },
[51604] = {name = "鞋子", lv = 160, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 160000, swap_atk_price = 1600000, main_attr_type = 7, main_attr_value = 1351, deputy_attr_num = 5, deputy_attr_min = 810, deputy_attr_max = 1013, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.084, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51601, 51602, 51603, 51604,}, up_stairs_item_num = 0, },
[11651] = {name = "武器", lv = 165, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 33000, swap_atk_price = 1650000, main_attr_type = 2, main_attr_value = 4307, deputy_attr_num = 2, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21651, 21652, 21653, 21654,}, up_stairs_item_num = 0, },
[21651] = {name = "武器", lv = 165, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 66000, swap_atk_price = 1650000, main_attr_type = 2, main_attr_value = 4307, deputy_attr_num = 3, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31651, 31652, 31653, 31654,}, up_stairs_item_num = 0, },
[31651] = {name = "武器", lv = 165, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 99000, swap_atk_price = 1650000, main_attr_type = 2, main_attr_value = 4307, deputy_attr_num = 4, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41651, 41652, 41653, 41654,}, up_stairs_item_num = 0, },
[41651] = {name = "武器", lv = 165, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 132000, swap_atk_price = 1650000, main_attr_type = 2, main_attr_value = 4307, deputy_attr_num = 5, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51651, 51652, 51653, 51654,}, up_stairs_item_num = 0, },
[51651] = {name = "武器", lv = 165, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 165000, swap_atk_price = 1650000, main_attr_type = 2, main_attr_value = 4307, deputy_attr_num = 5, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0688, extra_attr_max = 0.086, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51651, 51652, 51653, 51654,}, up_stairs_item_num = 0, },
[11652] = {name = "头盔", lv = 165, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 33000, swap_atk_price = 1650000, main_attr_type = 1, main_attr_value = 35893, deputy_attr_num = 2, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21651, 21652, 21653, 21654,}, up_stairs_item_num = 0, },
[21652] = {name = "头盔", lv = 165, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 66000, swap_atk_price = 1650000, main_attr_type = 1, main_attr_value = 35893, deputy_attr_num = 3, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31651, 31652, 31653, 31654,}, up_stairs_item_num = 0, },
[31652] = {name = "头盔", lv = 165, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 99000, swap_atk_price = 1650000, main_attr_type = 1, main_attr_value = 35893, deputy_attr_num = 4, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41651, 41652, 41653, 41654,}, up_stairs_item_num = 0, },
[41652] = {name = "头盔", lv = 165, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 132000, swap_atk_price = 1650000, main_attr_type = 1, main_attr_value = 35893, deputy_attr_num = 5, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51651, 51652, 51653, 51654,}, up_stairs_item_num = 0, },
[51652] = {name = "头盔", lv = 165, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 165000, swap_atk_price = 1650000, main_attr_type = 1, main_attr_value = 35893, deputy_attr_num = 5, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0688, extra_attr_max = 0.086, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51651, 51652, 51653, 51654,}, up_stairs_item_num = 0, },
[11653] = {name = "防具", lv = 165, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 33000, swap_atk_price = 1650000, main_attr_type = 6, main_attr_value = 1436, deputy_attr_num = 2, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21651, 21652, 21653, 21654,}, up_stairs_item_num = 0, },
[21653] = {name = "防具", lv = 165, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 66000, swap_atk_price = 1650000, main_attr_type = 6, main_attr_value = 1436, deputy_attr_num = 3, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31651, 31652, 31653, 31654,}, up_stairs_item_num = 0, },
[31653] = {name = "防具", lv = 165, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 99000, swap_atk_price = 1650000, main_attr_type = 6, main_attr_value = 1436, deputy_attr_num = 4, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41651, 41652, 41653, 41654,}, up_stairs_item_num = 0, },
[41653] = {name = "防具", lv = 165, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 132000, swap_atk_price = 1650000, main_attr_type = 6, main_attr_value = 1436, deputy_attr_num = 5, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51651, 51652, 51653, 51654,}, up_stairs_item_num = 0, },
[51653] = {name = "防具", lv = 165, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 165000, swap_atk_price = 1650000, main_attr_type = 6, main_attr_value = 1436, deputy_attr_num = 5, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0688, extra_attr_max = 0.086, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51651, 51652, 51653, 51654,}, up_stairs_item_num = 0, },
[11654] = {name = "鞋子", lv = 165, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 33000, swap_atk_price = 1650000, main_attr_type = 7, main_attr_value = 1436, deputy_attr_num = 2, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21651, 21652, 21653, 21654,}, up_stairs_item_num = 0, },
[21654] = {name = "鞋子", lv = 165, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 66000, swap_atk_price = 1650000, main_attr_type = 7, main_attr_value = 1436, deputy_attr_num = 3, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31651, 31652, 31653, 31654,}, up_stairs_item_num = 0, },
[31654] = {name = "鞋子", lv = 165, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 99000, swap_atk_price = 1650000, main_attr_type = 7, main_attr_value = 1436, deputy_attr_num = 4, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41651, 41652, 41653, 41654,}, up_stairs_item_num = 0, },
[41654] = {name = "鞋子", lv = 165, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 132000, swap_atk_price = 1650000, main_attr_type = 7, main_attr_value = 1436, deputy_attr_num = 5, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51651, 51652, 51653, 51654,}, up_stairs_item_num = 0, },
[51654] = {name = "鞋子", lv = 165, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 165000, swap_atk_price = 1650000, main_attr_type = 7, main_attr_value = 1436, deputy_attr_num = 5, deputy_attr_min = 862, deputy_attr_max = 1077, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0688, extra_attr_max = 0.086, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51651, 51652, 51653, 51654,}, up_stairs_item_num = 0, },
[11701] = {name = "武器", lv = 170, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 34000, swap_atk_price = 1700000, main_attr_type = 2, main_attr_value = 4568, deputy_attr_num = 2, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21701, 21702, 21703, 21704,}, up_stairs_item_num = 0, },
[21701] = {name = "武器", lv = 170, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 68000, swap_atk_price = 1700000, main_attr_type = 2, main_attr_value = 4568, deputy_attr_num = 3, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31701, 31702, 31703, 31704,}, up_stairs_item_num = 0, },
[31701] = {name = "武器", lv = 170, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 102000, swap_atk_price = 1700000, main_attr_type = 2, main_attr_value = 4568, deputy_attr_num = 4, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41701, 41702, 41703, 41704,}, up_stairs_item_num = 0, },
[41701] = {name = "武器", lv = 170, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 136000, swap_atk_price = 1700000, main_attr_type = 2, main_attr_value = 4568, deputy_attr_num = 5, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51701, 51702, 51703, 51704,}, up_stairs_item_num = 0, },
[51701] = {name = "武器", lv = 170, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 170000, swap_atk_price = 1700000, main_attr_type = 2, main_attr_value = 4568, deputy_attr_num = 5, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0704, extra_attr_max = 0.088, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51701, 51702, 51703, 51704,}, up_stairs_item_num = 0, },
[11702] = {name = "头盔", lv = 170, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 34000, swap_atk_price = 1700000, main_attr_type = 1, main_attr_value = 38070, deputy_attr_num = 2, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21701, 21702, 21703, 21704,}, up_stairs_item_num = 0, },
[21702] = {name = "头盔", lv = 170, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 68000, swap_atk_price = 1700000, main_attr_type = 1, main_attr_value = 38070, deputy_attr_num = 3, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31701, 31702, 31703, 31704,}, up_stairs_item_num = 0, },
[31702] = {name = "头盔", lv = 170, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 102000, swap_atk_price = 1700000, main_attr_type = 1, main_attr_value = 38070, deputy_attr_num = 4, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41701, 41702, 41703, 41704,}, up_stairs_item_num = 0, },
[41702] = {name = "头盔", lv = 170, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 136000, swap_atk_price = 1700000, main_attr_type = 1, main_attr_value = 38070, deputy_attr_num = 5, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51701, 51702, 51703, 51704,}, up_stairs_item_num = 0, },
[51702] = {name = "头盔", lv = 170, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 170000, swap_atk_price = 1700000, main_attr_type = 1, main_attr_value = 38070, deputy_attr_num = 5, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0704, extra_attr_max = 0.088, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51701, 51702, 51703, 51704,}, up_stairs_item_num = 0, },
[11703] = {name = "防具", lv = 170, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 34000, swap_atk_price = 1700000, main_attr_type = 6, main_attr_value = 1523, deputy_attr_num = 2, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21701, 21702, 21703, 21704,}, up_stairs_item_num = 0, },
[21703] = {name = "防具", lv = 170, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 68000, swap_atk_price = 1700000, main_attr_type = 6, main_attr_value = 1523, deputy_attr_num = 3, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31701, 31702, 31703, 31704,}, up_stairs_item_num = 0, },
[31703] = {name = "防具", lv = 170, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 102000, swap_atk_price = 1700000, main_attr_type = 6, main_attr_value = 1523, deputy_attr_num = 4, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41701, 41702, 41703, 41704,}, up_stairs_item_num = 0, },
[41703] = {name = "防具", lv = 170, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 136000, swap_atk_price = 1700000, main_attr_type = 6, main_attr_value = 1523, deputy_attr_num = 5, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51701, 51702, 51703, 51704,}, up_stairs_item_num = 0, },
[51703] = {name = "防具", lv = 170, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 170000, swap_atk_price = 1700000, main_attr_type = 6, main_attr_value = 1523, deputy_attr_num = 5, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0704, extra_attr_max = 0.088, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51701, 51702, 51703, 51704,}, up_stairs_item_num = 0, },
[11704] = {name = "鞋子", lv = 170, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 34000, swap_atk_price = 1700000, main_attr_type = 7, main_attr_value = 1523, deputy_attr_num = 2, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21701, 21702, 21703, 21704,}, up_stairs_item_num = 0, },
[21704] = {name = "鞋子", lv = 170, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 68000, swap_atk_price = 1700000, main_attr_type = 7, main_attr_value = 1523, deputy_attr_num = 3, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31701, 31702, 31703, 31704,}, up_stairs_item_num = 0, },
[31704] = {name = "鞋子", lv = 170, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 102000, swap_atk_price = 1700000, main_attr_type = 7, main_attr_value = 1523, deputy_attr_num = 4, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41701, 41702, 41703, 41704,}, up_stairs_item_num = 0, },
[41704] = {name = "鞋子", lv = 170, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 136000, swap_atk_price = 1700000, main_attr_type = 7, main_attr_value = 1523, deputy_attr_num = 5, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51701, 51702, 51703, 51704,}, up_stairs_item_num = 0, },
[51704] = {name = "鞋子", lv = 170, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 170000, swap_atk_price = 1700000, main_attr_type = 7, main_attr_value = 1523, deputy_attr_num = 5, deputy_attr_min = 914, deputy_attr_max = 1142, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0704, extra_attr_max = 0.088, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51701, 51702, 51703, 51704,}, up_stairs_item_num = 0, },
[11751] = {name = "武器", lv = 175, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 35000, swap_atk_price = 1750000, main_attr_type = 2, main_attr_value = 4838, deputy_attr_num = 2, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21751, 21752, 21753, 21754,}, up_stairs_item_num = 0, },
[21751] = {name = "武器", lv = 175, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 70000, swap_atk_price = 1750000, main_attr_type = 2, main_attr_value = 4838, deputy_attr_num = 3, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31751, 31752, 31753, 31754,}, up_stairs_item_num = 0, },
[31751] = {name = "武器", lv = 175, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 105000, swap_atk_price = 1750000, main_attr_type = 2, main_attr_value = 4838, deputy_attr_num = 4, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41751, 41752, 41753, 41754,}, up_stairs_item_num = 0, },
[41751] = {name = "武器", lv = 175, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 140000, swap_atk_price = 1750000, main_attr_type = 2, main_attr_value = 4838, deputy_attr_num = 5, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51751, 51752, 51753, 51754,}, up_stairs_item_num = 0, },
[51751] = {name = "武器", lv = 175, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 175000, swap_atk_price = 1750000, main_attr_type = 2, main_attr_value = 4838, deputy_attr_num = 5, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.09, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51751, 51752, 51753, 51754,}, up_stairs_item_num = 0, },
[11752] = {name = "头盔", lv = 175, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 35000, swap_atk_price = 1750000, main_attr_type = 1, main_attr_value = 40313, deputy_attr_num = 2, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21751, 21752, 21753, 21754,}, up_stairs_item_num = 0, },
[21752] = {name = "头盔", lv = 175, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 70000, swap_atk_price = 1750000, main_attr_type = 1, main_attr_value = 40313, deputy_attr_num = 3, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31751, 31752, 31753, 31754,}, up_stairs_item_num = 0, },
[31752] = {name = "头盔", lv = 175, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 105000, swap_atk_price = 1750000, main_attr_type = 1, main_attr_value = 40313, deputy_attr_num = 4, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41751, 41752, 41753, 41754,}, up_stairs_item_num = 0, },
[41752] = {name = "头盔", lv = 175, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 140000, swap_atk_price = 1750000, main_attr_type = 1, main_attr_value = 40313, deputy_attr_num = 5, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51751, 51752, 51753, 51754,}, up_stairs_item_num = 0, },
[51752] = {name = "头盔", lv = 175, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 175000, swap_atk_price = 1750000, main_attr_type = 1, main_attr_value = 40313, deputy_attr_num = 5, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.09, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51751, 51752, 51753, 51754,}, up_stairs_item_num = 0, },
[11753] = {name = "防具", lv = 175, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 35000, swap_atk_price = 1750000, main_attr_type = 6, main_attr_value = 1613, deputy_attr_num = 2, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21751, 21752, 21753, 21754,}, up_stairs_item_num = 0, },
[21753] = {name = "防具", lv = 175, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 70000, swap_atk_price = 1750000, main_attr_type = 6, main_attr_value = 1613, deputy_attr_num = 3, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31751, 31752, 31753, 31754,}, up_stairs_item_num = 0, },
[31753] = {name = "防具", lv = 175, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 105000, swap_atk_price = 1750000, main_attr_type = 6, main_attr_value = 1613, deputy_attr_num = 4, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41751, 41752, 41753, 41754,}, up_stairs_item_num = 0, },
[41753] = {name = "防具", lv = 175, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 140000, swap_atk_price = 1750000, main_attr_type = 6, main_attr_value = 1613, deputy_attr_num = 5, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51751, 51752, 51753, 51754,}, up_stairs_item_num = 0, },
[51753] = {name = "防具", lv = 175, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 175000, swap_atk_price = 1750000, main_attr_type = 6, main_attr_value = 1613, deputy_attr_num = 5, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.09, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51751, 51752, 51753, 51754,}, up_stairs_item_num = 0, },
[11754] = {name = "鞋子", lv = 175, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 35000, swap_atk_price = 1750000, main_attr_type = 7, main_attr_value = 1613, deputy_attr_num = 2, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21751, 21752, 21753, 21754,}, up_stairs_item_num = 0, },
[21754] = {name = "鞋子", lv = 175, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 70000, swap_atk_price = 1750000, main_attr_type = 7, main_attr_value = 1613, deputy_attr_num = 3, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31751, 31752, 31753, 31754,}, up_stairs_item_num = 0, },
[31754] = {name = "鞋子", lv = 175, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 105000, swap_atk_price = 1750000, main_attr_type = 7, main_attr_value = 1613, deputy_attr_num = 4, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41751, 41752, 41753, 41754,}, up_stairs_item_num = 0, },
[41754] = {name = "鞋子", lv = 175, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 140000, swap_atk_price = 1750000, main_attr_type = 7, main_attr_value = 1613, deputy_attr_num = 5, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51751, 51752, 51753, 51754,}, up_stairs_item_num = 0, },
[51754] = {name = "鞋子", lv = 175, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 175000, swap_atk_price = 1750000, main_attr_type = 7, main_attr_value = 1613, deputy_attr_num = 5, deputy_attr_min = 967, deputy_attr_max = 1209, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.09, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51751, 51752, 51753, 51754,}, up_stairs_item_num = 0, },
[11801] = {name = "武器", lv = 180, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 36000, swap_atk_price = 1800000, main_attr_type = 2, main_attr_value = 5114, deputy_attr_num = 2, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21801, 21802, 21803, 21804,}, up_stairs_item_num = 0, },
[21801] = {name = "武器", lv = 180, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 72000, swap_atk_price = 1800000, main_attr_type = 2, main_attr_value = 5114, deputy_attr_num = 3, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31801, 31802, 31803, 31804,}, up_stairs_item_num = 0, },
[31801] = {name = "武器", lv = 180, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 108000, swap_atk_price = 1800000, main_attr_type = 2, main_attr_value = 5114, deputy_attr_num = 4, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41801, 41802, 41803, 41804,}, up_stairs_item_num = 0, },
[41801] = {name = "武器", lv = 180, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 144000, swap_atk_price = 1800000, main_attr_type = 2, main_attr_value = 5114, deputy_attr_num = 5, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51801, 51802, 51803, 51804,}, up_stairs_item_num = 0, },
[51801] = {name = "武器", lv = 180, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 180000, swap_atk_price = 1800000, main_attr_type = 2, main_attr_value = 5114, deputy_attr_num = 5, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0736, extra_attr_max = 0.092, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51801, 51802, 51803, 51804,}, up_stairs_item_num = 0, },
[11802] = {name = "头盔", lv = 180, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 36000, swap_atk_price = 1800000, main_attr_type = 1, main_attr_value = 42620, deputy_attr_num = 2, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21801, 21802, 21803, 21804,}, up_stairs_item_num = 0, },
[21802] = {name = "头盔", lv = 180, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 72000, swap_atk_price = 1800000, main_attr_type = 1, main_attr_value = 42620, deputy_attr_num = 3, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31801, 31802, 31803, 31804,}, up_stairs_item_num = 0, },
[31802] = {name = "头盔", lv = 180, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 108000, swap_atk_price = 1800000, main_attr_type = 1, main_attr_value = 42620, deputy_attr_num = 4, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41801, 41802, 41803, 41804,}, up_stairs_item_num = 0, },
[41802] = {name = "头盔", lv = 180, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 144000, swap_atk_price = 1800000, main_attr_type = 1, main_attr_value = 42620, deputy_attr_num = 5, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51801, 51802, 51803, 51804,}, up_stairs_item_num = 0, },
[51802] = {name = "头盔", lv = 180, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 180000, swap_atk_price = 1800000, main_attr_type = 1, main_attr_value = 42620, deputy_attr_num = 5, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0736, extra_attr_max = 0.092, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51801, 51802, 51803, 51804,}, up_stairs_item_num = 0, },
[11803] = {name = "防具", lv = 180, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 36000, swap_atk_price = 1800000, main_attr_type = 6, main_attr_value = 1705, deputy_attr_num = 2, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21801, 21802, 21803, 21804,}, up_stairs_item_num = 0, },
[21803] = {name = "防具", lv = 180, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 72000, swap_atk_price = 1800000, main_attr_type = 6, main_attr_value = 1705, deputy_attr_num = 3, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31801, 31802, 31803, 31804,}, up_stairs_item_num = 0, },
[31803] = {name = "防具", lv = 180, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 108000, swap_atk_price = 1800000, main_attr_type = 6, main_attr_value = 1705, deputy_attr_num = 4, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41801, 41802, 41803, 41804,}, up_stairs_item_num = 0, },
[41803] = {name = "防具", lv = 180, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 144000, swap_atk_price = 1800000, main_attr_type = 6, main_attr_value = 1705, deputy_attr_num = 5, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51801, 51802, 51803, 51804,}, up_stairs_item_num = 0, },
[51803] = {name = "防具", lv = 180, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 180000, swap_atk_price = 1800000, main_attr_type = 6, main_attr_value = 1705, deputy_attr_num = 5, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0736, extra_attr_max = 0.092, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51801, 51802, 51803, 51804,}, up_stairs_item_num = 0, },
[11804] = {name = "鞋子", lv = 180, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 36000, swap_atk_price = 1800000, main_attr_type = 7, main_attr_value = 1705, deputy_attr_num = 2, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21801, 21802, 21803, 21804,}, up_stairs_item_num = 0, },
[21804] = {name = "鞋子", lv = 180, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 72000, swap_atk_price = 1800000, main_attr_type = 7, main_attr_value = 1705, deputy_attr_num = 3, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31801, 31802, 31803, 31804,}, up_stairs_item_num = 0, },
[31804] = {name = "鞋子", lv = 180, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 108000, swap_atk_price = 1800000, main_attr_type = 7, main_attr_value = 1705, deputy_attr_num = 4, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41801, 41802, 41803, 41804,}, up_stairs_item_num = 0, },
[41804] = {name = "鞋子", lv = 180, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 144000, swap_atk_price = 1800000, main_attr_type = 7, main_attr_value = 1705, deputy_attr_num = 5, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51801, 51802, 51803, 51804,}, up_stairs_item_num = 0, },
[51804] = {name = "鞋子", lv = 180, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 180000, swap_atk_price = 1800000, main_attr_type = 7, main_attr_value = 1705, deputy_attr_num = 5, deputy_attr_min = 1023, deputy_attr_max = 1279, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0736, extra_attr_max = 0.092, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51801, 51802, 51803, 51804,}, up_stairs_item_num = 0, },
[11851] = {name = "武器", lv = 185, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 37000, swap_atk_price = 1850000, main_attr_type = 2, main_attr_value = 5399, deputy_attr_num = 2, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21851, 21852, 21853, 21854,}, up_stairs_item_num = 0, },
[21851] = {name = "武器", lv = 185, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 74000, swap_atk_price = 1850000, main_attr_type = 2, main_attr_value = 5399, deputy_attr_num = 3, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31851, 31852, 31853, 31854,}, up_stairs_item_num = 0, },
[31851] = {name = "武器", lv = 185, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 111000, swap_atk_price = 1850000, main_attr_type = 2, main_attr_value = 5399, deputy_attr_num = 4, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41851, 41852, 41853, 41854,}, up_stairs_item_num = 0, },
[41851] = {name = "武器", lv = 185, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 148000, swap_atk_price = 1850000, main_attr_type = 2, main_attr_value = 5399, deputy_attr_num = 5, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51851, 51852, 51853, 51854,}, up_stairs_item_num = 0, },
[51851] = {name = "武器", lv = 185, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 185000, swap_atk_price = 1850000, main_attr_type = 2, main_attr_value = 5399, deputy_attr_num = 5, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0752, extra_attr_max = 0.094, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51851, 51852, 51853, 51854,}, up_stairs_item_num = 0, },
[11852] = {name = "头盔", lv = 185, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 37000, swap_atk_price = 1850000, main_attr_type = 1, main_attr_value = 44993, deputy_attr_num = 2, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21851, 21852, 21853, 21854,}, up_stairs_item_num = 0, },
[21852] = {name = "头盔", lv = 185, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 74000, swap_atk_price = 1850000, main_attr_type = 1, main_attr_value = 44993, deputy_attr_num = 3, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31851, 31852, 31853, 31854,}, up_stairs_item_num = 0, },
[31852] = {name = "头盔", lv = 185, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 111000, swap_atk_price = 1850000, main_attr_type = 1, main_attr_value = 44993, deputy_attr_num = 4, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41851, 41852, 41853, 41854,}, up_stairs_item_num = 0, },
[41852] = {name = "头盔", lv = 185, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 148000, swap_atk_price = 1850000, main_attr_type = 1, main_attr_value = 44993, deputy_attr_num = 5, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51851, 51852, 51853, 51854,}, up_stairs_item_num = 0, },
[51852] = {name = "头盔", lv = 185, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 185000, swap_atk_price = 1850000, main_attr_type = 1, main_attr_value = 44993, deputy_attr_num = 5, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0752, extra_attr_max = 0.094, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51851, 51852, 51853, 51854,}, up_stairs_item_num = 0, },
[11853] = {name = "防具", lv = 185, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 37000, swap_atk_price = 1850000, main_attr_type = 6, main_attr_value = 1800, deputy_attr_num = 2, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21851, 21852, 21853, 21854,}, up_stairs_item_num = 0, },
[21853] = {name = "防具", lv = 185, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 74000, swap_atk_price = 1850000, main_attr_type = 6, main_attr_value = 1800, deputy_attr_num = 3, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31851, 31852, 31853, 31854,}, up_stairs_item_num = 0, },
[31853] = {name = "防具", lv = 185, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 111000, swap_atk_price = 1850000, main_attr_type = 6, main_attr_value = 1800, deputy_attr_num = 4, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41851, 41852, 41853, 41854,}, up_stairs_item_num = 0, },
[41853] = {name = "防具", lv = 185, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 148000, swap_atk_price = 1850000, main_attr_type = 6, main_attr_value = 1800, deputy_attr_num = 5, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51851, 51852, 51853, 51854,}, up_stairs_item_num = 0, },
[51853] = {name = "防具", lv = 185, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 185000, swap_atk_price = 1850000, main_attr_type = 6, main_attr_value = 1800, deputy_attr_num = 5, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0752, extra_attr_max = 0.094, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51851, 51852, 51853, 51854,}, up_stairs_item_num = 0, },
[11854] = {name = "鞋子", lv = 185, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 37000, swap_atk_price = 1850000, main_attr_type = 7, main_attr_value = 1800, deputy_attr_num = 2, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21851, 21852, 21853, 21854,}, up_stairs_item_num = 0, },
[21854] = {name = "鞋子", lv = 185, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 74000, swap_atk_price = 1850000, main_attr_type = 7, main_attr_value = 1800, deputy_attr_num = 3, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31851, 31852, 31853, 31854,}, up_stairs_item_num = 0, },
[31854] = {name = "鞋子", lv = 185, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 111000, swap_atk_price = 1850000, main_attr_type = 7, main_attr_value = 1800, deputy_attr_num = 4, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41851, 41852, 41853, 41854,}, up_stairs_item_num = 0, },
[41854] = {name = "鞋子", lv = 185, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 148000, swap_atk_price = 1850000, main_attr_type = 7, main_attr_value = 1800, deputy_attr_num = 5, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51851, 51852, 51853, 51854,}, up_stairs_item_num = 0, },
[51854] = {name = "鞋子", lv = 185, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 185000, swap_atk_price = 1850000, main_attr_type = 7, main_attr_value = 1800, deputy_attr_num = 5, deputy_attr_min = 1080, deputy_attr_max = 1350, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0752, extra_attr_max = 0.094, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51851, 51852, 51853, 51854,}, up_stairs_item_num = 0, },
[11901] = {name = "武器", lv = 190, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 38000, swap_atk_price = 1900000, main_attr_type = 2, main_attr_value = 5692, deputy_attr_num = 2, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21901, 21902, 21903, 21904,}, up_stairs_item_num = 0, },
[21901] = {name = "武器", lv = 190, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 76000, swap_atk_price = 1900000, main_attr_type = 2, main_attr_value = 5692, deputy_attr_num = 3, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31901, 31902, 31903, 31904,}, up_stairs_item_num = 0, },
[31901] = {name = "武器", lv = 190, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 114000, swap_atk_price = 1900000, main_attr_type = 2, main_attr_value = 5692, deputy_attr_num = 4, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41901, 41902, 41903, 41904,}, up_stairs_item_num = 0, },
[41901] = {name = "武器", lv = 190, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 152000, swap_atk_price = 1900000, main_attr_type = 2, main_attr_value = 5692, deputy_attr_num = 5, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51901, 51902, 51903, 51904,}, up_stairs_item_num = 0, },
[51901] = {name = "武器", lv = 190, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 190000, swap_atk_price = 1900000, main_attr_type = 2, main_attr_value = 5692, deputy_attr_num = 5, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.096, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51901, 51902, 51903, 51904,}, up_stairs_item_num = 0, },
[11902] = {name = "头盔", lv = 190, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 38000, swap_atk_price = 1900000, main_attr_type = 1, main_attr_value = 47430, deputy_attr_num = 2, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21901, 21902, 21903, 21904,}, up_stairs_item_num = 0, },
[21902] = {name = "头盔", lv = 190, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 76000, swap_atk_price = 1900000, main_attr_type = 1, main_attr_value = 47430, deputy_attr_num = 3, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31901, 31902, 31903, 31904,}, up_stairs_item_num = 0, },
[31902] = {name = "头盔", lv = 190, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 114000, swap_atk_price = 1900000, main_attr_type = 1, main_attr_value = 47430, deputy_attr_num = 4, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41901, 41902, 41903, 41904,}, up_stairs_item_num = 0, },
[41902] = {name = "头盔", lv = 190, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 152000, swap_atk_price = 1900000, main_attr_type = 1, main_attr_value = 47430, deputy_attr_num = 5, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51901, 51902, 51903, 51904,}, up_stairs_item_num = 0, },
[51902] = {name = "头盔", lv = 190, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 190000, swap_atk_price = 1900000, main_attr_type = 1, main_attr_value = 47430, deputy_attr_num = 5, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.096, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51901, 51902, 51903, 51904,}, up_stairs_item_num = 0, },
[11903] = {name = "防具", lv = 190, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 38000, swap_atk_price = 1900000, main_attr_type = 6, main_attr_value = 1897, deputy_attr_num = 2, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21901, 21902, 21903, 21904,}, up_stairs_item_num = 0, },
[21903] = {name = "防具", lv = 190, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 76000, swap_atk_price = 1900000, main_attr_type = 6, main_attr_value = 1897, deputy_attr_num = 3, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31901, 31902, 31903, 31904,}, up_stairs_item_num = 0, },
[31903] = {name = "防具", lv = 190, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 114000, swap_atk_price = 1900000, main_attr_type = 6, main_attr_value = 1897, deputy_attr_num = 4, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41901, 41902, 41903, 41904,}, up_stairs_item_num = 0, },
[41903] = {name = "防具", lv = 190, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 152000, swap_atk_price = 1900000, main_attr_type = 6, main_attr_value = 1897, deputy_attr_num = 5, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51901, 51902, 51903, 51904,}, up_stairs_item_num = 0, },
[51903] = {name = "防具", lv = 190, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 190000, swap_atk_price = 1900000, main_attr_type = 6, main_attr_value = 1897, deputy_attr_num = 5, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.096, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51901, 51902, 51903, 51904,}, up_stairs_item_num = 0, },
[11904] = {name = "鞋子", lv = 190, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 38000, swap_atk_price = 1900000, main_attr_type = 7, main_attr_value = 1897, deputy_attr_num = 2, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21901, 21902, 21903, 21904,}, up_stairs_item_num = 0, },
[21904] = {name = "鞋子", lv = 190, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 76000, swap_atk_price = 1900000, main_attr_type = 7, main_attr_value = 1897, deputy_attr_num = 3, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31901, 31902, 31903, 31904,}, up_stairs_item_num = 0, },
[31904] = {name = "鞋子", lv = 190, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 114000, swap_atk_price = 1900000, main_attr_type = 7, main_attr_value = 1897, deputy_attr_num = 4, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41901, 41902, 41903, 41904,}, up_stairs_item_num = 0, },
[41904] = {name = "鞋子", lv = 190, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 152000, swap_atk_price = 1900000, main_attr_type = 7, main_attr_value = 1897, deputy_attr_num = 5, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51901, 51902, 51903, 51904,}, up_stairs_item_num = 0, },
[51904] = {name = "鞋子", lv = 190, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 190000, swap_atk_price = 1900000, main_attr_type = 7, main_attr_value = 1897, deputy_attr_num = 5, deputy_attr_min = 1138, deputy_attr_max = 1423, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.096, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51901, 51902, 51903, 51904,}, up_stairs_item_num = 0, },
[11951] = {name = "武器", lv = 195, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 39000, swap_atk_price = 1950000, main_attr_type = 2, main_attr_value = 5992, deputy_attr_num = 2, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21951, 21952, 21953, 21954,}, up_stairs_item_num = 0, },
[21951] = {name = "武器", lv = 195, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 78000, swap_atk_price = 1950000, main_attr_type = 2, main_attr_value = 5992, deputy_attr_num = 3, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31951, 31952, 31953, 31954,}, up_stairs_item_num = 0, },
[31951] = {name = "武器", lv = 195, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 117000, swap_atk_price = 1950000, main_attr_type = 2, main_attr_value = 5992, deputy_attr_num = 4, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41951, 41952, 41953, 41954,}, up_stairs_item_num = 0, },
[41951] = {name = "武器", lv = 195, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 156000, swap_atk_price = 1950000, main_attr_type = 2, main_attr_value = 5992, deputy_attr_num = 5, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51951, 51952, 51953, 51954,}, up_stairs_item_num = 0, },
[51951] = {name = "武器", lv = 195, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 195000, swap_atk_price = 1950000, main_attr_type = 2, main_attr_value = 5992, deputy_attr_num = 5, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0784, extra_attr_max = 0.098, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51951, 51952, 51953, 51954,}, up_stairs_item_num = 0, },
[11952] = {name = "头盔", lv = 195, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 39000, swap_atk_price = 1950000, main_attr_type = 1, main_attr_value = 49933, deputy_attr_num = 2, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21951, 21952, 21953, 21954,}, up_stairs_item_num = 0, },
[21952] = {name = "头盔", lv = 195, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 78000, swap_atk_price = 1950000, main_attr_type = 1, main_attr_value = 49933, deputy_attr_num = 3, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31951, 31952, 31953, 31954,}, up_stairs_item_num = 0, },
[31952] = {name = "头盔", lv = 195, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 117000, swap_atk_price = 1950000, main_attr_type = 1, main_attr_value = 49933, deputy_attr_num = 4, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41951, 41952, 41953, 41954,}, up_stairs_item_num = 0, },
[41952] = {name = "头盔", lv = 195, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 156000, swap_atk_price = 1950000, main_attr_type = 1, main_attr_value = 49933, deputy_attr_num = 5, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51951, 51952, 51953, 51954,}, up_stairs_item_num = 0, },
[51952] = {name = "头盔", lv = 195, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 195000, swap_atk_price = 1950000, main_attr_type = 1, main_attr_value = 49933, deputy_attr_num = 5, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0784, extra_attr_max = 0.098, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51951, 51952, 51953, 51954,}, up_stairs_item_num = 0, },
[11953] = {name = "防具", lv = 195, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 39000, swap_atk_price = 1950000, main_attr_type = 6, main_attr_value = 1997, deputy_attr_num = 2, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21951, 21952, 21953, 21954,}, up_stairs_item_num = 0, },
[21953] = {name = "防具", lv = 195, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 78000, swap_atk_price = 1950000, main_attr_type = 6, main_attr_value = 1997, deputy_attr_num = 3, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31951, 31952, 31953, 31954,}, up_stairs_item_num = 0, },
[31953] = {name = "防具", lv = 195, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 117000, swap_atk_price = 1950000, main_attr_type = 6, main_attr_value = 1997, deputy_attr_num = 4, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41951, 41952, 41953, 41954,}, up_stairs_item_num = 0, },
[41953] = {name = "防具", lv = 195, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 156000, swap_atk_price = 1950000, main_attr_type = 6, main_attr_value = 1997, deputy_attr_num = 5, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51951, 51952, 51953, 51954,}, up_stairs_item_num = 0, },
[51953] = {name = "防具", lv = 195, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 195000, swap_atk_price = 1950000, main_attr_type = 6, main_attr_value = 1997, deputy_attr_num = 5, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0784, extra_attr_max = 0.098, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51951, 51952, 51953, 51954,}, up_stairs_item_num = 0, },
[11954] = {name = "鞋子", lv = 195, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 39000, swap_atk_price = 1950000, main_attr_type = 7, main_attr_value = 1997, deputy_attr_num = 2, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {21951, 21952, 21953, 21954,}, up_stairs_item_num = 0, },
[21954] = {name = "鞋子", lv = 195, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 78000, swap_atk_price = 1950000, main_attr_type = 7, main_attr_value = 1997, deputy_attr_num = 3, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {31951, 31952, 31953, 31954,}, up_stairs_item_num = 0, },
[31954] = {name = "鞋子", lv = 195, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 117000, swap_atk_price = 1950000, main_attr_type = 7, main_attr_value = 1997, deputy_attr_num = 4, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {41951, 41952, 41953, 41954,}, up_stairs_item_num = 0, },
[41954] = {name = "鞋子", lv = 195, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 156000, swap_atk_price = 1950000, main_attr_type = 7, main_attr_value = 1997, deputy_attr_num = 5, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {51951, 51952, 51953, 51954,}, up_stairs_item_num = 0, },
[51954] = {name = "鞋子", lv = 195, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 195000, swap_atk_price = 1950000, main_attr_type = 7, main_attr_value = 1997, deputy_attr_num = 5, deputy_attr_min = 1198, deputy_attr_max = 1498, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.0784, extra_attr_max = 0.098, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {51951, 51952, 51953, 51954,}, up_stairs_item_num = 0, },
[12001] = {name = "武器", lv = 200, icon = 30001, _type = 0, tile_num = 0, quality = 1, strengthen_price = 40000, swap_atk_price = 2000000, main_attr_type = 2, main_attr_value = 6300, deputy_attr_num = 2, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {22001, 22002, 22003, 22004,}, up_stairs_item_num = 0, },
[22001] = {name = "武器", lv = 200, icon = 30005, _type = 0, tile_num = 0, quality = 2, strengthen_price = 80000, swap_atk_price = 2000000, main_attr_type = 2, main_attr_value = 6300, deputy_attr_num = 3, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {32001, 32002, 32003, 32004,}, up_stairs_item_num = 0, },
[32001] = {name = "武器", lv = 200, icon = 30009, _type = 0, tile_num = 0, quality = 3, strengthen_price = 120000, swap_atk_price = 2000000, main_attr_type = 2, main_attr_value = 6300, deputy_attr_num = 4, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {42001, 42002, 42003, 42004,}, up_stairs_item_num = 0, },
[42001] = {name = "武器", lv = 200, icon = 30013, _type = 0, tile_num = 0, quality = 4, strengthen_price = 160000, swap_atk_price = 2000000, main_attr_type = 2, main_attr_value = 6300, deputy_attr_num = 5, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {52001, 52002, 52003, 52004,}, up_stairs_item_num = 0, },
[52001] = {name = "武器", lv = 200, icon = 30017, _type = 0, tile_num = 0, quality = 5, strengthen_price = 200000, swap_atk_price = 2000000, main_attr_type = 2, main_attr_value = 6300, deputy_attr_num = 5, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.08, extra_attr_max = 0.1, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {52001, 52002, 52003, 52004,}, up_stairs_item_num = 0, },
[12002] = {name = "头盔", lv = 200, icon = 30002, _type = 1, tile_num = 0, quality = 1, strengthen_price = 40000, swap_atk_price = 2000000, main_attr_type = 1, main_attr_value = 52500, deputy_attr_num = 2, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {22001, 22002, 22003, 22004,}, up_stairs_item_num = 0, },
[22002] = {name = "头盔", lv = 200, icon = 30006, _type = 1, tile_num = 0, quality = 2, strengthen_price = 80000, swap_atk_price = 2000000, main_attr_type = 1, main_attr_value = 52500, deputy_attr_num = 3, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {32001, 32002, 32003, 32004,}, up_stairs_item_num = 0, },
[32002] = {name = "头盔", lv = 200, icon = 30010, _type = 1, tile_num = 0, quality = 3, strengthen_price = 120000, swap_atk_price = 2000000, main_attr_type = 1, main_attr_value = 52500, deputy_attr_num = 4, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {42001, 42002, 42003, 42004,}, up_stairs_item_num = 0, },
[42002] = {name = "头盔", lv = 200, icon = 30014, _type = 1, tile_num = 0, quality = 4, strengthen_price = 160000, swap_atk_price = 2000000, main_attr_type = 1, main_attr_value = 52500, deputy_attr_num = 5, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {52001, 52002, 52003, 52004,}, up_stairs_item_num = 0, },
[52002] = {name = "头盔", lv = 200, icon = 30018, _type = 1, tile_num = 0, quality = 5, strengthen_price = 200000, swap_atk_price = 2000000, main_attr_type = 1, main_attr_value = 52500, deputy_attr_num = 5, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.08, extra_attr_max = 0.1, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {52001, 52002, 52003, 52004,}, up_stairs_item_num = 0, },
[12003] = {name = "防具", lv = 200, icon = 30003, _type = 2, tile_num = 0, quality = 1, strengthen_price = 40000, swap_atk_price = 2000000, main_attr_type = 6, main_attr_value = 2100, deputy_attr_num = 2, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {22001, 22002, 22003, 22004,}, up_stairs_item_num = 0, },
[22003] = {name = "防具", lv = 200, icon = 30007, _type = 2, tile_num = 0, quality = 2, strengthen_price = 80000, swap_atk_price = 2000000, main_attr_type = 6, main_attr_value = 2100, deputy_attr_num = 3, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {32001, 32002, 32003, 32004,}, up_stairs_item_num = 0, },
[32003] = {name = "防具", lv = 200, icon = 30011, _type = 2, tile_num = 0, quality = 3, strengthen_price = 120000, swap_atk_price = 2000000, main_attr_type = 6, main_attr_value = 2100, deputy_attr_num = 4, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {42001, 42002, 42003, 42004,}, up_stairs_item_num = 0, },
[42003] = {name = "防具", lv = 200, icon = 30015, _type = 2, tile_num = 0, quality = 4, strengthen_price = 160000, swap_atk_price = 2000000, main_attr_type = 6, main_attr_value = 2100, deputy_attr_num = 5, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {52001, 52002, 52003, 52004,}, up_stairs_item_num = 0, },
[52003] = {name = "防具", lv = 200, icon = 30019, _type = 2, tile_num = 0, quality = 5, strengthen_price = 200000, swap_atk_price = 2000000, main_attr_type = 6, main_attr_value = 2100, deputy_attr_num = 5, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.08, extra_attr_max = 0.1, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {52001, 52002, 52003, 52004,}, up_stairs_item_num = 0, },
[12004] = {name = "鞋子", lv = 200, icon = 30004, _type = 3, tile_num = 0, quality = 1, strengthen_price = 40000, swap_atk_price = 2000000, main_attr_type = 7, main_attr_value = 2100, deputy_attr_num = 2, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.6, smelt_value = 50, up_stairs_target = {22001, 22002, 22003, 22004,}, up_stairs_item_num = 0, },
[22004] = {name = "鞋子", lv = 200, icon = 30008, _type = 3, tile_num = 0, quality = 2, strengthen_price = 80000, swap_atk_price = 2000000, main_attr_type = 7, main_attr_value = 2100, deputy_attr_num = 3, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.4, smelt_value = 100, up_stairs_target = {32001, 32002, 32003, 32004,}, up_stairs_item_num = 0, },
[32004] = {name = "鞋子", lv = 200, icon = 30012, _type = 3, tile_num = 0, quality = 3, strengthen_price = 120000, swap_atk_price = 2000000, main_attr_type = 7, main_attr_value = 2100, deputy_attr_num = 4, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.2, smelt_value = 150, up_stairs_target = {42001, 42002, 42003, 42004,}, up_stairs_item_num = 0, },
[42004] = {name = "鞋子", lv = 200, icon = 30016, _type = 3, tile_num = 0, quality = 4, strengthen_price = 160000, swap_atk_price = 2000000, main_attr_type = 7, main_attr_value = 2100, deputy_attr_num = 5, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 0, extra_attr_num_max = 0, extra_attr_min = 0, extra_attr_max = 0, up_stairs_odds = 0.1, smelt_value = 200, up_stairs_target = {52001, 52002, 52003, 52004,}, up_stairs_item_num = 0, },
[52004] = {name = "鞋子", lv = 200, icon = 30020, _type = 3, tile_num = 0, quality = 5, strengthen_price = 200000, swap_atk_price = 2000000, main_attr_type = 7, main_attr_value = 2100, deputy_attr_num = 5, deputy_attr_min = 1260, deputy_attr_max = 1575, extra_attr_num_min = 1, extra_attr_num_max = 5, extra_attr_min = 0.08, extra_attr_max = 0.1, up_stairs_odds = 0.05, smelt_value = 300, up_stairs_target = {52001, 52002, 52003, 52004,}, up_stairs_item_num = 0, },



[110011] = {name = "夏禹轩辕戟", lv = 1, icon = 30021, _type = 0, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 2, main_attr_value = 75, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110051}, up_stairs_item_num = 5, },
[110051] = {name = "夏禹轩辕戟", lv = 5, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 2, main_attr_value = 80, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110101}, up_stairs_item_num = 10, },
[110101] = {name = "夏禹轩辕戟", lv = 10, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 2, main_attr_value = 95, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110151}, up_stairs_item_num = 15, },
[110151] = {name = "夏禹轩辕戟", lv = 15, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 2, main_attr_value = 119, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110201}, up_stairs_item_num = 20, },
[110201] = {name = "夏禹轩辕戟", lv = 20, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 2, main_attr_value = 153, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110251}, up_stairs_item_num = 25, },
[110251] = {name = "夏禹轩辕戟", lv = 25, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 2, main_attr_value = 197, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110301}, up_stairs_item_num = 30, },
[110301] = {name = "夏禹轩辕戟", lv = 30, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 2, main_attr_value = 251, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110351}, up_stairs_item_num = 35, },
[110351] = {name = "夏禹轩辕戟", lv = 35, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 2, main_attr_value = 314, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110401}, up_stairs_item_num = 40, },
[110401] = {name = "夏禹轩辕戟", lv = 40, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 2, main_attr_value = 387, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110451}, up_stairs_item_num = 45, },
[110451] = {name = "夏禹轩辕戟", lv = 45, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 2, main_attr_value = 470, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110501}, up_stairs_item_num = 50, },
[110501] = {name = "夏禹轩辕戟", lv = 50, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 2, main_attr_value = 563, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110551}, up_stairs_item_num = 55, },
[110551] = {name = "夏禹轩辕戟", lv = 55, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 2, main_attr_value = 665, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110601}, up_stairs_item_num = 60, },
[110601] = {name = "夏禹轩辕戟", lv = 60, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 2, main_attr_value = 777, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110651}, up_stairs_item_num = 65, },
[110651] = {name = "夏禹轩辕戟", lv = 65, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 2, main_attr_value = 899, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110701}, up_stairs_item_num = 70, },
[110701] = {name = "夏禹轩辕戟", lv = 70, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 2, main_attr_value = 1031, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110751}, up_stairs_item_num = 75, },
[110751] = {name = "夏禹轩辕戟", lv = 75, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 2, main_attr_value = 1172, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110801}, up_stairs_item_num = 80, },
[110801] = {name = "夏禹轩辕戟", lv = 80, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 2, main_attr_value = 1323, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110851}, up_stairs_item_num = 85, },
[110851] = {name = "夏禹轩辕戟", lv = 85, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 2, main_attr_value = 1484, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110901}, up_stairs_item_num = 90, },
[110901] = {name = "夏禹轩辕戟", lv = 90, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 2, main_attr_value = 1655, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110951}, up_stairs_item_num = 95, },
[110951] = {name = "夏禹轩辕戟", lv = 95, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 2, main_attr_value = 1835, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111001}, up_stairs_item_num = 100, },
[111001] = {name = "夏禹轩辕戟", lv = 100, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 2, main_attr_value = 2025, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111051}, up_stairs_item_num = 105, },
[111051] = {name = "夏禹轩辕戟", lv = 105, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 2, main_attr_value = 2225, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111101}, up_stairs_item_num = 110, },
[111101] = {name = "夏禹轩辕戟", lv = 110, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 2, main_attr_value = 2435, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111151}, up_stairs_item_num = 115, },
[111151] = {name = "夏禹轩辕戟", lv = 115, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 2, main_attr_value = 2654, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111201}, up_stairs_item_num = 120, },
[111201] = {name = "夏禹轩辕戟", lv = 120, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 2, main_attr_value = 2883, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111251}, up_stairs_item_num = 125, },
[111251] = {name = "夏禹轩辕戟", lv = 125, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 2, main_attr_value = 3122, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111301}, up_stairs_item_num = 130, },
[111301] = {name = "夏禹轩辕戟", lv = 130, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 2, main_attr_value = 3371, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111351}, up_stairs_item_num = 135, },
[111351] = {name = "夏禹轩辕戟", lv = 135, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 2, main_attr_value = 3629, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111401}, up_stairs_item_num = 140, },
[111401] = {name = "夏禹轩辕戟", lv = 140, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 2, main_attr_value = 3897, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111451}, up_stairs_item_num = 145, },
[111451] = {name = "夏禹轩辕戟", lv = 145, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 2, main_attr_value = 4175, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111501}, up_stairs_item_num = 150, },
[111501] = {name = "夏禹轩辕戟", lv = 150, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 2, main_attr_value = 4463, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111551}, up_stairs_item_num = 155, },
[111551] = {name = "夏禹轩辕戟", lv = 155, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 2, main_attr_value = 4760, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111601}, up_stairs_item_num = 160, },
[111601] = {name = "夏禹轩辕戟", lv = 160, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 2, main_attr_value = 5067, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111651}, up_stairs_item_num = 165, },
[111651] = {name = "夏禹轩辕戟", lv = 165, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 2, main_attr_value = 5384, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111701}, up_stairs_item_num = 170, },
[111701] = {name = "夏禹轩辕戟", lv = 170, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 2, main_attr_value = 5711, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111751}, up_stairs_item_num = 175, },
[111751] = {name = "夏禹轩辕戟", lv = 175, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 2, main_attr_value = 6047, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111801}, up_stairs_item_num = 180, },
[111801] = {name = "夏禹轩辕戟", lv = 180, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 2, main_attr_value = 6393, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111851}, up_stairs_item_num = 185, },
[111851] = {name = "夏禹轩辕戟", lv = 185, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 2, main_attr_value = 6749, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111901}, up_stairs_item_num = 190, },
[111901] = {name = "夏禹轩辕戟", lv = 190, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 2, main_attr_value = 7115, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111951}, up_stairs_item_num = 195, },
[111951] = {name = "夏禹轩辕戟", lv = 195, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 2, main_attr_value = 7490, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {112001}, up_stairs_item_num = 200, },
[112001] = {name = "夏禹轩辕戟", lv = 200, icon = 30021, _type = 0, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 2, main_attr_value = 7875, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[110012] = {name = "寒铁逐风盔", lv = 1, icon = 30022, _type = 1, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 1, main_attr_value = 625, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110052}, up_stairs_item_num = 5, },
[110052] = {name = "寒铁逐风盔", lv = 5, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 1, main_attr_value = 666, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110102}, up_stairs_item_num = 10, },
[110102] = {name = "寒铁逐风盔", lv = 10, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 1, main_attr_value = 788, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110152}, up_stairs_item_num = 15, },
[110152] = {name = "寒铁逐风盔", lv = 15, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 1, main_attr_value = 991, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110202}, up_stairs_item_num = 20, },
[110202] = {name = "寒铁逐风盔", lv = 20, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 1, main_attr_value = 1275, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110252}, up_stairs_item_num = 25, },
[110252] = {name = "寒铁逐风盔", lv = 25, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 1, main_attr_value = 1641, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110302}, up_stairs_item_num = 30, },
[110302] = {name = "寒铁逐风盔", lv = 30, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 1, main_attr_value = 2088, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110352}, up_stairs_item_num = 35, },
[110352] = {name = "寒铁逐风盔", lv = 35, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 1, main_attr_value = 2616, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110402}, up_stairs_item_num = 40, },
[110402] = {name = "寒铁逐风盔", lv = 40, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 1, main_attr_value = 3225, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110452}, up_stairs_item_num = 45, },
[110452] = {name = "寒铁逐风盔", lv = 45, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 1, main_attr_value = 3916, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110502}, up_stairs_item_num = 50, },
[110502] = {name = "寒铁逐风盔", lv = 50, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 1, main_attr_value = 4688, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110552}, up_stairs_item_num = 55, },
[110552] = {name = "寒铁逐风盔", lv = 55, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 1, main_attr_value = 5541, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110602}, up_stairs_item_num = 60, },
[110602] = {name = "寒铁逐风盔", lv = 60, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 1, main_attr_value = 6475, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110652}, up_stairs_item_num = 65, },
[110652] = {name = "寒铁逐风盔", lv = 65, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 1, main_attr_value = 7491, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110702}, up_stairs_item_num = 70, },
[110702] = {name = "寒铁逐风盔", lv = 70, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 1, main_attr_value = 8588, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110752}, up_stairs_item_num = 75, },
[110752] = {name = "寒铁逐风盔", lv = 75, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 1, main_attr_value = 9766, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110802}, up_stairs_item_num = 80, },
[110802] = {name = "寒铁逐风盔", lv = 80, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 1, main_attr_value = 11025, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110852}, up_stairs_item_num = 85, },
[110852] = {name = "寒铁逐风盔", lv = 85, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 1, main_attr_value = 12366, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110902}, up_stairs_item_num = 90, },
[110902] = {name = "寒铁逐风盔", lv = 90, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 1, main_attr_value = 13788, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110952}, up_stairs_item_num = 95, },
[110952] = {name = "寒铁逐风盔", lv = 95, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 1, main_attr_value = 15291, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111002}, up_stairs_item_num = 100, },
[111002] = {name = "寒铁逐风盔", lv = 100, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 1, main_attr_value = 16875, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111052}, up_stairs_item_num = 105, },
[111052] = {name = "寒铁逐风盔", lv = 105, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 1, main_attr_value = 18541, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111102}, up_stairs_item_num = 110, },
[111102] = {name = "寒铁逐风盔", lv = 110, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 1, main_attr_value = 20288, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111152}, up_stairs_item_num = 115, },
[111152] = {name = "寒铁逐风盔", lv = 115, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 1, main_attr_value = 22116, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111202}, up_stairs_item_num = 120, },
[111202] = {name = "寒铁逐风盔", lv = 120, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 1, main_attr_value = 24025, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111252}, up_stairs_item_num = 125, },
[111252] = {name = "寒铁逐风盔", lv = 125, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 1, main_attr_value = 26016, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111302}, up_stairs_item_num = 130, },
[111302] = {name = "寒铁逐风盔", lv = 130, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 1, main_attr_value = 28088, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111352}, up_stairs_item_num = 135, },
[111352] = {name = "寒铁逐风盔", lv = 135, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 1, main_attr_value = 30241, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111402}, up_stairs_item_num = 140, },
[111402] = {name = "寒铁逐风盔", lv = 140, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 1, main_attr_value = 32475, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111452}, up_stairs_item_num = 145, },
[111452] = {name = "寒铁逐风盔", lv = 145, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 1, main_attr_value = 34791, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111502}, up_stairs_item_num = 150, },
[111502] = {name = "寒铁逐风盔", lv = 150, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 1, main_attr_value = 37188, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111552}, up_stairs_item_num = 155, },
[111552] = {name = "寒铁逐风盔", lv = 155, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 1, main_attr_value = 39666, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111602}, up_stairs_item_num = 160, },
[111602] = {name = "寒铁逐风盔", lv = 160, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 1, main_attr_value = 42225, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111652}, up_stairs_item_num = 165, },
[111652] = {name = "寒铁逐风盔", lv = 165, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 1, main_attr_value = 44866, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111702}, up_stairs_item_num = 170, },
[111702] = {name = "寒铁逐风盔", lv = 170, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 1, main_attr_value = 47588, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111752}, up_stairs_item_num = 175, },
[111752] = {name = "寒铁逐风盔", lv = 175, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 1, main_attr_value = 50391, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111802}, up_stairs_item_num = 180, },
[111802] = {name = "寒铁逐风盔", lv = 180, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 1, main_attr_value = 53275, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111852}, up_stairs_item_num = 185, },
[111852] = {name = "寒铁逐风盔", lv = 185, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 1, main_attr_value = 56241, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111902}, up_stairs_item_num = 190, },
[111902] = {name = "寒铁逐风盔", lv = 190, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 1, main_attr_value = 59288, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111952}, up_stairs_item_num = 195, },
[111952] = {name = "寒铁逐风盔", lv = 195, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 1, main_attr_value = 62416, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {112002}, up_stairs_item_num = 200, },
[112002] = {name = "寒铁逐风盔", lv = 200, icon = 30022, _type = 1, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 1, main_attr_value = 65625, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[110013] = {name = "流浪摘星甲", lv = 1, icon = 30023, _type = 2, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 6, main_attr_value = 25, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110053}, up_stairs_item_num = 5, },
[110053] = {name = "流浪摘星甲", lv = 5, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 6, main_attr_value = 27, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110103}, up_stairs_item_num = 10, },
[110103] = {name = "流浪摘星甲", lv = 10, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 6, main_attr_value = 32, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110153}, up_stairs_item_num = 15, },
[110153] = {name = "流浪摘星甲", lv = 15, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 6, main_attr_value = 40, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110203}, up_stairs_item_num = 20, },
[110203] = {name = "流浪摘星甲", lv = 20, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 6, main_attr_value = 51, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110253}, up_stairs_item_num = 25, },
[110253] = {name = "流浪摘星甲", lv = 25, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 6, main_attr_value = 66, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110303}, up_stairs_item_num = 30, },
[110303] = {name = "流浪摘星甲", lv = 30, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 6, main_attr_value = 84, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110353}, up_stairs_item_num = 35, },
[110353] = {name = "流浪摘星甲", lv = 35, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 6, main_attr_value = 105, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110403}, up_stairs_item_num = 40, },
[110403] = {name = "流浪摘星甲", lv = 40, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 6, main_attr_value = 129, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110453}, up_stairs_item_num = 45, },
[110453] = {name = "流浪摘星甲", lv = 45, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 6, main_attr_value = 157, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110503}, up_stairs_item_num = 50, },
[110503] = {name = "流浪摘星甲", lv = 50, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 6, main_attr_value = 188, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110553}, up_stairs_item_num = 55, },
[110553] = {name = "流浪摘星甲", lv = 55, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 6, main_attr_value = 222, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110603}, up_stairs_item_num = 60, },
[110603] = {name = "流浪摘星甲", lv = 60, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 6, main_attr_value = 259, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110653}, up_stairs_item_num = 65, },
[110653] = {name = "流浪摘星甲", lv = 65, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 6, main_attr_value = 300, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110703}, up_stairs_item_num = 70, },
[110703] = {name = "流浪摘星甲", lv = 70, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 6, main_attr_value = 344, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110753}, up_stairs_item_num = 75, },
[110753] = {name = "流浪摘星甲", lv = 75, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 6, main_attr_value = 391, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110803}, up_stairs_item_num = 80, },
[110803] = {name = "流浪摘星甲", lv = 80, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 6, main_attr_value = 441, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110853}, up_stairs_item_num = 85, },
[110853] = {name = "流浪摘星甲", lv = 85, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 6, main_attr_value = 495, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110903}, up_stairs_item_num = 90, },
[110903] = {name = "流浪摘星甲", lv = 90, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 6, main_attr_value = 552, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110953}, up_stairs_item_num = 95, },
[110953] = {name = "流浪摘星甲", lv = 95, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 6, main_attr_value = 612, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111003}, up_stairs_item_num = 100, },
[111003] = {name = "流浪摘星甲", lv = 100, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 6, main_attr_value = 675, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111053}, up_stairs_item_num = 105, },
[111053] = {name = "流浪摘星甲", lv = 105, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 6, main_attr_value = 742, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111103}, up_stairs_item_num = 110, },
[111103] = {name = "流浪摘星甲", lv = 110, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 6, main_attr_value = 812, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111153}, up_stairs_item_num = 115, },
[111153] = {name = "流浪摘星甲", lv = 115, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 6, main_attr_value = 885, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111203}, up_stairs_item_num = 120, },
[111203] = {name = "流浪摘星甲", lv = 120, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 6, main_attr_value = 961, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111253}, up_stairs_item_num = 125, },
[111253] = {name = "流浪摘星甲", lv = 125, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 6, main_attr_value = 1041, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111303}, up_stairs_item_num = 130, },
[111303] = {name = "流浪摘星甲", lv = 130, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 6, main_attr_value = 1124, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111353}, up_stairs_item_num = 135, },
[111353] = {name = "流浪摘星甲", lv = 135, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 6, main_attr_value = 1210, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111403}, up_stairs_item_num = 140, },
[111403] = {name = "流浪摘星甲", lv = 140, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 6, main_attr_value = 1299, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111453}, up_stairs_item_num = 145, },
[111453] = {name = "流浪摘星甲", lv = 145, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 6, main_attr_value = 1392, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111503}, up_stairs_item_num = 150, },
[111503] = {name = "流浪摘星甲", lv = 150, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 6, main_attr_value = 1488, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111553}, up_stairs_item_num = 155, },
[111553] = {name = "流浪摘星甲", lv = 155, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 6, main_attr_value = 1587, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111603}, up_stairs_item_num = 160, },
[111603] = {name = "流浪摘星甲", lv = 160, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 6, main_attr_value = 1689, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111653}, up_stairs_item_num = 165, },
[111653] = {name = "流浪摘星甲", lv = 165, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 6, main_attr_value = 1795, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111703}, up_stairs_item_num = 170, },
[111703] = {name = "流浪摘星甲", lv = 170, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 6, main_attr_value = 1904, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111753}, up_stairs_item_num = 175, },
[111753] = {name = "流浪摘星甲", lv = 175, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 6, main_attr_value = 2016, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111803}, up_stairs_item_num = 180, },
[111803] = {name = "流浪摘星甲", lv = 180, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 6, main_attr_value = 2131, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111853}, up_stairs_item_num = 185, },
[111853] = {name = "流浪摘星甲", lv = 185, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 6, main_attr_value = 2250, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111903}, up_stairs_item_num = 190, },
[111903] = {name = "流浪摘星甲", lv = 190, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 6, main_attr_value = 2372, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111953}, up_stairs_item_num = 195, },
[111953] = {name = "流浪摘星甲", lv = 195, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 6, main_attr_value = 2497, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {112003}, up_stairs_item_num = 200, },
[112003] = {name = "流浪摘星甲", lv = 200, icon = 30023, _type = 2, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 6, main_attr_value = 2625, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[110014] = {name = "冰棱极地靴", lv = 1, icon = 30024, _type = 3, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 7, main_attr_value = 25, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110054}, up_stairs_item_num = 5, },
[110054] = {name = "冰棱极地靴", lv = 5, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 7, main_attr_value = 27, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110104}, up_stairs_item_num = 10, },
[110104] = {name = "冰棱极地靴", lv = 10, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 7, main_attr_value = 32, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110154}, up_stairs_item_num = 15, },
[110154] = {name = "冰棱极地靴", lv = 15, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 7, main_attr_value = 40, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110204}, up_stairs_item_num = 20, },
[110204] = {name = "冰棱极地靴", lv = 20, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 7, main_attr_value = 51, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110254}, up_stairs_item_num = 25, },
[110254] = {name = "冰棱极地靴", lv = 25, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 7, main_attr_value = 66, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110304}, up_stairs_item_num = 30, },
[110304] = {name = "冰棱极地靴", lv = 30, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 7, main_attr_value = 84, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110354}, up_stairs_item_num = 35, },
[110354] = {name = "冰棱极地靴", lv = 35, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 7, main_attr_value = 105, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110404}, up_stairs_item_num = 40, },
[110404] = {name = "冰棱极地靴", lv = 40, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 7, main_attr_value = 129, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110454}, up_stairs_item_num = 45, },
[110454] = {name = "冰棱极地靴", lv = 45, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 7, main_attr_value = 157, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110504}, up_stairs_item_num = 50, },
[110504] = {name = "冰棱极地靴", lv = 50, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 7, main_attr_value = 188, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110554}, up_stairs_item_num = 55, },
[110554] = {name = "冰棱极地靴", lv = 55, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 7, main_attr_value = 222, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110604}, up_stairs_item_num = 60, },
[110604] = {name = "冰棱极地靴", lv = 60, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 7, main_attr_value = 259, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110654}, up_stairs_item_num = 65, },
[110654] = {name = "冰棱极地靴", lv = 65, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 7, main_attr_value = 300, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110704}, up_stairs_item_num = 70, },
[110704] = {name = "冰棱极地靴", lv = 70, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 7, main_attr_value = 344, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110754}, up_stairs_item_num = 75, },
[110754] = {name = "冰棱极地靴", lv = 75, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 7, main_attr_value = 391, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110804}, up_stairs_item_num = 80, },
[110804] = {name = "冰棱极地靴", lv = 80, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 7, main_attr_value = 441, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110854}, up_stairs_item_num = 85, },
[110854] = {name = "冰棱极地靴", lv = 85, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 7, main_attr_value = 495, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110904}, up_stairs_item_num = 90, },
[110904] = {name = "冰棱极地靴", lv = 90, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 7, main_attr_value = 552, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {110954}, up_stairs_item_num = 95, },
[110954] = {name = "冰棱极地靴", lv = 95, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 7, main_attr_value = 612, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111004}, up_stairs_item_num = 100, },
[111004] = {name = "冰棱极地靴", lv = 100, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 7, main_attr_value = 675, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111054}, up_stairs_item_num = 105, },
[111054] = {name = "冰棱极地靴", lv = 105, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 7, main_attr_value = 742, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111104}, up_stairs_item_num = 110, },
[111104] = {name = "冰棱极地靴", lv = 110, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 7, main_attr_value = 812, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111154}, up_stairs_item_num = 115, },
[111154] = {name = "冰棱极地靴", lv = 115, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 7, main_attr_value = 885, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111204}, up_stairs_item_num = 120, },
[111204] = {name = "冰棱极地靴", lv = 120, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 7, main_attr_value = 961, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111254}, up_stairs_item_num = 125, },
[111254] = {name = "冰棱极地靴", lv = 125, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 7, main_attr_value = 1041, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111304}, up_stairs_item_num = 130, },
[111304] = {name = "冰棱极地靴", lv = 130, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 7, main_attr_value = 1124, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111354}, up_stairs_item_num = 135, },
[111354] = {name = "冰棱极地靴", lv = 135, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 7, main_attr_value = 1210, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111404}, up_stairs_item_num = 140, },
[111404] = {name = "冰棱极地靴", lv = 140, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 7, main_attr_value = 1299, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111454}, up_stairs_item_num = 145, },
[111454] = {name = "冰棱极地靴", lv = 145, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 7, main_attr_value = 1392, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111504}, up_stairs_item_num = 150, },
[111504] = {name = "冰棱极地靴", lv = 150, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 7, main_attr_value = 1488, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111554}, up_stairs_item_num = 155, },
[111554] = {name = "冰棱极地靴", lv = 155, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 7, main_attr_value = 1587, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111604}, up_stairs_item_num = 160, },
[111604] = {name = "冰棱极地靴", lv = 160, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 7, main_attr_value = 1689, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111654}, up_stairs_item_num = 165, },
[111654] = {name = "冰棱极地靴", lv = 165, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 7, main_attr_value = 1795, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111704}, up_stairs_item_num = 170, },
[111704] = {name = "冰棱极地靴", lv = 170, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 7, main_attr_value = 1904, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111754}, up_stairs_item_num = 175, },
[111754] = {name = "冰棱极地靴", lv = 175, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 7, main_attr_value = 2016, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111804}, up_stairs_item_num = 180, },
[111804] = {name = "冰棱极地靴", lv = 180, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 7, main_attr_value = 2131, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111854}, up_stairs_item_num = 185, },
[111854] = {name = "冰棱极地靴", lv = 185, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 7, main_attr_value = 2250, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111904}, up_stairs_item_num = 190, },
[111904] = {name = "冰棱极地靴", lv = 190, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 7, main_attr_value = 2372, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {111954}, up_stairs_item_num = 195, },
[111954] = {name = "冰棱极地靴", lv = 195, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 7, main_attr_value = 2497, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {112004}, up_stairs_item_num = 200, },
[112004] = {name = "冰棱极地靴", lv = 200, icon = 30024, _type = 3, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 7, main_attr_value = 2625, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[120011] = {name = "龙牙邪神剑", lv = 1, icon = 30041, _type = 0, tile_num = 30, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 2, main_attr_value = 83, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120051}, up_stairs_item_num = 5, },
[120051] = {name = "龙牙邪神剑", lv = 5, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 2, main_attr_value = 88, deputy_attr_num = 5, deputy_attr_min = 21, deputy_attr_max = 21, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120101}, up_stairs_item_num = 10, },
[120101] = {name = "龙牙邪神剑", lv = 10, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 2, main_attr_value = 104, deputy_attr_num = 5, deputy_attr_min = 24, deputy_attr_max = 24, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120151}, up_stairs_item_num = 15, },
[120151] = {name = "龙牙邪神剑", lv = 15, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 2, main_attr_value = 131, deputy_attr_num = 5, deputy_attr_min = 31, deputy_attr_max = 31, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120201}, up_stairs_item_num = 20, },
[120201] = {name = "龙牙邪神剑", lv = 20, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 2, main_attr_value = 168, deputy_attr_num = 5, deputy_attr_min = 39, deputy_attr_max = 39, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120251}, up_stairs_item_num = 25, },
[120251] = {name = "龙牙邪神剑", lv = 25, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 2, main_attr_value = 217, deputy_attr_num = 5, deputy_attr_min = 51, deputy_attr_max = 51, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120301}, up_stairs_item_num = 30, },
[120301] = {name = "龙牙邪神剑", lv = 30, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 2, main_attr_value = 276, deputy_attr_num = 5, deputy_attr_min = 64, deputy_attr_max = 64, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120351}, up_stairs_item_num = 35, },
[120351] = {name = "龙牙邪神剑", lv = 35, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 2, main_attr_value = 345, deputy_attr_num = 5, deputy_attr_min = 81, deputy_attr_max = 81, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120401}, up_stairs_item_num = 40, },
[120401] = {name = "龙牙邪神剑", lv = 40, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 2, main_attr_value = 426, deputy_attr_num = 5, deputy_attr_min = 99, deputy_attr_max = 99, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120451}, up_stairs_item_num = 45, },
[120451] = {name = "龙牙邪神剑", lv = 45, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 2, main_attr_value = 517, deputy_attr_num = 5, deputy_attr_min = 121, deputy_attr_max = 121, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120501}, up_stairs_item_num = 50, },
[120501] = {name = "龙牙邪神剑", lv = 50, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 2, main_attr_value = 619, deputy_attr_num = 5, deputy_attr_min = 144, deputy_attr_max = 144, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120551}, up_stairs_item_num = 55, },
[120551] = {name = "龙牙邪神剑", lv = 55, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 2, main_attr_value = 731, deputy_attr_num = 5, deputy_attr_min = 171, deputy_attr_max = 171, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120601}, up_stairs_item_num = 60, },
[120601] = {name = "龙牙邪神剑", lv = 60, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 2, main_attr_value = 855, deputy_attr_num = 5, deputy_attr_min = 199, deputy_attr_max = 199, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120651}, up_stairs_item_num = 65, },
[120651] = {name = "龙牙邪神剑", lv = 65, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 2, main_attr_value = 989, deputy_attr_num = 5, deputy_attr_min = 231, deputy_attr_max = 231, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120701}, up_stairs_item_num = 70, },
[120701] = {name = "龙牙邪神剑", lv = 70, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 2, main_attr_value = 1134, deputy_attr_num = 5, deputy_attr_min = 264, deputy_attr_max = 264, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120751}, up_stairs_item_num = 75, },
[120751] = {name = "龙牙邪神剑", lv = 75, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 2, main_attr_value = 1289, deputy_attr_num = 5, deputy_attr_min = 301, deputy_attr_max = 301, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120801}, up_stairs_item_num = 80, },
[120801] = {name = "龙牙邪神剑", lv = 80, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 2, main_attr_value = 1455, deputy_attr_num = 5, deputy_attr_min = 340, deputy_attr_max = 340, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120851}, up_stairs_item_num = 85, },
[120851] = {name = "龙牙邪神剑", lv = 85, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 2, main_attr_value = 1632, deputy_attr_num = 5, deputy_attr_min = 381, deputy_attr_max = 381, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120901}, up_stairs_item_num = 90, },
[120901] = {name = "龙牙邪神剑", lv = 90, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 2, main_attr_value = 1820, deputy_attr_num = 5, deputy_attr_min = 425, deputy_attr_max = 425, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120951}, up_stairs_item_num = 95, },
[120951] = {name = "龙牙邪神剑", lv = 95, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 2, main_attr_value = 2018, deputy_attr_num = 5, deputy_attr_min = 471, deputy_attr_max = 471, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121001}, up_stairs_item_num = 100, },
[121001] = {name = "龙牙邪神剑", lv = 100, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 2, main_attr_value = 2228, deputy_attr_num = 5, deputy_attr_min = 520, deputy_attr_max = 520, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121051}, up_stairs_item_num = 105, },
[121051] = {name = "龙牙邪神剑", lv = 105, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 2, main_attr_value = 2447, deputy_attr_num = 5, deputy_attr_min = 571, deputy_attr_max = 571, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121101}, up_stairs_item_num = 110, },
[121101] = {name = "龙牙邪神剑", lv = 110, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 2, main_attr_value = 2678, deputy_attr_num = 5, deputy_attr_min = 625, deputy_attr_max = 625, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121151}, up_stairs_item_num = 115, },
[121151] = {name = "龙牙邪神剑", lv = 115, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 2, main_attr_value = 2919, deputy_attr_num = 5, deputy_attr_min = 681, deputy_attr_max = 681, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121201}, up_stairs_item_num = 120, },
[121201] = {name = "龙牙邪神剑", lv = 120, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 2, main_attr_value = 3171, deputy_attr_num = 5, deputy_attr_min = 740, deputy_attr_max = 740, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121251}, up_stairs_item_num = 125, },
[121251] = {name = "龙牙邪神剑", lv = 125, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 2, main_attr_value = 3434, deputy_attr_num = 5, deputy_attr_min = 801, deputy_attr_max = 801, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121301}, up_stairs_item_num = 130, },
[121301] = {name = "龙牙邪神剑", lv = 130, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 2, main_attr_value = 3708, deputy_attr_num = 5, deputy_attr_min = 865, deputy_attr_max = 865, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121351}, up_stairs_item_num = 135, },
[121351] = {name = "龙牙邪神剑", lv = 135, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 2, main_attr_value = 3992, deputy_attr_num = 5, deputy_attr_min = 931, deputy_attr_max = 931, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121401}, up_stairs_item_num = 140, },
[121401] = {name = "龙牙邪神剑", lv = 140, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 2, main_attr_value = 4287, deputy_attr_num = 5, deputy_attr_min = 1000, deputy_attr_max = 1000, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121451}, up_stairs_item_num = 145, },
[121451] = {name = "龙牙邪神剑", lv = 145, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 2, main_attr_value = 4592, deputy_attr_num = 5, deputy_attr_min = 1072, deputy_attr_max = 1072, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121501}, up_stairs_item_num = 150, },
[121501] = {name = "龙牙邪神剑", lv = 150, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 2, main_attr_value = 4909, deputy_attr_num = 5, deputy_attr_min = 1145, deputy_attr_max = 1145, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121551}, up_stairs_item_num = 155, },
[121551] = {name = "龙牙邪神剑", lv = 155, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 2, main_attr_value = 5236, deputy_attr_num = 5, deputy_attr_min = 1222, deputy_attr_max = 1222, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121601}, up_stairs_item_num = 160, },
[121601] = {name = "龙牙邪神剑", lv = 160, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 2, main_attr_value = 5574, deputy_attr_num = 5, deputy_attr_min = 1301, deputy_attr_max = 1301, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121651}, up_stairs_item_num = 165, },
[121651] = {name = "龙牙邪神剑", lv = 165, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 2, main_attr_value = 5922, deputy_attr_num = 5, deputy_attr_min = 1382, deputy_attr_max = 1382, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121701}, up_stairs_item_num = 170, },
[121701] = {name = "龙牙邪神剑", lv = 170, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 2, main_attr_value = 6282, deputy_attr_num = 5, deputy_attr_min = 1466, deputy_attr_max = 1466, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121751}, up_stairs_item_num = 175, },
[121751] = {name = "龙牙邪神剑", lv = 175, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 2, main_attr_value = 6652, deputy_attr_num = 5, deputy_attr_min = 1552, deputy_attr_max = 1552, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121801}, up_stairs_item_num = 180, },
[121801] = {name = "龙牙邪神剑", lv = 180, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 2, main_attr_value = 7032, deputy_attr_num = 5, deputy_attr_min = 1641, deputy_attr_max = 1641, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121851}, up_stairs_item_num = 185, },
[121851] = {name = "龙牙邪神剑", lv = 185, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 2, main_attr_value = 7424, deputy_attr_num = 5, deputy_attr_min = 1732, deputy_attr_max = 1732, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121901}, up_stairs_item_num = 190, },
[121901] = {name = "龙牙邪神剑", lv = 190, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 2, main_attr_value = 7826, deputy_attr_num = 5, deputy_attr_min = 1826, deputy_attr_max = 1826, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121951}, up_stairs_item_num = 195, },
[121951] = {name = "龙牙邪神剑", lv = 195, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 2, main_attr_value = 8239, deputy_attr_num = 5, deputy_attr_min = 1922, deputy_attr_max = 1922, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {122001}, up_stairs_item_num = 200, },
[122001] = {name = "龙牙邪神剑", lv = 200, icon = 30041, _type = 0, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 2, main_attr_value = 8663, deputy_attr_num = 5, deputy_attr_min = 2021, deputy_attr_max = 2021, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[120012] = {name = "龙牙邪魔盔", lv = 1, icon = 30042, _type = 1, tile_num = 30, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 1, main_attr_value = 688, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120052}, up_stairs_item_num = 5, },
[120052] = {name = "龙牙邪魔盔", lv = 5, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 1, main_attr_value = 733, deputy_attr_num = 5, deputy_attr_min = 21, deputy_attr_max = 21, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120102}, up_stairs_item_num = 10, },
[120102] = {name = "龙牙邪魔盔", lv = 10, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 1, main_attr_value = 866, deputy_attr_num = 5, deputy_attr_min = 24, deputy_attr_max = 24, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120152}, up_stairs_item_num = 15, },
[120152] = {name = "龙牙邪魔盔", lv = 15, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 1, main_attr_value = 1090, deputy_attr_num = 5, deputy_attr_min = 31, deputy_attr_max = 31, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120202}, up_stairs_item_num = 20, },
[120202] = {name = "龙牙邪魔盔", lv = 20, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 1, main_attr_value = 1403, deputy_attr_num = 5, deputy_attr_min = 39, deputy_attr_max = 39, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120252}, up_stairs_item_num = 25, },
[120252] = {name = "龙牙邪魔盔", lv = 25, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 1, main_attr_value = 1805, deputy_attr_num = 5, deputy_attr_min = 51, deputy_attr_max = 51, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120302}, up_stairs_item_num = 30, },
[120302] = {name = "龙牙邪魔盔", lv = 30, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 1, main_attr_value = 2296, deputy_attr_num = 5, deputy_attr_min = 64, deputy_attr_max = 64, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120352}, up_stairs_item_num = 35, },
[120352] = {name = "龙牙邪魔盔", lv = 35, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 1, main_attr_value = 2878, deputy_attr_num = 5, deputy_attr_min = 81, deputy_attr_max = 81, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120402}, up_stairs_item_num = 40, },
[120402] = {name = "龙牙邪魔盔", lv = 40, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 1, main_attr_value = 3548, deputy_attr_num = 5, deputy_attr_min = 99, deputy_attr_max = 99, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120452}, up_stairs_item_num = 45, },
[120452] = {name = "龙牙邪魔盔", lv = 45, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 1, main_attr_value = 4308, deputy_attr_num = 5, deputy_attr_min = 121, deputy_attr_max = 121, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120502}, up_stairs_item_num = 50, },
[120502] = {name = "龙牙邪魔盔", lv = 50, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 1, main_attr_value = 5156, deputy_attr_num = 5, deputy_attr_min = 144, deputy_attr_max = 144, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120552}, up_stairs_item_num = 55, },
[120552] = {name = "龙牙邪魔盔", lv = 55, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 1, main_attr_value = 6095, deputy_attr_num = 5, deputy_attr_min = 171, deputy_attr_max = 171, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120602}, up_stairs_item_num = 60, },
[120602] = {name = "龙牙邪魔盔", lv = 60, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 1, main_attr_value = 7123, deputy_attr_num = 5, deputy_attr_min = 199, deputy_attr_max = 199, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120652}, up_stairs_item_num = 65, },
[120652] = {name = "龙牙邪魔盔", lv = 65, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 1, main_attr_value = 8240, deputy_attr_num = 5, deputy_attr_min = 231, deputy_attr_max = 231, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120702}, up_stairs_item_num = 70, },
[120702] = {name = "龙牙邪魔盔", lv = 70, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 1, main_attr_value = 9446, deputy_attr_num = 5, deputy_attr_min = 264, deputy_attr_max = 264, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120752}, up_stairs_item_num = 75, },
[120752] = {name = "龙牙邪魔盔", lv = 75, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 1, main_attr_value = 10743, deputy_attr_num = 5, deputy_attr_min = 301, deputy_attr_max = 301, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120802}, up_stairs_item_num = 80, },
[120802] = {name = "龙牙邪魔盔", lv = 80, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 1, main_attr_value = 12128, deputy_attr_num = 5, deputy_attr_min = 340, deputy_attr_max = 340, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120852}, up_stairs_item_num = 85, },
[120852] = {name = "龙牙邪魔盔", lv = 85, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 1, main_attr_value = 13603, deputy_attr_num = 5, deputy_attr_min = 381, deputy_attr_max = 381, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120902}, up_stairs_item_num = 90, },
[120902] = {name = "龙牙邪魔盔", lv = 90, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 1, main_attr_value = 15166, deputy_attr_num = 5, deputy_attr_min = 425, deputy_attr_max = 425, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120952}, up_stairs_item_num = 95, },
[120952] = {name = "龙牙邪魔盔", lv = 95, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 1, main_attr_value = 16820, deputy_attr_num = 5, deputy_attr_min = 471, deputy_attr_max = 471, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121002}, up_stairs_item_num = 100, },
[121002] = {name = "龙牙邪魔盔", lv = 100, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 1, main_attr_value = 18563, deputy_attr_num = 5, deputy_attr_min = 520, deputy_attr_max = 520, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121052}, up_stairs_item_num = 105, },
[121052] = {name = "龙牙邪魔盔", lv = 105, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 1, main_attr_value = 20395, deputy_attr_num = 5, deputy_attr_min = 571, deputy_attr_max = 571, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121102}, up_stairs_item_num = 110, },
[121102] = {name = "龙牙邪魔盔", lv = 110, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 1, main_attr_value = 22316, deputy_attr_num = 5, deputy_attr_min = 625, deputy_attr_max = 625, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121152}, up_stairs_item_num = 115, },
[121152] = {name = "龙牙邪魔盔", lv = 115, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 1, main_attr_value = 24328, deputy_attr_num = 5, deputy_attr_min = 681, deputy_attr_max = 681, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121202}, up_stairs_item_num = 120, },
[121202] = {name = "龙牙邪魔盔", lv = 120, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 1, main_attr_value = 26428, deputy_attr_num = 5, deputy_attr_min = 740, deputy_attr_max = 740, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121252}, up_stairs_item_num = 125, },
[121252] = {name = "龙牙邪魔盔", lv = 125, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 1, main_attr_value = 28618, deputy_attr_num = 5, deputy_attr_min = 801, deputy_attr_max = 801, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121302}, up_stairs_item_num = 130, },
[121302] = {name = "龙牙邪魔盔", lv = 130, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 1, main_attr_value = 30896, deputy_attr_num = 5, deputy_attr_min = 865, deputy_attr_max = 865, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121352}, up_stairs_item_num = 135, },
[121352] = {name = "龙牙邪魔盔", lv = 135, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 1, main_attr_value = 33265, deputy_attr_num = 5, deputy_attr_min = 931, deputy_attr_max = 931, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121402}, up_stairs_item_num = 140, },
[121402] = {name = "龙牙邪魔盔", lv = 140, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 1, main_attr_value = 35723, deputy_attr_num = 5, deputy_attr_min = 1000, deputy_attr_max = 1000, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121452}, up_stairs_item_num = 145, },
[121452] = {name = "龙牙邪魔盔", lv = 145, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 1, main_attr_value = 38270, deputy_attr_num = 5, deputy_attr_min = 1072, deputy_attr_max = 1072, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121502}, up_stairs_item_num = 150, },
[121502] = {name = "龙牙邪魔盔", lv = 150, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 1, main_attr_value = 40906, deputy_attr_num = 5, deputy_attr_min = 1145, deputy_attr_max = 1145, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121552}, up_stairs_item_num = 155, },
[121552] = {name = "龙牙邪魔盔", lv = 155, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 1, main_attr_value = 43633, deputy_attr_num = 5, deputy_attr_min = 1222, deputy_attr_max = 1222, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121602}, up_stairs_item_num = 160, },
[121602] = {name = "龙牙邪魔盔", lv = 160, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 1, main_attr_value = 46448, deputy_attr_num = 5, deputy_attr_min = 1301, deputy_attr_max = 1301, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121652}, up_stairs_item_num = 165, },
[121652] = {name = "龙牙邪魔盔", lv = 165, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 1, main_attr_value = 49353, deputy_attr_num = 5, deputy_attr_min = 1382, deputy_attr_max = 1382, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121702}, up_stairs_item_num = 170, },
[121702] = {name = "龙牙邪魔盔", lv = 170, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 1, main_attr_value = 52346, deputy_attr_num = 5, deputy_attr_min = 1466, deputy_attr_max = 1466, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121752}, up_stairs_item_num = 175, },
[121752] = {name = "龙牙邪魔盔", lv = 175, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 1, main_attr_value = 55430, deputy_attr_num = 5, deputy_attr_min = 1552, deputy_attr_max = 1552, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121802}, up_stairs_item_num = 180, },
[121802] = {name = "龙牙邪魔盔", lv = 180, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 1, main_attr_value = 58603, deputy_attr_num = 5, deputy_attr_min = 1641, deputy_attr_max = 1641, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121852}, up_stairs_item_num = 185, },
[121852] = {name = "龙牙邪魔盔", lv = 185, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 1, main_attr_value = 61865, deputy_attr_num = 5, deputy_attr_min = 1732, deputy_attr_max = 1732, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121902}, up_stairs_item_num = 190, },
[121902] = {name = "龙牙邪魔盔", lv = 190, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 1, main_attr_value = 65216, deputy_attr_num = 5, deputy_attr_min = 1826, deputy_attr_max = 1826, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121952}, up_stairs_item_num = 195, },
[121952] = {name = "龙牙邪魔盔", lv = 195, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 1, main_attr_value = 68658, deputy_attr_num = 5, deputy_attr_min = 1922, deputy_attr_max = 1922, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {122002}, up_stairs_item_num = 200, },
[122002] = {name = "龙牙邪魔盔", lv = 200, icon = 30042, _type = 1, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 1, main_attr_value = 72188, deputy_attr_num = 5, deputy_attr_min = 2021, deputy_attr_max = 2021, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[120013] = {name = "龙牙邪王甲", lv = 1, icon = 30043, _type = 2, tile_num = 30, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 6, main_attr_value = 28, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120053}, up_stairs_item_num = 5, },
[120053] = {name = "龙牙邪王甲", lv = 5, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 6, main_attr_value = 29, deputy_attr_num = 5, deputy_attr_min = 21, deputy_attr_max = 21, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120103}, up_stairs_item_num = 10, },
[120103] = {name = "龙牙邪王甲", lv = 10, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 6, main_attr_value = 35, deputy_attr_num = 5, deputy_attr_min = 24, deputy_attr_max = 24, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120153}, up_stairs_item_num = 15, },
[120153] = {name = "龙牙邪王甲", lv = 15, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 6, main_attr_value = 44, deputy_attr_num = 5, deputy_attr_min = 31, deputy_attr_max = 31, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120203}, up_stairs_item_num = 20, },
[120203] = {name = "龙牙邪王甲", lv = 20, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 6, main_attr_value = 56, deputy_attr_num = 5, deputy_attr_min = 39, deputy_attr_max = 39, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120253}, up_stairs_item_num = 25, },
[120253] = {name = "龙牙邪王甲", lv = 25, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 6, main_attr_value = 72, deputy_attr_num = 5, deputy_attr_min = 51, deputy_attr_max = 51, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120303}, up_stairs_item_num = 30, },
[120303] = {name = "龙牙邪王甲", lv = 30, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 6, main_attr_value = 92, deputy_attr_num = 5, deputy_attr_min = 64, deputy_attr_max = 64, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120353}, up_stairs_item_num = 35, },
[120353] = {name = "龙牙邪王甲", lv = 35, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 6, main_attr_value = 115, deputy_attr_num = 5, deputy_attr_min = 81, deputy_attr_max = 81, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120403}, up_stairs_item_num = 40, },
[120403] = {name = "龙牙邪王甲", lv = 40, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 6, main_attr_value = 142, deputy_attr_num = 5, deputy_attr_min = 99, deputy_attr_max = 99, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120453}, up_stairs_item_num = 45, },
[120453] = {name = "龙牙邪王甲", lv = 45, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 6, main_attr_value = 172, deputy_attr_num = 5, deputy_attr_min = 121, deputy_attr_max = 121, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120503}, up_stairs_item_num = 50, },
[120503] = {name = "龙牙邪王甲", lv = 50, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 6, main_attr_value = 206, deputy_attr_num = 5, deputy_attr_min = 144, deputy_attr_max = 144, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120553}, up_stairs_item_num = 55, },
[120553] = {name = "龙牙邪王甲", lv = 55, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 6, main_attr_value = 244, deputy_attr_num = 5, deputy_attr_min = 171, deputy_attr_max = 171, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120603}, up_stairs_item_num = 60, },
[120603] = {name = "龙牙邪王甲", lv = 60, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 6, main_attr_value = 285, deputy_attr_num = 5, deputy_attr_min = 199, deputy_attr_max = 199, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120653}, up_stairs_item_num = 65, },
[120653] = {name = "龙牙邪王甲", lv = 65, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 6, main_attr_value = 330, deputy_attr_num = 5, deputy_attr_min = 231, deputy_attr_max = 231, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120703}, up_stairs_item_num = 70, },
[120703] = {name = "龙牙邪王甲", lv = 70, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 6, main_attr_value = 378, deputy_attr_num = 5, deputy_attr_min = 264, deputy_attr_max = 264, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120753}, up_stairs_item_num = 75, },
[120753] = {name = "龙牙邪王甲", lv = 75, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 6, main_attr_value = 430, deputy_attr_num = 5, deputy_attr_min = 301, deputy_attr_max = 301, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120803}, up_stairs_item_num = 80, },
[120803] = {name = "龙牙邪王甲", lv = 80, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 6, main_attr_value = 485, deputy_attr_num = 5, deputy_attr_min = 340, deputy_attr_max = 340, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120853}, up_stairs_item_num = 85, },
[120853] = {name = "龙牙邪王甲", lv = 85, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 6, main_attr_value = 544, deputy_attr_num = 5, deputy_attr_min = 381, deputy_attr_max = 381, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120903}, up_stairs_item_num = 90, },
[120903] = {name = "龙牙邪王甲", lv = 90, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 6, main_attr_value = 607, deputy_attr_num = 5, deputy_attr_min = 425, deputy_attr_max = 425, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120953}, up_stairs_item_num = 95, },
[120953] = {name = "龙牙邪王甲", lv = 95, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 6, main_attr_value = 673, deputy_attr_num = 5, deputy_attr_min = 471, deputy_attr_max = 471, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121003}, up_stairs_item_num = 100, },
[121003] = {name = "龙牙邪王甲", lv = 100, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 6, main_attr_value = 743, deputy_attr_num = 5, deputy_attr_min = 520, deputy_attr_max = 520, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121053}, up_stairs_item_num = 105, },
[121053] = {name = "龙牙邪王甲", lv = 105, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 6, main_attr_value = 816, deputy_attr_num = 5, deputy_attr_min = 571, deputy_attr_max = 571, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121103}, up_stairs_item_num = 110, },
[121103] = {name = "龙牙邪王甲", lv = 110, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 6, main_attr_value = 893, deputy_attr_num = 5, deputy_attr_min = 625, deputy_attr_max = 625, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121153}, up_stairs_item_num = 115, },
[121153] = {name = "龙牙邪王甲", lv = 115, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 6, main_attr_value = 973, deputy_attr_num = 5, deputy_attr_min = 681, deputy_attr_max = 681, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121203}, up_stairs_item_num = 120, },
[121203] = {name = "龙牙邪王甲", lv = 120, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 6, main_attr_value = 1057, deputy_attr_num = 5, deputy_attr_min = 740, deputy_attr_max = 740, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121253}, up_stairs_item_num = 125, },
[121253] = {name = "龙牙邪王甲", lv = 125, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 6, main_attr_value = 1145, deputy_attr_num = 5, deputy_attr_min = 801, deputy_attr_max = 801, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121303}, up_stairs_item_num = 130, },
[121303] = {name = "龙牙邪王甲", lv = 130, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 6, main_attr_value = 1236, deputy_attr_num = 5, deputy_attr_min = 865, deputy_attr_max = 865, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121353}, up_stairs_item_num = 135, },
[121353] = {name = "龙牙邪王甲", lv = 135, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 6, main_attr_value = 1331, deputy_attr_num = 5, deputy_attr_min = 931, deputy_attr_max = 931, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121403}, up_stairs_item_num = 140, },
[121403] = {name = "龙牙邪王甲", lv = 140, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 6, main_attr_value = 1429, deputy_attr_num = 5, deputy_attr_min = 1000, deputy_attr_max = 1000, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121453}, up_stairs_item_num = 145, },
[121453] = {name = "龙牙邪王甲", lv = 145, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 6, main_attr_value = 1531, deputy_attr_num = 5, deputy_attr_min = 1072, deputy_attr_max = 1072, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121503}, up_stairs_item_num = 150, },
[121503] = {name = "龙牙邪王甲", lv = 150, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 6, main_attr_value = 1636, deputy_attr_num = 5, deputy_attr_min = 1145, deputy_attr_max = 1145, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121553}, up_stairs_item_num = 155, },
[121553] = {name = "龙牙邪王甲", lv = 155, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 6, main_attr_value = 1745, deputy_attr_num = 5, deputy_attr_min = 1222, deputy_attr_max = 1222, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121603}, up_stairs_item_num = 160, },
[121603] = {name = "龙牙邪王甲", lv = 160, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 6, main_attr_value = 1858, deputy_attr_num = 5, deputy_attr_min = 1301, deputy_attr_max = 1301, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121653}, up_stairs_item_num = 165, },
[121653] = {name = "龙牙邪王甲", lv = 165, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 6, main_attr_value = 1974, deputy_attr_num = 5, deputy_attr_min = 1382, deputy_attr_max = 1382, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121703}, up_stairs_item_num = 170, },
[121703] = {name = "龙牙邪王甲", lv = 170, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 6, main_attr_value = 2094, deputy_attr_num = 5, deputy_attr_min = 1466, deputy_attr_max = 1466, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121753}, up_stairs_item_num = 175, },
[121753] = {name = "龙牙邪王甲", lv = 175, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 6, main_attr_value = 2217, deputy_attr_num = 5, deputy_attr_min = 1552, deputy_attr_max = 1552, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121803}, up_stairs_item_num = 180, },
[121803] = {name = "龙牙邪王甲", lv = 180, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 6, main_attr_value = 2344, deputy_attr_num = 5, deputy_attr_min = 1641, deputy_attr_max = 1641, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121853}, up_stairs_item_num = 185, },
[121853] = {name = "龙牙邪王甲", lv = 185, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 6, main_attr_value = 2475, deputy_attr_num = 5, deputy_attr_min = 1732, deputy_attr_max = 1732, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121903}, up_stairs_item_num = 190, },
[121903] = {name = "龙牙邪王甲", lv = 190, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 6, main_attr_value = 2609, deputy_attr_num = 5, deputy_attr_min = 1826, deputy_attr_max = 1826, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121953}, up_stairs_item_num = 195, },
[121953] = {name = "龙牙邪王甲", lv = 195, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 6, main_attr_value = 2746, deputy_attr_num = 5, deputy_attr_min = 1922, deputy_attr_max = 1922, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {122003}, up_stairs_item_num = 200, },
[122003] = {name = "龙牙邪王甲", lv = 200, icon = 30043, _type = 2, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 6, main_attr_value = 2888, deputy_attr_num = 5, deputy_attr_min = 2021, deputy_attr_max = 2021, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[120014] = {name = "龙牙邪帝靴", lv = 1, icon = 30044, _type = 3, tile_num = 30, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 7, main_attr_value = 28, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120054}, up_stairs_item_num = 5, },
[120054] = {name = "龙牙邪帝靴", lv = 5, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 7, main_attr_value = 29, deputy_attr_num = 5, deputy_attr_min = 21, deputy_attr_max = 21, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120104}, up_stairs_item_num = 10, },
[120104] = {name = "龙牙邪帝靴", lv = 10, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 7, main_attr_value = 35, deputy_attr_num = 5, deputy_attr_min = 24, deputy_attr_max = 24, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120154}, up_stairs_item_num = 15, },
[120154] = {name = "龙牙邪帝靴", lv = 15, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 7, main_attr_value = 44, deputy_attr_num = 5, deputy_attr_min = 31, deputy_attr_max = 31, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120204}, up_stairs_item_num = 20, },
[120204] = {name = "龙牙邪帝靴", lv = 20, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 7, main_attr_value = 56, deputy_attr_num = 5, deputy_attr_min = 39, deputy_attr_max = 39, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120254}, up_stairs_item_num = 25, },
[120254] = {name = "龙牙邪帝靴", lv = 25, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 7, main_attr_value = 72, deputy_attr_num = 5, deputy_attr_min = 51, deputy_attr_max = 51, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120304}, up_stairs_item_num = 30, },
[120304] = {name = "龙牙邪帝靴", lv = 30, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 7, main_attr_value = 92, deputy_attr_num = 5, deputy_attr_min = 64, deputy_attr_max = 64, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120354}, up_stairs_item_num = 35, },
[120354] = {name = "龙牙邪帝靴", lv = 35, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 7, main_attr_value = 115, deputy_attr_num = 5, deputy_attr_min = 81, deputy_attr_max = 81, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120404}, up_stairs_item_num = 40, },
[120404] = {name = "龙牙邪帝靴", lv = 40, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 7, main_attr_value = 142, deputy_attr_num = 5, deputy_attr_min = 99, deputy_attr_max = 99, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120454}, up_stairs_item_num = 45, },
[120454] = {name = "龙牙邪帝靴", lv = 45, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 7, main_attr_value = 172, deputy_attr_num = 5, deputy_attr_min = 121, deputy_attr_max = 121, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120504}, up_stairs_item_num = 50, },
[120504] = {name = "龙牙邪帝靴", lv = 50, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 7, main_attr_value = 206, deputy_attr_num = 5, deputy_attr_min = 144, deputy_attr_max = 144, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120554}, up_stairs_item_num = 55, },
[120554] = {name = "龙牙邪帝靴", lv = 55, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 7, main_attr_value = 244, deputy_attr_num = 5, deputy_attr_min = 171, deputy_attr_max = 171, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120604}, up_stairs_item_num = 60, },
[120604] = {name = "龙牙邪帝靴", lv = 60, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 7, main_attr_value = 285, deputy_attr_num = 5, deputy_attr_min = 199, deputy_attr_max = 199, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120654}, up_stairs_item_num = 65, },
[120654] = {name = "龙牙邪帝靴", lv = 65, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 7, main_attr_value = 330, deputy_attr_num = 5, deputy_attr_min = 231, deputy_attr_max = 231, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120704}, up_stairs_item_num = 70, },
[120704] = {name = "龙牙邪帝靴", lv = 70, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 7, main_attr_value = 378, deputy_attr_num = 5, deputy_attr_min = 264, deputy_attr_max = 264, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120754}, up_stairs_item_num = 75, },
[120754] = {name = "龙牙邪帝靴", lv = 75, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 7, main_attr_value = 430, deputy_attr_num = 5, deputy_attr_min = 301, deputy_attr_max = 301, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120804}, up_stairs_item_num = 80, },
[120804] = {name = "龙牙邪帝靴", lv = 80, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 7, main_attr_value = 485, deputy_attr_num = 5, deputy_attr_min = 340, deputy_attr_max = 340, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120854}, up_stairs_item_num = 85, },
[120854] = {name = "龙牙邪帝靴", lv = 85, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 7, main_attr_value = 544, deputy_attr_num = 5, deputy_attr_min = 381, deputy_attr_max = 381, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120904}, up_stairs_item_num = 90, },
[120904] = {name = "龙牙邪帝靴", lv = 90, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 7, main_attr_value = 607, deputy_attr_num = 5, deputy_attr_min = 425, deputy_attr_max = 425, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {120954}, up_stairs_item_num = 95, },
[120954] = {name = "龙牙邪帝靴", lv = 95, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 7, main_attr_value = 673, deputy_attr_num = 5, deputy_attr_min = 471, deputy_attr_max = 471, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121004}, up_stairs_item_num = 100, },
[121004] = {name = "龙牙邪帝靴", lv = 100, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 7, main_attr_value = 743, deputy_attr_num = 5, deputy_attr_min = 520, deputy_attr_max = 520, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121054}, up_stairs_item_num = 105, },
[121054] = {name = "龙牙邪帝靴", lv = 105, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 7, main_attr_value = 816, deputy_attr_num = 5, deputy_attr_min = 571, deputy_attr_max = 571, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121104}, up_stairs_item_num = 110, },
[121104] = {name = "龙牙邪帝靴", lv = 110, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 7, main_attr_value = 893, deputy_attr_num = 5, deputy_attr_min = 625, deputy_attr_max = 625, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121154}, up_stairs_item_num = 115, },
[121154] = {name = "龙牙邪帝靴", lv = 115, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 7, main_attr_value = 973, deputy_attr_num = 5, deputy_attr_min = 681, deputy_attr_max = 681, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121204}, up_stairs_item_num = 120, },
[121204] = {name = "龙牙邪帝靴", lv = 120, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 7, main_attr_value = 1057, deputy_attr_num = 5, deputy_attr_min = 740, deputy_attr_max = 740, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121254}, up_stairs_item_num = 125, },
[121254] = {name = "龙牙邪帝靴", lv = 125, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 7, main_attr_value = 1145, deputy_attr_num = 5, deputy_attr_min = 801, deputy_attr_max = 801, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121304}, up_stairs_item_num = 130, },
[121304] = {name = "龙牙邪帝靴", lv = 130, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 7, main_attr_value = 1236, deputy_attr_num = 5, deputy_attr_min = 865, deputy_attr_max = 865, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121354}, up_stairs_item_num = 135, },
[121354] = {name = "龙牙邪帝靴", lv = 135, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 7, main_attr_value = 1331, deputy_attr_num = 5, deputy_attr_min = 931, deputy_attr_max = 931, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121404}, up_stairs_item_num = 140, },
[121404] = {name = "龙牙邪帝靴", lv = 140, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 7, main_attr_value = 1429, deputy_attr_num = 5, deputy_attr_min = 1000, deputy_attr_max = 1000, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121454}, up_stairs_item_num = 145, },
[121454] = {name = "龙牙邪帝靴", lv = 145, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 7, main_attr_value = 1531, deputy_attr_num = 5, deputy_attr_min = 1072, deputy_attr_max = 1072, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121504}, up_stairs_item_num = 150, },
[121504] = {name = "龙牙邪帝靴", lv = 150, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 7, main_attr_value = 1636, deputy_attr_num = 5, deputy_attr_min = 1145, deputy_attr_max = 1145, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121554}, up_stairs_item_num = 155, },
[121554] = {name = "龙牙邪帝靴", lv = 155, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 7, main_attr_value = 1745, deputy_attr_num = 5, deputy_attr_min = 1222, deputy_attr_max = 1222, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121604}, up_stairs_item_num = 160, },
[121604] = {name = "龙牙邪帝靴", lv = 160, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 7, main_attr_value = 1858, deputy_attr_num = 5, deputy_attr_min = 1301, deputy_attr_max = 1301, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121654}, up_stairs_item_num = 165, },
[121654] = {name = "龙牙邪帝靴", lv = 165, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 7, main_attr_value = 1974, deputy_attr_num = 5, deputy_attr_min = 1382, deputy_attr_max = 1382, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121704}, up_stairs_item_num = 170, },
[121704] = {name = "龙牙邪帝靴", lv = 170, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 7, main_attr_value = 2094, deputy_attr_num = 5, deputy_attr_min = 1466, deputy_attr_max = 1466, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121754}, up_stairs_item_num = 175, },
[121754] = {name = "龙牙邪帝靴", lv = 175, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 7, main_attr_value = 2217, deputy_attr_num = 5, deputy_attr_min = 1552, deputy_attr_max = 1552, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121804}, up_stairs_item_num = 180, },
[121804] = {name = "龙牙邪帝靴", lv = 180, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 7, main_attr_value = 2344, deputy_attr_num = 5, deputy_attr_min = 1641, deputy_attr_max = 1641, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121854}, up_stairs_item_num = 185, },
[121854] = {name = "龙牙邪帝靴", lv = 185, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 7, main_attr_value = 2475, deputy_attr_num = 5, deputy_attr_min = 1732, deputy_attr_max = 1732, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121904}, up_stairs_item_num = 190, },
[121904] = {name = "龙牙邪帝靴", lv = 190, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 7, main_attr_value = 2609, deputy_attr_num = 5, deputy_attr_min = 1826, deputy_attr_max = 1826, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {121954}, up_stairs_item_num = 195, },
[121954] = {name = "龙牙邪帝靴", lv = 195, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 7, main_attr_value = 2746, deputy_attr_num = 5, deputy_attr_min = 1922, deputy_attr_max = 1922, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {122004}, up_stairs_item_num = 200, },
[122004] = {name = "龙牙邪帝靴", lv = 200, icon = 30044, _type = 3, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 7, main_attr_value = 2888, deputy_attr_num = 5, deputy_attr_min = 2021, deputy_attr_max = 2021, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[130011] = {name = "镇魔诛邪剑", lv = 1, icon = 30025, _type = 0, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 2, main_attr_value = 75, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130051}, up_stairs_item_num = 5, },
[130051] = {name = "镇魔诛邪剑", lv = 5, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 2, main_attr_value = 80, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130101}, up_stairs_item_num = 10, },
[130101] = {name = "镇魔诛邪剑", lv = 10, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 2, main_attr_value = 95, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130151}, up_stairs_item_num = 15, },
[130151] = {name = "镇魔诛邪剑", lv = 15, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 2, main_attr_value = 119, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130201}, up_stairs_item_num = 20, },
[130201] = {name = "镇魔诛邪剑", lv = 20, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 2, main_attr_value = 153, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130251}, up_stairs_item_num = 25, },
[130251] = {name = "镇魔诛邪剑", lv = 25, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 2, main_attr_value = 197, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130301}, up_stairs_item_num = 30, },
[130301] = {name = "镇魔诛邪剑", lv = 30, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 2, main_attr_value = 251, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130351}, up_stairs_item_num = 35, },
[130351] = {name = "镇魔诛邪剑", lv = 35, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 2, main_attr_value = 314, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130401}, up_stairs_item_num = 40, },
[130401] = {name = "镇魔诛邪剑", lv = 40, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 2, main_attr_value = 387, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130451}, up_stairs_item_num = 45, },
[130451] = {name = "镇魔诛邪剑", lv = 45, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 2, main_attr_value = 470, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130501}, up_stairs_item_num = 50, },
[130501] = {name = "镇魔诛邪剑", lv = 50, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 2, main_attr_value = 563, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130551}, up_stairs_item_num = 55, },
[130551] = {name = "镇魔诛邪剑", lv = 55, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 2, main_attr_value = 665, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130601}, up_stairs_item_num = 60, },
[130601] = {name = "镇魔诛邪剑", lv = 60, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 2, main_attr_value = 777, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130651}, up_stairs_item_num = 65, },
[130651] = {name = "镇魔诛邪剑", lv = 65, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 2, main_attr_value = 899, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130701}, up_stairs_item_num = 70, },
[130701] = {name = "镇魔诛邪剑", lv = 70, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 2, main_attr_value = 1031, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130751}, up_stairs_item_num = 75, },
[130751] = {name = "镇魔诛邪剑", lv = 75, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 2, main_attr_value = 1172, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130801}, up_stairs_item_num = 80, },
[130801] = {name = "镇魔诛邪剑", lv = 80, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 2, main_attr_value = 1323, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130851}, up_stairs_item_num = 85, },
[130851] = {name = "镇魔诛邪剑", lv = 85, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 2, main_attr_value = 1484, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130901}, up_stairs_item_num = 90, },
[130901] = {name = "镇魔诛邪剑", lv = 90, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 2, main_attr_value = 1655, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130951}, up_stairs_item_num = 95, },
[130951] = {name = "镇魔诛邪剑", lv = 95, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 2, main_attr_value = 1835, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131001}, up_stairs_item_num = 100, },
[131001] = {name = "镇魔诛邪剑", lv = 100, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 2, main_attr_value = 2025, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131051}, up_stairs_item_num = 105, },
[131051] = {name = "镇魔诛邪剑", lv = 105, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 2, main_attr_value = 2225, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131101}, up_stairs_item_num = 110, },
[131101] = {name = "镇魔诛邪剑", lv = 110, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 2, main_attr_value = 2435, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131151}, up_stairs_item_num = 115, },
[131151] = {name = "镇魔诛邪剑", lv = 115, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 2, main_attr_value = 2654, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131201}, up_stairs_item_num = 120, },
[131201] = {name = "镇魔诛邪剑", lv = 120, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 2, main_attr_value = 2883, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131251}, up_stairs_item_num = 125, },
[131251] = {name = "镇魔诛邪剑", lv = 125, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 2, main_attr_value = 3122, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131301}, up_stairs_item_num = 130, },
[131301] = {name = "镇魔诛邪剑", lv = 130, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 2, main_attr_value = 3371, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131351}, up_stairs_item_num = 135, },
[131351] = {name = "镇魔诛邪剑", lv = 135, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 2, main_attr_value = 3629, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131401}, up_stairs_item_num = 140, },
[131401] = {name = "镇魔诛邪剑", lv = 140, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 2, main_attr_value = 3897, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131451}, up_stairs_item_num = 145, },
[131451] = {name = "镇魔诛邪剑", lv = 145, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 2, main_attr_value = 4175, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131501}, up_stairs_item_num = 150, },
[131501] = {name = "镇魔诛邪剑", lv = 150, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 2, main_attr_value = 4463, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131551}, up_stairs_item_num = 155, },
[131551] = {name = "镇魔诛邪剑", lv = 155, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 2, main_attr_value = 4760, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131601}, up_stairs_item_num = 160, },
[131601] = {name = "镇魔诛邪剑", lv = 160, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 2, main_attr_value = 5067, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131651}, up_stairs_item_num = 165, },
[131651] = {name = "镇魔诛邪剑", lv = 165, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 2, main_attr_value = 5384, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131701}, up_stairs_item_num = 170, },
[131701] = {name = "镇魔诛邪剑", lv = 170, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 2, main_attr_value = 5711, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131751}, up_stairs_item_num = 175, },
[131751] = {name = "镇魔诛邪剑", lv = 175, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 2, main_attr_value = 6047, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131801}, up_stairs_item_num = 180, },
[131801] = {name = "镇魔诛邪剑", lv = 180, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 2, main_attr_value = 6393, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131851}, up_stairs_item_num = 185, },
[131851] = {name = "镇魔诛邪剑", lv = 185, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 2, main_attr_value = 6749, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131901}, up_stairs_item_num = 190, },
[131901] = {name = "镇魔诛邪剑", lv = 190, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 2, main_attr_value = 7115, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131951}, up_stairs_item_num = 195, },
[131951] = {name = "镇魔诛邪剑", lv = 195, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 2, main_attr_value = 7490, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {132001}, up_stairs_item_num = 200, },
[132001] = {name = "镇魔诛邪剑", lv = 200, icon = 30025, _type = 0, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 2, main_attr_value = 7875, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[130012] = {name = "丹青江山帽", lv = 1, icon = 30026, _type = 1, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 1, main_attr_value = 625, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130052}, up_stairs_item_num = 5, },
[130052] = {name = "丹青江山帽", lv = 5, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 1, main_attr_value = 666, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130102}, up_stairs_item_num = 10, },
[130102] = {name = "丹青江山帽", lv = 10, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 1, main_attr_value = 788, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130152}, up_stairs_item_num = 15, },
[130152] = {name = "丹青江山帽", lv = 15, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 1, main_attr_value = 991, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130202}, up_stairs_item_num = 20, },
[130202] = {name = "丹青江山帽", lv = 20, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 1, main_attr_value = 1275, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130252}, up_stairs_item_num = 25, },
[130252] = {name = "丹青江山帽", lv = 25, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 1, main_attr_value = 1641, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130302}, up_stairs_item_num = 30, },
[130302] = {name = "丹青江山帽", lv = 30, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 1, main_attr_value = 2088, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130352}, up_stairs_item_num = 35, },
[130352] = {name = "丹青江山帽", lv = 35, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 1, main_attr_value = 2616, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130402}, up_stairs_item_num = 40, },
[130402] = {name = "丹青江山帽", lv = 40, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 1, main_attr_value = 3225, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130452}, up_stairs_item_num = 45, },
[130452] = {name = "丹青江山帽", lv = 45, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 1, main_attr_value = 3916, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130502}, up_stairs_item_num = 50, },
[130502] = {name = "丹青江山帽", lv = 50, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 1, main_attr_value = 4688, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130552}, up_stairs_item_num = 55, },
[130552] = {name = "丹青江山帽", lv = 55, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 1, main_attr_value = 5541, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130602}, up_stairs_item_num = 60, },
[130602] = {name = "丹青江山帽", lv = 60, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 1, main_attr_value = 6475, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130652}, up_stairs_item_num = 65, },
[130652] = {name = "丹青江山帽", lv = 65, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 1, main_attr_value = 7491, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130702}, up_stairs_item_num = 70, },
[130702] = {name = "丹青江山帽", lv = 70, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 1, main_attr_value = 8588, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130752}, up_stairs_item_num = 75, },
[130752] = {name = "丹青江山帽", lv = 75, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 1, main_attr_value = 9766, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130802}, up_stairs_item_num = 80, },
[130802] = {name = "丹青江山帽", lv = 80, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 1, main_attr_value = 11025, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130852}, up_stairs_item_num = 85, },
[130852] = {name = "丹青江山帽", lv = 85, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 1, main_attr_value = 12366, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130902}, up_stairs_item_num = 90, },
[130902] = {name = "丹青江山帽", lv = 90, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 1, main_attr_value = 13788, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130952}, up_stairs_item_num = 95, },
[130952] = {name = "丹青江山帽", lv = 95, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 1, main_attr_value = 15291, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131002}, up_stairs_item_num = 100, },
[131002] = {name = "丹青江山帽", lv = 100, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 1, main_attr_value = 16875, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131052}, up_stairs_item_num = 105, },
[131052] = {name = "丹青江山帽", lv = 105, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 1, main_attr_value = 18541, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131102}, up_stairs_item_num = 110, },
[131102] = {name = "丹青江山帽", lv = 110, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 1, main_attr_value = 20288, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131152}, up_stairs_item_num = 115, },
[131152] = {name = "丹青江山帽", lv = 115, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 1, main_attr_value = 22116, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131202}, up_stairs_item_num = 120, },
[131202] = {name = "丹青江山帽", lv = 120, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 1, main_attr_value = 24025, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131252}, up_stairs_item_num = 125, },
[131252] = {name = "丹青江山帽", lv = 125, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 1, main_attr_value = 26016, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131302}, up_stairs_item_num = 130, },
[131302] = {name = "丹青江山帽", lv = 130, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 1, main_attr_value = 28088, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131352}, up_stairs_item_num = 135, },
[131352] = {name = "丹青江山帽", lv = 135, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 1, main_attr_value = 30241, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131402}, up_stairs_item_num = 140, },
[131402] = {name = "丹青江山帽", lv = 140, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 1, main_attr_value = 32475, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131452}, up_stairs_item_num = 145, },
[131452] = {name = "丹青江山帽", lv = 145, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 1, main_attr_value = 34791, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131502}, up_stairs_item_num = 150, },
[131502] = {name = "丹青江山帽", lv = 150, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 1, main_attr_value = 37188, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131552}, up_stairs_item_num = 155, },
[131552] = {name = "丹青江山帽", lv = 155, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 1, main_attr_value = 39666, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131602}, up_stairs_item_num = 160, },
[131602] = {name = "丹青江山帽", lv = 160, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 1, main_attr_value = 42225, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131652}, up_stairs_item_num = 165, },
[131652] = {name = "丹青江山帽", lv = 165, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 1, main_attr_value = 44866, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131702}, up_stairs_item_num = 170, },
[131702] = {name = "丹青江山帽", lv = 170, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 1, main_attr_value = 47588, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131752}, up_stairs_item_num = 175, },
[131752] = {name = "丹青江山帽", lv = 175, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 1, main_attr_value = 50391, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131802}, up_stairs_item_num = 180, },
[131802] = {name = "丹青江山帽", lv = 180, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 1, main_attr_value = 53275, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131852}, up_stairs_item_num = 185, },
[131852] = {name = "丹青江山帽", lv = 185, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 1, main_attr_value = 56241, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131902}, up_stairs_item_num = 190, },
[131902] = {name = "丹青江山帽", lv = 190, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 1, main_attr_value = 59288, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131952}, up_stairs_item_num = 195, },
[131952] = {name = "丹青江山帽", lv = 195, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 1, main_attr_value = 62416, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {132002}, up_stairs_item_num = 200, },
[132002] = {name = "丹青江山帽", lv = 200, icon = 30026, _type = 1, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 1, main_attr_value = 65625, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[130013] = {name = "彩石铸心甲", lv = 1, icon = 30027, _type = 2, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 6, main_attr_value = 25, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130053}, up_stairs_item_num = 5, },
[130053] = {name = "彩石铸心甲", lv = 5, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 6, main_attr_value = 27, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130103}, up_stairs_item_num = 10, },
[130103] = {name = "彩石铸心甲", lv = 10, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 6, main_attr_value = 32, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130153}, up_stairs_item_num = 15, },
[130153] = {name = "彩石铸心甲", lv = 15, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 6, main_attr_value = 40, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130203}, up_stairs_item_num = 20, },
[130203] = {name = "彩石铸心甲", lv = 20, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 6, main_attr_value = 51, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130253}, up_stairs_item_num = 25, },
[130253] = {name = "彩石铸心甲", lv = 25, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 6, main_attr_value = 66, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130303}, up_stairs_item_num = 30, },
[130303] = {name = "彩石铸心甲", lv = 30, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 6, main_attr_value = 84, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130353}, up_stairs_item_num = 35, },
[130353] = {name = "彩石铸心甲", lv = 35, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 6, main_attr_value = 105, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130403}, up_stairs_item_num = 40, },
[130403] = {name = "彩石铸心甲", lv = 40, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 6, main_attr_value = 129, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130453}, up_stairs_item_num = 45, },
[130453] = {name = "彩石铸心甲", lv = 45, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 6, main_attr_value = 157, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130503}, up_stairs_item_num = 50, },
[130503] = {name = "彩石铸心甲", lv = 50, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 6, main_attr_value = 188, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130553}, up_stairs_item_num = 55, },
[130553] = {name = "彩石铸心甲", lv = 55, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 6, main_attr_value = 222, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130603}, up_stairs_item_num = 60, },
[130603] = {name = "彩石铸心甲", lv = 60, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 6, main_attr_value = 259, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130653}, up_stairs_item_num = 65, },
[130653] = {name = "彩石铸心甲", lv = 65, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 6, main_attr_value = 300, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130703}, up_stairs_item_num = 70, },
[130703] = {name = "彩石铸心甲", lv = 70, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 6, main_attr_value = 344, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130753}, up_stairs_item_num = 75, },
[130753] = {name = "彩石铸心甲", lv = 75, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 6, main_attr_value = 391, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130803}, up_stairs_item_num = 80, },
[130803] = {name = "彩石铸心甲", lv = 80, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 6, main_attr_value = 441, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130853}, up_stairs_item_num = 85, },
[130853] = {name = "彩石铸心甲", lv = 85, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 6, main_attr_value = 495, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130903}, up_stairs_item_num = 90, },
[130903] = {name = "彩石铸心甲", lv = 90, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 6, main_attr_value = 552, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130953}, up_stairs_item_num = 95, },
[130953] = {name = "彩石铸心甲", lv = 95, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 6, main_attr_value = 612, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131003}, up_stairs_item_num = 100, },
[131003] = {name = "彩石铸心甲", lv = 100, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 6, main_attr_value = 675, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131053}, up_stairs_item_num = 105, },
[131053] = {name = "彩石铸心甲", lv = 105, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 6, main_attr_value = 742, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131103}, up_stairs_item_num = 110, },
[131103] = {name = "彩石铸心甲", lv = 110, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 6, main_attr_value = 812, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131153}, up_stairs_item_num = 115, },
[131153] = {name = "彩石铸心甲", lv = 115, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 6, main_attr_value = 885, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131203}, up_stairs_item_num = 120, },
[131203] = {name = "彩石铸心甲", lv = 120, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 6, main_attr_value = 961, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131253}, up_stairs_item_num = 125, },
[131253] = {name = "彩石铸心甲", lv = 125, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 6, main_attr_value = 1041, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131303}, up_stairs_item_num = 130, },
[131303] = {name = "彩石铸心甲", lv = 130, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 6, main_attr_value = 1124, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131353}, up_stairs_item_num = 135, },
[131353] = {name = "彩石铸心甲", lv = 135, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 6, main_attr_value = 1210, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131403}, up_stairs_item_num = 140, },
[131403] = {name = "彩石铸心甲", lv = 140, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 6, main_attr_value = 1299, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131453}, up_stairs_item_num = 145, },
[131453] = {name = "彩石铸心甲", lv = 145, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 6, main_attr_value = 1392, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131503}, up_stairs_item_num = 150, },
[131503] = {name = "彩石铸心甲", lv = 150, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 6, main_attr_value = 1488, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131553}, up_stairs_item_num = 155, },
[131553] = {name = "彩石铸心甲", lv = 155, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 6, main_attr_value = 1587, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131603}, up_stairs_item_num = 160, },
[131603] = {name = "彩石铸心甲", lv = 160, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 6, main_attr_value = 1689, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131653}, up_stairs_item_num = 165, },
[131653] = {name = "彩石铸心甲", lv = 165, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 6, main_attr_value = 1795, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131703}, up_stairs_item_num = 170, },
[131703] = {name = "彩石铸心甲", lv = 170, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 6, main_attr_value = 1904, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131753}, up_stairs_item_num = 175, },
[131753] = {name = "彩石铸心甲", lv = 175, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 6, main_attr_value = 2016, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131803}, up_stairs_item_num = 180, },
[131803] = {name = "彩石铸心甲", lv = 180, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 6, main_attr_value = 2131, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131853}, up_stairs_item_num = 185, },
[131853] = {name = "彩石铸心甲", lv = 185, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 6, main_attr_value = 2250, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131903}, up_stairs_item_num = 190, },
[131903] = {name = "彩石铸心甲", lv = 190, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 6, main_attr_value = 2372, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131953}, up_stairs_item_num = 195, },
[131953] = {name = "彩石铸心甲", lv = 195, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 6, main_attr_value = 2497, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {132003}, up_stairs_item_num = 200, },
[132003] = {name = "彩石铸心甲", lv = 200, icon = 30027, _type = 2, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 6, main_attr_value = 2625, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[130014] = {name = "巨神凌日靴", lv = 1, icon = 30028, _type = 3, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 7, main_attr_value = 25, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130054}, up_stairs_item_num = 5, },
[130054] = {name = "巨神凌日靴", lv = 5, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 7, main_attr_value = 27, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130104}, up_stairs_item_num = 10, },
[130104] = {name = "巨神凌日靴", lv = 10, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 7, main_attr_value = 32, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130154}, up_stairs_item_num = 15, },
[130154] = {name = "巨神凌日靴", lv = 15, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 7, main_attr_value = 40, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130204}, up_stairs_item_num = 20, },
[130204] = {name = "巨神凌日靴", lv = 20, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 7, main_attr_value = 51, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130254}, up_stairs_item_num = 25, },
[130254] = {name = "巨神凌日靴", lv = 25, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 7, main_attr_value = 66, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130304}, up_stairs_item_num = 30, },
[130304] = {name = "巨神凌日靴", lv = 30, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 7, main_attr_value = 84, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130354}, up_stairs_item_num = 35, },
[130354] = {name = "巨神凌日靴", lv = 35, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 7, main_attr_value = 105, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130404}, up_stairs_item_num = 40, },
[130404] = {name = "巨神凌日靴", lv = 40, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 7, main_attr_value = 129, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130454}, up_stairs_item_num = 45, },
[130454] = {name = "巨神凌日靴", lv = 45, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 7, main_attr_value = 157, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130504}, up_stairs_item_num = 50, },
[130504] = {name = "巨神凌日靴", lv = 50, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 7, main_attr_value = 188, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130554}, up_stairs_item_num = 55, },
[130554] = {name = "巨神凌日靴", lv = 55, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 7, main_attr_value = 222, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130604}, up_stairs_item_num = 60, },
[130604] = {name = "巨神凌日靴", lv = 60, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 7, main_attr_value = 259, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130654}, up_stairs_item_num = 65, },
[130654] = {name = "巨神凌日靴", lv = 65, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 7, main_attr_value = 300, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130704}, up_stairs_item_num = 70, },
[130704] = {name = "巨神凌日靴", lv = 70, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 7, main_attr_value = 344, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130754}, up_stairs_item_num = 75, },
[130754] = {name = "巨神凌日靴", lv = 75, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 7, main_attr_value = 391, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130804}, up_stairs_item_num = 80, },
[130804] = {name = "巨神凌日靴", lv = 80, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 7, main_attr_value = 441, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130854}, up_stairs_item_num = 85, },
[130854] = {name = "巨神凌日靴", lv = 85, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 7, main_attr_value = 495, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130904}, up_stairs_item_num = 90, },
[130904] = {name = "巨神凌日靴", lv = 90, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 7, main_attr_value = 552, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {130954}, up_stairs_item_num = 95, },
[130954] = {name = "巨神凌日靴", lv = 95, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 7, main_attr_value = 612, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131004}, up_stairs_item_num = 100, },
[131004] = {name = "巨神凌日靴", lv = 100, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 7, main_attr_value = 675, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131054}, up_stairs_item_num = 105, },
[131054] = {name = "巨神凌日靴", lv = 105, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 7, main_attr_value = 742, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131104}, up_stairs_item_num = 110, },
[131104] = {name = "巨神凌日靴", lv = 110, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 7, main_attr_value = 812, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131154}, up_stairs_item_num = 115, },
[131154] = {name = "巨神凌日靴", lv = 115, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 7, main_attr_value = 885, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131204}, up_stairs_item_num = 120, },
[131204] = {name = "巨神凌日靴", lv = 120, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 7, main_attr_value = 961, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131254}, up_stairs_item_num = 125, },
[131254] = {name = "巨神凌日靴", lv = 125, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 7, main_attr_value = 1041, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131304}, up_stairs_item_num = 130, },
[131304] = {name = "巨神凌日靴", lv = 130, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 7, main_attr_value = 1124, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131354}, up_stairs_item_num = 135, },
[131354] = {name = "巨神凌日靴", lv = 135, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 7, main_attr_value = 1210, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131404}, up_stairs_item_num = 140, },
[131404] = {name = "巨神凌日靴", lv = 140, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 7, main_attr_value = 1299, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131454}, up_stairs_item_num = 145, },
[131454] = {name = "巨神凌日靴", lv = 145, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 7, main_attr_value = 1392, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131504}, up_stairs_item_num = 150, },
[131504] = {name = "巨神凌日靴", lv = 150, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 7, main_attr_value = 1488, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131554}, up_stairs_item_num = 155, },
[131554] = {name = "巨神凌日靴", lv = 155, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 7, main_attr_value = 1587, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131604}, up_stairs_item_num = 160, },
[131604] = {name = "巨神凌日靴", lv = 160, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 7, main_attr_value = 1689, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131654}, up_stairs_item_num = 165, },
[131654] = {name = "巨神凌日靴", lv = 165, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 7, main_attr_value = 1795, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131704}, up_stairs_item_num = 170, },
[131704] = {name = "巨神凌日靴", lv = 170, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 7, main_attr_value = 1904, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131754}, up_stairs_item_num = 175, },
[131754] = {name = "巨神凌日靴", lv = 175, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 7, main_attr_value = 2016, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131804}, up_stairs_item_num = 180, },
[131804] = {name = "巨神凌日靴", lv = 180, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 7, main_attr_value = 2131, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131854}, up_stairs_item_num = 185, },
[131854] = {name = "巨神凌日靴", lv = 185, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 7, main_attr_value = 2250, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131904}, up_stairs_item_num = 190, },
[131904] = {name = "巨神凌日靴", lv = 190, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 7, main_attr_value = 2372, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {131954}, up_stairs_item_num = 195, },
[131954] = {name = "巨神凌日靴", lv = 195, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 7, main_attr_value = 2497, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {132004}, up_stairs_item_num = 200, },
[132004] = {name = "巨神凌日靴", lv = 200, icon = 30028, _type = 3, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 7, main_attr_value = 2625, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[140011] = {name = "梅花沥泉剑", lv = 1, icon = 30029, _type = 0, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 2, main_attr_value = 75, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140051}, up_stairs_item_num = 5, },
[140051] = {name = "梅花沥泉剑", lv = 5, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 2, main_attr_value = 80, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140101}, up_stairs_item_num = 10, },
[140101] = {name = "梅花沥泉剑", lv = 10, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 2, main_attr_value = 95, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140151}, up_stairs_item_num = 15, },
[140151] = {name = "梅花沥泉剑", lv = 15, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 2, main_attr_value = 119, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140201}, up_stairs_item_num = 20, },
[140201] = {name = "梅花沥泉剑", lv = 20, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 2, main_attr_value = 153, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140251}, up_stairs_item_num = 25, },
[140251] = {name = "梅花沥泉剑", lv = 25, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 2, main_attr_value = 197, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140301}, up_stairs_item_num = 30, },
[140301] = {name = "梅花沥泉剑", lv = 30, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 2, main_attr_value = 251, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140351}, up_stairs_item_num = 35, },
[140351] = {name = "梅花沥泉剑", lv = 35, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 2, main_attr_value = 314, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140401}, up_stairs_item_num = 40, },
[140401] = {name = "梅花沥泉剑", lv = 40, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 2, main_attr_value = 387, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140451}, up_stairs_item_num = 45, },
[140451] = {name = "梅花沥泉剑", lv = 45, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 2, main_attr_value = 470, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140501}, up_stairs_item_num = 50, },
[140501] = {name = "梅花沥泉剑", lv = 50, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 2, main_attr_value = 563, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140551}, up_stairs_item_num = 55, },
[140551] = {name = "梅花沥泉剑", lv = 55, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 2, main_attr_value = 665, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140601}, up_stairs_item_num = 60, },
[140601] = {name = "梅花沥泉剑", lv = 60, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 2, main_attr_value = 777, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140651}, up_stairs_item_num = 65, },
[140651] = {name = "梅花沥泉剑", lv = 65, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 2, main_attr_value = 899, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140701}, up_stairs_item_num = 70, },
[140701] = {name = "梅花沥泉剑", lv = 70, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 2, main_attr_value = 1031, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140751}, up_stairs_item_num = 75, },
[140751] = {name = "梅花沥泉剑", lv = 75, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 2, main_attr_value = 1172, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140801}, up_stairs_item_num = 80, },
[140801] = {name = "梅花沥泉剑", lv = 80, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 2, main_attr_value = 1323, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140851}, up_stairs_item_num = 85, },
[140851] = {name = "梅花沥泉剑", lv = 85, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 2, main_attr_value = 1484, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140901}, up_stairs_item_num = 90, },
[140901] = {name = "梅花沥泉剑", lv = 90, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 2, main_attr_value = 1655, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140951}, up_stairs_item_num = 95, },
[140951] = {name = "梅花沥泉剑", lv = 95, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 2, main_attr_value = 1835, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141001}, up_stairs_item_num = 100, },
[141001] = {name = "梅花沥泉剑", lv = 100, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 2, main_attr_value = 2025, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141051}, up_stairs_item_num = 105, },
[141051] = {name = "梅花沥泉剑", lv = 105, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 2, main_attr_value = 2225, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141101}, up_stairs_item_num = 110, },
[141101] = {name = "梅花沥泉剑", lv = 110, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 2, main_attr_value = 2435, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141151}, up_stairs_item_num = 115, },
[141151] = {name = "梅花沥泉剑", lv = 115, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 2, main_attr_value = 2654, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141201}, up_stairs_item_num = 120, },
[141201] = {name = "梅花沥泉剑", lv = 120, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 2, main_attr_value = 2883, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141251}, up_stairs_item_num = 125, },
[141251] = {name = "梅花沥泉剑", lv = 125, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 2, main_attr_value = 3122, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141301}, up_stairs_item_num = 130, },
[141301] = {name = "梅花沥泉剑", lv = 130, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 2, main_attr_value = 3371, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141351}, up_stairs_item_num = 135, },
[141351] = {name = "梅花沥泉剑", lv = 135, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 2, main_attr_value = 3629, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141401}, up_stairs_item_num = 140, },
[141401] = {name = "梅花沥泉剑", lv = 140, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 2, main_attr_value = 3897, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141451}, up_stairs_item_num = 145, },
[141451] = {name = "梅花沥泉剑", lv = 145, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 2, main_attr_value = 4175, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141501}, up_stairs_item_num = 150, },
[141501] = {name = "梅花沥泉剑", lv = 150, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 2, main_attr_value = 4463, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141551}, up_stairs_item_num = 155, },
[141551] = {name = "梅花沥泉剑", lv = 155, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 2, main_attr_value = 4760, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141601}, up_stairs_item_num = 160, },
[141601] = {name = "梅花沥泉剑", lv = 160, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 2, main_attr_value = 5067, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141651}, up_stairs_item_num = 165, },
[141651] = {name = "梅花沥泉剑", lv = 165, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 2, main_attr_value = 5384, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141701}, up_stairs_item_num = 170, },
[141701] = {name = "梅花沥泉剑", lv = 170, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 2, main_attr_value = 5711, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141751}, up_stairs_item_num = 175, },
[141751] = {name = "梅花沥泉剑", lv = 175, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 2, main_attr_value = 6047, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141801}, up_stairs_item_num = 180, },
[141801] = {name = "梅花沥泉剑", lv = 180, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 2, main_attr_value = 6393, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141851}, up_stairs_item_num = 185, },
[141851] = {name = "梅花沥泉剑", lv = 185, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 2, main_attr_value = 6749, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141901}, up_stairs_item_num = 190, },
[141901] = {name = "梅花沥泉剑", lv = 190, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 2, main_attr_value = 7115, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141951}, up_stairs_item_num = 195, },
[141951] = {name = "梅花沥泉剑", lv = 195, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 2, main_attr_value = 7490, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {142001}, up_stairs_item_num = 200, },
[142001] = {name = "梅花沥泉剑", lv = 200, icon = 30029, _type = 0, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 2, main_attr_value = 7875, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[140012] = {name = "寒风缀银盔", lv = 1, icon = 30030, _type = 1, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 1, main_attr_value = 625, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140052}, up_stairs_item_num = 5, },
[140052] = {name = "寒风缀银盔", lv = 5, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 1, main_attr_value = 666, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140102}, up_stairs_item_num = 10, },
[140102] = {name = "寒风缀银盔", lv = 10, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 1, main_attr_value = 788, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140152}, up_stairs_item_num = 15, },
[140152] = {name = "寒风缀银盔", lv = 15, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 1, main_attr_value = 991, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140202}, up_stairs_item_num = 20, },
[140202] = {name = "寒风缀银盔", lv = 20, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 1, main_attr_value = 1275, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140252}, up_stairs_item_num = 25, },
[140252] = {name = "寒风缀银盔", lv = 25, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 1, main_attr_value = 1641, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140302}, up_stairs_item_num = 30, },
[140302] = {name = "寒风缀银盔", lv = 30, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 1, main_attr_value = 2088, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140352}, up_stairs_item_num = 35, },
[140352] = {name = "寒风缀银盔", lv = 35, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 1, main_attr_value = 2616, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140402}, up_stairs_item_num = 40, },
[140402] = {name = "寒风缀银盔", lv = 40, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 1, main_attr_value = 3225, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140452}, up_stairs_item_num = 45, },
[140452] = {name = "寒风缀银盔", lv = 45, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 1, main_attr_value = 3916, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140502}, up_stairs_item_num = 50, },
[140502] = {name = "寒风缀银盔", lv = 50, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 1, main_attr_value = 4688, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140552}, up_stairs_item_num = 55, },
[140552] = {name = "寒风缀银盔", lv = 55, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 1, main_attr_value = 5541, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140602}, up_stairs_item_num = 60, },
[140602] = {name = "寒风缀银盔", lv = 60, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 1, main_attr_value = 6475, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140652}, up_stairs_item_num = 65, },
[140652] = {name = "寒风缀银盔", lv = 65, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 1, main_attr_value = 7491, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140702}, up_stairs_item_num = 70, },
[140702] = {name = "寒风缀银盔", lv = 70, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 1, main_attr_value = 8588, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140752}, up_stairs_item_num = 75, },
[140752] = {name = "寒风缀银盔", lv = 75, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 1, main_attr_value = 9766, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140802}, up_stairs_item_num = 80, },
[140802] = {name = "寒风缀银盔", lv = 80, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 1, main_attr_value = 11025, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140852}, up_stairs_item_num = 85, },
[140852] = {name = "寒风缀银盔", lv = 85, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 1, main_attr_value = 12366, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140902}, up_stairs_item_num = 90, },
[140902] = {name = "寒风缀银盔", lv = 90, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 1, main_attr_value = 13788, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140952}, up_stairs_item_num = 95, },
[140952] = {name = "寒风缀银盔", lv = 95, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 1, main_attr_value = 15291, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141002}, up_stairs_item_num = 100, },
[141002] = {name = "寒风缀银盔", lv = 100, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 1, main_attr_value = 16875, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141052}, up_stairs_item_num = 105, },
[141052] = {name = "寒风缀银盔", lv = 105, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 1, main_attr_value = 18541, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141102}, up_stairs_item_num = 110, },
[141102] = {name = "寒风缀银盔", lv = 110, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 1, main_attr_value = 20288, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141152}, up_stairs_item_num = 115, },
[141152] = {name = "寒风缀银盔", lv = 115, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 1, main_attr_value = 22116, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141202}, up_stairs_item_num = 120, },
[141202] = {name = "寒风缀银盔", lv = 120, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 1, main_attr_value = 24025, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141252}, up_stairs_item_num = 125, },
[141252] = {name = "寒风缀银盔", lv = 125, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 1, main_attr_value = 26016, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141302}, up_stairs_item_num = 130, },
[141302] = {name = "寒风缀银盔", lv = 130, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 1, main_attr_value = 28088, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141352}, up_stairs_item_num = 135, },
[141352] = {name = "寒风缀银盔", lv = 135, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 1, main_attr_value = 30241, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141402}, up_stairs_item_num = 140, },
[141402] = {name = "寒风缀银盔", lv = 140, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 1, main_attr_value = 32475, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141452}, up_stairs_item_num = 145, },
[141452] = {name = "寒风缀银盔", lv = 145, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 1, main_attr_value = 34791, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141502}, up_stairs_item_num = 150, },
[141502] = {name = "寒风缀银盔", lv = 150, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 1, main_attr_value = 37188, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141552}, up_stairs_item_num = 155, },
[141552] = {name = "寒风缀银盔", lv = 155, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 1, main_attr_value = 39666, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141602}, up_stairs_item_num = 160, },
[141602] = {name = "寒风缀银盔", lv = 160, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 1, main_attr_value = 42225, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141652}, up_stairs_item_num = 165, },
[141652] = {name = "寒风缀银盔", lv = 165, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 1, main_attr_value = 44866, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141702}, up_stairs_item_num = 170, },
[141702] = {name = "寒风缀银盔", lv = 170, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 1, main_attr_value = 47588, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141752}, up_stairs_item_num = 175, },
[141752] = {name = "寒风缀银盔", lv = 175, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 1, main_attr_value = 50391, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141802}, up_stairs_item_num = 180, },
[141802] = {name = "寒风缀银盔", lv = 180, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 1, main_attr_value = 53275, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141852}, up_stairs_item_num = 185, },
[141852] = {name = "寒风缀银盔", lv = 185, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 1, main_attr_value = 56241, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141902}, up_stairs_item_num = 190, },
[141902] = {name = "寒风缀银盔", lv = 190, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 1, main_attr_value = 59288, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141952}, up_stairs_item_num = 195, },
[141952] = {name = "寒风缀银盔", lv = 195, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 1, main_attr_value = 62416, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {142002}, up_stairs_item_num = 200, },
[142002] = {name = "寒风缀银盔", lv = 200, icon = 30030, _type = 1, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 1, main_attr_value = 65625, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[140013] = {name = "银缕镶金甲", lv = 1, icon = 30031, _type = 2, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 6, main_attr_value = 25, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140053}, up_stairs_item_num = 5, },
[140053] = {name = "银缕镶金甲", lv = 5, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 6, main_attr_value = 27, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140103}, up_stairs_item_num = 10, },
[140103] = {name = "银缕镶金甲", lv = 10, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 6, main_attr_value = 32, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140153}, up_stairs_item_num = 15, },
[140153] = {name = "银缕镶金甲", lv = 15, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 6, main_attr_value = 40, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140203}, up_stairs_item_num = 20, },
[140203] = {name = "银缕镶金甲", lv = 20, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 6, main_attr_value = 51, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140253}, up_stairs_item_num = 25, },
[140253] = {name = "银缕镶金甲", lv = 25, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 6, main_attr_value = 66, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140303}, up_stairs_item_num = 30, },
[140303] = {name = "银缕镶金甲", lv = 30, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 6, main_attr_value = 84, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140353}, up_stairs_item_num = 35, },
[140353] = {name = "银缕镶金甲", lv = 35, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 6, main_attr_value = 105, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140403}, up_stairs_item_num = 40, },
[140403] = {name = "银缕镶金甲", lv = 40, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 6, main_attr_value = 129, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140453}, up_stairs_item_num = 45, },
[140453] = {name = "银缕镶金甲", lv = 45, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 6, main_attr_value = 157, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140503}, up_stairs_item_num = 50, },
[140503] = {name = "银缕镶金甲", lv = 50, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 6, main_attr_value = 188, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140553}, up_stairs_item_num = 55, },
[140553] = {name = "银缕镶金甲", lv = 55, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 6, main_attr_value = 222, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140603}, up_stairs_item_num = 60, },
[140603] = {name = "银缕镶金甲", lv = 60, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 6, main_attr_value = 259, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140653}, up_stairs_item_num = 65, },
[140653] = {name = "银缕镶金甲", lv = 65, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 6, main_attr_value = 300, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140703}, up_stairs_item_num = 70, },
[140703] = {name = "银缕镶金甲", lv = 70, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 6, main_attr_value = 344, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140753}, up_stairs_item_num = 75, },
[140753] = {name = "银缕镶金甲", lv = 75, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 6, main_attr_value = 391, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140803}, up_stairs_item_num = 80, },
[140803] = {name = "银缕镶金甲", lv = 80, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 6, main_attr_value = 441, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140853}, up_stairs_item_num = 85, },
[140853] = {name = "银缕镶金甲", lv = 85, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 6, main_attr_value = 495, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140903}, up_stairs_item_num = 90, },
[140903] = {name = "银缕镶金甲", lv = 90, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 6, main_attr_value = 552, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140953}, up_stairs_item_num = 95, },
[140953] = {name = "银缕镶金甲", lv = 95, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 6, main_attr_value = 612, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141003}, up_stairs_item_num = 100, },
[141003] = {name = "银缕镶金甲", lv = 100, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 6, main_attr_value = 675, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141053}, up_stairs_item_num = 105, },
[141053] = {name = "银缕镶金甲", lv = 105, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 6, main_attr_value = 742, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141103}, up_stairs_item_num = 110, },
[141103] = {name = "银缕镶金甲", lv = 110, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 6, main_attr_value = 812, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141153}, up_stairs_item_num = 115, },
[141153] = {name = "银缕镶金甲", lv = 115, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 6, main_attr_value = 885, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141203}, up_stairs_item_num = 120, },
[141203] = {name = "银缕镶金甲", lv = 120, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 6, main_attr_value = 961, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141253}, up_stairs_item_num = 125, },
[141253] = {name = "银缕镶金甲", lv = 125, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 6, main_attr_value = 1041, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141303}, up_stairs_item_num = 130, },
[141303] = {name = "银缕镶金甲", lv = 130, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 6, main_attr_value = 1124, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141353}, up_stairs_item_num = 135, },
[141353] = {name = "银缕镶金甲", lv = 135, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 6, main_attr_value = 1210, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141403}, up_stairs_item_num = 140, },
[141403] = {name = "银缕镶金甲", lv = 140, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 6, main_attr_value = 1299, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141453}, up_stairs_item_num = 145, },
[141453] = {name = "银缕镶金甲", lv = 145, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 6, main_attr_value = 1392, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141503}, up_stairs_item_num = 150, },
[141503] = {name = "银缕镶金甲", lv = 150, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 6, main_attr_value = 1488, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141553}, up_stairs_item_num = 155, },
[141553] = {name = "银缕镶金甲", lv = 155, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 6, main_attr_value = 1587, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141603}, up_stairs_item_num = 160, },
[141603] = {name = "银缕镶金甲", lv = 160, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 6, main_attr_value = 1689, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141653}, up_stairs_item_num = 165, },
[141653] = {name = "银缕镶金甲", lv = 165, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 6, main_attr_value = 1795, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141703}, up_stairs_item_num = 170, },
[141703] = {name = "银缕镶金甲", lv = 170, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 6, main_attr_value = 1904, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141753}, up_stairs_item_num = 175, },
[141753] = {name = "银缕镶金甲", lv = 175, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 6, main_attr_value = 2016, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141803}, up_stairs_item_num = 180, },
[141803] = {name = "银缕镶金甲", lv = 180, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 6, main_attr_value = 2131, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141853}, up_stairs_item_num = 185, },
[141853] = {name = "银缕镶金甲", lv = 185, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 6, main_attr_value = 2250, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141903}, up_stairs_item_num = 190, },
[141903] = {name = "银缕镶金甲", lv = 190, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 6, main_attr_value = 2372, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141953}, up_stairs_item_num = 195, },
[141953] = {name = "银缕镶金甲", lv = 195, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 6, main_attr_value = 2497, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {142003}, up_stairs_item_num = 200, },
[142003] = {name = "银缕镶金甲", lv = 200, icon = 30031, _type = 2, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 6, main_attr_value = 2625, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[140014] = {name = "明光抹香靴", lv = 1, icon = 30032, _type = 3, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 7, main_attr_value = 25, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140054}, up_stairs_item_num = 5, },
[140054] = {name = "明光抹香靴", lv = 5, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 7, main_attr_value = 27, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140104}, up_stairs_item_num = 10, },
[140104] = {name = "明光抹香靴", lv = 10, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 7, main_attr_value = 32, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140154}, up_stairs_item_num = 15, },
[140154] = {name = "明光抹香靴", lv = 15, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 7, main_attr_value = 40, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140204}, up_stairs_item_num = 20, },
[140204] = {name = "明光抹香靴", lv = 20, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 7, main_attr_value = 51, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140254}, up_stairs_item_num = 25, },
[140254] = {name = "明光抹香靴", lv = 25, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 7, main_attr_value = 66, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140304}, up_stairs_item_num = 30, },
[140304] = {name = "明光抹香靴", lv = 30, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 7, main_attr_value = 84, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140354}, up_stairs_item_num = 35, },
[140354] = {name = "明光抹香靴", lv = 35, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 7, main_attr_value = 105, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140404}, up_stairs_item_num = 40, },
[140404] = {name = "明光抹香靴", lv = 40, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 7, main_attr_value = 129, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140454}, up_stairs_item_num = 45, },
[140454] = {name = "明光抹香靴", lv = 45, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 7, main_attr_value = 157, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140504}, up_stairs_item_num = 50, },
[140504] = {name = "明光抹香靴", lv = 50, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 7, main_attr_value = 188, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140554}, up_stairs_item_num = 55, },
[140554] = {name = "明光抹香靴", lv = 55, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 7, main_attr_value = 222, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140604}, up_stairs_item_num = 60, },
[140604] = {name = "明光抹香靴", lv = 60, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 7, main_attr_value = 259, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140654}, up_stairs_item_num = 65, },
[140654] = {name = "明光抹香靴", lv = 65, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 7, main_attr_value = 300, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140704}, up_stairs_item_num = 70, },
[140704] = {name = "明光抹香靴", lv = 70, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 7, main_attr_value = 344, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140754}, up_stairs_item_num = 75, },
[140754] = {name = "明光抹香靴", lv = 75, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 7, main_attr_value = 391, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140804}, up_stairs_item_num = 80, },
[140804] = {name = "明光抹香靴", lv = 80, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 7, main_attr_value = 441, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140854}, up_stairs_item_num = 85, },
[140854] = {name = "明光抹香靴", lv = 85, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 7, main_attr_value = 495, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140904}, up_stairs_item_num = 90, },
[140904] = {name = "明光抹香靴", lv = 90, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 7, main_attr_value = 552, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {140954}, up_stairs_item_num = 95, },
[140954] = {name = "明光抹香靴", lv = 95, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 7, main_attr_value = 612, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141004}, up_stairs_item_num = 100, },
[141004] = {name = "明光抹香靴", lv = 100, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 7, main_attr_value = 675, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141054}, up_stairs_item_num = 105, },
[141054] = {name = "明光抹香靴", lv = 105, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 7, main_attr_value = 742, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141104}, up_stairs_item_num = 110, },
[141104] = {name = "明光抹香靴", lv = 110, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 7, main_attr_value = 812, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141154}, up_stairs_item_num = 115, },
[141154] = {name = "明光抹香靴", lv = 115, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 7, main_attr_value = 885, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141204}, up_stairs_item_num = 120, },
[141204] = {name = "明光抹香靴", lv = 120, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 7, main_attr_value = 961, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141254}, up_stairs_item_num = 125, },
[141254] = {name = "明光抹香靴", lv = 125, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 7, main_attr_value = 1041, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141304}, up_stairs_item_num = 130, },
[141304] = {name = "明光抹香靴", lv = 130, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 7, main_attr_value = 1124, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141354}, up_stairs_item_num = 135, },
[141354] = {name = "明光抹香靴", lv = 135, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 7, main_attr_value = 1210, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141404}, up_stairs_item_num = 140, },
[141404] = {name = "明光抹香靴", lv = 140, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 7, main_attr_value = 1299, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141454}, up_stairs_item_num = 145, },
[141454] = {name = "明光抹香靴", lv = 145, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 7, main_attr_value = 1392, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141504}, up_stairs_item_num = 150, },
[141504] = {name = "明光抹香靴", lv = 150, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 7, main_attr_value = 1488, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141554}, up_stairs_item_num = 155, },
[141554] = {name = "明光抹香靴", lv = 155, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 7, main_attr_value = 1587, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141604}, up_stairs_item_num = 160, },
[141604] = {name = "明光抹香靴", lv = 160, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 7, main_attr_value = 1689, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141654}, up_stairs_item_num = 165, },
[141654] = {name = "明光抹香靴", lv = 165, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 7, main_attr_value = 1795, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141704}, up_stairs_item_num = 170, },
[141704] = {name = "明光抹香靴", lv = 170, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 7, main_attr_value = 1904, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141754}, up_stairs_item_num = 175, },
[141754] = {name = "明光抹香靴", lv = 175, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 7, main_attr_value = 2016, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141804}, up_stairs_item_num = 180, },
[141804] = {name = "明光抹香靴", lv = 180, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 7, main_attr_value = 2131, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141854}, up_stairs_item_num = 185, },
[141854] = {name = "明光抹香靴", lv = 185, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 7, main_attr_value = 2250, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141904}, up_stairs_item_num = 190, },
[141904] = {name = "明光抹香靴", lv = 190, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 7, main_attr_value = 2372, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {141954}, up_stairs_item_num = 195, },
[141954] = {name = "明光抹香靴", lv = 195, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 7, main_attr_value = 2497, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {142004}, up_stairs_item_num = 200, },
[142004] = {name = "明光抹香靴", lv = 200, icon = 30032, _type = 3, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 7, main_attr_value = 2625, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[150011] = {name = "青翼龙雀刀", lv = 1, icon = 30033, _type = 0, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 2, main_attr_value = 75, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150051}, up_stairs_item_num = 5, },
[150051] = {name = "青翼龙雀刀", lv = 5, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 2, main_attr_value = 80, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150101}, up_stairs_item_num = 10, },
[150101] = {name = "青翼龙雀刀", lv = 10, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 2, main_attr_value = 95, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150151}, up_stairs_item_num = 15, },
[150151] = {name = "青翼龙雀刀", lv = 15, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 2, main_attr_value = 119, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150201}, up_stairs_item_num = 20, },
[150201] = {name = "青翼龙雀刀", lv = 20, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 2, main_attr_value = 153, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150251}, up_stairs_item_num = 25, },
[150251] = {name = "青翼龙雀刀", lv = 25, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 2, main_attr_value = 197, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150301}, up_stairs_item_num = 30, },
[150301] = {name = "青翼龙雀刀", lv = 30, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 2, main_attr_value = 251, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150351}, up_stairs_item_num = 35, },
[150351] = {name = "青翼龙雀刀", lv = 35, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 2, main_attr_value = 314, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150401}, up_stairs_item_num = 40, },
[150401] = {name = "青翼龙雀刀", lv = 40, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 2, main_attr_value = 387, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150451}, up_stairs_item_num = 45, },
[150451] = {name = "青翼龙雀刀", lv = 45, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 2, main_attr_value = 470, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150501}, up_stairs_item_num = 50, },
[150501] = {name = "青翼龙雀刀", lv = 50, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 2, main_attr_value = 563, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150551}, up_stairs_item_num = 55, },
[150551] = {name = "青翼龙雀刀", lv = 55, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 2, main_attr_value = 665, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150601}, up_stairs_item_num = 60, },
[150601] = {name = "青翼龙雀刀", lv = 60, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 2, main_attr_value = 777, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150651}, up_stairs_item_num = 65, },
[150651] = {name = "青翼龙雀刀", lv = 65, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 2, main_attr_value = 899, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150701}, up_stairs_item_num = 70, },
[150701] = {name = "青翼龙雀刀", lv = 70, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 2, main_attr_value = 1031, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150751}, up_stairs_item_num = 75, },
[150751] = {name = "青翼龙雀刀", lv = 75, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 2, main_attr_value = 1172, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150801}, up_stairs_item_num = 80, },
[150801] = {name = "青翼龙雀刀", lv = 80, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 2, main_attr_value = 1323, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150851}, up_stairs_item_num = 85, },
[150851] = {name = "青翼龙雀刀", lv = 85, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 2, main_attr_value = 1484, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150901}, up_stairs_item_num = 90, },
[150901] = {name = "青翼龙雀刀", lv = 90, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 2, main_attr_value = 1655, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150951}, up_stairs_item_num = 95, },
[150951] = {name = "青翼龙雀刀", lv = 95, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 2, main_attr_value = 1835, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151001}, up_stairs_item_num = 100, },
[151001] = {name = "青翼龙雀刀", lv = 100, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 2, main_attr_value = 2025, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151051}, up_stairs_item_num = 105, },
[151051] = {name = "青翼龙雀刀", lv = 105, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 2, main_attr_value = 2225, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151101}, up_stairs_item_num = 110, },
[151101] = {name = "青翼龙雀刀", lv = 110, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 2, main_attr_value = 2435, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151151}, up_stairs_item_num = 115, },
[151151] = {name = "青翼龙雀刀", lv = 115, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 2, main_attr_value = 2654, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151201}, up_stairs_item_num = 120, },
[151201] = {name = "青翼龙雀刀", lv = 120, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 2, main_attr_value = 2883, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151251}, up_stairs_item_num = 125, },
[151251] = {name = "青翼龙雀刀", lv = 125, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 2, main_attr_value = 3122, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151301}, up_stairs_item_num = 130, },
[151301] = {name = "青翼龙雀刀", lv = 130, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 2, main_attr_value = 3371, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151351}, up_stairs_item_num = 135, },
[151351] = {name = "青翼龙雀刀", lv = 135, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 2, main_attr_value = 3629, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151401}, up_stairs_item_num = 140, },
[151401] = {name = "青翼龙雀刀", lv = 140, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 2, main_attr_value = 3897, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151451}, up_stairs_item_num = 145, },
[151451] = {name = "青翼龙雀刀", lv = 145, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 2, main_attr_value = 4175, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151501}, up_stairs_item_num = 150, },
[151501] = {name = "青翼龙雀刀", lv = 150, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 2, main_attr_value = 4463, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151551}, up_stairs_item_num = 155, },
[151551] = {name = "青翼龙雀刀", lv = 155, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 2, main_attr_value = 4760, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151601}, up_stairs_item_num = 160, },
[151601] = {name = "青翼龙雀刀", lv = 160, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 2, main_attr_value = 5067, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151651}, up_stairs_item_num = 165, },
[151651] = {name = "青翼龙雀刀", lv = 165, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 2, main_attr_value = 5384, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151701}, up_stairs_item_num = 170, },
[151701] = {name = "青翼龙雀刀", lv = 170, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 2, main_attr_value = 5711, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151751}, up_stairs_item_num = 175, },
[151751] = {name = "青翼龙雀刀", lv = 175, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 2, main_attr_value = 6047, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151801}, up_stairs_item_num = 180, },
[151801] = {name = "青翼龙雀刀", lv = 180, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 2, main_attr_value = 6393, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151851}, up_stairs_item_num = 185, },
[151851] = {name = "青翼龙雀刀", lv = 185, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 2, main_attr_value = 6749, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151901}, up_stairs_item_num = 190, },
[151901] = {name = "青翼龙雀刀", lv = 190, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 2, main_attr_value = 7115, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151951}, up_stairs_item_num = 195, },
[151951] = {name = "青翼龙雀刀", lv = 195, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 2, main_attr_value = 7490, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {152001}, up_stairs_item_num = 200, },
[152001] = {name = "青翼龙雀刀", lv = 200, icon = 30033, _type = 0, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 2, main_attr_value = 7875, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[150012] = {name = "蒸汽动能盔", lv = 1, icon = 30034, _type = 1, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 1, main_attr_value = 625, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150052}, up_stairs_item_num = 5, },
[150052] = {name = "蒸汽动能盔", lv = 5, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 1, main_attr_value = 666, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150102}, up_stairs_item_num = 10, },
[150102] = {name = "蒸汽动能盔", lv = 10, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 1, main_attr_value = 788, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150152}, up_stairs_item_num = 15, },
[150152] = {name = "蒸汽动能盔", lv = 15, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 1, main_attr_value = 991, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150202}, up_stairs_item_num = 20, },
[150202] = {name = "蒸汽动能盔", lv = 20, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 1, main_attr_value = 1275, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150252}, up_stairs_item_num = 25, },
[150252] = {name = "蒸汽动能盔", lv = 25, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 1, main_attr_value = 1641, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150302}, up_stairs_item_num = 30, },
[150302] = {name = "蒸汽动能盔", lv = 30, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 1, main_attr_value = 2088, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150352}, up_stairs_item_num = 35, },
[150352] = {name = "蒸汽动能盔", lv = 35, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 1, main_attr_value = 2616, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150402}, up_stairs_item_num = 40, },
[150402] = {name = "蒸汽动能盔", lv = 40, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 1, main_attr_value = 3225, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150452}, up_stairs_item_num = 45, },
[150452] = {name = "蒸汽动能盔", lv = 45, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 1, main_attr_value = 3916, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150502}, up_stairs_item_num = 50, },
[150502] = {name = "蒸汽动能盔", lv = 50, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 1, main_attr_value = 4688, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150552}, up_stairs_item_num = 55, },
[150552] = {name = "蒸汽动能盔", lv = 55, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 1, main_attr_value = 5541, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150602}, up_stairs_item_num = 60, },
[150602] = {name = "蒸汽动能盔", lv = 60, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 1, main_attr_value = 6475, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150652}, up_stairs_item_num = 65, },
[150652] = {name = "蒸汽动能盔", lv = 65, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 1, main_attr_value = 7491, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150702}, up_stairs_item_num = 70, },
[150702] = {name = "蒸汽动能盔", lv = 70, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 1, main_attr_value = 8588, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150752}, up_stairs_item_num = 75, },
[150752] = {name = "蒸汽动能盔", lv = 75, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 1, main_attr_value = 9766, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150802}, up_stairs_item_num = 80, },
[150802] = {name = "蒸汽动能盔", lv = 80, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 1, main_attr_value = 11025, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150852}, up_stairs_item_num = 85, },
[150852] = {name = "蒸汽动能盔", lv = 85, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 1, main_attr_value = 12366, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150902}, up_stairs_item_num = 90, },
[150902] = {name = "蒸汽动能盔", lv = 90, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 1, main_attr_value = 13788, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150952}, up_stairs_item_num = 95, },
[150952] = {name = "蒸汽动能盔", lv = 95, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 1, main_attr_value = 15291, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151002}, up_stairs_item_num = 100, },
[151002] = {name = "蒸汽动能盔", lv = 100, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 1, main_attr_value = 16875, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151052}, up_stairs_item_num = 105, },
[151052] = {name = "蒸汽动能盔", lv = 105, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 1, main_attr_value = 18541, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151102}, up_stairs_item_num = 110, },
[151102] = {name = "蒸汽动能盔", lv = 110, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 1, main_attr_value = 20288, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151152}, up_stairs_item_num = 115, },
[151152] = {name = "蒸汽动能盔", lv = 115, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 1, main_attr_value = 22116, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151202}, up_stairs_item_num = 120, },
[151202] = {name = "蒸汽动能盔", lv = 120, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 1, main_attr_value = 24025, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151252}, up_stairs_item_num = 125, },
[151252] = {name = "蒸汽动能盔", lv = 125, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 1, main_attr_value = 26016, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151302}, up_stairs_item_num = 130, },
[151302] = {name = "蒸汽动能盔", lv = 130, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 1, main_attr_value = 28088, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151352}, up_stairs_item_num = 135, },
[151352] = {name = "蒸汽动能盔", lv = 135, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 1, main_attr_value = 30241, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151402}, up_stairs_item_num = 140, },
[151402] = {name = "蒸汽动能盔", lv = 140, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 1, main_attr_value = 32475, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151452}, up_stairs_item_num = 145, },
[151452] = {name = "蒸汽动能盔", lv = 145, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 1, main_attr_value = 34791, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151502}, up_stairs_item_num = 150, },
[151502] = {name = "蒸汽动能盔", lv = 150, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 1, main_attr_value = 37188, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151552}, up_stairs_item_num = 155, },
[151552] = {name = "蒸汽动能盔", lv = 155, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 1, main_attr_value = 39666, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151602}, up_stairs_item_num = 160, },
[151602] = {name = "蒸汽动能盔", lv = 160, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 1, main_attr_value = 42225, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151652}, up_stairs_item_num = 165, },
[151652] = {name = "蒸汽动能盔", lv = 165, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 1, main_attr_value = 44866, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151702}, up_stairs_item_num = 170, },
[151702] = {name = "蒸汽动能盔", lv = 170, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 1, main_attr_value = 47588, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151752}, up_stairs_item_num = 175, },
[151752] = {name = "蒸汽动能盔", lv = 175, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 1, main_attr_value = 50391, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151802}, up_stairs_item_num = 180, },
[151802] = {name = "蒸汽动能盔", lv = 180, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 1, main_attr_value = 53275, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151852}, up_stairs_item_num = 185, },
[151852] = {name = "蒸汽动能盔", lv = 185, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 1, main_attr_value = 56241, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151902}, up_stairs_item_num = 190, },
[151902] = {name = "蒸汽动能盔", lv = 190, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 1, main_attr_value = 59288, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151952}, up_stairs_item_num = 195, },
[151952] = {name = "蒸汽动能盔", lv = 195, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 1, main_attr_value = 62416, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {152002}, up_stairs_item_num = 200, },
[152002] = {name = "蒸汽动能盔", lv = 200, icon = 30034, _type = 1, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 1, main_attr_value = 65625, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[150013] = {name = "兽披万灵铠", lv = 1, icon = 30035, _type = 2, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 6, main_attr_value = 25, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150053}, up_stairs_item_num = 5, },
[150053] = {name = "兽披万灵铠", lv = 5, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 6, main_attr_value = 27, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150103}, up_stairs_item_num = 10, },
[150103] = {name = "兽披万灵铠", lv = 10, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 6, main_attr_value = 32, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150153}, up_stairs_item_num = 15, },
[150153] = {name = "兽披万灵铠", lv = 15, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 6, main_attr_value = 40, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150203}, up_stairs_item_num = 20, },
[150203] = {name = "兽披万灵铠", lv = 20, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 6, main_attr_value = 51, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150253}, up_stairs_item_num = 25, },
[150253] = {name = "兽披万灵铠", lv = 25, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 6, main_attr_value = 66, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150303}, up_stairs_item_num = 30, },
[150303] = {name = "兽披万灵铠", lv = 30, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 6, main_attr_value = 84, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150353}, up_stairs_item_num = 35, },
[150353] = {name = "兽披万灵铠", lv = 35, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 6, main_attr_value = 105, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150403}, up_stairs_item_num = 40, },
[150403] = {name = "兽披万灵铠", lv = 40, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 6, main_attr_value = 129, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150453}, up_stairs_item_num = 45, },
[150453] = {name = "兽披万灵铠", lv = 45, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 6, main_attr_value = 157, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150503}, up_stairs_item_num = 50, },
[150503] = {name = "兽披万灵铠", lv = 50, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 6, main_attr_value = 188, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150553}, up_stairs_item_num = 55, },
[150553] = {name = "兽披万灵铠", lv = 55, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 6, main_attr_value = 222, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150603}, up_stairs_item_num = 60, },
[150603] = {name = "兽披万灵铠", lv = 60, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 6, main_attr_value = 259, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150653}, up_stairs_item_num = 65, },
[150653] = {name = "兽披万灵铠", lv = 65, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 6, main_attr_value = 300, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150703}, up_stairs_item_num = 70, },
[150703] = {name = "兽披万灵铠", lv = 70, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 6, main_attr_value = 344, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150753}, up_stairs_item_num = 75, },
[150753] = {name = "兽披万灵铠", lv = 75, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 6, main_attr_value = 391, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150803}, up_stairs_item_num = 80, },
[150803] = {name = "兽披万灵铠", lv = 80, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 6, main_attr_value = 441, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150853}, up_stairs_item_num = 85, },
[150853] = {name = "兽披万灵铠", lv = 85, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 6, main_attr_value = 495, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150903}, up_stairs_item_num = 90, },
[150903] = {name = "兽披万灵铠", lv = 90, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 6, main_attr_value = 552, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150953}, up_stairs_item_num = 95, },
[150953] = {name = "兽披万灵铠", lv = 95, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 6, main_attr_value = 612, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151003}, up_stairs_item_num = 100, },
[151003] = {name = "兽披万灵铠", lv = 100, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 6, main_attr_value = 675, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151053}, up_stairs_item_num = 105, },
[151053] = {name = "兽披万灵铠", lv = 105, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 6, main_attr_value = 742, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151103}, up_stairs_item_num = 110, },
[151103] = {name = "兽披万灵铠", lv = 110, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 6, main_attr_value = 812, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151153}, up_stairs_item_num = 115, },
[151153] = {name = "兽披万灵铠", lv = 115, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 6, main_attr_value = 885, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151203}, up_stairs_item_num = 120, },
[151203] = {name = "兽披万灵铠", lv = 120, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 6, main_attr_value = 961, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151253}, up_stairs_item_num = 125, },
[151253] = {name = "兽披万灵铠", lv = 125, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 6, main_attr_value = 1041, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151303}, up_stairs_item_num = 130, },
[151303] = {name = "兽披万灵铠", lv = 130, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 6, main_attr_value = 1124, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151353}, up_stairs_item_num = 135, },
[151353] = {name = "兽披万灵铠", lv = 135, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 6, main_attr_value = 1210, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151403}, up_stairs_item_num = 140, },
[151403] = {name = "兽披万灵铠", lv = 140, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 6, main_attr_value = 1299, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151453}, up_stairs_item_num = 145, },
[151453] = {name = "兽披万灵铠", lv = 145, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 6, main_attr_value = 1392, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151503}, up_stairs_item_num = 150, },
[151503] = {name = "兽披万灵铠", lv = 150, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 6, main_attr_value = 1488, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151553}, up_stairs_item_num = 155, },
[151553] = {name = "兽披万灵铠", lv = 155, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 6, main_attr_value = 1587, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151603}, up_stairs_item_num = 160, },
[151603] = {name = "兽披万灵铠", lv = 160, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 6, main_attr_value = 1689, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151653}, up_stairs_item_num = 165, },
[151653] = {name = "兽披万灵铠", lv = 165, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 6, main_attr_value = 1795, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151703}, up_stairs_item_num = 170, },
[151703] = {name = "兽披万灵铠", lv = 170, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 6, main_attr_value = 1904, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151753}, up_stairs_item_num = 175, },
[151753] = {name = "兽披万灵铠", lv = 175, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 6, main_attr_value = 2016, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151803}, up_stairs_item_num = 180, },
[151803] = {name = "兽披万灵铠", lv = 180, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 6, main_attr_value = 2131, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151853}, up_stairs_item_num = 185, },
[151853] = {name = "兽披万灵铠", lv = 185, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 6, main_attr_value = 2250, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151903}, up_stairs_item_num = 190, },
[151903] = {name = "兽披万灵铠", lv = 190, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 6, main_attr_value = 2372, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151953}, up_stairs_item_num = 195, },
[151953] = {name = "兽披万灵铠", lv = 195, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 6, main_attr_value = 2497, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {152003}, up_stairs_item_num = 200, },
[152003] = {name = "兽披万灵铠", lv = 200, icon = 30035, _type = 2, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 6, main_attr_value = 2625, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[150014] = {name = "云纹断金靴", lv = 1, icon = 30036, _type = 3, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 7, main_attr_value = 25, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150054}, up_stairs_item_num = 5, },
[150054] = {name = "云纹断金靴", lv = 5, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 7, main_attr_value = 27, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150104}, up_stairs_item_num = 10, },
[150104] = {name = "云纹断金靴", lv = 10, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 7, main_attr_value = 32, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150154}, up_stairs_item_num = 15, },
[150154] = {name = "云纹断金靴", lv = 15, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 7, main_attr_value = 40, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150204}, up_stairs_item_num = 20, },
[150204] = {name = "云纹断金靴", lv = 20, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 7, main_attr_value = 51, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150254}, up_stairs_item_num = 25, },
[150254] = {name = "云纹断金靴", lv = 25, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 7, main_attr_value = 66, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150304}, up_stairs_item_num = 30, },
[150304] = {name = "云纹断金靴", lv = 30, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 7, main_attr_value = 84, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150354}, up_stairs_item_num = 35, },
[150354] = {name = "云纹断金靴", lv = 35, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 7, main_attr_value = 105, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150404}, up_stairs_item_num = 40, },
[150404] = {name = "云纹断金靴", lv = 40, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 7, main_attr_value = 129, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150454}, up_stairs_item_num = 45, },
[150454] = {name = "云纹断金靴", lv = 45, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 7, main_attr_value = 157, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150504}, up_stairs_item_num = 50, },
[150504] = {name = "云纹断金靴", lv = 50, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 7, main_attr_value = 188, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150554}, up_stairs_item_num = 55, },
[150554] = {name = "云纹断金靴", lv = 55, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 7, main_attr_value = 222, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150604}, up_stairs_item_num = 60, },
[150604] = {name = "云纹断金靴", lv = 60, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 7, main_attr_value = 259, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150654}, up_stairs_item_num = 65, },
[150654] = {name = "云纹断金靴", lv = 65, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 7, main_attr_value = 300, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150704}, up_stairs_item_num = 70, },
[150704] = {name = "云纹断金靴", lv = 70, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 7, main_attr_value = 344, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150754}, up_stairs_item_num = 75, },
[150754] = {name = "云纹断金靴", lv = 75, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 7, main_attr_value = 391, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150804}, up_stairs_item_num = 80, },
[150804] = {name = "云纹断金靴", lv = 80, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 7, main_attr_value = 441, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150854}, up_stairs_item_num = 85, },
[150854] = {name = "云纹断金靴", lv = 85, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 7, main_attr_value = 495, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150904}, up_stairs_item_num = 90, },
[150904] = {name = "云纹断金靴", lv = 90, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 7, main_attr_value = 552, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {150954}, up_stairs_item_num = 95, },
[150954] = {name = "云纹断金靴", lv = 95, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 7, main_attr_value = 612, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151004}, up_stairs_item_num = 100, },
[151004] = {name = "云纹断金靴", lv = 100, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 7, main_attr_value = 675, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151054}, up_stairs_item_num = 105, },
[151054] = {name = "云纹断金靴", lv = 105, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 7, main_attr_value = 742, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151104}, up_stairs_item_num = 110, },
[151104] = {name = "云纹断金靴", lv = 110, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 7, main_attr_value = 812, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151154}, up_stairs_item_num = 115, },
[151154] = {name = "云纹断金靴", lv = 115, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 7, main_attr_value = 885, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151204}, up_stairs_item_num = 120, },
[151204] = {name = "云纹断金靴", lv = 120, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 7, main_attr_value = 961, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151254}, up_stairs_item_num = 125, },
[151254] = {name = "云纹断金靴", lv = 125, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 7, main_attr_value = 1041, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151304}, up_stairs_item_num = 130, },
[151304] = {name = "云纹断金靴", lv = 130, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 7, main_attr_value = 1124, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151354}, up_stairs_item_num = 135, },
[151354] = {name = "云纹断金靴", lv = 135, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 7, main_attr_value = 1210, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151404}, up_stairs_item_num = 140, },
[151404] = {name = "云纹断金靴", lv = 140, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 7, main_attr_value = 1299, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151454}, up_stairs_item_num = 145, },
[151454] = {name = "云纹断金靴", lv = 145, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 7, main_attr_value = 1392, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151504}, up_stairs_item_num = 150, },
[151504] = {name = "云纹断金靴", lv = 150, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 7, main_attr_value = 1488, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151554}, up_stairs_item_num = 155, },
[151554] = {name = "云纹断金靴", lv = 155, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 7, main_attr_value = 1587, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151604}, up_stairs_item_num = 160, },
[151604] = {name = "云纹断金靴", lv = 160, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 7, main_attr_value = 1689, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151654}, up_stairs_item_num = 165, },
[151654] = {name = "云纹断金靴", lv = 165, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 7, main_attr_value = 1795, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151704}, up_stairs_item_num = 170, },
[151704] = {name = "云纹断金靴", lv = 170, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 7, main_attr_value = 1904, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151754}, up_stairs_item_num = 175, },
[151754] = {name = "云纹断金靴", lv = 175, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 7, main_attr_value = 2016, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151804}, up_stairs_item_num = 180, },
[151804] = {name = "云纹断金靴", lv = 180, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 7, main_attr_value = 2131, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151854}, up_stairs_item_num = 185, },
[151854] = {name = "云纹断金靴", lv = 185, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 7, main_attr_value = 2250, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151904}, up_stairs_item_num = 190, },
[151904] = {name = "云纹断金靴", lv = 190, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 7, main_attr_value = 2372, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {151954}, up_stairs_item_num = 195, },
[151954] = {name = "云纹断金靴", lv = 195, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 7, main_attr_value = 2497, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {152004}, up_stairs_item_num = 200, },
[152004] = {name = "云纹断金靴", lv = 200, icon = 30036, _type = 3, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 7, main_attr_value = 2625, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[160011] = {name = "帝道赤霄刃", lv = 1, icon = 30037, _type = 0, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 2, main_attr_value = 75, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160051}, up_stairs_item_num = 5, },
[160051] = {name = "帝道赤霄刃", lv = 5, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 2, main_attr_value = 80, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160101}, up_stairs_item_num = 10, },
[160101] = {name = "帝道赤霄刃", lv = 10, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 2, main_attr_value = 95, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160151}, up_stairs_item_num = 15, },
[160151] = {name = "帝道赤霄刃", lv = 15, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 2, main_attr_value = 119, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160201}, up_stairs_item_num = 20, },
[160201] = {name = "帝道赤霄刃", lv = 20, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 2, main_attr_value = 153, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160251}, up_stairs_item_num = 25, },
[160251] = {name = "帝道赤霄刃", lv = 25, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 2, main_attr_value = 197, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160301}, up_stairs_item_num = 30, },
[160301] = {name = "帝道赤霄刃", lv = 30, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 2, main_attr_value = 251, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160351}, up_stairs_item_num = 35, },
[160351] = {name = "帝道赤霄刃", lv = 35, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 2, main_attr_value = 314, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160401}, up_stairs_item_num = 40, },
[160401] = {name = "帝道赤霄刃", lv = 40, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 2, main_attr_value = 387, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160451}, up_stairs_item_num = 45, },
[160451] = {name = "帝道赤霄刃", lv = 45, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 2, main_attr_value = 470, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160501}, up_stairs_item_num = 50, },
[160501] = {name = "帝道赤霄刃", lv = 50, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 2, main_attr_value = 563, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160551}, up_stairs_item_num = 55, },
[160551] = {name = "帝道赤霄刃", lv = 55, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 2, main_attr_value = 665, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160601}, up_stairs_item_num = 60, },
[160601] = {name = "帝道赤霄刃", lv = 60, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 2, main_attr_value = 777, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160651}, up_stairs_item_num = 65, },
[160651] = {name = "帝道赤霄刃", lv = 65, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 2, main_attr_value = 899, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160701}, up_stairs_item_num = 70, },
[160701] = {name = "帝道赤霄刃", lv = 70, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 2, main_attr_value = 1031, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160751}, up_stairs_item_num = 75, },
[160751] = {name = "帝道赤霄刃", lv = 75, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 2, main_attr_value = 1172, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160801}, up_stairs_item_num = 80, },
[160801] = {name = "帝道赤霄刃", lv = 80, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 2, main_attr_value = 1323, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160851}, up_stairs_item_num = 85, },
[160851] = {name = "帝道赤霄刃", lv = 85, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 2, main_attr_value = 1484, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160901}, up_stairs_item_num = 90, },
[160901] = {name = "帝道赤霄刃", lv = 90, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 2, main_attr_value = 1655, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160951}, up_stairs_item_num = 95, },
[160951] = {name = "帝道赤霄刃", lv = 95, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 2, main_attr_value = 1835, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161001}, up_stairs_item_num = 100, },
[161001] = {name = "帝道赤霄刃", lv = 100, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 2, main_attr_value = 2025, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161051}, up_stairs_item_num = 105, },
[161051] = {name = "帝道赤霄刃", lv = 105, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 2, main_attr_value = 2225, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161101}, up_stairs_item_num = 110, },
[161101] = {name = "帝道赤霄刃", lv = 110, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 2, main_attr_value = 2435, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161151}, up_stairs_item_num = 115, },
[161151] = {name = "帝道赤霄刃", lv = 115, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 2, main_attr_value = 2654, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161201}, up_stairs_item_num = 120, },
[161201] = {name = "帝道赤霄刃", lv = 120, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 2, main_attr_value = 2883, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161251}, up_stairs_item_num = 125, },
[161251] = {name = "帝道赤霄刃", lv = 125, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 2, main_attr_value = 3122, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161301}, up_stairs_item_num = 130, },
[161301] = {name = "帝道赤霄刃", lv = 130, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 2, main_attr_value = 3371, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161351}, up_stairs_item_num = 135, },
[161351] = {name = "帝道赤霄刃", lv = 135, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 2, main_attr_value = 3629, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161401}, up_stairs_item_num = 140, },
[161401] = {name = "帝道赤霄刃", lv = 140, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 2, main_attr_value = 3897, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161451}, up_stairs_item_num = 145, },
[161451] = {name = "帝道赤霄刃", lv = 145, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 2, main_attr_value = 4175, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161501}, up_stairs_item_num = 150, },
[161501] = {name = "帝道赤霄刃", lv = 150, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 2, main_attr_value = 4463, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161551}, up_stairs_item_num = 155, },
[161551] = {name = "帝道赤霄刃", lv = 155, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 2, main_attr_value = 4760, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161601}, up_stairs_item_num = 160, },
[161601] = {name = "帝道赤霄刃", lv = 160, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 2, main_attr_value = 5067, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161651}, up_stairs_item_num = 165, },
[161651] = {name = "帝道赤霄刃", lv = 165, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 2, main_attr_value = 5384, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161701}, up_stairs_item_num = 170, },
[161701] = {name = "帝道赤霄刃", lv = 170, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 2, main_attr_value = 5711, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161751}, up_stairs_item_num = 175, },
[161751] = {name = "帝道赤霄刃", lv = 175, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 2, main_attr_value = 6047, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161801}, up_stairs_item_num = 180, },
[161801] = {name = "帝道赤霄刃", lv = 180, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 2, main_attr_value = 6393, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161851}, up_stairs_item_num = 185, },
[161851] = {name = "帝道赤霄刃", lv = 185, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 2, main_attr_value = 6749, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161901}, up_stairs_item_num = 190, },
[161901] = {name = "帝道赤霄刃", lv = 190, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 2, main_attr_value = 7115, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161951}, up_stairs_item_num = 195, },
[161951] = {name = "帝道赤霄刃", lv = 195, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 2, main_attr_value = 7490, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {162001}, up_stairs_item_num = 200, },
[162001] = {name = "帝道赤霄刃", lv = 200, icon = 30037, _type = 0, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 2, main_attr_value = 7875, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[160012] = {name = "尘魔湮灭盔", lv = 1, icon = 30038, _type = 1, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 1, main_attr_value = 625, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160052}, up_stairs_item_num = 5, },
[160052] = {name = "尘魔湮灭盔", lv = 5, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 1, main_attr_value = 666, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160102}, up_stairs_item_num = 10, },
[160102] = {name = "尘魔湮灭盔", lv = 10, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 1, main_attr_value = 788, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160152}, up_stairs_item_num = 15, },
[160152] = {name = "尘魔湮灭盔", lv = 15, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 1, main_attr_value = 991, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160202}, up_stairs_item_num = 20, },
[160202] = {name = "尘魔湮灭盔", lv = 20, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 1, main_attr_value = 1275, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160252}, up_stairs_item_num = 25, },
[160252] = {name = "尘魔湮灭盔", lv = 25, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 1, main_attr_value = 1641, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160302}, up_stairs_item_num = 30, },
[160302] = {name = "尘魔湮灭盔", lv = 30, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 1, main_attr_value = 2088, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160352}, up_stairs_item_num = 35, },
[160352] = {name = "尘魔湮灭盔", lv = 35, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 1, main_attr_value = 2616, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160402}, up_stairs_item_num = 40, },
[160402] = {name = "尘魔湮灭盔", lv = 40, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 1, main_attr_value = 3225, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160452}, up_stairs_item_num = 45, },
[160452] = {name = "尘魔湮灭盔", lv = 45, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 1, main_attr_value = 3916, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160502}, up_stairs_item_num = 50, },
[160502] = {name = "尘魔湮灭盔", lv = 50, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 1, main_attr_value = 4688, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160552}, up_stairs_item_num = 55, },
[160552] = {name = "尘魔湮灭盔", lv = 55, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 1, main_attr_value = 5541, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160602}, up_stairs_item_num = 60, },
[160602] = {name = "尘魔湮灭盔", lv = 60, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 1, main_attr_value = 6475, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160652}, up_stairs_item_num = 65, },
[160652] = {name = "尘魔湮灭盔", lv = 65, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 1, main_attr_value = 7491, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160702}, up_stairs_item_num = 70, },
[160702] = {name = "尘魔湮灭盔", lv = 70, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 1, main_attr_value = 8588, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160752}, up_stairs_item_num = 75, },
[160752] = {name = "尘魔湮灭盔", lv = 75, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 1, main_attr_value = 9766, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160802}, up_stairs_item_num = 80, },
[160802] = {name = "尘魔湮灭盔", lv = 80, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 1, main_attr_value = 11025, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160852}, up_stairs_item_num = 85, },
[160852] = {name = "尘魔湮灭盔", lv = 85, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 1, main_attr_value = 12366, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160902}, up_stairs_item_num = 90, },
[160902] = {name = "尘魔湮灭盔", lv = 90, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 1, main_attr_value = 13788, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160952}, up_stairs_item_num = 95, },
[160952] = {name = "尘魔湮灭盔", lv = 95, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 1, main_attr_value = 15291, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161002}, up_stairs_item_num = 100, },
[161002] = {name = "尘魔湮灭盔", lv = 100, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 1, main_attr_value = 16875, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161052}, up_stairs_item_num = 105, },
[161052] = {name = "尘魔湮灭盔", lv = 105, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 1, main_attr_value = 18541, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161102}, up_stairs_item_num = 110, },
[161102] = {name = "尘魔湮灭盔", lv = 110, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 1, main_attr_value = 20288, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161152}, up_stairs_item_num = 115, },
[161152] = {name = "尘魔湮灭盔", lv = 115, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 1, main_attr_value = 22116, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161202}, up_stairs_item_num = 120, },
[161202] = {name = "尘魔湮灭盔", lv = 120, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 1, main_attr_value = 24025, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161252}, up_stairs_item_num = 125, },
[161252] = {name = "尘魔湮灭盔", lv = 125, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 1, main_attr_value = 26016, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161302}, up_stairs_item_num = 130, },
[161302] = {name = "尘魔湮灭盔", lv = 130, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 1, main_attr_value = 28088, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161352}, up_stairs_item_num = 135, },
[161352] = {name = "尘魔湮灭盔", lv = 135, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 1, main_attr_value = 30241, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161402}, up_stairs_item_num = 140, },
[161402] = {name = "尘魔湮灭盔", lv = 140, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 1, main_attr_value = 32475, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161452}, up_stairs_item_num = 145, },
[161452] = {name = "尘魔湮灭盔", lv = 145, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 1, main_attr_value = 34791, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161502}, up_stairs_item_num = 150, },
[161502] = {name = "尘魔湮灭盔", lv = 150, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 1, main_attr_value = 37188, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161552}, up_stairs_item_num = 155, },
[161552] = {name = "尘魔湮灭盔", lv = 155, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 1, main_attr_value = 39666, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161602}, up_stairs_item_num = 160, },
[161602] = {name = "尘魔湮灭盔", lv = 160, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 1, main_attr_value = 42225, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161652}, up_stairs_item_num = 165, },
[161652] = {name = "尘魔湮灭盔", lv = 165, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 1, main_attr_value = 44866, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161702}, up_stairs_item_num = 170, },
[161702] = {name = "尘魔湮灭盔", lv = 170, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 1, main_attr_value = 47588, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161752}, up_stairs_item_num = 175, },
[161752] = {name = "尘魔湮灭盔", lv = 175, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 1, main_attr_value = 50391, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161802}, up_stairs_item_num = 180, },
[161802] = {name = "尘魔湮灭盔", lv = 180, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 1, main_attr_value = 53275, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161852}, up_stairs_item_num = 185, },
[161852] = {name = "尘魔湮灭盔", lv = 185, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 1, main_attr_value = 56241, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161902}, up_stairs_item_num = 190, },
[161902] = {name = "尘魔湮灭盔", lv = 190, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 1, main_attr_value = 59288, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161952}, up_stairs_item_num = 195, },
[161952] = {name = "尘魔湮灭盔", lv = 195, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 1, main_attr_value = 62416, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {162002}, up_stairs_item_num = 200, },
[162002] = {name = "尘魔湮灭盔", lv = 200, icon = 30038, _type = 1, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 1, main_attr_value = 65625, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[160013] = {name = "红牙血色铠", lv = 1, icon = 30039, _type = 2, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 6, main_attr_value = 25, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160053}, up_stairs_item_num = 5, },
[160053] = {name = "红牙血色铠", lv = 5, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 6, main_attr_value = 27, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160103}, up_stairs_item_num = 10, },
[160103] = {name = "红牙血色铠", lv = 10, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 6, main_attr_value = 32, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160153}, up_stairs_item_num = 15, },
[160153] = {name = "红牙血色铠", lv = 15, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 6, main_attr_value = 40, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160203}, up_stairs_item_num = 20, },
[160203] = {name = "红牙血色铠", lv = 20, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 6, main_attr_value = 51, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160253}, up_stairs_item_num = 25, },
[160253] = {name = "红牙血色铠", lv = 25, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 6, main_attr_value = 66, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160303}, up_stairs_item_num = 30, },
[160303] = {name = "红牙血色铠", lv = 30, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 6, main_attr_value = 84, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160353}, up_stairs_item_num = 35, },
[160353] = {name = "红牙血色铠", lv = 35, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 6, main_attr_value = 105, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160403}, up_stairs_item_num = 40, },
[160403] = {name = "红牙血色铠", lv = 40, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 6, main_attr_value = 129, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160453}, up_stairs_item_num = 45, },
[160453] = {name = "红牙血色铠", lv = 45, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 6, main_attr_value = 157, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160503}, up_stairs_item_num = 50, },
[160503] = {name = "红牙血色铠", lv = 50, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 6, main_attr_value = 188, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160553}, up_stairs_item_num = 55, },
[160553] = {name = "红牙血色铠", lv = 55, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 6, main_attr_value = 222, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160603}, up_stairs_item_num = 60, },
[160603] = {name = "红牙血色铠", lv = 60, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 6, main_attr_value = 259, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160653}, up_stairs_item_num = 65, },
[160653] = {name = "红牙血色铠", lv = 65, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 6, main_attr_value = 300, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160703}, up_stairs_item_num = 70, },
[160703] = {name = "红牙血色铠", lv = 70, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 6, main_attr_value = 344, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160753}, up_stairs_item_num = 75, },
[160753] = {name = "红牙血色铠", lv = 75, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 6, main_attr_value = 391, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160803}, up_stairs_item_num = 80, },
[160803] = {name = "红牙血色铠", lv = 80, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 6, main_attr_value = 441, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160853}, up_stairs_item_num = 85, },
[160853] = {name = "红牙血色铠", lv = 85, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 6, main_attr_value = 495, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160903}, up_stairs_item_num = 90, },
[160903] = {name = "红牙血色铠", lv = 90, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 6, main_attr_value = 552, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160953}, up_stairs_item_num = 95, },
[160953] = {name = "红牙血色铠", lv = 95, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 6, main_attr_value = 612, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161003}, up_stairs_item_num = 100, },
[161003] = {name = "红牙血色铠", lv = 100, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 6, main_attr_value = 675, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161053}, up_stairs_item_num = 105, },
[161053] = {name = "红牙血色铠", lv = 105, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 6, main_attr_value = 742, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161103}, up_stairs_item_num = 110, },
[161103] = {name = "红牙血色铠", lv = 110, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 6, main_attr_value = 812, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161153}, up_stairs_item_num = 115, },
[161153] = {name = "红牙血色铠", lv = 115, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 6, main_attr_value = 885, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161203}, up_stairs_item_num = 120, },
[161203] = {name = "红牙血色铠", lv = 120, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 6, main_attr_value = 961, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161253}, up_stairs_item_num = 125, },
[161253] = {name = "红牙血色铠", lv = 125, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 6, main_attr_value = 1041, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161303}, up_stairs_item_num = 130, },
[161303] = {name = "红牙血色铠", lv = 130, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 6, main_attr_value = 1124, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161353}, up_stairs_item_num = 135, },
[161353] = {name = "红牙血色铠", lv = 135, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 6, main_attr_value = 1210, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161403}, up_stairs_item_num = 140, },
[161403] = {name = "红牙血色铠", lv = 140, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 6, main_attr_value = 1299, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161453}, up_stairs_item_num = 145, },
[161453] = {name = "红牙血色铠", lv = 145, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 6, main_attr_value = 1392, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161503}, up_stairs_item_num = 150, },
[161503] = {name = "红牙血色铠", lv = 150, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 6, main_attr_value = 1488, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161553}, up_stairs_item_num = 155, },
[161553] = {name = "红牙血色铠", lv = 155, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 6, main_attr_value = 1587, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161603}, up_stairs_item_num = 160, },
[161603] = {name = "红牙血色铠", lv = 160, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 6, main_attr_value = 1689, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161653}, up_stairs_item_num = 165, },
[161653] = {name = "红牙血色铠", lv = 165, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 6, main_attr_value = 1795, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161703}, up_stairs_item_num = 170, },
[161703] = {name = "红牙血色铠", lv = 170, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 6, main_attr_value = 1904, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161753}, up_stairs_item_num = 175, },
[161753] = {name = "红牙血色铠", lv = 175, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 6, main_attr_value = 2016, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161803}, up_stairs_item_num = 180, },
[161803] = {name = "红牙血色铠", lv = 180, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 6, main_attr_value = 2131, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161853}, up_stairs_item_num = 185, },
[161853] = {name = "红牙血色铠", lv = 185, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 6, main_attr_value = 2250, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161903}, up_stairs_item_num = 190, },
[161903] = {name = "红牙血色铠", lv = 190, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 6, main_attr_value = 2372, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161953}, up_stairs_item_num = 195, },
[161953] = {name = "红牙血色铠", lv = 195, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 6, main_attr_value = 2497, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {162003}, up_stairs_item_num = 200, },
[162003] = {name = "红牙血色铠", lv = 200, icon = 30039, _type = 2, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 6, main_attr_value = 2625, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },
[160014] = {name = "破道点风靴", lv = 1, icon = 30040, _type = 3, tile_num = 20, quality = 6, strengthen_price = 1200, swap_atk_price = 10000, main_attr_type = 7, main_attr_value = 25, deputy_attr_num = 5, deputy_attr_min = 18, deputy_attr_max = 18, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.024, extra_attr_max = 0.024, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160054}, up_stairs_item_num = 5, },
[160054] = {name = "破道点风靴", lv = 5, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 6000, swap_atk_price = 50000, main_attr_type = 7, main_attr_value = 27, deputy_attr_num = 5, deputy_attr_min = 19, deputy_attr_max = 19, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0264, extra_attr_max = 0.0264, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160104}, up_stairs_item_num = 10, },
[160104] = {name = "破道点风靴", lv = 10, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 12000, swap_atk_price = 100000, main_attr_type = 7, main_attr_value = 32, deputy_attr_num = 5, deputy_attr_min = 22, deputy_attr_max = 22, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0288, extra_attr_max = 0.0288, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160154}, up_stairs_item_num = 15, },
[160154] = {name = "破道点风靴", lv = 15, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 18000, swap_atk_price = 150000, main_attr_type = 7, main_attr_value = 40, deputy_attr_num = 5, deputy_attr_min = 28, deputy_attr_max = 28, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0312, extra_attr_max = 0.0312, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160204}, up_stairs_item_num = 20, },
[160204] = {name = "破道点风靴", lv = 20, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 24000, swap_atk_price = 200000, main_attr_type = 7, main_attr_value = 51, deputy_attr_num = 5, deputy_attr_min = 36, deputy_attr_max = 36, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0336, extra_attr_max = 0.0336, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160254}, up_stairs_item_num = 25, },
[160254] = {name = "破道点风靴", lv = 25, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 30000, swap_atk_price = 250000, main_attr_type = 7, main_attr_value = 66, deputy_attr_num = 5, deputy_attr_min = 46, deputy_attr_max = 46, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.036, extra_attr_max = 0.036, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160304}, up_stairs_item_num = 30, },
[160304] = {name = "破道点风靴", lv = 30, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 36000, swap_atk_price = 300000, main_attr_type = 7, main_attr_value = 84, deputy_attr_num = 5, deputy_attr_min = 58, deputy_attr_max = 58, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0384, extra_attr_max = 0.0384, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160354}, up_stairs_item_num = 35, },
[160354] = {name = "破道点风靴", lv = 35, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 42000, swap_atk_price = 350000, main_attr_type = 7, main_attr_value = 105, deputy_attr_num = 5, deputy_attr_min = 73, deputy_attr_max = 73, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0408, extra_attr_max = 0.0408, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160404}, up_stairs_item_num = 40, },
[160404] = {name = "破道点风靴", lv = 40, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 48000, swap_atk_price = 400000, main_attr_type = 7, main_attr_value = 129, deputy_attr_num = 5, deputy_attr_min = 90, deputy_attr_max = 90, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0432, extra_attr_max = 0.0432, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160454}, up_stairs_item_num = 45, },
[160454] = {name = "破道点风靴", lv = 45, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 54000, swap_atk_price = 450000, main_attr_type = 7, main_attr_value = 157, deputy_attr_num = 5, deputy_attr_min = 110, deputy_attr_max = 110, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0456, extra_attr_max = 0.0456, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160504}, up_stairs_item_num = 50, },
[160504] = {name = "破道点风靴", lv = 50, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 60000, swap_atk_price = 500000, main_attr_type = 7, main_attr_value = 188, deputy_attr_num = 5, deputy_attr_min = 131, deputy_attr_max = 131, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.048, extra_attr_max = 0.048, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160554}, up_stairs_item_num = 55, },
[160554] = {name = "破道点风靴", lv = 55, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 66000, swap_atk_price = 550000, main_attr_type = 7, main_attr_value = 222, deputy_attr_num = 5, deputy_attr_min = 155, deputy_attr_max = 155, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0504, extra_attr_max = 0.0504, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160604}, up_stairs_item_num = 60, },
[160604] = {name = "破道点风靴", lv = 60, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 72000, swap_atk_price = 600000, main_attr_type = 7, main_attr_value = 259, deputy_attr_num = 5, deputy_attr_min = 181, deputy_attr_max = 181, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0528, extra_attr_max = 0.0528, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160654}, up_stairs_item_num = 65, },
[160654] = {name = "破道点风靴", lv = 65, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 78000, swap_atk_price = 650000, main_attr_type = 7, main_attr_value = 300, deputy_attr_num = 5, deputy_attr_min = 210, deputy_attr_max = 210, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0552, extra_attr_max = 0.0552, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160704}, up_stairs_item_num = 70, },
[160704] = {name = "破道点风靴", lv = 70, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 84000, swap_atk_price = 700000, main_attr_type = 7, main_attr_value = 344, deputy_attr_num = 5, deputy_attr_min = 240, deputy_attr_max = 240, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0576, extra_attr_max = 0.0576, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160754}, up_stairs_item_num = 75, },
[160754] = {name = "破道点风靴", lv = 75, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 90000, swap_atk_price = 750000, main_attr_type = 7, main_attr_value = 391, deputy_attr_num = 5, deputy_attr_min = 273, deputy_attr_max = 273, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.06, extra_attr_max = 0.06, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160804}, up_stairs_item_num = 80, },
[160804] = {name = "破道点风靴", lv = 80, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 96000, swap_atk_price = 800000, main_attr_type = 7, main_attr_value = 441, deputy_attr_num = 5, deputy_attr_min = 309, deputy_attr_max = 309, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0624, extra_attr_max = 0.0624, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160854}, up_stairs_item_num = 85, },
[160854] = {name = "破道点风靴", lv = 85, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 102000, swap_atk_price = 850000, main_attr_type = 7, main_attr_value = 495, deputy_attr_num = 5, deputy_attr_min = 346, deputy_attr_max = 346, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0648, extra_attr_max = 0.0648, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160904}, up_stairs_item_num = 90, },
[160904] = {name = "破道点风靴", lv = 90, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 108000, swap_atk_price = 900000, main_attr_type = 7, main_attr_value = 552, deputy_attr_num = 5, deputy_attr_min = 386, deputy_attr_max = 386, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0672, extra_attr_max = 0.0672, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {160954}, up_stairs_item_num = 95, },
[160954] = {name = "破道点风靴", lv = 95, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 114000, swap_atk_price = 950000, main_attr_type = 7, main_attr_value = 612, deputy_attr_num = 5, deputy_attr_min = 428, deputy_attr_max = 428, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0696, extra_attr_max = 0.0696, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161004}, up_stairs_item_num = 100, },
[161004] = {name = "破道点风靴", lv = 100, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 120000, swap_atk_price = 1000000, main_attr_type = 7, main_attr_value = 675, deputy_attr_num = 5, deputy_attr_min = 473, deputy_attr_max = 473, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.072, extra_attr_max = 0.072, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161054}, up_stairs_item_num = 105, },
[161054] = {name = "破道点风靴", lv = 105, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 126000, swap_atk_price = 1050000, main_attr_type = 7, main_attr_value = 742, deputy_attr_num = 5, deputy_attr_min = 519, deputy_attr_max = 519, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0744, extra_attr_max = 0.0744, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161104}, up_stairs_item_num = 110, },
[161104] = {name = "破道点风靴", lv = 110, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 132000, swap_atk_price = 1100000, main_attr_type = 7, main_attr_value = 812, deputy_attr_num = 5, deputy_attr_min = 568, deputy_attr_max = 568, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0768, extra_attr_max = 0.0768, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161154}, up_stairs_item_num = 115, },
[161154] = {name = "破道点风靴", lv = 115, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 138000, swap_atk_price = 1150000, main_attr_type = 7, main_attr_value = 885, deputy_attr_num = 5, deputy_attr_min = 619, deputy_attr_max = 619, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0792, extra_attr_max = 0.0792, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161204}, up_stairs_item_num = 120, },
[161204] = {name = "破道点风靴", lv = 120, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 144000, swap_atk_price = 1200000, main_attr_type = 7, main_attr_value = 961, deputy_attr_num = 5, deputy_attr_min = 673, deputy_attr_max = 673, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0816, extra_attr_max = 0.0816, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161254}, up_stairs_item_num = 125, },
[161254] = {name = "破道点风靴", lv = 125, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 150000, swap_atk_price = 1250000, main_attr_type = 7, main_attr_value = 1041, deputy_attr_num = 5, deputy_attr_min = 728, deputy_attr_max = 728, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.084, extra_attr_max = 0.084, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161304}, up_stairs_item_num = 130, },
[161304] = {name = "破道点风靴", lv = 130, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 156000, swap_atk_price = 1300000, main_attr_type = 7, main_attr_value = 1124, deputy_attr_num = 5, deputy_attr_min = 786, deputy_attr_max = 786, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0864, extra_attr_max = 0.0864, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161354}, up_stairs_item_num = 135, },
[161354] = {name = "破道点风靴", lv = 135, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 162000, swap_atk_price = 1350000, main_attr_type = 7, main_attr_value = 1210, deputy_attr_num = 5, deputy_attr_min = 847, deputy_attr_max = 847, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0888, extra_attr_max = 0.0888, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161404}, up_stairs_item_num = 140, },
[161404] = {name = "破道点风靴", lv = 140, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 168000, swap_atk_price = 1400000, main_attr_type = 7, main_attr_value = 1299, deputy_attr_num = 5, deputy_attr_min = 909, deputy_attr_max = 909, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0912, extra_attr_max = 0.0912, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161454}, up_stairs_item_num = 145, },
[161454] = {name = "破道点风靴", lv = 145, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 174000, swap_atk_price = 1450000, main_attr_type = 7, main_attr_value = 1392, deputy_attr_num = 5, deputy_attr_min = 974, deputy_attr_max = 974, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0936, extra_attr_max = 0.0936, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161504}, up_stairs_item_num = 150, },
[161504] = {name = "破道点风靴", lv = 150, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 180000, swap_atk_price = 1500000, main_attr_type = 7, main_attr_value = 1488, deputy_attr_num = 5, deputy_attr_min = 1041, deputy_attr_max = 1041, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.096, extra_attr_max = 0.096, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161554}, up_stairs_item_num = 155, },
[161554] = {name = "破道点风靴", lv = 155, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 186000, swap_atk_price = 1550000, main_attr_type = 7, main_attr_value = 1587, deputy_attr_num = 5, deputy_attr_min = 1111, deputy_attr_max = 1111, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.0984, extra_attr_max = 0.0984, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161604}, up_stairs_item_num = 160, },
[161604] = {name = "破道点风靴", lv = 160, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 192000, swap_atk_price = 1600000, main_attr_type = 7, main_attr_value = 1689, deputy_attr_num = 5, deputy_attr_min = 1182, deputy_attr_max = 1182, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1008, extra_attr_max = 0.1008, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161654}, up_stairs_item_num = 165, },
[161654] = {name = "破道点风靴", lv = 165, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 198000, swap_atk_price = 1650000, main_attr_type = 7, main_attr_value = 1795, deputy_attr_num = 5, deputy_attr_min = 1256, deputy_attr_max = 1256, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1032, extra_attr_max = 0.1032, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161704}, up_stairs_item_num = 170, },
[161704] = {name = "破道点风靴", lv = 170, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 204000, swap_atk_price = 1700000, main_attr_type = 7, main_attr_value = 1904, deputy_attr_num = 5, deputy_attr_min = 1332, deputy_attr_max = 1332, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1056, extra_attr_max = 0.1056, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161754}, up_stairs_item_num = 175, },
[161754] = {name = "破道点风靴", lv = 175, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 210000, swap_atk_price = 1750000, main_attr_type = 7, main_attr_value = 2016, deputy_attr_num = 5, deputy_attr_min = 1411, deputy_attr_max = 1411, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.108, extra_attr_max = 0.108, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161804}, up_stairs_item_num = 180, },
[161804] = {name = "破道点风靴", lv = 180, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 216000, swap_atk_price = 1800000, main_attr_type = 7, main_attr_value = 2131, deputy_attr_num = 5, deputy_attr_min = 1492, deputy_attr_max = 1492, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1104, extra_attr_max = 0.1104, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161854}, up_stairs_item_num = 185, },
[161854] = {name = "破道点风靴", lv = 185, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 222000, swap_atk_price = 1850000, main_attr_type = 7, main_attr_value = 2250, deputy_attr_num = 5, deputy_attr_min = 1575, deputy_attr_max = 1575, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1128, extra_attr_max = 0.1128, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161904}, up_stairs_item_num = 190, },
[161904] = {name = "破道点风靴", lv = 190, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 228000, swap_atk_price = 1900000, main_attr_type = 7, main_attr_value = 2372, deputy_attr_num = 5, deputy_attr_min = 1660, deputy_attr_max = 1660, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1152, extra_attr_max = 0.1152, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {161954}, up_stairs_item_num = 195, },
[161954] = {name = "破道点风靴", lv = 195, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 234000, swap_atk_price = 1950000, main_attr_type = 7, main_attr_value = 2497, deputy_attr_num = 5, deputy_attr_min = 1748, deputy_attr_max = 1748, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.1176, extra_attr_max = 0.1176, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {162004}, up_stairs_item_num = 200, },
[162004] = {name = "破道点风靴", lv = 200, icon = 30040, _type = 3, tile_num = 0, quality = 6, strengthen_price = 240000, swap_atk_price = 2000000, main_attr_type = 7, main_attr_value = 2625, deputy_attr_num = 5, deputy_attr_min = 1838, deputy_attr_max = 1838, extra_attr_num_min = 5, extra_attr_num_max = 5, extra_attr_min = 0.12, extra_attr_max = 0.12, up_stairs_odds = 1, smelt_value = 0, up_stairs_target = {0}, up_stairs_item_num = 0, },


};


function EquipConfig_getEquipmentType( id )
	return GetEquipTemplate(id)._type
end

function EquipConfig_getEquipmentTypeNameByType(equipType)
	if equipType == 0 then
		return "武器"
	elseif equipType == 1 then
		return "头盔"
    elseif equipType == 2 then
    	return "防具"
    elseif equipType == 3 then
    	return "鞋子"
	end

	return "无效的装备类型"
end

function EquipConfig_getEquipmentTypeName( id )
	local equipType = GetEquipTemplate(id)._type
	
	return EquipConfig_getEquipmentTypeNameByType(equipType)
end


--获取装备等级
function EquipConfig_getLv( id )
	return GetEquipTemplate(id).lv
end


--得到装备强化配置
function GetEquipStrengthenCfg(equip_lv)
	return EquipStrengthenCfg[equip_lv + 1];
end

--装备强化配置（价格在装备模版上）
EquipStrengthenCfg = 
{
[1] = {item = 90002, num = 20, odds = 0.9,},
[2] = {item = 90002, num = 50, odds = 0.8,},
[3] = {item = 90002, num = 100, odds = 0.7,},
[4] = {item = 90002, num = 170, odds = 0.6,},
[5] = {item = 90002, num = 260, odds = 0.5,},
[6] = {item = 90002, num = 370, odds = 0.4,},
[7] = {item = 90002, num = 500, odds = 0.3,},
[8] = {item = 90002, num = 650, odds = 0.2,},
[9] = {item = 90002, num = 820, odds = 0.1,},

};


